from __future__ import absolute_import
import re
from collections import OrderedDict
import six
data = {'bos': {'BeginLines': {'data': OrderedDict(),
                        'pattern': None},
         'EndLines': {'data': OrderedDict(),
                      'pattern': None},
         'PartialLines': {'data': OrderedDict([(u'da nadjem', u'na\u0107i'), (u'da nadjes', u'na\u0107i'), (u'da budes', u'biti'), (u'da ides', u'i\u0107i'), (u'da prodemo', u'pro\u0107i'), (u'da udem', u'u\u0107i'), (u'gdje ides', u'kamo ide\u0161'), (u'Gdje ides', u'Kamo ide\u0161'), (u'hocu da budem', u'\u017eelim biti'), (u'Hocu da budem', u'\u017delim biti'), (u'hocu da kazem', u'\u017eelim re\u0107i'), (u'hoces da kazes', u'\u017eeli\u0161 re\u0107i'), (u'hoce da kaze', u'\u017eeli re\u0107i'), (u'kao sto sam', u'kao \u0161to sam'), (u'me leda', u'me le\u0111a'), (u'medu nama', u'me\u0111u nama'), (u'moramo da idemo', u'moramo i\u0107i'), (u'moras da ides', u'mora\u0161 i\u0107i'), (u'na vecer', u'nave\u010der'), (u'Na vecer', u'Nave\u010der'), (u'ne cu', u'ne\u0107u'), (u'ne ces', u'ne\u0107e\u0161'), (u'ne\u0161to sto', u'ne\u0161to \u0161to'), (u'ono sto', u'ono \u0161to'), (u'Ono sto', u'Ono \u0161to'), (u'reci \u0107u', u're\u0107i \u0107u'), (u'sto ti se ne', u'\u0161to ti se ne'), (u'sto vise', u'\u0161to vi\u0161e'), (u'sve sto', u'sve \u0161to'), (u'Zao mi', u'\u017dao mi'), (u'zao mi', u'\u017eao mi'), (u'Zato sto', u'Zato \u0161to'), (u'zato sto', u'zato \u0161to'), (u'znas sto', u'zna\u0161 \u0161to'), (u'zna\u0161 sto', u'zna\u0161 \u0161to')]),
                          'pattern': u'(?um)(?:(?<=\\s)|(?<=^)|(?<=\\b))(?:da\\ nadjem|da\\ nadjes|da\\ budes|da\\ ides|da\\ prodemo|da\\ udem|gdje\\ ides|Gdje\\ ides|hocu\\ da\\ budem|Hocu\\ da\\ budem|hocu\\ da\\ kazem|hoces\\ da\\ kazes|hoce\\ da\\ kaze|kao\\ sto\\ sam|me\\ leda|medu\\ nama|moramo\\ da\\ idemo|moras\\ da\\ ides|na\\ vecer|Na\\ vecer|ne\\ cu|ne\\ ces|ne\\\u0161to\\ sto|ono\\ sto|Ono\\ sto|reci\\ \\\u0107u|sto\\ ti\\ se\\ ne|sto\\ vise|sve\\ sto|Zao\\ mi|zao\\ mi|Zato\\ sto|zato\\ sto|znas\\ sto|zna\\\u0161\\ sto)(?:(?=\\s)|(?=$)|(?=\\b))'},
         'PartialWordsAlways': {'data': OrderedDict(),
                                'pattern': None},
         'WholeLines': {'data': OrderedDict(),
                        'pattern': None},
         'WholeWords': {'data': OrderedDict([(u'andele', u'an\u0111ele'), (u'andeli', u'an\u0111eli'), (u'bacas', u'baca\u0161'), (u'bas', u'ba\u0161'), (u'Bas', u'Ba\u0161'), (u'basta', u'vrt'), (u'Basta', u'Vrt'), (u'baste', u'vrtovi'), (u'Baste', u'Vrtovi'), (u'basti', u'vrtu'), (u'Basti', u'Vrtu'), (u'bastom', u'vrtom'), (u'Bastom', u'Vrtom'), (u'bastu', u'vrt'), (u'Bastu', u'Vrt'), (u'Bice', u'Bi\u0107e'), (u'bice', u'bi\u0107e'), (u'Bice\u0161', u'Bit \u0107e\u0161'), (u'Bicu', u'Bit \u0107u'), (u'bicu', u'bi\u0107u'), (u'blagonaklonoscu', u'blagonaklono\u0161\u0107u'), (u'blizi', u'bli\u017ei'), (u'bljesti', u'blije\u0161ti'), (u'Bljesti', u'Blije\u0161ti'), (u'bojis', u'boji\u0161'), (u'braca', u'bra\u0107a'), (u'Braca', u'Bra\u0107a'), (u'broncane', u'bron\u010dane'), (u'broncanu', u'bron\u010danu'), (u'budes', u'bude\u0161'), (u'caj', u'\u010daj'), (u'caja', u'\u010daja'), (u'Cak', u'\u010cak'), (u'cak', u'\u010dak'), (u'cale', u'tata'), (u'Cao', u'\u0106ao'), (u'cao', u'\u0107ao'), (u'cas', u'sat'), (u'casno', u'\u010dasno'), (u'Casno', u'\u010casno'), (u'castis', u'\u010dasti\u0161'), (u'casu', u'ca\u0161u'), (u'ca\u0161u', u'\u010da\u0161u'), (u'cebe', u'deku'), (u'cega', u'\u010dega'), (u'Cek', u'\u010cek'), (u'cek', u'\u010dek'), (u'cekali', u'\u010dekali'), (u'cekas', u'\u010deka\u0161'), (u'Cemu', u'\u010cemu'), (u'cemu', u'\u010demu'), (u'cerka', u'k\u0107i'), (u'Cerka', u'K\u0107i'), (u'cerke', u'k\u0107eri'), (u'Cerke', u'K\u0107eri'), (u'cerku', u'k\u0107er'), (u'Cerku', u'K\u0107er'), (u'ces', u'\u0107e\u0161'), (u'cesce', u'\u010de\u0161\u0107e'), (u'Cesce', u'\u010ce\u0161\u0107e'), (u'Ceskoj', u'\u010ce\u0161koj'), (u'cestitki', u'\u010destitki'), (u'cesto', u'\u010desto'), (u'Cesto', u'\u010cesto'), (u'cetiri', u'\u010detiri'), (u'Cetiri', u'\u010cetiri'), (u'cetri', u'\u010detiri'), (u'cetu', u'\u010detu'), (u'ceznja', u'\u010de\u017enja'), (u'ceznje', u'\u010de\u017enje'), (u'ceznji', u'\u010de\u017enji'), (u'ceznjom', u'\u010de\u017enjom'), (u'ceznju', u'\u010de\u017enju'), (u'ceznu', u'\u010deznu'), (u'ce\u0161', u'\u0107e\u0161'), (u'Cija', u'\u010cija'), (u'cija', u'\u010dija'), (u'cije', u'\u010dije'), (u'Ciji', u'\u010ciji'), (u'ciji', u'\u010diji'), (u'cijih', u'\u010dijih'), (u'Cijih', u'\u010cijih'), (u'cijim', u'\u010dijim'), (u'Cijim', u'\u010cijim'), (u'Cim', u'\u010cim'), (u'cim', u'\u010dim'), (u'cime', u'\u010dime'), (u'cinila', u'\u010dinila'), (u'cinili', u'\u010dinili'), (u'cinio', u'\u010dinio'), (u'cinis', u'\u010dini\u0161'), (u'ciniti', u'\u010diniti'), (u'cipka', u'\u010dipka'), (u'cipku', u'\u010dipku'), (u'cita', u'\u010dita'), (u'citao', u'\u010ditao'), (u'citas', u'\u010dita\u0161'), (u'citavu', u'\u010ditavu'), (u'cizme', u'\u010dizme'), (u'clan', u'\u010dlan'), (u'Clan', u'\u010clan'), (u'clanke', u'\u010dlanke'), (u'clanove', u'\u010dlanove'), (u'clanovi', u'\u010dlanovi'), (u'clanovima', u'\u010dlanovima'), (u'cmo', u'\u0107emo'), (u'corsokak', u'slijepa ulica'), (u'corsokaku', u'slijepoj ulici'), (u'cosak', u'ugao'), (u'cosku', u'uglu'), (u'covece', u'\u010dovje\u010de'), (u'covek', u'\u010dovjek'), (u'covjece', u'\u010dovje\u010de'), (u'covjecnost', u'\u010dovje\u010dnost'), (u'covjek', u'\u010dovjek'), (u'covjeka', u'\u010dovjeka'), (u'covjeku', u'\u010dovjeku'), (u'crpeci', u'crpe\u0107i'), (u'cte', u'\u0107ete'), (u'Cu', u'\u0106u'), (u'Ce\u0161', u'\u0106e\u0161'), (u'Ce', u'\u0106e'), (u'Cemo', u'\u0106emo'), (u'Cete', u'\u0106ete'), (u'cu', u'\u0107u'), (u'ce', u'\u0107e'), (u'cemo', u'\u0107emo'), (u'cete', u'\u0107ete'), (u'cudi', u'\u010dudi'), (u'Cudo', u'\u010cudo'), (u'cudo', u'\u010dudo'), (u'Cujte', u'\u010cujte'), (u'cula', u'\u010dula'), (u'culi', u'\u010duli'), (u'Culi', u'\u010culi'), (u'culima', u'\u010dulima'), (u'cuo', u'\u010duo'), (u'Cuo', u'\u010cuo'), (u'cupam', u'\u010dupam'), (u'cutanje', u'\u0161utnja'), (u'Cutanje', u'\u0160utnja'), (u'cutao', u'\u0161utio'), (u'Cutao', u'\u0160utio'), (u'cuti', u'\u010duti'), (u'cutljiv', u'\u0161utljiv'), (u'cutnja', u'\u0161utnja'), (u'cuvali', u'\u010duvali'), (u'cuveni', u'\u010duveni'), (u'dace', u'dat \u0107e'), (u'dacemo', u'dat \u0107emo'), (u'davo', u'vrag'), (u'definise', u'definira'), (u'definisi', u'definiraj'), (u'Desava', u'Doga\u0111a'), (u'desava', u'doga\u0111a'), (u'disemo', u'di\u0161emo'), (u'disi', u'di\u0161i'), (u'dobijes', u'dobije\u0161'), (u'dobivas', u'dobiva\u0161'), (u'doci', u'do\u0107i'), (u'dode', u'do\u0111e'), (u'dodem', u'do\u0111em'), (u'dodes', u'do\u0111e\u0161'), (u'dodete', u'do\u0111ete'), (u'dode\u0161', u'do\u0111e\u0161'), (u'Dodi', u'Do\u0111i'), (u'dodi', u'do\u0111i'), (u'dodite', u'do\u0111ite'), (u'Dodji', u'Do\u0111i'), (u'dodji', u'do\u0111i'), (u'Dodjite', u'Do\u0111ite'), (u'dodjite', u'do\u0111ite'), (u'Dodju', u'Do\u0111u'), (u'dodju', u'do\u0111u'), (u'dodu', u'do\u0111u'), (u'dolazis', u'dolazi\u0161'), (u'dopustao', u'dopu\u0161tao'), (u'dorucak', u'doru\u010dak'), (u'dorucku', u'doru\u010dku'), (u'Dosao', u'Do\u0161ao'), (u'dosao', u'do\u0161ao'), (u'drhteci', u'drhte\u0107i'), (u'drhte\u0107i', u'drhte\u0107i'), (u'Drhte\u0107i', u'Drhte\u0107i'), (u'drugacija', u'druga\u010dija'), (u'Drugacije', u'Druga\u010dije'), (u'drugacije', u'druga\u010dije'), (u'drugaciji', u'druga\u010diji'), (u'Drugaciji', u'Druga\u010diji'), (u'drukciji', u'druga\u010diji'), (u'drveca', u'drve\u0107a'), (u'drvece', u'drve\u0107e'), (u'drvecem', u'drve\u0107em'), (u'drvecu', u'drve\u0107u'), (u'drzi', u'dr\u017ei'), (u'Drzim', u'Dr\u017eim'), (u'dugmici', u'gumbi\u0107i'), (u'duze', u'du\u017ee'), (u'duzinom', u'du\u017einom'), (u'dzanki', u'ovisnik'), (u'Dzejk', u'Jake'), (u'Dzime', u'Jime'), (u'Dzone', u'Johne'), (u'flasom', u'fla\u0161om'), (u'flasu', u'fla\u0161u'), (u'fucka', u'fu\u0107ka'), (u'funkcionisu', u'funkcioniraju'), (u'gacice', u'ga\u0107ice'), (u'gadao', u'ga\u0111ao'), (u'gadis', u'gadi\u0161'), (u'Gadis', u'Gadi\u0161'), (u'gdica', u'g\u0111ica'), (u'gdice', u'g\u0111ice'), (u'gdici', u'g\u0111ici'), (u'gdicu', u'g\u0111icu'), (u'gdu', u'g\u0111u'), (u'glupaco', u'glupa\u010do'), (u'govoris', u'govori\u0161'), (u'gradani', u'gra\u0111ani'), (u'gradic', u'gradi\u0107'), (u'gradica', u'gradi\u0107a'), (u'gradicu', u'gradi\u0107u'), (u'grancica', u'gran\u010dica'), (u'grancicu', u'gran\u010dicu'), (u'gresci', u'gre\u0161ci'), (u'grese', u'grije\u0161e'), (u'greski', u'gre\u0161ci'), (u'gresku', u'gre\u0161ku'), (u'gubis', u'gubi\u0161'), (u'Hoces', u'Ho\u0107e\u0161'), (u'hoces', u'ho\u0107e\u0161'), (u'hocu', u'ho\u0107u'), (u'Hocu', u'Ho\u0107u'), (u'hodas', u'hoda\u0161'), (u'htjeo', u'htio'), (u'iceg', u'i\u010deg'), (u'icega', u'i\u010dega'), (u'icemu', u'i\u010demu'), (u'Ici', u'I\u0107i'), (u'ici', u'i\u0107i'), (u'Ides', u'Ide\u0161'), (u'ides', u'ide\u0161'), (u'iduce', u'idu\u0107e'), (u'iduceg', u'idu\u0107eg'), (u'iducem', u'idu\u0107em'), (u'Iduci', u'Idu\u0107i'), (u'iduci', u'idu\u0107i'), (u'ignorisi', u'ignoriraju'), (u'igras', u'igra\u0161'), (u'Ijudi', u'ljudi'), (u'imas', u'ima\u0161'), (u'imidz', u'imid\u017e'), (u'inace', u'ina\u010de'), (u'Inace', u'Ina\u010de'), (u'isao', u'i\u0161ao'), (u'Isao', u'I\u0161ao'), (u'iscupao', u'i\u0161\u010dupao'), (u'ise\u0107emo', u'izrezati'), (u'isla', u'i\u0161la'), (u'istjece', u'istje\u010de'), (u'istrazio', u'istrazio'), (u'Istrazio', u'Istrazio'), (u'isuvise', u'previ\u0161e'), (u'izaci', u'iza\u0107i'), (u'Izaci', u'Iza\u0107i'), (u'izade', u'iza\u0111e'), (u'Izade', u'Iza\u0111e'), (u'izadem', u'iza\u0111em'), (u'izades', u'iza\u0111e\u0161'), (u'izadete', u'iza\u0111ete'), (u'Izadi', u'Iza\u0111i'), (u'izadi', u'iza\u0111i'), (u'izasao', u'iza\u0161ao'), (u'izasla', u'iza\u0161la'), (u'izici', u'izi\u0107i'), (u'izluduje', u'izlu\u0111uje'), (u'izluduju', u'izlu\u0111uju'), (u'izmedu', u'izme\u0111u'), (u'Izmedu', u'Izme\u0111u'), (u'izostri', u'izo\u0161tri'), (u'izostrim', u'izo\u0161trim'), (u'izvuci', u'izvu\u0107i'), (u'i\u0161cupao', u'i\u0161\u010dupao'), (u'jebes', u'jebe\u0161'), (u'Jebes', u'Jebe\u0161'), (u'jos', u'jo\u0161'), (u'Jos', u'Jo\u0161'), (u'juce', u'ju\u010der'), (u'Juce', u'Ju\u010der'), (u'jucer', u'ju\u010der'), (u'Jucer', u'Ju\u010der'), (u'kaslja', u'ka\u0161lja'), (u'kaze', u'ka\u017ee'), (u'Kaze', u'Ka\u017ee'), (u'kazemo', u'ka\u017eemo'), (u'kazite', u'ka\u017eite'), (u'Kazite', u'Ka\u017eite'), (u'kazu', u'ka\u017eu'), (u'Kcer', u'K\u0107er'), (u'kcer', u'k\u0107er'), (u'kcerka', u'k\u0107i'), (u'Kcerka', u'K\u0107i'), (u'kcerkama', u'k\u0107erima'), (u'kcerku', u'k\u0107er'), (u'Kcerku', u'K\u0107er'), (u'kecap', u'ke\u010dap'), (u'kecapa', u'ke\u010dapa'), (u'kise', u'ki\u0161e'), (u'kisi', u'ki\u0161i'), (u'kleknes', u'klekne\u0161'), (u'kociji', u'ko\u010diji'), (u'kolaca', u'kola\u010da'), (u'kolace', u'kola\u010de'), (u'komadic', u'komadi\u0107'), (u'komsijama', u'susjedima'), (u'komsije', u'susjedi'), (u'komsiji', u'susjedu'), (u'komsiluk', u'susjedstvo'), (u'komsiluku', u'susjedstvu'), (u'kom\u0161ija', u'susjed'), (u'Kom\u0161ija', u'Susjed'), (u'Konkurise', u'Konkurira'), (u'konkurise', u'konkurira'), (u'konkurisem', u'konkuriram'), (u'konkurisu', u'konkuriraju'), (u'kontrolisu', u'kontroliraju'), (u'kosulja', u'ko\u0161ulja'), (u'kosulje', u'ko\u0161ulje'), (u'kosulji', u'ko\u0161ulji'), (u'kosulju', u'ko\u0161ulju'), (u'kovceg', u'kov\u010deg'), (u'kovcegu', u'kov\u010degu'), (u'krada', u'kra\u0111a'), (u'Krada', u'Kra\u0111a'), (u'Krece', u'Kre\u0107e'), (u'krece', u'kre\u0107e'), (u'Kreci', u'Kre\u0107i'), (u'kreci', u'kre\u0107i'), (u'krecu', u'kre\u0107u'), (u'kre\u0107es', u'kre\u0107e\u0161'), (u'krosnje', u'kro\u0161nje'), (u'krvaris', u'krvari\u0161'), (u'kuca', u'ku\u0107a'), (u'kucama', u'ku\u0107ama'), (u'kuce', u'ku\u0107e'), (u'kuci', u'ku\u0107i'), (u'kusa', u'ku\u0161a'), (u'kusas', u'ku\u0161a\u0161'), (u'ku\u010da', u'ku\u0107a'), (u'ku\u010di', u'ku\u0107i'), (u'lakocom', u'lako\u0107om'), (u'laz', u'la\u017e'), (u'lazac', u'la\u017eljivac'), (u'laze', u'la\u017ee'), (u'lazi', u'la\u017ei'), (u'lazne', u'la\u017ene'), (u'lazni', u'la\u017eni'), (u'lazov', u'la\u017eljivac'), (u'ledja', u'le\u0111a'), (u'ledjima', u'le\u0111ima'), (u'leprsa', u'lepr\u0161a'), (u'lezala', u'le\u017eala'), (u'lezali', u'le\u017eali'), (u'lezati', u'le\u017eati'), (u'lezis', u'le\u017ei\u0161'), (u'Lezis', u'Le\u017ei\u0161'), (u'lici', u'li\u010di'), (u'licim', u'li\u010dim'), (u'licis', u'li\u010di\u0161'), (u'licnost', u'li\u010dnost'), (u'licnosti', u'li\u010dnosti'), (u'lijecniku', u'lije\u010dniku'), (u'ljubis', u'ljubi\u0161'), (u'los', u'lo\u0161'), (u'losa', u'lo\u0161a'), (u'losu', u'lo\u0161u'), (u'majcine', u'maj\u010dine'), (u'masini', u'ma\u0161ini'), (u'medu', u'me\u0111u'), (u'Medutim', u'Me\u0111utim'), (u'medutim', u'me\u0111utim'), (u'mici', u'mi\u010di'), (u'Mici', u'Mi\u010di'), (u'micu', u'mi\u010du'), (u'mislis', u'misli\u0161'), (u'Mislis', u'Misli\u0161'), (u'mjesecevom', u'mjese\u010devom'), (u'mjesecine', u'mjese\u010dine'), (u'mjesecini', u'mjese\u010dini'), (u'mjesecinu', u'mjese\u010dinu'), (u'mladic', u'mladi\u0107'), (u'moc', u'mo\u0107'), (u'moci', u'mo\u0107i'), (u'motivisu', u'motiviraju'), (u'mozda', u'mo\u017eda'), (u'Mozda', u'Mo\u017eda'), (u'moze', u'mo\u017ee'), (u'mozete', u'mo\u017eete'), (u'mreza', u'mre\u017ea'), (u'mrezu', u'mre\u017eu'), (u'mrzis', u'mrzi\u0161'), (u'muce', u'mu\u010de'), (u'mucenik', u'mu\u010denik'), (u'mucne', u'mu\u010dne'), (u'muska', u'mu\u0161ka'), (u'muz', u'mu\u017e'), (u'muza', u'mu\u017ea'), (u'naci', u'na\u0107i'), (u'Naci', u'Na\u0107i'), (u'nacin', u'na\u010din'), (u'nadem', u'na\u0111em'), (u'Nadem', u'Na\u0111em'), (u'nademo', u'na\u0111emo'), (u'nades', u'na\u0111e\u0161'), (u'Nades', u'Na\u0111e\u0161'), (u'nadete', u'na\u0111ete'), (u'nadici', u'nadi\u0107i'), (u'nadje', u'na\u0111e'), (u'Nadje', u'Na\u0111e'), (u'nadjen', u'na\u0111en'), (u'nadjes', u'na\u0111e\u0161'), (u'Nadjes', u'Na\u0111e\u0161'), (u'nadjete', u'na\u0111ete'), (u'nagovestaj', u'nagovje\u0161taj'), (u'najvise', u'najvise'), (u'Najvise', u'Najvi\u0161e'), (u'naklonoscu', u'nakolono\u0161\u0107u'), (u'naocale', u'nao\u010dale'), (u'Napisite', u'Napi\u0161ite'), (u'nasa', u'na\u0161a'), (u'Nase', u'Na\u0161e'), (u'nase', u'na\u0161e'), (u'naseg', u'na\u0161eg'), (u'nasi', u'na\u0161i'), (u'Nasi', u'Na\u0161i'), (u'nasao', u'na\u0161ao'), (u'Nasao', u'Na\u0161ao'), (u'nasla', u'na\u0161la'), (u'Nasla', u'Na\u0161la'), (u'nasli', u'na\u0161li'), (u'Nasli', u'Na\u0161li'), (u'nasoj', u'na\u0161oj'), (u'nasrecu', u'na sre\u0107u'), (u'nastavis', u'nastavi\u0161'), (u'nasu', u'na\u0161u'), (u'nauce', u'nau\u010de'), (u'neceg', u'ne\u010deg'), (u'necega', u'ne\u010dega'), (u'necemo', u'ne\u0107emo'), (u'necemu', u'ne\u010demu'), (u'necije', u'ne\u010dije'), (u'neciji', u'ne\u010diji'), (u'necim', u'ne\u010dim'), (u'necovjecnost', u'ne\u010dovje\u010dnost'), (u'necovjecnosti', u'ne\u010dovje\u010dnosti'), (u'necu', u'ne\u0107u'), (u'Necu', u'Ne\u0107u'), (u'nekaze', u'ne ka\u017ee'), (u'nekoc', u'neko\u0107'), (u'Nemas', u'Nema\u0161'), (u'nemas', u'nema\u0161'), (u'Nesreca', u'Nesre\u0107a'), (u'nesto', u'ne\u0161to'), (u'Nesto', u'Ne\u0161to'), (u'new yorski', u'njujor\u0161ki'), (u'Nezan', u'Nje\u017ean'), (u'nezan', u'nje\u017ean'), (u'nezna', u'nje\u017ena'), (u'Neznam', u'Ne znam'), (u'Neznas', u'Ne znas'), (u'Neznajuci', u'Ne znaju\u0107i'), (u'Neznavsi', u'Ne znav\u0161i'), (u'neznam', u'ne znam'), (u'neznas', u'ne znas'), (u'neznajuci', u'ne znaju\u0107i'), (u'neznavsi', u'ne znav\u0161i'), (u'nezni', u'nje\u017eni'), (u'neznih', u'nje\u017enih'), (u'neznim', u'nje\u017enim'), (u'nezno', u'nje\u017eno'), (u'neznu', u'nje\u017enu'), (u'niceg', u'ni\u010deg'), (u'nicega', u'ni\u010dega'), (u'nicemu', u'ni\u010demu'), (u'nicija', u'ni\u010dija'), (u'niciji', u'ni\u010diji'), (u'nicim', u'ni\u010dim'), (u'njezno', u'nje\u017eno'), (u'nju jorski', u'njujor\u0161ki'), (u'noci', u'no\u0107i'), (u'nocnu', u'no\u0107nu'), (u'nosac', u'nosa\u010d'), (u'nosices', u'nosit \u0107e\u0161'), (u'nosis', u'nosi\u0161'), (u'noz', u'no\u017e'), (u'nozem', u'no\u017eem'), (u'Obecao', u'Obe\u0107ao'), (u'Obezbedjuju', u'Osiguravaju'), (u'obezbedjuju', u'osiguravaju'), (u'obide', u'obi\u0111e'), (u'objasnis', u'objasni\u0161'), (u'obozavalac', u'obo\u017eavatelj'), (u'obracas', u'obra\u0107a\u0161'), (u'obra\u0107as', u'obra\u0107a\u0161'), (u'obuce', u'obu\u010de'), (u'obucem', u'obu\u010dem'), (u'oceve', u'o\u010deve'), (u'ocito', u'o\u010dito'), (u'ocnjaci', u'o\u010dnjaci'), (u'odes', u'ode\u0161'), (u'odlazis', u'odlazi\u0161'), (u'odlezati', u'odle\u017eati'), (u'odlucim', u'odlu\u010dim'), (u'odmice', u'odmi\u010de'), (u'odraduje', u'odra\u0111uje'), (u'odreden', u'odre\u0111en'), (u'odreduje', u'odre\u0111uje'), (u'odredujemo', u'odre\u0111ujemo'), (u'odvec', u'odve\u0107'), (u'ogrtac', u'ogrta\u010d'), (u'ohrabrujuce', u'ohrabruju\u0107e'), (u'ojacam', u'oja\u010dam'), (u'okrece', u'okre\u0107e'), (u'opasac', u'opasa\u010d'), (u'operise', u'operira'), (u'operisemo', u'operiramo'), (u'operisete', u'operirate'), (u'operise\u0161', u'operira\u0161'), (u'osecaces', u'osje\u0107at \u0107e\u0161'), (u'osjecaces', u'osje\u0107at \u0107e\u0161'), (u'osjecam', u'osje\u0107am'), (u'osjecanja', u'osje\u0107anja'), (u'oslobada', u'osloba\u0111a'), (u'ostra', u'o\u0161tra'), (u'ostre', u'o\u0161tre'), (u'ostri', u'o\u0161tri'), (u'ostrom', u'o\u0161trom'), (u'ostru', u'o\u0161tru'), (u'osvrnes', u'osvrne\u0161'), (u'Osvrnes', u'Osvrne\u0161'), (u'otezala', u'ote\u017eala'), (u'otidi', u'oti\u0111i'), (u'otidji', u'oti\u0111i'), (u'otisao', u'oti\u0161ao'), (u'oziljak', u'o\u017eiljak'), (u'palaca', u'pala\u010da'), (u'palaci', u'pala\u010di'), (u'palacu', u'pala\u010du'), (u'papucama', u'papu\u010dama'), (u'parce', u'komadi\u0107'), (u'pateci', u'pate\u0107i'), (u'patis', u'pati\u0161'), (u'pcela', u'p\u010dela'), (u'pcele', u'p\u010dele'), (u'pecini', u'pe\u0107ini'), (u'pecinski', u'pe\u0107inski'), (u'peraca', u'pera\u010da'), (u'Peraci', u'Pera\u010di'), (u'pica', u'pi\u0107a'), (u'pice', u'pi\u0107e'), (u'picem', u'pi\u0107em'), (u'pijes', u'pije\u0161'), (u'pisacoj', u'pisa\u0107oj'), (u'pise', u'pi\u0161e'), (u'pisem', u'pi\u0161em'), (u'pisemo', u'pi\u0161emo'), (u'pises', u'pi\u0161e\u0161'), (u'pisite', u'pi\u0161ite'), (u'pisu', u'pi\u0161u'), (u'pitas', u'pita\u0161'), (u'placa', u'pla\u0107a'), (u'placam', u'pla\u0107am'), (u'placanje', u'pla\u0107anje'), (u'placanjem', u'pla\u0107anjem'), (u'place', u'pla\u010de'), (u'placem', u'pla\u010dem'), (u'placete', u'pla\u010dete'), (u'place\u0161', u'pla\u010de\u0161'), (u'placu', u'pla\u0107u'), (u'placuci', u'pla\u010du\u0107i'), (u'Plasi', u'Boji'), (u'plazi', u'pla\u017ei'), (u'plazu', u'pla\u017eu'), (u'plese', u'ple\u0161e'), (u'plesemo', u'ple\u0161emo'), (u'plesete', u'ple\u0161ete'), (u'plesu', u'ple\u0161u'), (u'ploca', u'plo\u010da'), (u'ploce', u'plo\u010de'), (u'pluca', u'plu\u0107a'), (u'plucima', u'plu\u0107ima'), (u'pobjeci', u'pobje\u0107i'), (u'pobjeduje', u'pobje\u0111uje'), (u'poceli', u'po\u010deli'), (u'poceo', u'po\u010deo'), (u'pocetak', u'po\u010detak'), (u'pocevsi', u'po\u010dev\u0161i'), (u'pocev\u0161i', u'po\u010dev\u0161i'), (u'poci', u'po\u0107i'), (u'pocinje', u'po\u010dinje'), (u'pociva', u'po\u010diva'), (u'pocivali', u'po\u010divali'), (u'pocivao', u'po\u010divao'), (u'pode', u'po\u0111e'), (u'podi', u'po\u0111i'), (u'podici', u'podi\u0107i'), (u'Podici', u'Podi\u0107i'), (u'podimo', u'po\u0111imo'), (u'Podimo', u'Po\u0111imo'), (u'podje', u'po\u0111e'), (u'Podje', u'Po\u0111e'), (u'Podji', u'Po\u0111i'), (u'podji', u'po\u0111i'), (u'podneses', u'podnese\u0161'), (u'podocnjacima', u'podo\u010dnjacima'), (u'podocnjake', u'podo\u010dnjake'), (u'podstice', u'poti\u010de'), (u'poduzeca', u'poduze\u0107a'), (u'poduzece', u'poduze\u0107e'), (u'poduzecu', u'poduze\u0107u'), (u'pojesce', u'pojest \u0107e'), (u'pojiliste', u'pojili\u0161te'), (u'pokazi', u'poka\u017ei'), (u'Pokazi', u'Poka\u017ei'), (u'pokrece', u'pokre\u0107e'), (u'pokusaj', u'poku\u0161aj'), (u'pokusam', u'poku\u0161am'), (u'pokusas', u'poku\u0161a\u0161'), (u'poletis', u'poleti\u0161'), (u'polozaja', u'polo\u017eaja'), (u'polozaju', u'polo\u017eaju'), (u'pomaci', u'pomaknuti'), (u'pomazes', u'poma\u017ee\u0161'), (u'pomislis', u'pomisli\u0161'), (u'pomognes', u'pomogne\u0161'), (u'poneses', u'ponese\u0161'), (u'ponovis', u'ponovi\u0161'), (u'poreci', u'pore\u0107i'), (u'porice', u'pori\u010de'), (u'posalji', u'po\u0161alji'), (u'Posalji', u'Po\u0161alji'), (u'posaljite', u'po\u0161aljite'), (u'posle', u'poslije'), (u'posluzili', u'poslu\u017eili'), (u'Posluzite', u'Poslu\u017eite'), (u'posluzite', u'poslu\u017eite'), (u'postaras', u'pobrine\u0161'), (u'posto', u'po\u0161to'), (u'Posto', u'Po\u0161to'), (u'potece', u'pote\u010de'), (u'potice', u'poti\u010de'), (u'potici', u'poti\u010di'), (u'potjece', u'potje\u010de'), (u'potjecem', u'potje\u010dem'), (u'potjeces', u'potje\u010de\u0161'), (u'potpises', u'potpi\u0161e\u0161'), (u'povedes', u'povede\u0161'), (u'pozuda', u'po\u017euda'), (u'pozude', u'po\u017eude'), (u'pozudi', u'po\u017eudi'), (u'pozudu', u'po\u017eudu'), (u'prakticno', u'prakti\u010dno'), (u'premasuje', u'prema\u0161uje'), (u'premasuju', u'prema\u0161uju'), (u'preporuca', u'preporu\u010duje'), (u'presao', u'pre\u0161ao'), (u'presjecen', u'presje\u010den'), (u'Previse', u'Previ\u0161e'), (u'previse', u'previ\u0161e'), (u'preziveo', u'pre\u017eivio'), (u'Priblizi', u'Pribli\u017ei'), (u'price', u'pri\u010de'), (u'prici', u'pri\u010di'), (u'pricu', u'pri\u010du'), (u'Pridji', u'Pri\u0111i'), (u'pridji', u'pri\u0111i'), (u'prijeci', u'prije\u0107i'), (u'prijedi', u'prije\u0111i'), (u'prilazis', u'prilazi\u0161'), (u'prisao', u'pri\u0161ao'), (u'priusti', u'priu\u0161ti'), (u'priustimo', u'priu\u0161timo'), (u'priustiti', u'priu\u0161titi'), (u'proci', u'pro\u0107i'), (u'prodavac', u'prodava\u010d'), (u'promasio', u'proma\u0161io'), (u'Promasio', u'Proma\u0161io'), (u'prosao', u'pro\u0161ao'), (u'prosla', u'pro\u0161la'), (u'Prosle', u'Pro\u0161le'), (u'prosle', u'pro\u0161le'), (u'prosli', u'pro\u0161li'), (u'Prosli', u'Pro\u0161li'), (u'proslim', u'pro\u0161lim'), (u'proslo', u'pro\u0161lo'), (u'Proslo', u'Pro\u0161lo'), (u'provedes', u'provede\u0161'), (u'provlaci', u'provla\u010di'), (u'provlacimo', u'provla\u010dimo'), (u'pticica', u'pti\u010dica'), (u'pticicu', u'pti\u010dicu'), (u'pucini', u'pu\u010dini'), (u'pupcanu', u'pup\u010danu'), (u'pusac', u'pu\u0161a\u010d'), (u'pusaci', u'pu\u0161a\u010di'), (u'pusi', u'pu\u0161i'), (u'pusimo', u'pu\u0161imo'), (u'pusite', u'pu\u0161ite'), (u'pustam', u'pu\u0161tam'), (u'racunare', u'ra\u010dunala'), (u'racunari', u'ra\u010dunala'), (u'radis', u'radi\u0161'), (u'Radis', u'Radi\u0161'), (u'raskosni', u'rasko\u0161ni'), (u'razumes', u'razumije\u0161'), (u'Razumes', u'Razumije\u0161'), (u'rec', u'rije\u010d'), (u'rece', u're\u010de'), (u'Receno', u'Re\u010deno'), (u'receno', u're\u010deno'), (u'recima', u'rije\u010dima'), (u'resimo', u'rije\u0161imo'), (u'rijec', u'rije\u010d'), (u'Rijeci', u'Rije\u010di'), (u'rijedji', u'rje\u0111i'), (u'rjedji', u'rje\u0111i'), (u'Rjesit', u'Rije\u0161it'), (u'rodena', u'ro\u0111ena'), (u'rodeni', u'ro\u0111eni'), (u'rodis', u'rodi\u0161'), (u'rodjen', u'ro\u0111en'), (u'rucno', u'ru\u010dno'), (u'ruza', u'ru\u017ea'), (u'ruzan', u'ru\u017ean'), (u'ruzu', u'ru\u017eu'), (u'sadrze', u'sadr\u017ee'), (u'sadrzi', u'sadr\u017ei'), (u'salje', u'\u0161alje'), (u'saljes', u'\u0161alje\u0161'), (u'salju', u'\u0161alju'), (u'sasila', u'sa\u0161ila'), (u'sasili', u'sa\u0161ili'), (u'sasio', u'sa\u0161io'), (u'sasiti', u'sa\u0161iti'), (u'savescu', u'savje\u0161\u0107u'), (u'savijescu', u'savje\u0161\u0107u'), (u'sedeces', u'sjedit \u0107e\u0161'), (u'sedis', u'sjedi\u0161'), (u'sedista', u'sjedala'), (u'sediste', u'sjedi\u0161te'), (u'sendvic', u'sendvi\u010d'), (u'sesir', u'\u0161e\u0161ir'), (u'sesirom', u'\u0161e\u0161irom'), (u'sest', u'\u0161est'), (u'setala', u'\u0161etala'), (u'setam', u'\u0161etam'), (u'setis', u'sjeti\u0161'), (u'seva', u'\u0161eva'), (u'sevu', u'\u0161evu'), (u'sezdeset', u'\u0161ezdeset'), (u'Sidji', u'Si\u0111i'), (u'sidji', u'si\u0111i'), (u'sijecanj', u'sije\u010danj'), (u'siroki', u'\u0161iroki'), (u'sjecaju', u'sje\u0107aju'), (u'sjecam', u'sje\u0107am'), (u'Sjecam', u'Sje\u0107am'), (u'sjecanja', u'sje\u0107anja'), (u'sjecanje', u'sje\u0107anje'), (u'skace', u'ska\u010de'), (u'skaci', u'ska\u010di'), (u'skacu', u'ska\u010du'), (u'sklanjas', u'sklanja\u0161'), (u'sklonoscu', u'sklono\u0161\u0107u'), (u'sklupcam', u'sklup\u010dam'), (u'skola', u'\u0161kola'), (u'Skola', u'\u0160kola'), (u'Skotska', u'\u0160kotska'), (u'Skotskoj', u'\u0160kotskoj'), (u'skrt', u'\u0161krt'), (u'skrte', u'\u0161krte'), (u'skrusena', u'skru\u0161ena'), (u'Skrusena', u'Skru\u0161ena'), (u'sledeca', u'sljede\u0107a'), (u'Sledece', u'Sljede\u0107e'), (u'sledeci', u'sljede\u0107i'), (u'Sledeci', u'Sljede\u0107i'), (u'slicno', u'sli\u010dno'), (u'sljedeci', u'sljede\u0107i'), (u'Sljedeci', u'Sljede\u0107i'), (u'slozila', u'slo\u017eila'), (u'slozili', u'slo\u017eili'), (u'slozio', u'slo\u017eio'), (u'sloziti', u'slo\u017eiti'), (u'slucaja', u'slu\u010daja'), (u'Smatras', u'Smatra\u0161'), (u'smatras', u'smatra\u0161'), (u'smece', u'sme\u0107e'), (u'smeda', u'sme\u0111a'), (u'smedem', u'sme\u0111em'), (u'smedi', u'sme\u0111i'), (u'smedoj', u'sme\u0111oj'), (u'smedu', u'sme\u0111u'), (u'smesak', u'smje\u0161ak'), (u'Smijes', u'Smije\u0161'), (u'smijes', u'smije\u0161'), (u'smionoscu', u'smiono\u0161\u0107u'), (u'smraci', u'smra\u010di'), (u'smracilo', u'smra\u010dilo'), (u'smrcu', u'smr\u0107u'), (u'snimacete', u'snimat \u0107ete'), (u'sokiras', u'\u0161okira\u0161'), (u'spases', u'spasi\u0161'), (u'Spases', u'Spasi\u0161'), (u'spavaca', u'spava\u0107a'), (u'spavacoj', u'spava\u0107oj'), (u'spominjes', u'spominje\u0161'), (u'spustamo', u'spu\u0161tamo'), (u'srdacan', u'srda\u010dan'), (u'srecom', u'sre\u0107om'), (u'sresce', u'srest \u0107e'), (u'sre\u0161ce', u'srest \u0107e'), (u'srljas', u'srlja\u0161'), (u'Sta', u'\u0160to'), (u'sta', u'\u0161to'), (u'stab', u'sto\u017eer'), (u'Stab', u'Sto\u017eer'), (u'stagod', u'\u0161to god'), (u'stampa', u'tisak'), (u'stampati', u'tiskati'), (u'stampi', u'tisku'), (u'stampom', u'tiskom'), (u'stampu', u'tisak'), (u'standa', u'\u0161tanda'), (u'standu', u'\u0161tandu'), (u'stavis', u'stavi\u0161'), (u'Stavise', u'\u0160tovi\u0161e'), (u'Stavi\u0107emo', u'Stavit \u0107emo'), (u'steceni', u'ste\u010deni'), (u'stezuci', u'ste\u017eu\u0107i'), (u'stici', u'sti\u0107i'), (u'stojis', u'stoji\u0161'), (u'Stojis', u'Stoji\u0161'), (u'stp', u'\u0161to'), (u'strasan', u'stra\u0161an'), (u'strasno', u'stra\u0161no'), (u'sudeci', u'sude\u0107i'), (u'sudenja', u'su\u0111enja'), (u'sudenje', u'su\u0111enje'), (u'sudenju', u'su\u0111enju'), (u'sugerisu', u'predla\u017eu'), (u'sumnjas', u'sumnja\u0161'), (u'sumska', u'\u0161umska'), (u'sumski', u'\u0161umski'), (u'sumskoj', u'\u0161umskoj'), (u'supak', u'\u0161upak'), (u'suraduj', u'sura\u0111uj'), (u'suraduje', u'sura\u0111uje'), (u'suradujemo', u'sura\u0111ujemo'), (u'suraduju', u'sura\u0111uju'), (u'Suraduj', u'Sura\u0111uj'), (u'Suraduje', u'Sura\u0111uje'), (u'Suradujemo', u'Sura\u0111ujemo'), (u'Suraduju', u'Sura\u0111uju'), (u'sustina', u'bit'), (u'sustine', u'biti'), (u'sustini', u'biti'), (u'Sustine', u'Biti'), (u'Sustini', u'Biti'), (u'Sustinom', u'Biti'), (u'sustinom', u'biti'), (u'sustinski', u'bitni'), (u'suti', u'\u0161uti'), (u'Suti', u'\u0160uti'), (u'svacije', u'sva\u010dije'), (u'svaciji', u'sva\u010diji'), (u'svaciju', u'sva\u010diju'), (u'svecan', u'sve\u010dan'), (u'svecani', u'sve\u010dani'), (u'svez', u'svje\u017e'), (u'sveza', u'svje\u017ea'), (u'svezu', u'svje\u017eu'), (u'svezi', u'svje\u017ei'), (u'sveze', u'svje\u017ee'), (u'svezim', u'svje\u017eim'), (u'svezom', u'svje\u017eom'), (u'svezoj', u'svje\u017eoj'), (u'svezinom', u'svje\u017einom'), (u'svezina', u'svje\u017eina'), (u'svezinu', u'svje\u017einu'), (u'svezini', u'svje\u017eini'), (u'svezine', u'svje\u017eine'), (u'Svida', u'Svi\u0111a'), (u'svidala', u'svi\u0111ala'), (u'svidalo', u'svi\u0111alo'), (u'svidam', u'svi\u0111am'), (u'svidao', u'svi\u0111ao'), (u'sviras', u'svira\u0161'), (u'taknes', u'takne\u0161'), (u'takode', u'tako\u0111er'), (u'takoder', u'tako\u0111er'), (u'takodje', u'tako\u0111er'), (u'Takodje', u'Tako\u0111er'), (u'tece', u'te\u010de'), (u'teska', u'te\u0161ka'), (u'Teska', u'Te\u0161ka'), (u'teske', u'te\u0161ke'), (u'teski', u'te\u0161ki'), (u'tesko', u'te\u0161ko'), (u'Tesko', u'Te\u0161ko'), (u'teskom', u'te\u0161kom'), (u'tezak', u'te\u017eak'), (u'Tezak', u'Te\u017eak'), (u'teze', u'te\u017ee'), (u'tezi', u'te\u017ei'), (u'Tezi', u'Te\u017ei'), (u'tezimo', u'te\u017eimo'), (u'Tezimo', u'Te\u017eimo'), (u'tezinu', u'te\u017einu'), (u'tezis', u'te\u017ei\u0161'), (u'Tezi\u0161', u'Te\u017ei\u0161'), (u'tisuce', u'tisu\u0107e'), (u'tisucu', u'tisu\u0107u'), (u'Tocak', u'Kota\u010d'), (u'tocak', u'kota\u010d'), (u'tocka', u'to\u010dka'), (u'tocku', u'to\u010dku'), (u'trajace', u'trajat \u0107e'), (u'Trajace', u'Trajat \u0107e'), (u'trazis', u'tra\u017ei\u0161'), (u'trcao', u'tr\u010dao'), (u'trce', u'tr\u010de'), (u'Trce', u'Tr\u010de'), (u'trci', u'tr\u010di'), (u'Trci', u'Tr\u010di'), (u'trcim', u'tr\u010dim'), (u'Trcim', u'Tr\u010dim'), (u'trcimo', u'tr\u010dimo'), (u'trebas', u'treba\u0161'), (u'Trebas', u'Treba\u0161'), (u'treci', u'tre\u0107i'), (u'tricarija', u'tri\u010darija'), (u'trudis', u'trudi\u0161'), (u'trunuce', u'trunut \u0107e'), (u'tuce', u'tu\u010de'), (u'tuces', u'tu\u010de\u0161'), (u'tucom', u'tu\u010dom'), (u'tucu', u'tu\u010dnjavu'), (u'tudje', u'tu\u0111e'), (u'tudjeg', u'tu\u0111eg'), (u'tudoj', u'tu\u0111oj'), (u'tudom', u'tu\u0111om'), (u'tudjem', u'tu\u0111em'), (u'tudem', u'tu\u0111em'), (u'tumaras', u'tumara\u0161'), (u'tvoris', u'tvori\u0161'), (u'ubedjuju', u'uvjeravaju'), (u'ubijes', u'ubije\u0161'), (u'Ubijes', u'Ubije\u0161'), (u'uceni', u'u\u010deni'), (u'uci', u'u\u0107i'), (u'ucine', u'u\u010dine'), (u'ucinimo', u'u\u010dinimo'), (u'ucinio', u'u\u010dinio'), (u'ucio', u'u\u010dio'), (u'Ucio', u'U\u010dio'), (u'udas', u'uda\u0161'), (u'udete', u'u\u0111ete'), (u'ude\u0161', u'ude\u0161'), (u'udi', u'u\u0111i'), (u'Udi', u'U\u0111i'), (u'Udje', u'U\u0111e'), (u'udje', u'u\u0111e'), (u'udjes', u'u\u0111e\u0161'), (u'ugriscu', u'ugrist \u0107u'), (u'ukljestena', u'uklije\u0161tena'), (u'ukljucujuci', u'uklju\u010duju\u0107i'), (u'umes', u'umije\u0161'), (u'umiruci', u'umiru\u0107i'), (u'umrecu', u'umrijet \u0107u'), (u'umres', u'umre\u0161'), (u'unistice', u'uni\u0161tit \u0107e'), (u'uopce', u'uop\u0107e'), (u'Uopce', u'Uop\u0107e'), (u'Uopste', u'Uop\u0107e'), (u'uopste', u'uop\u0107e'), (u'upoznas', u'upozna\u0161'), (u'uradis', u'u\u010dini\u0161'), (u'usao', u'u\u0161ao'), (u'Usao', u'U\u0161ao'), (u'usli', u'u\u0161li'), (u'Usmjerice', u'Usmjerit \u0107e'), (u'uspanicio', u'uspani\u010dio'), (u'utapas', u'utapa\u0161'), (u'utesi', u'utje\u0161i'), (u'utesim', u'utje\u0161im'), (u'uzinu', u'u\u017einu'), (u'uzivo', u'u\u017eivo'), (u'valda', u'valjda'), (u'vasa', u'va\u0161a'), (u'vaseg', u'va\u0161eg'), (u'Vaseg', u'Va\u0161eg'), (u'vasem', u'va\u0161em'), (u'vasi', u'va\u0161i'), (u'vasoj', u'va\u0161oj'), (u'vazi', u'vrijedi'), (u'Vec', u'Ve\u0107'), (u'vec', u've\u0107'), (u'vecan', u'vje\u010dan'), (u'vecera', u've\u010dera'), (u'Veceras', u'Ve\u010deras'), (u'veceras', u've\u010deras'), (u'vecere', u've\u010dere'), (u'veceri', u've\u010deri'), (u'veceru', u've\u010deru'), (u'vecih', u've\u0107ih'), (u'vecitim', u'vje\u010ditim'), (u'vecna', u'vje\u010dna'), (u'vecno', u'vje\u010dno'), (u'vecnost', u'vje\u010dnost'), (u'verovacu', u'vjerovat \u0107u'), (u'vice', u'vi\u010de'), (u'vicem', u'vi\u010dem'), (u'vicemo', u'vi\u010demo'), (u'vices', u'vi\u010de\u0161'), (u'vicete', u'vi\u010dete'), (u'viden', u'vi\u0111en'), (u'Viden', u'Vi\u0111en'), (u'vishe', u'vi\u0161e'), (u'vjencali', u'vjen\u010dali'), (u'vjencati', u'vjen\u010dati'), (u'vjerujes', u'vjeruje\u0161'), (u'Vjerujes', u'Vjeruje\u0161'), (u'vjetrenjace', u'vjetrenja\u010de'), (u'voce', u'vo\u0107e'), (u'vocka', u'vo\u0107ka'), (u'vocku', u'vo\u0107ku'), (u'vocnjak', u'vo\u0107njak'), (u'vocnjaku', u'vo\u0107njaku'), (u'vodic', u'vodi\u010d'), (u'vodju', u'vo\u0111u'), (u'vozac', u'voza\u010d'), (u'Vozac', u'Voza\u010d'), (u'vozaca', u'voza\u010da'), (u'vracam', u'vra\u0107am'), (u'vracen', u'vra\u010den'), (u'vrazja', u'vra\u017eja'), (u'vrazji', u'vra\u017eji'), (u'vreca', u'vre\u010da'), (u'vrece', u'vre\u0107e'), (u'vrecu', u'vre\u0107u'), (u'vredja', u'vrije\u0111a'), (u'vredjanje', u'vrije\u0111anje'), (u'vrtic', u'vrti\u0107'), (u'vrtica', u'vrti\u0107a'), (u'vrticu', u'vrti\u0107u'), (u'zacepe', u'za\u010depe'), (u'Zacepi', u'Za\u010depi'), (u'Zadrzi', u'Zadr\u017ei'), (u'zadrzi', u'zadr\u017ei'), (u'zaduzen', u'zadu\u017een'), (u'Zaduzen', u'Zadu\u017een'), (u'zagrlis', u'zagrli\u0161'), (u'zaljenja', u'\u017ealjenja'), (u'zaljenje', u'\u017ealjenje'), (u'zalosna', u'\u017ealosna'), (u'Zalosna', u'\u017dalosna'), (u'zaokruzi', u'zaokru\u017ei'), (u'zaokruzim', u'zaokru\u017eim'), (u'zaokruzimo', u'zaokru\u017eimo'), (u'zapoceli', u'zapo\u010deli'), (u'zarucen', u'zaru\u010den'), (u'zasto', u'za\u0161to'), (u'Zasto', u'Za\u0161to'), (u'zateci', u'zate\u0107i'), (u'zatvoris', u'zatvori\u0161'), (u'zdrebe', u'\u017edrijebe'), (u'Zele', u'\u017dele'), (u'zele', u'\u017eele'), (u'Zeleci', u'\u017dele\u0107i'), (u'zelila', u'\u017eeljela'), (u'Zelis', u'\u017deli\u0161'), (u'zelis', u'\u017eeli\u0161'), (u'zene', u'\u017eene'), (u'zenke', u'\u017eenke'), (u'zesce', u'\u017ee\u0161\u0107e'), (u'zezas', u'zeza\u0161'), (u'zita', u'\u017eita'), (u'zito', u'\u017eito'), (u'zitu', u'\u017eitu'), (u'ziv', u'\u017eiv'), (u'ziva', u'\u017eiva'), (u'zive', u'\u017eive'), (u'zivi', u'\u017eivi'), (u'zivis', u'\u017eivi\u0161'), (u'zivjeo', u'\u017eivio'), (u'Zivjeo', u'\u017divio'), (u'zmureo', u'\u017emirio'), (u'znacaj', u'zna\u010daj'), (u'znacaja', u'zna\u010daja'), (u'znace', u'zna\u010de'), (u'znace\u0161', u'znat \u0107e\u0161'), (u'znas', u'zna\u0161'), (u'Znas', u'Zna\u0161'), (u'zuris', u'zuri\u0161'), (u'zutoj', u'\u017eutoj'), (u'zvanican', u'slu\u017eben'), (u'\u0107es', u'\u0107e\u0161'), (u'\u0107te', u'\u0107ete'), (u'\u010cime', u'\u010cime'), (u'\u017eelis', u'\u017eeli\u0161'), (u'\u017diveo', u'\u017divio')]),
                        'pattern': u'(?um)(\\b|^)(?:andele|andeli|bacas|bas|Bas|basta|Basta|baste|Baste|basti|Basti|bastom|Bastom|bastu|Bastu|Bice|bice|Bice\\\u0161|Bicu|bicu|blagonaklonoscu|blizi|bljesti|Bljesti|bojis|braca|Braca|broncane|broncanu|budes|caj|caja|Cak|cak|cale|Cao|cao|cas|casno|Casno|castis|casu|ca\\\u0161u|cebe|cega|Cek|cek|cekali|cekas|Cemu|cemu|cerka|Cerka|cerke|Cerke|cerku|Cerku|ces|cesce|Cesce|Ceskoj|cestitki|cesto|Cesto|cetiri|Cetiri|cetri|cetu|ceznja|ceznje|ceznji|ceznjom|ceznju|ceznu|ce\\\u0161|Cija|cija|cije|Ciji|ciji|cijih|Cijih|cijim|Cijim|Cim|cim|cime|cinila|cinili|cinio|cinis|ciniti|cipka|cipku|cita|citao|citas|citavu|cizme|clan|Clan|clanke|clanove|clanovi|clanovima|cmo|corsokak|corsokaku|cosak|cosku|covece|covek|covjece|covjecnost|covjek|covjeka|covjeku|crpeci|cte|Cu|Ce\\\u0161|Ce|Cemo|Cete|cu|ce|cemo|cete|cudi|Cudo|cudo|Cujte|cula|culi|Culi|culima|cuo|Cuo|cupam|cutanje|Cutanje|cutao|Cutao|cuti|cutljiv|cutnja|cuvali|cuveni|dace|dacemo|davo|definise|definisi|Desava|desava|disemo|disi|dobijes|dobivas|doci|dode|dodem|dodes|dodete|dode\\\u0161|Dodi|dodi|dodite|Dodji|dodji|Dodjite|dodjite|Dodju|dodju|dodu|dolazis|dopustao|dorucak|dorucku|Dosao|dosao|drhteci|drhte\\\u0107i|Drhte\\\u0107i|drugacija|Drugacije|drugacije|drugaciji|Drugaciji|drukciji|drveca|drvece|drvecem|drvecu|drzi|Drzim|dugmici|duze|duzinom|dzanki|Dzejk|Dzime|Dzone|flasom|flasu|fucka|funkcionisu|gacice|gadao|gadis|Gadis|gdica|gdice|gdici|gdicu|gdu|glupaco|govoris|gradani|gradic|gradica|gradicu|grancica|grancicu|gresci|grese|greski|gresku|gubis|Hoces|hoces|hocu|Hocu|hodas|htjeo|iceg|icega|icemu|Ici|ici|Ides|ides|iduce|iduceg|iducem|Iduci|iduci|ignorisi|igras|Ijudi|imas|imidz|inace|Inace|isao|Isao|iscupao|ise\\\u0107emo|isla|istjece|istrazio|Istrazio|isuvise|izaci|Izaci|izade|Izade|izadem|izades|izadete|Izadi|izadi|izasao|izasla|izici|izluduje|izluduju|izmedu|Izmedu|izostri|izostrim|izvuci|i\\\u0161cupao|jebes|Jebes|jos|Jos|juce|Juce|jucer|Jucer|kaslja|kaze|Kaze|kazemo|kazite|Kazite|kazu|Kcer|kcer|kcerka|Kcerka|kcerkama|kcerku|Kcerku|kecap|kecapa|kise|kisi|kleknes|kociji|kolaca|kolace|komadic|komsijama|komsije|komsiji|komsiluk|komsiluku|kom\\\u0161ija|Kom\\\u0161ija|Konkurise|konkurise|konkurisem|konkurisu|kontrolisu|kosulja|kosulje|kosulji|kosulju|kovceg|kovcegu|krada|Krada|Krece|krece|Kreci|kreci|krecu|kre\\\u0107es|krosnje|krvaris|kuca|kucama|kuce|kuci|kusa|kusas|ku\\\u010da|ku\\\u010di|lakocom|laz|lazac|laze|lazi|lazne|lazni|lazov|ledja|ledjima|leprsa|lezala|lezali|lezati|lezis|Lezis|lici|licim|licis|licnost|licnosti|lijecniku|ljubis|los|losa|losu|majcine|masini|medu|Medutim|medutim|mici|Mici|micu|mislis|Mislis|mjesecevom|mjesecine|mjesecini|mjesecinu|mladic|moc|moci|motivisu|mozda|Mozda|moze|mozete|mreza|mrezu|mrzis|muce|mucenik|mucne|muska|muz|muza|naci|Naci|nacin|nadem|Nadem|nademo|nades|Nades|nadete|nadici|nadje|Nadje|nadjen|nadjes|Nadjes|nadjete|nagovestaj|najvise|Najvise|naklonoscu|naocale|Napisite|nasa|Nase|nase|naseg|nasi|Nasi|nasao|Nasao|nasla|Nasla|nasli|Nasli|nasoj|nasrecu|nastavis|nasu|nauce|neceg|necega|necemo|necemu|necije|neciji|necim|necovjecnost|necovjecnosti|necu|Necu|nekaze|nekoc|Nemas|nemas|Nesreca|nesto|Nesto|new\\ yorski|Nezan|nezan|nezna|Neznam|Neznas|Neznajuci|Neznavsi|neznam|neznas|neznajuci|neznavsi|nezni|neznih|neznim|nezno|neznu|niceg|nicega|nicemu|nicija|niciji|nicim|njezno|nju\\ jorski|noci|nocnu|nosac|nosices|nosis|noz|nozem|Obecao|Obezbedjuju|obezbedjuju|obide|objasnis|obozavalac|obracas|obra\\\u0107as|obuce|obucem|oceve|ocito|ocnjaci|odes|odlazis|odlezati|odlucim|odmice|odraduje|odreden|odreduje|odredujemo|odvec|ogrtac|ohrabrujuce|ojacam|okrece|opasac|operise|operisemo|operisete|operise\\\u0161|osecaces|osjecaces|osjecam|osjecanja|oslobada|ostra|ostre|ostri|ostrom|ostru|osvrnes|Osvrnes|otezala|otidi|otidji|otisao|oziljak|palaca|palaci|palacu|papucama|parce|pateci|patis|pcela|pcele|pecini|pecinski|peraca|Peraci|pica|pice|picem|pijes|pisacoj|pise|pisem|pisemo|pises|pisite|pisu|pitas|placa|placam|placanje|placanjem|place|placem|placete|place\\\u0161|placu|placuci|Plasi|plazi|plazu|plese|plesemo|plesete|plesu|ploca|ploce|pluca|plucima|pobjeci|pobjeduje|poceli|poceo|pocetak|pocevsi|pocev\\\u0161i|poci|pocinje|pociva|pocivali|pocivao|pode|podi|podici|Podici|podimo|Podimo|podje|Podje|Podji|podji|podneses|podocnjacima|podocnjake|podstice|poduzeca|poduzece|poduzecu|pojesce|pojiliste|pokazi|Pokazi|pokrece|pokusaj|pokusam|pokusas|poletis|polozaja|polozaju|pomaci|pomazes|pomislis|pomognes|poneses|ponovis|poreci|porice|posalji|Posalji|posaljite|posle|posluzili|Posluzite|posluzite|postaras|posto|Posto|potece|potice|potici|potjece|potjecem|potjeces|potpises|povedes|pozuda|pozude|pozudi|pozudu|prakticno|premasuje|premasuju|preporuca|presao|presjecen|Previse|previse|preziveo|Priblizi|price|prici|pricu|Pridji|pridji|prijeci|prijedi|prilazis|prisao|priusti|priustimo|priustiti|proci|prodavac|promasio|Promasio|prosao|prosla|Prosle|prosle|prosli|Prosli|proslim|proslo|Proslo|provedes|provlaci|provlacimo|pticica|pticicu|pucini|pupcanu|pusac|pusaci|pusi|pusimo|pusite|pustam|racunare|racunari|radis|Radis|raskosni|razumes|Razumes|rec|rece|Receno|receno|recima|resimo|rijec|Rijeci|rijedji|rjedji|Rjesit|rodena|rodeni|rodis|rodjen|rucno|ruza|ruzan|ruzu|sadrze|sadrzi|salje|saljes|salju|sasila|sasili|sasio|sasiti|savescu|savijescu|sedeces|sedis|sedista|sediste|sendvic|sesir|sesirom|sest|setala|setam|setis|seva|sevu|sezdeset|Sidji|sidji|sijecanj|siroki|sjecaju|sjecam|Sjecam|sjecanja|sjecanje|skace|skaci|skacu|sklanjas|sklonoscu|sklupcam|skola|Skola|Skotska|Skotskoj|skrt|skrte|skrusena|Skrusena|sledeca|Sledece|sledeci|Sledeci|slicno|sljedeci|Sljedeci|slozila|slozili|slozio|sloziti|slucaja|Smatras|smatras|smece|smeda|smedem|smedi|smedoj|smedu|smesak|Smijes|smijes|smionoscu|smraci|smracilo|smrcu|snimacete|sokiras|spases|Spases|spavaca|spavacoj|spominjes|spustamo|srdacan|srecom|sresce|sre\\\u0161ce|srljas|Sta|sta|stab|Stab|stagod|stampa|stampati|stampi|stampom|stampu|standa|standu|stavis|Stavise|Stavi\\\u0107emo|steceni|stezuci|stici|stojis|Stojis|stp|strasan|strasno|sudeci|sudenja|sudenje|sudenju|sugerisu|sumnjas|sumska|sumski|sumskoj|supak|suraduj|suraduje|suradujemo|suraduju|Suraduj|Suraduje|Suradujemo|Suraduju|sustina|sustine|sustini|Sustine|Sustini|Sustinom|sustinom|sustinski|suti|Suti|svacije|svaciji|svaciju|svecan|svecani|svez|sveza|svezu|svezi|sveze|svezim|svezom|svezoj|svezinom|svezina|svezinu|svezini|svezine|Svida|svidala|svidalo|svidam|svidao|sviras|taknes|takode|takoder|takodje|Takodje|tece|teska|Teska|teske|teski|tesko|Tesko|teskom|tezak|Tezak|teze|tezi|Tezi|tezimo|Tezimo|tezinu|tezis|Tezi\\\u0161|tisuce|tisucu|Tocak|tocak|tocka|tocku|trajace|Trajace|trazis|trcao|trce|Trce|trci|Trci|trcim|Trcim|trcimo|trebas|Trebas|treci|tricarija|trudis|trunuce|tuce|tuces|tucom|tucu|tudje|tudjeg|tudoj|tudom|tudjem|tudem|tumaras|tvoris|ubedjuju|ubijes|Ubijes|uceni|uci|ucine|ucinimo|ucinio|ucio|Ucio|udas|udete|ude\\\u0161|udi|Udi|Udje|udje|udjes|ugriscu|ukljestena|ukljucujuci|umes|umiruci|umrecu|umres|unistice|uopce|Uopce|Uopste|uopste|upoznas|uradis|usao|Usao|usli|Usmjerice|uspanicio|utapas|utesi|utesim|uzinu|uzivo|valda|vasa|vaseg|Vaseg|vasem|vasi|vasoj|vazi|Vec|vec|vecan|vecera|Veceras|veceras|vecere|veceri|veceru|vecih|vecitim|vecna|vecno|vecnost|verovacu|vice|vicem|vicemo|vices|vicete|viden|Viden|vishe|vjencali|vjencati|vjerujes|Vjerujes|vjetrenjace|voce|vocka|vocku|vocnjak|vocnjaku|vodic|vodju|vozac|Vozac|vozaca|vracam|vracen|vrazja|vrazji|vreca|vrece|vrecu|vredja|vredjanje|vrtic|vrtica|vrticu|zacepe|Zacepi|Zadrzi|zadrzi|zaduzen|Zaduzen|zagrlis|zaljenja|zaljenje|zalosna|Zalosna|zaokruzi|zaokruzim|zaokruzimo|zapoceli|zarucen|zasto|Zasto|zateci|zatvoris|zdrebe|Zele|zele|Zeleci|zelila|Zelis|zelis|zene|zenke|zesce|zezas|zita|zito|zitu|ziv|ziva|zive|zivi|zivis|zivjeo|Zivjeo|zmureo|znacaj|znacaja|znace|znace\\\u0161|znas|Znas|zuris|zutoj|zvanican|\\\u0107es|\\\u0107te|\\\u010cime|\\\u017eelis|\\\u017diveo)(\\b|$)'}},
 'dan': {'BeginLines': {'data': OrderedDict(),
                        'pattern': None},
         'EndLines': {'data': OrderedDict(),
                      'pattern': None},
         'PartialLines': {'data': OrderedDict(),
                          'pattern': None},
         'PartialWordsAlways': {'data': OrderedDict([(u'\xa4', u'o'), (u'IVI', u'M'), (u'lVI', u'M'), (u'IVl', u'M'), (u'lVl', u'M')]),
                                'pattern': None},
         'WholeLines': {'data': OrderedDict(),
                        'pattern': None},
         'WholeWords': {'data': OrderedDict([(u'Haner', u'Han er'), (u'JaveL', u'Javel'), (u'Pa//e', u'Palle'), (u'bffte', u'bitte'), (u'Utro//gt', u'Utroligt'), (u'Kommerdu', u'Kommer du'), (u'smi/er', u'smiler'), (u'/eg', u'leg'), (u'harvinger', u'har vinger'), (u'/et', u'let'), (u'erjeres', u'er jeres'), (u'hardet', u'har det'), (u't\xe6nktjer', u't\xe6nkt jer'), (u'erjo', u'er jo'), (u'sti/', u'stil'), (u'Iappe', u'lappe'), (u'Beklagel\xe7', u'Beklager,'), (u'vardet', u'var det'), (u'afden', u'af den'), (u'snupperjeg', u'snupper jeg'), (u'ikkejeg', u'ikke jeg'), (u'bliverjeg', u'bliver jeg'), (u'hartravit', u'har travlt'), (u'pandekagef/ag', u'pandekageflag'), (u'Stormvarsell', u'Stormvarsel!'), (u'stormvejn', u'stormvejr.'), (u'morgenkomp/et', u'morgenkomplet'), (u'/yv', u'lyv'), (u'varjo', u'var jo'), (u'/eger', u'leger'), (u'harjeg', u'har jeg'), (u'havdejeg', u'havde jeg'), (u'hvorjeg', u'hvor jeg'), (u'n\xe5rjeg', u'n\xe5r jeg'), (u'g\xe5rvi', u'g\xe5r vi'), (u'atjeg', u'at jeg'), (u'isine', u'i sine'), (u'f\xe5rjeg', u'f\xe5r jeg'), (u'k\xe6rtighed', u'k\xe6rlighed'), (u'skullejeg', u'skulle jeg'), (u'laest', u'l\xe6st'), (u'laese', u'l\xe6se'), (u'g\xf8rjeg', u'g\xf8r jeg'), (u'g\xf8rvi', u'g\xf8r vi'), (u'angrerjo', u'angrer jo'), (u'Hvergang', u'Hver gang'), (u'erder', u'er der'), (u'villetilgive', u'ville tilgive'), (u'\ufb01eme', u'fjeme'), (u'genopst\xe5ri', u'genopst\xe5r i'), (u'svigtejer', u'svigte jer'), (u'kommernu', u'kommer nu'), (u'n\xe5rman', u'n\xe5r man'), (u'erfire', u'er fire'), (u'Hvorfor\ufb01nderdu', u'Hvorfor \ufb01nder du'), (u'undertigt', u'underligt'), (u'itroen', u'i troen'), (u'erl\xf8gnt', u'er l\xf8gn!'), (u'g\xf8rden', u'g\xf8r den'), (u'forhelvede', u'for helvede'), (u'hjpe', u'hj\xe6lpe'), (u'togeti', u'toget i'), (u'M\xe5jeg', u'M\xe5 jeg'), (u'savnerjer', u'savner jer'), (u'erjeg', u'er jeg'), (u'vaere', u'v\xe6re'), (u'geme', u'gerne'), (u'trorp\xe5', u'tror p\xe5'), (u'forham', u'for ham'), (u'afham', u'af ham'), (u'harjo', u'har jo'), (u'ovema\ufb01et', u'overnattet'), (u'begae\ufb01ighed', u'beg\xe6rlighed'), (u'sy\u2019g', u'syg'), (u'Imensjeg', u'Imens jeg'), (u'bliverdu', u'bliver du'), (u'\ufb01ser', u'fiser'), (u'manipuierer', u'manipulerer'), (u'forjeg', u'for jeg'), (u'iivgivendefor', u'livgivende for'), (u'formig', u'for mig'), (u'Hardu', u'Har du'), (u'fornold', u'forhold'), (u'defrelste', u'de frelste'), (u'S\xe5jeg', u'S\xe5 jeg'), (u'varjeg', u'var jeg'), (u'g\xf8rved', u'g\xf8r ved'), (u'kalderjeg', u'kalder jeg'), (u'\ufb02ytte', u'flytte'), (u'handlerdet', u'handler det'), (u'trorjeg', u'tror jeg'), (u'\ufb02ytter', u'flytter'), (u'soverjeg', u'sover jeg'), (u'\ufb01nderud', u'\ufb01nder ud'), (u'naboerp\xe5', u'naboer p\xe5'), (u'ervildt', u'er vildt'), (u'v\xe6reher', u'v\xe6re her'), (u'hyggerjer', u'hygger jer'), (u'borjo', u'bor jo'), (u'kommerikke', u'kommer ikke'), (u'folkynde', u'forkynde'), (u'farglad', u'far glad'), (u'misterjeg', u'mister jeg'), (u'\ufb01nt', u'fint'), (u'Harl', u'Har I'), (u'bedejer', u'bede jer'), (u'synesjeg', u'synes jeg'), (u'vartil', u'var til'), (u'eren', u'er en'), (u'\\Al', u'Vil'), (u'\\A', u'Vi'), (u'fjeme', u'fjerne'), (u'Iigefyldt', u'lige fyldt'), (u'ertil', u'er til'), (u'fa\ufb01igt', u'farligt'), (u'\ufb01nder', u'finder'), (u'\ufb01ndes', u'findes'), (u'irettesae\ufb01else', u'irettes\xe6ttelse'), (u'ermed', u'er med'), (u'\xe8n', u'\xe9n'), (u'gikjoi', u'gik jo i'), (u'Hvisjeg', u'Hvis jeg'), (u'ovema\ufb01er', u'overnatter'), (u'hoident', u'holdent'), (u'\\Adne', u'Vidne'), (u'fori', u'for i'), (u'vei', u'vel'), (u'savnerjerjo', u'savner jer jo'), (u'elskerjer', u'elsker jer'), (u'harl\xf8jet', u'har l\xf8jet'), (u'eri', u'er i'), (u'\ufb01ende', u'fjende'), (u'derjo', u'der jo'), (u'sigerjo', u'siger jo'), (u'menerjeg', u'mener jeg'), (u'Harjeg', u'Har jeg'), (u'sigerjeg', u'siger jeg'), (u'splitterjeg', u'splitter jeg'), (u'erjournalist', u'er journalist'), (u'erjoumalist', u'er journalist'), (u'Forjeg', u'For jeg'), (u'g\xe2rjeg', u'g\xe5r jeg'), (u'N\xe2rjeg', u'N\xe5r jeg'), (u'a\ufb02lom', u'afkom'), (u'farerjo', u'farer jo'), (u'tagerjeg', u'tager jeg'), (u'Virkerjeg', u'Virker jeg'), (u'morerjer', u'morer jer'), (u'kommerjo', u'kommer jo'), (u'istand', u'i stand'), (u'b\xf8m', u'b\xf8rn'), (u'frygterjeg', u'frygter jeg'), (u'kommerjeg', u'kommer jeg'), (u'eriournalistelev', u'er journalistelev'), (u'harfat', u'har fat'), (u'f\xe5r\ufb01ngre', u'f\xe5r \ufb01ngre'), (u'sl\xe2rjeg', u'sl\xe5r jeg'), (u'bam', u'barn'), (u'erjournalistelev', u'er journalistelev'), (u'politietjo', u'politiet jo'), (u'elskerjo', u'elsker jo'), (u'vari', u'var i'), (u'fornemmerjeres', u'fornemmer jeres'), (u'udkl\xe6kketl', u'udkl\xe6kket!'), (u'\xed', u'i'), (u'nyi', u'ny i'), (u'Iumijelse', u'forn\xf8jelse'), (u'vures', u'vores'), (u'I/Vash\xedngtan', u'Washington'), (u'opleverjeg', u'oplever jeg'), (u'PANTEL\xc3NER', u'PANTEL\xc5NER'), (u'Gudmurgen', u'Godmorgen'), (u'SKYDEV\xc3BEN', u'SKYDEV\xc5BEN'), (u'P\xc3LIDELIG', u'P\xc5LIDELIG'), (u'avertalte', u'overtalte'), (u'Oms\xedder', u'Omsider'), (u'lurteb\xe5d', u'lorteb\xe5d'), (u'Telrslning', u'Tekstning'), (u'miU\xf8', u'milj\xf8'), (u'g\xe5ri', u'g\xe5r i'), (u'Fan/el', u'Farvel'), (u'abe\ufb01\xe6s', u'abefj\xe6s'), (u'hartalt', u'har talt'), (u'\\\xc5rkelig', u'Virkelig'), (u'beklagerjeg', u'beklager jeg'), (u'N\xe5rjeg', u'N\xe5r jeg'), (u'rnaend', u'm\xe6nd'), (u'vaskebjorn', u'vaskebj\xf8rn'), (u'Ivil', u'I vil'), (u'besog', u'bes\xf8g'), (u'Vaer', u'V\xe6r'), (u'Undersogte', u'Unders\xf8gte'), (u'modte', u'm\xf8dte'), (u'toj', u't\xf8j'), (u'fodt', u'f\xf8dt'), (u'gore', u'g\xf8re'), (u'provede', u'pr\xf8vede'), (u'forste', u'f\xf8rste'), (u'igang', u'i gang'), (u'ligenu', u'lige nu'), (u'clet', u'det'), (u'Strombell', u'Strombel!'), (u'tmvlt', u'travlt'), (u'studererjournalistik', u'studerer journalistik'), (u'inforrnererjeg', u'informerer jeg'), (u'omk\ufb01ng', u'omkring'), (u'tilAsg\xe5rd', u'til Asg\xe5rd'), (u'Kederjeg', u'Keder jeg'), (u'jaettetamp', u'j\xe6ttetamp'), (u'erjer', u'er jer'), (u'atjulehygge', u'at julehygge'), (u'Ueneste', u'tjeneste'), (u'foltsaetter', u'forts\xe6tter'), (u'A/ice', u'Alice'), (u'tvivlerjeg', u'tvivler jeg'), (u'henterjer', u'henter jer'), (u'forst\xe5rjeg', u'forst\xe5r jeg'), (u'hvisjeg', u'hvis jeg'), (u'/\xe6rt', u'l\xe6rt'), (u'vfgtrgt', u'vigtigt'), (u'hurtigtjeg', u'hurtigt jeg'), (u'kenderjo', u'kender jo'), (u'seiv', u'selv'), (u'/\xe6gehuset', u'l\xe6gehuset'), (u'herjo', u'her jo'), (u'stolerjeg', u'stoler jeg'), (u'digi', u'dig i'), (u'taberi', u'taber i'), (u'sl\xe5rjeres', u'sl\xe5r jeres'), (u'laere', u'l\xe6re'), (u'tr\xe6nerwushu', u'tr\xe6ner wushu'), (u'efterjeg', u'efter jeg'), (u'e\ufb01er', u'efter'), (u'dui', u'du i'), (u'a\ufb01en', u'aften'), (u'bliveri', u'bliver i'), (u'acceptererjer', u'accepterer jer'), (u'drikkerjo', u'drikker jo'), (u'\ufb01anjin', u'Tianjin'), (u'erl\xe6nge', u'er l\xe6nge'), (u'erikke', u'er ikke'), (u'medjer', u'med jer'), (u'Tmykke', u'Tillykke'), (u"'\ufb01anjins", u'Tianjins'), (u'Mesteri', u'Mester i'), (u'sagdetil', u'sagde til'), (u'indei', u'inde i'), (u'o\ufb01e', u'ofte'), (u"'\ufb01lgiv", u'Tilgiv'), (u'Lf\xe5r', u'I f\xe5r'), (u'viserjer', u'viser jer'), (u'Rejsjerblot', u'Rejs jer blot'), (u"'\ufb01llad", u'Tillad'), (u'iiiie\ufb01nger', u'lille\ufb01nger'), (u'VILOMFATTE', u'VIL OMFATTE'), (u'mo\ufb01o', u'motto'), (u'g\xf8rjer', u'g\xf8r jer'), (u'gifi', u'gift'), (u'hardu', u'har du'), (u'gi\ufb01', u'gift'), (u'Iaeggerjeg', u'l\xe6gger jeg'), (u'iet', u'i et'), (u'sv/yte', u'svigte'), (u'ti/', u'til'), (u'Wdal', u'Vidal'), (u'\ufb01\xe5et', u'f\xe5et'), (u'Hvo/for', u'Hvorfor'), (u'hellerikke', u'heller ikke'), (u'Wlle', u'Ville'), (u'dr/ver', u'driver'), (u'V\\\ufb02lliam', u'William'), (u'V\\\ufb02lliams', u'Williams'), (u'Vk\ufb01lliam', u'William'), (u'v\xe5dejakke', u'v\xe5de jakke'), (u'k\xe6\ufb02l', u'k\xe6ft!'), (u'sagdejeg', u'sagde jeg'), (u'oven/ejet', u'overvejet'), (u'karameisauce', u'karamelsauce'), (u'Lf\xf8lgej\xf8disk', u'If\xf8lge j\xf8disk'), (u'blevjo', u'blev jo'), (u'asiateri', u'asiater i'), (u'erV\\\ufb02lliam', u'er William'), (u'lidt\ufb02ov', u'lidt \ufb02ov'), (u'sagdejo', u'sagde jo'), (u'erlige', u'er lige'), (u'Vt\ufb01lliam', u'William'), (u'W\ufb01II', u'Will'), (u'a\ufb02darede', u'afklarede'), (u'hj\xe6iperjeg', u'hj\xe6lper jeg'), (u'laderjeg', u'lader jeg'), (u'H\xe2ndledsbeskyttere', u'H\xe5ndledsbeskyttere'), (u'Lsabels', u'Isabels'), (u'G\xf8rjeg', u'G\xf8r jeg'), (u'm\xe2jeg', u'm\xe5 jeg'), (u'ogjeg', u'og jeg'), (u'gjordejeg', u'gjorde jeg'), (u'villejeg', u'ville jeg'), (u'Vl\ufb02lliams', u'Williams'), (u'Dajeg', u'Da jeg'), (u'iorden', u'i orden'), (u'fandtjeg', u'fandt jeg'), (u'Tilykke', u'Tillykke'), (u'k\xf8rerjer', u'k\xf8rer jer'), (u'g\xf8fjeg', u'g\xf8r jeg'), (u'Selvflgelig', u'Selvf\xf8lgelig'), (u'fdder', u'fadder'), (u'bnfaldt', u'b\xf8nfaldt'), (u't\\/ehovedede', u'tvehovedede'), (u'EIler', u'Eller'), (u'ringerjeg', u'ringer jeg'), (u'blevv\xe6k', u'blev v\xe6k'), (u'st\xe1rjeg', u'st\xe5r jeg'), (u'varforbi', u'var forbi'), (u'harfortalt', u'har fortalt'), (u'iflere', u'i flere'), (u't\xf8rjeg', u't\xf8r jeg'), (u'kunnejeg', u'kunne jeg'), (u'm\xe1', u'm\xe5'), (u'hart\xe6nkt', u'har t\xe6nkt'), (u'F\xe1rjeg', u'F\xe5r jeg'), (u'afdelingervar', u'afdelinger var'), (u'0rd', u'ord'), (u'p\xe1st\xe1', u'p\xe5st\xe5'), (u'gr\xe1haret', u'gr\xe5haret'), (u'varforbl\xf8ffende', u'var forbl\xf8ffende'), (u'holdtjeg', u'holdt jeg'), (u'h\xe6ngerjo', u'h\xe6nger jo'), (u'fikjeg', u'fik jeg'), (u'f\xe1r', u'f\xe5r'), (u'Hvorforf\xf8lerjeg', u'Hvorfor f\xf8ler jeg'), (u'harfeber', u'har feber'), (u'\xe1ndssvagt', u'\xe5ndssvagt'), (u'0g', u'Og'), (u'vartre', u'var tre'), (u'abner', u'\xe5bner'), (u'garjeg', u'g\xe5r jeg'), (u'sertil', u'ser til'), (u'hvorfin', u'hvor fin'), (u'harfri', u'har fri'), (u'forstarjeg', u'forst\xe5r jeg'), (u'S\xe4', u'S\xe5'), (u'hvorfint', u'hvor fint'), (u'm\xe6rkerjeg', u'm\xe6rker jeg'), (u'ogsa', u'ogs\xe5'), (u'n\xe1rjeg', u'n\xe5r jeg'), (u'Jas\xe1', u'Jas\xe5'), (u'b\xe1ndoptager', u'b\xe5ndoptager'), (u'bed\xe1rende', u'bed\xe5rende'), (u's\xe1', u's\xe5'), (u'n\xe1r', u'n\xe5r'), (u'kunnejo', u'kunne jo'), (u'Brammertil', u'Brammer til'), (u'serjeg', u'ser jeg'), (u'gikjeg', u'gik jeg'), (u'udholderjeg', u'udholder jeg'), (u'm\xe1neder', u'm\xe5neder'), (u'vartr\xe6t', u'var tr\xe6t'), (u'd\xe1rligt', u'd\xe5rligt'), (u'klaretjer', u'klaret jer'), (u'pavirkelig', u'p\xe5virkelig'), (u'spekulererjeg', u'spekulerer jeg'), (u'fors\xf8gerjeg', u'fors\xf8ger jeg'), (u'huskerjeg', u'husker jeg'), (u'ifavnen', u'i favnen'), (u'skullejo', u'skulle jo'), (u'vartung', u'var tung'), (u'varfuldst\xe6ndig', u'var fuldst\xe6ndig'), (u'Paskedag', u'P\xe5skedag'), (u'turi', u'tur i'), (u'spillerschumanns', u'spiller Schumanns'), (u'forst\xe1rjeg', u'forst\xe5r jeg'), (u'istedet', u'i stedet'), (u'n\xe1rfrem', u'n\xe5r frem'), (u'habertrods', u'h\xe5ber trods'), (u'forf\xf8rste', u'for f\xf8rste'), (u'varto', u'var to'), (u'overtil', u'over til'), (u'forfem', u'for fem'), (u'holdtjo', u'holdt jo'), (u'passerjo', u'passer jo'), (u'ellerto', u'eller to'), (u'hartrods', u'har trods'), (u'harfuldst\xe6ndig', u'har fuldst\xe6ndig'), (u'g\xe5rjeg', u'g\xe5r jeg'), (u'giderjeg', u'gider jeg'), (u'forjer', u'for jer'), (u'erindrerjeg', u'erindrer jeg'), (u't\xe6nkerjeg', u't\xe6nker jeg'), (u'GAEt', u'G\xc5ET'), (u'h\xf8rerjo', u'h\xf8rer jo'), (u'forladerjeg', u'forlader jeg'), (u'kosterjo', u'koster jo'), (u'fort\xe6llerjeg', u'fort\xe6ller jeg'), (u'Forstyrrerjeg', u'Forstyrrer jeg'), (u'tjekkerjeg', u'tjekker jeg'), (u'erjurist', u'er jurist'), (u'tlLBUD', u'TILBUD'), (u'serjo', u'se rjo'), (u'bederjeg', u'beder jeg'), (u'bilderjeg', u'bilder jeg'), (u'ULVEtlME', u'ULVETlME'), (u'sk\xe6rerjo', u'sk\xe6rer jo'), (u'afjer', u'af jer'), (u'ordnerjeg', u'ordner jeg'), (u'giverjeg', u'giver jeg'), (u'rejservi', u'rejser vi'), (u'fangerjeg', u'fanger jeg'), (u'erjaloux', u'er jaloux'), (u'glemmerjeg', u'glemmer jeg'), (u'Beh\xf8verjeg', u'Beh\xf8ver jeg'), (u'harvi', u'har vi'), (u'ertyndere', u'er tyndere'), (u'f\xe5rtordenvejr', u'f\xe5r tordenvejr'), (u'varf\xe6rdig', u'var f\xe6rdig'), (u'h\xf8rerfor', u'h\xf8rer for'), (u'varvel', u'var vel'), (u'erforbi', u'er forbi'), (u'AIle', u'Alle'), (u'l\xe6serjo', u'l\xe6ser jo'), (u'Edgarer', u'Edgar er'), (u'hartaget', u'har taget'), (u'derer', u'der er'), (u'stikkerfrem', u'stikker frem'), (u'haraldrig', u'har aldrig'), (u'ellerfar', u'eller far'), (u'erat', u'er at'), (u'turtil', u'tur til'), (u'erf\xe6rdig', u'er f\xe6rdig'), (u'f\xf8lerjeg', u'f\xf8ler jeg'), (u'jerfra', u'jer fra'), (u'eralt', u'er alt'), (u'harfaktisk', u'har faktisk'), (u'harfundet', u'har fundet'), (u'harvendt', u'har vendt'), (u'Kunstneraf', u'Kunstner af'), (u'ervel', u'er vel'), (u'st\xe5ransigt', u'st\xe5r ansigt'), (u'Erjeg', u'Er jeg'), (u'venterjeg', u'venter jeg'), (u'Hvorvar', u'Hvor var'), (u'varfint', u'var fint'), (u'ervarmt', u'er varmt'), (u'g\xe5rfint', u'g\xe5r fint'), (u'flyverforbi', u'flyver forbi'), (u'Dervar', u'Der var'), (u'dervar', u'der var'), (u'mener\xe5ndeligt', u'mener \xe5ndeligt'), (u'forat', u'for at'), (u'herovertil', u'herover til'), (u'soverfor', u'sover for'), (u'begyndtejeg', u'begyndte jeg'), (u'vendertilbage', u'vender tilbage'), (u'erforf\xe6rdelig', u'er forf\xe6rdelig'), (u'g\xf8raltid', u'g\xf8r altid'), (u'ertilbage', u'er tilbage'), (u'harv\xe6ret', u'har v\xe6ret'), (u'bagoverellertil', u'bagover eller til'), (u'hertaler', u'her taler'), (u'v\xe5gnerjeg', u'v\xe5gner jeg'), (u'vartomt', u'var tomt'), (u'g\xe5rfrem', u'g\xe5r frem'), (u'talertil', u'taler til'), (u'ertryg', u'er tryg'), (u'ansigtervendes', u'ansigter vendes'), (u'hervirkeligt', u'her virkeligt'), (u'herer', u'her er'), (u'dr\xf8mmerjo', u'dr\xf8mmer jo'), (u'erfuldkommen', u'er fuldkommen'), (u'hveren', u'hver en'), (u'erfej', u'er fej'), (u'datterforg\xe6ves', u'datter forg\xe6ves'), (u'fors\xf8gerjo', u'fors\xf8ger jo'), (u'ertom', u'er tom'), (u'vareftermiddag', u'var eftermiddag'), (u'vartom', u'var tom'), (u'angerellerforventninger', u'anger eller forventninger'), (u'k\xf8rtejeg', u'k\xf8rte jeg'), (u'Hvorforfort\xe6ller', u'Hvorfor fort\xe6ller'), (u'g\xe5rtil', u'g\xe5r til'), (u'ringerefter', u'ringer efter'), (u's\xf8gertilflugt', u's\xf8ger tilflugt'), (u'ertvunget', u'er tvunget'), (u'megetjeg', u'meget jeg'), (u'varikke', u'var ikke'), (u'Derermange', u'Der e rmange'), (u'dervilhindre', u'der vil hindre'), (u'ers\xe5', u'er s\xe5'), (u'Detforst\xe5rLeggodt', u'Det forst\xe5r jeg godt'), (u'ergodt', u'er godt'), (u'vorventen', u'vor venten'), (u'tagerfejl', u'tager fejl'), (u'ellerer', u'eller er'), (u'laverjeg', u'laver jeg'), (u'0mgang', u'omgang'), (u'afst\xe1r', u'afst\xe5r'), (u'p\xe1', u'p\xe5'), (u'rejserjeg', u'rejser jeg'), (u'ellertage', u'eller tage'), (u'takkerjeg', u'takker jeg'), (u'ertilf\xe6ldigvis', u'er tilf\xe6ldigvis'), (u'fremstar', u'fremst\xe5r'), (u'ert\xe6t', u'er t\xe6t'), (u'ijeres', u'i jeres'), (u'Sagdejeg', u'Sagde jeg'), (u'overi', u'over i'), (u'plukkerjordb\xe6r', u'plukker jordb\xe6r'), (u'klarerjeg', u'klarer jeg'), (u'jerfire', u'jer fire'), (u't\xe1beligste', u't\xe5beligste'), (u'sigertvillingerne', u'siger tvillingerne'), (u'erfaktisk', u'er faktisk'), (u'g\xe1r', u'g\xe5r'), (u'harvasket', u'har vasket'), (u'harplukketjordb\xe6rtil', u'har plukket jordb\xe6r til'), (u'plukketjordb\xe6r', u'plukket jordb\xe6r'), (u'klaverfireh\xe6ndigt', u'klaver fireh\xe6ndigt'), (u'erj\xe6vnaldrende', u'er j\xe6vnaldrende'), (u'tierjeg', u'tier jeg'), (u'Hvorerden', u'Hvor er den'), (u'0veraltjeg', u'overalt jeg'), (u'g\xe5rp\xe5', u'g\xe5r p\xe5'), (u'finderjeg', u'finder jeg'), (u'serhans', u'ser hans'), (u'tiderbliver', u'tider bliver'), (u'ellertrist', u'eller trist'), (u'forst\xe5rjeres', u'forst\xe5r jeres'), (u'Hvorsj\xe6len', u'Hvor sj\xe6len'), (u'finderro', u'finder ro'), (u'sidderjeg', u'sidder jeg'), (u'tagerjo', u'tager jo'), (u'efterjeres', u'efter jeres'), (u'10O', u'100'), (u'besluttedejeg', u'besluttede jeg'), (u'varsket', u'var sket'), (u'uadskillige', u'uadskillelige'), (u'harjetlag', u'har jetlag'), (u'lkke', u'Ikke'), (u'lntet', u'Intet'), (u'afsl\xf8rerjeg', u'afsl\xf8rer jeg'), (u'm\xe5jeg', u'm\xe5 jeg'), (u'Vl', u'VI'), (u'atbygge', u'at bygge'), (u'detmakabre', u'det makabre'), (u'vilikke', u'vil ikke'), (u'talsmandbekr\xe6fter', u'talsmand bekr\xe6fter'), (u'vedatrenovere', u'ved at renovere'), (u'fors\xf8geratforst\xe5', u'fors\xf8ger at forst\xe5'), (u'ersket', u'er sket'), (u'morderp\xe5', u'morder p\xe5'), (u'frifodiRosewood', u'fri fod i Rosewood'), (u'holdtpressem\xf8de', u'holdt pressem\xf8de'), (u'lngen', u'Ingen'), (u'lND', u'IND'), (u'henterjeg', u'henter jeg'), (u'lsabel', u'Isabel'), (u'lsabels', u'Isabels'), (u'vinderjo', u'vinder jo'), (u'r\xf8dmerjo', u'r\xf8dmer jo'), (u'etjakkes\xe6t', u'et jakkes\xe6t'), (u'gl\xe6derjeg', u'gl\xe6der jeg'), (u'lgen', u'Igen'), (u'ls\xe6r', u'Is\xe6r'), (u'iparken', u'i parken'), (u'n\xe5rl', u'n\xe5r I'), (u'tilA1', u'til A1'), (u'FBl', u'FBI'), (u'viljo', u'vil jo'), (u'detp\xe5', u'det p\xe5'), (u'KIar', u'Klar'), (u'PIan', u'Plan'), (u'EIIer', u'Eller'), (u'FIot', u'Flot'), (u'AIIe', u'Alle'), (u'AIt', u'Alt'), (u'KIap', u'Klap'), (u'PIaza', u'Plaza'), (u'SIap', u'Slap'), (u'I\xe5', u'l\xe5'), (u'BIing', u'Bling'), (u'GIade', u'Glade'), (u'Iejrb\xe5lssange', u'lejrb\xe5lssange'), (u'bedtjer', u'bedt jer'), (u'h\xf8rerjeg', u'h\xf8rer jeg'), (u'F\xe5rjeg', u'F\xe5r jeg'), (u'fikJames', u'fik James'), (u'atsnakke', u'at snakke'), (u'varkun', u'var kun'), (u'retterjeg', u'retter jeg'), (u'ernormale', u'er normale'), (u'viljeg', u'vil jeg'), (u'S\xe6tjer', u'S\xe6t jer'), (u'udsatham', u'udsat ham'), (u'afen', u'af en'), (u'p\xe5jorden', u'p\xe5 jorden'), (u'afdem', u'af dem'), (u'kmt', u'km/t')]),
                        'pattern': u"(?um)(\\b|^)(?:Haner|JaveL|Pa\\/\\/e|bffte|Utro\\/\\/gt|Kommerdu|smi\\/er|\\/eg|harvinger|\\/et|erjeres|hardet|t\\\xe6nktjer|erjo|sti\\/|Iappe|Beklagel\\\xe7|vardet|afden|snupperjeg|ikkejeg|bliverjeg|hartravit|pandekagef\\/ag|Stormvarsell|stormvejn|morgenkomp\\/et|\\/yv|varjo|\\/eger|harjeg|havdejeg|hvorjeg|n\\\xe5rjeg|g\\\xe5rvi|atjeg|isine|f\\\xe5rjeg|k\\\xe6rtighed|skullejeg|laest|laese|g\\\xf8rjeg|g\\\xf8rvi|angrerjo|Hvergang|erder|villetilgive|\\\ufb01eme|genopst\\\xe5ri|svigtejer|kommernu|n\\\xe5rman|erfire|Hvorfor\\\ufb01nderdu|undertigt|itroen|erl\\\xf8gnt|g\\\xf8rden|forhelvede|hjpe|togeti|M\\\xe5jeg|savnerjer|erjeg|vaere|geme|trorp\\\xe5|forham|afham|harjo|ovema\\\ufb01et|begae\\\ufb01ighed|sy\\\u2019g|Imensjeg|bliverdu|\\\ufb01ser|manipuierer|forjeg|iivgivendefor|formig|Hardu|fornold|defrelste|S\\\xe5jeg|varjeg|g\\\xf8rved|kalderjeg|\\\ufb02ytte|handlerdet|trorjeg|\\\ufb02ytter|soverjeg|\\\ufb01nderud|naboerp\\\xe5|ervildt|v\\\xe6reher|hyggerjer|borjo|kommerikke|folkynde|farglad|misterjeg|\\\ufb01nt|Harl|bedejer|synesjeg|vartil|eren|\\\\Al|\\\\A|fjeme|Iigefyldt|ertil|fa\\\ufb01igt|\\\ufb01nder|\\\ufb01ndes|irettesae\\\ufb01else|ermed|\\\xe8n|gikjoi|Hvisjeg|ovema\\\ufb01er|hoident|\\\\Adne|fori|vei|savnerjerjo|elskerjer|harl\\\xf8jet|eri|\\\ufb01ende|derjo|sigerjo|menerjeg|Harjeg|sigerjeg|splitterjeg|erjournalist|erjoumalist|Forjeg|g\\\xe2rjeg|N\\\xe2rjeg|a\\\ufb02lom|farerjo|tagerjeg|Virkerjeg|morerjer|kommerjo|istand|b\\\xf8m|frygterjeg|kommerjeg|eriournalistelev|harfat|f\\\xe5r\\\ufb01ngre|sl\\\xe2rjeg|bam|erjournalistelev|politietjo|elskerjo|vari|fornemmerjeres|udkl\\\xe6kketl|\\\xed|nyi|Iumijelse|vures|I\\/Vash\\\xedngtan|opleverjeg|PANTEL\\\xc3NER|Gudmurgen|SKYDEV\\\xc3BEN|P\\\xc3LIDELIG|avertalte|Oms\\\xedder|lurteb\\\xe5d|Telrslning|miU\\\xf8|g\\\xe5ri|Fan\\/el|abe\\\ufb01\\\xe6s|hartalt|\\\\\\\xc5rkelig|beklagerjeg|N\\\xe5rjeg|rnaend|vaskebjorn|Ivil|besog|Vaer|Undersogte|modte|toj|fodt|gore|provede|forste|igang|ligenu|clet|Strombell|tmvlt|studererjournalistik|inforrnererjeg|omk\\\ufb01ng|tilAsg\\\xe5rd|Kederjeg|jaettetamp|erjer|atjulehygge|Ueneste|foltsaetter|A\\/ice|tvivlerjeg|henterjer|forst\\\xe5rjeg|hvisjeg|\\/\\\xe6rt|vfgtrgt|hurtigtjeg|kenderjo|seiv|\\/\\\xe6gehuset|herjo|stolerjeg|digi|taberi|sl\\\xe5rjeres|laere|tr\\\xe6nerwushu|efterjeg|e\\\ufb01er|dui|a\\\ufb01en|bliveri|acceptererjer|drikkerjo|\\\ufb01anjin|erl\\\xe6nge|erikke|medjer|Tmykke|\\'\\\ufb01anjins|Mesteri|sagdetil|indei|o\\\ufb01e|\\'\\\ufb01lgiv|Lf\\\xe5r|viserjer|Rejsjerblot|\\'\\\ufb01llad|iiiie\\\ufb01nger|VILOMFATTE|mo\\\ufb01o|g\\\xf8rjer|gifi|hardu|gi\\\ufb01|Iaeggerjeg|iet|sv\\/yte|ti\\/|Wdal|\\\ufb01\\\xe5et|Hvo\\/for|hellerikke|Wlle|dr\\/ver|V\\\\\\\ufb02lliam|V\\\\\\\ufb02lliams|Vk\\\ufb01lliam|v\\\xe5dejakke|k\\\xe6\\\ufb02l|sagdejeg|oven\\/ejet|karameisauce|Lf\\\xf8lgej\\\xf8disk|blevjo|asiateri|erV\\\\\\\ufb02lliam|lidt\\\ufb02ov|sagdejo|erlige|Vt\\\ufb01lliam|W\\\ufb01II|a\\\ufb02darede|hj\\\xe6iperjeg|laderjeg|H\\\xe2ndledsbeskyttere|Lsabels|G\\\xf8rjeg|m\\\xe2jeg|ogjeg|gjordejeg|villejeg|Vl\\\ufb02lliams|Dajeg|iorden|fandtjeg|Tilykke|k\\\xf8rerjer|g\\\xf8fjeg|Selvflgelig|fdder|bnfaldt|t\\\\\\/ehovedede|EIler|ringerjeg|blevv\\\xe6k|st\\\xe1rjeg|varforbi|harfortalt|iflere|t\\\xf8rjeg|kunnejeg|m\\\xe1|hart\\\xe6nkt|F\\\xe1rjeg|afdelingervar|0rd|p\\\xe1st\\\xe1|gr\\\xe1haret|varforbl\\\xf8ffende|holdtjeg|h\\\xe6ngerjo|fikjeg|f\\\xe1r|Hvorforf\\\xf8lerjeg|harfeber|\\\xe1ndssvagt|0g|vartre|abner|garjeg|sertil|hvorfin|harfri|forstarjeg|S\\\xe4|hvorfint|m\\\xe6rkerjeg|ogsa|n\\\xe1rjeg|Jas\\\xe1|b\\\xe1ndoptager|bed\\\xe1rende|s\\\xe1|n\\\xe1r|kunnejo|Brammertil|serjeg|gikjeg|udholderjeg|m\\\xe1neder|vartr\\\xe6t|d\\\xe1rligt|klaretjer|pavirkelig|spekulererjeg|fors\\\xf8gerjeg|huskerjeg|ifavnen|skullejo|vartung|varfuldst\\\xe6ndig|Paskedag|turi|spillerschumanns|forst\\\xe1rjeg|istedet|n\\\xe1rfrem|habertrods|forf\\\xf8rste|varto|overtil|forfem|holdtjo|passerjo|ellerto|hartrods|harfuldst\\\xe6ndig|g\\\xe5rjeg|giderjeg|forjer|erindrerjeg|t\\\xe6nkerjeg|GAEt|h\\\xf8rerjo|forladerjeg|kosterjo|fort\\\xe6llerjeg|Forstyrrerjeg|tjekkerjeg|erjurist|tlLBUD|serjo|bederjeg|bilderjeg|ULVEtlME|sk\\\xe6rerjo|afjer|ordnerjeg|giverjeg|rejservi|fangerjeg|erjaloux|glemmerjeg|Beh\\\xf8verjeg|harvi|ertyndere|f\\\xe5rtordenvejr|varf\\\xe6rdig|h\\\xf8rerfor|varvel|erforbi|AIle|l\\\xe6serjo|Edgarer|hartaget|derer|stikkerfrem|haraldrig|ellerfar|erat|turtil|erf\\\xe6rdig|f\\\xf8lerjeg|jerfra|eralt|harfaktisk|harfundet|harvendt|Kunstneraf|ervel|st\\\xe5ransigt|Erjeg|venterjeg|Hvorvar|varfint|ervarmt|g\\\xe5rfint|flyverforbi|Dervar|dervar|mener\\\xe5ndeligt|forat|herovertil|soverfor|begyndtejeg|vendertilbage|erforf\\\xe6rdelig|g\\\xf8raltid|ertilbage|harv\\\xe6ret|bagoverellertil|hertaler|v\\\xe5gnerjeg|vartomt|g\\\xe5rfrem|talertil|ertryg|ansigtervendes|hervirkeligt|herer|dr\\\xf8mmerjo|erfuldkommen|hveren|erfej|datterforg\\\xe6ves|fors\\\xf8gerjo|ertom|vareftermiddag|vartom|angerellerforventninger|k\\\xf8rtejeg|Hvorforfort\\\xe6ller|g\\\xe5rtil|ringerefter|s\\\xf8gertilflugt|ertvunget|megetjeg|varikke|Derermange|dervilhindre|ers\\\xe5|Detforst\\\xe5rLeggodt|ergodt|vorventen|tagerfejl|ellerer|laverjeg|0mgang|afst\\\xe1r|p\\\xe1|rejserjeg|ellertage|takkerjeg|ertilf\\\xe6ldigvis|fremstar|ert\\\xe6t|ijeres|Sagdejeg|overi|plukkerjordb\\\xe6r|klarerjeg|jerfire|t\\\xe1beligste|sigertvillingerne|erfaktisk|g\\\xe1r|harvasket|harplukketjordb\\\xe6rtil|plukketjordb\\\xe6r|klaverfireh\\\xe6ndigt|erj\\\xe6vnaldrende|tierjeg|Hvorerden|0veraltjeg|g\\\xe5rp\\\xe5|finderjeg|serhans|tiderbliver|ellertrist|forst\\\xe5rjeres|Hvorsj\\\xe6len|finderro|sidderjeg|tagerjo|efterjeres|10O|besluttedejeg|varsket|uadskillige|harjetlag|lkke|lntet|afsl\\\xf8rerjeg|m\\\xe5jeg|Vl|atbygge|detmakabre|vilikke|talsmandbekr\\\xe6fter|vedatrenovere|fors\\\xf8geratforst\\\xe5|ersket|morderp\\\xe5|frifodiRosewood|holdtpressem\\\xf8de|lngen|lND|henterjeg|lsabel|lsabels|vinderjo|r\\\xf8dmerjo|etjakkes\\\xe6t|gl\\\xe6derjeg|lgen|ls\\\xe6r|iparken|n\\\xe5rl|tilA1|FBl|viljo|detp\\\xe5|KIar|PIan|EIIer|FIot|AIIe|AIt|KIap|PIaza|SIap|I\\\xe5|BIing|GIade|Iejrb\\\xe5lssange|bedtjer|h\\\xf8rerjeg|F\\\xe5rjeg|fikJames|atsnakke|varkun|retterjeg|ernormale|viljeg|S\\\xe6tjer|udsatham|afen|p\\\xe5jorden|afdem|kmt)(\\b|$)"}},
 'deu': {'BeginLines': {'data': OrderedDict(),
                        'pattern': None},
         'EndLines': {'data': OrderedDict(),
                      'pattern': None},
         'PartialLines': {'data': OrderedDict(),
                          'pattern': None},
         'PartialWordsAlways': {'data': OrderedDict([(u'IVI', u'M'), (u'IVl', u'M'), (u'I\\/I', u'M'), (u'I\\/l', u'M'), (u'lVI', u'M'), (u'lVl', u'M'), (u'l\\/I', u'M'), (u'l\\/l', u'M'), (u'\xa4', u'o')]),
                                'pattern': None},
         'WholeLines': {'data': OrderedDict(),
                        'pattern': None},
         'WholeWords': {'data': OrderedDict([(u'/a', u'Ja'), (u'/ch', u'Ich'), (u'/d/of', u'Idiot'), (u'/ebte', u'lebte'), (u'/eid', u'leid'), (u'/hn', u'ihn'), (u'/hnen', u'Ihnen'), (u'/hr', u'Ihr'), (u'/hre', u'Ihre'), (u'/hren', u'Ihren'), (u'/m', u'im'), (u'/mmer', u'immer'), (u'/n', u'In'), (u'/ndividuen', u'Individuen'), (u'/nn', u'Inn'), (u'/oe', u'Joe'), (u'/sf', u'ist'), (u'/sf/0/1n', u'Ist John'), (u'/ungs', u'Jungs'), (u'/Vfinuten', u'Minuten'), (u'/\xe9nger', u'l\xe4nger'), (u'/\xe9uft', u'l\xe4uft'), (u'0/1', u'Oh'), (u'0/me', u'ohne'), (u'0/vne', u'ohne'), (u'00om', u'000 m'), (u'100m', u'100 m'), (u'120m', u'120 m'), (u'13Oj\xa7hrie', u'130-j\xe4hrige'), (u'145m', u'145 m'), (u'150m', u'150 m'), (u'160m', u'160 m'), (u'165m', u'165 m'), (u'19m', u'19 m'), (u'20m', u'20 m'), (u'27m', u'27 m'), (u'30m', u'30 m'), (u'37m', u'37 m'), (u'38m', u'38 m'), (u'3km', u'3 km'), (u'5/ch', u'sich'), (u'5/cher', u'sicher'), (u'5/cherer', u'sicherer'), (u'5/e', u'Sie'), (u'5/nd', u'Sind'), (u'500m', u'500 m'), (u'5ulSere', u'\xe4u\xdfere'), (u'60m', u'60 m'), (u'6de', u'\xf6de'), (u'6dere', u'\xf6dere'), (u'6ffne', u'\xf6ffne'), (u'6ffnen', u'\xf6ffnen'), (u'6ffnet', u'\xd6ffnet'), (u'6fter', u'\xf6fter'), (u'750m', u'750 m'), (u'85m', u'85 m'), (u'90m', u'90 m'), (u'a//em', u'allem'), (u'A//es', u'Alles'), (u'abbeif$en', u'abbei\xdfen'), (u'abdrficken', u'abdr\xfccken'), (u'aBen', u'a\xdfen'), (u'abergl\xe9iubischen', u'abergl\xe4ubischen'), (u'aberja', u'aber ja'), (u'aberjemand', u'aber jemand'), (u'Aberjetzt', u'Aber jetzt'), (u'abf\xe9hrt', u'abf\xe4hrt'), (u'abf\xe9illt', u'abf\xe4llt'), (u'abgef\xe9rbt', u'abgef\xe4rbt'), (u'abgeh\xe9ngt', u'abgeh\xe4ngt'), (u'abgeh\xe9rt', u'abgeh\xf6rt'), (u'abgelost', u'abgel\xf6st'), (u'abgesprengli', u'abgesprengt!'), (u'abgestfirztl', u'abgest\xfcrzt'), (u'abgestilrzt', u'abgest\xfcrzt'), (u'abgestofien', u'abgesto\xdfen'), (u'abgew\xe9hlt', u'abgew\xe4hlt'), (u'abgew\xe9hnen', u'abgew\xf6hnen'), (u'abgew\xe9hnt', u'abgew\xf6hnt'), (u'abge\xe9nderten', u'abge\xe4nderten'), (u'abh\xe9ingt', u'abh\xe4ngt'), (u'abh\xe9ngen', u'abh\xe4ngen'), (u'abh\xe9ngig', u'abh\xe4ngig'), (u'abh\xe9ngiges', u'abh\xe4ngiges'), (u'Abh\xe9rstationen', u'Abh\xf6rstationen'), (u'Abjetzt', u'Ab jetzt'), (u'abkfihlen', u'abk\xfchlen'), (u'Abkfirzung', u'Abk\xfcrzung'), (u'abkommlich', u'abk\xf6mmlich'), (u'Ablegenl', u'Ablegen!'), (u'ablfisen', u'abl\xf6sen'), (u'ablosen', u'abl\xf6sen'), (u'Ablosung', u'Abl\xf6sung'), (u'abreif$en', u'abrei\xdfen'), (u'Abrijcken', u'Abr\xfccken'), (u'abr\xe9umen', u'abr\xe4umen'), (u'Absch/ed', u'Abschied'), (u'abschiefien', u'abschie\xdfen'), (u'abschlief$en', u'abschlie\xdfen'), (u'abschliefien', u'abschlie\xdfen'), (u'abschwiiren', u'abschw\xf6ren'), (u'abstoflsend', u'absto\xdfend'), (u'Abtrijnnige', u'Abtr\xfcnnige'), (u'abwiirgt', u'abw\xfcrgt'), (u'abw\xe9gen', u'abw\xe4gen'), (u'abzuh\xe9ren', u'abzuh\xf6ren'), (u'abzuschwiiren', u'abzuschw\xf6ren'), (u'abzusfofien', u'abzusto\xdfen'), (u'ACh', u'Ach'), (u'Achtungl', u'Achtung!'), (u'Achzen', u'\xc4chzen'), (u'ACHZT', u'\xc4CHZT'), (u'Acic', u'Acid'), (u'ADDRESSDATEI', u'ADRESSDATEI'), (u'Adi\xf6s', u'Adi\xf3s'), (u'Admiralitat', u'Admiralit\xe4t'), (u'Admiralit\xe9it', u'Admiralit\xe4t'), (u'Admiralit\xe9t', u'Admiralit\xe4t'), (u'Aff\xe9re', u'Aff\xe4re'), (u'Aff\xe9ren', u'Aff\xe4ren'), (u'AFl', u'AFI'), (u'aggresivem', u'aggressivem'), (u'Agypten', u'\xc4gypten'), (u'aher', u'aber'), (u'AI/en/vichtigste', u'Allerwichtigste'), (u'Ain/vays', u'Airways'), (u'AIs', u'Als'), (u'Aktivit\xe9iten', u'Aktivit\xe4ten'), (u'Aktivit\xe9ten', u'Aktivit\xe4ten'), (u'AKTMERT', u'AKTIVIERT'), (u'Alarmsfufe', u'Alarmstufe'), (u'albem', u'albern'), (u'Albtriiume', u'Albtr\xe4ume'), (u'ale', u'als'), (u'alleinl', u'allein!'), (u'allejubeln', u'alle jubeln'), (u'allern\xe9chsten', u'allern\xe4chsten'), (u'Allmiichtigerl', u'Allm\xe4chtiger!'), (u'Allm\xe9chtige', u'Allm\xe4chtige'), (u'Allm\xe9chtiger', u'Allm\xe4chtiger'), (u'allm\xe9hlich', u'allm\xe4hlich'), (u'Allm\xe9ichtiger', u'Allm\xe4chtiger'), (u'Allsparkl', u'Allspark!'), (u'allt\xe9iglichen', u'allt\xe4glichen'), (u'ALTESTE', u'\xc4LTESTE'), (u'Altester', u'\xc4ltester'), (u'Alzte', u'\xc4rzte'), (u"Amerx'kaner", u'Amerikaner'), (u'amfisierst', u'am\xfcsierst'), (u'Amiilsierst', u'Am\xfcsierst'), (u'amiisieren', u'am\xfcsieren'), (u'amiisierenl', u'am\xfcsieren!'), (u'amiisierte', u'am\xfcsierte'), (u'Amijsant', u'Am\xfcsant'), (u'amlllsant', u'am\xfcsant'), (u'amlllsiert', u'am\xfcsiert'), (u'amtlsant', u'am\xfcsant'), (u'Amusanf', u'Am\xfcsant'), (u'amusant', u'am\xfcsant'), (u'Amusiert', u'Am\xfcsiert'), (u'Anderst', u'\xc4nderst'), (u'Anderung', u'\xc4nderung'), (u'Anderungen', u'\xc4nderungen'), (u"anfa'ngt", u'anf\xe4ngt'), (u'Anffihrer', u'Anf\xfchrer'), (u'Anffingerl', u'Anf\xe4nger!'), (u'Anfiihrer', u'Anf\xfchrer'), (u'anfijhlt', u'anf\xfchlt'), (u'Anfingerl', u'Anf\xe4nger!'), (u'Anfuhrer', u'Anf\xfchrer'), (u'Anfuhrern', u'Anf\xfchrern'), (u'Anf\xe9inger', u'Anf\xe4nger'), (u'Anf\xe9ingergliick', u'Anf\xe4ngergl\xfcck'), (u'Anf\xe9nge', u'Anf\xe4nge'), (u'anf\xe9ngst', u'anf\xe4ngst'), (u'anf\xe9ngt', u'anf\xe4ngt'), (u'angebrfillt', u'angebr\xfcllt'), (u'angebrullt', u'angebr\xfcllt'), (u'angefiihrt', u'angef\xfchrt'), (u'ANGEHCHDRIGE', u'ANGEH\xd6RIGE'), (u'angehfirt', u'angeh\xf6rt'), (u'Angehtirigen', u'Angeh\xf6rigen'), (u'angeh\xe9ren', u'angeh\xf6ren'), (u'angeh\xe9rt', u'angeh\xf6rt'), (u'angel\xe9chelt', u'angel\xe4chelt'), (u'angerilhrt', u'anger\xfchrt'), (u'anger\ufb02hrt', u'anger\xfchrt'), (u'angeschweifit', u'angeschwei\xdft'), (u'angespruht', u'angespr\xfcht'), (u'angetiltert', u'anget\xfctert'), (u'Angriffspl\xe9nen', u'Angriffspl\xe4nen'), (u'Angstschweili', u'Angstschwei\xdf'), (u'anhiiren', u'anh\xf6ren'), (u'Anh\xe9inger', u'Anh\xe4nger'), (u'anh\xe9lt', u'anh\xe4lt'), (u'anh\xe9ngen', u'anh\xe4ngen'), (u'anh\xe9ren', u'anh\xf6ren'), (u'ankijndigen', u'ank\xfcndigen'), (u'anliigen', u'anl\xfcgen'), (u'anlugen', u'anl\xfcgen'), (u'anmal3ende', u'anma\xdfende'), (u'ann\xe9hern', u'ann\xe4hern'), (u'anriihrst', u'anr\xfchrst'), (u'anrijuhren', u'anr\xfchren'), (u'anst\xe9indig', u'anst\xe4ndig'), (u'anst\xe9indiger', u'anst\xe4ndiger'), (u'anst\xe9indiges', u'anst\xe4ndiges'), (u'anst\xe9ndig', u'anst\xe4ndig'), (u'anst\xe9ndige', u'anst\xe4ndige'), (u'anst\xe9ndigen', u'anst\xe4ndigen'), (u'Anst\xe9ndiges', u'Anst\xe4ndiges'), (u'Antik\xe9rper', u'Antik\xf6rper'), (u'Antiquit\xe9t', u'Antiquit\xe4t'), (u'Antistrahlenger\xe9t', u'Antistrahlenger\xe4t'), (u'antwortenl', u'antworten!'), (u'Anwe/sung', u'Anweisung'), (u'Anwe/sungen', u'Anweisungen'), (u'Anw\xe9iltin', u'Anw\xe4ltin'), (u'Anw\xe9lte', u'Anw\xe4lte'), (u'Anw\xe9ltin', u'Anw\xe4ltin'), (u'Anzilge', u'Anz\xfcge'), (u'Anztinden', u'Anz\xfcnden'), (u'Anzuge', u'Anz\xfcge'), (u'Anzugen', u'Anz\xfcgen'), (u'anzuhiiren', u'anzuh\xf6ren'), (u'anzuhoren', u'anzuh\xf6ren'), (u'anzundenl', u'anz\xfcnden!'), (u'anzupiibeln', u'anzup\xf6beln'), (u'An\xe9sthesie', u'An\xe4sthesie'), (u'An\xe9sthesieprofessor', u'An\xe4sthesieprofessor'), (u'An\xe9sthesieteam', u'An\xe4sthesieteam'), (u'An\xe9sthesist', u'An\xe4sthesist'), (u'An\xe9sthesisten', u'An\xe4sthesisten'), (u'An\xe9sthetikum', u'An\xe4sthetikum'), (u'ARBEITERI', u'ARBEITER:'), (u'Arbeitsfl\ufb02gel', u'Arbeitsfl\xfcgel'), (u'Armeefunkger\xe9t', u'Armeefunkger\xe4t'), (u'Armel', u'\xc4rmel'), (u'Arschkichern', u'Arschl\xf6chern'), (u'Arschliicher', u'Arschl\xf6cher'), (u'Arschliichern', u'Arschl\xf6chern'), (u'Arschl\xe9cher', u'Arschl\xf6cher'), (u'Arschl\xe9chern', u'Arschl\xf6chern'), (u'Arzte', u'\xc4rzte'), (u'Arzten', u'\xc4rzten'), (u'Arztin', u'\xc4rztin'), (u'Atemger\xe9usche', u'Atemger\xe4usche'), (u'Atlantikkiiste', u'Atlantikk\xfcste'), (u'Atlantikkuste', u'Atlantikk\xfcste'), (u'ATMOSPHARE', u'ATMOSPH\xc4RE'), (u'Atmosph\xe9re', u'Atmosph\xe4re'), (u'Atmosph\xe9renbereich', u'Atmosph\xe4renbereich'), (u'Atmosph\xe9reneinflugsequenz', u'Atmosph\xe4reneinflugsequenz'), (u'Atmosph\xe9reneintritt', u'Atmosph\xe4reneintritt'), (u'Attenfaiter', u'Attent\xe4ter'), (u'Attent\xe9iter', u'Attent\xe4ter'), (u'Attent\xe9ter', u'Attent\xe4ter'), (u'Attent\xe9ters', u'Attent\xe4ters'), (u'Attraktivit\xe9t', u'Attraktivit\xe4t'), (u'auBen', u'au\xdfen'), (u'Aubenblick', u'Augenblick'), (u'AuBenbord', u'Au\xdfenbord'), (u'AuBenwelt', u'Au\xdfenwelt'), (u'auBer', u'au\xdfer'), (u'AuBerdem', u'Au\xdferdem'), (u'auBerhalb', u'au\xdferhalb'), (u'auc/1', u'auch'), (u'auchl', u'auch!'), (u'Auf$erdem', u'Au\xdferdem'), (u'auf3er', u'au\xdfer'), (u'aufAugenh6he', u'auf Augenh\xf6he'), (u'aufblilhende', u'aufbl\xfchende'), (u"auff'a'ngt", u'auff\xe4ngt'), (u'Auff\xe9lliges', u'Auff\xe4lliges'), (u'aufgebltiht', u'aufgebl\xfcht'), (u'aufgeftlhrt', u'aufgef\xfchrt'), (u'aufgeh\xe9ingt', u'aufgeh\xe4ngt'), (u'aufgeh\xe9rt', u'aufgeh\xf6rt'), (u'aufgekl\xe9rt', u'aufgekl\xe4rt'), (u'aufger\xe9umt', u'aufger\xe4umt'), (u'aufgespiefit', u'aufgespie\xdft'), (u'aufgewiihlter', u'aufgew\xfchlter'), (u'aufgez\xe9hlt', u'aufgez\xe4hlt'), (u'Aufh6ren', u'Aufh\xf6ren'), (u'aufhbren', u'aufh\xf6ren'), (u'aufhdrf', u'aufh\xf6rt'), (u'aufhfiren', u'aufh\xf6ren'), (u'aufhiiren', u'aufh\xf6ren'), (u'Aufhoren', u'Aufh\xf6ren'), (u'Aufh\xe9iren', u'Aufh\xf6ren'), (u'aufh\xe9ngen', u'aufh\xe4ngen'), (u'Aufh\xe9ren', u'Aufh\xf6ren'), (u'aufh\xe9renl', u'aufh\xf6ren'), (u'aufi', u'auf,'), (u'Aufienministerium', u'Au\xdfenministerium'), (u'aufier', u'au\xdfer'), (u'Aufierdem', u'Au\xdferdem'), (u'aufiergew\xe9hnliche', u'au\xdfergew\xf6hnliche'), (u'aufierhalb', u'au\xdferhalb'), (u'Aufierirdischer', u'Au\xdferirdischer'), (u'Aufierlich', u'\xc4u\xdferlich'), (u'aufierordentlich', u'au\xdferordentlich'), (u'Aufkenposten', u'Au\xdfenposten'), (u'aufkisen', u'aufl\xf6sen'), (u'aufkl\xe9ren', u'aufkl\xe4ren'), (u'Aufkl\xe9rung', u'Aufkl\xe4rung'), (u'aufl', u'auf!'), (u'Aufl6sung', u'Aufl\xf6sung'), (u'aufliisen', u'aufl\xf6sen'), (u'auflser', u'au\xdfer'), (u'aufl\xe9sen', u'aufl\xf6sen'), (u'aufmiibeln', u'aufm\xf6beln'), (u'aufraumte', u'aufr\xe4umte'), (u'aufr\xe9umen', u'aufr\xe4umen'), (u'aufschlief$en', u'aufschlie\xdfen'), (u'Aufschlull', u'Aufschluss'), (u'aufSer', u'au\xdfer'), (u'aufSIJBigkeiten', u'auf S\xfc\xdfigkeiten'), (u'aufspturen', u'aufsp\xfcren'), (u'aufstellenl', u'aufstellen!'), (u'Aufst\xe9ndige', u'Aufst\xe4ndische'), (u'aufTanis', u'auf Tanis'), (u'Auftr\xe9ge', u'Auftr\xe4ge'), (u'aufvv\xe9ndigen', u'aufw\xe4ndigen'), (u'aufw\xe9ichst', u'aufw\xe4chst'), (u'aufw\xe9rmen', u'aufw\xe4rmen'), (u'aufZ>er', u'au\xdfer'), (u'Aufztlge', u'Aufz\xfcge'), (u'aufzuhiivren', u'aufzuh\xf6ren'), (u'aufzukl\xe9ren', u'aufzukl\xe4ren'), (u'aufzuldsen', u'aufzul\xf6sen'), (u'aufzur\xe9umen', u'aufzur\xe4umen'), (u'aufz\xe9hlen', u'aufz\xe4hlen'), (u'auf\xe9er', u'au\xdfer'), (u'auf\ufb02iegen', u'auffliegen'), (u'Augenm\xe9igen', u'Augenm\xe4gen'), (u"aul'5er", u'au\xdfer'), (u'aul3er', u'au\xdfer'), (u'Aul3erdem', u'Au\xdferdem'), (u'aul5er', u'au\xdfer'), (u'aulier', u'au\xdfer'), (u'Aulierdem', u'Au\xdferdem'), (u'auliergewfihnlich', u'au\xdfergew\xf6hnlich'), (u'aulierhalb', u'au\xdferhalb'), (u'Aulierirdischen', u'Au\xdferirdischen'), (u'auller', u'au\xdfer'), (u'aullerhalb', u'au\xdferhalb'), (u'AulSer', u'Au\xdfer'), (u'AulSerdem', u'Au\xdferdem'), (u'ausdriicken', u'ausdr\xfccken'), (u'ausdriickt', u'ausdr\xfcckt'), (u'ausdrijcken', u'ausdr\xfccken'), (u'ausdrucklicher', u'ausdr\xfccklicher'), (u'Ausdr\ufb02cken', u'Ausdr\xfccken'), (u'Ausen/v\xe9hlte', u'Auserw\xe4hlte'), (u'Ausen/v\xe9hlter', u'Auserw\xe4hlter'), (u'auserw\xe9hlt', u'auserw\xe4hlt'), (u'Ausffillen', u'Ausf\xfcllen'), (u'ausfijhren', u'ausf\xfchren'), (u'ausfijhrt', u'ausf\xfchrt'), (u'ausfuhren', u'ausf\xfchren'), (u'ausfullt', u'ausf\xfcllt'), (u'ausgef\ufb02llt', u'ausgef\xfcllt'), (u'ausgeliischt', u'ausgel\xf6scht'), (u'ausgeliist', u'ausgel\xf6st'), (u'ausgel\xe9ist', u'ausgel\xf6st'), (u'ausgel\xe9scht', u'ausgel\xf6scht'), (u'ausgel\xe9st', u'ausgel\xf6st'), (u'ausgeriickt', u'ausger\xfcckt'), (u'ausgerijstet', u'ausger\xfcstet'), (u'AUSGEWAHLT', u'AUSGEW\xc4HLT'), (u'ausgew\xe9hlt', u'ausgew\xe4hlt'), (u'Ausg\xe9ngen', u'Ausg\xe4ngen'), (u'aush6hlen', u'aush\xf6hlen'), (u'aushiilt', u'aush\xe4lt'), (u'Aushilfspunkerl', u'Aushilfspunker!'), (u'aush\xe9lt', u'aush\xe4lt'), (u'ausilben', u'aus\xfcben'), (u'Auskunfte', u'Ausk\xfcnfte'), (u'ausl', u'aus!'), (u'Ausl\xe9nder', u'Ausl\xe4nder'), (u'Ausl\xe9nderl', u'Ausl\xe4nder'), (u'ausl\xe9schen', u'ausl\xf6schen'), (u'ausl\xe9sen', u'ausl\xf6sen'), (u'Ausl\xe9ser', u'Ausl\xf6ser'), (u'AusmaB', u'Ausma\xdf'), (u'ausprobie\ufb02', u'ausprobiert'), (u'Ausriistung', u'Ausr\xfcstung'), (u'ausrusten', u'ausr\xfcsten'), (u'Ausrustung', u'Ausr\xfcstung'), (u'Ausschullware', u'Ausschussware'), (u'ausschwinnenl', u'ausschw\xe4rmen!'), (u'auszudriicken', u'auszudr\xfccken'), (u'auszuschliefien', u'auszuschlie\xdfen'), (u'auszuw\xe9hlen', u'auszuw\xe4hlen'), (u'Autorit\xe9t', u'Autorit\xe4t'), (u'Autoschlilssel', u'Autoschl\xfcssel'), (u'Autoschl\ufb02ssel', u'Autoschl\xfcssel'), (u'au\ufb02/viihlt', u'aufw\xfchlt'), (u'Au\ufb02ergewiihnlich', u'Au\xdfergew\xf6hnlich'), (u'Azevedol', u'Azevedo!'), (u'A\ufb02es', u'Alles'), (u'B/ick', u'Blick'), (u'b/olog/sch', u'biologisch'), (u'b/sschen', u'bisschen'), (u'B6se', u'B\xf6se'), (u'B6sem', u'B\xf6sem'), (u'B6ser', u'B\xf6ser'), (u'Babym\xe9dchen', u'Babym\xe4dchen'), (u'Ballastst\xe9ffchen', u'Ballastst\xf6ffchen'), (u'Ballm\xe9dchen', u'Ballm\xe4dchen'), (u'Ballm\xe9idchen', u'Ballm\xe4dchen'), (u'Ballonverk\xe9ufer', u'Ballonverk\xe4ufer'), (u'Balzenl', u'Balzen!'), (u'Bankijberfall', u'Bank\xfcberfall'), (u'Barbarenilberfall', u'Barbaren\xfcberfall'), (u'Barenk\xe9nig', u'Barenk\xf6nig'), (u'basfeln', u'basteln'), (u'Bastianol', u'Bastiano!'), (u'Bastlano', u'Bastiano'), (u'Bauchfellentztmdung', u'Bauchfellentz\xfcndung'), (u'Bauchkr\xe9mpfe', u'Bauchkr\xe4mpfe'), (u'bauf\xe9llig', u'bauf\xe4llig'), (u'bauf\xe9llige', u'bauf\xe4llige'), (u'Baumst\xe9mme', u'Baumst\xe4mme'), (u'Baupl\xe9ne', u'Baupl\xe4ne'), (u'Bbses', u'B\xf6ses'), (u'be/de', u'beide'), (u'bedecktl', u'bedeckt!'), (u'Bedilrfnisse', u'Bed\xfcrfnisse'), (u'Bedilrfnissen', u'Bed\xfcrfnissen'), (u'Bedllirfnisse', u'Bed\xfcrfnisse'), (u'bedrijckt', u'bedr\xfcckt'), (u'bedr\xe9ngen', u'bedr\xe4ngen'), (u'bedr\xe9ngt', u'bedr\xe4ngt'), (u'bedr\xe9ngten', u'bedr\xe4ngten'), (u'Beeilungf', u'Beeilung!'), (u'Beeilungl', u'Beeilung!'), (u'Beerdingungsinsiiiui', u'Beerdigungsinstitut'), (u'Beerdingungsinstitut', u'Beerdigungsinstitut'), (u'Befehll', u'Befehl!'), (u'beffirdert', u'bef\xf6rdert'), (u'Beffirderung', u'Bef\xf6rderung'), (u'befiirchte', u'bef\xfcrchte'), (u'befiirchteten', u'bef\xfcrchteten'), (u'befiirdert', u'bef\xf6rdert'), (u'befiirderte', u'bef\xf6rderte'), (u'Befiirderung', u'Bef\xf6rderung'), (u'befilrchtete', u'bef\xfcrchtete'), (u'befllirchte', u'bef\xfcrchte'), (u'befurworte', u'bef\xfcrworte'), (u'befurwortet', u'bef\xfcrwortet'), (u'bef\xe9rdere', u'bef\xf6rdere'), (u'bef\xe9rdert', u'bef\xf6rdert'), (u'Bef\xe9rderung', u'Bef\xf6rderung'), (u'beg/ng', u'beging'), (u'begl\ufb02ckt', u'begl\xfcckt'), (u'begniigt', u'begn\xfcgt'), (u'begrfindetes', u'begr\xfcndetes'), (u'Begriiliungsruf', u'Begr\xfc\xdfungsruf'), (u'begrijfien', u'begr\xfc\xdfen'), (u'Begrilfiung', u'Begr\xfc\xdfung'), (u'Begrilfkung', u'Begr\xfc\xdfung'), (u"begrL'llZ>en", u'begr\xfc\xdfen'), (u'BegrUBungsruf', u'Begr\xfc\xdfungsruf'), (u'begrUf$t', u'begr\xfc\xdft'), (u'begrufie', u'begr\xfc\xdfe'), (u'begrufit', u'begr\xfc\xdft'), (u'Begrundung', u'Begr\xfcndung'), (u'Beh6rden', u'Beh\xf6rden'), (u'beh\xe9lt', u'beh\xe4lt'), (u'Beh\xe9lter', u'Beh\xe4lter'), (u'beh\xe9mmert', u'beh\xe4mmert'), (u'beiB', u'bei\xdf'), (u'beiBen', u'bei\xdfen'), (u'beiBt', u'bei\xdft'), (u'beif$t', u'bei\xdft'), (u'beif2>en', u'bei\xdfen'), (u'beifken', u'bei\xdfen'), (u'beiflsen', u'bei\xdfen'), (u'beijenen', u'bei jenen'), (u'Beiliring', u'Bei\xdfring'), (u'BEKAMPFEN', u'BEK\xc4MPFEN'), (u'bekannf', u'bekannt'), (u'bekanntermafken', u'bekannterma\xdfen'), (u'bek\xe9me', u'bek\xe4me'), (u'bek\xe9mpfen', u'bek\xe4mpfen'), (u'Bek\xe9mpfung', u'Bek\xe4mpfung'), (u'bel', u'bei'), (u'belde', u'beide'), (u'beliellsen', u'belie\xdfen'), (u'belm', u'beim'), (u'Beltlftungstunnels', u'Bel\xfcftungstunnels'), (u'Beluftungstunnel', u'Bel\xfcftungstunnel'), (u'Beluftungstunnell', u'Bel\xfcftungstunnel!'), (u'bel\xe9stigen', u'bel\xe4stigen'), (u'Bemiihe', u'Bem\xfche'), (u'Bemiihen', u'Bem\xfchen'), (u"bemL'lhe", u'bem\xfche'), (u'bemtuht', u'bem\xfcht'), (u'bemuhen', u'bem\xfchen'), (u'bemuhten', u'bem\xfchten'), (u'Ben\xe9tigen', u'Ben\xf6tigen'), (u'ben\xe9tigt', u'ben\xf6tigt'), (u'ben\xe9tigten', u'ben\xf6tigten'), (u'Beobachtar', u'Beobachter'), (u'bereft', u'bereit'), (u'bereitf\xe9ndet', u'bereitf\xe4ndet'), (u'beriichtigtsten', u'ber\xfcchtigtsten'), (u'beriichtlgten', u'ber\xfcchtigten'), (u'beriihmt', u'ber\xfchmt'), (u'Beriihmtheiten', u'Ber\xfchmtheiten'), (u'beriihren', u'ber\xfchren'), (u'Beriihrend', u'Ber\xfchrend'), (u'beriihrt', u'ber\xfchrt'), (u'Beriihrtl', u'Ber\xfchrt!'), (u'berijhrt', u'ber\xfchrt'), (u'berilhmter', u'ber\xfchmter'), (u'berilhrt', u'ber\xfchrt'), (u'Berilhrung', u'Ber\xfchrung'), (u'Berks/1/re', u'Berkshire'), (u"BerL'lhre", u'Ber\xfchre'), (u'berllichtigter', u'ber\xfcchtigter'), (u'berllihren', u'ber\xfchren'), (u'berllihrt', u'ber\xfchrt'), (u'berlllhmten', u'ber\xfchmten'), (u'Bern/e', u'Bernie'), (u'beruhrt', u'ber\xfchrt'), (u'beruhrte', u'ber\xfchrte'), (u'ber\ufb02hmter', u'ber\xfchmter'), (u'besafi', u'besa\xdf'), (u"Besch'a'ftigt", u'Besch\xe4ftigt'), (u'bescheifien', u'beschei\xdfen'), (u'beschiftigt', u'besch\xe4ftigt'), (u'beschiiftigt', u'besch\xe4ftigt'), (u'beschiitzen', u'besch\xfctzen'), (u'beschiitzt', u'besch\xfctzt'), (u'beschiltze', u'besch\xfctze'), (u'beschiltzen', u'besch\xfctzen'), (u'beschleun/gt', u'beschleunigt'), (u'beschliefkt', u'beschlie\xdft'), (u'beschlie\ufb02tloszuziehen', u'beschlie\xdft loszuziehen'), (u'beschllitzet', u'besch\xfctzet'), (u'beschllitzt', u'besch\xfctzt'), (u'beschr\xe9nkt', u'beschr\xe4nkt'), (u'Beschr\xe9nkungen', u'Beschr\xe4nkungen'), (u'beschtitze', u'besch\xfctze'), (u'beschutzen', u'besch\xfctzen'), (u'besch\xe9digt', u'besch\xe4digt'), (u'besch\xe9ftigen', u'besch\xe4ftigen'), (u'besch\xe9ftigt', u'besch\xe4ftigt'), (u'besch\xe9ftigte', u'besch\xe4ftigte'), (u'besch\xe9ftigten', u'besch\xe4ftigten'), (u'besch\xe9iftige', u'besch\xe4ftige'), (u'besch\xe9iftigt', u'besch\xe4ftigt'), (u'Besch\xe9imen', u'Besch\xe4men'), (u'besch\xe9mendste', u'besch\xe4mendste'), (u'besch\xe9oligen', u'besch\xe4digen'), (u'besch\ufb02tzen', u'besch\xfctzen'), (u'Besch\ufb02tzer', u'Besch\xfctzer'), (u'Besf\xe9f/gen', u'Best\xe4tigen'), (u'Besitztijmer', u'Besitzt\xfcmer'), (u'BESTATIGE', u'BEST\xc4TIGE'), (u'BESTATIGT', u'BEST\xc4TIGT'), (u'bestenl', u'besten!'), (u'bestiirzt', u'best\xfcrzt'), (u'bestiitigen', u'best\xe4tigen'), (u'bestltigt', u'best\xe4tigt'), (u"bestx'mmt", u'bestimmt'), (u'best\xe9indige', u'best\xe4ndige'), (u'best\xe9itigt', u'best\xe4tigt'), (u'Best\xe9itigung', u'Best\xe4tigung'), (u'Best\xe9itigungen', u'Best\xe4tigungen'), (u'Best\xe9tige', u'Best\xe4tige'), (u'Best\xe9tigen', u'Best\xe4tigen'), (u'best\xe9tigt', u'best\xe4tigt'), (u'Best\xe9tigung', u'Best\xe4tigung'), (u'bes\xe9inftigen', u'bes\xe4nftigen'), (u'bes\xe9inftigt', u'bes\xe4nftigt'), (u'bes\xe9nftigen', u'bes\xe4nftigen'), (u'Betiiubt', u'Bet\xe4ubt'), (u'betriibt', u'betr\xfcbt'), (u'betriigen', u'betr\xfcgen'), (u'Betriiger', u'Betr\xfcger'), (u'betriigt', u'betr\xfcgt'), (u'betrijgen', u'betr\xfcgen'), (u'Betrijgerl', u'Betr\xfcger!'), (u'betrilgen', u'betr\xfcgen'), (u'betrtlgerischer', u'betr\xfcgerischer'), (u'betr\xe9chtliches', u'betr\xe4chtliches'), (u'Betr\xe9ge', u'Betr\xe4ge'), (u'betr\xe9gt', u'betr\xe4gt'), (u'Bettw\xe9ische', u'Bettw\xe4sche'), (u'Beviilkerung', u'Bev\xf6lkerung'), (u'bevorwir', u'bevor wir'), (u'bev\xe9lkern', u'bev\xf6lkern'), (u'bewegf', u'bewegt'), (u'Bew\xe9hrungsauflage', u'Bew\xe4hrungsauflage'), (u'bew\xe9ihrte', u'bew\xe4hrte'), (u'bew\xe9iltigen', u'bew\xe4ltigen'), (u'bew\xe9issern', u'bew\xe4ssern'), (u'bew\xe9lkten', u'bew\xf6lkten'), (u'bew\xe9ltigen', u'bew\xe4ltigen'), (u'Bew\xe9ltigung', u'Bew\xe4ltigung'), (u'bew\xe9ssern', u'bew\xe4ssern'), (u'Bew\xe9sserungssysteme', u'Bew\xe4sserungssysteme'), (u'Bezirksgelinde', u'Bezirksgel\xe4nde'), (u'bezuglich', u'bez\xfcglich'), (u'be\xe9ingstigende', u'be\xe4ngstigende'), (u'be\xe9ngstigend', u'be\xe4ngstigend'), (u'be\xe9ngstigender', u'be\xe4ngstigender'), (u'bffnen', u'\xf6ffnen'), (u'Bficher', u'B\xfccher'), (u'Bfiro', u'B\xfcro'), (u'bfirsten', u'b\xfcrsten'), (u'bfise', u'b\xf6se'), (u'bfisen', u'b\xf6sen'), (u'bfiser', u'b\xf6ser'), (u'bfises', u'b\xf6ses'), (u'bfiseste', u'b\xf6seste'), (u'bfisesten', u'b\xf6sesten'), (u'bgsonderen', u'besonderen'), (u'BI6de', u'Bl\xf6de'), (u'Bierbfichse', u'Bierb\xfcchse'), (u'Biicher', u'B\xfccher'), (u'Biicherei', u'B\xfccherei'), (u'Biick', u'B\xfcck'), (u'Biiffel', u'B\xfcffel'), (u'BIiHlt', u'Bl\xfcht'), (u'Biihne', u'B\xfchne'), (u'Biilcherei', u'B\xfccherei'), (u'BIind', u'Blind'), (u'Biirger', u'B\xfcrger'), (u'Biirgerrechte', u'B\xfcrgerrechte'), (u'Biiro', u'B\xfcro'), (u'Biiros', u'B\xfcros'), (u'Biirotiir', u'B\xfcrot\xfcr'), (u'biirsten', u'b\xfcrsten'), (u'Biise', u'B\xf6se'), (u'Biisen', u'B\xf6sen'), (u'biises', u'b\xf6ses'), (u'Bijchern', u'B\xfcchern'), (u'Bijhne', u'B\xfchne'), (u'Bijndnis', u'B\xfcndnis'), (u'Bijrger', u'B\xfcrger'), (u'Bijrgermeister', u'B\xfcrgermeister'), (u'Bijro', u'B\xfcro'), (u'Bijrokraten', u'B\xfcrokraten'), (u'Bijrzel', u'B\xfcrzel'), (u'Bilchern', u'B\xfcchern'), (u'Bildseitenverh\xe9ltnis', u'Bildseitenverh\xe4ltnis'), (u'Bilndel', u'B\xfcndel'), (u'Bilro', u'B\xfcro'), (u'BIood', u'Blood'), (u'BIQIS', u'Blo\xdf'), (u'Bischiife', u'Bisch\xf6fe'), (u'Bischiifen', u'Bisch\xf6fen'), (u'Bisch\xe9fe', u'Bisch\xf6fe'), (u'bistja', u'bist ja'), (u'bistjetzt', u'bist jetzt'), (u'Bittejetzt', u'Bitte jetzt'), (u'bittersiJl3es', u'bitters\xfc\xdfes'), (u'Bittesch\xe9n', u'Bittesch\xf6n'), (u'BIue', u'Blue'), (u'bi\xdfchen', u'bisschen'), (u'BL1hne', u'B\xfchne'), (u'Bl6cke', u'Bl\xf6cke'), (u'bl6d', u'bl\xf6d'), (u'bl6de', u'bl\xf6de'), (u'bl6den', u'bl\xf6den'), (u'bl6der', u'bl\xf6der'), (u'bl6des', u'bl\xf6des'), (u'Bl6dian', u'Bl\xf6dian'), (u'Bl6dmann', u'Bl\xf6dmann'), (u'Bl6dsinn', u'Bl\xf6dsinn'), (u'Blauaugel', u'Blauauge!'), (u'Blddes', u'Bl\xf6des'), (u'Ble/bf', u'Bleibt'), (u'bleibenl', u'bleiben!'), (u'blelbenl', u'blelben!'), (u'Blfidmann', u'Bl\xf6dmann'), (u'Blfidsinn', u'Bl\xf6dsinn'), (u'Blfimchen', u'Bl\xfcmchen'), (u'BLicher', u'B\xfccher'), (u'BLihne', u'B\xfchne'), (u'Bliid', u'Bl\xf6d'), (u'bliide', u'bl\xf6de'), (u'bliiden', u'bl\xf6den'), (u'bliidere', u'bl\xf6dere'), (u'bliides', u'bl\xf6des'), (u'Bliidmann', u'Bl\xf6dmann'), (u'Bliidsinn', u'Bl\xf6dsinn'), (u'bliiht', u'bl\xfcht'), (u'bliirgerlichen', u'b\xfcrgerlichen'), (u'Blijmchen', u'Bl\xfcmchen'), (u'Bllck', u'Blick'), (u'Bllindel', u'B\xfcndel'), (u'Blllroklammer', u'B\xfcroklammer'), (u'bln', u'bin'), (u'bloB', u'blo\xdf'), (u'bloBen', u'blo\xdfen'), (u'bloBstellen', u'blo\xdfstellen'), (u'blockiertl', u'blockiert!'), (u'BLODE', u'BL\xd6DE'), (u'blof$', u'blo\xdf'), (u'blofl', u'blo\xdf'), (u'Blol2>', u'Blo\xdf'), (u'blol3', u'blo\xdf'), (u'blol3>', u'blo\xdf'), (u'blol3stellen', u'blo\xdfstellen'), (u'bloli', u'blo\xdf'), (u'blolistellen', u'blo\xdfstellen'), (u'blolls', u'blo\xdf'), (u'bls', u'bis'), (u'Blst', u'Bist'), (u'bltte', u'bitte'), (u'Blumenstr\xe9iulichen', u'Blumenstr\xe4u\xdfchen'), (u'Blument\xe9pfen', u'Blument\xf6pfen'), (u'Blutgetr\xe4nkte', u'Blut getr\xe4nkte'), (u'Blutgetr\xe9nkte', u'Blutgetr\xe4nkte'), (u'blutjungl', u'blutjung!'), (u'blutriinstig', u'blutr\xfcnstig'), (u'Blutvergiefien', u'Blutvergie\xdfen'), (u'bl\xe9d', u'bl\xf6d'), (u'Bl\xe9de', u'Bl\xf6de'), (u'bl\xe9den', u'bl\xf6den'), (u'bl\xe9der', u'bl\xf6der'), (u'Bl\xe9des', u'Bl\xf6des'), (u'Bl\xe9dheit', u'Bl\xf6dheit'), (u'Bl\xe9dmann', u'Bl\xf6dmann'), (u'Bl\xe9dsinn', u'Bl\xf6dsinn'), (u'Bl\xe9iser', u'Bl\xe4ser'), (u'Bl\xe9ser', u'Bl\xe4ser'), (u'bl\xe9st', u'bl\xe4st'), (u'Bnjicke', u'Br\xfccke'), (u'Bodensch\xe9tze', u'Bodensch\xe4tze'), (u'Bogenschiefien', u'Bogenschie\xdfen'), (u'Bogenschiefienl', u'Bogenschie\xdfen!'), (u'Bogenschiefiens', u'Bogenschie\xdfens'), (u'Bogenschiitze', u'Bogensch\xfctze'), (u'Bogenschiitzen', u'Bogensch\xfctzen'), (u'Bogenschijtze', u'Bogensch\xfctze'), (u'Bogenschijtzen', u'Bogensch\xfctzen'), (u'Bogenschutzen', u'Bogensch\xfctzen'), (u'Bogenschutzenl', u'Bogensch\xfctzen!'), (u'BOnjour', u'Bonjour'), (u'bosartige', u'b\xf6sartige'), (u'Bracken', u'Brocken'), (u'Briicke', u'Br\xfccke'), (u'Briicken', u'Br\xfccken'), (u'Briider', u'Br\xfcder'), (u'Briihe', u'Br\xfche'), (u'Briillen', u'Br\xfcllen'), (u'briillt', u'br\xfcllt'), (u'Brijcke', u'Br\xfccke'), (u'Brijderlichkeit', u'Br\xfcderlichkeit'), (u'brijllen', u'br\xfcllen'), (u'Brilcke', u'Br\xfccke'), (u'Brilder', u'Br\xfcder'), (u'Brilllen', u'Br\xfcllen'), (u'brillltjeden', u'br\xfcllt jeden'), (u'Brilnette', u'Br\xfcnette'), (u'Brilsten', u'Br\xfcsten'), (u'brilten', u'br\xfcten'), (u"BrL'lcke", u'Br\xfccke'), (u"brL'lllen", u'br\xfcllen'), (u'brlliderliche', u'br\xfcderliche'), (u'Brllidern', u'Br\xfcdern'), (u'Brlliste', u'Br\xfcste'), (u'Broschijre', u'Brosch\xfcre'), (u'Broschilren', u'Brosch\xfcren'), (u'Broschuren', u'Brosch\xfcren'), (u'Brucke', u'Br\xfccke'), (u'Brucken', u'Br\xfccken'), (u'Brudern', u'Br\xfcdern'), (u'Bruhe', u'Br\xfche'), (u'brullen', u'br\xfcllen'), (u'brullt', u'br\xfcllt'), (u'Brutalitiit', u'Brutalit\xe4t'), (u'Brutzelhtihnchen', u'Brutzelh\xfchnchen'), (u'Br\xe9chtet', u'Br\xe4chtet'), (u'Br\xe9iutigam', u'Br\xe4utigam'), (u'Br\xe9sel', u'Br\xf6sel'), (u'Br\xe9tchen', u'Br\xf6tchen'), (u'br\xe9uchte', u'br\xe4uchte'), (u'br\xe9uchten', u'br\xe4uchten'), (u'br\xe9unen', u'br\xe4unen'), (u'Br\xe9ute', u'Br\xe4ute'), (u'Br\ufb02cke', u'Br\xfccke'), (u'Br\ufb02der', u'Br\xfcder'), (u'Btiro', u'B\xfcro'), (u'Btiser', u'B\xf6ser'), (u'Bucher', u'B\xfccher'), (u'Buchern', u'B\xfcchern'), (u'Budgetkiirzung', u'Budgetk\xfcrzung'), (u'BUFO', u'B\xfcro'), (u'Bugschutzgerate', u'Bugschutzger\xe4te'), (u'Buhnenbild', u'B\xfchnenbild'), (u'Bullel', u'Bulle!'), (u'Buml', u'Bum!'), (u'Bundnis', u'B\xfcndnis'), (u'Burger', u'B\xfcrger'), (u'Burgerrechtlerin', u'B\xfcrgerrechtlerin'), (u'Buro', u'B\xfcro'), (u'BURO', u'B\xdcRO'), (u'Burol', u'B\xfcro!'), (u'Burottlr', u'B\xfcrot\xfcr'), (u'Busche', u'B\xfcsche'), (u'B\xe9ickchen', u'B\xe4ckchen'), (u'B\xe9ickerei', u'B\xe4ckerei'), (u'B\xe9ille', u'B\xe4lle'), (u'B\xe9inder', u'B\xe4nder'), (u'B\xe9ir', u'B\xe4r'), (u'B\xe9irgermeister', u'B\xfcrgermeister'), (u'B\xe9iro', u'B\xfcro'), (u'b\xe9ise', u'b\xf6se'), (u'B\xe9iume', u'B\xe4ume'), (u'B\xe9nder', u'B\xe4nder'), (u'B\xe9r', u'B\xe4r'), (u'B\xe9ren', u'B\xe4ren'), (u'B\xe9renhasser', u'B\xe4renhasser'), (u'B\xe9renhunger', u'B\xe4renhunger'), (u'B\xe9renj\xe9ger', u'B\xe4renj\xe4ger'), (u'B\xe9renk\xe9nig', u'B\xe4renk\xf6nig'), (u'B\xe9renlaute', u'B\xe4renlaute'), (u'B\xe9renrolle', u'B\xe4renrolle'), (u'B\xe9renschnitzereien', u'B\xe4renschnitzereien'), (u'B\xe9renstimmen', u'B\xe4renstimmen'), (u'B\xe9rin', u'B\xe4rin'), (u'B\xe9risch', u'B\xe4risch'), (u'B\xe9rs', u'B\xe4rs'), (u'B\xe9rte', u'B\xe4rte'), (u'b\xe9s', u'b\xf6s'), (u'b\xe9se', u'b\xf6se'), (u'b\xe9sen', u'b\xf6sen'), (u'B\xe9ses', u'B\xf6ses'), (u'B\xe9ume', u'B\xe4ume'), (u'B\xe9umen', u'B\xe4umen'), (u'B\ufb02chern', u'B\xfcchern'), (u'B\ufb02ste', u'B\xfcste'), (u'Cafe', u'Caf\xe9'), (u'Caf\xe4', u'Caf\xe9'), (u'CASAREN', u'C\xc4SAREN'), (u'Charakterm\xe9ngel', u'Charakterm\xe4ngel'), (u'Charakterst\xe9rke', u'Charakterst\xe4rke'), (u'Chrlntlna', u'Christina'), (u'Ciden', u'\xf6den'), (u'Ciffnet', u'\xd6ffnet'), (u'Cihrchen', u'\xd6hrchen'), (u'Citro\xe9n', u'Citro\xebn'), (u'clamit', u'damit'), (u'class', u'dass'), (u'Clbernimmt', u'\xfcbernimmt'), (u'cler', u'der'), (u'Coimbrasl', u'Coimbras!'), (u'CommanderWill', u'Commander Will'), (u'Corenillal', u'Corenilla!'), (u'Cowboyscheifi', u'Cowboyschei\xdf'), (u'C\xe9sar', u'C\xe4sar'), (u'D/e', u'Die'), (u'd/ese', u'diese'), (u'd/esem', u'diesem'), (u'd/esen', u'diesen'), (u'D/eser', u'Dieser'), (u'D/eses', u'Dieses'), (u'D/sko', u'Disko'), (u'dabel', u'dabei'), (u'dachfen', u'dachten'), (u'daffir', u'daf\xfcr'), (u'dafiir', u'daf\xfcr'), (u'Dafijr', u'Daf\xfcr'), (u'Dafijur', u'Daf\xfcr'), (u'Dafilr', u'Daf\xfcr'), (u"dafL'lr", u'daf\xfcr'), (u'dafLir', u'daf\xfcr'), (u'dafljr', u'daf\xfcr'), (u'dafllir', u'daf\xfcr'), (u'Daflllrwar', u'Daf\xfcr war'), (u'daftir', u'daf\xfcr'), (u'dafUr', u'daf\xfcr'), (u'dafzjir', u'daf\xfcr'), (u'dajemand', u'da jemand'), (u'dal', u'da!'), (u'Damenh\xe9nde', u'Damenh\xe4nde'), (u'damitl', u'damit!'), (u'damlt', u'damit'), (u'DANEMARK', u'D\xc4NEMARK'), (u'darfiber', u'dar\xfcber'), (u'Dariiber', u'Dar\xfcber'), (u'darijber', u'dar\xfcber'), (u'Darilber', u'Dar\xfcber'), (u"dart/'ber", u'dar\xfcber'), (u'dartlber', u'dar\xfcber'), (u'DARUBER', u'DAR\xdcBER'), (u'DarUber', u'Dar\xfcber'), (u'dasjetzt', u'das jetzt'), (u'dasl', u'das!'), (u'Dateniibermittlung', u'Daten\xfcbermittlung'), (u'dauem', u'dauern'), (u'dauerf', u'dauert'), (u'dazugeh\xe9ren', u'dazugeh\xf6ren'), (u'Da\xdf', u'Dass'), (u'Da\ufb02lr', u'Daf\xfcr'), (u'Ddrfern', u'D\xf6rfern'), (u'def', u'der'), (u'Defekf/v', u'Detektiv'), (u'deinerZelle', u'deiner Zelle'), (u'deln', u'dein'), (u'delne', u'deine'), (u'demfiltigen', u'dem\xfctigen'), (u'Demijtigung', u'Dem\xfctigung'), (u'demllitige', u'dem\xfctige'), (u'demllitigen', u'dem\xfctigen'), (u'denkwurdiger', u'denkw\xfcrdiger'), (u'denkw\ufb02rdiger', u'denkw\xfcrdiger'), (u'derAbgeordnete', u'der Abgeordnete'), (u'derAusgabe', u'der Ausgabe'), (u'derAusl6ser', u'der Ausl\xf6ser'), (u"DerjL'lngste", u'Der j\xfcngste'), (u'derjunge', u'der junge'), (u'dermaben', u'derma\xdfen'), (u'derTyp', u'der Typ'), (u'derWeg', u'der Weg'), (u'derWelle', u'der Welle'), (u'DerWL1rfel', u'Der W\xfcrfel'), (u'DerZauberer', u'Der Zauberer'), (u'de__n', u'den'), (u'dfeserr', u'diesem'), (u'dffentlichen', u'\xf6ffentlichen'), (u'dffnen', u'\xf6ffnen'), (u'Dfimonen', u'D\xe4monen'), (u'dfinn', u'd\xfcnn'), (u'dichl', u'dich!'), (u'diej\xfcngste', u'die J\xfcngste'), (u'dienstunfahig', u'dienstunf\xe4hig'), (u'Dieselkapit\xe9in', u'Dieselkapit\xe4n'), (u'Dieselkapit\xe9n', u'Dieselkapit\xe4n'), (u'Dieselmotorenl', u'Dieselmotoren!'), (u'dieserAufnahme', u'dieser Aufnahme'), (u'Dieserjunge', u'Dieser junge'), (u'Diiit', u'Di\xe4t'), (u'diirfe', u'd\xfcrfe'), (u'Diirfen', u'D\xfcrfen'), (u'diirft', u'd\xfcrft'), (u'diirfte', u'd\xfcrfte'), (u'dijfien', u'd\xfcrfen'), (u'dijnn', u'd\xfcnn'), (u'dijrfen', u'd\xfcrfen'), (u'Dijrfte', u'D\xfcrfte'), (u'dijstere', u'd\xfcstere'), (u'dilmmer', u'd\xfcmmer'), (u'dilrfen', u'd\xfcrfen'), (u'dilrft', u'd\xfcrft'), (u'dilrften', u'd\xfcrften'), (u'dilrftig', u'd\xfcrftig'), (u'Dine', u'D\xe4ne'), (u'dirja', u'dir ja'), (u'dirjemand', u'dir jemand'), (u'dirjetzt', u'dir jetzt'), (u'dirJulie', u'dir Julie'), (u'dirl', u'dir!'), (u'dirwehzutun', u'dir wehzutun'), (u'Di\xe9t', u'Di\xe4t'), (u'Di\xe9tberaterin', u'Di\xe4tberaterin'), (u'Di\xe9tbier', u'Di\xe4tbier'), (u'dlch', u'dich'), (u'Dle', u'Die'), (u'dles', u'dies'), (u'Dlese', u'Diese'), (u'Dlfit', u'Di\xe4t'), (u'Dlitplan', u'Di\xe4tplan'), (u'dllirfen', u'd\xfcrfen'), (u'dllirft', u'd\xfcrft'), (u'dllirstet', u'd\xfcrstet'), (u'dlr', u'dir'), (u'doc/1', u'doch'), (u'dochl', u'doch!'), (u'dolthin', u'dorthin'), (u'Doppelgfiner', u'Doppelg\xe4nger'), (u'Doppelgfinger', u'Doppelg\xe4nger'), (u'Doppelg\xe9inger', u'Doppelg\xe4nger'), (u'Doppelg\xe9nger', u'Doppelg\xe4nger'), (u'Doppelzijngig', u'Doppelz\xfcngig'), (u'doppelztmgiger', u'doppelz\xfcngiger'), (u'dor', u'der'), (u"Dr'a'ngt", u'Dr\xe4ngt'), (u'drachengriinen', u'drachengr\xfcnen'), (u'Drahte', u'Dr\xe4hte'), (u'dranl', u'dran!'), (u'drau/3en', u'drau\xdfen'), (u'drau/Sen', u'drau\xdfen'), (u'drauBen', u'drau\xdfen'), (u'drauf$en', u'drau\xdfen'), (u'draufdrilcken', u'draufdr\xfccken'), (u'draufgestllirzt', u'draufgest\xfcrzt'), (u'draufg\xe9ngerisch', u'draufg\xe4ngerisch'), (u'draufien', u'drau\xdfen'), (u'draufken', u'drau\xdfen'), (u'drauflsenl', u'drau\xdfen!'), (u'drauf\xe9en', u'drau\xdfen'), (u'drauilen', u'drau\xdfen'), (u'draul3en', u'drau\xdfen'), (u'draul5en', u'drau\xdfen'), (u'draulien', u'drau\xdfen'), (u'draullen', u'drau\xdfen'), (u'draulSen', u'drau\xdfen'), (u'Dreckl\xe9chern', u'Dreckl\xf6chern'), (u'Drecksmiihle', u'Drecksm\xfchle'), (u'Drecks\xe9cke', u'Drecks\xe4cke'), (u'drfiben', u'dr\xfcben'), (u'Drfick', u'Dr\xfcck'), (u'Drfingeln', u'Dr\xe4ngeln'), (u'drih', u'dritt'), (u'driiben', u'dr\xfcben'), (u'driicken', u'dr\xfccken'), (u'driickt', u'dr\xfcckt'), (u'drijben', u'dr\xfcben'), (u'drijber', u'dr\xfcber'), (u'drijck', u'dr\xfcck'), (u'drijckt', u'dr\xfcckt'), (u'drilben', u'dr\xfcben'), (u'drilber', u'dr\xfcber'), (u'drilcken', u'dr\xfccken'), (u'drLiber', u'dr\xfcber'), (u'drlliben', u'dr\xfcben'), (u'drlllben', u'dr\xfcben'), (u'Drogenabh\xe9ngige', u'Drogenabh\xe4ngige'), (u'Drticken', u'Dr\xfccken'), (u'druben', u'dr\xfcben'), (u'drubenl', u'dr\xfcben!'), (u'druber', u'dr\xfcber'), (u'Druckkn\xe9pfe', u'Druckkn\xf6pfe'), (u'drunterliegt', u'drunter liegt'), (u'Dr\xe9nage', u'Dr\xe4nage'), (u'dr\xe9ngeln', u'dr\xe4ngeln'), (u'dr\xe9ngen', u'dr\xe4ngen'), (u'dr\xe9ngt', u'dr\xe4ngt'), (u'dr\ufb02ben', u'dr\xfcben'), (u'dtirft', u'd\xfcrft'), (u'dtlrfen', u'd\xfcrfen'), (u'Dudels\xe9cken', u'Dudels\xe4cken'), (u"dUFf\u20acl'1", u'd\xfcrfen'), (u'dul', u'du!'), (u'dull', u'dass'), (u'Dummk6pfe', u'Dummk\xf6pfe'), (u'Dummkiipfe', u'Dummk\xf6pfe'), (u'Dunnschiss', u'D\xfcnnschiss'), (u'durchdrficken', u'durchdr\xfccken'), (u'durchdr\xe9ngen', u'durchdr\xe4ngen'), (u'Durchfiihrung', u'Durchf\xfchrung'), (u'durchfuhren', u'durchf\xfchren'), (u'durchgefiihlt', u'durchgef\xfchrt'), (u'durchgefijhrt', u'durchgef\xfchrt'), (u'durchgefuhrt', u'durchgef\xfchrt'), (u'durchgef\ufb02hrt', u'durchgef\xfchrt'), (u'Durchg\xe9nge', u'Durchg\xe4nge'), (u'Durchladenl', u'Durchladen!'), (u'durchlfichere', u'durchl\xf6chere'), (u'durchsetzungsf\xe9higer', u'durchsetzungsf\xe4higer'), (u'durchst\xe9bern', u'durchst\xf6bern'), (u'durchwilhlt', u'durchw\xfchlt'), (u'durchzufilhren', u'durchzuf\xfchren'), (u'durchzufuhren', u'durchzuf\xfchren'), (u'Durfen', u'D\xfcrfen'), (u'durft', u'd\xfcrft'), (u'dusterer', u'd\xfcsterer'), (u'D\xe9cher', u'D\xe4cher'), (u'D\xe9imon', u'D\xe4mon'), (u'D\xe9imonen', u'D\xe4monen'), (u'D\xe9inemark', u'D\xe4nemark'), (u'D\xe9inemarks', u'D\xe4nemarks'), (u'D\xe9inen', u'D\xe4nen'), (u'd\xe9inisches', u'd\xe4nisches'), (u'd\xe9mlich', u'd\xe4mlich'), (u'D\xe9mliche', u'D\xe4mliche'), (u'd\xe9mlichen', u'd\xe4mlichen'), (u'd\xe9mlicher', u'd\xe4mlicher'), (u'd\xe9mlichl', u'd\xe4mlich'), (u'd\xe9mmert', u'd\xe4mmert'), (u'D\xe9monenb\xe9ren', u'D\xe4monenb\xe4ren'), (u'd\xe9monischen', u'd\xe4monischen'), (u'D\xe9rme', u'D\xe4rme'), (u'D\xe9rrfleisch', u'D\xf6rrfleisch'), (u'D\xe9umchen', u'D\xe4umchen'), (u'd\ufb02rfen', u'd\xfcrfen'), (u'E//e', u'Elle'), (u'e/n', u'ein'), (u'e/ne', u'eine'), (u'e/nem', u'einem'), (u'e/nen', u'einen'), (u'e/ner', u'einer'), (u'e/nes', u'eines'), (u'e/ns', u'eins'), (u'e/nsf', u'einst'), (u'E9YPt', u'Egypt'), (u'Ea/vtes', u'Echtes'), (u'ebenbfirtig', u'ebenb\xfcrtig'), (u'ebenburtige', u'ebenb\xfcrtige'), (u'Ec/vte', u'Echte'), (u'echfen', u'echten'), (u'edelm\ufb02tig', u'edelm\xfctig'), (u'efn', u'ein'), (u'efwas', u'etwas'), (u'Eheminner', u'Ehem\xe4nner'), (u'Ehem\xe9nnern', u'Ehem\xe4nnern'), (u'Ehezerstfirerin', u'Ehezerst\xf6rerin'), (u'Ehrenbijrger', u'Ehrenb\xfcrger'), (u'EHRENBURGERSCHAFT', u'EHRENB\xdcRGERSCHAFT'), (u'Ehreng\xe9iste', u'Ehreng\xe4ste'), (u'Eichhfirnchen', u'Eichh\xf6rnchen'), (u'Eichhiirnchen', u'Eichh\xf6rnchen'), (u'Eichh\xe9rnchens', u'Eichh\xf6rnchens'), (u'eifersfichtig', u'eifers\xfcchtig'), (u'eifersiichtig', u'eifers\xfcchtig'), (u'eifers\ufb02chtig', u'eifers\xfcchtig'), (u'eigenh\xe9ndig', u'eigenh\xe4ndig'), (u'eigenmlchtig', u'eigenm\xe4chtig'), (u'eigenntltziges', u'eigenn\xfctziges'), (u'Eihnlich', u'\xe4hnlich'), (u'Eimen/veise', u'Eimerweise'), (u'Einbruche', u'Einbr\xfcche'), (u'eindriicken', u'eindr\xfccken'), (u'Eindring/Inge', u'Eindringlinge'), (u'eindrucken', u'eindr\xfccken'), (u'einejunge', u'eine junge'), (u'einerfr\ufb02hen', u'einer fr\xfchen'), (u'einervorfuhrung', u'einer Vorf\xfchrung'), (u'einfiihren', u'einf\xfchren'), (u'Einfiihrung', u'Einf\xfchrung'), (u'einfilgen', u'einf\xfcgen'), (u'einfilhlsamsten', u'einf\xfchlsamsten'), (u'einflllgen', u'einf\xfcgen'), (u'Einflusse', u'Einfl\xfcsse'), (u'einfugen', u'einf\xfcgen'), (u'einfuhrten', u'einf\xfchrten'), (u'Einfuhrung', u'Einf\xfchrung'), (u'Einf\xe9ltige', u'Einf\xe4ltige'), (u'eingefiigt', u'eingef\xfcgt'), (u'eingef\ufb02gt', u'eingef\xfcgt'), (u'eingehiillt', u'eingeh\xfcllt'), (u'eingepr\xe9gt', u'eingepr\xe4gt'), (u'einger\xe9iumt', u'einger\xe4umt'), (u'einger\xe9umt', u'einger\xe4umt'), (u'eingeschl\xe9fert', u'eingeschl\xe4fert'), (u'eingeschr\xe9nkt', u'eingeschr\xe4nkt'), (u'eingesch\xe9itzt', u'eingesch\xe4tzt'), (u'eingesch\xe9tzt', u'eingesch\xe4tzt'), (u'eingesturzt', u'eingest\xfcrzt'), (u'eingieBt', u'eingie\xdft'), (u'eingschaltet', u'eingeschaltet'), (u'Einh\xe9rnern', u'Einh\xf6rner'), (u'einlegenl', u'einlegen!'), (u'einl\xe9dt', u'einl\xe4dt'), (u'einl\xe9sen', u'einl\xf6sen'), (u'Einsatzfahigkeit', u'Einsatzf\xe4higkeit'), (u'Einschiichterung', u'Einsch\xfcchterung'), (u'Einschliefklich', u'Einschlie\xdflich'), (u'Einschlielilich', u'Einschlie\xdflich'), (u'einstellenl', u'einstellen!'), (u'Eins\xe9tze', u'Eins\xe4tze'), (u'eint\xe9nig', u'eint\xf6nig'), (u'Einzelg\xe9ngerin', u'Einzelg\xe4ngerin'), (u'einzusch\xe9tzen', u'einzusch\xe4tzen'), (u'Eisstiirme', u'Eisst\xfcrme'), (u'Elektrizit\xe9t', u'Elektrizit\xe4t'), (u'elfenbeingetfinte', u'elfenbeinget\xf6nte'), (u'elit\xe9rer', u'elit\xe4rer'), (u'Eln', u'Ein'), (u'Elne', u'Eine'), (u'elnem', u'einem'), (u'Elnen', u'Einen'), (u'elner', u'einer'), (u'Elnes', u'Eines'), (u'empfindungsf\xe9higen', u'empfindungsf\xe4higen'), (u'Empf\xe9inger', u'Empf\xe4nger'), (u'empf\xe9ngt', u'empf\xe4ngt'), (u'Empiirend', u'Emp\xf6rend'), (u'Empiirendste', u'Emp\xf6rendste'), (u'empiirt', u'emp\xf6rt'), (u'emst', u'ernst'), (u'en/varten', u'erwarten'), (u'En/vartungen', u'Erwartungen'), (u'en/v\xe9hnt', u'erw\xe4hnt'), (u'Enchant\xe4', u'Enchant\xe9'), (u'endgiiltig', u'endg\xfcltig'), (u'endgultig', u'endg\xfcltig'), (u'endgultigen', u'endg\xfcltigen'), (u'endg\ufb02ltig', u'endg\xfcltig'), (u'endlichl', u'endlich!'), (u'ENERIGE', u'ENERGIE'), (u'enfternt', u'entfernt'), (u'Engl\xe9nder', u'Engl\xe4nder'), (u'Engl\xe9nderin', u'Engl\xe4nderin'), (u'eniillen', u'erf\xfcllen'), (u'entbl6Bte', u'entbl\xf6\xdfte'), (u'entbl6f$en', u'entbl\xf6\xdfen'), (u'entfiihre', u'entf\xfchre'), (u'entfiihrt', u'entf\xfchrt'), (u'entfiihrte', u'entf\xfchrte'), (u'Entfiihrung', u'Entf\xfchrung'), (u'Entftihrung', u'Entf\xfchrung'), (u'ENTFUHRUNGSVERDACHTIGER', u'ENTF\xdcHRUNGSVERD\xc4CHTIGER'), (u'enthllt', u'enth\xe4lt'), (u'enthUllt', u'enth\xfcllt'), (u'enth\xe9lt', u'enth\xe4lt'), (u'entliiften', u'entl\xfcften'), (u'Entliiftungen', u'Entl\xfcftungen'), (u'Entlijlftungen', u'Entl\xfcftungen'), (u'entluften', u'entl\xfcften'), (u'entl\xe9sst', u'entl\xe4sst'), (u'Entreilit', u'Entrei\xdft'), (u'entriistet', u'entr\xfcstet'), (u'entr\xe9itseln', u'entr\xe4tseln'), (u'Entschlrfen', u'Entsch\xe4rfen'), (u'Entschlull', u'Entschluss'), (u'ENTSCHLUSSELN', u'ENTSCHL\xdcSSELN'), (u'Entschlussen', u'Entschl\xfcssen'), (u'entsch\xe9rfen', u'entsch\xe4rfen'), (u'enttausche', u'entt\xe4usche'), (u'enttiiuscht', u'entt\xe4uscht'), (u'Enttluscht', u'Entt\xe4uscht'), (u'Enttluschungen', u'Entt\xe4uschungen'), (u'entt\xe9iuschen', u'entt\xe4uschen'), (u'entt\xe9uschen', u'entt\xe4uschen'), (u'entt\xe9uschst', u'entt\xe4uschst'), (u'entt\xe9uscht', u'entt\xe4uscht'), (u'Entv\\/Urfe', u'Entw\xfcrfe'), (u'Entwicklungsl\xe9ndern', u'Entwicklungsl\xe4ndern'), (u'entzllickt', u'entz\xfcckt'), (u'entzllindet', u'entz\xfcndet'), (u'entzuckend', u'entz\xfcckend'), (u'entzundet', u'entz\xfcndet'), (u'enzv\xe9rmt', u'erw\xe4rmt'), (u'Er6ffnen', u'Er\xf6ffnen'), (u'erb\xe9rml/ch', u'erb\xe4rmlich'), (u'erb\xe9rmlich', u'erb\xe4rmlich'), (u'Erb\xe9rmliches', u'Erb\xe4rmliches'), (u'Erdnijsse', u'Erdn\xfcsse'), (u'erdriickt', u'erdr\xfcckt'), (u'erd\xe9ihnliche', u'erd\xe4hnliche'), (u'erfebst', u'erlebst'), (u'erffillen', u'erf\xfcllen'), (u'erfiffnet', u'er\xf6ffnet'), (u'erfiille', u'erf\xfclle'), (u'erfiillen', u'erf\xfcllen'), (u'erfiillt', u'erf\xfcllt'), (u'erfijllt', u'erf\xfcllt'), (u'erfillle', u'erf\xfclle'), (u'erfilllen', u'erf\xfcllen'), (u'erfilllt', u'erf\xfcllt'), (u'erfllille', u'erf\xfclle'), (u'erfllillt', u'erf\xfcllt'), (u'erflllllen', u'erf\xfcllen'), (u'Erfolgl', u'Erfolg!'), (u'erfullen', u'erf\xfcllen'), (u'erfullt', u'erf\xfcllt'), (u'erf\xe9hrst', u'erf\xe4hrst'), (u'erf\xe9hrt', u'erf\xe4hrt'), (u'erf\ufb02llen', u'erf\xfcllen'), (u'ergrllindet', u'ergr\xfcndet'), (u'erhalfen', u'erhalten'), (u'Erhdhe', u'Erh\xf6he'), (u'erhiihter', u'erh\xf6hter'), (u'erhiiren', u'erh\xf6ren'), (u'ERHKLT', u'ERH\xc4LT'), (u'erhllt', u'erh\xe4lt'), (u'erh\xe9hen', u'erh\xf6hen'), (u'erh\xe9ht', u'erh\xf6ht'), (u'erh\xe9ilt', u'erh\xe4llt'), (u'erh\xe9lt', u'erh\xe4lt'), (u'erh\xe9rt', u'erh\xf6rt'), (u'erh\xe9rte', u'erh\xf6rte'), (u'eriiffnet', u'er\xf6ffnet'), (u'erja', u'er ja'), (u'erjetzt', u'er jetzt'), (u'erjung', u'er jung'), (u"erkl'a'ren", u'erkl\xe4ren'), (u"erkl'air's", u"erkl\xe4r's"), (u'erklaren', u'erkl\xe4ren'), (u'erklfire', u'erkl\xe4re'), (u'Erklfirung', u'Erkl\xe4rung'), (u'erklirt', u'erkl\xe4rt'), (u'erkllre', u'erkl\xe4re'), (u'erkllrt', u'erkl\xe4rt'), (u'erkllrte', u'erkl\xe4rte'), (u'erkllrten', u'erkl\xe4rten'), (u'Erkllrung', u'Erkl\xe4rung'), (u'erkl\xe9ir', u'erkl\xe4r'), (u'erkl\xe9ire', u'erkl\xe4re'), (u'erkl\xe9iren', u'erkl\xe4ren'), (u'erkl\xe9r', u'erkl\xe4r'), (u"erkl\xe9r's", u"erkl\xe4r's"), (u'erkl\xe9rbar', u'erkl\xe4rbar'), (u'Erkl\xe9re', u'Erkl\xe4re'), (u'erkl\xe9ren', u'erkl\xe4ren'), (u'erkl\xe9rt', u'erkl\xe4rt'), (u'Erkl\xe9rung', u'Erkl\xe4rung'), (u'erk\xe9ltest', u'erkaltest'), (u"erlC'>st", u'erl\xf6st'), (u'erldse', u'erl\xf6se'), (u'Erled/gen', u'Erledigen'), (u'erlieB', u'erlie\xdf'), (u'erlnnem', u'erinnern'), (u'erl\xe9scht', u'erl\xf6scht'), (u'erl\xe9sen', u'erl\xf6sen'), (u'erl\xe9st', u'erl\xf6st'), (u'Erl\xe9sung', u'Erl\xf6sung'), (u'ermbglichen', u'erm\xf6glichen'), (u'Erm\xe9chtige', u'Erm\xe4chtige'), (u'erm\xe9glicht', u'erm\xf6glicht'), (u'erm\xe9glichte', u'erm\xf6glichte'), (u'ernlllchtert', u'ern\xfcchtert'), (u'ern\xe9hren', u'ern\xe4hren'), (u'Ern\xe9hrung', u'Ern\xe4hrung'), (u'eroffnet', u'er\xf6ffnet'), (u'Erpressungsscheilie', u'Erpressungsschei\xdfe'), (u'err\xe9tst', u'err\xe4tst'), (u'erschieB', u'erschie\xdf'), (u'erschieBen', u'erschie\xdfen'), (u'erschiefien', u'erschie\xdfen'), (u'erschiefit', u'erschie\xdft'), (u'erschiefke', u'erschie\xdfe'), (u'erschielie', u'erschie\xdfe'), (u'Erschielit', u'Erschie\xdft'), (u'erschiipft', u'ersch\xf6pft'), (u'erschiittert', u'ersch\xfcttert'), (u'erschilttert', u'ersch\xfcttert'), (u'erschl\xe9gt', u'erschl\xe4gt'), (u'ERTCHDNT', u'ERT\xd6NT'), (u'ERTCNT', u'ERT\xd6NT'), (u'ERTGNT', u'ERT\xd6NT'), (u'ertiffnen', u'er\xf6ffnen'), (u'ertr\xe9gst', u'ertr\xe4gst'), (u'ertr\xe9inken', u'ertr\xe4nken'), (u'ert\xe9nt', u'ert\xf6nt'), (u'ervvartez', u'erwartet'), (u'ervvilrgen', u'erw\xfcrgen'), (u'ervv\xe9hnen', u'erw\xe4hnen'), (u'ervv\xe9ihnen', u'erw\xe4hnen'), (u'ervv\xe9ihnt', u'erw\xe4hnt'), (u'ervv\xe9ihnte', u'erw\xe4hnte'), (u'Erv\\/an', u'Erwan'), (u"Erv\\/an's", u"Erwan's"), (u"erw'a'hnt", u'erw\xe4hnt'), (u'Erwar', u'Er war'), (u'erwe/sen', u'erweisen'), (u'Erwfirmung', u'Erw\xe4rmung'), (u'Erwird', u'Er wird'), (u'Erwtirde', u'Er w\xfcrde'), (u'erw\xe9gt', u'erw\xe4gt'), (u'Erw\xe9gung', u'Erw\xe4gung'), (u'Erw\xe9hne', u'Erw\xe4hne'), (u'erw\xe9hnen', u'erw\xe4hnen'), (u'erw\xe9hnt', u'erw\xe4hnt'), (u'erw\xe9hnte', u'erw\xe4hnte'), (u'Erw\xe9hnung', u'Erw\xe4hnung'), (u'erw\xe9ihlt', u'erw\xe4hlt'), (u'erw\xe9ihnt', u'erw\xe4hnt'), (u'erw\xe9rmt', u'erw\xe4rmt'), (u"erz'a'hlt", u'erz\xe4hlt'), (u'Erzdiiizese', u'Erzdi\xf6zese'), (u'erzfihlen', u'erz\xe4hlen'), (u'Erzfihler', u'Erz\xe4hler'), (u'erzihlenl', u'erz\xe4hlen!'), (u'erziihlen', u'erz\xe4hlen'), (u'erziihlt', u'erz\xe4hlt'), (u'erziirnt', u'erz\xfcrnt'), (u'erzilrnt', u'erz\xfcrnt'), (u'erzllirnt', u'erz\xfcrnt'), (u'erzurnen', u'erz\xfcrnen'), (u'erz\xe9hl', u'erz\xe4hl'), (u'erz\xe9hle', u'erz\xe4hle'), (u'Erz\xe9hlen', u'Erz\xe4hlen'), (u'erz\xe9hlerische', u'erz\xe4hlerische'), (u'erz\xe9hlerischen', u'erz\xe4hlerischen'), (u'erz\xe9hlerischer', u'erz\xe4hlerischer'), (u'Erz\xe9hlkunste', u'Erz\xe4hlk\xfcnste'), (u'erz\xe9hlst', u'erz\xe4hlst'), (u'erz\xe9hlt', u'erz\xe4hlt'), (u'erz\xe9hlte', u'erz\xe4hlte'), (u'Erz\xe9hlung', u'Erz\xe4hlung'), (u'Erz\xe9ihl', u'Erz\xe4hl'), (u'Erz\xe9ihle', u'Erz\xe4hle'), (u'erz\xe9ihlen', u'erz\xe4hlen'), (u'erz\xe9ihlst', u'erz\xe4hlst'), (u'erz\xe9ihlt', u'erz\xe4hlt'), (u'erz\xe9ihlte', u'erz\xe4hlte'), (u'er\xe9ffnen', u'er\xf6ffnen'), (u'er\xe9ffnet', u'er\xf6ffnet'), (u'er\xe9ffnete', u'er\xf6ffnete'), (u'Er\xe9ffnungsaufnahme', u'Er\xf6ffnungsaufnahme'), (u'Er\xe9ffnungssequenz', u'Er\xf6ffnungssequenz'), (u'Er\xe9ffnungsszene', u'Er\xf6ffnungsszene'), (u'Er\ufb02lllen', u'Erf\xfcllen'), (u'etemity', u'eternity'), (u'etvva', u'etwa'), (u'euc/1', u'euch'), (u'Europ\xe9er', u'Europ\xe4er'), (u'europ\xe9ische', u'europ\xe4ische'), (u"ex'nfac'/7", u'einfach'), (u'Examenspriifungen', u'Examenspr\xfcfungen'), (u'Exekutivzust\xe9noligkeit', u'Exekutivzust\xe4ndigkeit'), (u'Explosionenl', u'Explosionen!'), (u'Extrablattl', u'Extrablatt!'), (u'F/nden', u'Finden'), (u'F/ugba/I', u'Flugball'), (u'Fahnrich', u'F\xe4hnrich'), (u'fahrlissiges', u'fahrl\xe4ssiges'), (u'Fairbankverlieh', u'Fairbank verlieh'), (u'Fallef', u'Falle!'), (u'fallengelassen', u'fallen gelassen'), (u'Fallschirmj\xe9gereinheiten', u'Fallschirmj\xe4gereinheiten'), (u'Fam/Z/e', u'Familie'), (u'Fa\xdf', u'Fass'), (u'FBl', u'FBI'), (u'Fe/nd', u'Feind'), (u'fehlschl\xe9gt', u'fehlschl\xe4gt'), (u'Feindberllihrung', u'Feindber\xfchrung'), (u'Feind\xfcbewvachung', u'Feind\xfcberwachung'), (u'feltig', u'fertig'), (u'femen', u'fernen'), (u'fernh\xe9ilt', u'fernh\xe4lt'), (u'Festhaltenl', u'Festhalten!'), (u'Fettw\xe9nste', u'Fettw\xe4nste'), (u'Feuen/vehr', u'Feuerwehr'), (u'Feuerliischer', u'Feuerl\xf6scher'), (u'Feuervvehrrnann', u'Feuerwehrrnann'), (u'Feuerwehrl', u'Feuerwehr!'), (u'Feuerwfirmen', u'Feuer w\xe4rmen'), (u'Feue\ufb02', u'Feuer!'), (u"ff'Ul'1\u20acf'\u20acl'1", u'fr\xfcheren'), (u'Ffiegen', u'Fliegen'), (u'ffihft', u'f\xfchlt'), (u'ffihren', u'f\xfchren'), (u'ffinf', u'f\xfcnf'), (u'ffir', u'f\xfcr'), (u'ffirchte', u'f\xfcrchte'), (u'ffirs', u'f\xfcrs'), (u'ffittere', u'f\xfcttere'), (u'FI6he', u'Fl\xf6he'), (u'Fiasenm\xe9iher', u'Rasenm\xe4her'), (u'fibel', u'\xfcbel'), (u'fiber', u'\xfcber'), (u'fiberdressierter', u'\xfcberdressierter'), (u'fibergezogen', u'\xfcbergezogen'), (u'fiberhaupt', u'\xfcberhaupt'), (u'fiberholt', u'\xfcberholt'), (u'fiberlegt', u'\xfcberlegt'), (u'fibernachtet', u'\xfcbernachtet'), (u'fiberspannt', u'\xfcberspannt'), (u'fibertreiben', u'\xfcbertreiben'), (u'fiberzfichtete', u'\xfcberz\xfcchtete'), (u'fibrig', u'\xfcbrig'), (u'Fieferenz', u'Referenz'), (u'Fieifi', u'Rei\xdf'), (u'fiffentlichkeit', u'\xd6ffentlichkeit'), (u'fiffnen', u'\xf6ffnen'), (u'fiffnest', u'\xf6ffnest'), (u'fifter', u'\xf6fter'), (u'Fihigkeit', u'F\xe4higkeit'), (u'fihneln', u'\xe4hneln'), (u'Fihrt', u'F\xe4hrt'), (u'fiihl', u'f\xfchl'), (u'fiihle', u'f\xfchle'), (u'fiihlen', u'f\xfchlen'), (u'fiihlst', u'f\xfchlst'), (u'fiihlt', u'f\xfchlt'), (u'Fiihlte', u'F\xfchlte'), (u'Fiihre', u'F\xfchre'), (u'Fiihren', u'F\xfchren'), (u'Fiihrerin', u'F\xfchrerin'), (u'Fiihrerschein', u'F\xfchrerschein'), (u'fiihrfe', u'f\xfchrte'), (u'fiihrt', u'f\xfchrt'), (u'fiihrte', u'f\xfchrte'), (u'Fiihrungsf\xe9ihigkeiten', u'F\xfchrungsf\xe4higkeiten'), (u'Fiihrungsprogramm', u'F\xfchrungsprogramm'), (u'Fiihrungsstil', u'F\xfchrungsstil'), (u'Fiilcksicht', u'R\xfccksicht'), (u'fiillen', u'f\xfcllen'), (u'fiinden', u'f\xe4nden'), (u'fiinf', u'f\xfcnf'), (u'fiinfhundert', u'f\xfcnfhundert'), (u'fiinfzehn', u'f\xfcnfzehn'), (u'fiir', u'f\xfcr'), (u'fiirchte', u'f\xfcrchte'), (u'fiirchten', u'f\xfcrchten'), (u'fiirchterlich', u'f\xfcrchterlich'), (u'fiirchterlichl', u'f\xfcrchterlich!'), (u'fiirchterllches', u'f\xfcrchterliches'), (u'fiirchtet', u'f\xfcrchtet'), (u'fiirchteten', u'f\xfcrchteten'), (u'fiirjeden', u'f\xfcr jeden'), (u'Fiirmchen', u'F\xf6rmchen'), (u'fiirs', u'f\xfcrs'), (u'Fijgen', u'F\xfcgen'), (u'fijhl', u'f\xfchl'), (u'fijhle', u'f\xfchle'), (u'fijhlen', u'f\xfchlen'), (u'fijhlst', u'f\xfchlst'), (u'fijhlt', u'f\xfchlt'), (u'fijhren', u'f\xfchren'), (u'Fijhrer', u'F\xfchrer'), (u'fijhrt', u'f\xfchrt'), (u'Fijhrungsqualit\xe9iten', u'F\xfchrungsqualit\xe4ten'), (u'FiJl3en', u'F\xfc\xdfen'), (u'Fijlie', u'F\xfc\xdfe'), (u'fijlr', u'f\xfcr'), (u'Fijnf', u'F\xfcnf'), (u'Fijnfziger', u'F\xfcnfziger'), (u'fijr', u'f\xfcr'), (u'fijrchte', u'f\xfcrchte'), (u'fijrchten', u'f\xfcrchten'), (u'Fijrjedenl', u'F\xfcr jeden!'), (u'fijrs', u'f\xfcrs'), (u'fiJrVorteile', u'f\xfcr Vorteile'), (u'fijttern', u'f\xfcttern'), (u'fijur', u'f\xfcr'), (u'filhl', u'f\xfchl'), (u'filhle', u'f\xfchle'), (u'filhlen', u'f\xfchlen'), (u'filhlte', u'f\xfchlte'), (u'filhre', u'f\xfchre'), (u'filhren', u'f\xfchren'), (u'Filhrern', u'F\xfchrern'), (u'Filhrerschein', u'F\xfchrerschein'), (u'filhrst', u'f\xfchrst'), (u'filhrt', u'f\xfchrt'), (u'filhrte', u'f\xfchrte'), (u'filhrten', u'f\xfchrten'), (u'Filhrung', u'F\xfchrung'), (u'Fillle', u'F\xfclle'), (u'Filll\xe9en', u'F\xfc\xdfen'), (u'Filmemachen', u'Filme machen'), (u'Filml', u'Film!'), (u'filnf', u'f\xfcnf'), (u'Filn\ufb02', u'F\xfcnf!'), (u'Filr', u'F\xfcr'), (u"filr'ne", u"f\xfcr'ne"), (u'filrchten', u'f\xfcrchten'), (u'filrchterlich', u'f\xfcrchterlich'), (u'filrs', u'f\xfcrs'), (u'filter', u'\xe4lter'), (u'findem', u'\xe4ndern'), (u'findenlassen', u'finden lassen'), (u'Fingerabdrijcke', u'Fingerabdr\xfccke'), (u'Fingerabdrilcke', u'Fingerabdr\xfccke'), (u'Fingerniigeln', u'Fingern\xe4geln'), (u'Fingern\xe9gel', u'Fingern\xe4gel'), (u'Fingern\xe9geln', u'Fingern\xe4geln'), (u'fingstlich', u'\xe4ngstlich'), (u'Fiothaarige', u'Rothaarige'), (u'Firmen\xe9rzte', u'Firmen\xe4rzte'), (u'Fischk\xe9pfe', u'Fischk\xf6pfe'), (u'FIUssigkeitsgleichgewicht', u'Fl\xfcssigkeitsgleichgewicht'), (u'Fiusten', u'F\xe4usten'), (u'FIynn', u'Flynn'), (u'fjffnen', u'\xf6ffnen'), (u"fL'1'r", u'f\xfcr'), (u"fL'1hle", u'f\xfchle'), (u"FL'1r", u'F\xfcr'), (u"fL'ir", u'f\xfcr'), (u"fL'lr", u'f\xfcr'), (u'fL1r', u'f\xfcr'), (u'Fl6he', u'Fl\xf6he'), (u'Flclse', u'Rose'), (u'fleifkige', u'flei\xdfige'), (u'fleifkiges', u'flei\xdfiges'), (u'fleil3ig', u'flei\xdfig'), (u'Fleischb\xe9llchen', u'Fleischb\xe4llchen'), (u"Fleischkl6l'Sen", u'Fleischkl\xf6\xdfen'), (u'Flfige', u'Fl\xfcge'), (u'Flfigell', u'Fl\xfcgel!'), (u'flfistert', u'fl\xfcstert'), (u'Flhigkeiten', u'F\xe4higkeiten'), (u'Flhnrich', u'F\xe4hnrich'), (u'Flhnriche', u'F\xe4hnriche'), (u'flieBen', u'flie\xdfen'), (u'Fliefiband', u'Flie\xdfband'), (u'Fliefiheck', u'Flie\xdfheck'), (u'Flieflsb\xe9nder', u'Flie\xdfb\xe4nder'), (u'flielit', u'flie\xdft'), (u'flielSt', u'flie\xdft'), (u'FLif$e', u'F\xfc\xdfe'), (u'fLihlt', u'f\xfchlt'), (u'fliichtige', u'fl\xfcchtige'), (u'Fliigel', u'Fl\xfcgel'), (u'flijchtig', u'fl\xfcchtig'), (u'Flijgel', u'Fl\xfcgel'), (u'Flijgelfedernl', u'Fl\xfcgelfedern!'), (u'Flilssige', u'Fl\xfcssige'), (u'flilstert', u'fl\xfcstert'), (u'fLir', u'f\xfcr'), (u'fljhrt', u'f\xfchrt'), (u'Fljr', u'F\xfcr'), (u"flJr'n", u"f\xfcr'n"), (u'fllihrst', u'f\xfchrst'), (u'Fllihrt', u'F\xfchrt'), (u'fllinf', u'f\xfcnf'), (u'fllinften', u'f\xfcnften'), (u'Fllinkchen', u'F\xfcnkchen'), (u'Fllir', u'F\xfcr'), (u'fllirchte', u'f\xfcrchte'), (u'fllirchten', u'f\xfcrchten'), (u'fllirchterlichen', u'f\xfcrchterlichen'), (u'fllirchtet', u'f\xfcrchtet'), (u'Fllirsten', u'F\xfcrsten'), (u'Fllitterungszeitenl', u'F\xfctterungszeiten!'), (u'flllgte', u'f\xfcgte'), (u'flllgten', u'f\xfcgten'), (u'flllhrten', u'fl\xfchrten'), (u'Flllhrung', u'F\xfchrung'), (u'Fllligel', u'Fl\xfcgel'), (u'flllistern', u'fl\xfcstern'), (u'fllllstert', u'fl\xfcstert'), (u'flllrchte', u'f\xfcrchte'), (u'flllrchten', u'f\xfcrchten'), (u'flllrjede', u'f\xfcr jede'), (u'Flohtransporterl', u'Flohtransporter!'), (u'Floli', u'Flo\xdf'), (u'Flottenalzt', u'Flottenarzt'), (u'Flottenstiitzpunkt', u'Flottenst\xfctzpunkt'), (u'Flottenstutzpunkt', u'Flottenst\xfctzpunkt'), (u'Flrma', u'Firma'), (u'fltlsterte', u'fl\xfcsterte'), (u'Fluchtig', u'Fl\xfcchtig'), (u'Flughdhe', u'Flugh\xf6he'), (u'Flughiihe', u'Flugh\xf6he'), (u'Flugh\xe9ifen', u'Flugh\xe4fen'), (u'Flugunf\xe9ihig', u'Flugunf\xe4hig'), (u'flugunf\xe9ihigen', u'flugunf\xe4higen'), (u'Flugunf\xe9ihigl', u'Flugunf\xe4hig!'), (u'Flugzeugl', u'Flugzeug!'), (u'FLUSSIGER', u'FL\xdcSSIGER'), (u'Flustereffekt', u'Fl\xfcstereffekt'), (u'Flustern', u'Fl\xfcstern'), (u'FLUSTERT', u'FL\xdcSTERT'), (u'fl\ufb02stern', u'fl\xfcstern'), (u'fl\ufb02sterten', u'fl\xfcsterten'), (u'Folgendesz', u'Folgendes:'), (u'fortgespiilt', u'fortgesp\xfclt'), (u'fortspiilen', u'fortsp\xfclen'), (u'fortw\xe9hrend', u'fortw\xe4hrend'), (u'Fr/ed/10/', u'Friedhof'), (u'Fr5ulein', u'Fr\xe4ulein'), (u'Fr6hliche', u'Fr\xf6hliche'), (u'Frachfmodule', u'Frachtmodule'), (u'Frafi', u'Fra\xdf'), (u'fragfe', u'fragte'), (u"Fral'S", u'Fra\xdf'), (u'fralken', u'fra\xdfen'), (u'Franzfisisch', u'Franz\xf6sisch'), (u'Franziisin', u'Franz\xf6sin'), (u'franziisische', u'franz\xf6sische'), (u'franziisischen', u'franz\xf6sischen'), (u'franziisischer', u'franz\xf6sischer'), (u'franziisisches', u'franz\xf6sisches'), (u'Franz\xe9sisch', u'Franz\xf6sisch'), (u'franz\xe9sische', u'franz\xf6sische'), (u'franz\xe9sischen', u'franz\xf6sischen'), (u'franz\xe9sischer', u'franz\xf6sischer'), (u'Franz\xe9sisches', u'Franz\xf6sisches'), (u'FRAULEIN', u'FR\xc4ULEIN'), (u'fre/em', u'freiem'), (u'freffen', u'treffen'), (u'freilieB', u'freilie\xdf'), (u'freimiitigen', u'freim\xfctigen'), (u'Fressger\xe9usche', u'Fressger\xe4usche'), (u'Frfichtekuchen', u'Fr\xfcchtekuchen'), (u'frfih', u'fr\xfch'), (u'frfiher', u'fr\xfcher'), (u'Friedh\xe9fe', u'Friedh\xf6fe'), (u'Friichtchen', u'Fr\xfcchtchen'), (u'friih', u'fr\xfch'), (u'friihen', u'fr\xfchen'), (u'friiher', u'fr\xfcher'), (u'friihere', u'fr\xfchere'), (u'friihliche', u'fr\xf6hliche'), (u'friihlichen', u'fr\xf6hlichen'), (u'Friihstiick', u'Fr\xfchst\xfcck'), (u'friilher', u'fr\xfcher'), (u'friilhesten', u'fr\xfchesten'), (u'Frijchte', u'Fr\xfcchte'), (u'frijh', u'fr\xfch'), (u'frijher', u'fr\xfcher'), (u'frijherer', u'fri\xfcherer'), (u'frilh', u'fr\xfch'), (u'frilhen', u'fr\xfchen'), (u'Frilher', u'Fr\xfcher'), (u'frilhere', u'fr\xfchere'), (u'Frilhst\ufb02ck', u'Fr\xfchst\xfcck'), (u'Fris6r', u'Fris\xf6r'), (u"frL'lher", u'fr\xfcher'), (u'Frljihling', u'Fr\xfchling'), (u'Frllichte', u'Fr\xfcchte'), (u'frllih', u'fr\xfch'), (u'frlliher', u'fr\xfcher'), (u'Frllihstiickskiiche', u'Fr\xfchst\xfccksk\xfcche'), (u'fro/1', u'froh'), (u'FROHLICHE', u'FR\xd6HLICHE'), (u'frtih', u'fr\xfch'), (u'Frtiher', u'Fr\xfcher'), (u'Frtihliche', u'Fr\xf6hliche'), (u'Frtihstticksei', u'Fr\xfchst\xfccksei'), (u'Frtlh', u'Fr\xfch'), (u'FrUh', u'Fr\xfch'), (u'FRUHE', u'FR\xdcHE'), (u'fruhe', u'fr\xfche'), (u'fruhen', u'fr\xfchen'), (u'Fruher', u'Fr\xfcher'), (u'fruheren', u'fr\xfcheren'), (u'Fruhling', u'Fr\xfchling'), (u'Fruhlingsrolle', u'Fr\xfchlingsrolle'), (u'FrUhstUck', u'Fr\xfchstuck'), (u'Fruhstuck', u'Fr\xfchst\xfcck'), (u'frUhstUcken', u'fr\xfchst\xfccken'), (u'fr\xe9hliches', u'fr\xf6hliches'), (u'fr\xe9ihfiches', u'fr\xf6hliches'), (u'fr\xe9ihlich', u'fr\xf6hlich'), (u'Fr\xe9iulein', u'Fr\xe4ulein'), (u'fr\xe9nen', u'fr\xf6nen'), (u'Fr\xe9sche', u'Fr\xf6sche'), (u'Fr\xe9ulein', u'Fr\xe4ulein'), (u'ftihlen', u'f\xfchlen'), (u'Ftillhorn', u'F\xfcllhorn'), (u'Ftir', u'F\xfcr'), (u'Ftirs', u'F\xfcrs'), (u'Ftlhrung', u'F\xfchrung'), (u'ftlrchte', u'f\xfcrchte'), (u'ftmf', u'f\xfcnf'), (u'Fu/3', u'Fu\xdf'), (u'FuB', u'Fu\xdf'), (u'FuBballspieler', u'Fu\xdfballspieler'), (u'FUBen', u'F\xfc\xdfen'), (u'Fuf$', u'Fu\xdf'), (u'Fufi', u'Fu\xdf'), (u'Fufiabdrucke', u'Fu\xdfabdr\xfccke'), (u'Fufiballtraining', u'Fu\xdfballtraining'), (u'FufL', u'Fu\xdf'), (u'Fuflsball', u'Fu\xdfball'), (u'Fuflsballszene', u'Fu\xdfballszene'), (u"fUhl't", u'f\xfchrt'), (u'fuhle', u'f\xfchle'), (u'fuhlst', u'f\xfchlst'), (u'fUhlt', u'f\xfchlt'), (u'fUhre', u'f\xfchre'), (u'fUhrt', u'f\xfchrt'), (u'fuhrte', u'f\xfchrte'), (u'fuhrten', u'f\xfchrten'), (u'Fuhrung', u'F\xfchrung'), (u'Fuhrungsf\xe9higkeiten', u'F\xfchrungsf\xe4higkeiten'), (u'Fuhrungsoffizier', u'F\xfchrungsoffizier'), (u'Fuhrungsqualit\xe9t', u'F\xfchrungsqualit\xe4t'), (u'FUI3en', u'F\xfc\xdfen'), (u'Fuli', u'Fu\xdf'), (u'Fuliball', u'Fu\xdfball'), (u'Fulisohlen', u'Fu\xdfsohlen'), (u'FUller', u'F\xfcller'), (u'fUllten', u'f\xfcllten'), (u'fumt', u'f\xfchlt'), (u'Fundbiiro', u'Fundb\xfcro'), (u'FUnf', u'F\xfcnf'), (u'Funftbeste', u'F\xfcnftbeste'), (u'Funkchen', u'F\xfcnkchen'), (u'Funkger\xe9it', u'Funkger\xe4t'), (u'Funkger\xe9ite', u'Funkger\xe4te'), (u'Funkger\xe9t', u'Funkger\xe4t'), (u'funktionstilchtig', u'funktionst\xfcchtig'), (u'FUR', u'F\xdcR'), (u'Fur', u'F\xfcr'), (u"fUrAusweichmanc'\xa7ver", u'f\xfcr Ausweichman\xf6ver'), (u'furchteinfl6Bend', u'furchteinfl\xf6\xdfend'), (u'furchteinfl6Bende', u'furchteinfl\xf6\xdfende'), (u'furchten', u'f\xfcrchten'), (u'Furchtest', u'F\xfcrchtest'), (u'furchtet', u'f\xfcrchtet'), (u'furchteten', u'f\xfcrchteten'), (u'fureinander', u'f\xfcreinander'), (u'furjeden', u'f\xfcr jeden'), (u'furjemanden', u'f\xfcr jemanden'), (u'furjudische', u'fur j\xfcdische'), (u'furs', u'f\xfcrs'), (u'FUrWalter', u'F\xfcr Walter'), (u'fut', u'tut'), (u'Fu\ufb02ballspiel', u'Fu\xdfballspiel'), (u'F\xa7hnlein', u'F\xe4hnlein'), (u'f\xe9//t', u'f\xe4llt'), (u'f\xe9hig', u'f\xe4hig'), (u'F\xe9higkeit', u'F\xe4higkeit'), (u'F\xe9higkeiten', u'F\xe4higkeiten'), (u'f\xe9hnen', u'f\xf6hnen'), (u'F\xe9hnens', u'F\xf6hnens'), (u'F\xe9hnerei', u'F\xf6hnerei'), (u'F\xe9hnleinmiitter', u'F\xe4hnleinm\xfctter'), (u'F\xe9hre', u'F\xe4hre'), (u'f\xe9hrst', u'f\xe4hrst'), (u'f\xe9hrt', u'f\xe4hrt'), (u'F\xe9ihigkeit', u'F\xe4higkeit'), (u'F\xe9ihigkeiten', u'F\xe4higkeiten'), (u'f\xe9ihrt', u'f\xe4hrt'), (u'f\xe9illst', u'f\xe4llst'), (u'f\xe9illt', u'f\xe4llt'), (u'F\xe9ilschung', u'F\xe4lschung'), (u'F\xe9ingt', u'F\xe4ngt'), (u'f\xe9ir', u'f\xfcr'), (u'F\xe9lle', u'F\xe4lle'), (u'F\xe9llen', u'F\xe4llen'), (u'f\xe9lligl', u'f\xe4llig'), (u'F\xe9llt', u'F\xe4llt'), (u"f\xe9llt's", u"f\xe4llt's"), (u'F\xe9lschen', u'F\xe4lschen'), (u'F\xe9lschung', u'F\xe4lschung'), (u'f\xe9nde', u'f\xe4nde'), (u'F\xe9ngst', u'F\xe4ngst'), (u'F\xe9ngt', u'F\xe4ngt'), (u'f\xe9rben', u'f\xe4rben'), (u'f\xe9rbt', u'f\xe4rbt'), (u'f\xe9rdern', u'f\xf6rdern'), (u'f\xe9rmlich', u'f\xf6rmlich'), (u'F\xe9ustlinge', u'F\xe4ustlinge'), (u"f\xfcr'ne", u"f\xfcr 'ne"), (u'f\xfcrchlerlichen', u'f\xfcrchterlichen'), (u'f\xfcrjede', u'f\xfcr jede'), (u'f\xfcrjeden', u'f\xfcr jeden'), (u'F\ufb02hrungsprogramm', u'F\xfchrungsprogramm'), (u'F\ufb02hrungsstil', u'F\xfchrungsstil'), (u'f\ufb02llen', u'f\xfcllen'), (u'f\ufb02llt', u'f\xe4llt'), (u'f\ufb02nf', u'f\xfcnf'), (u'F\ufb02r', u'F\xfcr'), (u'f\ufb02rchte', u'f\xfcrchte'), (u'f\ufb02rjeden', u'f\xfcr jeden'), (u'g/bf', u'gibt'), (u'g/bsf', u'gibst'), (u'G5ste', u'G\xe4ste'), (u'G6nn', u'G\xf6nn'), (u"G6t'lllche", u'G\xf6ttliche'), (u'G6tter', u'G\xf6tter'), (u'G6ttern', u'G\xf6ttern'), (u'Gamilonl', u'Gamilon!'), (u'ganzlich', u'g\xe4nzlich'), (u'gardel', u'garde!'), (u'Gasbrfiter', u'Gasbr\xe4ter'), (u'gauze', u'ganze'), (u'GCJKTEN', u'G\xd6KTEN'), (u'ge6lt', u'ge\xf6lt'), (u'gebauf', u'gebaut'), (u'Gebiez', u'Gebiet'), (u'Gebi\xe9ude', u'Geb\xe4ude'), (u'gebliebenl', u'geblieben!'), (u'GEBRAUCHTWAGENIPOLIZEIITAXI', u'GEBRAUCHTWAGEN/POLIZEI/TAXI'), (u'Gebr\xe9u', u'Gebr\xe4u'), (u'gebs', u"geb's"), (u'gebuhrend', u'geb\xfchrend'), (u'Geb\xe9ick', u'Geb\xe4ck'), (u'Geb\xe9iude', u'Geb\xe4ude'), (u'geb\xe9rdet', u'geb\xe4rdet'), (u'Geb\xe9rmutter', u'Geb\xe4rmutter'), (u'Geb\xe9rmutterhals', u'Geb\xe4rmutterhals'), (u'Geb\xe9ude', u'Geb\xe4ude'), (u'Geb\xe9udedach', u'Geb\xe4udedach'), (u'Geb\xe9uden', u'Geb\xe4uden'), (u'Geb\xe9udes', u'Geb\xe4udes'), (u'gedemiitigt', u'gedem\xfctigt'), (u'gedemijtigt', u'gedem\xfctigt'), (u'gedemllitigt', u'gedem\xfctigt'), (u'gedrtickt', u'gedr\xfcckt'), (u'gedr\xe9ngt', u'gedr\xe4ngt'), (u'Ged\xe9chtnisverlustes', u'Ged\xe4chtnisverlustes'), (u'Ged\xe9ichtnis', u'Ged\xe4chtnis'), (u'ged\xe9mpft', u'ged\xe4mpft'), (u"gef'a'hrlich", u'gef\xe4hrlich'), (u"gef'a'llt", u'gef\xe4llt'), (u'gef5IIt', u'gef\xe4llt'), (u'gefahrdet', u'gef\xe4hrdet'), (u'gefahrlich', u'gef\xe4hrlich'), (u'gefallsllichtige', u'gefalls\xfcchtige'), (u'GEFANGNISTECHNOLOGIE', u'GEF\xc4NGNISTECHNOLOGIE'), (u'Gefechtsausrustung', u'Gefechtsausr\xfcstung'), (u'Geffihl', u'Gef\xfchl'), (u'geffihrt', u'gef\xfchrt'), (u'geffillt', u'gef\xe4llt'), (u'Gefihrliche', u'Gef\xe4rliche'), (u'Gefiihl', u'Gef\xfchl'), (u'Gefiihle', u'Gef\xfchle'), (u'Gefiihlen', u'Gef\xfchlen'), (u'Gefiihlslebens', u'Gef\xfchlslebens'), (u'gefiihlsmiliigen', u'gef\xfchlsm\xe4\xdfigen'), (u'gefiihrt', u'gef\xfchrt'), (u'gefiillst', u'gef\xe4llst'), (u'gefiillt', u'gef\xfcllt'), (u'gefiirchtet', u'gef\xfcrchtet'), (u'Gefijhl', u'Gef\xfchl'), (u'Gefijhle', u'Gef\xfchle'), (u'gefijhlt', u'gef\xfchlt'), (u'gefijllte', u'gef\xfcllte'), (u'Gefilhl', u'Gef\xfchl'), (u'Gefilhle', u'Gef\xfchle'), (u'gefillt', u'gef\xe4llt'), (u'Gefingnis', u'Gef\xe4ngnis'), (u"gefL'lllten", u'gef\xfcllten'), (u'Geflilster', u'Gefl\xfcster'), (u'gefllihllos', u'gef\xfchllos'), (u'Geflllhlsduselige', u'Gef\xfchlsduselige'), (u'GEFLUSTERT', u'GEFL\xdcSTERT'), (u'Geftuhle', u'Gef\xfchle'), (u'Gefuhl', u'Gef\xfchl'), (u'Gefuhle', u'Gef\xfchle'), (u'Gefuhlen', u'Gef\xfchlen'), (u'gefuhlt', u'gef\xfchlt'), (u'gefuhlvolle', u'gef\xfchlvolle'), (u'gefurchtet', u'gef\xfcrchtet'), (u'Gef\xe9hrde', u'Gef\xe4hrde'), (u'gef\xe9hrden', u'gef\xe4hrden'), (u'gef\xe9hrdet', u'gef\xe4hrdet'), (u'Gef\xe9hrdung', u'Gef\xe4hrdung'), (u'gef\xe9hrlich', u'gef\xe4hrlich'), (u'gef\xe9hrliche', u'gef\xe4hrliche'), (u'gef\xe9hrlicher', u'gef\xe4hrlicher'), (u'gef\xe9hrlicheren', u'gef\xe4hrlicheren'), (u'Gef\xe9hrliches', u'Gef\xe4hrliches'), (u'Gef\xe9hrt', u'Gef\xe4hrt'), (u'gef\xe9ihrden', u'gef\xe4hrden'), (u'gef\xe9ihrdet', u'gef\xe4hrdet'), (u'gef\xe9ihrlich', u'gef\xe4hrlich'), (u'Gef\xe9ihrte', u'Gef\xe4hrte'), (u'Gef\xe9ihrten', u'Gef\xe4hrten'), (u'gef\xe9illt', u'gef\xe4llt'), (u"Gef\xe9illt's", u"Gef\xe4llt's"), (u'gef\xe9llf', u'gef\xe4llt'), (u'gef\xe9llfs', u"gef\xe4llt's"), (u'gef\xe9llig', u'gef\xe4llig'), (u'gef\xe9lligst', u'gef\xe4lligst'), (u'gef\xe9llst', u'gef\xe4llst'), (u'Gef\xe9llt', u'Gef\xe4llt'), (u"Gef\xe9llt's", u"Gef\xe4llt's"), (u'gef\xe9lscht', u'gef\xe4lscht'), (u'Gef\xe9ngnis', u'Gef\xe4ngnis'), (u'Gef\xe9ngnisregeln', u'Gef\xe4ngnisregeln'), (u'Gef\xe9ngnisse', u'Gef\xe4ngnisse'), (u'Gef\xe9ngnissen', u'Gef\xe4ngnissen'), (u'Gef\xe9ngnisses', u'Gef\xe4ngnisses'), (u'Gef\xe9ngniswagen', u'Gef\xe4ngniswagen'), (u'gef\ufb02gig', u'gef\xfcgig'), (u'gegenfiber', u'gegen\xfcber'), (u'gegeniiber', u'gegen\xfcber'), (u'gegeniibertritt', u'gegen\xfcbertritt'), (u'gegeniiberzusfehen', u'gegen\xfcberzustehen'), (u'gegenijber', u'gegen\xfcber'), (u'gegenlliber', u'gegen\xfcber'), (u'gegenlliberstehen', u'gegen\xfcberstehen'), (u'Gegenstrfimung', u'Gegenstr\xf6mung'), (u'Gegenstr\xe9mung', u'Gegenstr\xf6mung'), (u'Gegensttlck', u'Gegenst\xfcck'), (u'Gegenst\xe9nde', u'Gegenst\xe4nde'), (u'gegenuber', u'gegen\xfcber'), (u'Gegenverschwiirung', u'Gegenverschw\xf6rung'), (u'gegenw\xe9rtigen', u'gegenw\xe4rtigen'), (u'gegriindet', u'gegr\xfcndet'), (u'gegrijfit', u'gegr\xfc\xdft'), (u'gegrilfit', u'gegr\xfc\xdft'), (u'GegrUl3t', u'Gegr\xfc\xdft'), (u'gegrundet', u'gegr\xfcndet'), (u'geh6ren', u'geh\xf6ren'), (u'geh6rt', u'geh\xf6rt'), (u'gehdrt', u'geh\xf6rt'), (u'GeheilS', u'Gehei\xdf'), (u'geheilSen', u'gehei\xdfen'), (u'gehejetzt', u'gehe jetzt'), (u'gehf', u'geht'), (u'gehfiirt', u'geh\xf6rt'), (u'gehfire', u'geh\xf6re'), (u'gehfiren', u'geh\xf6ren'), (u'gehfirt', u'geh\xf6rt'), (u'gehiipft', u'geh\xfcpft'), (u'Gehiir', u'Geh\xf6r'), (u'gehiire', u'geh\xf6re'), (u'gehiiren', u'geh\xf6ren'), (u'gehiirst', u'geh\xf6rst'), (u'gehiirt', u'geh\xf6rt'), (u'Gehim', u'Gehirn'), (u'Gehirnsch\xe9den', u'Gehirnsch\xe4den'), (u'gehlngt', u'geh\xe4ngt'), (u'gehore', u'geh\xf6re'), (u'gehoren', u'geh\xf6ren'), (u'gehort', u'geh\xf6rt'), (u"geht'sl", u"geht's!"), (u'Gehtirt', u'Geh\xf6rt'), (u'gehtjetzt', u'geht jetzt'), (u'geh\xe9irt', u'geh\xf6rt'), (u'Geh\xe9iuteten', u'Geh\xe4uteten'), (u'geh\xe9r', u'geh\xf6r'), (u'geh\xe9re', u'geh\xf6re'), (u'geh\xe9ren', u'geh\xf6ren'), (u'geh\xe9rst', u'geh\xf6rst'), (u'Geh\xe9rt', u'Geh\xf6rt'), (u'geh\xe9rten', u'geh\xf6rten'), (u'geh\xe9rtf', u'geh\xf6rt!'), (u'geiiffnet', u'ge\xf6ffnet'), (u'geilbt', u'ge\xfcbt'), (u'geistesgestort', u'geistesgest\xf6rt'), (u'Gei\ufb02blatt', u'Gei\xdfblatt'), (u'Gei\ufb02blattstaude', u'Gei\xdfblattstaude'), (u'gekiisst', u'gek\xfcsst'), (u'gekiisstl', u'gek\xfcsst!'), (u'gekijndigt', u'gek\xfcndigt'), (u'gekijsst', u'gek\xfcsst'), (u'gekilsst', u'gek\xfcsst'), (u'gekimpfl', u'gek\xe4mpft'), (u'gekimpft', u'gek\xe4mpft'), (u'geklautl', u'geklaut!'), (u'gekliirt', u'gekl\xe4rt'), (u'gekllrt', u'gekl\xe4rt'), (u'gekl\xe9rt', u'gekl\xe4rt'), (u'gekriint', u'gekr\xf6nt'), (u'gekrijmmt', u'gekr\xfcmmt'), (u'GEKUHLTER', u'GEK\xdcHLTER'), (u'gekurzt', u'gek\xfcrzt'), (u'gek\xe9mpft', u'gek\xe4mpft'), (u'gelaufenl', u'gelaufen!'), (u'gelegf', u'gelegt'), (u'gelegtwurde', u'gelegt wurde'), (u'geliist', u'gel\xf6st'), (u'gelilftet', u'gel\xfcftet'), (u'gelndert', u'ge\xe4ndert'), (u'Gelst', u'Geist'), (u'Geltungsbedurfnis', u'Geltungsbed\xfcrfnis'), (u'GELUBDE', u'GEL\xdcBDE'), (u'Gel\xe9chter', u'Gel\xe4chter'), (u'gel\xe9hmt', u'gel\xe4hmt'), (u'gel\xe9ischt', u'gel\xf6scht'), (u'Gel\xe9nde', u'Gel\xe4nde'), (u'gel\xe9nge', u'gel\xe4nge'), (u'gel\xe9st', u'gel\xf6st'), (u'gem', u'gern'), (u'gemafiregelt', u'gema\xdfregelt'), (u'Geme', u'Gerne'), (u'gemfitliches', u'gem\xfctliches'), (u'Gemiise', u'Gem\xfcse'), (u'gemiitlich', u'gem\xfctlich'), (u'Gemijlse', u'Gem\xfcse'), (u'Gemilt', u'Gem\xfct'), (u'gemiltlicher', u'gem\xfctlicher'), (u'GemLise', u'Gem\xfcse'), (u'Gemut', u'Gem\xfct'), (u'gem\xe9fi', u'gem\xe4\xdf'), (u'Gem\xe9fk', u'Gem\xe4\xdf'), (u'gem\xe9ht', u'gem\xe4ht'), (u'Gem\xe9ili', u'Gem\xe4\xdf'), (u'Gem\xe9lde', u'Gem\xe4lde'), (u'Gem\xe9lden', u'Gem\xe4lden'), (u'Genaul', u'Genau!'), (u'genieBt', u'genie\xdft'), (u'genief$en', u'genie\xdfen'), (u'Geniefien', u'Genie\xdfen'), (u'geniefk', u'genie\xdf'), (u'genielien', u'genie\xdfen'), (u'genielken', u'genie\xdfen'), (u'genie\ufb02en', u'genie\xdfen'), (u'genligen', u'gen\xfcgen'), (u'genlligend', u'gen\xfcgend'), (u'genlligt', u'gen\xfcgt'), (u'genlllgend', u'gen\xfcgend'), (u'genugt', u'gen\xfcgt'), (u'genugte', u'gen\xfcgte'), (u'georfef', u'geortet'), (u'gepfluckt', u'gepfl\xfcckt'), (u'gepriifter', u'gepr\xfcfter'), (u'gepruft', u'gepr\xfcft'), (u'Gep\xe9ck', u'Gep\xe4ck'), (u'gerfit', u'ger\xe4t'), (u'Geriichte', u'Ger\xfcchte'), (u'Geriite', u'Ger\xe4te'), (u'Gerijcht', u'Ger\xfccht'), (u'Gerllicht', u'Ger\xfccht'), (u'gerllistet', u'ger\xfcstet'), (u'gernhaben', u'gern-haben'), (u'gernntgt', u'ger\xf6ntgt'), (u'ger\xe9it', u'ger\xe4t'), (u'Ger\xe9iusch', u'Ger\xe4usch'), (u'Ger\xe9t', u'Ger\xe4t'), (u'Ger\xe9te', u'Ger\xe4te'), (u'Ger\xe9tschaften', u'Ger\xe4tschaften'), (u'ger\xe9umt', u'ger\xe4umt'), (u'Ger\xe9usch', u'Ger\xe4usch'), (u'Ger\xe9usche', u'Ger\xe4usche'), (u'ger\xe9uschvoll', u'ger\xe4uschvoll'), (u'geschafff', u'geschafft'), (u'GESCHAFTSFUHRER', u'GESCH\xc4FTSF\xdcHRER'), (u'gescha\ufb02i', u'geschafft'), (u'Geschfift', u'Gesch\xe4ft'), (u'geschfimt', u'gesch\xe4mt'), (u'Geschift', u'Gesch\xe4ft'), (u'Geschifte', u'Gesch\xe4fte'), (u'Geschiftsleute', u'Gesch\xe4ftsleute'), (u'Geschiftswelt', u'Gesch\xe4ftswelt'), (u'geschiidigt', u'gesch\xe4digt'), (u'Geschiift', u'Gesch\xe4ft'), (u'Geschiiftsleben', u'Gesch\xe4ftsleben'), (u'geschijtzten', u'gesch\xfctzten'), (u'Geschiltz', u'Gesch\xfctz'), (u'Geschiltze', u'Gesch\xfctze'), (u'Geschiltzrohre', u'Gesch\xfctzrohre'), (u'Geschiltzturm', u'Gesch\xfctzturm'), (u'geschlijpftl', u'geschl\xfcpft!'), (u'Geschllitzstellungen', u'Gesch\xfctzstellungen'), (u'geschnfiffelt', u'geschn\xfcffelt'), (u'Geschtitz', u'Gesch\xfctz'), (u'Geschtltz', u'Gesch\xfctz'), (u'Geschutz', u'Gesch\xfctz'), (u'Geschutze', u'Gesch\xfctze'), (u'Geschwiir', u'Geschw\xfcr'), (u'Geschwllir', u'Geschw\xfcr'), (u'Geschwur', u'Geschw\xfcr'), (u'geschw\xe9cht', u'geschw\xe4cht'), (u'geschw\xe9ingert', u'geschw\xe4ngert'), (u'Geschw\xe9tz', u'Geschw\xe4tz'), (u'Gesch\xe9ft', u'Gesch\xe4ft'), (u'Gesch\xe9fte', u'Gesch\xe4fte'), (u'Gesch\xe9ftige', u'Gesch\xe4ftige'), (u'gesch\xe9ftlich', u'gesch\xe4ftlich'), (u'Gesch\xe9fts', u'Gesch\xe4fts'), (u'Gesch\xe9ftsleben', u'Gesch\xe4ftsleben'), (u'Gesch\xe9ift', u'Gesch\xe4ft'), (u'Gesch\xe9ifte', u'Gesch\xe4fte'), (u'gesch\xe9iftsm\xe9ifiig', u'gesch\xe4ftsm\xe4\xdfig'), (u'gesch\xe9itzt', u'gesch\xe4tzt'), (u'gesch\xe9nolet', u'gesch\xe4ndet'), (u'Gesch\ufb02tze', u'Gesch\xfctze'), (u'Gesetzeshiiter', u'Gesetzesh\xfcter'), (u'Gesichtl', u'Gesicht!'), (u'Gesichtsausdrijcke', u'Gesichtsausdr\xfccke'), (u'Gesiiff', u'Ges\xf6ff'), (u'gesiindigt', u'ges\xfcndigt'), (u'gespiirt', u'gesp\xfcrt'), (u'Gesprach', u'Gespr\xe4ch'), (u'GESPRACH', u'GESPR\xc4CH'), (u'GESPRACHE', u'GESPR\xc4CHE'), (u'Gespr\xe9ch', u'Gespr\xe4ch'), (u'Gespr\xe9che', u'Gespr\xe4che'), (u'Gespr\xe9iche', u'Gespr\xe4che'), (u'Gespr\xe9ichsthema', u'Gespr\xe4chsthema'), (u'Gespur', u'Gesp\xfcr'), (u'gestiirt', u'gest\xf6rt'), (u'gestijrzt', u'gest\xfcrzt'), (u'gestijtzte', u'gest\xfctzte'), (u'gestof$en', u'gesto\xdfen'), (u'gestolken', u'gesto\xdfen'), (u'Gestriipp', u'Gestr\xfcpp'), (u'Gestrijpp', u'Gestr\xfcpp'), (u'GESTURZT', u'GEST\xdcRZT'), (u'gest\xe9irt', u'gest\xf6rt'), (u'Gest\xe9ndnis', u'Gest\xe4ndnis'), (u'gest\xe9rt', u'gest\xf6rt'), (u'gest\ufb02rzt', u'gest\xfcrzt'), (u'Gesundheitsbehijrde', u'Gesundheitsbeh\xf6rde'), (u'Gesundheitsftlrsorge', u'Gesundheitsf\xfcrsorge'), (u'Ges\xe9fitaschel', u'Ges\xe4\xdftasche!'), (u'Ges\xe9iffstaschenl', u'Ges\xe4\xdftaschen!'), (u'get6tet', u'get\xf6tet'), (u'Getiise', u'Get\xf6se'), (u'getiitet', u'get\xf6tet'), (u"getr'a'umt", u'getr\xe4umt'), (u'getr\xe9umt', u'getr\xe4umt'), (u'get\xe9tet', u'get\xf6tet'), (u'get\xe9tetf', u'get\xf6tet!'), (u'get\xe9uscht', u'get\xe4uscht'), (u'gev\xe9gelt', u'gev\xf6gelt'), (u'gew6hnt', u'gew\xf6hnt'), (u'GEWACHSHAUS', u'GEW\xc4CHSHAUS'), (u'gewaltt\xe9tig', u'gewaltt\xe4tig'), (u'gewarnf', u'gewarnt'), (u'Gewerkschaftsfunktion\xe9ren', u'Gewerkschaftsfunktion\xe4ren'), (u'gewfinscht', u'gew\xfcnscht'), (u'Gewiasenskon\ufb02ikte', u'Gewissenskon\ufb02ikte'), (u'gewiihlt', u'gew\xe4hlt'), (u'gewiihnen', u'gew\xf6hnen'), (u'gewiihnlich', u'gew\xf6hnlich'), (u'gewiihnlicher', u'gew\xf6hnlicher'), (u'gewiihnliches', u'gew\xf6hnliches'), (u'gewiihnt', u'gew\xf6hnt'), (u'gewiinscht', u'gew\xfcnscht'), (u'gewijhnlichen', u'gew\xf6hnlichen'), (u'gewijnscht', u'gew\xfcnscht'), (u'gewissermafien', u'gewisserma\xdfen'), (u'gewissermallsen', u'gewisserma\xdfen'), (u'gewlllnscht', u'gew\xfcnscht'), (u'Gewohnheitstiter', u'Gewohnheitst\xe4ter'), (u'gewtinscht', u'gew\xfcnscht'), (u'gewunscht', u'gew\xfcnscht'), (u'gewunschten', u'gew\xfcnschten'), (u'Gew\xe9chshaus', u'Gew\xe4chshaus'), (u'gew\xe9hlt', u'gew\xe4hlt'), (u'gew\xe9hnen', u'gew\xf6hnen'), (u'gew\xe9hnlicher', u'gew\xf6hnlicher'), (u'gew\xe9hnst', u'gew\xf6hnst'), (u'gew\xe9hnt', u'gew\xf6hnt'), (u'Gew\xe9hren', u'Gew\xe4hren'), (u'gew\xe9hrt', u'gew\xe4hrt'), (u'Gew\xe9isser', u'Gew\xe4sser'), (u'Gew\xe9ssern', u'Gew\xe4ssern'), (u'gezfichtet', u'gez\xfcchtet'), (u'gezilndet', u'gez\xfcndet'), (u'gez\xe9hlt', u'gez\xe4hlt'), (u'gez\xe9ihlt', u'gez\xe4hlt'), (u'gez\xe9ihmt', u'gez\xe4hmt'), (u'ge\xe9ndert', u'ge\xe4ndert'), (u"GF6l'1Z6fUf", u'Grenze f\xfcr'), (u'Gfirtel', u'G\xfcrtel'), (u'Gfirtner', u'G\xe4rtner'), (u'Gfiste', u'G\xe4ste'), (u'Gfitter', u'G\xf6tter'), (u'Ghrchen', u'\xd6hrchen'), (u'gibtjede', u'gibt jede'), (u'gibtk', u"gibt's"), (u'gibts', u"gibt's"), (u'gieBen', u'gie\xdfen'), (u'GieBkanne', u'Gie\xdfkanne'), (u'gief$t', u'gie\xdft'), (u'giefit', u'gie\xdft'), (u'gielit', u'gie\xdft'), (u'gignalton', u'Signalton'), (u'giinstiger', u'g\xfcnstiger'), (u'Giire', u'G\xf6re'), (u'Giite', u'G\xfcte'), (u'giitiger', u'g\xfctiger'), (u'Giitter', u'G\xf6tter'), (u'Giittliche', u'G\xf6ttliche'), (u'giittlichen', u'g\xf6ttlichen'), (u'Gijte', u'G\xfcte'), (u'Gijtel', u'G\xfcte!'), (u'Gilrtel', u'G\xfcrtel'), (u'Gilte', u'G\xfcte'), (u'Giltiger', u'G\xfctiger'), (u'Gitarrenkl\xe9nge', u'Gitarrenkl\xe4nge'), (u'Gite', u'G\xfcte'), (u'GIUck', u'Gl\xfcck'), (u"GIUCKliCl'1", u'Gl\xfccklich'), (u"GL'lte", u'G\xfcte'), (u'Glaubwurdigkeit', u'Glaubw\xfcrdigkeit'), (u'Glaubwurdigkeitl', u'Glaubw\xfcrdigkeit!'), (u'glaubw\ufb02rdig', u'glaubw\xfcrdig'), (u'glb', u'gib'), (u'glbt', u'gibt'), (u'Gle/ch', u'Gleich'), (u'gleichgiiltig', u'gleichg\xfcltig'), (u'gleichm\xe9mig', u'gleichm\xe4\xdfig'), (u'Glfick', u'Gl\xfcck'), (u'glficklich', u'gl\xfccklich'), (u'Glfickspilz', u'Gl\xfcckspilz'), (u'Gliick', u'Gl\xfcck'), (u'Gliickchen', u'Gl\xf6ckchen'), (u'gliicklich', u'gl\xfccklich'), (u'gliicklicher', u'gl\xfccklicher'), (u'Gliicksbringer', u'Gl\xfccksbringer'), (u'Gliickssfr\xe9hne', u'Gl\xfccksstr\xe4hne'), (u'Gliickwunsch', u'Gl\xfcckwunsch'), (u'gliilcklich', u'gl\xfccklich'), (u'Glijck', u'Gl\xfcck'), (u'glijcklich', u'gl\xfccklich'), (u'Glilck', u'Gl\xfcck'), (u'glilcklich', u'gl\xfccklich'), (u'Glilckwunsch', u'Gl\xfcckwunsch'), (u'Glillck', u'Gl\xfcck'), (u'gllinstig', u'g\xfcnstig'), (u'gllinstigem', u'g\xfcnstigem'), (u'gllinstigen', u'g\xfcnstigen'), (u'glljcklich', u'gl\xfccklich'), (u'glllicklich', u'gl\xfccklich'), (u'glllickliche', u'gl\xfcckliche'), (u'Glllte', u'G\xfcte'), (u'Glorifiziertl', u'Glorifiziert!'), (u'glticklich', u'gl\xfccklich'), (u'Gltickszahlen', u'Gl\xfcckszahlen'), (u'gltlckliohes', u'gl\xfcckliches'), (u'Gluck', u'Gl\xfcck'), (u'glucklich', u'gl\xfccklich'), (u'gluckliche', u'gl\xfcckliche'), (u'GLUCKSELIGKEIT', u'GL\xdcCKSELIGKEIT'), (u'Gluckwunsch', u'Gl\xfcckwunsch'), (u'Gluok', u'Gl\xfcck'), (u'gluoklich', u'gl\xfccklich'), (u'Glupsch\xe9ugige', u'Glupsch\xe4ugige'), (u'glutheilie', u'gluthei\xdfe'), (u'gl\xe9inzende', u'gl\xe4nzende'), (u'gl\xe9nzende', u'gl\xe4nzende'), (u'gl\xe9nzte', u'gl\xe4nzte'), (u'Gl\xe9ser', u'Gl\xe4ser'), (u'gl\xe9ubige', u'gl\xe4ubige'), (u'Gl\xe9ubigen', u'Gl\xe4ubigen'), (u'Gl\ufb02ck', u'Gl\xfcck'), (u'Gl\ufb02cklich', u'Gl\xfccklich'), (u'Gl\ufb02ckstag', u'Gl\xfcckstag'), (u'Gl\ufb02ckwilnsche', u'Gl\xfcckw\xfcnsche'), (u'gnidig', u'gn\xe4dig'), (u'Gnllnden', u'Gr\xfcnden'), (u'gn\xe9dig', u'gn\xe4dig'), (u'gn\xe9dige', u'gn\xe4dige'), (u'gn\xe9digen', u'gn\xe4digen'), (u'Gn\xe9digste', u'Gn\xe4digste'), (u'gn\xe9idig', u'gn\xe4dig'), (u'Goff', u'Gott'), (u'Golfballweili', u'Golfballwei\xdf'), (u'gonnst', u'g\xf6nnst'), (u'gottesfllirchtiger', u'gottesf\xfcrchtiger'), (u'Gottverdammt', u'Gott verdammt'), (u'Go\ufb02', u'Gott'), (u'Gr6Be', u'Gr\xf6\xdfe'), (u'gr6Ber', u'gr\xf6\xdfer'), (u'gr6Bere', u'gr\xf6\xdfere'), (u'gr6Beren', u'gr\xf6\xdferen'), (u'Gr6Bte', u'Gr\xf6\xdfte'), (u'Gr6Bten', u'Gr\xf6\xdften'), (u'gr6Bter', u'gr\xf6\xdfter'), (u'gr6Btes', u'gr\xf6\xdftes'), (u'gr6f$te', u'gr\xf6\xdfte'), (u'gr6f$ten', u'gr\xf6\xdften'), (u'gr6f5ten', u'gr\xf6\xdften'), (u'gr6I3ter', u'gr\xf6\xdfter'), (u'gr6ISten', u'gr\xf6\xdften'), (u'Gr6l3e', u'Gr\xf6\xdfe'), (u'gr6l3ter', u'gr\xf6\xdfter'), (u'Grabst\xe9tte', u'Grabst\xe4tte'), (u'gratulierel', u'gratuliere!'), (u'grClf$en', u'gr\xfc\xdfen'), (u'grfilieren', u'gr\xf6\xdferen'), (u'Grfiner', u'Gr\xfcner'), (u'griil3e', u'gr\xfc\xdfe'), (u'griiliere', u'gr\xf6\xdfere'), (u'griiliten', u'gr\xf6\xdften'), (u'griin', u'gr\xfcn'), (u'Griinde', u'Gr\xfcnde'), (u'Griinden', u'Gr\xfcnden'), (u'griindlich', u'gr\xfcndlich'), (u'Griine', u'Gr\xfcne'), (u'griinen', u'gr\xfcnen'), (u'Griiner', u'Gr\xfcner'), (u'griin\xe9iugige', u'gr\xfcn\xe4ugige'), (u'griin\xe9iugiges', u'gr\xfcn\xe4ugiges'), (u'grii\ufb02te', u'gr\xf6\xdfte'), (u'Grijbeln', u'Gr\xfcbeln'), (u'griJBen', u'gr\xfc\xdfen'), (u'grijn', u'gr\xfcn'), (u'Grijnde', u'Gr\xfcnde'), (u'grijnden', u'gr\xfcnden'), (u'grijndlich', u'gr\xfcndlich'), (u'grijnes', u'gr\xfcnes'), (u'Grijnfutter', u'Gr\xfcnfutter'), (u'Grilbelt', u'Gr\xfcbelt'), (u'grilfken', u'gr\xfc\xdfen'), (u'Grillh\xe9hnchen', u'Grillh\xe4hnchen'), (u'Grilnde', u'Gr\xfcnde'), (u'Grilnden', u'Gr\xfcnden'), (u'grilndet', u'gr\xfcndet'), (u'grilndlich', u'gr\xfcndlich'), (u'grilndlicherf', u'gr\xfcndlicher!'), (u'grilndlichl', u'gr\xfcndlich!'), (u'grilne', u'gr\xfcne'), (u'Grilnschn\xe9bel', u'Gr\xfcnschn\xe4bel'), (u'grim', u'gr\xfcn'), (u'Grime', u'Gr\xf6\xdfe'), (u'grinco', u'gringo'), (u'Grllinde', u'Gr\xfcnde'), (u'grllinden', u'gr\xfcnden'), (u'grllindlich', u'gr\xfcndlich'), (u'grlllnes', u'gr\xfcnes'), (u'Gro/3artig', u'Gro\xdfartig'), (u'gro/3es', u'gro\xdfes'), (u'gro/3zUgig', u'gro\xdfz\xfcgig'), (u'Gro/Bstadt', u'Gro\xdfstadt'), (u'gro/Ken', u'gro\xdfen'), (u'groB', u'gro\xdf'), (u'groBartig', u'gro\xdfartig'), (u'GroBe', u'Gro\xdfe'), (u'GroBes', u'Gro\xdfes'), (u'GroBmutter', u'Gro\xdfmutter'), (u'GroBteil', u'Gro\xdfteil'), (u'groBziJgiger', u'gro\xdfz\xfcgiger'), (u'grof$', u'gro\xdf'), (u'grof$artig', u'gro\xdfartig'), (u'grof$artigen', u'gro\xdfartigen'), (u'grof$e', u'gro\xdfe'), (u'grof$er', u'gro\xdfer'), (u'grof$es', u'gro\xdfes'), (u'grof3', u'gro\xdf'), (u'grof3>artige', u'gro\xdfartige'), (u'Grof3e', u'Gro\xdfe'), (u'grof3en', u'gro\xdfen'), (u'grof3erAlien', u'gro\xdfer Alien'), (u'grof5es', u'gro\xdfes'), (u'Grofbvaters', u'Gro\xdfvaters'), (u'grofi', u'gro\xdf'), (u'Grofiangriffs', u'Gro\xdfangriffs'), (u'Grofiartig', u'Gro\xdfartig'), (u'grofiartige', u'gro\xdfartige'), (u'grofiartigen', u'gro\xdfartigen'), (u'grofiartiger', u'gro\xdfartiger'), (u'Grofiartiges', u'Gro\xdfartiges'), (u'Grofibritannien', u'Gro\xdfbritannien'), (u'Grofidiebstahl', u'Gro\xdfdiebstahl'), (u'Grofie', u'Gro\xdfe'), (u'grofier', u'gro\xdfer'), (u'grofies', u'gro\xdfes'), (u'grofiten', u'gr\xf6\xdften'), (u'grofk', u'gro\xdf'), (u'Grofkartig', u'Gro\xdfartig'), (u'grofke', u'gro\xdfe'), (u'Grofken', u'Gro\xdfen'), (u'Grofker', u'Gro\xdfer'), (u'Grofkvater', u'Gro\xdfvater'), (u'grofLe', u'gro\xdfe'), (u'grofler', u'gro\xdfer'), (u'groflsartig', u'gro\xdfartig'), (u'groflsartige', u'gro\xdfartige'), (u'Groflse', u'Gro\xdfe'), (u'groflsen', u'gro\xdfen'), (u'Grofser', u'Gro\xdfer'), (u'grol', u'gro\xdf'), (u"grol'3>en", u'gro\xdfen'), (u'grol2>', u'gro\xdf'), (u'grol2>en', u'gro\xdfen'), (u'grol3>es', u'gro\xdfes'), (u'grol3e', u'gro\xdfe'), (u'grol3er', u'gro\xdfer'), (u'Grol3raum', u'Gro\xdfraum'), (u'groli', u'gro\xdf'), (u'Groliartig', u'Gro\xdfartig'), (u'groliartige', u'gro\xdfartige'), (u'groliartigen', u'gro\xdfartigen'), (u'grolie', u'gro\xdfe'), (u'grolien', u'gro\xdfen'), (u'groliherzig', u'gro\xdfherzig'), (u'Grolimutter', u'Gro\xdfmutter'), (u'Grolisegel', u'Gro\xdfsegel'), (u'Grolkvater', u'Gro\xdfvater'), (u'groller', u'gro\xdfer'), (u'Grollser', u'Gro\xdfer'), (u'grollzugig', u'gro\xdfz\xfcgig'), (u'grolS', u'gro\xdf'), (u'grolSe', u'gro\xdfe'), (u'GrolSeltern', u'Gro\xdfeltern'), (u'grolSer', u'gro\xdfer'), (u'GrolSvater', u'Gro\xdfvater'), (u'grolZ~', u'gro\xdfe'), (u'gror$er', u'gro\xdfer'), (u'grorker', u'gro\xdfer'), (u'grosses', u'gro\xdfes'), (u'GROSSTE', u'GR\xd6SSTE'), (u'gro\ufb02', u'gro\xdf'), (u'gro\ufb02e', u'gro\xdfe'), (u'Gro\ufb02stadtkind', u'Gro\xdfstadtkind'), (u'Gro\ufb02vater', u'Gro\xdfvater'), (u'Grtin', u'Gr\xfcn'), (u'Grtmde', u'Gr\xfcnde'), (u'GruB', u'Gru\xdf'), (u'Grubenausg\xe9nge', u'Grubenausg\xe4nge'), (u'Gruf$', u'Gru\xdf'), (u'grUf$en', u'gr\xfc\xdfen'), (u'grufit', u'gr\xfc\xdft'), (u'Gruli', u'Gru\xdf'), (u'Grulikarte', u'Gru\xdfkarte'), (u'Grulikarten', u'Gru\xdfkarten'), (u'Grun', u'Gr\xfcn'), (u'grundlich', u'gr\xfcndlich'), (u'Grundstiick', u'Grundst\xfcck'), (u'grunds\xe9tzlich', u'grunds\xe4tzlich'), (u'grune', u'gr\xfcne'), (u'grunen', u'gr\xfcnen'), (u'Gr\xe9ben', u'Gr\xe4ben'), (u'gr\xe9bst', u'gr\xe4bst'), (u'gr\xe9fier', u'gr\xf6\xdfer'), (u'gr\xe9fkte', u'gr\xf6\xdfte'), (u'gr\xe9flserer', u'gr\xf6\xdferer'), (u'Gr\xe9ifite', u'Gr\xf6\xdfte'), (u'gr\xe9illten', u'gr\xf6\xdften'), (u'gr\xe9sslich', u'gr\xe4sslich'), (u'Gr\xe9uel', u'Gr\xe4uel'), (u'gr\ufb02ndlich', u'gr\xfcndlich'), (u'gr\ufb02ne', u'gr\xfcne'), (u'gull', u'gut!'), (u'Gummist\xe9psel', u'Gummist\xf6psel'), (u'Gumml', u'Gummi'), (u'GUNSTIGSTEN', u'G\xdcNSTIGSTEN'), (u'Gurtell', u'G\xfcrtel!'), (u'gutaussehend', u'gut aussehend'), (u'gutaussehender', u'gut aussehender'), (u'GUte', u'G\xfcte'), (u'gutgebaut', u'gut gebaut'), (u'gutgehen', u'gut gehen'), (u'Gutmijtigkeit', u'Gutm\xfctigkeit'), (u'g\xe9be', u'g\xe4be'), (u'g\xe9ben', u'g\xe4ben'), (u'g\xe9ibe', u'g\xe4be'), (u'G\xe9ittern', u'G\xf6ttern'), (u'G\xe9lisch', u'G\xe4lisch'), (u'G\xe9lische', u'G\xe4lische'), (u'g\xe9lisches', u'g\xe4lisches'), (u'G\xe9nsehaut', u'G\xe4nsehaut'), (u'G\xe9nsen', u'G\xe4nsen'), (u'G\xe9nze', u'G\xe4nze'), (u'G\xe9rfen', u'G\xe4rten'), (u'G\xe9rtnern', u'G\xe4rtnern'), (u'G\xe9ste', u'G\xe4ste'), (u'G\xe9stezimmer', u'G\xe4stezimmer'), (u'G\xe9tter', u'G\xf6tter'), (u'G\xe9tterspeise', u'G\xf6tterspeise'), (u'G\xe9ttin', u'G\xf6ttin'), (u'G\xe9ttliche', u'G\xf6ttliche'), (u'g\xe9ttlichen', u'g\xf6ttlichen'), (u'G\xe9tze', u'G\xf6tze'), (u'G\u20acfUhl6', u'Gef\xfchle'), (u'G\u20acStFUpp', u'Gestr\xfcpp'), (u"h<'>'r't", u'h\xf6rt'), (u"h<'5r", u'h\xf6r'), (u"h'a'lt", u'h\xe4lt'), (u"H'a'nde", u'H\xe4nde'), (u"H'a'nden", u'H\xe4nden'), (u"H'a'ttest", u'H\xe4ttest'), (u'H/', u'Hi'), (u'H/er', u'Hier'), (u'h/nfer', u'hinter'), (u'h5tte', u'h\xe4tte'), (u'H6fe', u'H\xf6fe'), (u'h6flich', u'h\xf6flich'), (u'H6fling', u'H\xf6fling'), (u'H6hen', u'H\xf6hen'), (u'h6her', u'h\xf6her'), (u'h6here', u'h\xf6here'), (u'H6HERER', u'H\xd6HERER'), (u'H6hle', u'H\xf6hle'), (u'H6l1e', u'H\xf6rte'), (u'H6lle', u'H\xf6lle'), (u'H6llen', u'H\xf6llen'), (u'h6lte', u'h\xf6rte'), (u'H6r', u'H\xf6r'), (u'h6re', u'h\xf6re'), (u'h6ren', u'h\xf6ren'), (u'H6rer', u'H\xf6rer'), (u'H6rner', u'H\xf6rner'), (u'h6rst', u'h\xf6rst'), (u'h6rt', u'h\xf6rt'), (u'h6rte', u'h\xf6rte'), (u'Ha/s', u'Hals'), (u'Haarbijrstel', u'Haarb\xfcrste!'), (u'Haarhfirste', u'Haarb\xfcrste'), (u'Haarl', u'Haar!'), (u'Haarstr\xe9hne', u'Haarstr\xe4hne'), (u"hab'jemanden", u"hab' jemanden"), (u'Hah', u'H\xe4h'), (u'halbstlllndiges', u'halbst\xfcndiges'), (u'halbvervvandelt', u'halbverwandelt'), (u'halfef', u'haltet'), (u'Hallfjchen', u'Hall\xf6chen'), (u'hallol', u'hallo!'), (u'Halsb\xe9nder', u'Halsb\xe4nder'), (u'Halsl', u'Hals!'), (u'haltenl', u'halten!'), (u'Haltjohnny', u'Halt Johnny'), (u'Hammersch\xe9del', u'Hammersch\xe4del'), (u'Handfl\xe9che', u'Handfl\xe4che'), (u'Handlungsstr\xe9nge', u'Handlungsstr\xe4nge'), (u'harfe', u'harte'), (u'hartn\xe9ickig', u'hartn\xe4ckig'), (u'Hasenful', u'Hasenfu\xdf'), (u'Hasenfull', u'Hasenfu\xdf'), (u'hassq', u'hasse'), (u'Hastja', u'Hast ja'), (u'hatjetzt', u'hat jetzt'), (u'hatta', u'hatte'), (u'Haupfbus', u'Hauptbus'), (u'Hauptaktion\xe9ire', u'Hauptaktion\xe4re'), (u'Hauptaktion\xe9irinnen', u'Hauptaktion\xe4rinnen'), (u'Hauptkabell', u'Hauptkabel!'), (u'haupts\xe9chlich', u'haupts\xe4chlich'), (u'haupts\xe9ichlich', u'haupts\xe4chlich'), (u'Haupttrib\ufb02ne', u'Haupttrib\xfcne'), (u'Hauptverschwiirer', u'Hauptverschw\xf6rer'), (u'Hauptwasserrohrwar', u'Hauptwasserrohr war'), (u'Hausfirzte', u'Haus\xe4rzte'), (u'Haush\xe9lterin', u'Haush\xe4lterin'), (u'Hausschlilssel', u'Hausschl\xfcssel'), (u'Haustilr', u'Haust\xfcr'), (u'Hausubervvachung', u'Haus\xfcberwachung'), (u'ha\xdft', u'hasst'), (u'Hbr', u'H\xf6r'), (u"hc'5ren", u'h\xf6ren'), (u"hc'\xa7r", u'h\xf6r'), (u'hdchsfens', u'h\xf6chstens'), (u'Hdchstleistung', u'H\xf6chstleistung'), (u'hdher', u'h\xf6her'), (u'Hdlle', u'H\xf6lle'), (u'Hdllenfeuer', u'H\xf6llenfeuer'), (u'hdre', u'h\xf6re'), (u'hdren', u'h\xf6ren'), (u'hdrsf', u'h\xf6rst'), (u'hdrten', u'horten'), (u'He/nr/ch', u'Heinrich'), (u'hedeutest', u'bedeutest'), (u'hegrfille', u'begr\xfc\xdfe'), (u'heiB', u'hei\xdf'), (u'heiBe', u'hei\xdfe'), (u'heiBen', u'hei\xdfen'), (u'HeiBer', u'Hei\xdfer'), (u'heiBes', u'hei\xdfes'), (u'heiBt', u'hei\xdft'), (u'heif$', u'hei\xdf'), (u'heif$e', u'hei\xdfe'), (u'heif$es', u'hei\xdfes'), (u'Heif$t', u'Hei\xdft'), (u'heif3>en', u'hei\xdfen'), (u'heif3t', u'hei\xdft'), (u'heif5en', u'hei\xdfen'), (u'heifie', u'hei\xdfe'), (u'heifiem', u'hei\xdfem'), (u'heifien', u'hei\xdfen'), (u'heifit', u'hei\xdft'), (u'heifkt', u'hei\xdft'), (u'heifLt', u'hei\xdft'), (u'heifZ>e', u'hei\xdfe'), (u"heil'$", u'hei\xdf'), (u"heil'$en", u'hei\xdfen'), (u"heil'$t", u'hei\xdft'), (u"heil'Se", u'hei\xdfe'), (u'heil2>en', u'hei\xdfen'), (u'heil2>t', u'hei\xdft'), (u'heil3en', u'hei\xdfen'), (u'heil3t', u'hei\xdft'), (u'heil5e', u'hei\xdfe'), (u'heil5t', u'hei\xdft'), (u'heili', u'hei\xdf'), (u'heilies', u'hei\xdfes'), (u'heilit', u'hei\xdft'), (u'heillst', u'hei\xdft'), (u'heilZ~', u'hei\xdft'), (u'heir$', u'hei\xdf'), (u'heisst', u'hei\xdft'), (u'Helllger', u'Heiliger'), (u'Helzlichen', u'Herzlichen'), (u"Hen'je", u'Herrje'), (u'herabstofien', u'herabsto\xdfen'), (u'heransttlrmtet', u'heranst\xfcrmtet'), (u'heraush\xe9ngendem', u'heraush\xe4ngendem'), (u'herhfiren', u'herh\xf6ren'), (u'herh\xe9ren', u'herh\xf6ren'), (u'heriiber', u'her\xfcber'), (u'HerrSchmidt', u'Herr Schmidt'), (u'herumf\xe9hrt', u'herumf\xe4hrt'), (u'herumkehren', u'herum kehren'), (u'herumlluft', u'heruml\xe4uft'), (u'herumzuwijhlen', u'herumzuw\xfchlen'), (u'Herzrhythmusst\xe9rungen', u'Herzrhythmusst\xf6rungen'), (u'Herzschlielierei', u'Herzschlie\xdferei'), (u'Herzstlllck', u'Herzst\xfcck'), (u'Heuta', u'Heute'), (u'Hexenhtltte', u'Hexenh\xfctte'), (u'HeY\xb7', u'Hey.'), (u'Hfibscheste', u'H\xfcbscheste'), (u'hfiherer', u'h\xf6herer'), (u'hfihsch', u'h\xfcbsch'), (u'Hfilfte', u'H\xe4fte'), (u'Hfille', u'H\xf6lle'), (u'hfilt', u'h\xe4lt'), (u'hfiltst', u'h\xe4ltst'), (u'Hfin', u'H\xf6rt'), (u'hfipft', u'h\xfcpft'), (u'Hfir', u'H\xf6r'), (u'hfiren', u'h\xf6ren'), (u'hfirst', u'h\xf6rst'), (u'hfirt', u'h\xf6rt'), (u'hfitte', u'h\xe4tte'), (u'hfitten', u'h\xe4tten'), (u'hie/3', u'hie\xdf'), (u'hieB', u'hie\xdf'), (u'hiefL', u'hie\xdf'), (u'hiel3', u'hie\xdf'), (u'hiells', u'hie\xdf'), (u'hierhergereist', u'hierher gereist'), (u'hierherzuriick', u'hierher zur\xfcck'), (u'hierijber', u'hier\xfcber'), (u'hierjede', u'hier jede'), (u'hierjeder', u'hier jeder'), (u'hierl', u'hier!'), (u'hierL', u'hie\xdf'), (u'hierwar', u'hier war'), (u'hierzum', u'hier-zum'), (u'hie\ufb02', u'hie\xdf'), (u'Hiibsch', u'H\xfcbsch'), (u'Hiibsche', u'H\xfcbsche'), (u'Hiibscher', u'H\xfcbscher'), (u'hiibschl', u'h\xfcbsch!'), (u'hiichst', u'h\xf6chst'), (u'hiichstens', u'h\xf6chstens'), (u'hiichster', u'h\xf6chster'), (u'hiichstpersiinlich', u'h\xf6chstpers\xf6nlich'), (u'Hiifen', u'H\xf6fen'), (u'hiifischen', u'h\xf6fischen'), (u'Hiifling', u'H\xf6fling'), (u'Hiigel', u'H\xfcgel'), (u'Hiihe', u'H\xf6he'), (u'Hiihepunkt', u'H\xf6hepunkt'), (u'hiiher', u'h\xf6her'), (u'hiihere', u'h\xf6here'), (u'Hiihlen', u'H\xf6hlen'), (u'Hiihnchen', u'H\xfchnchen'), (u'Hiihner', u'H\xfchner'), (u'Hiihnerkl\xe9fkchen', u'H\xfchnerkl\xf6\xdfchen'), (u'Hiilfte', u'H\xe4lfte'), (u'Hiille', u'H\xf6lle'), (u'Hiillenstreitmacht', u'H\xf6llenstreitmacht'), (u'hiillischen', u'h\xf6llischen'), (u'hiipfen', u'h\xfcpfen'), (u'Hiir', u'H\xf6r'), (u'hiire', u'h\xf6re'), (u'Hiiren', u'H\xf6ren'), (u'Hiirer', u'H\xf6rer'), (u'Hiiret', u'H\xf6ret'), (u'Hiirjetzt', u'H\xf6r jetzt'), (u'Hiirt', u'H\xf6rt'), (u'hiirte', u'h\xf6rte'), (u'hiirtest', u'h\xf6rtest'), (u'Hiissliches', u'H\xe4ssliches'), (u'Hiite', u'H\xfcte'), (u'Hiiten', u'H\xfcten'), (u'hiitet', u'h\xfctet'), (u'Hiitte', u'H\xe4tte'), (u'hiitten', u'h\xe4tten'), (u'Hiitten', u'H\xfctten'), (u'hijbsch', u'h\xfcbsch'), (u'hijbschen', u'h\xfcbschen'), (u'hijbsches', u'h\xfcbsches'), (u'Hijfte', u'H\xfcfte'), (u'Hijften', u'H\xfcften'), (u'Hijgel', u'H\xfcgel'), (u'Hijgels', u'H\xfcgels'), (u'Hijpfburgl', u'H\xfcpfburg!'), (u'hijpfe', u'h\xfcpfe'), (u'hijpfen', u'h\xfcpfen'), (u'hijre', u'h\xf6re'), (u'Hijren', u'H\xf6ren'), (u'Hijrer', u'H\xf6rer'), (u'hilbsch', u'h\xfcbsch'), (u'hilbsche', u'h\xfcbsche'), (u'hilbschen', u'h\xfcbschen'), (u'hilbscher', u'h\xfcbscher'), (u'Hilfel', u'Hilfe!'), (u'HILFSPERSONALI', u'HILFSPERSONAL:'), (u'Hilgel', u'H\xfcgel'), (u'hillig', u'billig'), (u'Hilt', u'H\xe4lt'), (u'hil\ufb02', u'hilft'), (u'Him', u'Hirn'), (u'Himmell', u'Himmel!'), (u'hineintr\xe9umen', u'hineintr\xe4umen'), (u'hinfijhrt', u'hinf\xfchrt'), (u'hingefiihrt', u'hingef\xfchrt'), (u'hingehdren', u'hingeh\xf6ren'), (u'hingehiiren', u'hingeh\xf6ren'), (u'hinilber', u'hin\xfcber'), (u'hinreiliend', u'hinrei\xdfend'), (u'hinschmeifit', u'hinschmei\xdft'), (u'HintenN\xe4ldler', u'Hinterw\xe4ldler'), (u'Hintergrundl\xe9rm', u'Hintergrundl\xe4rm'), (u'hinterhfiltig', u'hinterh\xe4ltig'), (u'hinterh\xe9iltiger', u'hinterh\xe4ltiger'), (u'Hinterh\xe9iltigl', u'Hinterh\xe4ltig!'), (u'hinterh\xe9ltige', u'hinterh\xe4ltige'), (u'hinterh\xe9ltiger', u'hinterh\xe4ltiger'), (u'Hinterk\xe9pfen', u'Hinterk\xf6pfen'), (u'hinterlieBe', u'hinterlie\xdfe'), (u'hinterl\xe9sst', u'hinterl\xe4sst'), (u'Hintersttlbchen', u'Hinterst\xfcbchen'), (u'Hintertur', u'Hintert\xfcr'), (u'hinwollen', u'hin wollen'), (u'hinzufuhren', u'hinzuf\xfchren'), (u'hinzuf\ufb02gten', u'hinzuf\xfcgten'), (u'Hirnrnel', u'Himmel'), (u'hirteste', u'h\xe4rteste'), (u'hisslich', u'h\xe4sslich'), (u'Hi\xe9tte', u'H\xe4tte'), (u'Hler', u'Her'), (u'hler', u'hier'), (u'hllf', u'hilf'), (u'hllibsch', u'h\xfcbsch'), (u'Hllindinnen', u'H\xfcndinnen'), (u'Hlllpf', u'H\xfcpf'), (u'hln', u'hin'), (u'Hlnbllck', u'Hinblick'), (u'hltte', u'h\xe4tte'), (u'Hltten', u'H\xe4tten'), (u'Hochfrequenzst\xe9rungenl', u'Hochfrequenzst\xf6rungen!'), (u'hochl', u'hoch!'), (u'Hochsicherheitsgef\xe9ngnis', u'Hochsicherheitsgef\xe4ngnis'), (u'Hochstens', u'H\xf6chstens'), (u'Hochzeitskostiime', u'Hochzeitskost\xfcme'), (u'Hohek', u'Hoheit'), (u'Hohepunkt', u'H\xf6hepunkt'), (u'hohere', u'h\xf6here'), (u'HoHo', u'Hoho'), (u'Holle', u'H\xf6lle'), (u'Holzsttlck', u'Holzst\xfcck'), (u'hor', u'h\xf6r'), (u'Horen', u'H\xf6ren'), (u'Hosenscheifker', u'Hosenschei\xdfer'), (u'Hosenscheiiker', u'Hosenschei\xdfer'), (u'Hosenschei\ufb02er', u'Hosenschei\xdfer'), (u'Hotelg\xe9ste', u'Hotelg\xe4ste'), (u'HQHE', u'H\xd6HE'), (u'htibscher', u'h\xfcbscher'), (u'Htihnchen', u'H\xfchnchen'), (u'Htipfen', u'H\xfcpfen'), (u'Htipfenl', u'H\xfcpfen!'), (u'htiren', u'h\xf6ren'), (u'hubsch', u'h\xfcbsch'), (u'hubsche', u'h\xfcbsche'), (u'hubschen', u'h\xfcbschen'), (u'Hubscher', u'H\xfcbscher'), (u'hubscheres', u'h\xfcbscheres'), (u'Hubsches', u'H\xfcbsches'), (u'Huhner', u'H\xfchner'), (u'humon/oll', u'humorvoll'), (u'Hundchen', u'H\xfcndchen'), (u'Hundebullel', u'Hundebulle!'), (u'Hunden\xe9pfe', u'Hunden\xe4pfe'), (u'Hundescheilie', u'Hundeschei\xdfe'), (u'Hundl', u'Hund!'), (u'HUNG', u'H\xfclle'), (u'hunte', u'bunte'), (u'Hurensiihne', u'Hurens\xf6hne'), (u'Hurensohnl', u'Hurensohn!'), (u'Huterin', u'H\xfcterin'), (u'HUtte', u'H\xfctte'), (u'Hypoglyk\xe9mie', u'Hypoglyk\xe4mie'), (u'h\xe9', u'h\xe4'), (u'H\xe9chste', u'H\xf6chste'), (u'h\xe9chsten', u'h\xf6chsten'), (u'H\xe9chstens', u'H\xf6chstens'), (u'H\xe9chstpers\xe9nlich', u'H\xf6chstpers\xf6nlich'), (u'H\xe9fen', u'H\xe4fen'), (u'h\xe9flich', u'h\xf6flich'), (u'H\xe9ftling', u'H\xe4ftling'), (u'H\xe9ftlinge', u'H\xe4ftlinge'), (u'H\xe9ftlingsr\xe9te', u'H\xe4ftlingsr\xe4te'), (u'H\xe9hef', u'H\xf6he!'), (u'H\xe9hepunkt', u'H\xf6hepunkt'), (u'h\xe9her', u'h\xf6her'), (u'h\xe9heren', u'h\xf6heren'), (u'H\xe9i', u'H\xe4'), (u'H\xe9ifen', u'H\xe4fen'), (u'H\xe9ilften', u'H\xe4lften'), (u'h\xe9iltst', u'h\xe4ltst'), (u'H\xe9inde', u'H\xe4nde'), (u'h\xe9ing', u'h\xe4ng'), (u'h\xe9ingen', u'h\xe4ngen'), (u'h\xe9ingt', u'h\xe4ngt'), (u'h\xe9ir', u'h\xf6r'), (u'h\xe9irter', u'h\xe4rter'), (u'h\xe9itt', u'h\xe4tt'), (u'H\xe9itte', u'H\xe4tte'), (u'h\xe9itten', u'h\xe4tten'), (u'h\xe9ittest', u'h\xe4ttest'), (u'h\xe9iufig', u'h\xe4ufig'), (u'H\xe9lfte', u'H\xe4lfte'), (u'H\xe9lle', u'H\xf6lle'), (u'H\xe9llen', u'H\xf6llen'), (u'H\xe9llenloch', u'H\xf6llenloch'), (u'h\xe9llisch', u'h\xf6llisch'), (u'h\xe9llische', u'h\xf6llische'), (u'h\xe9lt', u'h\xe4lt'), (u'H\xe9ltst', u'H\xe4ltst'), (u'h\xe9lzernes', u'h\xf6lzernes'), (u'h\xe9misch', u'h\xe4misch'), (u'H\xe9mmer', u'H\xe4mmer'), (u'h\xe9mmernde', u'h\xe4mmernde'), (u'H\xe9moglobin', u'H\xe4moglobin'), (u'H\xe9morrhoiden', u'H\xe4morrhoiden'), (u'H\xe9ndchen', u'H\xe4ndchen'), (u'H\xe9nde', u'H\xe4nde'), (u'H\xe9ndedruck', u'H\xe4ndedruck'), (u'H\xe9nden', u'H\xe4nden'), (u'H\xe9ndlerin', u'H\xe4ndlerin'), (u'h\xe9ng', u'h\xe4ng'), (u'h\xe9ngen', u'h\xe4ngen'), (u'h\xe9ngend', u'h\xe4ngend'), (u'h\xe9ngst', u'h\xe4ngst'), (u'h\xe9ngt', u'h\xe4ngt'), (u'H\xe9r', u'H\xf6r'), (u'h\xe9re', u'h\xf6re'), (u'h\xe9ren', u'h\xf6ren'), (u'H\xe9rgesch\xe9idigte', u'H\xf6rgesch\xe4digte'), (u'h\xe9rst', u'h\xf6rst'), (u'h\xe9rt', u'h\xf6rt'), (u'h\xe9rte', u'h\xf6rte'), (u'h\xe9rten', u'h\xf6rten'), (u'h\xe9rter', u'h\xe4rter'), (u'H\xe9rzu', u'H\xf6r zu'), (u'H\xe9schen', u'Haschen'), (u'h\xe9sslich', u'h\xe4sslich'), (u'h\xe9sslicher', u'h\xe4sslicher'), (u'h\xe9sslichl', u'h\xe4sslich'), (u'h\xe9sslichste', u'h\xe4sslichste'), (u'h\xe9tt', u'h\xe4tt'), (u'H\xe9tte', u'H\xe4tte'), (u'h\xe9tten', u'h\xe4tten'), (u"h\xe9tten's", u"h\xe4tten's"), (u'h\xe9ttest', u'h\xe4ttest'), (u'H\xe9ttet', u'H\xe4ttet'), (u'H\xe9ufi', u'H\xe4ufi'), (u'h\xe9ufig', u'h\xe4ufig'), (u'h\xe9ufiger', u'h\xe4ufiger'), (u'H\xe9ufigkeit', u'H\xe4ufigkeit'), (u'h\xe9ufigsten', u'h\xe4ufigsten'), (u'H\xe9user', u'H\xe4user'), (u'H\xe9usern', u'H\xe4usern'), (u'h\xe9ute', u'h\xe4ute'), (u'H\u20acY', u'Hey'), (u'H\ufb02geln', u'H\xfcgeln'), (u"i'\xa7ffne", u'\xd6ffne'), (u'I/egen', u'liegen'), (u'I5sst', u'l\xe4sst'), (u'I5stern', u'l\xe4stern'), (u'I6sen', u'l\xf6sen'), (u'Ia\xdf', u'lass'), (u'Ia\xdft', u'lasst'), (u'Icll', u'Ich'), (u'identifizieet', u'identifiziert'), (u'IDENTITAT', u'IDENTIT\xc4T'), (u'IE', u'I\xdf'), (u'Iebendigl', u'lebendig!'), (u'Iebenslinglich', u'lebensl\xe4glich'), (u'Iebtjetzt', u'lebt jetzt'), (u'Ieck', u'leck'), (u'Iehn', u'lehn'), (u'Ieid\u201a', u'leid\u201a'), (u'Ieinenlose', u'leinenlose'), (u'Ienistische', u'leninistische'), (u'Ietztendlich', u'letztendlich'), (u'Ifigt', u'l\xfcgt'), (u'Ihrdllirft', u'Ihr d\xfcrft'), (u'ihrja', u'ihr ja'), (u'ihrjemals', u'ihr jemals'), (u'ihrjetzt', u'ihr jetzt'), (u'ihrjeweiliges', u'ihr jeweiliges'), (u'ihrVater', u'ihr Vater'), (u'ihrvorstrafenregister', u'ihr Vorstrafenregister'), (u'ihrwahres', u'ihr wahres'), (u'Ihrwerdet', u'Ihr werdet'), (u'ihrzwei', u'ihr zwei'), (u'iibel', u'\xfcbel'), (u'iibemehmen', u'\xfcbernehmen'), (u'iiber', u'\xfcber'), (u'iiberall', u'\xfcberall'), (u'iiberallhin', u'\xfcberallhin'), (u'iiberdauern', u'\xfcberdauern'), (u'iiberdauerte', u'\xfcberdauerte'), (u'iibereinstimmte', u'\xfcbereinstimme'), (u'iiberfallen', u'\xfcberfallen'), (u'iiberfiel', u'\xfcberfiel'), (u'iibergeben', u'\xfcbergeben'), (u'iiberhaupt', u'\xfcberhaupt'), (u'iiberhiirt', u'\xfcberh\xf6rt'), (u'iiberholt', u'\xfcberholt'), (u'iiberholter', u'\xfcberholter'), (u'iiberkam', u'\xfcberkam'), (u'iiberlassen', u'\xfcberlassen'), (u'iiberleben', u'\xfcberleben'), (u'iiberlebt', u'\xfcberlebt'), (u'iiberlegen', u'\xfcberlegen'), (u'iiberlegten', u'\xfcberlegten'), (u'iibernahmen', u'\xfcbernahmen'), (u'iibernehme', u'\xfcbernehme'), (u'iibernehmen', u'\xfcbernehmen'), (u'iibernimmt', u'\xfcbernimmt'), (u'iibernommen', u'\xfcbernommen'), (u'iiberpriife', u'\xfcberpr\xfcfe'), (u'iiberpriifen', u'\xfcberpr\xfcfen'), (u'iiberpriift', u'\xfcberpr\xfcft'), (u'iiberpriiften', u'\xfcberpr\xfcften'), (u'iiberqueren', u'\xfcberqueren'), (u'iiberragen', u'\xfcberragen'), (u'iiberrascht', u'\xfcberrascht'), (u'iiberraschte', u'\xfcberraschte'), (u'iiberreden', u'\xfcberreden'), (u'iiberschritten', u'\xfcberschritten'), (u'iibersetzen', u'\xfcbersetzen'), (u'iibersetzt', u'\xfcbersetzt'), (u'iibersteigt', u'\xfcbersteigt'), (u'iibertragen', u'\xfcbertragen'), (u'iibertreffen', u'\xfcbertreffen'), (u'iibertreib', u'\xfcbertreib'), (u'iibertreiben', u'\xfcbertreiben'), (u'iibertrieben', u'\xfcbertrieben'), (u'iiberzeugen', u'\xfcberzeugen'), (u'iiberzeugt', u'\xfcberzeugt'), (u'iiblich', u'\xfcblich'), (u'iibliche', u'\xfcbliche'), (u'iibrig', u'\xfcbrig'), (u'IieB', u'lie\xdf'), (u'Iiebte', u'liebte'), (u"Iief's", u"lief's"), (u'Iiehe', u'liebe'), (u'Iie\ufb02est', u'lie\xdfest'), (u'iiffentlichen', u'\xf6ffentlichen'), (u'iiffentliches', u'\xf6ffentliches'), (u'iiffnest', u'\xf6ffnest'), (u'iifter', u'\xf6fter'), (u'iihnllchkelt', u'\xc4hnllchkelt'), (u'Iisst', u'l\xe4sst'), (u'ijbel', u'\xfcbel'), (u'ijben', u'\xfcben'), (u'ijberall', u'\xfcberall'), (u'ijberhaupt', u'\xfcberhaupt'), (u'ijberlegene', u'\xfcberlegene'), (u'ijbernehme', u'\xfcbernehme'), (u'ijbernimmst', u'\xfcbernimmst'), (u'ijberprijfen', u'\xfcberpr\xfcfen'), (u'ijberreden', u'\xfcberreden'), (u'ijbertrage', u'\xfcbertrage'), (u'ijberwunden', u'\xfcberwunden'), (u'ijberzeugen', u'\xfcberzeugen'), (u'ijberzogen', u'\xfcberzogen'), (u'Il6her', u'h\xf6her'), (u'IleiB', u'hei\xdf'), (u'Ill', u'III'), (u'Illfie', u'Wie'), (u'Ilrger', u'\xc4rger'), (u'Ilufierste', u'\xc4u\xdferste'), (u'immerja', u'immer ja'), (u'immerjung', u'immer jung'), (u'immerweinen', u'immer weinen'), (u'immerw\xe4hrende', u'immer w\xe4hrende'), (u'immerw\xe9hrende', u'immerw\xe4hrende'), (u'Improvisiation', u'Improvisation'), (u'Impulswellengeschutz', u'Impulswellengesch\xfctz'), (u'INBRUNSTIGE', u'INBR\xdcNSTIGE'), (u'instfindig', u'inst\xe4ndig'), (u'intramuskul\xe9r', u'intramuskul\xe4r'), (u'INVASIONSFLOTFE', u'INVASIONSFLOTTE'), (u'Iosgeliist', u'losgel\xf6st'), (u'Iosgel\xe9st', u'losgel\xf6st'), (u'Ioszuliisen', u'loszul\xf6sen'), (u'ip', u'in'), (u'irn', u'im'), (u'irrefuhren', u'irref\xfchren'), (u'irrefuhrende', u'irref\xfchrende'), (u'istja', u'ist ja'), (u'istjedoch', u'ist jedoch'), (u'istjemand', u'ist jemand'), (u'istjetzt', u'ist jetzt'), (u'istJohnny', u'ist Johnny'), (u'istjung', u'ist jung'), (u'istweg', u'ist weg'), (u'ITIUSSEFI', u'm\xfcssen'), (u'ITIUSSGI7', u'm\xfcssen'), (u'ITTITTRZ', u'Danke.'), (u'Ivl\xe9gliche', u'M\xf6gliche'), (u'I\xe9cheln', u'l\xe4cheln'), (u'I\xe9cherlich', u'l\xe4cherlich'), (u'I\xe9cherlichen', u'l\xe4cherlichen'), (u'I\xe9hmt', u'l\xe4hmt'), (u'I\xe9iuft', u'l\xe4uft'), (u'I\xe9nger', u'l\xe4nger'), (u'I\xe9sst', u'l\xe4sst'), (u'I\xe9sste', u'l\xe4sste'), (u'I\xe9uft', u'l\xe4uft'), (u'J0Shua', u'Joshua'), (u'Jackettkaufen', u'Jackett kaufen'), (u'jahr', u'Jahr'), (u'jahre', u'Jahre'), (u'jahren', u'Jahren'), (u'JAHRIGE', u'J\xc4HRIGE'), (u'jal', u'ja!'), (u'jemandenl', u'jemanden!'), (u'jetztl', u'jetzt!'), (u'jiidisch', u'j\xfcdisch'), (u'Jiingem', u'J\xfcngern'), (u'jiingerwar', u'j\xfcnger war'), (u'Jiingste', u'J\xfcngste'), (u'jilnger', u'j\xfcnger'), (u'Jlllngling', u'J\xfcngling'), (u'job', u'Job'), (u'Jogglng', u'Jogging'), (u'john', u'John'), (u'johnny', u'Johnny'), (u'journalisten', u'Journalisten'), (u'Jullo', u'Julie'), (u'JUNGFRAULICHE', u'JUNGFR\xc4ULICHE'), (u'jungfr\xe9uliche', u'jungfr\xe4uliche'), (u'jungfr\xe9ulichen', u'jungfr\xe4ulichen'), (u'jungfr\xe9ulicher', u'jungfr\xe4ulicher'), (u'Jungfr\xe9ulichkeit', u'Jungfr\xe4ulichkeit'), (u'Jungsl', u'Jungs!'), (u'Jungste', u'J\xfcngste'), (u'Jurlgs', u'Jungs'), (u'Justitzministeriums', u'Justizministeriums'), (u'J\xe9ger', u'J\xe4ger'), (u'J\xe9hrige', u'J\xe4hrige'), (u'j\xe9hrigen', u'j\xe4hrigen'), (u'j\xe9hriger', u'j\xe4hriger'), (u'j\xe9hrlich', u'j\xe4hrlich'), (u'J\xe9iger', u'J\xe4ger'), (u'j\xe9ihrigen', u'j\xe4hrigen'), (u'j\xe9mmerlich', u'j\xe4mmerlich'), (u"k'a'mpfen", u'k\xe4mpfen'), (u'K/no', u'Kino'), (u'K/Varte', u'Warte'), (u'K/Velle', u'Welle'), (u'K5NIGIN', u'K\xd6NIGIN'), (u'K6der', u'K\xf6der'), (u'K6ln', u'K\xf6ln'), (u'K6nig', u'K\xf6nig'), (u'K6nige', u'K\xf6nige'), (u'K6nigin', u'K\xf6nigin'), (u'k6nnen', u'k\xf6nnen'), (u"k6nnen's", u"k\xf6nnen's"), (u'k6nnest', u'k\xf6nntest'), (u'k6nnt', u'k\xf6nnt'), (u'K6nnte', u'K\xf6nnte'), (u"k6nnte's", u"k\xf6nnte's"), (u'k6nnten', u'k\xf6nnten'), (u'k6nntest', u'k\xf6nntest'), (u'K6pfe', u'K\xf6pfe'), (u'K6rper', u'K\xf6rper'), (u'K6rpers', u'K\xf6rpers'), (u'K6stlich', u'K\xf6stlich'), (u'Kabelm\xe9nner', u'Kabelm\xe4nner'), (u'kalf', u'kalt'), (u'kaltblijtig', u'kaltbl\xfctig'), (u'kampfen', u'k\xe4mpfen'), (u'Kampfj\xe9ger', u'Kampfj\xe4ger'), (u'Kanarienviigeln', u'Kanarienv\xf6geln'), (u"kann'sja", u"kann's ja"), (u'kannstja', u'kannst ja'), (u'Kan\xe9len', u'Kan\xe4len'), (u'Kapitan', u'Kapit\xe4n'), (u'Kapitln', u'Kapit\xe4n'), (u'Kapitlnen', u'Kapit\xe4nen'), (u'Kapitlns', u'Kapit\xe4ns'), (u'Kapit\xe9in', u'Kapit\xe4n'), (u'Kapit\xe9inleutnant', u'Kapit\xe4nleutnant'), (u'Kapit\xe9ins', u'Kapit\xe4ns'), (u'Kapit\xe9n', u'Kapit\xe4n'), (u'Kapit\xe9nleutnant', u'Kapit\xe4nleutnant'), (u'Kapit\xe9ns', u'Kapit\xe4ns'), (u"Kapt'n", u"K\xe4pt'n"), (u'kaputthaust', u'kaputt haust'), (u'Kartoffelsch\xe9len', u'Kartoffelsch\xe4len'), (u'Kassettenger\xe9it', u'Kassettenger\xe4t'), (u'kbnnen', u'k\xf6nnen'), (u'kbnnten', u'k\xf6nnten'), (u'kdnnen', u'k\xf6nnen'), (u'kdnnfe', u'k\xf6nnte'), (u'kdnnte', u'k\xf6nnte'), (u'ke/ne', u'keine'), (u'Kefn', u'Kein'), (u'Keh/1', u'Kehrt'), (u'Keithl', u'Keith!'), (u'keln', u'kein'), (u'kelne', u'keine'), (u'Keri', u'Kerl'), (u'kfime', u'k\xe4me'), (u'Kfimmer', u'K\xfcmmer'), (u'kfimmere', u'k\xfcmmere'), (u'kfimmern', u'k\xfcmmern'), (u'kfimmert', u'k\xfcmmert'), (u'kfimpft', u'k\xe4mpft'), (u'kfimpften', u'k\xe4mpften'), (u'Kfinig', u'K\xf6nig'), (u'Kfinnen', u'K\xf6nnen'), (u'kfinnte', u'k\xf6nnte'), (u'Kfinnten', u'K\xf6nnten'), (u'Kfinntest', u'K\xf6nntest'), (u'Kfiss', u'K\xfcss'), (u'Kfisschen', u'K\xfcsschen'), (u'Kfissen', u'K\xfcssen'), (u'Kfjnnte', u'K\xf6nnte'), (u'Khnlichkeit', u'\xc4hnlichkeit'), (u'KIar', u'Klar'), (u'Kifig', u'K\xe4fig'), (u'Kiiche', u'K\xfcche'), (u'Kiichenhelfer', u'K\xfcchenhelfer'), (u'Kiichln', u'K\xf6chin'), (u'Kiihe', u'K\xfche'), (u'Kiihlbox', u'K\xfchlbox'), (u'kiihler', u'k\xfchler'), (u'Kiihlschrank', u'K\xfchlschrank'), (u'kiimmem', u'k\xfcmmern'), (u'kiimmer', u'k\xfcmmer'), (u'kiimmere', u'k\xfcmmere'), (u'Kiimmern', u'K\xfcmmern'), (u'kiindigen', u'k\xfcndigen'), (u'Kiinig', u'K\xf6nig'), (u'Kiinige', u'K\xf6nige'), (u'Kiinigen', u'K\xf6nigen'), (u'Kiinigin', u'K\xf6nigin'), (u'Kiiniginnen', u'K\xf6niginnen'), (u'kiinigliche', u'k\xf6nigliche'), (u'kiiniglichen', u'k\xf6niglichen'), (u'kiiniglicher', u'k\xf6niglicher'), (u'Kiinigreichs', u'K\xf6nigreichs'), (u'Kiinigs', u'K\xf6nigs'), (u'Kiinigtum', u'K\xf6nigtum'), (u'kiinne', u'k\xf6nne'), (u'kiinnen', u'k\xf6nnen'), (u'kiinnt', u'k\xf6nnt'), (u'Kiinnte', u'K\xf6nnte'), (u'kiinnten', u'k\xf6nnten'), (u'kiinntest', u'k\xf6nntest'), (u'kiinntet', u'k\xf6nntet'), (u'Kiinstler', u'K\xfcnstler'), (u'kiinstlerischen', u'k\xfcnstlerischen'), (u'kiipfen', u'k\xf6pfen'), (u'Kiirper', u'K\xf6rper'), (u'Kiirperfunktionen', u'K\xf6rperfunktionen'), (u'Kiirperhaltung', u'K\xf6rperhaltung'), (u'kiirperliche', u'k\xf6rperliche'), (u'Kiirperliches', u'K\xf6rperliches'), (u'Kiirpersprache', u'K\xf6rpersprache'), (u'Kiirperverletzung', u'K\xf6rperverletzung'), (u'kiirzen', u'k\xfcrzen'), (u'kiirzerzutreten', u'k\xfcrzerzutreten'), (u'kiirzeste', u'k\xfcrzeste'), (u'Kiisschen', u'K\xfcsschen'), (u'Kiissen', u'K\xfcssen'), (u'Kiisst', u'K\xfcsst'), (u'Kiiste', u'K\xfcste'), (u'kiistlich', u'k\xf6stlich'), (u'Kijche', u'K\xfcche'), (u'Kijhlschrank', u'K\xfchlschrank'), (u'Kijmmere', u'K\xfcmmere'), (u'kijmmern', u'k\xfcmmern'), (u'kijmmernl', u'k\xfcmmern!'), (u'kijmmerst', u'k\xfcmmerst'), (u'kijmmerten', u'k\xfcmmerten'), (u'kijndigt', u'k\xfcndigt'), (u'kijnnen', u'k\xf6nnen'), (u'kijnnt', u'k\xf6nnt'), (u'kijnnte', u'k\xf6nnte'), (u'kijnnten', u'k\xf6nnten'), (u'Kijnstler', u'K\xfcnstler'), (u'Kijrbis', u'K\xfcrbis'), (u'kijrzlich', u'k\xfcrzlich'), (u'kijrzliche', u'k\xfcrzliche'), (u'Kijrzungen', u'K\xfcrzungen'), (u'kijsst', u'k\xfcsst'), (u'Kijste', u'K\xfcste'), (u'Kilche', u'K\xfcche'), (u'Kilchlein', u'K\xfcchlein'), (u'kilhlen', u'k\xfchlen'), (u'kilhler', u'k\xfchler'), (u'Kilhlkreislauf', u'K\xfchlkreislauf'), (u'Kilhlschrank', u'K\xfchlschrank'), (u'Kilmmern', u'K\xfcmmern'), (u'Kilmmert', u'K\xfcmmert'), (u'kilndigen', u'k\xfcndigen'), (u'kilnstliche', u'k\xfcnstliche'), (u'kilss', u'k\xfcss'), (u'kilsse', u'k\xfcsse'), (u'kilssen', u'k\xfcssen'), (u'Kinderm\xe9dchen', u'Kinderm\xe4dchen'), (u'Kinderspiell', u'Kinderspiel!'), (u'Kindsk\xe9pfe', u'Kindsk\xf6pfe'), (u'kiokflip', u'kickflip'), (u'KIotz', u'Klotz'), (u"KL'lr", u'K\xfcr'), (u"KL'lste", u'K\xfcste'), (u'Klapsmiihle', u'Klapsm\xfchle'), (u'Klassem\xe9dchen', u'Klassem\xe4dchen'), (u'kle/ne', u'kleine'), (u'Kleidergr6Be', u'Kleidergr\xf6\xdfe'), (u'Kleidergrfilie', u'Kleidergr\xf6\xdfe'), (u'Kleinerl', u'Kleiner!'), (u'kleinwiichsige', u'kleinw\xfcchsige'), (u'kleinwilchsiges', u'kleinw\xfcchsiges'), (u'klijger', u'kl\xfcger'), (u'klijgsten', u'kl\xfcgsten'), (u'klilger', u'kl\xfcger'), (u"kLinft'gen", u"k\xfcnft'gen"), (u'klirst', u'kl\xe4rst'), (u'kljmmere', u'k\xfcmmere'), (u'Kllirze', u'K\xfcrze'), (u'kllissen', u'k\xfcssen'), (u'Klliste', u'K\xfcste'), (u'Klllche', u'K\xfcche'), (u'klllhnsten', u'k\xfchnsten'), (u'kllllger', u'kl\xfcger'), (u'Klobtlrsten', u'Klob\xfcrsten'), (u'klop\ufb02l', u'klopft!'), (u"Klpt'n", u"K\xe4pt'n"), (u"Klpt'nl", u"K\xe4pt'n!"), (u"Klpt'ns", u"K\xe4pt'ns"), (u'Klse', u'K\xe4se'), (u'Klseschnuffelei', u'K\xe4seschn\xfcffelei'), (u'Kltigste', u'Kl\xfcgste'), (u'Klugschei\ufb02er', u'Klugschei\xdfer'), (u'kl\xe9ffen', u'kl\xe4ffen'), (u'Kl\xe9iren', u'Kl\xe4ren'), (u'Kl\xe9ranlage', u'Kl\xe4ranlage'), (u'Kl\xe9re', u'Kl\xe4re'), (u'kl\xe9ren', u'kl\xe4ren'), (u'Kn6pf', u'Kn\xf6pf'), (u'Knallttite', u'Knallt\xfcte'), (u'Knastwill', u'Knast will'), (u'Knderung', u'\xc4nderung'), (u'Knochengrfinde', u'Knochengr\xfcnde'), (u'Knofen', u'Knoten'), (u'Knuller', u'Kn\xfcller'), (u'Knupf', u'Kn\xfcpf'), (u'Knupfe', u'Kn\xfcpfe'), (u'knupfen', u'kn\xfcpfen'), (u'knzjipfe', u'kn\xfcpfe'), (u'Kn\xe9dell', u'Kn\xf6del!'), (u'kn\xe9pf', u'kn\xf6pf'), (u'Kn\xe9pfe', u'Kn\xf6pfe'), (u'Kn\xe9sten', u'Kn\xe4sten'), (u'Kofferraumschliissel', u'Kofferraumschl\xfcssel'), (u'Kohlens\xe9ure', u'Kohlens\xe4ure'), (u'Komaf\xe9lle', u'Komaf\xe4lle'), (u'Komaf\xe9llen', u'Komaf\xe4llen'), (u'Kombiise', u'Komb\xfcse'), (u'Kombuse', u'Komb\xfcse'), (u'Komiidie', u'Kom\xf6die'), (u'kommerz/ellen', u'kommerziellen'), (u'kommjetzt', u'komm jetzt'), (u'Kompatibilitfits', u'Kompatibilit\xe4ts'), (u'Kompatibilit\xe9its', u'Kompatibilit\xe4ts'), (u'Kompatiblit5ts', u'Kompatiblit\xe4ts'), (u'Kom\xe9die', u'Kom\xf6die'), (u'KONIGIN', u'K\xd6NIGIN'), (u'konne', u'k\xf6nne'), (u'konnen', u'k\xf6nnen'), (u'konnt', u'k\xf6nnt'), (u'konsen/ativ', u'konservativ'), (u'Kopfabreifimann', u'Kopfabrei\xdfmann'), (u'Kopfgeldj\xe9ger', u'Kopfgeldj\xe4ger'), (u'Kopfgeldj\xe9gern', u'Kopfgeldj\xe4gern'), (u'Kopfm\xe9fiig', u'Kopfm\xe4\xdfig'), (u'Kopfnijsse', u'Kopfn\xfcsse'), (u'kostengtlnstige', u'kosteng\xfcnstige'), (u'Kostiim', u'Kost\xfcm'), (u'Kostiimdesigner', u'Kost\xfcmdesigner'), (u'Kostiimdesignerin', u'Kost\xfcmdesignerin'), (u'Kostiimdrama', u'Kost\xfcmdrama'), (u'Kostiime', u'Kost\xfcme'), (u'Kostiims', u'Kost\xfcms'), (u'Kostume', u'Kost\xfcme'), (u'Kost\ufb02m', u'Kost\xfcm'), (u'kr/egen', u'kriegen'), (u'kr6ne', u'kr\xf6ne'), (u'kr6nen', u'kr\xf6nen'), (u'Kr6ten', u'Kr\xf6ten'), (u'Krafte', u'Kr\xe4fte'), (u'Kraftwfirfel', u'Kraftw\xfcrfel'), (u'Kranf\ufb02hrer', u'Kranf\xfchrer'), (u'Kreativit\xe9t', u'Kreativit\xe4t'), (u'Kreuzverhor', u'Kreuzverh\xf6r'), (u'krfiftiger', u'kr\xe4ftiger'), (u'Krfiutertee', u'Kr\xe4utertee'), (u'Kriegserkl\xe9rungen', u'Kriegserkl\xe4rungen'), (u'Kriegsfuhrung', u'Kriegsf\xfchrung'), (u'Kriegsschauplatze', u'Kriegsschaupl\xe4tze'), (u'Kriifte', u'Kr\xe4fte'), (u'Kriinung', u'Kr\xf6nung'), (u'Kriinungsfeier', u'Kr\xf6nungsfeier'), (u'Krijppel', u'Kr\xfcppel'), (u'Krijte', u'Kr\xf6te'), (u'Kronjuwell', u'Kronjuwel!'), (u'KROTE', u'KR\xd6TE'), (u'Krsche', u'\xc4rsche'), (u'Kr\xe9fte', u'Kr\xe4fte'), (u'Kr\xe9ften', u'Kr\xe4ften'), (u'Kr\xe9ftigsten', u'Kr\xe4ftigsten'), (u'Kr\xe9he', u'Kr\xe4he'), (u'kr\xe9ht', u'kr\xe4ht'), (u'kr\xe9ichzt', u'kr\xe4chzt'), (u'Kr\xe9ifte', u'Kr\xe4fte'), (u'Kr\xe9iutertee', u'Kr\xe4utertee'), (u'Kr\xe9mpfe', u'Kr\xe4mpfe'), (u'kr\xe9nte', u'kr\xf6nte'), (u'Kr\xe9te', u'Kr\xf6te'), (u'Kr\xe9tes', u'Kr\xf6tes'), (u'Kr\xe9utern', u'Kr\xe4utern'), (u'Kr\xe9utersenf', u'Kr\xe4utersenf'), (u'Ktiche', u'K\xfcche'), (u'Ktinige', u'K\xf6nige'), (u'ktinntest', u'k\xf6nntest'), (u'Ktisschen', u'K\xfcsschen'), (u'ktlmmere', u'k\xfcmmere'), (u'ktznnen', u'k\xf6nnen'), (u'Kuche', u'K\xfcche'), (u'KUCHE', u'K\xdcCHE'), (u'Kuckucksger\xe9usch', u'Kuckucksger\xe4usch'), (u"KUl'ZSCl'1lUSS9", u'K\xfcrzschl\xfcsse'), (u'kulz', u'kurz'), (u'kummer', u'k\xfcmmer'), (u'Kummere', u'K\xfcmmere'), (u'kummern', u'k\xfcmmern'), (u'kummert', u'k\xfcmmert'), (u'Kumpell', u'Kumpel!'), (u'Kunststficke', u'Kunstst\xfccke'), (u'Kunststticke', u'Kunstst\xfccke'), (u'Kuriosit\xe9ten', u'Kuriosit\xe4ten'), (u'kurzeste', u'k\xfcrzeste'), (u'kurzte', u'k\xfcrzte'), (u'Kurzwellenfunkger\xe9te', u'Kurzwellenfunkger\xe4te'), (u'Kurzzeitgediichtnis', u'Kurzzeitged\xe4chtnis'), (u'Kurzzeitged\xe9chtnis', u'Kurzzeitged\xe4chtnis'), (u'KUS1I\u20ac', u'K\xfcste'), (u'Kuschelhengstl', u'Kuschelhengst!'), (u'KUSSE', u'K\xdcSSE'), (u'KUSSGH', u'k\xfcssen'), (u'kusste', u'k\xfcsste'), (u'KUSTE', u'K\xdcSTE'), (u'Kuste', u'K\xfcste'), (u'K\xe9fer', u'K\xe4fer'), (u'K\xe9fig', u'K\xe4fig'), (u'k\xe9ime', u'k\xe4me'), (u'k\xe9impfen', u'k\xe4mpfen'), (u'k\xe9impfend', u'k\xe4mpfend'), (u'k\xe9impft', u'k\xe4mpft'), (u'k\xe9impfte', u'k\xe4mpfte'), (u'k\xe9impften', u'k\xe4mpften'), (u'k\xe9impftest', u'k\xe4mpftest'), (u'k\xe9impfwie', u'k\xe4mpf wie'), (u'K\xe9inguru', u'K\xe4nguru'), (u'k\xe9innen', u'k\xf6nnen'), (u'k\xe9innte', u'k\xf6nnte'), (u'K\xe9irper', u'K\xf6rper'), (u'K\xe9ise', u'K\xe4se'), (u'K\xe9isebrunnen', u'K\xe4sebrunnen'), (u'K\xe9lte', u'K\xe4lte'), (u'k\xe9lter', u'k\xe4lter'), (u'k\xe9lteste', u'k\xe4lteste'), (u'k\xe9me', u'k\xe4me'), (u'k\xe9men', u'k\xe4men'), (u'k\xe9mpfe', u'k\xe4mpfe'), (u'K\xe9mpfen', u'K\xe4mpfen'), (u'K\xe9mpfer', u'K\xe4mpfer'), (u'k\xe9mpferische', u'k\xe4mpferische'), (u'k\xe9mpfst', u'k\xe4mpfst'), (u'k\xe9mpft', u'k\xe4mpft'), (u'k\xe9mpfte', u'k\xe4mpfte'), (u'k\xe9mpften', u'k\xe4mpften'), (u'k\xe9mt', u'k\xe4mt'), (u'K\xe9nig', u'K\xf6nig'), (u'K\xe9nige', u'K\xf6nige'), (u'K\xe9nigin', u'K\xf6nigin'), (u'K\xe9niginl', u'K\xf6nigin!'), (u'K\xe9niginnen', u'K\xf6niginnen'), (u'k\xe9niglich', u'k\xf6niglich'), (u'k\xe9nigliche', u'k\xf6nigliche'), (u'k\xe9niglichen', u'k\xf6niglichen'), (u'k\xe9nigliches', u'k\xf6nigliches'), (u'K\xe9nigreich', u'K\xf6nigreich'), (u'K\xe9nigreichs', u'K\xf6nigreichs'), (u'K\xe9nigs', u'K\xf6nigs'), (u'K\xe9nigsfamilie', u'K\xf6nigsfamilie'), (u'k\xe9nne', u'k\xf6nne'), (u'k\xe9nnen', u'k\xf6nnen'), (u'k\xe9nnt', u'k\xf6nnt'), (u'k\xe9nnte', u'k\xf6nnte'), (u'K\xe9nnten', u'K\xf6nnten'), (u'K\xe9nntest', u'K\xf6nntest'), (u'K\xe9nntet', u'K\xf6nntet'), (u'K\xe9pfchen', u'K\xf6pfchen'), (u'K\xe9pfe', u'K\xf6pfe'), (u'K\xe9pfen', u'K\xf6pfen'), (u'k\xe9pft', u'k\xf6pft'), (u"K\xe9pt'n", u"K\xe4pt'n"), (u'K\xe9rbchen', u'K\xf6rbchen'), (u'K\xe9rbchengr\xe9fie', u'K\xf6rbchengr\xf6\xdfe'), (u'K\xe9rben', u'K\xf6rben'), (u'K\xe9rper', u'K\xf6rper'), (u'K\xe9rperfunktionen', u'K\xf6rperfunktionen'), (u'k\xe9rperlich', u'k\xf6rperlich'), (u'k\xe9rperliche', u'k\xf6rperliche'), (u'K\xe9rperproportionen', u'K\xf6rperproportionen'), (u'K\xe9rpersprache', u'K\xf6rpersprache'), (u'K\xe9rpertyp', u'K\xf6rpertyp'), (u'K\xe9rperverletzung', u'K\xf6rperverletzung'), (u'K\xe9rper\xe9ffnungen', u'K\xf6rper\xf6ffnungen'), (u'K\xe9se', u'K\xe4se'), (u'K\xe9sebrett', u'K\xe4sebrett'), (u'K\xe9secracker', u'K\xe4secracker'), (u'k\xe9stlich', u'k\xf6stlich'), (u'K\xe9ter', u'K\xf6ter'), (u'K\xe9tern', u'K\xf6tern'), (u'K\ufb02mmere', u'K\xfcmmere'), (u'k\ufb02mmern', u'k\xfcmmern'), (u"L'a'cherlich", u'L\xe4cherlich'), (u"L'a'ndern", u'L\xe4ndern'), (u"l'a'sst", u'l\xe4sst'), (u"l'a'uft", u'l\xe4uft'), (u'l/chtes', u'lichtes'), (u'l/Vings', u'Wings'), (u'L5cheln', u'L\xe4cheln'), (u'L6ffel', u'L\xf6ffel'), (u'L6schen', u'L\xf6schen'), (u'L6se', u'L\xf6se'), (u'l6sen', u'l\xf6sen'), (u'L6wen', u'L\xf6wen'), (u'L6win', u'L\xf6win'), (u'LADIESMANZ17', u'LADIESMAN217'), (u'Landh\xe9user', u'Landh\xe4user'), (u'Landstra\ufb02e', u'Landstra\xdfe'), (u'Lands\xe9iugetier', u'Lands\xe4ugetier'), (u'langl', u'lang!'), (u'langweiligl', u'langweilig!'), (u'Lasergestutzte', u'Lasergest\xfctzte'), (u'Laserzielger\xe9t', u'Laserzielger\xe4t'), (u'Lattenzaunwei\ufb02', u'Lattenzaunwei\xdf'), (u'Laudal', u'Lauda!'), (u'laufl', u'lauf!'), (u'Lau\ufb02', u'Lauf!'), (u'La\xdf', u'Lass'), (u'lch', u'Ich'), (u'ldee', u'Idee'), (u'ldeen', u'Ideen'), (u'ldelia', u'Idelia'), (u'ldentifikation', u'Identifikation'), (u'ldentifikationsnummer', u'Identifikationsnummer'), (u'ldentifikationssignal', u'Identifikationssignal'), (u'ldentifizierung', u'Identifizierung'), (u"ldentit'a'tsscheibe", u'ldentit\xe4tsscheibe'), (u'ldioten', u'Idioten'), (u'ldloten', u'Idioten'), (u'Le/d', u'Leid'), (u'Lebenl', u'Leben!'), (u'lebensf\xe9hig', u'lebensf\xe4hig'), (u'lebensl\xe9nglich', u'lebensl\xe4nglich'), (u'lebensmijlde', u'lebensm\xfcde'), (u'Lebersch\xe9den', u'Lebersch\xe4den'), (u'leergegessen', u'leer gegessen'), (u'legend\xe9re', u'legend\xe4re'), (u'legend\xe9ren', u'legend\xe4ren'), (u'Legion\xe9r', u'Legion\xe4r'), (u'Legion\xe9re', u'Legion\xe4re'), (u'Lehe', u'Lebe'), (u'Leichensch\xe9ndung', u'Leichensch\xe4ndung'), (u'leichtjemanden', u'leicht jemanden'), (u'leidl', u'leid!'), (u'Leistuljg', u'Leistung'), (u'Lelbwfichter', u'Leibw\xe4chter'), (u'Leld', u'Leid'), (u'lemen', u'lernen'), (u'Lenks\xe9ule', u'Lenks\xe4ule'), (u'lfidt', u'l\xe4dt'), (u'lfigt', u'l\xfcgt'), (u'lfinger', u'l\xe4nger'), (u'lfiuft', u'l\xe4uft'), (u'Lfiuterung', u'L\xe4uterung'), (u'lgitt', u'Igitt'), (u'lgnorier', u'Ignorier'), (u'lhm', u'Ihm'), (u'lhn', u'Ihn'), (u'lhnen', u'Ihnen'), (u'lhnenl', u'Ihnen!'), (u'lhr', u'Ihr'), (u'lhre', u'Ihre'), (u'lhrem', u'Ihrem'), (u'lhren', u'Ihren'), (u'lhrer', u'Ihrer'), (u'lhrerverffigung', u'Ihrer Verf\xfcgung'), (u'lhres', u'Ihres'), (u'lhrfehlt', u'Ihr fehlt'), (u'lhrjemalsjemanden', u'lhr jemals jemanden'), (u'lhrVerteidiger', u'lhr Verteidiger'), (u'Libel', u'\xfcbel'), (u'Libelwollen', u'\xfcbelwollen'), (u'Liben', u'\xfcben'), (u'Liber', u'\xfcber'), (u'Liberall', u'\xfcberall'), (u'Liberdenken', u'\xfcberdenken'), (u'Liberdrllissig', u'\xfcberdr\xfcssig'), (u'Liberfallen', u'\xfcberfallen'), (u'Libergebrannt', u'\xfcbergebrannt'), (u'Liberhaupt', u'\xfcberhaupt'), (u'Liberlasst', u'\xfcberlasst'), (u'Liberleben', u'\xdcberleben'), (u'Liberlegen', u'\xfcberlegen'), (u'Liberlegt', u'\xfcberlegt'), (u'Libernimmt', u'\xfcbernimmt'), (u'Liberpriift', u'\xfcberpr\xfcft'), (u'Liberreden', u'\xfcberreden'), (u'Libersteht', u'\xfcbersteht'), (u'Liberstllirzen', u'\xfcberst\xfcrzen'), (u'Liberwachen', u'\xfcberwachen'), (u'Liberwacht', u'\xfcberwacht'), (u'Liberwinden', u'\xfcberwinden'), (u'Liberw\xe9ltigen', u'\xfcberw\xe4ltigen'), (u'Liberw\xe9ltigt', u'\xfcberw\xe4ltigt'), (u'Liberzeugt', u'\xfcberzeugt'), (u'Lible', u'\xfcble'), (u'Liblich', u'\xfcblich'), (u'Libliche', u'\xdcbliche'), (u'Librig', u'\xfcbrig'), (u'lie/3', u'lie\xdf'), (u'lie/Se', u'lie\xdfe'), (u'lieB', u'lie\xdf'), (u'lieBe', u'lie\xdfe'), (u'liebenswilrdig', u'liebensw\xfcrdig'), (u'liebenswurdiger', u'liebensw\xfcrdiger'), (u'Liebesgestiindnis', u'Liebesgest\xe4ndnis'), (u'Lieblingsbesch\xe9ftigung', u'Lieblingsbesch\xe4ftigung'), (u'Lieblingsrockerl', u'Lieblingsrocker!'), (u'Lieblingss\xe9tze', u'Lieblingss\xe4tze'), (u'lief2>en', u'lie\xdfen'), (u'Liefergebiihren', u'Liefergeb\xfchren'), (u'lieflsen', u'lie\xdfen'), (u'liegenlassen', u'liegen lassen'), (u'Liehe', u'Liebe'), (u'lieli', u'lie\xdf'), (u'lielien', u'lie\xdfen'), (u'Liellen', u'Lie\xdfen'), (u'liells', u'lie\xdf'), (u'lien', u'lie\xdf'), (u'Liicher', u'L\xf6cher'), (u'Liige', u'L\xfcge'), (u'Liigner', u'L\xfcgner'), (u'liinger', u'l\xe4nger'), (u'liischen', u'l\xf6schen'), (u'liischt', u'l\xf6scht'), (u'Liisst', u'L\xe4sst'), (u'liist', u'l\xf6st'), (u'Liisung', u'L\xf6sung'), (u'Liisungen', u'L\xf6sungen'), (u'Liiwen', u'L\xf6wen'), (u'Lii\ufb02ung', u'L\xfcftung'), (u'lijgen', u'l\xfcgen'), (u'Lijgner', u'L\xfcgner'), (u'Lilgner', u'L\xfcgner'), (u'lilgst', u'l\xfcgst'), (u'lilgt', u'l\xfcgt'), (u'Lilterer', u'\xc4lterer'), (u'LIMOUSINENSERVICE10I06', u'LIMOUSINENSERVICE 10:06'), (u'linger', u'l\xe4nger'), (u"lke's", u"Ike's"), (u'lkone', u'Ikone'), (u"lL'lgt", u'l\xfcgt'), (u'Llberstehen', u'\xfcberstehen'), (u'Llebe', u'Liebe'), (u'llebt', u'liebt'), (u'lllfie', u'Wie'), (u'lllfillensstark', u'Willensstark'), (u"lllfillie's", u"Willie's"), (u'lllfir', u'Wir'), (u'Lllignerl', u'L\xfcgner!'), (u'llligtl', u'l\xfcgt!'), (u'lllusionen', u'Illusionen'), (u'llngst', u'l\xe4ngst'), (u'llztlicher', u'\xe4rztlicher'), (u'lm', u'Im'), (u'lmbiss', u'Imbiss'), (u'lmmer', u'Immer'), (u'lmmigranten', u'Immigranten'), (u'lmpuls', u'Impuls'), (u'lmpulsantrieb', u'Impulsantrieb'), (u'lndianer', u'Indianer'), (u'lndianerin', u'Indianerin'), (u'lndianerm\xe9dchen', u'Indianerm\xe4dchen'), (u'lndianertanz', u'Indianertanz'), (u'lndikation', u'Indikation'), (u'lndividualit\xe9t', u'Individualit\xe4t'), (u'lndividuen', u'Individuen'), (u'lndividuum', u'Individuum'), (u'lnduktion', u'Induktion'), (u'lneffizienz', u'Ineffizienz'), (u'lnformationen', u'Informationen'), (u'lnfos', u'Infos'), (u'lngenieur', u'Ingenieur'), (u'lngenieure', u'Ingenieure'), (u'lnhalt', u'Inhalt'), (u'lnhalte', u'Inhalte'), (u'lnnenraum', u'Innenraum'), (u'lnnenr\xe9ume', u'Innenr\xe4ume'), (u'lnsekt', u'Insekt'), (u'lnsekten', u'Insekten'), (u'lnsel', u'Insel'), (u'lnserat', u'Inserat'), (u'lnspektion', u'Inspektion'), (u'lnstinkt', u'Instinkt'), (u'lnstinkte', u'Instinkte'), (u'lnstitut', u'Institut'), (u'lnstrumente', u'Instrumente'), (u'lnstrumentenwagen', u'Instrumentenwagen'), (u'lnsubordination', u'Insubordination'), (u'lntellektuellste', u'Intellektuellste'), (u'lntelligenz', u'Intelligenz'), (u'lntensivstation', u'Intensivstation'), (u'lnteraktion', u'Interaktion'), (u'lnteresse', u'Interesse'), (u'lnteressen', u'Interessen'), (u'lnternat', u'Internat'), (u'lntrigantin', u'Intrigantin'), (u'lntrigantl', u'Intrigant!'), (u'lntrigen', u'Intrigen'), (u'lnverness', u'Inverness'), (u'lnvestition', u'Investition'), (u'lnvestoren', u'Investoren'), (u'lnzucht', u'Inzucht'), (u'lo', u'Io'), (u'Lordk\xe9mmerer', u'Lordk\xe4mmerer'), (u'losf', u'los!'), (u'losl', u'los!'), (u'losw\ufb02rde', u'losw\xfcrde'), (u'Lou/e', u'Louie'), (u'Loyalit\xe9t', u'Loyalit\xe4t'), (u'lrak', u'Irak'), (u'lraner', u'Iraner'), (u'lren', u'Iren'), (u'Lrgendetvvas', u'Irgendetwas'), (u'lrland', u'Irland'), (u'lronhide', u'Ironhide'), (u'lronie', u'Ironie'), (u'lrre', u'Irre'), (u'lrren', u'Irren'), (u'lrrenanstalt', u'Irrenanstalt'), (u'lrrenhaus', u'Irrenhaus'), (u'lrrer', u'Irrer'), (u'lrrgarten', u'Irrgarten'), (u'lrrlicht', u'Irrlicht'), (u'lrrlichter', u'Irrlichter'), (u'lrrsinn', u'Irrsinn'), (u'lrrsinns', u'Irrsinns'), (u'lrrtum', u'Irrtum'), (u'lscandar', u'Iscandar'), (u'lscandars', u'Iscandars'), (u'lsolierband', u'Isolierband'), (u'lss', u'Iss'), (u'lstja', u'Ist ja'), (u'ltaker', u'Itaker'), (u'ltakerflossen', u'Itakerflossen'), (u'ltalo', u'Italo'), (u'Ltiffel', u'L\xf6ffel'), (u'ltlgen', u'l\xfcgen'), (u'Lufijagen', u'Luft jagen'), (u'Luftballonsl', u'Luftballons!'), (u'Luftjagen', u'Luft jagen'), (u'Luftunterst\ufb02tzung', u'Luftunterst\xfctzung'), (u'LUgen', u'L\xfcgen'), (u'lvl\xe9idchen', u'M\xe4dchen'), (u'lwan', u'Iwan'), (u"l\xa7uft's", u"l\xe4uft's"), (u'L\xe9chelmfinderl', u'L\xe4chelm\xfcnder!'), (u'l\xe9cheln', u'l\xe4cheln'), (u'l\xe9chelt', u'l\xe4chelt'), (u'L\xe9cher', u'L\xf6cher'), (u'L\xe9cherlich', u'L\xe4cherlich'), (u'l\xe9cherliches', u'l\xe4cherliches'), (u'L\xe9chle', u'L\xe4chle'), (u'l\xe9dt', u'l\xe4dt'), (u'L\xe9ffel', u'L\xf6ffel'), (u'l\xe9ge', u'l\xe4ge'), (u'L\xe9icheln', u'L\xe4cheln'), (u'L\xe9icherlich', u'L\xe4cherlich'), (u'l\xe9ichle', u'l\xe4chle'), (u'L\xe9indchen', u'L\xe4ndchen'), (u'l\xe9ingst', u'l\xe4ngst'), (u'l\xe9isen', u'l\xf6sen'), (u'l\xe9issig', u'l\xe4ssig'), (u'l\xe9isst', u'l\xe4sst'), (u'L\xe9iuft', u'L\xe4uft'), (u'L\xe9jsung', u'L\xf6sung'), (u'L\xe9mmchen', u'L\xe4mmchen'), (u'L\xe9mmer', u'L\xe4mmer'), (u'L\xe9nder', u'L\xe4nder'), (u'L\xe9ndern', u'L\xe4ndern'), (u'L\xe9nge', u'L\xe4nge'), (u'L\xe9ngen', u'L\xe4ngen'), (u'l\xe9nger', u'l\xe4nger'), (u'l\xe9ngst', u'l\xe4ngst'), (u'l\xe9ngste', u'l\xe4ngste'), (u'L\xe9rm', u'L\xe4rm'), (u'L\xe9rmbeschwerden', u'L\xe4rmbeschwerden'), (u'l\xe9schen', u'l\xf6schen'), (u'L\xe9se', u'L\xf6se'), (u'L\xe9segeld', u'L\xf6segeld'), (u'l\xe9sst', u'l\xe4sst'), (u'l\xe9st', u'l\xf6st'), (u'l\xe9ste', u'l\xf6ste'), (u'l\xe9sten', u'l\xf6sten'), (u'l\xe9stig', u'listig'), (u'L\xe9sung', u'L\xf6sung'), (u'l\xe9ufig', u'l\xe4ufig'), (u'l\xe9ufst', u'l\xe4ufst'), (u'L\xe9uft', u'L\xe4uft'), (u'l\xe9uten', u'l\xe4uten'), (u'l\xe9utet', u'l\xe4utet'), (u'L\xe9we', u'L\xf6we'), (u'L\ufb02gner', u'L\xfcgner'), (u"M'a'dchen", u'M\xe4dchen'), (u'm/ese', u'miese'), (u'M/ffsommernachfsfraum', u'Mittsommernachtstraum'), (u'M/r', u'Mir'), (u'M0I8KUI', u'Molek\xfcl'), (u'm6belt', u'm\xf6belt'), (u'm6chte', u'm\xf6chte'), (u'm6chtest', u'm\xf6chtest'), (u'm6gen', u'm\xf6gen'), (u'm6glich', u'm\xf6glich'), (u'm6glichen', u'm\xf6glichen'), (u'm6glicher', u'm\xf6glicher'), (u'm6gt', u'm\xf6gt'), (u'M6rder', u'M\xf6rder'), (u'MaB', u'Ma\xdf'), (u'MaBgabe', u'Ma\xdfgabe'), (u'mac/1e', u'mache'), (u'mac/7', u'nach'), (u'machs', u"mach's"), (u'Machtiibernahme', u'Macht\xfcbernahme'), (u'madenschw\xe9inziger', u'madenschw\xe4nziger'), (u'Mafinahme', u'Ma\xdfnahme'), (u'Magengeschwiire', u'Magengeschw\xfcre'), (u'Magengeschwilr', u'Magengeschw\xfcr'), (u'Magengeschwtir', u'Magengeschw\xfcr'), (u'Magnolienbliiten', u'Magnolienbl\xfcten'), (u'Majesfait', u'Majest\xe4t'), (u'Majest\xe9it', u'Majest\xe4t'), (u'Majest\xe9t', u'Majest\xe4t'), (u'Majest\xe9ten', u'Majest\xe4ten'), (u'Mal2>en', u'Ma\xdfen'), (u'Mal3en', u'Ma\xdfen'), (u'malf', u'mal!'), (u'Malinahme', u'Ma\xdfnahme'), (u'mall', u'mal!'), (u'Mallregelten', u'Ma\xdfregelten'), (u'Mandverstation', u'Man\xf6verstation'), (u'Manfiver', u'Man\xf6ver'), (u'Maniiver', u'Man\xf6ver'), (u'Manikfire', u'Manik\xfcre'), (u'Mannscha\ufb02', u'Mannschaft'), (u"Mansclle\ufb02'enkm'5pfe", u'Manschettenkn\xf6pfe'), (u'Man\xe9iver', u'Man\xf6ver'), (u'Man\xe9ver', u'Man\xf6ver'), (u'man\xe9vrieren', u'man\xf6vrieren'), (u'man\xe9vrierf\xe9hig', u'man\xf6vrierf\xe4hig'), (u'Man\xe9vriermodus', u'Man\xf6vriermodus'), (u'Margoliserklfirung', u'Margoliserkl\xe4rung'), (u'Margoliserkl\xe9rung', u'Margoliserkl\xe4rung'), (u'marsch\xe9hnliche', u'marsch\xe4hnliche'), (u'Massagestllihlen', u'Massagest\xfchlen'), (u'Massenzerst\xe9rung', u'Massenzerst\xf6rung'), (u'Massenzerst\xe9rungswaffen', u'Massenzerst\xf6rungswaffen'), (u'Mater/al', u'Material'), (u'Maxiriicke', u'Maxir\xf6cke'), (u'Mayonaise', u'Mayonnaise'), (u'mbglichst', u'm\xf6glichst'), (u'Mdge', u'M\xf6ge'), (u'mdglichen/veise', u'm\xf6glicherweise'), (u'mdglicherweise', u'm\xf6glicherweise'), (u'Mdglichkeit', u'M\xf6glichkeit'), (u'me/n', u'mein'), (u'mehrZeit', u'mehr Zeit'), (u"mein'ja", u"mein' ja"), (u'meinerjetzigen', u'meiner jetzigen'), (u'Meinungs\xe9ufierung', u'Meinungs\xe4u\xdferung'), (u'Meisterbr\xe9u', u'Meisterbr\xe4u'), (u'Meisterstijck', u'Meisterst\xfcck'), (u'meistgehasste', u'meist gehasste'), (u'meln', u'mein'), (u'melne', u'meine'), (u'Mend', u'Mond'), (u'Menschenh\xe9indler', u'Menschenh\xe4ndler'), (u'Menstruationsst\xe9rungen', u'Menstruationsst\xf6rungen'), (u'Merkwiirdig', u'Merkw\xfcrdig'), (u'Merkwiirdige', u'Merkw\xfcrdige'), (u'merkwiirdiger', u'merkw\xfcrdiger'), (u'merkwilrdig', u'merkw\xfcrdig'), (u'merkwlllrdige', u'merkw\xfcrdige'), (u'merkwurdig', u'merkw\xfcrdig'), (u'merkwurolig', u'merkw\xfcrdig'), (u'merkw\ufb02rdig', u'merkw\xfcrdig'), (u'Messger\xe9t', u'Messger\xe4t'), (u'mfichte', u'm\xf6chte'), (u'Mfichten', u'M\xf6chten'), (u'Mfidchen', u'M\xe4dchen'), (u'Mfidchenl', u'M\xe4dchen!'), (u'Mfidels', u'M\xe4dels'), (u'mfigen', u'm\xf6gen'), (u'Mfigliche', u'M\xf6gliche'), (u'mfiglichen', u'm\xf6glichen'), (u'mfiglicherweise', u'm\xf6glicherweise'), (u'Mfill', u'M\xfcll'), (u'Mfillhalde', u'M\xfcllhalde'), (u'Mfinchen', u'M\xfcnchen'), (u'Mfinder', u'M\xfcnder'), (u'Mfinnern', u'M\xe4nnern'), (u'Mfissen', u'M\xfcssen'), (u'mfisst', u'm\xfcsst'), (u'mfisste', u'm\xfcsste'), (u'Mfjrder', u'M\xf6rder'), (u'Midchen', u'M\xe4dchen'), (u'Migrane', u'Migr\xe4ne'), (u'Migr\xe9ne', u'Migr\xe4ne'), (u'Migr\ufb02ne', u'Migr\xe4ne'), (u'miichte', u'm\xf6chte'), (u'Miichtegern', u'M\xf6chtegern'), (u'Miichten', u'M\xf6chten'), (u'miichtest', u'm\xf6chtest'), (u'miide', u'm\xfcde'), (u'Miidels', u'M\xe4dels'), (u'miides', u'm\xfcdes'), (u'miige', u'm\xf6ge'), (u'miigen', u'm\xf6gen'), (u'miiglich', u'm\xf6glich'), (u'miigliche', u'm\xf6gliche'), (u'miiglichen', u'm\xf6glichen'), (u'miigliches', u'm\xf6gliches'), (u'Miiglichkeit', u'M\xf6glichkeit'), (u'Miiglichkeiten', u'M\xf6glichkeiten'), (u'miigt', u'm\xf6gt'), (u'Miill', u'M\xfcll'), (u'Miillhalde', u'M\xfcllhalde'), (u'Miilltonnen', u'M\xfclltonnen'), (u'miilssen', u'm\xfcssen'), (u'miirderisch', u'm\xf6rderisch'), (u'miisse', u'm\xfcsse'), (u'Miissen', u'M\xfcssen'), (u'miisst', u'm\xfcsst'), (u'miisste', u'm\xfcsste'), (u'Miiuse', u'M\xe4use'), (u'mijchte', u'm\xf6chte'), (u'Mijcken', u'M\xfccken'), (u'Mijhe', u'M\xfche'), (u'Mijnzen', u'M\xfcnzen'), (u'mijssen', u'm\xfcssen'), (u'mijsst', u'm\xfcsst'), (u'mijsste', u'm\xfcsste'), (u'mijsstest', u'm\xfcsstest'), (u'Milchstrafie', u'Milchstra\xdfe'), (u'Milhe', u'M\xfche'), (u'Milhle', u'M\xfchle'), (u'MILITAR', u'MILIT\xc4R'), (u'Militiirprogramme', u'Milit\xe4rprogramme'), (u'Militir', u'Milit\xe4r'), (u'militlrische', u'milit\xe4rische'), (u'Milit\xe9irkodex', u'Milit\xe4rkodex'), (u'Milit\xe9r', u'Milit\xe4r'), (u'Milit\xe9rakademie', u'Milit\xe4rakademie'), (u'Milit\xe9rdienst', u'Milit\xe4rdienst'), (u'milit\xe9rischen', u'milit\xe4rischen'), (u'Milit\xe9rkodex', u'Milit\xe4rkodex'), (u'Milit\xe9rluftraum', u'Milit\xe4rluftraum'), (u'Milit\xe9rnetzwerk', u'Milit\xe4rnetzwerk'), (u'Milit\xe9rs', u'Milit\xe4rs'), (u'Milit\xe9rsystem', u'Milit\xe4rsystem'), (u'Millbilligung', u'Missbilligung'), (u'Millefs', u"Miller's"), (u'Millgeburt', u'Missgeburt'), (u'Milliard\xe9iren', u'Milliard\xe4ren'), (u'Million\xe9rssohn', u'Million\xe4rssohn'), (u'Milli\xe9quivalent', u'Milli\xe4quivalent'), (u'Millltonne', u'M\xfclltonne'), (u'millverstanden', u'missverstanden'), (u'milssen', u'm\xfcssen'), (u'milsst', u'm\xfcsst'), (u'milsste', u'm\xfcsste'), (u'milssten', u'm\xfcssten'), (u'Miltter', u'M\xfctter'), (u'Minenraumen', u'Minenr\xe4umen'), (u'Miniriicke', u'Minir\xf6cke'), (u'mirglauben', u'mir glauben'), (u'mirja', u'mir ja'), (u'mirje', u'mir je'), (u'mirjeglichen', u'mir jeglichen'), (u'mirjemals', u'mir jemals'), (u'mirjemand', u'mir jemand'), (u'mirjetzt', u'mir jetzt'), (u'mirso', u'mir so'), (u'mirvon', u'mir von'), (u'mirzu', u'mir zu'), (u'Miserabell', u'Miserabel!'), (u'missf\xe9llt', u'missf\xe4llt'), (u'Missverstfindnisl', u'Missverst\xe4ndnis!'), (u'Missverstiindnis', u'Missverst\xe4ndnis'), (u'Missverst\xe9ndnis', u'Missverst\xe4ndnis'), (u'Missverst\xe9ndnissen', u'Missverst\xe4ndnissen'), (u'Mistkerlel', u'Mistkerle!'), (u'Mistkiiter', u'Mistk\xf6ter'), (u'Miststiick', u'Mistst\xfcck'), (u'Mistst\ufb02cke', u'Mistst\xfccke'), (u'Mitbijrger', u'Mitb\xfcrger'), (u'Mitbilrger', u'Mitb\xfcrger'), (u'mitfiihlend', u'mitf\xfchlend'), (u'mitfiihlender', u'mitf\xfchlender'), (u'mitfuhlend', u'mitf\xfchlend'), (u'Mitgefiihl', u'Mitgef\xfchl'), (u'Mitgefuhl', u'Mitgef\xfchl'), (u'mitgehiirt', u'mitgeh\xf6rt'), (u'mitgez\xe9hlt', u'mitgez\xe4hlt'), (u'mitjedem', u'mit jedem'), (u'mitjemandem', u'mit jemandem'), (u'mittlen/veile', u'mittlerweile'), (u"ML'1nze", u'M\xfcnze'), (u'mlch', u'mich'), (u'Mldchen', u'M\xe4dchen'), (u'mLissen', u'm\xfcssen'), (u'Mljnder', u'M\xfcnder'), (u'Mllillschlucker', u'M\xfcllschlucker'), (u'Mllindel', u'M\xfcndel'), (u'Mllindung', u'M\xfcndung'), (u'mllissen', u'm\xfcssen'), (u'mllisst', u'm\xfcsst'), (u'Mlllhe', u'M\xfche'), (u'Mllllon', u'Million'), (u'Mllllonen', u'Millionen'), (u'mlllsst', u'm\xfcsst'), (u'Mllltterjedoch', u'M\xfctter jedoch'), (u'Mlnnern', u'M\xe4nnern'), (u'mlr', u'mir'), (u'mlrl', u'mir!'), (u'mlt', u'mit'), (u'moglich', u'm\xf6glich'), (u'Moglichkeit', u'M\xf6glichkeit'), (u'Moglichkeiten', u'M\xf6glichkeiten'), (u'Molekijle', u'Molek\xfcle'), (u"MolekL'lle", u'Molek\xfcle'), (u'Mondeinhiirner', u'Mondeinh\xf6rner'), (u'Mondeinhiirnerl', u'Mondeinh\xf6rner!'), (u'Mondeinh\xe9irner', u'Mondeinh\xf6rner'), (u'Mondk\xe9ilber', u'Mondk\xe4lber'), (u'Monl', u'Mom'), (u'MONTONEI', u'MONTONE:'), (u'Mordsiiberraschung', u'Mords\xfcberraschung'), (u'Mordverd\xe9chtiger', u'Mordverd\xe4chtiger'), (u'Morsealphabetl', u'Morsealphabet!'), (u'Motorger\xe9usch', u'Motorger\xe4usch'), (u'Motorger\xe9usche', u'Motorger\xe4usche'), (u"Mousset\ufb02e's", u"Moussette's"), (u'Mowen', u'M\xf6wen'), (u'Mtihe', u'M\xfche'), (u'Mtillschlucker', u'M\xfcllschlucker'), (u'mtissen', u'm\xfcssen'), (u'mtissenl', u'm\xfcssen!'), (u'Mtitzel', u'M\xfctze!'), (u'mtlde', u'm\xfcde'), (u'mtlsste', u'm\xfcsste'), (u'muBt', u'musst'), (u'Mucken', u'M\xfccken'), (u'mucksm\xe9uschenstill', u'mucksm\xe4uschenstill'), (u'mude', u'm\xfcde'), (u'Muhe', u'M\xfche'), (u'MUII', u'M\xfcll'), (u'mull', u'muss'), (u'MULL', u'M\xdcLL'), (u'mullte', u'musste'), (u'Mundl', u'Mund!'), (u'Mundung', u'M\xfcndung'), (u'Munzfernsprecher', u'M\xfcnzfernsprecher'), (u'Muskatnijsse', u'Muskatn\xfcsse'), (u'Muskelkumpelsl', u'Muskelkumpels!'), (u'muskul\xe9ren', u'muskul\xe4ren'), (u'mussen', u'm\xfcssen'), (u'MUSSEN', u'M\xdcSSEN'), (u"mUssen's", u"m\xfcssen's"), (u"muss_'\xa7e", u'musste'), (u'Musterschuler', u'Mustersch\xfcler'), (u'Mutterja', u'Mutter ja'), (u'mutterlich', u'm\xfctterlich'), (u'Mutze', u'M\xfctze'), (u'mu\xdf', u'muss'), (u'mu\xdft', u'musst'), (u'mu\xdfte', u'musste'), (u"mx't", u'mit'), (u'Mzlinnern', u'M\xe4nnern'), (u'M\xe9bel', u'M\xf6bel'), (u'm\xe9cht', u'm\xf6cht'), (u'M\xe9chte', u'M\xe4chte'), (u'm\xe9chte', u'm\xf6chte'), (u'M\xe9chtegern', u'M\xf6chtegern'), (u'm\xe9chten', u'm\xf6chten'), (u'm\xe9chtest', u'm\xf6chtest'), (u'm\xe9chtet', u'm\xf6chtet'), (u'm\xe9chtig', u'm\xe4chtig'), (u'm\xe9chtige', u'm\xe4chtige'), (u'm\xe9chtigen', u'm\xe4chtigen'), (u'm\xe9chtiger', u'm\xe4chtiger'), (u'm\xe9chtiges', u'm\xe4chtiges'), (u'm\xe9chtigste', u'm\xe4chtigste'), (u'm\xe9chtigsten', u'm\xe4chtigsten'), (u'M\xe9dchen', u'M\xe4dchen'), (u'M\xe9dchenh\xe9nden', u'M\xe4dchenh\xe4nden'), (u'M\xe9dchens', u'M\xe4dchens'), (u'M\xe9del', u'M\xe4del'), (u'M\xe9dels', u'M\xe4dels'), (u'M\xe9delsl', u'M\xe4dels!'), (u'M\xe9fiigung', u'M\xe4\xdfigung'), (u'm\xe9ge', u'm\xf6ge'), (u'M\xe9gen', u'M\xf6gen'), (u'M\xe9glich', u'M\xf6glich'), (u'm\xe9gliche', u'm\xf6gliche'), (u'M\xe9glichen', u'M\xf6glichen'), (u'M\xe9gliches', u'M\xf6gliches'), (u'M\xe9glichkeit', u'M\xf6glichkeit'), (u'M\xe9glichkeiten', u'M\xf6glichkeiten'), (u'm\xe9glichst', u'm\xf6glichst'), (u'm\xe9gt', u'm\xf6gt'), (u'm\xe9ichtig', u'm\xe4chtig'), (u'm\xe9ichtige', u'm\xe4chtige'), (u'm\xe9ichtigen', u'm\xe4chtigen'), (u'm\xe9ichtiger', u'm\xe4chtiger'), (u'M\xe9idchen', u'M\xe4dchen'), (u'M\xe9idel', u'M\xe4del'), (u'M\xe9inner', u'M\xe4nner'), (u'M\xe9innl', u'M\xe4nnl'), (u'm\xe9innlicher', u'm\xe4nnlicher'), (u'M\xe9irder', u'M\xf6rder'), (u'M\xe9irz', u'M\xe4rz'), (u'M\xe9nnchen', u'M\xe4nnchen'), (u'M\xe9nnchens', u'M\xe4nnchens'), (u'M\xe9nner', u'M\xe4nner'), (u'M\xe9nnerfreundschaft', u'M\xe4nnerfreundschaft'), (u'M\xe9nnern', u'M\xe4nnern'), (u'M\xe9nnersache', u'M\xe4nnersache'), (u'm\xe9nnlich', u'm\xe4nnlich'), (u'm\xe9nnliche', u'm\xe4nnliche'), (u'M\xe9ntel', u'M\xe4ntel'), (u'M\xe9olel', u'M\xe4del'), (u'M\xe9olels', u'M\xe4dels'), (u'M\xe9rchen', u'M\xe4rchen'), (u'M\xe9rchenl', u'M\xe4rchen!'), (u'M\xe9rchenprinzen', u'M\xe4rchenprinzen'), (u'M\xe9rder', u'M\xf6rder'), (u'M\xe9rtyrer', u'M\xe4rtyrer'), (u'M\xe9rz', u'M\xe4rz'), (u'M\xe9tresse', u'M\xe4tresse'), (u'M\xe9uschen', u'M\xe4uschen'), (u'M\xe9use', u'M\xe4use'), (u'M\xe9usehtipfer', u'M\xe4useh\xfcpfer'), (u'M\xe9usen', u'M\xe4usen'), (u'M\xe9userennen', u'M\xe4userennen'), (u'm\xfc\xdft', u'm\xfcsst'), (u'm\ufb02de', u'm\xfcde'), (u'm\ufb02ssen', u'm\xfcssen'), (u"n'a'chste", u'n\xe4chste'), (u"n'a'hert", u'n\xe4hert'), (u'n/chfs', u'nichts'), (u'n/chi', u'nicht'), (u'N/ck', u'Nick'), (u'n/e', u'nie'), (u'N6', u'N\xf6'), (u'n6tig', u'n\xf6tig'), (u'nac/1', u'nach'), (u'Nachf', u'Nacht'), (u'nachllssig', u'nachl\xe4ssig'), (u'nachl\xe9ssig', u'nachl\xe4ssig'), (u'nachl\xe9sst', u'nachl\xe4sst'), (u'nachprufen', u'nachpr\xfcfen'), (u'Nachschlussel', u'Nachschl\xfcssel'), (u'Nachste', u'N\xe4chste'), (u'NAHERT', u'N\xc4HERT'), (u'NAHERTE', u'N\xc4HERTE'), (u'Nat/on', u'Nation'), (u'natfirlich', u'nat\xfcrlich'), (u'Natiilrlich', u'Nat\xfcrlich'), (u'Natiirlich', u'Nat\xfcrlich'), (u'Natiirllch', u'Nat\xfcrlich'), (u'natijrlich', u'nat\xfcrlich'), (u'natijrlichen', u'nat\xfcrlichen'), (u'natilrlich', u'nat\xfcrlich'), (u'natilrliche', u'nat\xfcrliche'), (u"natL'lrlich", u'nat\xfcrlich'), (u'Natllirlich', u'Nat\xfcrlich'), (u'Nattirlich', u'Nat\xfcrlich'), (u'Nattlrlich', u'Nat\xfcrlich'), (u'Nattlrliohl', u'Nat\xfcrlich!'), (u'Naturlich', u'Naturloch'), (u'naturlich', u'nat\xfcrlich'), (u'naturlichen', u'nat\xfcrlichen'), (u'naturlichsten', u'nat\xfcrlichsten'), (u'Navajoweifi', u'Navajowei\xdf'), (u'ndtige', u'n\xf6tige'), (u'ne/n', u'nein'), (u'Nebengeb\xe9ude', u'Nebengeb\xe4ude'), (u'Nebengesch\xe9ift', u'Nebengesch\xe4ft'), (u'neffes', u'nettes'), (u'Nehmf', u'Nehmt'), (u'neinl', u'nein!'), (u'Neln', u'Nein'), (u'nerv6s', u'nerv\xf6s'), (u'Nervens\xe9ge', u'Nervens\xe4ge'), (u'Nervens\xe9ige', u'Nervens\xe4ge'), (u'nerviis', u'nerv\xf6s'), (u'Nerv\xe9s', u'Nerv\xf6s'), (u'ner\\/t', u'nervt'), (u'Neuankiimmlinge', u'Neuank\xf6mmlinge'), (u'neuromuskul\xe9ren', u'neuromuskul\xe4ren'), (u'Neuzug\xe9inge', u'Neuzug\xe4nge'), (u'Nfichster', u'N\xe4chster'), (u'NIANN', u'MANN'), (u'nichsten', u'n\xe4chsten'), (u'nichtim', u'nicht im'), (u'nichtjemand', u'nicht jemand'), (u'Nichtjetzt', u'Nicht jetzt'), (u'Nichtsl', u'Nichts!'), (u'nichtzurilckgelassen', u'nicht zur\xfcckgelassen'), (u'nic_l_1t', u'nicht'), (u'niederk\xe9mpfen', u'niederk\xe4mpfen'), (u'niederliells', u'niederlie\xdf'), (u'niedlichl', u'niedlich!'), (u'niher', u'n\xe4her'), (u'niichsten', u'n\xe4chsten'), (u'niichstes', u'n\xe4chstes'), (u'niirgeln', u'n\xf6rgeln'), (u'niitig', u'n\xf6tig'), (u'niitige', u'n\xf6tige'), (u'Nijssen', u'N\xfcssen'), (u'Nijsternl', u'N\xfcstern!'), (u'nijtzlich', u'n\xfctzlich'), (u'nilchtern', u'n\xfcchtern'), (u'niltzen', u'n\xfctzen'), (u'Nlagnaten', u'Magnaten'), (u'Nlannern', u'M\xe4nnern'), (u'nlchste', u'n\xe4chste'), (u'nlchsthoheren', u'n\xe4chsth\xf6heren'), (u'nlcht', u'nicht'), (u'nle', u'nie'), (u'Nlemalsl', u'Niemals!'), (u'Nlhe', u'N\xe4he'), (u'nlir', u'mir'), (u'nllitzen', u'n\xfctzen'), (u'Nl\xe9inner', u'M\xe4nner'), (u'noc/1', u'noch'), (u"Not/'all", u'Notfall'), (u'Notfalll', u'Notfall!'), (u'notig', u'n\xf6tig'), (u'notigen', u'n\xf6tigen'), (u'Notliige', u'Notl\xfcge'), (u'Notziindung', u'Notz\xfcndung'), (u'NUFI', u'Nur:'), (u'Nunja', u'Nun ja'), (u'Nurdich', u'Nur dich'), (u'nureins', u'nur eins'), (u'nurflustern', u'nur fl\xfcstern'), (u'Nurjetzt', u'Nur jetzt'), (u'nurl', u'nur 1'), (u'nurwunscht', u'nur w\xfcnscht'), (u'Nurzu', u'Nur zu'), (u'nus', u'aus'), (u'NUSSS', u'N\xfcsse'), (u'nutzlich', u'n\xfctzlich'), (u"Nx'emand", u'Niemand'), (u'N\xe9chste', u'N\xe4chste'), (u'n\xe9chsten', u'n\xe4chsten'), (u'N\xe9chster', u'N\xe4chster'), (u'n\xe9chstes', u'n\xe4chstes'), (u'N\xe9chte', u'N\xe4chte'), (u'N\xe9chten', u'N\xe4chten'), (u'n\xe9chtlichen', u'n\xe4chtlichen'), (u'N\xe9gel', u'N\xe4gel'), (u'N\xe9h', u'N\xe4h'), (u'N\xe9he', u'N\xe4he'), (u'n\xe9henf', u'n\xe4hert'), (u'n\xe9her', u'n\xe4her'), (u'n\xe9here', u'n\xe4here'), (u'N\xe9hern', u'N\xe4hern'), (u'n\xe9hernde', u'n\xe4hernde'), (u'n\xe9hert', u'n\xe4hert'), (u'n\xe9herte', u'n\xe4herte'), (u'n\xe9hren', u'n\xe4hren'), (u'n\xe9ht', u'n\xe4ht'), (u'N\xe9hten', u'N\xe4hten'), (u'N\xe9ichste', u'N\xe4chste'), (u'n\xe9ichsten', u'n\xe4chsten'), (u'N\xe9ichstes', u'N\xe4chstes'), (u'N\xe9ihe', u'N\xe4he'), (u'n\xe9iher', u'n\xe4her'), (u'n\xe9ihern', u'n\xe4hern'), (u'n\xe9ihert', u'n\xe4hert'), (u'N\xe9ihten', u'N\xe4hten'), (u'n\xe9imlich', u'n\xe4mlich'), (u'n\xe9mlich', u'n\xe4mlich'), (u'N\xe9pfe', u'N\xe4pfe'), (u'n\xe9rdlich', u'n\xf6rdlich'), (u'n\xe9rgelnde', u'n\xf6rgelnde'), (u'N\xe9rrin', u'N\xe4rrin'), (u'N\xe9schen', u'N\xe4schen'), (u'n\xe9tig', u'n\xf6tig'), (u'n\xe9tige', u'n\xf6tige'), (u'n\xe9tiges', u'n\xf6tiges'), (u'O8', u'08'), (u'obdachlosl', u'obdachlos!'), (u'Obefil\xe9iche', u'Oberfl\xe4che'), (u'OBERFLACHENSCHWERKRAFT', u'OBERFL\xc4CHENSCHWERKRAFT'), (u'Oberfl\xe9che', u'Oberfl\xe4che'), (u'Oberfl\xe9chen', u'Oberfl\xe4chen'), (u'oberfl\xe9chlich', u'oberfl\xe4chlich'), (u'oberfl\xe9chliche', u'oberfl\xe4chliche'), (u'Oberm\xe9inner', u'Oberm\xe4nner'), (u'Ober\ufb02fiche', u'Oberfl\xe4che'), (u"of/'en", u'offen'), (u'Offenslchtllch', u'Offensichtlich'), (u'Offentliches', u'\xd6ffentliches'), (u'Offentlichkeit', u'\xd6ffentlichkeit'), (u'Offne', u'\xd6ffne'), (u'Offnen', u'\xd6ffnen'), (u'Offnet', u'\xd6ffnet'), (u'ofi', u'oft'), (u'Ofiiziere', u'Offiziere'), (u'Ofiiziers', u'Offiziers'), (u'Oftweg', u'Oft weg'), (u'Of\ufb02cer', u'Officer'), (u'Ohnejede', u'Ohne jede'), (u'ohnm\xe9chtig', u'ohnm\xe4chtig'), (u'ohnm\xe9ichtig', u'ohnm\xe4chtig'), (u'OI', u'\xd6l'), (u'olas', u'das'), (u'oles', u'des'), (u'Oltanks', u'\xd6ltanks'), (u'OO', u'00'), (u'Orgelt\xe9ne', u'Orgelt\xf6ne'), (u'ORTI', u'ORT:'), (u'Ortl', u'Ort!'), (u'Ostfltlgel', u'Ostfl\xfcgel'), (u'Paliontologie', u'Pal\xe4ontologie'), (u'pallt', u'passt'), (u'Pal\xe9sten', u'Pal\xe4sten'), (u'Panfike/chen', u'Partikelchen'), (u'Papierbl\xe9tter', u'Papierbl\xe4tter'), (u'Papiertiite', u'Papiert\xfcte'), (u'Papiertilcher', u'Papiert\xfccher'), (u'Parfyknaller', u'Partyknaller'), (u'Partyhiite', u'Partyh\xfcte'), (u'Partyhijte', u'Partyh\xfcte'), (u'Passendervveise', u'Passenderweise'), (u'Paulgenauso', u'Paul genauso'), (u'pa\xdf', u'pass'), (u'pa\xdft', u'passt'), (u'peinliohl', u'peinlich'), (u'persdnlich', u'pers\xf6nlich'), (u'persfinlich', u'pers\xf6nlich'), (u'persiinlich', u'pers\xf6nlich'), (u'persiinliche', u'pers\xf6nliche'), (u'persiinlicher', u'pers\xf6nlicher'), (u'Persiinllchkeltsspaltun', u'Pers\xf6nllchkeltsspaltung'), (u'persijnliche', u'pers\xf6nliche'), (u'personlich', u'pers\xf6nlich'), (u'Personlichkeit', u'Pers\xf6nlichkeit'), (u'pers\xe9nlich', u'pers\xf6nlich'), (u'pers\xe9nliche', u'pers\xf6nliche'), (u'pers\xe9nlicher', u'pers\xf6nlicher'), (u'Pers\xe9nliches', u'Pers\xf6nliches'), (u'Pers\xe9nlichkeit', u'Pers\xf6nlichkeit'), (u'pe\ufb02g', u'peng'), (u'Pfadfindervvappen', u'Pfadfinderwappen'), (u'Pfad\ufb02ndeml', u'Pfad\ufb02ndern!'), (u'Pffitzen', u'Pf\xfctzen'), (u'Pfiitchen', u'Pf\xf6tchen'), (u'Pfippchen', u'P\xfcppchen'), (u"pflL'lgen", u'pfl\xfcgen'), (u'Pfllitze', u'Pf\xfctze'), (u'pflugte', u'pfl\xfcgte'), (u'Pfundbijro', u'Pfundb\xfcro'), (u'ph\xe9nomenal', u'ph\xe4nomenal'), (u'PIatz', u'Platz'), (u'Piimpel', u'P\xf6mpel'), (u'Piinlttchenltrawatte', u'P\xfcnktchenkrawatte'), (u'Pijppchen', u'P\xfcppchen'), (u'Pijppchenl', u'P\xfcppchen!'), (u'Planetenf', u'Planeten!'), (u'planm\xe9fiigen', u'planm\xe4\xdfigen'), (u'Plastikfr\xe9iuleinl', u'Plastikfr\xe4ulein!'), (u'plattmachen', u'platt machen'), (u'Plfitzchen', u'Pl\xe4tzchen'), (u'plfitzlich', u'pl\xf6tzlich'), (u'pliitzlich', u'pl\xf6tzlich'), (u'pliitzllch', u'pl\xf6tzlich'), (u'Pllllnderer', u'Pl\xfcnderer'), (u'plotzlich', u'pl\xf6tzlich'), (u'pl\xe9dieren', u'pl\xe4dieren'), (u'Pl\xe9ine', u'Pl\xe4ne'), (u'Pl\xe9inen', u'Pl\xe4nen'), (u'Pl\xe9itzchen', u'Pl\xe4tzchen'), (u'Pl\xe9itze', u'Pl\xe4tze'), (u'Pl\xe9ne', u'Pl\xe4ne'), (u'Pl\xe9tzchen', u'Pl\xe4tzchen'), (u'Pl\xe9tze', u'Platze'), (u'Pl\xe9tzel', u'Pl\xe4tze!'), (u'pl\xe9tzlich', u'pl\xf6tzlich'), (u'pl\xe9tzliche', u'pl\xf6tzliche'), (u'Pofkawoche', u'Polkawoche'), (u'Polizistl', u'Polizist!'), (u'pompiise', u'pomp\xf6se'), (u'popul\xe9r', u'popul\xe4r'), (u'potth\xe9sslich', u'potth\xe4sslich'), (u'prasentleren', u'pr\xe4sentieren'), (u'prfignant', u'pr\xe4gnant'), (u'Prfisentation', u'Pr\xe4sentation'), (u'Prfisi', u'Pr\xe4si'), (u'priide', u'pr\xfcde'), (u'Priife', u'Pr\xfcfe'), (u'priifen', u'pr\xfcfen'), (u'prijfen', u'pr\xfcfen'), (u"Priorit2a't", u'Priorit\xe4t'), (u'PRIORITKT', u'PRIORIT\xc4T'), (u'PRIORITKTSZUGANG', u'PRIORIT\xc4TSZUGANG'), (u'Priorit\xe9itszugang', u'Priorit\xe4tszugang'), (u'Priorit\xe9t', u'Priorit\xe4t'), (u'Prisident', u'Pr\xe4sident'), (u'Privatgem\xe9chern', u'Privatgem\xe4chern'), (u'Privatsph\xe9re', u'Privatsph\xe4re'), (u'Probfeme', u'Probleme'), (u'Profitinzerinnen', u'Profit\xe4nzerinnen'), (u'Protege', u'Prot\xe9g\xe9'), (u'prude', u'pr\xfcde'), (u'Pruf', u'Pr\xfcf'), (u'prufen', u'pr\xfcfen'), (u'Prugelei', u'Pr\xfcgelei'), (u'prugeln', u'pr\xfcgeln'), (u'pr\xe9chtig', u'pr\xe4chtig'), (u'Pr\xe9fekt', u'Pr\xe4fekt'), (u'pr\xe9historischer', u'pr\xe4historischer'), (u'pr\xe9ichtiger', u'pr\xe4chtiger'), (u'pr\xe9ichtiges', u'pr\xe4chtiges'), (u'Pr\xe9imie', u'Pr\xe4mie'), (u'pr\xe9ipotente', u'pr\xe4potente'), (u'pr\xe9isentiert', u'pr\xe4sentiert'), (u'Pr\xe9isidenten', u'Pr\xe4sidenten'), (u'Pr\xe9itorianer', u'Pr\xe4torianer'), (u'Pr\xe9mie', u'Pr\xe4mie'), (u'Pr\xe9operative', u'Pr\xe4operative'), (u'pr\xe9sentiere', u'pr\xe4sentiere'), (u'pr\xe9sentieren', u'pr\xe4sentieren'), (u'Pr\xe9sentiert', u'Pr\xe4sentiert'), (u'Pr\xe9senz', u'Pr\xe4senz'), (u'Pr\xe9sident', u'Pr\xe4sident'), (u'Pr\xe9sidenten', u'Pr\xe4sidenten'), (u'Pr\xe9sidentin', u'Pr\xe4sidentin'), (u'Pr\xe9sidentschaft', u'Pr\xe4sidentschaft'), (u'Pr\xe9torianer', u'Pr\xe4torianer'), (u'pr\xe9zise', u'pr\xe4zise'), (u'pr\xe9ziser', u'pr\xe4ziser'), (u'Pr\ufb02fungen', u'Pr\xfcfungen'), (u'Pubert\xe9it', u'Pubert\xe4t'), (u'Publlkuml', u'Publlkum!'), (u'PUPPCHEN', u'P\xdcPPCHEN'), (u'PUpst', u'Pupst'), (u'Purzelb\xe9ume', u'Purzelb\xe4ume'), (u'P\xe9ckchen', u'P\xe4ckchen'), (u'p\xe9idagogisch', u'p\xe4dagogisch'), (u'P\xe9irchen', u'P\xe4rchen'), (u'P\xe9rchen', u'P\xe4rchen'), (u'p\ufb02egen', u'pflegen'), (u'P\ufb02icht', u'Pflicht'), (u'p\ufb02ichtbewullt', u'pflichtbewusst'), (u'Qas', u'Das'), (u'Qualit\xe9tskontrolle', u'Qualit\xe4tskontrolle'), (u'Quten', u'guten'), (u'qu\xe9ilen', u'qu\xe4len'), (u'qu\xe9ilt', u'qu\xe4lt'), (u'Qu\xe9l', u'Qu\xe4l'), (u'Qu\xe9lt', u'Qu\xe4lt'), (u"R'a'che", u'R\xe4che'), (u'R/ck', u'Rick'), (u'R/nge', u'Ringe'), (u'R6mer', u'R\xf6mer'), (u'rachsiichtiger', u'rachs\xfcchtiger'), (u'ranghfiheren', u'rangh\xf6heren'), (u'rangh\xe9heren', u'rangh\xf6heren'), (u'ranzukommen', u'ran-zukommen'), (u'Rasenm\xe9herunfall', u'Rasenm\xe4herunfall'), (u'Rasterllibertragung', u'Raster\xfcbertragung'), (u'Rasterubertragung', u'Raster\xfcbertragung'), (u'Ratschl\xe9ige', u'Ratschl\xe4ge'), (u'Rattenf\xe9nger', u'Rattenf\xe4nger'), (u'Rauc/7', u'Rauch'), (u'Rauc/vender', u'Rauchender'), (u'rauhen', u'rauen'), (u'RAUMFAHRE', u'RAUMF\xc4HRE'), (u'Raumf\xe9hre', u'Raumf\xe4hre'), (u'Raumsschiff', u'Raumschiff'), (u'rausf\xe9hrt', u'rausf\xe4hrt'), (u'rausgeprtigeltl', u'rausgepr\xfcgelt!'), (u'rausliefien', u'rauslie\xdfen'), (u'rauszuschmeifien', u'rauszuschmei\xdfen'), (u'rau\ufb02', u'rau!'), (u'Re/se', u'Reise'), (u'Realit\xe9it', u'Realit\xe4t'), (u'Realit\xe9t', u'Realit\xe4t'), (u'Rechtgl\xe9ubige', u'Rechtgl\xe4ubige'), (u'rechtm\xe9fkigen', u'rechtm\xe4\xdfigen'), (u'RECHTSANWALTE', u'RECHTSANW\xc4LTE'), (u'rechtsl', u'rechts!'), (u'Reffer', u'Retter'), (u'regelm\xe9fiige', u'regelm\xe4\xdfige'), (u'Regenh\xe9igen', u'Regenb\xf6gen'), (u'Regenm\xe9ntel', u'Regenm\xe4ntel'), (u'Regierungsgehirnw\xe9ischesignal', u'Regierungsgehirnw\xe4schesignal'), (u'regul\xe9re', u'regul\xe4re'), (u'reiB', u'rei\xdf'), (u'reiBt', u'rei\xdft'), (u'Reichtfimer', u'Reicht\xfcmer'), (u'Reichtllimern', u'Reicht\xfcmern'), (u'reif$', u'rei\xdf'), (u'reif$en', u'rei\xdfen'), (u'Reifiverschluss', u'Rei\xdfverschluss'), (u'Reil3t', u'Rei\xdft'), (u'reil5', u'rei\xdf'), (u'Reili', u'Rei\xdf'), (u'reilien', u'rei\xdfen'), (u'Reilin\xe9gel', u'Rei\xdfn\xe4gel'), (u'Reillt', u'Rei\xdft'), (u'reilZ>', u'rei\xdf'), (u'reingeh\xe9ngt', u'reingeh\xe4ngt'), (u'Reingelegtl', u'Reingelegt!'), (u'reinhupft', u'reinh\xfcpft'), (u'reinl', u'rein!'), (u'reinstilrmen', u'reinst\xfcrmen'), (u'reiohen', u'reichen'), (u'REISSVERSCHLUSSGERAUSCH', u'REISSVERSCHLUSSGER\xc4USCH'), (u'rei\ufb02', u'rei\xdf'), (u'rei\ufb02en', u'rei\xdfen'), (u'relch', u'reich'), (u'religi6s', u'religi\xf6s'), (u'religiiiser', u'religi\xf6ser'), (u'religi\xe9s', u'religi\xf6s'), (u'Rels', u'Reis'), (u'Rentenbezuge', u'Rentenbez\xfcge'), (u'Repr\xe9sentantin', u'Repr\xe4sentantin'), (u'Rettungsflofi', u'Rettungsflo\xdf'), (u'Rev/er', u'Revier'), (u'rfiber', u'r\xfcber'), (u'rfiberwachsen', u'r\xfcberwachsen'), (u'Rfickseite', u'R\xfcckseite'), (u'rfihrselige', u'r\xfchrselige'), (u'rfilpse', u'r\xfclpse'), (u'Rfissel', u'R\xfcssel'), (u'RGMISCHE', u'R\xd6MISCHE'), (u'Richer', u'R\xe4cher'), (u'Riesenhfipfer', u'Riesenh\xfcpfer'), (u'Riesenspafi', u'Riesenspa\xdf'), (u'Riesentijr', u'Riesent\xfcr'), (u'riiber', u'r\xfcber'), (u'Riicheln', u'R\xf6cheln'), (u'riichelt', u'r\xf6chelt'), (u'Riick', u'R\xfcck'), (u'Riickblickend', u'R\xfcckblickend'), (u'Riicken', u'R\xfccken'), (u'Riickenlage', u'R\xfcckenlage'), (u'Riickenwind', u'R\xfcckenwind'), (u'riicksichtslos', u'r\xfccksichtslos'), (u'Riicksichtslosigkeit', u'R\xfccksichtslosigkeit'), (u'Riicksitz', u'R\xfccksitz'), (u'Riickw\xe9irts', u'R\xfcckw\xe4rts'), (u'Riickzug', u'R\xfcckzug'), (u'Riick\ufb02ug', u'R\xfcck\ufb02ug'), (u'riihrt', u'r\xfchrt'), (u'Riilpsen', u'R\xfclpsen'), (u'riilpst', u'r\xfclpst'), (u'Riimischen', u'R\xf6mischen'), (u'Riistung', u'R\xfcstung'), (u'Riiumlichkeiten', u'R\xe4umlichkeiten'), (u'Rijbe', u'R\xfcbe'), (u'rijber', u'r\xfcber'), (u'rijckgfingig', u'r\xfcckg\xe4ngig'), (u'rijckw\xe9irts', u'r\xfcckw\xe4rts'), (u'Rijsseltierl', u'R\xfcsseltier!'), (u'Rilbe', u'R\xfcbe'), (u'rilber', u'r\xfcber'), (u'rilberkommen', u'r\xfcberkommen'), (u'Rilckkehr', u'R\xfcckkehr'), (u'rilcksichtsloses', u'r\xfccksichtsloses'), (u'rilckw\xe9rts', u'r\xfcckw\xe4rts'), (u'Rillpsen', u'R\xfclpsen'), (u'Riol', u'Rio!'), (u'Rivalit\xe9t', u'Rivalit\xe4t'), (u"rL'lber", u'r\xfcber'), (u"RL'lhr", u'R\xfchr'), (u'rllicken', u'r\xfccken'), (u'rllickt', u'r\xfcckt'), (u'Rlllckgrat', u'R\xfcckgrat'), (u'Rlnge', u'Ringe'), (u'Rlumgerate', u'R\xe4umger\xe4te'), (u'ROMISCHE', u'R\xd6MISCHE'), (u'ROMISCHEN', u'R\xd6MISCHEN'), (u'rosa\xe9ugiges', u'rosa\xe4ugiges'), (u'rotiugiger', u'rot\xe4ugiger'), (u'Rotk\xe9ppchen', u'Rotk\xe4ppchen'), (u'Rott\xe9nen', u'Rott\xf6nen'), (u'Routinetlberprijfung', u'Routine\xfcberpr\xfcfung'), (u'Rticken', u'R\xfccken'), (u'rticksichtslos', u'r\xfccksichtslos'), (u'rtlber', u'r\xfcber'), (u'Rtlckseite', u'R\xfcckseite'), (u'ruber', u'r\xfcber'), (u'Ruberrutschen', u'R\xfcberrutschen'), (u'Ruckblende', u'R\xfcckblende'), (u'Ruckblick', u'R\xfcckblick'), (u'Rucken', u'R\xfccken'), (u'Ruckenlage', u'R\xfcckenlage'), (u'Ruckenwind', u'R\xfcckenwind'), (u'Ruckfall', u'R\xfcckfall'), (u'Ruckfrage', u'R\xfcckfrage'), (u'Ruckgriff', u'R\xfcckgriff'), (u'Ruckkehr', u'R\xfcckkehr'), (u'Rucksitz', u'R\xfccksitz'), (u'Ruckzugl', u'R\xfcckzug!'), (u'ruhlg', u'ruhig'), (u'ruhrenl', u'r\xfchren!'), (u'Ruhrt', u'R\xfchrt'), (u'Rul3', u'Ru\xdf'), (u'Rumgebrfillel', u'Rumgebr\xfclle!'), (u'rumhingen', u'rumh\xe4ngen'), (u'rumh\xe9ngen', u'rumh\xe4ngen'), (u'rumh\xe9ngst', u'rumh\xe4ngst'), (u'ruml\xe9uft', u'ruml\xe4uft'), (u'rumwuhlen', u'rumw\xfchlen'), (u'rumzuf\ufb02hren', u'rumzuf\xfchren'), (u'rum\xe9rgern', u'rum\xe4rgern'), (u'runterffihrt', u'runterf\xe4hrt'), (u'runtergespillt', u'runtergesp\xfclt'), (u'runtergesp\ufb02lt', u'runtergesp\xfclt'), (u'Runterl', u'Runter!'), (u'runterspillen', u'runtersp\xfclen'), (u'runterspllllen', u'runtersp\xfclen'), (u'runtersp\xfclt', u'runter-sp\xfclt'), (u'runtervverfen', u'runterwerfen'), (u'Rupem', u'Rupert!'), (u'Rustung', u'R\xfcstung'), (u'r\xe9che', u'r\xe4che'), (u'r\xe9chen', u'r\xe4chen'), (u'R\xe9cher', u'R\xe4cher'), (u'r\xe9cht', u'r\xe4cht'), (u'R\xe9der', u'R\xe4der'), (u'R\xe9dern', u'R\xe4dern'), (u'R\xe9hre', u'R\xf6hre'), (u'R\xe9idern', u'R\xe4dern'), (u'R\xe9itsel', u'R\xe4tsel'), (u'r\xe9itseln', u'r\xe4tseln'), (u'r\xe9itst', u'r\xe4tst'), (u'R\xe9iume', u'R\xe4ume'), (u'R\xe9mern', u'R\xf6mern'), (u'r\xe9mische', u'r\xf6mische'), (u'r\xe9mischen', u'r\xf6mischen'), (u'r\xe9mischer', u'r\xf6mischer'), (u'R\xe9nder', u'R\xe4nder'), (u'R\xe9nke', u'R\xe4nke'), (u'R\xe9nken', u'R\xe4nken'), (u'R\xe9ntgenaufnahme', u'R\xf6ntgenaufnahme'), (u'R\xe9ntgenbild', u'R\xf6ntgenbild'), (u'R\xe9son', u'R\xe4son'), (u'r\xe9t', u'r\xe4t'), (u'R\xe9tsel', u'R\xe4tsel'), (u'r\xe9tselhaft', u'r\xe4tselhaft'), (u'R\xe9tselhaftes', u'R\xe4tselhaftes'), (u'R\xe9ume', u'R\xe4ume'), (u'R\xe9umen', u'R\xe4umen'), (u'R\xe9umlichkeiten', u'R\xe4umlichkeiten'), (u'R\xe9umt', u'R\xe4umt'), (u'r\xe9uspert', u'r\xe4uspert'), (u'R\ufb02be', u'R\xfcbe'), (u'r\ufb02bergeguckt', u'r\xfcbergekuckt'), (u'R\ufb02ckkehr', u'R\xfcckkehr'), (u'S/e', u'Sie'), (u's/nd', u'sind'), (u'S5tze', u'S\xe4tze'), (u'S6hne', u'S\xf6hne'), (u'saB', u'sa\xdf'), (u'Sachverstlndiger', u'Sachverst\xe4ndiger'), (u'sagf', u'sagt'), (u'sagfen', u'sagten'), (u'Sammlerstiicken', u'Sammlerst\xfccken'), (u'Sands\xe9cke', u'Sands\xe4cke'), (u'Sanftmiltigen', u'Sanftm\xfctigen'), (u'Sanierungsbeh\xe9rde', u'Sanierungsbeh\xf6rde'), (u'Sanit\xe9ter', u'Sanit\xe4ter'), (u'Sargn\xe9gel', u'Sargn\xe4gel'), (u'sari', u'sa\xdf'), (u'Satellitenschijssel', u'Satellitensch\xfcssel'), (u'Satellitenschusseln', u'Satellitensch\xfcsseln'), (u'Satellitenuberwachung', u'Satelliten\xfcberwachung'), (u'Saugf\ufb02flsen', u'Saugf\xfc\xdfen'), (u'sc/10/1', u'schon'), (u'sc/16/1', u'sch\xf6n'), (u'sch/cken', u'schicken'), (u'Sch/ffe', u'Schiffe'), (u'sch6n', u'sch\xf6n'), (u'Schadeniiberpriifung', u'Schaden\xfcberpr\xfcfung'), (u'Schadenuberprtlfung', u'Schaden\xfcberpr\xfcfung'), (u'Scharfschijtze', u'Scharfsch\xfctze'), (u'schbn', u'sch\xf6n'), (u"schc'\xa7n", u'sch\xf6n'), (u'Schdn', u'Sch\xf6n'), (u'schdnen', u'sch\xf6nen'), (u'Schecksl', u'Schecks!'), (u'ScheiB', u'Schei\xdf'), (u'ScheiBe', u'Schei\xdfe'), (u'scheiBegal', u'schei\xdfegal'), (u'Scheif$e', u'Schei\xdfe'), (u'scheiffsel', u'schei\xdfe!'), (u'Scheifi', u'Schei\xdf'), (u'Scheifiding', u'Schei\xdfding'), (u'scheifie', u'schei\xdfe'), (u'Scheifiel', u'Schei\xdfe!'), (u'Scheifier', u'Schei\xdfer'), (u'Scheifihelm', u'Schei\xdfhelm'), (u'Scheifiloch', u'Schei\xdfloch'), (u'Scheifipascha', u'Schei\xdfpascha'), (u'Scheifisofa', u'Schei\xdfsofa'), (u'Scheifiweiber', u'Schei\xdfweiber'), (u'Scheifle', u'Schei\xdfe'), (u'Scheiiislangweilig', u'Schei\xdflangweilig'), (u"Scheil'$e", u'Schei\xdfe'), (u'Scheil3>er', u'Schei\xdfer'), (u'Scheil3e', u'Schei\xdfe'), (u'Scheili', u'Schei\xdf'), (u'Scheilie', u'Schei\xdfe'), (u'scheilien', u'schei\xdfen'), (u'Scheille', u'Schei\xdfe'), (u'Scheillel', u'Schei\xdfe!'), (u'ScheilSe', u'Schei\xdfe'), (u'ScheilZ>', u'Schei\xdf'), (u'Scheir$oling', u'Schei\xdfding'), (u'scheissegal', u'schei\xdfegal'), (u'Scheisskarre', u'Schei\xdfkarre'), (u'Schei\ufb02e', u'Schei\xdfe'), (u'scheme', u'schei\xdfe'), (u'scheuf$lich', u'scheu\xdflich'), (u'Scheulilich', u'Scheu\xdflich'), (u'schfichtern', u'sch\xfcchtern'), (u'schfimen', u'sch\xe4men'), (u'schfin', u'sch\xf6n'), (u'Schfine', u'Sch\xf6ne'), (u'schfinen', u'sch\xf6nen'), (u'Schfines', u'Sch\xf6nes'), (u'schfirfer', u'sch\xe4rfer'), (u'Schfissel', u'Sch\xfcssel'), (u'Schfitzchen', u'Sch\xe4tzchen'), (u'schfjnes', u'sch\xf6nes'), (u'Schideln', u'Sch\xe4deln'), (u'schief$en', u'schie\xdfen'), (u'Schief3>en', u'Schie\xdfen'), (u'Schiefien', u'Schie\xdfen'), (u'schiefit', u'schie\xdft'), (u'schiefZ>t', u'schie\xdft'), (u"schiel'5", u'schie\xdf'), (u'Schiel3t', u'Schie\xdft'), (u'schiellen', u'schie\xdfen'), (u'Schielmbung', u'Schie\xdf\xfcbung'), (u'schie\ufb02en', u'schie\xdfen'), (u'schie\ufb02t', u'schie\xdft'), (u'Schiffs\xe9rzte', u'Schiffs\xe4rzte'), (u'Schiffzerstfiren', u'Schiff zerst\xf6ren'), (u'Schifies', u'Schiffes'), (u'Schiidel', u'Sch\xe4del'), (u'schiilzen', u'sch\xe4tzen'), (u'schiin', u'sch\xf6n'), (u'schiine', u'sch\xf6ne'), (u'Schiinen', u'Sch\xf6nen'), (u'Schiiner', u'Sch\xf6ner'), (u'schiines', u'sch\xf6nes'), (u'Schiinheit', u'Sch\xf6nheit'), (u'Schiipfer', u'Sch\xf6pfer'), (u'Schiipfung', u'Sch\xf6pfung'), (u'Schiisse', u'Sch\xfcsse'), (u'Schiitt', u'Sch\xfctt'), (u'Schiittelfrost', u'Sch\xfcttelfrost'), (u'schiitten', u'sch\xfctten'), (u'schiittet', u'sch\xfcttet'), (u'schiitze', u'sch\xe4tze'), (u'schiitzen', u'sch\xfctzen'), (u'schiitzt', u'sch\xfctzt'), (u'schijn', u'sch\xf6n'), (u'Schijnes', u'Sch\xf6nes'), (u'schijng', u'sch\xf6n!'), (u'Schijssel', u'Sch\xfcssel'), (u'schijttelt', u'sch\xfcttelt'), (u'Schijtze', u'Sch\xfctze'), (u'schijtzen', u'sch\xfctzen'), (u'Schildkr\xe9te', u'Schildkr\xf6te'), (u'Schilrze', u'Sch\xfcrze'), (u'Schilsse', u'Sch\xfcsse'), (u'schiltten', u'sch\xfctten'), (u'schiltzen', u'sch\xfctzen'), (u'schimte', u'sch\xe4mte'), (u'Schizophrenia', u'Schizophrenie'), (u'Schi\xe9tze', u'Sch\xe4tze'), (u'Schlachtgetllimmels', u'Schlachtget\xfcmmels'), (u'Schlachtschifl', u'Schlachtschiff'), (u'schlafenl', u'schlafen!'), (u'Schlafk\xe9fern', u'Schlafk\xe4fern'), (u'Schlafmiitzenl', u'Schlafm\xfctzen!'), (u'Schlafm\ufb02tzel', u'Schlafm\xfctze!'), (u'Schlangeng\xe9ttin', u'Schlangeng\xf6ttin'), (u'Schlappschw\xe9nze', u'Schlappschw\xe4nze'), (u'Schlaumeierl', u'Schlaumeier!'), (u'schlechf', u'schlecht'), (u'Schlelistiinde', u'Schie\xdfst\xe4nde'), (u'Schlellen', u'Schie\xdfen'), (u'Schle\ufb02t', u'Schie\xdft'), (u'Schlfilsselparty', u'Schl\xfcsselparty'), (u'Schlfisse', u'Schl\xfcsse'), (u'SchlieBe', u'Schlie\xdfe'), (u'schlieBen', u'schlie\xdfen'), (u'schlieBIich', u'schlie\xdflich'), (u'schlieBlich', u'schlie\xdflich'), (u'SchlieBt', u'Schlie\xdft'), (u'schlief$en', u'schlie\xdfen'), (u'Schlief$lich', u'Schlie\xdflich'), (u'schlief2>lich', u'schlie\xdflich'), (u'schlief3t', u'schlie\xdft'), (u'Schliefie', u'Schlie\xdfe'), (u'schliefien', u'schlie\xdfen'), (u'Schliefilich', u'Schlie\xdflich'), (u'schlieflslich', u'schlie\xdflich'), (u'schliel3en', u'schlie\xdfen'), (u'schliel3lich', u'schlie\xdflich'), (u'Schliel5t', u'Schlie\xdft'), (u'schlielie', u'schlie\xdfe'), (u'schlielien', u'schlie\xdfen'), (u'schlielilich', u'schlie\xdflich'), (u'schliellsen', u'schlie\xdfen'), (u'SchlielSt', u'Schlie\xdft'), (u'Schliissel', u'Schl\xfcssel'), (u'Schliissell', u'Schl\xfcssel!'), (u'Schliisselmoment', u'Schl\xfcsselmoment'), (u'Schliisseln', u'Schl\xfcsseln'), (u'Schlijsse', u'Schl\xfcsse'), (u'Schlijssel', u'Schl\xfcssel'), (u'Schlijsselloch', u'Schl\xfcsselloch'), (u'Schlilssel', u'Schl\xfcssel'), (u'Schlilssell', u'Schl\xfcssel'), (u'Schlilsselparty', u'Schl\xfcsselparty'), (u'schlimmsterAlbtraum', u'schlimmster Albtraum'), (u'Schlle\ufb02en', u'Schlie\xdfen'), (u'Schllisse', u'Sch\xfcsse'), (u'schllitze', u'sch\xfctze'), (u'schllitzen', u'sch\xfctzen'), (u'Schlllissell', u'Schl\xfcssel!'), (u'Schlull', u'Schluss'), (u'Schlupfern', u'Schl\xfcpfern'), (u'Schlusselmoment', u'Schl\xfcsselmoment'), (u'Schlusselszenen', u'Schl\xfcsselszenen'), (u'Schlusselw\xe9rter', u'Schlusselw\xf6rter'), (u'Schlussl', u'Schluss!'), (u'Schlu\xdf', u'Schluss'), (u'Schl\xe9chter', u'Schl\xe4chter'), (u'schl\xe9fst', u'schl\xe4fst'), (u'Schl\xe9ft', u'Schl\xe4ft'), (u'Schl\xe9ge', u'Schl\xe4ge'), (u'Schl\xe9ger', u'Schl\xe4ger'), (u'Schl\xe9gerei', u'Schl\xe4gerei'), (u'schl\xe9gt', u'schl\xe4gt'), (u'schl\xe9ift', u'schl\xe4ft'), (u'schl\xe9igst', u'schl\xe4gst'), (u'Schl\ufb02ssel', u'Schl\xfcssel'), (u'Schmatzger\xe9usche', u'Schmatzger\xe4usche'), (u'SchmeiBt', u'Schmei\xdft'), (u'Schmeif$', u'Schmei\xdf'), (u'Schmeif$t', u'Schmei\xdft'), (u'Schmeifien', u'Schmei\xdfen'), (u'schmeifit', u'schmei\xdft'), (u'Schmeilit', u'Schmei\xdft'), (u'Schmei\ufb02', u'Schmei\xdf'), (u'Schmier\xe9l', u'Schmier\xf6l'), (u'schmiicken', u'schm\xfccken'), (u'schmilztl', u'schmilzt!'), (u'schmi\ufb02', u'schmiss'), (u'Schmuckk\xe9stchen', u'Schmuckk\xe4stchen'), (u'Schmuckstiick', u'Schmuckst\xfcck'), (u'Schnappschijsse', u'Schnappsch\xfcsse'), (u'Schnauzel', u'Schnauze!'), (u'Schneegest\xe9ber', u'Schneegest\xf6ber'), (u'Schneidez\xe9hnen', u'Schneidez\xe4hnen'), (u'Schneidez\xe9ihne', u'Schneidez\xe4hne'), (u'schnellf', u'schnell!'), (u'Schnfiffeln', u'Schn\xfcffeln'), (u'schnfiffelnl', u'schn\xfcffeln!'), (u'schnfiffelst', u'schn\xfcffelst'), (u'Schnfirsenkel', u'Schn\xfcrsenkel'), (u'schniiffele', u'schn\xfcffele'), (u'schnijffelt', u'schn\xfcffelt'), (u'Schnilffeln', u'Schn\xfcffeln'), (u'schnilrt', u'schn\xfcrt'), (u'Schnitzereigesch\xe9ft', u'Schnitzereigesch\xe4ft'), (u'Schniuzer', u'Schn\xe4uzer'), (u'Schnuoki', u'Schnucki'), (u'Schn\xe9ppchen', u'Schn\xe4ppchen'), (u'SchoB', u'Scho\xdf'), (u'Schofk', u'Scho\xdf'), (u'ScholShund', u'Scho\xdfhund'), (u'Schones', u'Sch\xf6nes'), (u'schonl', u'schon!'), (u'schopferische', u'sch\xf6pferische'), (u'scho\xdf', u'schoss'), (u'Schrankw\xe9nde', u'Schrankw\xe4nde'), (u'Schraubenschlijssel', u'Schraubenschl\xfcssel'), (u'schrecklichl', u'schrecklich!'), (u'Schriftist', u'Schrift ist'), (u'Schriftstijcks', u'Schriftst\xfccks'), (u'schr\xe9ge', u'schr\xe4ge'), (u'Schr\xe9ges', u'Schr\xe4ges'), (u'Schr\xe9nke', u'Schr\xe4nke'), (u'Schr\xe9nken', u'Schr\xe4nken'), (u'schtin', u'sch\xf6n'), (u'schtine', u'sch\xf6ne'), (u'Schtisse', u'Sch\xfcsse'), (u'schuchtern', u'sch\xfcchtern'), (u'Schuchterne', u'Sch\xfcchterne'), (u'Schuhl', u'Schuh!'), (u'Schuldgeftihlen', u'Schuldgef\xfchlen'), (u'Schulterl', u'Schulter!'), (u'Schutzen', u'Sch\xfctzen'), (u'Schutzr\xe9ume', u'Schutzr\xe4ume'), (u'SCHUTZT', u'SCH\xdcTZT'), (u"Schw6r's", u"Schw\xf6r's"), (u'Schwachkop\ufb02', u'Schwachkop!'), (u'Schwanzlutscherl', u'Schwanzlutscher!'), (u'Schwarzh\xe9ndler', u'Schwarzh\xe4ndler'), (u'Schwarzweills', u'Schwarzwei\xdf'), (u'schwei\ufb02durchnisst', u'schwei\xdfdurchn\xe4sst'), (u'schwerh\xe9rig', u'schwerh\xf6rig'), (u'schwiicht', u'schw\xe4cht'), (u'schwiire', u'schw\xf6re'), (u'schwiiren', u'schw\xf6ren'), (u'Schwimmanziige', u'Schwimmanz\xfcge'), (u'schwi\xe9rmten', u'schw\xe4rmten'), (u'schwnre', u'schw\xf6re'), (u'Schw\xe9che', u'Schw\xe4che'), (u'Schw\xe9chen', u'Schw\xe4chen'), (u'schw\xe9cher', u'schw\xe4cher'), (u'schw\xe9cheren', u'schw\xe4cheren'), (u'schw\xe9chsten', u'schw\xe4chsten'), (u'Schw\xe9icheanfall', u'Schw\xe4cheanfall'), (u'Schw\xe9ichen', u'Schw\xe4chen'), (u'schw\xe9icher', u'schw\xe4cher'), (u'Schw\xe9ichling', u'Schw\xe4chling'), (u'Schw\xe9irmerei', u'Schw\xe4rmerei'), (u'schw\xe9irzeste', u'schw\xe4rzeste'), (u'Schw\xe9mme', u'Schw\xe4mme'), (u'schw\xe9re', u'schw\xf6re'), (u'schw\xe9ren', u'schw\xf6ren'), (u'Schw\xe9rme', u'Schw\xe4rme'), (u'schw\xe9rmt', u'schw\xe4rmt'), (u'schw\xe9rmte', u'schw\xe4rmte'), (u'Schw\xe9tzer', u'Schw\xe4tzer'), (u'sch\xe9biger', u'sch\xe4biger'), (u'Sch\xe9del', u'Sch\xe4del'), (u'Sch\xe9den', u'Sch\xe4den'), (u'Sch\xe9inder', u'Sch\xe4nder'), (u'sch\xe9ine', u'sch\xf6ne'), (u'sch\xe9inen', u'sch\xf6nen'), (u'Sch\xe9iner', u'Sch\xf6ner'), (u'sch\xe9irfen', u'sch\xe4rfen'), (u'sch\xe9le', u'sch\xe4le'), (u'sch\xe9me', u'sch\xe4me'), (u'Sch\xe9n', u'Sch\xf6n'), (u'sch\xe9ne', u'sch\xf6ne'), (u'Sch\xe9nen', u'Sch\xf6nen'), (u'Sch\xe9ner', u'Sch\xf6ner'), (u'Sch\xe9nes', u'Sch\xf6nes'), (u'Sch\xe9nheit', u'Sch\xf6nheit'), (u'sch\xe9nl', u'sch\xf6n!'), (u'sch\xe9nste', u'sch\xf6nste'), (u'sch\xe9nsten', u'sch\xf6nsten'), (u'sch\xe9nstes', u'sch\xf6nstes'), (u'Sch\xe9tzchen', u'Sch\xe4tzchen'), (u'Sch\xe9tze', u'Sch\xe4tze'), (u'sch\xe9tzen', u'sch\xe4tzen'), (u'sch\xe9tzt', u'sch\xe4tzt'), (u'Sch\xe9tzung', u'Sch\xe4tzung'), (u'Sch\xe9umen', u'Sch\xe4umen'), (u'sch\ufb02chtern', u'sch\xfcchtern'), (u"SCl'1lUSS6l", u'Schl\xfcssel'), (u'Scllrift', u'Schrift'), (u'scmoss', u'SCHLOSS'), (u'se/n', u'sein'), (u'Se/wen', u'Sehen'), (u'sehenl', u'sehen!'), (u'Sehenswlllrdigkeiten', u'Sehensw\xfcrdigkeiten'), (u'Sehnsilchte', u'Sehns\xfcchte'), (u'sehrangespannt', u'sehr angespannt'), (u'sehrjung', u'sehr jung'), (u'Sehrwohl', u'Sehr wohl'), (u'sehrzufrieden', u'sehr zufrieden'), (u'sehtjetzt', u'seht jetzt'), (u'Seidenglattl', u'Seidenglatt!'), (u'seidjetzt', u'seid jetzt'), (u'Seitwann', u'Seit wann'), (u'SEKRETARIN', u'SEKRET\xc4RIN'), (u'Sekretiir', u'Sekret\xe4r'), (u'Sekretir', u'Sekret\xe4r'), (u'Sekret\xe9irin', u'Sekret\xe4rin'), (u'Sekret\xe9rin', u'Sekret\xe4rin'), (u'sel/g', u'selig'), (u'selbstl', u'selbst!'), (u'selbststiindig', u'selbstst\xe4ndig'), (u'selbstsuchtige', u'selbsts\xfcchtige'), (u'selbstverstindlich', u'selbstverst\xe4ndlich'), (u'Selbstverstlndlich', u'Selbstverst\xe4ndlich'), (u'Selbstverst\xe9indlich', u'Selbstverst\xe4ndlich'), (u'Selbstverst\xe9ndlich', u'Selbstverst\xe4ndlich'), (u'seld', u'seid'), (u'selhst', u'selbst'), (u'SeligerVater', u'Seliger Vater'), (u'seln', u'sein'), (u'Selt', u'Seit'), (u'sentimalen', u'sentimentalen'), (u'seri\xe9ser', u'seri\xf6ser'), (u'Sexualit\xe9t', u'Sexualit\xe4t'), (u'Sfe', u'Sie'), (u'Sfidamerikas', u'S\xfcdamerikas'), (u'Sfidwind', u'S\xfcdwind'), (u'Sfifies', u'S\xfc\xdfes'), (u'Sfihne', u'S\xf6hne'), (u'Sfildner', u'S\xf6ldner'), (u'Sfilie', u'S\xfc\xdfe'), (u'Sfilieste', u'S\xfc\xdfeste'), (u'Sfi\ufb02igkeiten', u'S\xfc\xdfigkeiten'), (u'sfnd', u'sind'), (u'SICHERHEITSBEHORDE', u'SICHERHEITSBEH\xd6RDE'), (u'Sicherheitsgrijnden', u'Sicherheitsgr\xfcnden'), (u'Sichtubervvachung', u'Sicht\xfcberwachung'), (u'Sichtunterstutzung', u'Sichtunterst\xfctzung'), (u'Sieja', u'Sie ja'), (u'Sifihnchen', u'S\xf6hnchen'), (u'Signalst\xe9rke', u'Signalst\xe4rke'), (u'Siiden', u'S\xfcden'), (u'Siidfrankreich', u'S\xfcdfrankreich'), (u'siidliche', u's\xfcdliche'), (u'siil$', u's\xfc\xdf'), (u'siili', u's\xfc\xdf'), (u'Siilie', u'S\xfc\xdfe'), (u'siilier', u's\xfc\xdfer'), (u"SIim's", u"Slim's"), (u'Siinde', u'S\xfcnde'), (u'Siinden', u'S\xfcnden'), (u'Siinder', u'S\xfcnder'), (u'siindigen', u's\xfcndigen'), (u'sii\ufb02en', u's\xfc\xdfen'), (u'siJB', u's\xfc\xdf'), (u'SiJBe', u'S\xfc\xdfe'), (u'siJchtige', u's\xfcchtige'), (u'sijlien', u'si\xfc\xdfen'), (u'sijliesten', u's\xfc\xdfesten'), (u'Sijsser', u'S\xfc\xdfer'), (u'Sildtunnel', u'S\xfcdtunnel'), (u'Silfie', u'S\xfc\xdfe'), (u'Silfier', u'S\xfc\xdfer'), (u'Silfies', u'S\xfc\xdfes'), (u'silfker', u's\xfc\xdfer'), (u'Silnden', u'S\xfcnden'), (u'Silndenbock', u'S\xfcndenbock'), (u'sindja', u'sind ja'), (u'Sirl', u'Sir!'), (u'Sj_r', u'Sir'), (u'Skilaufen', u'Ski laufen'), (u'skrupelloserAnw\xe9lte', u'skrupelloser Anw\xe4lte'), (u"sL'lf$e", u's\xfc\xdfe'), (u'sL1B', u's\xfc\xdf'), (u'slch', u'sich'), (u'sle', u'sie'), (u'slebe', u'siebe'), (u'sLif$', u's\xfc\xdf'), (u'SLif$e', u'S\xfc\xdfe'), (u'SLif$er', u'S\xfc\xdfer'), (u'sLif$es', u's\xfc\xdfes'), (u'SLilSe', u'S\xfc\xdfe'), (u'Slliden', u'S\xfcden'), (u'Sllinde', u'S\xfcnde'), (u'sllindigen', u's\xfcndigen'), (u'Slnd', u'Sind'), (u'Slr', u'Sir'), (u'Slrs', u'Sirs'), (u'SoBen', u'So\xdfen'), (u'sofortl', u'sofort!'), (u'soh\xe9nen', u'sch\xf6nen'), (u'Solien', u'So\xdfen'), (u'sollenl', u'sollen!'), (u'SONDERMULL', u'SONDERM\xdcLL'), (u'sorgf\xe9iltig', u'sorgf\xe4ltig'), (u'sorgf\xe9ltig', u'sorgf\xe4ltig'), (u'souver\xe9ine', u'souver\xe4ne'), (u'souver\xe9inen', u'souver\xe4nen'), (u'souver\xe9ner', u'souver\xe4ner'), (u"sp'a'ter", u'sp\xe4ter'), (u'sp/elen', u'spielen'), (u'SpaB', u'Spa\xdf'), (u'Spaf$', u'Spa\xdf'), (u'Spaf2>', u'Spa\xdf'), (u'Spaffs', u'Spa\xdf'), (u'Spafi', u'Spa\xdf'), (u'Spafls', u'Spa\xdf'), (u'SpafS', u'Spa\xdf'), (u"Spal'5", u'Spa\xdf'), (u'Spal2>', u'Spa\xdf'), (u'Spal3', u'Spa\xdf'), (u'Spali', u'Spa\xdf'), (u'Spall', u'Spa\xdf'), (u'Spass', u'Spa\xdf'), (u'spat', u'sp\xe4t'), (u'spektakular', u'spektakul\xe4r'), (u'Spell', u'Sp\xe4\xdf'), (u'Spells', u'Sp\xe4\xdf'), (u'Spell\xbb', u'Spa\xdf'), (u'Spezialit\xe9t', u'Spezialit\xe4t'), (u'spfit', u'sp\xe4t'), (u'SpieB', u'Spie\xdf'), (u'spief$ig', u'spie\xdfig'), (u'Spielzeuggeschfiftn', u'Spielzeuggesch\xe4ft--'), (u'spiilte', u'sp\xfclte'), (u'spiiren', u'sp\xfcren'), (u'spiirt', u'sp\xfcrt'), (u'spiit', u'sp\xe4t'), (u'spijre', u'sp\xfcre'), (u'spijren', u'sp\xfcren'), (u'spijrt', u'sp\xfcrt'), (u'Spillmeier', u'Sp\xfclmeier'), (u'spilre', u'sp\xfcre'), (u'spilren', u'sp\xfcren'), (u'spit', u'sp\xe4t'), (u'Spitzenfriihstiick', u'Spitzenfr\xfchst\xfcck'), (u"spLir's", u"sp\xfcr's"), (u'splliren', u'sp\xfcren'), (u'splter', u'sp\xe4ter'), (u'Sportilbertragung', u'Sport\xfcbertragung'), (u'Sportsfraund', u'Sportsfreund'), (u'Sprachpijppchen', u'Sprachp\xfcppchen'), (u'SPRACHPUPPCHEN', u'SPRACHP\xdcPPCHEN'), (u'Spriichlein', u'Spr\xfcchlein'), (u'Sprilht', u'Spr\xfcht'), (u'spr\xe9che', u'spr\xe4che'), (u'spr\xe9chen', u'spr\xe4chen'), (u'spr\xe9chet', u'spr\xe4chet'), (u'Spr\ufb02che', u'Spr\xfcche'), (u'spr\ufb02ht', u'spr\xfcht'), (u'spUl', u'sp\xfcl'), (u'spUr', u'sp\xfcr'), (u'spurbare', u'sp\xfcrbare'), (u'spUrt', u'sp\xfcrt'), (u'sp\xa7ter', u'sp\xe4ter'), (u'Sp\xe4\xdf', u'Spa\xdf'), (u'sp\xe9it', u'sp\xe4t'), (u'sp\xe9iter', u'sp\xe4ter'), (u'sp\xe9t', u'sp\xe4t'), (u'Sp\xe9ter', u'Sp\xe4ter'), (u'Sp\xe9tzchen', u'Sp\xe4tzchen'), (u'Sp\xe9tzchenl', u'Sp\xe4tzchen!'), (u'ssh', u'sah'), (u'st6Bt', u'st\xf6\xdft'), (u'st6hnt', u'st\xf6hnt'), (u'st6lSt', u'st\xf6\xdft'), (u'St6rt', u'St\xf6rt'), (u'ST@HNT', u'ST\xd6HNT'), (u'Staatsaff\xe9ren', u'Staatsaff\xe4ren'), (u'staatsbllirgerliches', u'staatsb\xfcrgerliches'), (u'Staatsgesch\xe9fte', u'Staatsgesch\xe4fte'), (u'Standardan\xe9sthesie', u'Standardan\xe4sthesie'), (u'standig', u'st\xe4ndig'), (u'STARSCREAMI', u'STARSCREAM:'), (u'station\xe9r', u'station\xe4r'), (u'Statusmeldungl', u'Statusmeldung!'), (u'stdrte', u'st\xf6rte'), (u'stecktjede', u'steckt jede'), (u'Stehenbleiben', u'Stehen bleiben'), (u'Stehvermiigen', u'Stehverm\xf6gen'), (u'Steigbilgeldinger', u'Steigb\xfcgeldinger'), (u'Steinh\xe9user', u'Steinh\xe4user'), (u'Sternenkijsse', u'Sternenk\xfcsse'), (u'Steuererkl\xe9rung', u'Steuererkl\xe4rung'), (u'Steuererkl\xe9rungen', u'Steuererkl\xe4rungen'), (u'Steuerprtifer', u'Steuerpr\xfcfer'), (u'Steuerprtifung', u'Steuerpr\xfcfung'), (u'Steuersiitzen', u'Steuers\xe4tzen'), (u'stfipseln', u'st\xf6pseln'), (u'stfiren', u'st\xf6ren'), (u'stfirker', u'st\xe4rker'), (u'Stfirt', u'St\xf6rt'), (u'stfirzt', u'st\xfcrzt'), (u'stieB', u'stie\xdf'), (u'Stiefbriider', u'Stiefbr\xfcder'), (u'Stiicke', u'St\xfccke'), (u'Stiihle', u'St\xfchle'), (u'Stiihlen', u'St\xfchlen'), (u'stiihnt', u'st\xf6hnt'), (u'Stiillen', u'St\xe4llen'), (u'Stiire', u'St\xf6re'), (u'stiiren', u'st\xf6ren'), (u'Stiirme', u'St\xfcrme'), (u'stiirmischen', u'st\xfcrmischen'), (u'Stiirsignale', u'St\xf6rsignale'), (u'stiirt', u'st\xf6rt'), (u'Stiirung', u'St\xf6rung'), (u'stiirzen', u'st\xfcrzen'), (u'Stiitzpunkt', u'St\xfctzpunkt'), (u'Stijck', u'St\xfcck'), (u'Stijckchen', u'St\xfcckchen'), (u'Stijcke', u'St\xfccke'), (u'stijhle', u'st\xfchle'), (u'stijrme', u'st\xfcrme'), (u'stijrzen', u'st\xfcrzen'), (u'Stilck', u'St\xfcck'), (u'Stilcke', u'St\xfccke'), (u'Stillckchen', u'St\xfcckchen'), (u'Stillst\xe9nde', u'Stillst\xe4nde'), (u'Stilvolll', u'Stilvoll!'), (u'stinden', u'st\xe4nden'), (u'Stldseite', u'S\xfcdseite'), (u'stleg', u'stieg'), (u'Stllihle', u'St\xfchle'), (u'Stllirmen', u'St\xfcrmen'), (u'stllirzt', u'st\xfcrzt'), (u'stlllrzen', u'st\xfcrzen'), (u'Stl\ufb02', u'Stift'), (u'sto/3en', u'sto\xdfen'), (u'StoB', u'Sto\xdf'), (u'stoBe', u'sto\xdfe'), (u'stof$en', u'sto\xdfen'), (u'Stofi', u'Sto\xdf'), (u'STOHNT', u'ST\xd6HNT'), (u'Stol3zahn', u'Sto\xdfzahn'), (u'Stol3zeit', u'Sto\xdfzeit'), (u'stolie', u'sto\xdfe'), (u'Storung', u'St\xf6rung'), (u'Str6men', u'Str\xf6men'), (u'str6mt', u'str\xf6mt'), (u'StraBe', u'Stra\xdfe'), (u'StraBen', u'Stra\xdfen'), (u'StraBenk6tern', u'Stra\xdfenk\xf6tern'), (u'Straf$e', u'Stra\xdfe'), (u'Strafiengang', u'Stra\xdfengang'), (u'Strafienratten', u'Stra\xdfenratten'), (u'Strafienschlacht', u'Stra\xdfenschlacht'), (u'Straflsenecke', u'Stra\xdfenecke'), (u'Straflsenmaler', u'Stra\xdfenmaler'), (u'Straflsenschilder', u'Stra\xdfenschilder'), (u'Straft\xe9ter', u'Straft\xe4ter'), (u'Strahlenschutzger\xe9t', u'Strahlenschutzger\xe4t'), (u'Strahlungsintensit\xe9t', u'Strahlungsintensit\xe4t'), (u'Stral3en', u'Stra\xdfen'), (u'Stral5e', u'Stra\xdfe'), (u'Stralie', u'Stra\xdfe'), (u'Straliengang', u'Stra\xdfengang'), (u'Stralienk\xe9ter', u'Stra\xdfenk\xf6ter'), (u'Straliensperre', u'Stra\xdfensperre'), (u'Streitkr\xe9fte', u'Streitkr\xe4fte'), (u'Streitkr\xe9ften', u'Streitkr\xe4ften'), (u'Streit\xe9xte', u'Streit\xe4xte'), (u'strfimten', u'str\xf6mten'), (u'Striimen', u'Str\xf6men'), (u'Striimungen', u'Str\xf6mungen'), (u'Stromschliige', u'Stromschl\xe4ge'), (u'Stromschnellenl', u'Stromschnellen!'), (u'Stromung', u'Str\xf6mung'), (u'Strullerl', u'Struller!'), (u'Str\xe9mung', u'Str\xf6mung'), (u'Str\xe9mungen', u'Str\xf6mungen'), (u'sturzte', u'st\xfcrzte'), (u'STUTZPUNKT', u'ST\xdcTZPUNKT'), (u'St\xe9be', u'St\xe4be'), (u'st\xe9hnt', u'st\xf6hnt'), (u'st\xe9hnte', u'st\xf6hnte'), (u'St\xe9idtchen', u'St\xe4dtchen'), (u'St\xe9idte', u'St\xe4dte'), (u'st\xe9indig', u'st\xe4ndig'), (u'St\xe9irke', u'St\xe4rke'), (u'st\xe9irker', u'st\xe4rker'), (u'St\xe9irkeres', u'St\xe4rkeres'), (u'st\xe9llst', u'st\xf6\xdft'), (u'St\xe9ndchen', u'St\xe4ndchen'), (u'St\xe9nder', u'St\xe4nder'), (u'St\xe9ndig', u'St\xe4ndig'), (u'st\xe9pseln', u'st\xf6pseln'), (u'st\xe9ren', u'st\xf6ren'), (u'St\xe9rke', u'St\xe4rke'), (u'St\xe9rken', u'St\xe4rken'), (u'st\xe9rker', u'st\xe4rker'), (u'St\xe9rkere', u'St\xe4rkere'), (u'st\xe9rkeres', u'st\xe4rkeres'), (u'st\xe9rkste', u'st\xe4rkste'), (u'st\xe9rst', u'st\xf6rst'), (u'st\xe9rt', u'st\xf6rt'), (u'St\xe9rung', u'St\xf6rung'), (u'St\xe9tten', u'St\xe4tten'), (u'St\ufb02ck', u'St\xfcck'), (u'St\ufb02hlen', u'St\xfchlen'), (u'sUB', u's\xfc\xdf'), (u'sUBe', u's\xfc\xdfe'), (u'Suchfeam', u'Suchteam'), (u'SUden', u'S\xfcden'), (u'Sudseite', u'S\xfcdseite'), (u'Sudwest', u'S\xfcdwest'), (u'sUf$', u's\xfc\xdf'), (u'SUf$e', u'S\xfc\xdfe'), (u'suMM\u2020', u'SUMMT'), (u'Suohet', u'Suchet'), (u'Superkr\xe9fte', u'Superkr\xe4fte'), (u'superl\xe9cherlich', u'superl\xe4cherlich'), (u"s\xa2'il3", u's\xfc\xdf'), (u'S\xe9cke', u'S\xe4cke'), (u'S\xe9ge', u'S\xe4ge'), (u's\xe9he', u's\xe4he'), (u'S\xe9hne', u'S\xf6hne'), (u'S\xe9hnen', u'S\xf6hnen'), (u'S\xe9icke', u'S\xe4cke'), (u'S\xe9inger', u'S\xe4nger'), (u'S\xe9iulen', u'S\xe4ulen'), (u'S\xe9ldner', u'S\xf6ldner'), (u's\xe9mfl/che', u's\xe4mtliche'), (u's\xe9mtliche', u's\xe4mtliche'), (u's\xe9mtlichen', u's\xe4mtlichen'), (u'S\xe9nger', u'S\xe4nger'), (u'S\xe9ngerin', u'S\xe4ngerin'), (u's\xe9ubern', u's\xe4ubern'), (u's\xe9uft', u's\xe4uft'), (u's\xe9ugen', u's\xe4ugen'), (u'S\xe9ulen', u'S\xe4ulen'), (u'S\xe9urewannen', u'S\xe4urewannen'), (u'S\ufb02dh\xe9ingen', u'S\xfcdh\xe4ngen'), (u'T6chter', u'T\xf6chter'), (u'T6pfchen', u'T\xf6pfchen'), (u'T6rn', u'T\xf6rn'), (u'T6rtchen', u'T\xf6rtchen'), (u't6te', u't\xf6te'), (u'T6ten', u'T\xf6ten'), (u't6tet', u't\xf6tet'), (u'TANZERINNEN', u'T\xc4NZERINNEN'), (u'Tater', u'T\xe4ter'), (u'tats\xe9chlich', u'tats\xe4chlich'), (u'tats\xe9chliche', u'tats\xe4chliche'), (u'tats\xe9ichlich', u'tats\xe4chlich'), (u'Tatverd\xe9ichtigen', u'Tatverd\xe4chtigen'), (u'Tauchg\xe9inge', u'Tauchg\xe4nge'), (u'Tauchg\xe9nge', u'Tauchg\xe4nge'), (u'Tauschgesch\xe9fte', u'Tauschgesch\xe4fte'), (u'Tauschgesch\xe9\ufb02e', u'Tauschgesch\xe4fte'), (u'Tbrn', u'T\xf6rn'), (u'tbten', u't\xf6ten'), (u'tdten', u't\xf6ten'), (u'tdtete', u't\xf6tete'), (u'Telefongespr\xe9che', u'Telefongespr\xe4che'), (u'Tempelsch\xe9nderf', u'Tempelsch\xe4nder!'), (u'TemPO', u'Tempo'), (u'TESTGELANDE', u'TESTGEL\xc4NDE'), (u'Testvorf\ufb02hrungen', u'Testvorf\xfchrungen'), (u'tfidlich', u't\xf6dlich'), (u'tfiitet', u't\xf6tet'), (u'Tfir', u'T\xfcr'), (u'tfirkischen', u't\xfcrkischen'), (u'Tfite', u'T\xfcte'), (u'Theaterstfick', u'Theaterst\xfcck'), (u'Therapiel', u'Therapie!'), (u'Thermalger\xe9t', u'Thermalger\xe4t'), (u'Thronr\xe9uber', u'Thronr\xe4uber'), (u'Thronr\xe9uberin', u'Thronr\xe4uberin'), (u'Tiefkilhlung', u'Tiefk\xfchlung'), (u'Tiefktih/system', u'Tiefk\xfchlsystem'), (u'Tiefktihleind\xe9mmung', u'Tiefk\xfchleind\xe4mmung'), (u'TIEFKUHL', u'TIEFK\xdcHL'), (u'Tiefkuhlstasis', u'Tiefk\xfchlstasis'), (u'Tiefkuhlung', u'Tiefk\xfchlung'), (u'tiglich', u't\xe4glich'), (u'tiichtige', u't\xfcchtige'), (u'tiint', u't\xf6nt'), (u'Tiipfchen', u'T\xf6pfchen'), (u'Tiipfchennummer', u'T\xf6pfchennummer'), (u'Tiir', u'T\xfcr'), (u'Tiiren', u'T\xfcren'), (u'Tiirl', u'T\xfcr!'), (u'Tiirme', u'T\xfcrme'), (u'tiite', u't\xf6te'), (u'Tiite', u'T\xfcte'), (u'tiiten', u't\xf6ten'), (u'tiitet', u't\xf6tet'), (u'tiitete', u't\xf6tete'), (u'TiJr', u'T\xfcr'), (u'Tijrme', u'T\xfcrme'), (u'Tilr', u'T\xfcr'), (u'Tilrglocke', u'T\xfcrglocke'), (u'Tilrklingel', u'T\xfcrklingel'), (u'Tilr\xe9ffner', u'T\xfcr\xf6ffner'), (u'Tippger\xe9usch', u'Tippger\xe4usch'), (u'Tischlenuerkstatt', u'Tischlerwerkstatt'), (u"TL'lr", u'T\xfcr'), (u'tlglich', u't\xe4glich'), (u'Tllir', u'T\xfcr'), (u'Tllirkei', u'T\xfcrkei'), (u'Tlllpfelchen', u'T\xfcpfelchen'), (u'TOILETTENSPULUNG', u'TOILETTENSP\xdcLUNG'), (u'Tonl', u'Ton'), (u'Toreroabs\xe9tze', u'Toreroabs\xe4tze'), (u'Tortenb\xe9ickerin', u'Tortenb\xe4ckerin'), (u'Tragfidie', u'Trag\xf6die'), (u'Tragiidie', u'Trag\xf6die'), (u'Trag\xe9die', u'Trag\xf6die'), (u'Trainingsijbung', u'Trainings\xfcbung'), (u'TRAUMKCRPER', u'TRAUMK\xd6RPER'), (u'treffan', u'treffen'), (u'trfiumen', u'tr\xe4umen'), (u'Tribiinen', u'Trib\xfcnen'), (u"trif'f't", u'trifft'), (u'trigt', u'tr\xe4gt'), (u'Triibsal', u'Tr\xfcbsal'), (u'Triimmem', u'Tr\xfcmmern'), (u'triistllch', u'tr\xf6stlich'), (u'Triistungen', u'Tr\xf6stungen'), (u'Triiume', u'Tr\xe4ume'), (u'Trilmmer', u'Tr\xfcmmer'), (u'triume', u'tr\xe4ume'), (u'Trockenger\xe9ite', u'Trockenger\xe4te'), (u'Trockenger\xe9te', u'Trockenger\xe4te'), (u'Tropfsteinhiihle', u'Tropfsteinh\xf6hle'), (u'Trottell', u'Trottel!'), (u'Trubsal', u'Tr\xfcbsal'), (u'tr\xe9ge', u'tr\xe4ge'), (u'Tr\xe9gerschiff', u'Tr\xe4gerschiff'), (u'tr\xe9gt', u'tr\xe4gt'), (u'Tr\xe9igerschiff', u'Tr\xe4gerschiff'), (u'tr\xe9igt', u'tr\xe4gt'), (u'tr\xe9ium', u'tr\xe4um'), (u'tr\xe9iume', u'tr\xe4ume'), (u'tr\xe9iumen', u'tr\xe4umen'), (u'tr\xe9iumt', u'tr\xe4umt'), (u'tr\xe9llert', u'tr\xe4llert'), (u'Tr\xe9ne', u'Tr\xe4ne'), (u'Tr\xe9nen', u'Tr\xe4nen'), (u'Tr\xe9um', u'Tr\xe4um'), (u'tr\xe9ume', u'tr\xe4ume'), (u'Tr\xe9umen', u'Tr\xe4umen'), (u'Tr\xe9umer', u'Tr\xe4umer'), (u'tr\xe9umst', u'tr\xe4umst'), (u'Tr\xe9umt', u'Tr\xe4umt'), (u'Tschiiss', u'Tsch\xfcss'), (u'Tschiissl', u'Tsch\xfcss!'), (u'tschijss', u'tsch\xfcss'), (u'Tschtiss', u'Tsch\xfcss'), (u'tsch\xfc\xdf', u'tsch\xfcss'), (u'Tsch\ufb02s', u'Tsch\xfcs'), (u'Ttir', u'T\xfcr'), (u'ttlckisch', u't\xfcckisch'), (u'Ttlte', u'T\xfcte'), (u'tubul\xe9re', u'tubul\xe4re'), (u'Tupperschiissel', u'Tuppersch\xfcssel'), (u'TUR', u'T\xdcR'), (u'TUr', u'T\xfcr'), (u'Turen', u'T\xfcren'), (u'TURKEI', u'T\xdcRKEI'), (u'Turmwiichter', u'Turmw\xe4chter'), (u'tutjetzt', u'tut jetzt'), (u'typlschl', u'typlsch!'), (u'T\xe9chter', u'T\xf6chter'), (u't\xe9d/ichen', u't\xf6dlichen'), (u't\xe9dlich', u't\xf6dlich'), (u't\xe9dliche', u't\xf6dliche'), (u't\xe9dlichen', u't\xf6dlichen'), (u't\xe9glich', u't\xe4glich'), (u't\xe9glichen', u't\xe4glichen'), (u't\xe9iglich', u't\xe4glich'), (u't\xe9itowieren', u't\xe4towieren'), (u't\xe9itowierte', u't\xe4towierte'), (u'T\xe9itowierung', u'T\xe4towierung'), (u't\xe9iuschen', u't\xe4uschen'), (u'T\xe9ler', u'T\xe4ler'), (u'T\xe9lpell', u'T\xf6lpel!'), (u'T\xe9nze', u'T\xe4nze'), (u'T\xe9nzerin', u'T\xe4nzerin'), (u'T\xe9pfchen', u'T\xf6pfchen'), (u'T\xe9pfchenquatsch', u'T\xf6pfchenquatsch'), (u'T\xe9pfchensache', u'T\xf6pfchensache'), (u't\xe9te', u't\xf6te'), (u'T\xe9ten', u'T\xf6ten'), (u't\xe9test', u't\xe4test'), (u't\xe9tet', u't\xf6tet'), (u't\xe9tete', u't\xf6tete'), (u't\xe9towieren', u't\xe4towieren'), (u't\xe9towierte', u't\xe4towierte'), (u'T\xe9towierung', u'T\xe4towierung'), (u'T\xe9towierungen', u'T\xe4towierungen'), (u't\xe9uschen', u't\xe4uschen'), (u't\xe9uscht', u't\xe4uscht'), (u'T\xe9uschung', u'T\xe4uschung'), (u'T\xe9uschungsman\xe9ver', u'T\xe4uschungsman\xf6ver'), (u"Ub6FpFUfl'T1al", u'\xfcberpr\xfcf'), (u"Ub6l'pl'Uf\u20ac", u'\xdcberpr\xfcfe'), (u'Ube', u'\xdcbe'), (u'Ubel', u'\xfcbel'), (u'Ubelkeit', u'\xdcbelkeit'), (u'Ubelt\xe9ter', u'\xdcbelt\xe4ter'), (u'Uben', u'\xdcben'), (u'Uben/vachen', u'\xdcberwachen'), (u'Uben/vacher', u'\xdcberwacher'), (u'Uben/vacht', u'\xdcberwacht'), (u'Uben/vachungen', u'\xdcberwachungen'), (u'Uben/vachungsgesetz', u'\xdcberwachungsgesetz'), (u'Uben/vinden', u'\xfcberwinden'), (u'Uber', u'\xfcber'), (u'UBER', u'\xdcBER'), (u'Uberall', u'\xfcberall'), (u'Uberanstrenge', u'\xfcberanstrenge'), (u'Uberanstrengung', u'\xdcberanstrengung'), (u'Uberarbeiten', u'\xdcberarbeiten'), (u'UberAuf$erirdische', u'\xfcber Au\xdferirdische'), (u'Uberaus', u'\xfcberaus'), (u'Uberbleibsel', u'\xdcberbleibsel'), (u'Uberblick', u'\xdcberblick'), (u'Uberbringe', u'\xfcberbringe'), (u'Uberdauern', u'\xfcberdauern'), (u'Uberdecken', u'\xfcberdecken'), (u'Ubereinstimmung', u'\xdcbereinstimmung'), (u'Uberfahren', u'\xfcberfahren'), (u'Uberfall', u'\xdcberfall'), (u'Uberflilssig', u'\xfcberfl\xfcssig'), (u'Ubergabe', u'\xdcbergabe'), (u'Ubergaben', u'\xdcbergaben'), (u'Ubergabepunkt', u'\xdcbergabepunkt'), (u'Ubergangen', u'\xfcbergangen'), (u'Ubergangsweise', u'\xfcbergangsweise'), (u'Ubergeben', u'\xfcbergeben'), (u'Ubergehen', u'\xfcbergehen'), (u'Uberhaupt', u'\xdcberhaupt'), (u'Uberholt', u'\xdcberholt'), (u'Uberholter', u'\xfcberholter'), (u'Uberh\xe9rt', u'\xfcberh\xf6rt'), (u'Uberjemanden', u'\xfcber jemanden'), (u'Uberlagerungs', u'\xdcberlagerungs'), (u'Uberlandleitungen', u'\xdcberlandleitungen'), (u'Uberlass', u'\xdcberlass'), (u'Uberlasse', u'\xfcberlasse'), (u'Uberlassen', u'\xfcberlassen'), (u'Uberlassenl', u'\xfcberlassen!'), (u'Uberlasteten', u'\xdcberlasteten'), (u'Uberleben', u'\xdcberleben'), (u'Uberlebende', u'\xdcberlebende'), (u'Uberlebenden', u'\xdcberlebenden'), (u'Uberlebenschancen', u'\xdcberlebenschancen'), (u'Uberlebenswichtigen', u'\xfcberlebenswichtigen'), (u'Uberlebt', u'\xfcberlebt'), (u'Uberleg', u'\xfcberleg'), (u'Uberlegen', u'\xdcberlegen'), (u'Uberlegenheit', u'\xdcberlegenheit'), (u'uberlegt', u'\xfcberlegt'), (u'Uberlegten', u'\xfcberlegten'), (u'Uberleiten', u'\xfcberleiten'), (u'Uberleitung', u'\xdcberleitung'), (u'Uberlieferungen', u'\xdcberlieferungen'), (u'Uberl\xe9sst', u'\xfcberl\xe4sst'), (u'Uberm', u'\xfcberm'), (u'Ubermorgen', u'\xdcbermorgen'), (u'Ubernachtungsgast', u'\xdcbernachtungsgast'), (u'Ubernahm', u'\xfcbernahm'), (u'Ubernahme', u'\xdcbernahme'), (u'Ubernahmen', u'\xfcbernahmen'), (u'Ubernehme', u'\xfcbernehme'), (u'Ubernehmen', u'\xfcbernehmen'), (u'Ubernimmst', u'\xfcbernimmst'), (u'ubernimmt', u'\xfcbernimmt'), (u'Ubernommen', u'\xfcbernommen'), (u'Uberpriifen', u'\xfcberpr\xfcfen'), (u'Uberprilfen', u'\xfcberpr\xfcfen'), (u'Uberprliifen', u'\xdcberpr\xfcfen'), (u'Uberprufe', u'\xfcberpr\xfcfe'), (u'Uberprufen', u'\xfcberpr\xfcfen'), (u'Uberpruft', u'\xfcberpr\xfcft'), (u'Uberraschend', u'\xdcberraschend'), (u'Uberrascht', u'\xdcberrascht'), (u'Uberraschte', u'\xdcberraschte'), (u'Uberraschter', u'\xfcberraschter'), (u'Uberraschung', u'\xdcberraschung'), (u'Uberraschungen', u'\xdcberraschungen'), (u'Uberraschungl', u'\xdcberraschung!'), (u'Uberreagiert', u'\xfcberreagiert'), (u'Uberreden', u'\xfcberreden'), (u'Uberredet', u'\xdcberredet'), (u'Uberreste', u'\xdcberreste'), (u'Uberrumpeln', u'\xfcberrumpeln'), (u'Uberrumple', u'\xdcberrumple'), (u'Ubers', u'\xfcbers'), (u'Uberschl\xe9gt', u'\xdcberschl\xe4gt'), (u'Uberschreiten', u'\xdcberschreiten'), (u'Uberschritten', u'\xfcberschritten'), (u'Uberschwemmung', u'\xdcberschwemmung'), (u'Ubersehen', u'\xfcbersehen'), (u'Ubersensibilit\xe9t', u'\xdcbersensibilit\xe4t'), (u'Ubersetzung', u'\xdcbersetzung'), (u'Uberspannte', u'\xfcberspannte'), (u'Uberspielt', u'\xfcberspielt'), (u'Uberstehen', u'\xdcberstehen'), (u'Ubersteigerten', u'\xfcbersteigerten'), (u'Ubersteigt', u'\xfcbersteigt'), (u'Uberstunden', u'\xdcberstunden'), (u'Ubertraf', u'\xfcbertraf'), (u'UBERTRAGEN', u'\xdcBERTRAGEN'), (u'Ubertragen', u'\xfcbertragen'), (u'UBERTRAGUNG', u'\xdcBERTRAGUNG'), (u'ubertreibe', u'\xfcbertreibe'), (u'Ubertreiben', u'\xfcbertreiben'), (u'Ubertrieben', u'\xfcbertrieben'), (u'Ubertriebene', u'\xdcbertriebene'), (u'ubertriebener', u'\xfcbertriebener'), (u'Ubertrifft', u'\xdcbertrifft'), (u'Ubervvachen', u'\xfcberwachen'), (u'Ubervvacht', u'\xfcberwacht'), (u'Ubervvachung', u'\xdcberwachung'), (u'Ubervvachungs', u'\xdcberwachungs'), (u'Ubervvachungsstaat', u'\xdcberwachungsstaat'), (u'Ubervvachungsstaats', u'\xdcberwachungsstaats'), (u'Ubervvachungsvideos', u'\xdcberwachungsvideos'), (u'Ubervv\xe9iltigend', u'\xfcberw\xe4ltigend'), (u'Uberwachen', u'\xfcberwachen'), (u'Uberwacher', u'\xdcberwacher'), (u'Uberwachung', u'\xdcberwachung'), (u'Uberzeuge', u'\xfcberzeuge'), (u'Uberzeugen', u'\xfcberzeugen'), (u'Uberzeugend', u'\xfcberzeugend'), (u'Uberzeugt', u'\xfcberzeugt'), (u'Uberzeugung', u'\xdcberzeugung'), (u'Uberzeugungen', u'\xdcberzeugungen'), (u'Uberziehen', u'\xfcberziehen'), (u'Uberzuleiten', u'\xfcberzuleiten'), (u'ublem', u'\xfcblem'), (u'Ubler', u'\xdcbler'), (u'Ubles', u'\xdcbles'), (u'Ublich', u'\xfcblich'), (u'Ubliche', u'\xdcbliche'), (u'ublichen', u'\xfcblichen'), (u'Ubrig', u'\xfcbrig'), (u'Ubrige', u'\xdcbrige'), (u'Ubrigen', u'\xdcbrigen'), (u'Ubrigens', u'\xfcbrigens'), (u'Ubrlgens', u'\xdcbrigens'), (u'Ubrllccol', u'Ubriacco!'), (u'Ubung', u'\xdcbung'), (u'Ubungsbedingungen', u'\xdcbungsbedingungen'), (u'Ubungsschiisse', u'\xdcbungssch\xfcsse'), (u'Ubungsschusse', u'\xdcbungssch\xfcsse'), (u"Ub\u20acf'pf'Uf\u20acl'1", u'\xfcberpr\xfcfen'), (u'Uher', u'\xdcber'), (u'ultrakiistlichl', u'ultrak\xf6stlich!'), (u'umgeriistet', u'umger\xfcstet'), (u'umg\xe9nglich', u'umg\xe4nglich'), (u'umhdren', u'umh\xf6ren'), (u'umh\xe9ngt', u'umh\xe4ngt'), (u'Umschlfigen', u'Umschl\xe4gen'), (u'umschlieBt', u'umschlie\xdft'), (u'Umst\xe9inden', u'Umst\xe4nden'), (u'Umst\xe9nde', u'Umst\xe4nde'), (u'Umst\xe9nden', u'Umst\xe4nden'), (u'umst\xe9ndlich', u'umst\xe4ndlich'), (u'umweltsch\xe9dlich', u'umweltsch\xe4dlich'), (u'unabhiingiges', u'unabh\xe4ngiges'), (u'unabh\xe9ingig', u'unabh\xe4ngig'), (u'unabh\xe9ngig', u'unabh\xe4ngig'), (u'unabl\xe9ssig', u'unabl\xe4ssig'), (u'Unauff\xe9lligeres', u'Unauff\xe4lligeres'), (u'unaufhalfsam', u'unaufhaltsam'), (u'unaufhiirlich', u'unaufh\xf6rlich'), (u'unaufh\xe9rlich', u'unaufh\xf6rlich'), (u'unaufi\xe9llig', u'unauff\xe4llig'), (u'unberijhrbar', u'unber\xfchrbar'), (u'unberllihrten', u'unber\xfchrten'), (u'unbesch\xe9digt', u'unbesch\xe4digt'), (u'Uncl', u'Und'), (u'undja', u'und ja'), (u'undjeder', u'und jeder'), (u'undjemand', u'und jemand'), (u'undjetzt', u'und jetzt'), (u'undlassenihn', u'und lassen ihn'), (u'undlhnen', u'und Ihnen'), (u'undurchfuhrbar', u'undurchf\xfchrbar'), (u'uneingeschr\xe9nkten', u'uneingeschr\xe4nkten'), (u'unergrilndliche', u'unergr\xfcndliche'), (u'unerhort', u'unerh\xf6rt'), (u'unerhorte', u'unerh\xf6rte'), (u'unerkl\xe9rliche', u'unerkl\xe4rliche'), (u'unerkl\xe9rlichen', u'unerkl\xe4rlichen'), (u'unertr\xe9glich', u'unertr\xe4glich'), (u"unf'a'hig", u'unf\xe4hig'), (u'Unfahigkeit', u'Unf\xe4higkeit'), (u'unfersfellen', u'unterstellen'), (u'unfiirmigen', u'unf\xf6rmigen'), (u'unf\xe9hig', u'unf\xe4hig'), (u'unf\xe9higste', u'unf\xe4higste'), (u'unf\xe9ihigste', u'unf\xe4higste'), (u'Unf\xe9ille', u'Unf\xe4lle'), (u'Unf\xe9lle', u'Unf\xe4lle'), (u'ungef\xe9hr', u'ungef\xe4hr'), (u'ungef\xe9hre', u'ungef\xe4hre'), (u'Ungef\xe9ihr', u'Ungef\xe4hr'), (u'ungef\xe9ihrlich', u'ungef\xe4hrlich'), (u'ungemutlich', u'ungem\xfctlich'), (u'ungenugend', u'ungen\xfcgend'), (u'ungestbrt', u'ungest\xf6rt'), (u'ungewfihnliche', u'ungew\xf6hnliche'), (u'Ungewfjhnliches', u'Ungew\xf6hnliches'), (u'ungewiihnlich', u'ungew\xf6hnlich'), (u'Ungewijhnliches', u'Ungew\xf6hnliches'), (u'ungew\xe9hnlich', u'ungew\xf6hnlich'), (u'ungew\xe9hnliche', u'ungew\xf6hnliche'), (u'ungew\xe9hnlichste', u'ungew\xf6hnlichste'), (u'ungfinstigen', u'ung\xfcnstigen'), (u'ungiiltig', u'ung\xfcltig'), (u'ungilnstig', u'ung\xfcnstig'), (u'Unglaubliohl', u'Unglaublich!'), (u'unglaubwurdig', u'unglaubw\xfcrdig'), (u'Unglfiubige', u'Ungl\xe4ubige'), (u'Ungliicklicherweise', u'Ungl\xfccklicherweise'), (u'Unglilck', u'Ungl\xfcck'), (u"Ungll'Jcklichervveise", u'Ungl\xfccklicherweise'), (u'Unglllick', u'Ungl\xfcck'), (u'unglllicklich', u'ungl\xfccklich'), (u'ungllllckliche', u'ungl\xfcckliche'), (u'unglucklich', u'ungl\xfccklich'), (u'Ungl\xe9ubiger', u'Ungl\xe4ubiger'), (u'ungultig', u'ung\xfcltig'), (u'ungunstigen', u'ung\xfcnstigen'), (u'unheimlichl', u'unheimlich!'), (u'UNHORBARES', u'UNH\xd6RBARES'), (u'unh\xe9flich', u'unh\xf6flich'), (u'Universitlt', u'Universit\xe4t'), (u'Universit\xe9t', u'Universit\xe4t'), (u'unlfisbare', u'unl\xf6sbare'), (u'unm6glich', u'unm\xf6glich'), (u'unmfiglich', u'unm\xf6glich'), (u'Unmiiglich', u'Unm\xf6glich'), (u'Unmiigliche', u'Unm\xf6gliche'), (u'unmijglich', u'unm\xf6glich'), (u'unmissverst\xe9ndlich', u'unmissverst\xe4ndlich'), (u'unmoglich', u'unm\xf6glich'), (u'Unmtioglich', u'Unm\xf6glich'), (u'Unm\xe9glich', u'Unm\xf6glich'), (u'unm\xe9glioh', u'unm\xf6glich'), (u'unnatiirliche', u'unnat\xfcrliche'), (u'unnaturliche', u'unnat\xfcrliche'), (u'unnfitigen', u'unn\xf6tigen'), (u'unniitig', u'unn\xf6tig'), (u'unnllitz', u'unn\xfctz'), (u'unn\xe9tig', u'unn\xf6tig'), (u'unn\xe9tigen', u'unn\xf6tigen'), (u'unol', u'und'), (u'unp\xe9sslich', u'unp\xe4sslich'), (u'UNREGELMASSIG', u'UNREGELM\xc4SSIG'), (u'Unregelm\xe9fiigkeiten', u'Unregelm\xe4\xdfigkeiten'), (u'unschliissig', u'unschl\xfcssig'), (u'unserejungen', u'unsere jungen'), (u'unsererAnw\xe9lte', u'unserer Anw\xe4lte'), (u'unsererjungfr\xe9ulichen', u'unserer jungfr\xe4ulichen'), (u'unsjede', u'uns jede'), (u'uns\xe9glich', u'uns\xe4glich'), (u'Untenuelt', u'Unterwelt'), (u'unterdriickten', u'unterdr\xfcckten'), (u'Unterdrilckung', u'\xdcnterdr\xfcckung'), (u'unterdrtlckte', u'unterdr\xfcckte'), (u'Unterdr\ufb02ckung', u'Unterdr\xfcckung'), (u'Unterhaltskostenl', u'Unterhaltskosten!'), (u'Unterhaltungsm\xe9fiig', u'Unterhaltungsm\xe4\xdfig'), (u'unterhfilt', u'unterh\xe4lt'), (u'unterh\xe9lt', u'unterh\xe4lt'), (u'unterschitzt', u'untersch\xe4tzt'), (u'untersch\xe9tzte', u'untersch\xe4tzte'), (u'unterstiitzt', u'unterst\xfctzt'), (u'Unterstiitzung', u'Unterst\xfctzung'), (u'unterstijtzt', u'unterst\xfctzt'), (u'Unterstiltzung', u'Unterst\xfctzung'), (u'Unterstllitzung', u'Unterst\xfctzung'), (u'unterstutzen', u'unterst\xfctzen'), (u'unterstutzt', u'unterst\xfctzt'), (u'Unterstutzten', u'Unterst\xfctzten'), (u'Unterstutzung', u'Unterst\xfctzung'), (u'Untersuchungsausschijsse', u'Untersuchungsaussch\xfcsse'), (u'Unterw\xe9sche', u'Unterw\xe4sche'), (u'untr\xe9stlich', u'untr\xf6stlich'), (u'Unt\xe9tigkeit', u'Unt\xe4tigkeit'), (u'unumg\xe9nglich', u'unumg\xe4nglich'), (u'unverm\xe9hlt', u'unverm\xe4hlt'), (u'Unverschfimtheitl', u'Unversch\xe4mtheit'), (u'unversch\xe9mte', u'unversch\xe4mte'), (u'Unversch\xe9mtheitl', u'Unversch\xe4mtheit'), (u'UNVERSTANDLICH', u'UNVERST\xc4NDLICH'), (u'UNVERSTANDLICHE', u'UNVERST\xc4NDLICHE'), (u'UNVERSTANDLICHER', u'UNVERST\xc4NDLICHER'), (u'UNVERSTANDLICHES', u'UNVERST\xc4NDLICHES'), (u'Unverst\xe9ndliche', u'Unverst\xe4ndliche'), (u'unverst\xe9ndlichen', u'unverst\xe4ndlichen'), (u'unverst\xe9ndliches', u'unverst\xe4ndliches'), (u'unverzlliglich', u'unverz\xfcglich'), (u'unver\xe9ndert', u'unver\xe4ndert'), (u'Unzerbrechliohen', u'Unzerbrechlichen'), (u'unzurechnungsfahig', u'unzurechnungsf\xe4hig'), (u'unzuverlassiger', u'unzuverl\xe4ssiger'), (u'Unzuverl\xe9ssiger', u'Unzuverl\xe4ssiger'), (u'unzuverl\xe9ssiges', u'unzuverl\xe4ssiges'), (u'unz\xe9hlige', u'unz\xe4hlige'), (u'unz\xe9hligen', u'unz\xe4hligen'), (u'unz\xe9ihlige', u'unz\xe4hlige'), (u'Urgrofivaters', u'Urgro\xdfvaters'), (u'Urlaubsuberschreitung', u'Urlaubs\xfcberschreitung'), (u'Ursprijnglich', u'Urspr\xfcnglich'), (u'ursprtmglich', u'urspr\xfcnglich'), (u'Ursprunglich', u'Urspr\xfcnglich'), (u'Ururgrofivater', u'Ururgro\xdfvater'), (u'v/el', u'viel'), (u'v/er', u'vier'), (u'v/erfe', u'vierte'), (u'v/erfes', u'viertes'), (u'V6gel', u'V\xf6gel'), (u'v6IIig', u'v\xf6llig'), (u'V6lker', u'V\xf6lker'), (u'V6llig', u'V\xf6llig'), (u'v6lllg', u'v\xf6llig'), (u'vdllig', u'v\xf6llig'), (u'Ve/Teidigungskr\xe9fte', u'Verteidigungskr\xe4fte'), (u'Velzeih', u'Verzeih'), (u'Velzeihung', u'Verzeihung'), (u'velzichte', u'verzichte'), (u'Ven/vandter', u'Verwandter'), (u'ven/v\xe9hntl', u'verw\xf6hnt!'), (u'Ventilationsfiffnung', u'Ventilations\xf6ffnung'), (u'Ventilatorsch\xe9chte', u'Ventilatorsch\xe4chte'), (u'VERACHTLICH', u'VER\xc4CHTLICH'), (u'verandert', u'ver\xe4ndert'), (u'Verbiindeten', u'Verb\xfcndeten'), (u'Verbilndeter', u'Verb\xfcndeter'), (u'verbliidet', u'verbl\xf6det'), (u'Verbliidung', u'Verbl\xf6dung'), (u'verbllirgen', u'verb\xfcrgen'), (u'verbrachfe', u'verbrachte'), (u'Verbrec/ver', u'Verbrecher'), (u'Verbtmdeter', u'Verb\xfcndeter'), (u'Verbundeten', u'Verb\xfcndeten'), (u'Verb\ufb02nolete', u'Verb\xfcndete'), (u'verdiichtigen', u'verd\xe4chtigen'), (u'verdiinnt', u'verd\xfcnnt'), (u'verdllistern', u'verd\xfcstern'), (u'verdr\ufb02ckt', u'verdr\xfcckt'), (u'verdunnt', u'verd\xfcnnt'), (u'verd\xe9chtig', u'verd\xe4chtig'), (u'Verd\xe9chtigen', u'Verd\xe4chtigen'), (u'verd\xe9chtiger', u'verd\xe4chtiger'), (u'verffilgbares', u'verf\xfcgbares'), (u'Verfiigung', u'Verf\xfcgung'), (u'verfiihren', u'verf\xfchren'), (u'verfiihrt', u'verf\xfchrt'), (u'verfiittem', u'verf\xfcttern'), (u'Verfijgung', u'Verf\xfcgung'), (u'verfilgst', u'verf\xfcgst'), (u'verfilgte', u'verf\xfcgte'), (u'Verfilgung', u'Verf\xfcgung'), (u'Verfilhrungskilnste', u'Verf\xfchrungsk\xfcnste'), (u'verflligen', u'verf\xfcgen'), (u'verfllihrt', u'verf\xfchrt'), (u'Verflllgung', u'Verf\xfcgung'), (u'verfolgf', u'verfolgt'), (u'verfolgtl', u'verfolgt!'), (u'VERFUGBAR', u'VERF\xdcGBAR'), (u'verfugt', u'verf\xfcgt'), (u'vergafk', u'verga\xdf'), (u'Vergniigen', u'Vergn\xfcgen'), (u'Vergniigens', u'Vergn\xfcgens'), (u'Vergniigungsausflug', u'Vergn\xfcgungsausflug'), (u'Vergnijgen', u'Vergn\xfcgen'), (u'Vergnilgen', u'Vergn\xfcgen'), (u'Vergnlligen', u'Vergn\xfcgen'), (u'Vergntigen', u'Vergn\xfcgen'), (u'Vergnugen', u'Vergn\xfcgen'), (u'vergnugt', u'vergn\xfcgt'), (u'vergnugte', u'vergn\xfcgte'), (u'Vergnugungsausflug', u'Vergn\xfcgungsausflug'), (u'vergr6Bern', u'vergr\xf6\xdfern'), (u'vergr\xe9fiern', u'vergr\xf6\xdfern'), (u'Vergr\xe9fierung', u'Vergr\xf6\xdferung'), (u'verg\xe9nglich', u'verg\xe4nglich'), (u'verhiirt', u'verh\xf6rt'), (u'Verhiitung', u'Verh\xfctung'), (u'Verhor', u'Verh\xf6r'), (u'verhort', u'verh\xf6rt'), (u'verhorten', u'verh\xf6rten'), (u'verh\xe9ilt', u'verh\xe4lt'), (u'verh\xe9lt', u'verh\xe4lt'), (u'Verh\xe9ltnis', u'Verh\xe4ltnis'), (u'Verh\xe9ltnisse', u'Verh\xe4ltnisse'), (u'verh\xe9ltst', u'verh\xe4ltst'), (u'veriindert', u'ver\xe4ndert'), (u'Verinderungen', u'Ver\xe4nderungen'), (u'verkilnden', u'verk\xfcnden'), (u'verkilndet', u'verk\xfcndet'), (u'verkniipft', u'verkn\xfcpft'), (u"verknUpf't", u'verkn\xfcpft'), (u'verkunde', u'verk\xfcnde'), (u'verkunden', u'verk\xfcnden'), (u'verkundet', u'verk\xfcndet'), (u'VERKUNDIGUNG', u'VERK\xdcNDIGUNG'), (u'Verk\xe9ufer', u'Verk\xe4ufer'), (u'verletztl', u'verletzt!'), (u'verlieB', u'verlie\xdf'), (u'verlielien', u'verlie\xdfen'), (u'verlorenl', u'verloren!'), (u'verl\xe9ingert', u'verl\xe4ngert'), (u'Verl\xe9ingerungskabel', u'Verl\xe4ngerungskabel'), (u'verl\xe9isst', u'verl\xe4sst'), (u'verl\xe9sst', u'verl\xe4sst'), (u'verl\xe9uft', u'verl\xe4uft'), (u"verm'aihlen", u'verm\xe4hlen'), (u'verm/ssf', u'vermisst'), (u'vermiibelt', u'verm\xf6belt'), (u'Vermiigt', u'Verm\xf6gt'), (u'Verm\xe9gen', u'Verm\xf6gen'), (u'verm\xe9hle', u'verm\xe4hle'), (u'verm\xe9hlen', u'verm\xe4hlen'), (u'verm\xe9hlt', u'verm\xe4hlt'), (u'Verm\xe9ihlung', u'Verm\xe4hlung'), (u'vernachl\xe9ssigt', u'vernachl\xe4ssigt'), (u'Vernachl\xe9ssigung', u'Vernachl\xe4ssigung'), (u'vernfinftig', u'vern\xfcnftig'), (u'vernfinftige', u'vern\xfcnftige'), (u'vernilnftig', u'vern\xfcnftig'), (u'vernllmftigsten', u'vern\xfcnftigsten'), (u'verntmftige', u'vern\xfcnftige'), (u'vernunftig', u'vern\xfcnftig'), (u'vernunftigsten', u'vern\xfcnftigsten'), (u'vern\ufb02nftig', u'vern\xfcnftig'), (u'verpa\xdft', u'verpasst'), (u'verpesfefe', u'verpestete'), (u'verprilgle', u'verpr\xfcgle'), (u'verprugeln', u'verpr\xfcgeln'), (u'Verp\ufb02ichtungen', u'Verpflichtungen'), (u'verrat', u'verr\xe4t'), (u'verrfickter', u'verr\xfcckter'), (u'verriickt', u'verr\xfcckt'), (u'Verriickte', u'Verr\xfcckte'), (u'Verriickten', u'Verr\xfcckten'), (u'Verriickter', u'Verr\xfcckter'), (u'verriicktes', u'verr\xfccktes'), (u'verrijckt', u'verr\xfcckt'), (u'verrijckte', u'verr\xfcckte'), (u'verrilckt', u'verr\xfcckt'), (u'Verrilckte', u'Verr\xfcckte'), (u'Verrilckter', u'Verr\xfcckter'), (u'Verrilcktes', u'Verr\xfccktes'), (u"verrL'lckt", u'verr\xfcckt'), (u'verrljckt', u'verr\xfcckt'), (u'verrllickt', u'verr\xfcckt'), (u'Verrllickte', u'Verr\xfcckte'), (u'Verrllickter', u'Verr\xfcckter'), (u'verrlllckte', u'verr\xfcckte'), (u'verrtickt', u'verr\xfcckt'), (u'verrUckt', u'verr\xfcckt'), (u'Verruckte', u'Verr\xfcckte'), (u'verruckten', u'verr\xfcckten'), (u'Verruckter', u'Verr\xfcckter'), (u'Verr\xe9iter', u'Verr\xe4ter'), (u'verr\xe9itst', u'verr\xe4itst'), (u'verr\xe9t', u'verr\xe4t'), (u'Verr\xe9ter', u'Verr\xe4ter'), (u'Verr\xe9terin', u'Verr\xe4terin'), (u'verr\xe9terisch', u'verr\xe4terisch'), (u'verr\xe9terischen', u'verr\xe4terischen'), (u'verr\ufb02ckt', u'verr\xfcckt'), (u'versaumt', u'vers\xe4umt'), (u'Verscheifier', u'Verschei\xdfer'), (u'verschiichtert', u'versch\xfcchtert'), (u'verschiitten', u'versch\xfctten'), (u'verschlucktl', u'verschluckt!'), (u'VERSCHLUSSELN', u'VERSCHL\xdcSSELN'), (u'VERSCHLUSSELT', u'VERSCHL\xdcSSELT'), (u'Verschlusselung', u'Verschl\xfcsselung'), (u'Verschnauferst', u'Verschnauf erst'), (u'Verschwdrung', u'Verschw\xf6rung'), (u'verschweilit', u'verschwei\xdft'), (u'Verschwiirer', u'Verschw\xf6rer'), (u'verschwiirerisch', u'verschw\xf6rerisch'), (u'Verschwiirern', u'Verschw\xf6rern'), (u'Verschwiirung', u'Verschw\xf6rung'), (u'Verschwiirungen', u'Verschw\xf6rungen'), (u'Verschw\xe9rer', u'Verschw\xf6rer'), (u'Verschw\xe9rung', u'Verschw\xf6rung'), (u'Verschw\xe9rungstheoretiker', u'Verschw\xf6rungstheoretiker'), (u'versch\xe9rft', u'versch\xe4rft'), (u'versfanden', u'verstanden'), (u'Versfehen', u'Verstehen'), (u'versiihnlich', u'vers\xf6hnlich'), (u'Versiihnung', u'Vers\xf6hnung'), (u'verslumte', u'vers\xe4umte'), (u'Verspfitung', u'Versp\xe4tung'), (u'verspiire', u'versp\xfcre'), (u'verspilre', u'versp\xfcre'), (u'verspiten', u'versp\xe4ten'), (u'versprijht', u'verspr\xfcht'), (u'verst0I3en', u'versto\xdfen'), (u'verst6Bt', u'verst\xf6\xdft'), (u'Verst6ISt', u'Verst\xf6\xdft'), (u'verst6l3t', u'verst\xf6\xdft'), (u'verstehejetzt', u'verstehe jetzt'), (u'Verstiindnis', u'Verst\xe4ndnis'), (u'verstiirkt', u'verst\xe4rkt'), (u'Verstiirkung', u'Verst\xe4rkung'), (u'verstilmmelst', u'verst\xfcmmelst'), (u'verstoBen', u'Versto\xdfen'), (u'verstofken', u'versto\xdfen'), (u'verstolien', u'versto\xdfen'), (u'verstummelt', u'verst\xfcmmelt'), (u'verstunde', u'verst\xfcnde'), (u'verstundest', u'verst\xfcndest'), (u'verst\xe9fkt', u'verst\xf6\xdft'), (u'verst\xe9indlich', u'verst\xe4ndlich'), (u'Verst\xe9irkung', u'Verst\xe4rkung'), (u'Verst\xe9ndigen', u'Verst\xe4ndigen'), (u'Verst\xe9ndigt', u'Verst\xe4ndigt'), (u'verst\xe9ndlich', u'verst\xe4ndlich'), (u'Verst\xe9ndnis', u'Verst\xe4ndnis'), (u'verst\xe9rken', u'verst\xe4rken'), (u'verst\xe9rkt', u'verst\xe4rkt'), (u'verst\xe9rkte', u'verst\xe4rkte'), (u'verst\xe9rkter', u'verst\xe4rkter'), (u'Verst\xe9rkung', u'Verst\xe4rkung'), (u'verst\xe9rt', u'verst\xf6rt'), (u'vers\xe9hnen', u'vers\xf6hnen'), (u'vers\xe9hnt', u'vers\xf6hnt'), (u'vers\xe9umen', u'vers\xe4umen'), (u'vers\xe9umt', u'vers\xe4umt'), (u'VERTRAGSLANGE', u'VERTRAGSL\xc4NGE'), (u'vertrauenswiirdig', u'vertrauensw\xfcrdig'), (u'vertrauenswtlrdig', u'vertrauensw\xfcrdig'), (u'vertrauenswtlrdigen', u'vertrauensw\xfcrdigen'), (u'vertr\xe9umte', u'vertr\xe4umte'), (u'vervvanzt', u'verwanzt'), (u'verwiistete', u'verw\xfcstete'), (u'verwllisten', u'verw\xfcsten'), (u'verwustet', u'verw\xfcstet'), (u'verw\xe9hnten', u'verw\xf6hnten'), (u'verw\xe9ihnen', u'verw\xf6hnen'), (u'verw\xe9ssert', u'verw\xe4ssert'), (u'verz\xe9gere', u'verz\xf6gere'), (u'Verz\xe9gerte', u'Verz\xf6gerte'), (u'Verz\xe9gerung', u'Verz\xf6gerung'), (u'ver\xe9ffentliche', u'ver\xf6ffentliche'), (u'ver\xe9ffentlichen', u'ver\xf6ffentlichen'), (u'ver\xe9ffentlicht', u'ver\xf6ffentlicht'), (u'ver\xe9indert', u'ver\xe4ndert'), (u'Ver\xe9inderung', u'Ver\xe4nderung'), (u'ver\xe9ndern', u'ver\xe4ndern'), (u'ver\xe9ndert', u'ver\xe4ndert'), (u'ver\xe9nderte', u'ver\xe4nderte'), (u'ver\xe9nderten', u'ver\xe4nderten'), (u'Ver\xe9nderung', u'Ver\xe4nderung'), (u'Ver\xe9nderungen', u'Ver\xe4nderungen'), (u'ver\xe9ngstigtes', u'ver\xe4ngstigtes'), (u'ver\xe9ppelt', u'ver\xe4ppelt'), (u'ver\xe9rgert', u'ver\xe4rgert'), (u'vewvendet', u'verwendet'), (u'vfillig', u'v\xf6llig'), (u'VGFKUFZGH', u'verk\xfcrzen'), (u'VI/illkommen', u'Willkommen'), (u'VI/itwicky', u'Witwicky'), (u'vial', u'viel'), (u'Videoiiben/vachung', u'Video\xfcberwachung'), (u'Vie/e', u'Viele'), (u'Vielfrafi', u'Vielfra\xdf'), (u'vielf\xe9ltig', u'vielf\xe4ltig'), (u'Vielleichtja', u'Vielleicht ja'), (u'vielversprechend', u'viel versprechend'), (u'Vieraugengespr\xe9ch', u'Vieraugengespr\xe4ch'), (u'vieriunge', u'vier junge'), (u'vierj\xe9hriges', u'vierj\xe4hriges'), (u'vierk\xe9pfige', u'vierk\xf6pfige'), (u'Viigel', u'V\xf6gel'), (u'viillig', u'v\xf6llig'), (u'viilliges', u'v\xf6lliges'), (u'Viterchen', u'V\xe4terchen'), (u'Vizepr\xe9isident', u'Vizepr\xe4sident'), (u'vlel', u'viel'), (u'Vlellelcht', u'Vielleicht'), (u'Vogelscheifke', u'Vogelschei\xdfe'), (u'Vogelscheilie', u'Vogelschei\xdfe'), (u'Volksm\xe9rchen', u'Volksm\xe4rchen'), (u'vollerjeder', u'voller jeder'), (u'vollmachen', u'voll machen'), (u'vollst\xe9ndig', u'vollst\xe4ndig'), (u'vollst\xe9ndige', u'vollst\xe4ndige'), (u'Volltrefferl', u'Volltreffer!'), (u'vollz\xe9hlig', u'vollz\xe4hlig'), (u'Volumenl', u'Volumen!'), (u'von/vagten', u'vorwagten'), (u'von/v\xe9irts', u'vorw\xe4rts'), (u'vonn6ten', u'vonn\xf6ten'), (u'Vonn\xe9irts', u'Vorw\xe4rts'), (u'Vordertiir', u'Vordert\xfcr'), (u'Vorderturl', u'Vordert\xfcr!'), (u'vordr\xe9ngelnl', u'vordr\xe4ngeln!'), (u'vorfibergehend', u'vor\xfcbergehend'), (u'Vorfuhrungen', u'Vorf\xfchrungen'), (u'vorgef\ufb02hrt', u'vorgef\xfchrt'), (u'Vorgiinge', u'Vorg\xe4nge'), (u'Vorg\xe9nger', u'Vorg\xe4nger'), (u'Vorg\xe9ngern', u'Vorg\xe4ngern'), (u'Vorh\xe9nge', u'Vorh\xe4nge'), (u'vorijbergehend', u'vor\xfcbergehend'), (u'vorilber', u'vor\xfcber'), (u'vorilbergehende', u'vor\xfcbergehende'), (u'vorkniipfen', u'vorkn\xf6pfen'), (u'Vorl\xe9ufer', u'Vorl\xe4ufer'), (u'Vorl\xe9ufig', u'Vorl\xe4ufig'), (u'Vorraus', u'Voraus'), (u'Vorschl\xe9ge', u'Vorschl\xe4ge'), (u'vorschriftsm\xe9fiig', u'vorschriftsm\xe4\xdfig'), (u'vorschriftsm\xe9iliig', u'vorschriftsm\xe4\xdfig'), (u'Vorsichtsmaflnahme', u'Vorsichtsma\xdfnahme'), (u'Vorstellungsgespr\xe9ch', u'Vorstellungsgespr\xe4ch'), (u'Vorstellungsgespr\xe9che', u'Vorstellungsgespr\xe4che'), (u'Vorstof$', u'Vorsto\xdf'), (u'Vortlbergehende', u'Vor\xfcbergehende'), (u'vort\xe9uschen', u'vort\xe4uschen'), (u'vorubergehend', u'vor\xfcbergehend'), (u'vorvv\xe9rts', u'vorw\xe4rts'), (u'Vorwfirts', u'Vorw\xe4rts'), (u'vorw\xe9rts', u'vorw\xe4rts'), (u'vorzfiglichl', u'vorz\xfcglich!'), (u'vor\ufb02ber', u'vor\xfcber'), (u'Vor\ufb02bergehend', u'Vor\xfcbergehend'), (u'VVACHMANN', u'WACHMANN'), (u'Vvaffen', u'Waffen'), (u'Vvagen', u'Wagen'), (u'VVarte', u'Warte'), (u'VVeif3>t', u'Wei\xdft'), (u"VVeil'2>t", u'Wei\xdft'), (u'VVir', u'Wir'), (u'VVM', u'WM'), (u'v\\/as', u'was'), (u'V\\/e', u'We'), (u'V\xe9gel', u'V\xf6gel'), (u'v\xe9geln', u'v\xf6geln'), (u'v\xe9gelt', u'v\xf6gelt'), (u'v\xe9llig', u'v\xf6llig'), (u"w/'r", u'wir'), (u'W/e', u'Wie'), (u'w/eder', u'wieder'), (u'W/nkel', u'Winkel'), (u'w/r', u'wir'), (u'w/rd', u'wird'), (u'w/rkl/ch', u'wirklich'), (u'W0', u'Wo'), (u'w5r', u'w\xe4r'), (u"w5r's", u"w\xe4r's"), (u'W6lfe', u'W\xf6lfe'), (u'W6lfen', u'W\xf6lfen'), (u'W99', u'Weg'), (u'Waffenschr\xe9nke', u'Waffenschr\xe4nke'), (u'wafs', u"w\xe4r's"), (u'wahrend', u'w\xe4hrend'), (u'WAHRENDDESSEN', u'W\xc4HRENDDESSEN'), (u'Wahrheitl', u'Wahrheit!'), (u'wail', u'weil'), (u'Walbl', u'Wal\xf6l'), (u'Walsinghaml', u'Walsingham!'), (u'wankelmiltig', u'wankelm\xfctig'), (u'ware', u'w\xe4re'), (u'WAREST', u'W\xc4REST'), (u'Warfe', u'Warte'), (u'warja', u'war ja'), (u'Waschbrettb\xe9uche', u'Waschbrettb\xe4uche'), (u'Waschb\xe9ir', u'Waschb\xe4r'), (u'Waschb\xe9iren', u'Waschb\xe4ren'), (u'Wasseranschlljssen', u'Wasseranschl\xfcssen'), (u'Wattekn\xe9uel', u'Wattekn\xe4uel'), (u'Wattest\xe9bchen', u'Wattest\xe4bchen'), (u"we're", u'w\xe4re'), (u"We'ro", u"We're"), (u'we/B', u'wei\xdf'), (u'We/Bf', u'Wei\xdft'), (u'we/fere', u'weitere'), (u'Wechsell', u'Wechsel!'), (u'weggebfirstet', u'weggeb\xfcrstet'), (u'weggespllllt', u'weggesp\xfclt'), (u'weggesplllltl', u'weggesp\xfclt!'), (u'weggesp\ufb02lt', u'weggesp\xfclt'), (u'wegl', u'weg!'), (u'wegreiflsen', u'wegrei\xdfen'), (u'wegschieBen', u'wegschie\xdfen'), (u'Wegtratan', u'Wegtreten'), (u'wegzuwefien', u'wegzuwerfen'), (u'wei/3', u'wei\xdf'), (u'WeiB', u'Wei\xdf'), (u'weiBe', u'wei\xdfe'), (u'weiBen', u'wei\xdfen'), (u'weiBer', u'wei\xdfer'), (u'weiBes', u'wei\xdfes'), (u'WeiBfresse', u'Wei\xdffresse'), (u'weiBt', u'wei\xdft'), (u'Weif$', u'Wei\xdf'), (u'Weif$t', u'Wei\xdft'), (u'weif2>', u'wei\xdf'), (u'weif3', u'wei\xdf'), (u'weif3>', u'wei\xdf'), (u'Weif3t', u'Wei\xdft'), (u'weif5', u'wei\xdf'), (u'Weifbe', u'Wei\xdfe'), (u'weifbt', u'wei\xdft'), (u'Weifi', u'Wei\xdf'), (u'Weifie', u'Wei\xdfe'), (u'weifies', u'wei\xdfes'), (u'Weifist', u'Wei\xdft'), (u'Weifit', u'Wei\xdft'), (u'weifk', u'wei\xdf'), (u'weifken', u'wei\xdfen'), (u'Weifker', u'Wei\xdfer'), (u'weifkes', u'wei\xdfes'), (u'weifkt', u'wei\xdft'), (u'weifL', u'wei\xdf'), (u'weifLt', u'wei\xdft'), (u'weifl\xbb', u'wei\xdf'), (u'weifS', u'wei\xdf'), (u'WeifSt', u'Wei\xdft'), (u'weifZ>', u'wei\xdf'), (u'WeifZ>t', u'Wei\xdft'), (u'weif\xe9t', u'wei\xdft'), (u'Weihnachtseink\xe9ufe', u'Weihnachtseink\xe4ufe'), (u'Weihnachtsm\xe9nner', u'Weihnachtsm\xe4nner'), (u"weil'5", u'wei\xdf'), (u"weil'5t", u'wei\xdft'), (u'weil3', u'wei\xdf'), (u'Weil3t', u'Wei\xdft'), (u'weil5', u'wei\xdf'), (u'Weil5t', u'Wei\xdft'), (u'weili', u'wei\xdf'), (u'weilit', u'wei\xdft'), (u'weilke', u'wei\xdfe'), (u'Weill', u'Wei\xdf'), (u'weills', u'wei\xdf'), (u'weillst', u'wei\xdft'), (u'weillt', u'weisst'), (u'weilS', u'wei\xdf'), (u'weilSe', u'wei\xdfe'), (u'WeilSglut', u'Wei\xdfglut'), (u'weilZ>', u'wei\xdf'), (u'weilZ~', u'wei\xdf'), (u'weiss', u'wei\xdf'), (u'weissen', u'wei\xdfen'), (u'weisst', u'wei\xdft'), (u'weiterhiipfen', u'weiterh\xfcpfen'), (u'Weiterpessen', u'Weiterpressen'), (u'weitl\xe9ufige', u'weitl\xe4ufige'), (u'weitweg', u'weit weg'), (u'WelBt', u'Wei\xdft'), (u'well', u'weil'), (u'Well', u'Welt'), (u'Wellit', u'Wei\xdft'), (u'welllt', u'wei\xdft'), (u'welt', u'weit'), (u'WELTBEVOLKERUNG', u'WELTBEV\xd6LKERUNG'), (u'Wel\ufb02t', u'Wei\xdft'), (u'Werdja', u'Werd ja'), (u'Werkst\xe9tten', u'Werkst\xe4tten'), (u'Werkzeugg\ufb02rtel', u'Werkzeugg\xfcrtel'), (u'wertschfitzen', u'wertsch\xe4tzen'), (u'Westflilgel', u'Westfl\xfcgel'), (u'Westkilste', u'Westk\xfcste'), (u'Wettk\xe9mpfe', u'Wettk\xe4mpfe'), (u'Wettk\xe9mpfen', u'Wettk\xe4mpfen'), (u'Wettk\xe9mpfer', u'Wettk\xe4mpfer'), (u'Wfinsche', u'W\xfcnsche'), (u'wfinschen', u'w\xfcnschen'), (u'Wfird', u'W\xfcrd'), (u'wfirde', u'w\xfcrde'), (u'Wfirden', u'W\xfcrden'), (u'wfirdest', u'w\xfcrdest'), (u'wfire', u'w\xe4re'), (u'Wfirme', u'W\xe4rme'), (u'Wfisste', u'W\xfcsste'), (u'wfitete', u'w\xfctete'), (u'wfssen', u'wissen'), (u'Widen/v\xe9rtig', u'Widerw\xe4rtig'), (u"widerf'a'hrt", u'widerf\xe4hrt'), (u'widerspriichliche', u'widerspr\xfcchliche'), (u'Widerw\xe9irtig', u'Widerw\xe4rtig'), (u'wiedergew\xe9ihltl', u'wiedergew\xe4hlt'), (u'wiederhaben', u'wieder-haben'), (u'Wiederh\xe9ren', u'Wiederh\xf6ren'), (u'Wieheifiternoch', u'Wiehei\xdfternoch'), (u'Wieheiliternoch', u'Wiehei\xdfternoch'), (u'wihlerisch', u'w\xe4hlerisch'), (u'wihlerlsch', u'w\xe4hlerisch'), (u'wiihlen', u'w\xfchlen'), (u'wiihlte', u'w\xe4hlte'), (u'wiihrend', u'w\xe4hrend'), (u'wiilrdest', u'w\xfcrdest'), (u'Wiinde', u'W\xe4nde'), (u'wiinsch', u'w\xfcnsch'), (u'Wiinsche', u'W\xfcnsche'), (u'Wiinschen', u'W\xfcnschen'), (u'wiinschst', u'w\xfcnschst'), (u'wiinscht', u'w\xfcnscht'), (u'wiinschte', u'w\xfcnschte'), (u'wiirde', u'w\xfcrde'), (u'Wiirden', u'W\xfcrden'), (u'Wiirdest', u'W\xfcrdest'), (u'wiirdet', u'w\xfcrdet'), (u'wiirdigst', u'w\xfcrdigst'), (u'Wiire', u'W\xe4re'), (u'wiiren', u'w\xe4ren'), (u'Wiirfel', u'W\xfcrfel'), (u'wiirfeln', u'w\xfcrfeln'), (u'Wiirfels', u'W\xfcrfels'), (u'wiirs', u"w\xe4r's"), (u'Wiirstchen', u'W\xfcrstchen'), (u'wiischt', u'w\xe4scht'), (u'Wiisste', u'W\xfcsste'), (u'wiissten', u'w\xfcssten'), (u'wiisstest', u'w\xfcsstest'), (u'Wiiste', u'W\xfcste'), (u'wiitenden', u'w\xfctenden'), (u'wijnsche', u'w\xfcnsche'), (u'wijnschen', u'w\xfcnschen'), (u'wijnschte', u'w\xfcnschte'), (u'wijrd', u'w\xfcrd'), (u'wijrde', u'w\xfcrde'), (u'wijrden', u'w\xfcrden'), (u'wijrdest', u'w\xfcrdest'), (u'wijrdiger', u'w\xfcrdiger'), (u'Wijrg', u'W\xfcrg'), (u'wijsste', u'w\xfcsste'), (u'wijtend', u'w\xfctend'), (u'wildl', u'wild!'), (u'wilnsch', u'w\xfcnsch'), (u'wilnsche', u'w\xfcnsche'), (u'wilnschen', u'w\xfcnschen'), (u'wilnscht', u'w\xfcnscht'), (u'wilnschte', u'w\xfcnschte'), (u'wilrd', u'w\xfcrd'), (u'Wilrde', u'W\xfcrde'), (u'Wilrden', u'W\xfcrden'), (u'Wilrdest', u'W\xfcrdest'), (u'wilrdig', u'w\xfcrdig'), (u'Wilrfel', u'W\xfcrfel'), (u'Wilrfelenergie', u'W\xfcrfelenergie'), (u'wilsste', u'w\xfcsste'), (u'wilssten', u'w\xfcssten'), (u'Wilstling', u'W\xfcstling'), (u'wiltend', u'w\xfctend'), (u'Windelhundl', u'Windelhund!'), (u'Windhundk\xe9rper', u'Windhundk\xf6rper'), (u'winner', u'w\xe4rmer'), (u'Wire', u'W\xe4re'), (u'wires', u'wir es'), (u'Wirfangen', u'Wir fangen'), (u'wirja', u'wir ja'), (u'wirje', u'wir je'), (u'wirjede', u'wir jede'), (u'wirjeden', u'wir jeden'), (u'wirjetzt', u'wir jetzt'), (u'Wirnisse', u'Wirrnisse'), (u'Wirsind', u'Wir sind'), (u'wirtragen', u'wir tragen'), (u'Wirtschaftspriifer', u'Wirtschaftspr\xfcfer'), (u'Wirverfolgen', u'Wir verfolgen'), (u'wirvom', u'wir vom'), (u'Wirwaren', u'Wir waren'), (u'Wirwarten', u'Wir warten'), (u'Wirwerden', u'Wir werden'), (u'Wirwissen', u'Wir wissen'), (u'Wirwollen', u'Wir wollen'), (u'Wirwollten', u'Wir wollten'), (u'Wirzeigten', u'Wir zeigten'), (u'wirzu', u'wir zu'), (u'Witzl', u'Witz!'), (u'WKHRENDDESSEN', u'W\xc4HRENDDESSEN'), (u"wL'lrden", u'w\xfcrden'), (u'wle', u'wie'), (u'Wleso', u'Wieso'), (u'Wlhlen', u'W\xe4hlen'), (u'wllinsch', u'w\xfcnsch'), (u'wllinschst', u'w\xfcnschst'), (u'wllinscht', u'w\xfcnscht'), (u'wllirde', u'w\xfcrde'), (u'wllirden', u'w\xfcrden'), (u'wllirdest', u'w\xfcrdest'), (u'wllirdet', u'w\xfcrdet'), (u'Wllirgegriff', u'W\xfcrgegriff'), (u'wllirgen', u'w\xfcrgen'), (u'wllisste', u'w\xfcsste'), (u'wlr', u'wir'), (u'wlrd', u'wird'), (u'wlrkllch', u'wirklich'), (u'Wlrkllchkelt', u'Wirklichkeit'), (u'wlrst', u'wirst'), (u'Wlrwarten', u'Wir warten'), (u'wlrwollen', u'wir wollen'), (u'Wo/f', u'Wolf'), (u'Wochenf\xe9hre', u'Wochenf\xe4hre'), (u'woffir', u'wof\xfcr'), (u'Wofiir', u'Wof\xfcr'), (u'Wofijr', u'Wof\xfcr'), (u'wofilr', u'wof\xfcr'), (u'Wofur', u'Wof\xfcr'), (u'WoherweiB', u'Woher wei\xdf'), (u'WoherweiBt', u'Woher wei\xdft'), (u'Woherweif$t', u'Woher wei\xdft'), (u'wohlfilhlen', u'wohlf\xfchlen'), (u'Wollkn\xe9uel', u'Wollkn\xe4uel'), (u'womiiglich', u'wom\xf6glich'), (u'wom\xe9glich', u'wom\xf6glich'), (u'wom\xe9iglich', u'wom\xf6glich'), (u'Worfiber', u'Wor\xfcber'), (u'woriiber', u'wor\xfcber'), (u'Worijber', u'Wor\xfcber'), (u'Wortgepl\xe9nkel', u'Wortgepl\xe4nkel'), (u'Woruber', u'Wor\xfcber'), (u"wt/'rden", u'w\xfcrden'), (u'wtinsche', u'w\xfcnsche'), (u'wtinschst', u'w\xfcnschst'), (u'wtirde', u'w\xfcrde'), (u'Wtirdest', u'W\xfcrdest'), (u'Wtirfel', u'W\xfcrfel'), (u'Wtmschen', u'W\xfcnschen'), (u"WUl'd\u20ac", u'w\xfcrde'), (u'WUlfelbecher', u'W\xfcrfelbecher'), (u'wullte', u'wusste'), (u'Wundersch6n', u'Wundersch\xf6n'), (u'wunderschfin', u'wundersch\xf6n'), (u'Wunderschiin', u'Wundersch\xf6n'), (u'wunderschiinen', u'wundersch\xf6nen'), (u'wundersch\xe9n', u'wundersch\xf6n'), (u'wundersch\xe9ne', u'wundersch\xf6ne'), (u'Wundersch\xe9nel', u'Wundersch\xf6ne!'), (u'wundersch\xe9nen', u'wundersch\xf6nen'), (u'wundersch\xe9nes', u'wundersch\xf6nes'), (u'wundersoh\xe9n', u'wundersch\xf6n'), (u'wunsche', u'w\xfcnsche'), (u'Wunschen', u'W\xfcnschen'), (u'wunscht', u'w\xfcnscht'), (u'wunschte', u'w\xfcnschte'), (u'WUNSCHTE', u'W\xdcNSCHTE'), (u'wurcle', u'wurde'), (u'wUrde', u'w\xfcrde'), (u'Wurdige', u'W\xfcrdige'), (u'WURGT', u'W\xdcRGT'), (u'Wurmer', u'W\xfcrmer'), (u'Wursfsfulle', u'Wurststulle'), (u'Wuste', u'W\xfcste'), (u'WUSTEN', u'W\xdcSTEN'), (u'wutend', u'w\xfctend'), (u'wu\xdfte', u'wusste'), (u'wu\xdftest', u'wusstest'), (u"w\xa7r's", u"w\xe4r's"), (u'w\xa7re', u'w\xe4re'), (u"W\xa7ren's", u"W\xe4ren's"), (u"w\xe9'hrend", u'w\xe4hrend'), (u'w\xe9chst', u'w\xe4chst'), (u'W\xe9chter', u'W\xe4chter'), (u'w\xe9fs', u"w\xe4r's"), (u'W\xe9g', u'Weg'), (u'w\xe9hle', u'w\xe4hle'), (u'w\xe9hlejetzt', u'w\xe4hle jetzt'), (u'w\xe9hlen', u'w\xe4hlen'), (u'W\xe9hler', u'W\xe4hler'), (u'W\xe9hlern', u'W\xe4hlern'), (u'w\xe9hlt', u'w\xe4hlt'), (u'w\xe9hlte', u'w\xe4hlte'), (u'w\xe9hrend', u'w\xe4hrend'), (u'W\xe9hrung', u'W\xe4hrung'), (u'W\xe9ichter', u'W\xe4chter'), (u'w\xe9ihlen', u'w\xe4hlen'), (u'w\xe9ihrend', u'w\xe4hrend'), (u'w\xe9ir', u'w\xe4r'), (u"w\xe9ir's", u"w\xe4r's"), (u'w\xe9irde', u'w\xfcrde'), (u'W\xe9ire', u'W\xe4re'), (u'w\xe9iren', u'w\xe4ren'), (u'w\xe9irmen', u'w\xe4rmen'), (u'w\xe9irst', u'w\xe4rst'), (u'W\xe9lder', u'W\xe4lder'), (u'W\xe9ldern', u'W\xe4ldern'), (u'W\xe9lfen', u'W\xf6lfen'), (u'W\xe9lkchen', u'W\xf6lkchen'), (u'W\xe9nde', u'W\xe4nde'), (u'W\xe9nden', u'W\xe4nden'), (u'w\xe9r', u'w\xe4r'), (u"w\xe9r's", u"w\xe4r's"), (u'W\xe9re', u'W\xe4re'), (u'W\xe9ren', u'W\xe4ren'), (u'w\xe9ret', u'w\xe4ret'), (u'w\xe9rja', u'w\xe4r ja'), (u'W\xe9rm', u'W\xe4rm'), (u'W\xe9rme', u'W\xe4rme'), (u'w\xe9rmt', u'w\xe4rmt'), (u'W\xe9rst', u'W\xe4rst'), (u'w\xe9rt', u'w\xe4rt'), (u'W\xe9rter', u'W\xf6rter'), (u'W\xe9rterbuch', u'W\xf6rterbuch'), (u'w\xe9rtliche', u'w\xf6rtliche'), (u'W\xe9sche', u'W\xe4sche'), (u'W\xe9scheklammer', u'W\xe4scheklammer'), (u'W\xe9schst', u'W\xe4schst'), (u'w\xe9scht', u'w\xe4scht'), (u'w\ufb02rde', u'w\xfcrde'), (u'w\ufb02rden', u'w\xfcrden'), (u'W\ufb02rfel', u'W\xfcrfel'), (u"z'a'h", u'z\xe4h'), (u'Z/egf', u'liegt'), (u'Z/yarettenb\xe4ume', u'Zigarettenb\xe4ume'), (u'Z05', u'los'), (u'z6gel1e', u'z\xf6gerte'), (u'z6gern', u'z\xf6gern'), (u'zahlenm\xe9\ufb02ig', u'zahlenm\xe4\xdfig'), (u'zappelnl', u'zappeln!'), (u'Zauberspruchen', u'Zauberspr\xfcchen'), (u'Zaubervoodookr\xe9fte', u'Zaubervoodookr\xe4fte'), (u'Zauherpfippchen', u'Zauberp\xfcppchen'), (u'Zefietzende', u'Zerfetzende'), (u'zeitgem5B', u'zeitgem\xe4\xdf'), (u'Zeitgem\xe9\ufb02e', u'Zeitgem\xe4\xdfe'), (u'Zeitgeniissische', u'Zeitgen\xf6ssische'), (u'zeitgeniissischen', u'zeitgen\xf6ssischen'), (u'Zellenschliissel', u'Zellenschl\xfcssel'), (u'zerbeif$en', u'zerbei\xdfen'), (u'zerbeif$t', u'zerbei\xdft'), (u'zerf\xe9llt', u'zerf\xe4llt'), (u'Zermatschger\xe9usch', u'Zermatschger\xe4usch'), (u'zerm\ufb02rben', u'zerm\xfcrben'), (u'zerreifien', u'zerrei\xdfen'), (u'zerreilit', u'zerrei\xdft'), (u'zersfdren', u'zerst\xf6ren'), (u'zerst6rst', u'zerst\xf6rst'), (u'zerst6rt', u'zerst\xf6rt'), (u'zerstdren', u'zerst\xf6ren'), (u'Zerstfiren', u'Zerst\xf6ren'), (u'Zerstfirer', u'Zerst\xf6rer'), (u'Zerstfirungskraft', u'Zerst\xf6rungskraft'), (u'Zerstiickelung', u'Zerst\xfcckelung'), (u'zerstiire', u'zerst\xf6re'), (u'zerstiiren', u'zerst\xf6ren'), (u'Zerstiirer', u'Zerst\xf6rer'), (u'zerstiirt', u'zerst\xf6rt'), (u'zerstiirten', u'zerst\xf6rten'), (u'zerstiirtl', u'zerst\xf6rt!'), (u'Zerstiirungl', u'Zerst\xf6rung!'), (u'zerstoren', u'zerst\xf6ren'), (u'zerst\xe9re', u'zerst\xf6re'), (u'zerst\xe9ren', u'zerst\xf6ren'), (u'Zerst\xe9rer', u'Zerst\xf6rer'), (u'zerst\xe9rt', u'zerst\xf6rt'), (u'Zerst\xe9rung', u'Zerst\xf6rung'), (u'Zerst\xe9rungsfeldzug', u'Zerst\xf6rungsfeldzug'), (u'zertrlllmmert', u'zertr\xfcmmert'), (u'zfihlt', u'z\xe4hlt'), (u'Ziel160m', u'Ziel 160 m'), (u'Zihnelt', u'\xe4hnelt'), (u'ziichtiger', u'z\xfcchtiger'), (u'Ziige', u'Z\xfcge'), (u'Ziindkapseln', u'Z\xfcndkapseln'), (u'Zilnd', u'Z\xfcnd'), (u'Zilnden', u'Z\xfcnden'), (u'Zilndungsenergie', u'Z\xfcndungsenergie'), (u'Zilrich', u'Z\xfcrich'), (u'Zindern', u'\xe4ndern'), (u'Zingstlich', u'\xe4ngstlich'), (u'Ziufierst', u'\xe4u\xdferst'), (u'zleht', u'zieht'), (u'ZLIFUCK', u'zur\xfcck'), (u'Zooschlieliung', u'Zooschlie\xdfung'), (u'Zuckerschn\ufb02tchen', u'Zuckerschn\xfctchen'), (u'zuerstvor', u'zuerst vor'), (u'zuffillig', u'zuf\xe4llig'), (u'zuflligen', u'zuf\xfcgen'), (u'ZUFUCK', u'zur\xfcck'), (u'Zuf\xe9illig', u'Zuf\xe4llig'), (u'Zuf\xe9illigerweise', u'Zuf\xe4lligerweise'), (u'zuf\xe9llig', u'zuf\xe4llig'), (u'Zuf\xe9lligerweise', u'Zuf\xe4lligerweise'), (u"zug'a'nglichen", u'zug\xe4nglichen'), (u'ZUGANGSPRIORITKT', u'ZUGANGSPRIORIT\xc4T'), (u'zugehdrt', u'zugeh\xf6rt'), (u'zugeh\xe9rt', u'zugeh\xf6rt'), (u'zugestofien', u'zugesto\xdfen'), (u'Zugest\xe9ndnis', u'Zugest\xe4ndnis'), (u'Zugest\xe9ndnisse', u'Zugest\xe4ndnisse'), (u'Zugiinge', u'Zug\xe4nge'), (u'zuh6ren', u'zuh\xf6ren'), (u'zuh6rt', u'zuh\xf6rt'), (u'zuhiiren', u'zuh\xf6ren'), (u'zuhiirt', u'zuh\xf6rt'), (u'Zuh\xe9lter', u'Zuh\xe4lter'), (u'Zuh\xe9ren', u'Zuh\xf6ren'), (u'Zuh\xe9rer', u'Zuh\xf6rer'), (u'zukilnftiges', u'zuk\xfcnftiges'), (u'zul', u'zu!'), (u'zundete', u'z\xfcndete'), (u'Zundverteilerkappe', u'Z\xfcndverteilerkappe'), (u'zunjick', u'zur\xfcck'), (u'zun\xe9chst', u'zun\xe4chst'), (u'zun\xe9hen', u'zun\xe4hen'), (u'zun\xe9ihen', u'zun\xe4hen'), (u'Zuokerschntltchen', u'Zuckerschn\xfctchen'), (u'zurfick', u'zur\xfcck'), (u'zurfickblicken', u'zur\xfcckblicken'), (u'zurfickgekommen', u'zur\xfcckgekommen'), (u'zurfickgezogen', u'zur\xfcckgezogen'), (u'zurfickkehren', u'zur\xfcckkehren'), (u'zurfickzufuhren', u'zur\xfcckzuf\xfchren'), (u'zuriick', u'zur\xfcck'), (u'zuriickbleiben', u'zur\xfcckbleiben'), (u'zuriickgeben', u'zur\xfcckgeben'), (u'zuriickgehen', u'zur\xfcckgehen'), (u'zuriickgekommen', u'zur\xfcckgekommen'), (u'zuriickgezogen', u'zur\xfcckgezogen'), (u'zuriickhaben', u'zur\xfcckhaben'), (u'zuriickkehre', u'zur\xfcckkehre'), (u'zuriickkehren', u'zur\xfcckkehren'), (u'zuriickkehrst', u'zur\xfcckkehrst'), (u'zuriickziehen', u'zur\xfcckziehen'), (u'Zurijck', u'Zur\xfcck'), (u'zurijckbringen', u'zur\xfcckbringen'), (u'zurijckfordem', u'zur\xfcckfordern'), (u'zurijckgeholt', u'zur\xfcckgeholt'), (u'zurijckgekehrt', u'zur\xfcckgekehrt'), (u'zurijckgekommen', u'zur\xfcckgekommen'), (u'zurijckgelassen', u'zur\xfcckgelassen'), (u'zurijckgerufen', u'zur\xfcckgerufen'), (u'zurijckkehren', u'zur\xfcckkehren'), (u'zurijcknehmen', u'zur\xfccknehmen'), (u'zurijckstolpern', u'zur\xfcckstolpern'), (u'Zurilck', u'Zur\xfcck'), (u'Zurilckf', u'Zur\xfcck!'), (u'zurilckgeblieben', u'zur\xfcckgeblieben'), (u'zurilckgeholt', u'zur\xfcckgeholt'), (u'zurilckgekehrt', u'zur\xfcckgekehrt'), (u'zurilckhalten', u'zur\xfcckhalten'), (u'zurilckholen', u'zur\xfcckholen'), (u'zurilckkehre', u'zur\xfcckkehre'), (u'zurilckkehren', u'zur\xfcckkehren'), (u'zurilckkehrt', u'zur\xfcckkehrt'), (u'zurilckkommen', u'zur\xfcckkommen'), (u'zurilckkommt', u'zur\xfcckkommt'), (u'zurilcklassen', u'zur\xfccklassen'), (u'zurilckziehen', u'zur\xfcckziehen'), (u'Zurilckziehenl', u'Zur\xfcckziehen!'), (u'zurilckzugeben', u'zur\xfcckzugeben'), (u"zurl'Jck", u'zur\xfcck!'), (u"zurL'lck", u'zur\xfcck'), (u'zurLick', u'zur\xfcck'), (u'zurljckgeben', u'zur\xfcckgeben'), (u'zurllickfallen', u'zur\xfcckfallen'), (u'zurllickgekehrt', u'zur\xfcckgekehrt'), (u'zurllickkehrt', u'zur\xfcckkehrt'), (u'zurllickzukehren', u'zur\xfcckzukehren'), (u'zurlllckgehen', u'zur\xfcckgehen'), (u'zurlllckkomme', u'zur\xfcckkomme'), (u'zurtick', u'zur\xfcck'), (u'zurtickbringe', u'zur\xfcckbringe'), (u'zurtickgezogen', u'zur\xfcckgezogen'), (u'zurtlckgekommen', u'zur\xfcckgekommen'), (u'zurtlckvervvandeln', u'zur\xfcckverwandeln'), (u'Zuruck', u'Zur\xfcck'), (u'ZURUCK', u'ZUR\xdcCK'), (u'zuruckbleiben', u'zur\xfcckbleiben'), (u'zuruckblicken', u'zur\xfcckblicken'), (u'zuruckdenke', u'zur\xfcckdenke'), (u'zuruckfeuern', u'zur\xfcckfeuern'), (u'zuruckgehen', u'zur\xfcckgehen'), (u'zuruckgelegt', u'zur\xfcckgelegt'), (u'zuruckgewiesen', u'zur\xfcckgewiesen'), (u'zuruckgreifen', u'zur\xfcckgreifen'), (u'zuruckhaben', u'zur\xfcckhaben'), (u'zuruckkehren', u'zur\xfcckkehren'), (u'zuruckkehrten', u'zur\xfcckkehrten'), (u'zuruckkomme', u'zur\xfcckkomme'), (u'zuruckkommen', u'zur\xfcckkommen'), (u'zuruckk\xe9mst', u'zur\xfcckk\xe4mst'), (u'zuruckl', u'zur\xfcck!'), (u'zurucklassen', u'zur\xfccklassen'), (u'zurUcklieB', u'zur\xfccklie\xdf'), (u'zuruckl\xe9cheln', u'zur\xfcckl\xe4cheln'), (u'zurucknehmen', u'zur\xfccknehmen'), (u'zuruckverwandeln', u'zur\xfcckverwandeln'), (u'zuruckverwandelt', u'zur\xfcckverwandelt'), (u'zuruckziehen', u'zur\xfcckziehen'), (u'zuruckzukommen', u'zur\xfcckzukommen'), (u'zurverfilgung', u'zur Verf\xfcgung'), (u'zur\xe9ickrufen', u'zur\xfcckrufen'), (u'zur\ufb02ck', u'zur\xfcck'), (u'Zur\ufb02ckbleiben', u'Zur\xfcckbleiben'), (u'zur\ufb02ckfliegen', u'zur\xfcckfliegen'), (u'zur\ufb02ckgeschickt', u'zur\xfcckgeschickt'), (u'zur\ufb02ckgibst', u'zur\xfcckgibst'), (u"zus'a'tzliche", u'zus\xe4tzliche'), (u'zusammenbeilien', u'zusammenbei\xdfen'), (u'zusammenffigen', u'zusammenf\xfcgen'), (u'zusammenfugen', u'zusammenf\xfcgen'), (u'zusammenfuhren', u'zusammenf\xfchren'), (u'zusammenf\xe9illt', u'zusammenf\xe4llt'), (u'zusammenh\xe9ilt', u'zusammenh\xe4lt'), (u'zusammenh\xe9lt', u'zusammenh\xe4lt'), (u'zusammenh\xe9ngen', u'zusammenh\xe4ngen'), (u'zusammenreifien', u'zusammenrei\xdfen'), (u'zusammenzuschweifien', u'zusammenzuschwei\xdfen'), (u'zuschl\xe9gst', u'zuschl\xe4gst'), (u'zust6Bt', u'zust\xf6\xdft'), (u'zustofken', u'zusto\xdfen'), (u'zust\xe9indig', u'zust\xe4ndig'), (u'zust\xe9ncligen', u'zust\xe4ndigen'), (u'zust\xe9ndig', u'zust\xe4ndig'), (u'zust\xe9ndigen', u'zust\xe4ndigen'), (u'zus\xe9tzlich', u'zus\xe4tzlich'), (u'zus\xe9tzliche', u'zus\xe4tzliche'), (u'zuverlfissig', u'zuverl\xe4ssig'), (u'zuverllssig', u'zuverl\xe4ssig'), (u'zuverl\xe9ssig', u'zuverl\xe4ssig'), (u'zuverl\xe9ssiger', u'zuverl\xe4ssiger'), (u'zuviel', u'zu viel'), (u'zuviele', u'zu viele'), (u'zuzuflligen', u'zuzuf\xfcgen'), (u'Zu\ufb02ucht', u'Zuflucht'), (u'zvvei', u'zwei'), (u'Zw6If', u'Zw\xf6lf'), (u'zw6lfmal', u'zw\xf6lfmal'), (u'Zwel', u'Zwei'), (u'Zwickmfihle', u'Zwickm\xfchle'), (u'Zwillingstiichter', u'Zwillingst\xf6chter'), (u'Zwischenf\xe9lle', u'Zwischenf\xe4lle'), (u'zwnlf', u'zw\xf6lf'), (u'Zw\xe9ilften', u'Zw\xf6lften'), (u'zw\xe9lf', u'zw\xf6lf'), (u'z\xe9gerlich', u'z\xf6gerlich'), (u'z\xe9gern', u'z\xf6gern'), (u'Z\xe9gerns', u'Z\xf6gerns'), (u'z\xe9h', u'z\xe4h'), (u'z\xe9he', u'z\xe4he'), (u'z\xe9her', u'z\xe4her'), (u'z\xe9hl', u'z\xe4hl'), (u'z\xe9hle', u'z\xe4hle'), (u'z\xe9hlen', u'z\xe4hlen'), (u'Z\xe9hlerei', u'Z\xe4hlerei'), (u'z\xe9hlt', u'z\xe4hlt'), (u'z\xe9hltl', u'z\xe4hlt!'), (u'Z\xe9hlung', u'Z\xe4hlung'), (u'Z\xe9hne', u'Z\xe4hne'), (u'Z\xe9hnen', u'Z\xe4hnen'), (u'Z\xe9hneputzen', u'Z\xe4hneputzen'), (u'z\xe9ihle', u'z\xe4hle'), (u'z\xe9ihlen', u'z\xe4hlen'), (u'z\xe9ihlt', u'z\xe4hlt'), (u'Z\xe9ihlungen', u'Z\xe4hlungen'), (u'Z\xe9ihne', u'Z\xe4hne'), (u'Z\xe9libat', u'Z\xf6libat'), (u'\\/GFQHUQGH', u'Vergn\xfcgen'), (u'\\/OFVVUFf\u20ac', u'Vorw\xfcrfe'), (u'\\/Vahrheit', u'Wahrheit'), (u'\\/Vir', u'Wir'), (u"\\/\\/i6fUl'1l\u20acfi", u'Wie f\xfchlen'), (u"\\/\\/il'fUl'1I'\u20acl'1", u'Wir f\xfchren'), (u'\\Nynn', u'Wynn'), (u'_', u'-'), (u'\xc4u', u'Au'), (u'\xe9', u'\xe0'), (u'\xe9chzt', u'\xe4chzt'), (u'\xe9ffentlich', u'\xf6ffentlich'), (u'\xe9ffne', u'\xf6ffne'), (u'\xe9ffnen', u'\xf6ffnen'), (u'\xe9ffnet', u'\xf6ffnet'), (u'\xe9fft', u'\xe4fft'), (u'\xe9fter', u'\xf6fter'), (u'\xe9fters', u'\xf6fters'), (u'\xe9h', u'\xe4h'), (u'\xe9hnlich', u'\xe4hnlich'), (u'\xe9hnliche', u'\xe4hnliche'), (u'\xe9hnlicher', u'\xe4hnlicher'), (u'\xe9ih', u'\xe4h'), (u'\xe9ihnlich', u'\xe4hnlich'), (u'\xe9indern', u'\xe4ndern'), (u'\xe9itzend', u'\xe4tzend'), (u'\xe9lter', u'\xe4lter'), (u'\xe9lteste', u'\xe4lteste'), (u'\xe9ltesten', u'\xe4ltesten'), (u'\xe9ndere', u'\xe4ndere'), (u'\xe9ndern', u'\xe4ndern'), (u'\xe9ndert', u'\xe4ndert'), (u'\xe9nderte', u'\xe4nderte'), (u'\xe9nderten', u'\xe4nderten'), (u'\xe9ngstlich', u'\xe4ngstlich'), (u'\xe9rgere', u'\xe4rgere'), (u'\xe9rgern', u'\xe4rgern'), (u'\xe9rztliche', u'\xe4rztliche'), (u'\xe9rztlichen', u'\xe4rztlichen'), (u'\xe9rztlicher', u'\xe4rztlicher'), (u'\xe9sthetisch', u'\xe4sthetisch'), (u'\xe9tzend', u'\xe4tzend'), (u'\xe9ufierst', u'\xe4u\xdferst'), (u'\xe9ufiersten', u'\xe4u\xdfersten'), (u'\xe9uflserst', u'\xe4u\xdferst'), (u'\ufb02atterndem', u'flatterndem'), (u'\ufb02el', u'fiel'), (u'\ufb02iehen', u'fliehen'), (u'\ufb02jr', u'f\xfcr'), (u'\ufb02lhlen', u'f\xfchlen'), (u'\ufb02lllen', u'f\xfcllen'), (u'\ufb02lr', u'f\xfcr'), (u'\ufb02lrchterlich', u'f\xfcrchterlich'), (u'\ufb02ndet', u'findet'), (u'AIle', u'Alle'), (u'AIter', u'Alter'), (u'GI\xfcck', u'Gl\xfcck'), (u'PIaystation', u'Playstation'), (u'AIIes', u'Alles'), (u'AIso', u'Also'), (u'Ouatsch', u'Quatsch'), (u'AIles', u'Alles'), (u'BIeib', u'Bleib'), (u'KIaut', u'Klaut'), (u'AIlah', u'Allah'), (u'PIan', u'Plan'), (u'oderjemand', u'oder jemand'), (u'liestjetzt', u'liest jetzt')]),
                        'pattern': u"(?um)(\\b|^)(?:\\/a|\\/ch|\\/d\\/of|\\/ebte|\\/eid|\\/hn|\\/hnen|\\/hr|\\/hre|\\/hren|\\/m|\\/mmer|\\/n|\\/ndividuen|\\/nn|\\/oe|\\/sf|\\/sf\\/0\\/1n|\\/ungs|\\/Vfinuten|\\/\\\xe9nger|\\/\\\xe9uft|0\\/1|0\\/me|0\\/vne|00om|100m|120m|13Oj\\\xa7hrie|145m|150m|160m|165m|19m|20m|27m|30m|37m|38m|3km|5\\/ch|5\\/cher|5\\/cherer|5\\/e|5\\/nd|500m|5ulSere|60m|6de|6dere|6ffne|6ffnen|6ffnet|6fter|750m|85m|90m|a\\/\\/em|A\\/\\/es|abbeif\\$en|abdrficken|aBen|abergl\\\xe9iubischen|aberja|aberjemand|Aberjetzt|abf\\\xe9hrt|abf\\\xe9illt|abgef\\\xe9rbt|abgeh\\\xe9ngt|abgeh\\\xe9rt|abgelost|abgesprengli|abgestfirztl|abgestilrzt|abgestofien|abgew\\\xe9hlt|abgew\\\xe9hnen|abgew\\\xe9hnt|abge\\\xe9nderten|abh\\\xe9ingt|abh\\\xe9ngen|abh\\\xe9ngig|abh\\\xe9ngiges|Abh\\\xe9rstationen|Abjetzt|abkfihlen|Abkfirzung|abkommlich|Ablegenl|ablfisen|ablosen|Ablosung|abreif\\$en|Abrijcken|abr\\\xe9umen|Absch\\/ed|abschiefien|abschlief\\$en|abschliefien|abschwiiren|abstoflsend|Abtrijnnige|abwiirgt|abw\\\xe9gen|abzuh\\\xe9ren|abzuschwiiren|abzusfofien|ACh|Achtungl|Achzen|ACHZT|Acic|ADDRESSDATEI|Adi\\\xf6s|Admiralitat|Admiralit\\\xe9it|Admiralit\\\xe9t|Aff\\\xe9re|Aff\\\xe9ren|AFl|aggresivem|Agypten|aher|AI\\/en\\/vichtigste|Ain\\/vays|AIs|Aktivit\\\xe9iten|Aktivit\\\xe9ten|AKTMERT|Alarmsfufe|albem|Albtriiume|ale|alleinl|allejubeln|allern\\\xe9chsten|Allmiichtigerl|Allm\\\xe9chtige|Allm\\\xe9chtiger|allm\\\xe9hlich|Allm\\\xe9ichtiger|Allsparkl|allt\\\xe9iglichen|ALTESTE|Altester|Alzte|Amerx\\'kaner|amfisierst|Amiilsierst|amiisieren|amiisierenl|amiisierte|Amijsant|amlllsant|amlllsiert|amtlsant|Amusanf|amusant|Amusiert|Anderst|Anderung|Anderungen|anfa\\'ngt|Anffihrer|Anffingerl|Anfiihrer|anfijhlt|Anfingerl|Anfuhrer|Anfuhrern|Anf\\\xe9inger|Anf\\\xe9ingergliick|Anf\\\xe9nge|anf\\\xe9ngst|anf\\\xe9ngt|angebrfillt|angebrullt|angefiihrt|ANGEHCHDRIGE|angehfirt|Angehtirigen|angeh\\\xe9ren|angeh\\\xe9rt|angel\\\xe9chelt|angerilhrt|anger\\\ufb02hrt|angeschweifit|angespruht|angetiltert|Angriffspl\\\xe9nen|Angstschweili|anhiiren|Anh\\\xe9inger|anh\\\xe9lt|anh\\\xe9ngen|anh\\\xe9ren|ankijndigen|anliigen|anlugen|anmal3ende|ann\\\xe9hern|anriihrst|anrijuhren|anst\\\xe9indig|anst\\\xe9indiger|anst\\\xe9indiges|anst\\\xe9ndig|anst\\\xe9ndige|anst\\\xe9ndigen|Anst\\\xe9ndiges|Antik\\\xe9rper|Antiquit\\\xe9t|Antistrahlenger\\\xe9t|antwortenl|Anwe\\/sung|Anwe\\/sungen|Anw\\\xe9iltin|Anw\\\xe9lte|Anw\\\xe9ltin|Anzilge|Anztinden|Anzuge|Anzugen|anzuhiiren|anzuhoren|anzundenl|anzupiibeln|An\\\xe9sthesie|An\\\xe9sthesieprofessor|An\\\xe9sthesieteam|An\\\xe9sthesist|An\\\xe9sthesisten|An\\\xe9sthetikum|ARBEITERI|Arbeitsfl\\\ufb02gel|Armeefunkger\\\xe9t|Armel|Arschkichern|Arschliicher|Arschliichern|Arschl\\\xe9cher|Arschl\\\xe9chern|Arzte|Arzten|Arztin|Atemger\\\xe9usche|Atlantikkiiste|Atlantikkuste|ATMOSPHARE|Atmosph\\\xe9re|Atmosph\\\xe9renbereich|Atmosph\\\xe9reneinflugsequenz|Atmosph\\\xe9reneintritt|Attenfaiter|Attent\\\xe9iter|Attent\\\xe9ter|Attent\\\xe9ters|Attraktivit\\\xe9t|auBen|Aubenblick|AuBenbord|AuBenwelt|auBer|AuBerdem|auBerhalb|auc\\/1|auchl|Auf\\$erdem|auf3er|aufAugenh6he|aufblilhende|auff\\'a\\'ngt|Auff\\\xe9lliges|aufgebltiht|aufgeftlhrt|aufgeh\\\xe9ingt|aufgeh\\\xe9rt|aufgekl\\\xe9rt|aufger\\\xe9umt|aufgespiefit|aufgewiihlter|aufgez\\\xe9hlt|Aufh6ren|aufhbren|aufhdrf|aufhfiren|aufhiiren|Aufhoren|Aufh\\\xe9iren|aufh\\\xe9ngen|Aufh\\\xe9ren|aufh\\\xe9renl|aufi|Aufienministerium|aufier|Aufierdem|aufiergew\\\xe9hnliche|aufierhalb|Aufierirdischer|Aufierlich|aufierordentlich|Aufkenposten|aufkisen|aufkl\\\xe9ren|Aufkl\\\xe9rung|aufl|Aufl6sung|aufliisen|auflser|aufl\\\xe9sen|aufmiibeln|aufraumte|aufr\\\xe9umen|aufschlief\\$en|Aufschlull|aufSer|aufSIJBigkeiten|aufspturen|aufstellenl|Aufst\\\xe9ndige|aufTanis|Auftr\\\xe9ge|aufvv\\\xe9ndigen|aufw\\\xe9ichst|aufw\\\xe9rmen|aufZ\\>er|Aufztlge|aufzuhiivren|aufzukl\\\xe9ren|aufzuldsen|aufzur\\\xe9umen|aufz\\\xe9hlen|auf\\\xe9er|auf\\\ufb02iegen|Augenm\\\xe9igen|aul\\'5er|aul3er|Aul3erdem|aul5er|aulier|Aulierdem|auliergewfihnlich|aulierhalb|Aulierirdischen|auller|aullerhalb|AulSer|AulSerdem|ausdriicken|ausdriickt|ausdrijcken|ausdrucklicher|Ausdr\\\ufb02cken|Ausen\\/v\\\xe9hlte|Ausen\\/v\\\xe9hlter|auserw\\\xe9hlt|Ausffillen|ausfijhren|ausfijhrt|ausfuhren|ausfullt|ausgef\\\ufb02llt|ausgeliischt|ausgeliist|ausgel\\\xe9ist|ausgel\\\xe9scht|ausgel\\\xe9st|ausgeriickt|ausgerijstet|AUSGEWAHLT|ausgew\\\xe9hlt|Ausg\\\xe9ngen|aush6hlen|aushiilt|Aushilfspunkerl|aush\\\xe9lt|ausilben|Auskunfte|ausl|Ausl\\\xe9nder|Ausl\\\xe9nderl|ausl\\\xe9schen|ausl\\\xe9sen|Ausl\\\xe9ser|AusmaB|ausprobie\\\ufb02|Ausriistung|ausrusten|Ausrustung|Ausschullware|ausschwinnenl|auszudriicken|auszuschliefien|auszuw\\\xe9hlen|Autorit\\\xe9t|Autoschlilssel|Autoschl\\\ufb02ssel|au\\\ufb02\\/viihlt|Au\\\ufb02ergewiihnlich|Azevedol|A\\\ufb02es|B\\/ick|b\\/olog\\/sch|b\\/sschen|B6se|B6sem|B6ser|Babym\\\xe9dchen|Ballastst\\\xe9ffchen|Ballm\\\xe9dchen|Ballm\\\xe9idchen|Ballonverk\\\xe9ufer|Balzenl|Bankijberfall|Barbarenilberfall|Barenk\\\xe9nig|basfeln|Bastianol|Bastlano|Bauchfellentztmdung|Bauchkr\\\xe9mpfe|bauf\\\xe9llig|bauf\\\xe9llige|Baumst\\\xe9mme|Baupl\\\xe9ne|Bbses|be\\/de|bedecktl|Bedilrfnisse|Bedilrfnissen|Bedllirfnisse|bedrijckt|bedr\\\xe9ngen|bedr\\\xe9ngt|bedr\\\xe9ngten|Beeilungf|Beeilungl|Beerdingungsinsiiiui|Beerdingungsinstitut|Befehll|beffirdert|Beffirderung|befiirchte|befiirchteten|befiirdert|befiirderte|Befiirderung|befilrchtete|befllirchte|befurworte|befurwortet|bef\\\xe9rdere|bef\\\xe9rdert|Bef\\\xe9rderung|beg\\/ng|begl\\\ufb02ckt|begniigt|begrfindetes|Begriiliungsruf|begrijfien|Begrilfiung|Begrilfkung|begrL\\'llZ\\>en|BegrUBungsruf|begrUf\\$t|begrufie|begrufit|Begrundung|Beh6rden|beh\\\xe9lt|Beh\\\xe9lter|beh\\\xe9mmert|beiB|beiBen|beiBt|beif\\$t|beif2\\>en|beifken|beiflsen|beijenen|Beiliring|BEKAMPFEN|bekannf|bekanntermafken|bek\\\xe9me|bek\\\xe9mpfen|Bek\\\xe9mpfung|bel|belde|beliellsen|belm|Beltlftungstunnels|Beluftungstunnel|Beluftungstunnell|bel\\\xe9stigen|Bemiihe|Bemiihen|bemL\\'lhe|bemtuht|bemuhen|bemuhten|Ben\\\xe9tigen|ben\\\xe9tigt|ben\\\xe9tigten|Beobachtar|bereft|bereitf\\\xe9ndet|beriichtigtsten|beriichtlgten|beriihmt|Beriihmtheiten|beriihren|Beriihrend|beriihrt|Beriihrtl|berijhrt|berilhmter|berilhrt|Berilhrung|Berks\\/1\\/re|BerL\\'lhre|berllichtigter|berllihren|berllihrt|berlllhmten|Bern\\/e|beruhrt|beruhrte|ber\\\ufb02hmter|besafi|Besch\\'a\\'ftigt|bescheifien|beschiftigt|beschiiftigt|beschiitzen|beschiitzt|beschiltze|beschiltzen|beschleun\\/gt|beschliefkt|beschlie\\\ufb02tloszuziehen|beschllitzet|beschllitzt|beschr\\\xe9nkt|Beschr\\\xe9nkungen|beschtitze|beschutzen|besch\\\xe9digt|besch\\\xe9ftigen|besch\\\xe9ftigt|besch\\\xe9ftigte|besch\\\xe9ftigten|besch\\\xe9iftige|besch\\\xe9iftigt|Besch\\\xe9imen|besch\\\xe9mendste|besch\\\xe9oligen|besch\\\ufb02tzen|Besch\\\ufb02tzer|Besf\\\xe9f\\/gen|Besitztijmer|BESTATIGE|BESTATIGT|bestenl|bestiirzt|bestiitigen|bestltigt|bestx\\'mmt|best\\\xe9indige|best\\\xe9itigt|Best\\\xe9itigung|Best\\\xe9itigungen|Best\\\xe9tige|Best\\\xe9tigen|best\\\xe9tigt|Best\\\xe9tigung|bes\\\xe9inftigen|bes\\\xe9inftigt|bes\\\xe9nftigen|Betiiubt|betriibt|betriigen|Betriiger|betriigt|betrijgen|Betrijgerl|betrilgen|betrtlgerischer|betr\\\xe9chtliches|Betr\\\xe9ge|betr\\\xe9gt|Bettw\\\xe9ische|Beviilkerung|bevorwir|bev\\\xe9lkern|bewegf|Bew\\\xe9hrungsauflage|bew\\\xe9ihrte|bew\\\xe9iltigen|bew\\\xe9issern|bew\\\xe9lkten|bew\\\xe9ltigen|Bew\\\xe9ltigung|bew\\\xe9ssern|Bew\\\xe9sserungssysteme|Bezirksgelinde|bezuglich|be\\\xe9ingstigende|be\\\xe9ngstigend|be\\\xe9ngstigender|bffnen|Bficher|Bfiro|bfirsten|bfise|bfisen|bfiser|bfises|bfiseste|bfisesten|bgsonderen|BI6de|Bierbfichse|Biicher|Biicherei|Biick|Biiffel|BIiHlt|Biihne|Biilcherei|BIind|Biirger|Biirgerrechte|Biiro|Biiros|Biirotiir|biirsten|Biise|Biisen|biises|Bijchern|Bijhne|Bijndnis|Bijrger|Bijrgermeister|Bijro|Bijrokraten|Bijrzel|Bilchern|Bildseitenverh\\\xe9ltnis|Bilndel|Bilro|BIood|BIQIS|Bischiife|Bischiifen|Bisch\\\xe9fe|bistja|bistjetzt|Bittejetzt|bittersiJl3es|Bittesch\\\xe9n|BIue|bi\\\xdfchen|BL1hne|Bl6cke|bl6d|bl6de|bl6den|bl6der|bl6des|Bl6dian|Bl6dmann|Bl6dsinn|Blauaugel|Blddes|Ble\\/bf|bleibenl|blelbenl|Blfidmann|Blfidsinn|Blfimchen|BLicher|BLihne|Bliid|bliide|bliiden|bliidere|bliides|Bliidmann|Bliidsinn|bliiht|bliirgerlichen|Blijmchen|Bllck|Bllindel|Blllroklammer|bln|bloB|bloBen|bloBstellen|blockiertl|BLODE|blof\\$|blofl|Blol2\\>|blol3|blol3\\>|blol3stellen|bloli|blolistellen|blolls|bls|Blst|bltte|Blumenstr\\\xe9iulichen|Blument\\\xe9pfen|Blutgetr\\\xe4nkte|Blutgetr\\\xe9nkte|blutjungl|blutriinstig|Blutvergiefien|bl\\\xe9d|Bl\\\xe9de|bl\\\xe9den|bl\\\xe9der|Bl\\\xe9des|Bl\\\xe9dheit|Bl\\\xe9dmann|Bl\\\xe9dsinn|Bl\\\xe9iser|Bl\\\xe9ser|bl\\\xe9st|Bnjicke|Bodensch\\\xe9tze|Bogenschiefien|Bogenschiefienl|Bogenschiefiens|Bogenschiitze|Bogenschiitzen|Bogenschijtze|Bogenschijtzen|Bogenschutzen|Bogenschutzenl|BOnjour|bosartige|Bracken|Briicke|Briicken|Briider|Briihe|Briillen|briillt|Brijcke|Brijderlichkeit|brijllen|Brilcke|Brilder|Brilllen|brillltjeden|Brilnette|Brilsten|brilten|BrL\\'lcke|brL\\'lllen|brlliderliche|Brllidern|Brlliste|Broschijre|Broschilren|Broschuren|Brucke|Brucken|Brudern|Bruhe|brullen|brullt|Brutalitiit|Brutzelhtihnchen|Br\\\xe9chtet|Br\\\xe9iutigam|Br\\\xe9sel|Br\\\xe9tchen|br\\\xe9uchte|br\\\xe9uchten|br\\\xe9unen|Br\\\xe9ute|Br\\\ufb02cke|Br\\\ufb02der|Btiro|Btiser|Bucher|Buchern|Budgetkiirzung|BUFO|Bugschutzgerate|Buhnenbild|Bullel|Buml|Bundnis|Burger|Burgerrechtlerin|Buro|BURO|Burol|Burottlr|Busche|B\\\xe9ickchen|B\\\xe9ickerei|B\\\xe9ille|B\\\xe9inder|B\\\xe9ir|B\\\xe9irgermeister|B\\\xe9iro|b\\\xe9ise|B\\\xe9iume|B\\\xe9nder|B\\\xe9r|B\\\xe9ren|B\\\xe9renhasser|B\\\xe9renhunger|B\\\xe9renj\\\xe9ger|B\\\xe9renk\\\xe9nig|B\\\xe9renlaute|B\\\xe9renrolle|B\\\xe9renschnitzereien|B\\\xe9renstimmen|B\\\xe9rin|B\\\xe9risch|B\\\xe9rs|B\\\xe9rte|b\\\xe9s|b\\\xe9se|b\\\xe9sen|B\\\xe9ses|B\\\xe9ume|B\\\xe9umen|B\\\ufb02chern|B\\\ufb02ste|Cafe|Caf\\\xe4|CASAREN|Charakterm\\\xe9ngel|Charakterst\\\xe9rke|Chrlntlna|Ciden|Ciffnet|Cihrchen|Citro\\\xe9n|clamit|class|Clbernimmt|cler|Coimbrasl|CommanderWill|Corenillal|Cowboyscheifi|C\\\xe9sar|D\\/e|d\\/ese|d\\/esem|d\\/esen|D\\/eser|D\\/eses|D\\/sko|dabel|dachfen|daffir|dafiir|Dafijr|Dafijur|Dafilr|dafL\\'lr|dafLir|dafljr|dafllir|Daflllrwar|daftir|dafUr|dafzjir|dajemand|dal|Damenh\\\xe9nde|damitl|damlt|DANEMARK|darfiber|Dariiber|darijber|Darilber|dart\\/\\'ber|dartlber|DARUBER|DarUber|dasjetzt|dasl|Dateniibermittlung|dauem|dauerf|dazugeh\\\xe9ren|Da\\\xdf|Da\\\ufb02lr|Ddrfern|def|Defekf\\/v|deinerZelle|deln|delne|demfiltigen|Demijtigung|demllitige|demllitigen|denkwurdiger|denkw\\\ufb02rdiger|derAbgeordnete|derAusgabe|derAusl6ser|DerjL\\'lngste|derjunge|dermaben|derTyp|derWeg|derWelle|DerWL1rfel|DerZauberer|de\\_\\_n|dfeserr|dffentlichen|dffnen|Dfimonen|dfinn|dichl|diej\\\xfcngste|dienstunfahig|Dieselkapit\\\xe9in|Dieselkapit\\\xe9n|Dieselmotorenl|dieserAufnahme|Dieserjunge|Diiit|diirfe|Diirfen|diirft|diirfte|dijfien|dijnn|dijrfen|Dijrfte|dijstere|dilmmer|dilrfen|dilrft|dilrften|dilrftig|Dine|dirja|dirjemand|dirjetzt|dirJulie|dirl|dirwehzutun|Di\\\xe9t|Di\\\xe9tberaterin|Di\\\xe9tbier|dlch|Dle|dles|Dlese|Dlfit|Dlitplan|dllirfen|dllirft|dllirstet|dlr|doc\\/1|dochl|dolthin|Doppelgfiner|Doppelgfinger|Doppelg\\\xe9inger|Doppelg\\\xe9nger|Doppelzijngig|doppelztmgiger|dor|Dr\\'a\\'ngt|drachengriinen|Drahte|dranl|drau\\/3en|drau\\/Sen|drauBen|drauf\\$en|draufdrilcken|draufgestllirzt|draufg\\\xe9ngerisch|draufien|draufken|drauflsenl|drauf\\\xe9en|drauilen|draul3en|draul5en|draulien|draullen|draulSen|Dreckl\\\xe9chern|Drecksmiihle|Drecks\\\xe9cke|drfiben|Drfick|Drfingeln|drih|driiben|driicken|driickt|drijben|drijber|drijck|drijckt|drilben|drilber|drilcken|drLiber|drlliben|drlllben|Drogenabh\\\xe9ngige|Drticken|druben|drubenl|druber|Druckkn\\\xe9pfe|drunterliegt|Dr\\\xe9nage|dr\\\xe9ngeln|dr\\\xe9ngen|dr\\\xe9ngt|dr\\\ufb02ben|dtirft|dtlrfen|Dudels\\\xe9cken|dUFf\\\u20acl\\'1|dul|dull|Dummk6pfe|Dummkiipfe|Dunnschiss|durchdrficken|durchdr\\\xe9ngen|Durchfiihrung|durchfuhren|durchgefiihlt|durchgefijhrt|durchgefuhrt|durchgef\\\ufb02hrt|Durchg\\\xe9nge|Durchladenl|durchlfichere|durchsetzungsf\\\xe9higer|durchst\\\xe9bern|durchwilhlt|durchzufilhren|durchzufuhren|Durfen|durft|dusterer|D\\\xe9cher|D\\\xe9imon|D\\\xe9imonen|D\\\xe9inemark|D\\\xe9inemarks|D\\\xe9inen|d\\\xe9inisches|d\\\xe9mlich|D\\\xe9mliche|d\\\xe9mlichen|d\\\xe9mlicher|d\\\xe9mlichl|d\\\xe9mmert|D\\\xe9monenb\\\xe9ren|d\\\xe9monischen|D\\\xe9rme|D\\\xe9rrfleisch|D\\\xe9umchen|d\\\ufb02rfen|E\\/\\/e|e\\/n|e\\/ne|e\\/nem|e\\/nen|e\\/ner|e\\/nes|e\\/ns|e\\/nsf|E9YPt|Ea\\/vtes|ebenbfirtig|ebenburtige|Ec\\/vte|echfen|edelm\\\ufb02tig|efn|efwas|Eheminner|Ehem\\\xe9nnern|Ehezerstfirerin|Ehrenbijrger|EHRENBURGERSCHAFT|Ehreng\\\xe9iste|Eichhfirnchen|Eichhiirnchen|Eichh\\\xe9rnchens|eifersfichtig|eifersiichtig|eifers\\\ufb02chtig|eigenh\\\xe9ndig|eigenmlchtig|eigenntltziges|Eihnlich|Eimen\\/veise|Einbruche|eindriicken|Eindring\\/Inge|eindrucken|einejunge|einerfr\\\ufb02hen|einervorfuhrung|einfiihren|Einfiihrung|einfilgen|einfilhlsamsten|einflllgen|Einflusse|einfugen|einfuhrten|Einfuhrung|Einf\\\xe9ltige|eingefiigt|eingef\\\ufb02gt|eingehiillt|eingepr\\\xe9gt|einger\\\xe9iumt|einger\\\xe9umt|eingeschl\\\xe9fert|eingeschr\\\xe9nkt|eingesch\\\xe9itzt|eingesch\\\xe9tzt|eingesturzt|eingieBt|eingschaltet|Einh\\\xe9rnern|einlegenl|einl\\\xe9dt|einl\\\xe9sen|Einsatzfahigkeit|Einschiichterung|Einschliefklich|Einschlielilich|einstellenl|Eins\\\xe9tze|eint\\\xe9nig|Einzelg\\\xe9ngerin|einzusch\\\xe9tzen|Eisstiirme|Elektrizit\\\xe9t|elfenbeingetfinte|elit\\\xe9rer|Eln|Elne|elnem|Elnen|elner|Elnes|empfindungsf\\\xe9higen|Empf\\\xe9inger|empf\\\xe9ngt|Empiirend|Empiirendste|empiirt|emst|en\\/varten|En\\/vartungen|en\\/v\\\xe9hnt|Enchant\\\xe4|endgiiltig|endgultig|endgultigen|endg\\\ufb02ltig|endlichl|ENERIGE|enfternt|Engl\\\xe9nder|Engl\\\xe9nderin|eniillen|entbl6Bte|entbl6f\\$en|entfiihre|entfiihrt|entfiihrte|Entfiihrung|Entftihrung|ENTFUHRUNGSVERDACHTIGER|enthllt|enthUllt|enth\\\xe9lt|entliiften|Entliiftungen|Entlijlftungen|entluften|entl\\\xe9sst|Entreilit|entriistet|entr\\\xe9itseln|Entschlrfen|Entschlull|ENTSCHLUSSELN|Entschlussen|entsch\\\xe9rfen|enttausche|enttiiuscht|Enttluscht|Enttluschungen|entt\\\xe9iuschen|entt\\\xe9uschen|entt\\\xe9uschst|entt\\\xe9uscht|Entv\\\\\\/Urfe|Entwicklungsl\\\xe9ndern|entzllickt|entzllindet|entzuckend|entzundet|enzv\\\xe9rmt|Er6ffnen|erb\\\xe9rml\\/ch|erb\\\xe9rmlich|Erb\\\xe9rmliches|Erdnijsse|erdriickt|erd\\\xe9ihnliche|erfebst|erffillen|erfiffnet|erfiille|erfiillen|erfiillt|erfijllt|erfillle|erfilllen|erfilllt|erfllille|erfllillt|erflllllen|Erfolgl|erfullen|erfullt|erf\\\xe9hrst|erf\\\xe9hrt|erf\\\ufb02llen|ergrllindet|erhalfen|Erhdhe|erhiihter|erhiiren|ERHKLT|erhllt|erh\\\xe9hen|erh\\\xe9ht|erh\\\xe9ilt|erh\\\xe9lt|erh\\\xe9rt|erh\\\xe9rte|eriiffnet|erja|erjetzt|erjung|erkl\\'a\\'ren|erkl\\'air\\'s|erklaren|erklfire|Erklfirung|erklirt|erkllre|erkllrt|erkllrte|erkllrten|Erkllrung|erkl\\\xe9ir|erkl\\\xe9ire|erkl\\\xe9iren|erkl\\\xe9r|erkl\\\xe9r\\'s|erkl\\\xe9rbar|Erkl\\\xe9re|erkl\\\xe9ren|erkl\\\xe9rt|Erkl\\\xe9rung|erk\\\xe9ltest|erlC\\'\\>st|erldse|Erled\\/gen|erlieB|erlnnem|erl\\\xe9scht|erl\\\xe9sen|erl\\\xe9st|Erl\\\xe9sung|ermbglichen|Erm\\\xe9chtige|erm\\\xe9glicht|erm\\\xe9glichte|ernlllchtert|ern\\\xe9hren|Ern\\\xe9hrung|eroffnet|Erpressungsscheilie|err\\\xe9tst|erschieB|erschieBen|erschiefien|erschiefit|erschiefke|erschielie|Erschielit|erschiipft|erschiittert|erschilttert|erschl\\\xe9gt|ERTCHDNT|ERTCNT|ERTGNT|ertiffnen|ertr\\\xe9gst|ertr\\\xe9inken|ert\\\xe9nt|ervvartez|ervvilrgen|ervv\\\xe9hnen|ervv\\\xe9ihnen|ervv\\\xe9ihnt|ervv\\\xe9ihnte|Erv\\\\\\/an|Erv\\\\\\/an\\'s|erw\\'a\\'hnt|Erwar|erwe\\/sen|Erwfirmung|Erwird|Erwtirde|erw\\\xe9gt|Erw\\\xe9gung|Erw\\\xe9hne|erw\\\xe9hnen|erw\\\xe9hnt|erw\\\xe9hnte|Erw\\\xe9hnung|erw\\\xe9ihlt|erw\\\xe9ihnt|erw\\\xe9rmt|erz\\'a\\'hlt|Erzdiiizese|erzfihlen|Erzfihler|erzihlenl|erziihlen|erziihlt|erziirnt|erzilrnt|erzllirnt|erzurnen|erz\\\xe9hl|erz\\\xe9hle|Erz\\\xe9hlen|erz\\\xe9hlerische|erz\\\xe9hlerischen|erz\\\xe9hlerischer|Erz\\\xe9hlkunste|erz\\\xe9hlst|erz\\\xe9hlt|erz\\\xe9hlte|Erz\\\xe9hlung|Erz\\\xe9ihl|Erz\\\xe9ihle|erz\\\xe9ihlen|erz\\\xe9ihlst|erz\\\xe9ihlt|erz\\\xe9ihlte|er\\\xe9ffnen|er\\\xe9ffnet|er\\\xe9ffnete|Er\\\xe9ffnungsaufnahme|Er\\\xe9ffnungssequenz|Er\\\xe9ffnungsszene|Er\\\ufb02lllen|etemity|etvva|euc\\/1|Europ\\\xe9er|europ\\\xe9ische|ex\\'nfac\\'\\/7|Examenspriifungen|Exekutivzust\\\xe9noligkeit|Explosionenl|Extrablattl|F\\/nden|F\\/ugba\\/I|Fahnrich|fahrlissiges|Fairbankverlieh|Fallef|fallengelassen|Fallschirmj\\\xe9gereinheiten|Fam\\/Z\\/e|Fa\\\xdf|FBl|Fe\\/nd|fehlschl\\\xe9gt|Feindberllihrung|Feind\\\xfcbewvachung|feltig|femen|fernh\\\xe9ilt|Festhaltenl|Fettw\\\xe9nste|Feuen\\/vehr|Feuerliischer|Feuervvehrrnann|Feuerwehrl|Feuerwfirmen|Feue\\\ufb02|ff\\'Ul\\'1\\\u20acf\\'\\\u20acl\\'1|Ffiegen|ffihft|ffihren|ffinf|ffir|ffirchte|ffirs|ffittere|FI6he|Fiasenm\\\xe9iher|fibel|fiber|fiberdressierter|fibergezogen|fiberhaupt|fiberholt|fiberlegt|fibernachtet|fiberspannt|fibertreiben|fiberzfichtete|fibrig|Fieferenz|Fieifi|fiffentlichkeit|fiffnen|fiffnest|fifter|Fihigkeit|fihneln|Fihrt|fiihl|fiihle|fiihlen|fiihlst|fiihlt|Fiihlte|Fiihre|Fiihren|Fiihrerin|Fiihrerschein|fiihrfe|fiihrt|fiihrte|Fiihrungsf\\\xe9ihigkeiten|Fiihrungsprogramm|Fiihrungsstil|Fiilcksicht|fiillen|fiinden|fiinf|fiinfhundert|fiinfzehn|fiir|fiirchte|fiirchten|fiirchterlich|fiirchterlichl|fiirchterllches|fiirchtet|fiirchteten|fiirjeden|Fiirmchen|fiirs|Fijgen|fijhl|fijhle|fijhlen|fijhlst|fijhlt|fijhren|Fijhrer|fijhrt|Fijhrungsqualit\\\xe9iten|FiJl3en|Fijlie|fijlr|Fijnf|Fijnfziger|fijr|fijrchte|fijrchten|Fijrjedenl|fijrs|fiJrVorteile|fijttern|fijur|filhl|filhle|filhlen|filhlte|filhre|filhren|Filhrern|Filhrerschein|filhrst|filhrt|filhrte|filhrten|Filhrung|Fillle|Filll\\\xe9en|Filmemachen|Filml|filnf|Filn\\\ufb02|Filr|filr\\'ne|filrchten|filrchterlich|filrs|filter|findem|findenlassen|Fingerabdrijcke|Fingerabdrilcke|Fingerniigeln|Fingern\\\xe9gel|Fingern\\\xe9geln|fingstlich|Fiothaarige|Firmen\\\xe9rzte|Fischk\\\xe9pfe|FIUssigkeitsgleichgewicht|Fiusten|FIynn|fjffnen|fL\\'1\\'r|fL\\'1hle|FL\\'1r|fL\\'ir|fL\\'lr|fL1r|Fl6he|Flclse|fleifkige|fleifkiges|fleil3ig|Fleischb\\\xe9llchen|Fleischkl6l\\'Sen|Flfige|Flfigell|flfistert|Flhigkeiten|Flhnrich|Flhnriche|flieBen|Fliefiband|Fliefiheck|Flieflsb\\\xe9nder|flielit|flielSt|FLif\\$e|fLihlt|fliichtige|Fliigel|flijchtig|Flijgel|Flijgelfedernl|Flilssige|flilstert|fLir|fljhrt|Fljr|flJr\\'n|fllihrst|Fllihrt|fllinf|fllinften|Fllinkchen|Fllir|fllirchte|fllirchten|fllirchterlichen|fllirchtet|Fllirsten|Fllitterungszeitenl|flllgte|flllgten|flllhrten|Flllhrung|Fllligel|flllistern|fllllstert|flllrchte|flllrchten|flllrjede|Flohtransporterl|Floli|Flottenalzt|Flottenstiitzpunkt|Flottenstutzpunkt|Flrma|fltlsterte|Fluchtig|Flughdhe|Flughiihe|Flugh\\\xe9ifen|Flugunf\\\xe9ihig|flugunf\\\xe9ihigen|Flugunf\\\xe9ihigl|Flugzeugl|FLUSSIGER|Flustereffekt|Flustern|FLUSTERT|fl\\\ufb02stern|fl\\\ufb02sterten|Folgendesz|fortgespiilt|fortspiilen|fortw\\\xe9hrend|Fr\\/ed\\/10\\/|Fr5ulein|Fr6hliche|Frachfmodule|Frafi|fragfe|Fral\\'S|fralken|Franzfisisch|Franziisin|franziisische|franziisischen|franziisischer|franziisisches|Franz\\\xe9sisch|franz\\\xe9sische|franz\\\xe9sischen|franz\\\xe9sischer|Franz\\\xe9sisches|FRAULEIN|fre\\/em|freffen|freilieB|freimiitigen|Fressger\\\xe9usche|Frfichtekuchen|frfih|frfiher|Friedh\\\xe9fe|Friichtchen|friih|friihen|friiher|friihere|friihliche|friihlichen|Friihstiick|friilher|friilhesten|Frijchte|frijh|frijher|frijherer|frilh|frilhen|Frilher|frilhere|Frilhst\\\ufb02ck|Fris6r|frL\\'lher|Frljihling|Frllichte|frllih|frlliher|Frllihstiickskiiche|fro\\/1|FROHLICHE|frtih|Frtiher|Frtihliche|Frtihstticksei|Frtlh|FrUh|FRUHE|fruhe|fruhen|Fruher|fruheren|Fruhling|Fruhlingsrolle|FrUhstUck|Fruhstuck|frUhstUcken|fr\\\xe9hliches|fr\\\xe9ihfiches|fr\\\xe9ihlich|Fr\\\xe9iulein|fr\\\xe9nen|Fr\\\xe9sche|Fr\\\xe9ulein|ftihlen|Ftillhorn|Ftir|Ftirs|Ftlhrung|ftlrchte|ftmf|Fu\\/3|FuB|FuBballspieler|FUBen|Fuf\\$|Fufi|Fufiabdrucke|Fufiballtraining|FufL|Fuflsball|Fuflsballszene|fUhl\\'t|fuhle|fuhlst|fUhlt|fUhre|fUhrt|fuhrte|fuhrten|Fuhrung|Fuhrungsf\\\xe9higkeiten|Fuhrungsoffizier|Fuhrungsqualit\\\xe9t|FUI3en|Fuli|Fuliball|Fulisohlen|FUller|fUllten|fumt|Fundbiiro|FUnf|Funftbeste|Funkchen|Funkger\\\xe9it|Funkger\\\xe9ite|Funkger\\\xe9t|funktionstilchtig|FUR|Fur|fUrAusweichmanc\\'\\\xa7ver|furchteinfl6Bend|furchteinfl6Bende|furchten|Furchtest|furchtet|furchteten|fureinander|furjeden|furjemanden|furjudische|furs|FUrWalter|fut|Fu\\\ufb02ballspiel|F\\\xa7hnlein|f\\\xe9\\/\\/t|f\\\xe9hig|F\\\xe9higkeit|F\\\xe9higkeiten|f\\\xe9hnen|F\\\xe9hnens|F\\\xe9hnerei|F\\\xe9hnleinmiitter|F\\\xe9hre|f\\\xe9hrst|f\\\xe9hrt|F\\\xe9ihigkeit|F\\\xe9ihigkeiten|f\\\xe9ihrt|f\\\xe9illst|f\\\xe9illt|F\\\xe9ilschung|F\\\xe9ingt|f\\\xe9ir|F\\\xe9lle|F\\\xe9llen|f\\\xe9lligl|F\\\xe9llt|f\\\xe9llt\\'s|F\\\xe9lschen|F\\\xe9lschung|f\\\xe9nde|F\\\xe9ngst|F\\\xe9ngt|f\\\xe9rben|f\\\xe9rbt|f\\\xe9rdern|f\\\xe9rmlich|F\\\xe9ustlinge|f\\\xfcr\\'ne|f\\\xfcrchlerlichen|f\\\xfcrjede|f\\\xfcrjeden|F\\\ufb02hrungsprogramm|F\\\ufb02hrungsstil|f\\\ufb02llen|f\\\ufb02llt|f\\\ufb02nf|F\\\ufb02r|f\\\ufb02rchte|f\\\ufb02rjeden|g\\/bf|g\\/bsf|G5ste|G6nn|G6t\\'lllche|G6tter|G6ttern|Gamilonl|ganzlich|gardel|Gasbrfiter|gauze|GCJKTEN|ge6lt|gebauf|Gebiez|Gebi\\\xe9ude|gebliebenl|GEBRAUCHTWAGENIPOLIZEIITAXI|Gebr\\\xe9u|gebs|gebuhrend|Geb\\\xe9ick|Geb\\\xe9iude|geb\\\xe9rdet|Geb\\\xe9rmutter|Geb\\\xe9rmutterhals|Geb\\\xe9ude|Geb\\\xe9udedach|Geb\\\xe9uden|Geb\\\xe9udes|gedemiitigt|gedemijtigt|gedemllitigt|gedrtickt|gedr\\\xe9ngt|Ged\\\xe9chtnisverlustes|Ged\\\xe9ichtnis|ged\\\xe9mpft|gef\\'a\\'hrlich|gef\\'a\\'llt|gef5IIt|gefahrdet|gefahrlich|gefallsllichtige|GEFANGNISTECHNOLOGIE|Gefechtsausrustung|Geffihl|geffihrt|geffillt|Gefihrliche|Gefiihl|Gefiihle|Gefiihlen|Gefiihlslebens|gefiihlsmiliigen|gefiihrt|gefiillst|gefiillt|gefiirchtet|Gefijhl|Gefijhle|gefijhlt|gefijllte|Gefilhl|Gefilhle|gefillt|Gefingnis|gefL\\'lllten|Geflilster|gefllihllos|Geflllhlsduselige|GEFLUSTERT|Geftuhle|Gefuhl|Gefuhle|Gefuhlen|gefuhlt|gefuhlvolle|gefurchtet|Gef\\\xe9hrde|gef\\\xe9hrden|gef\\\xe9hrdet|Gef\\\xe9hrdung|gef\\\xe9hrlich|gef\\\xe9hrliche|gef\\\xe9hrlicher|gef\\\xe9hrlicheren|Gef\\\xe9hrliches|Gef\\\xe9hrt|gef\\\xe9ihrden|gef\\\xe9ihrdet|gef\\\xe9ihrlich|Gef\\\xe9ihrte|Gef\\\xe9ihrten|gef\\\xe9illt|Gef\\\xe9illt\\'s|gef\\\xe9llf|gef\\\xe9llfs|gef\\\xe9llig|gef\\\xe9lligst|gef\\\xe9llst|Gef\\\xe9llt|Gef\\\xe9llt\\'s|gef\\\xe9lscht|Gef\\\xe9ngnis|Gef\\\xe9ngnisregeln|Gef\\\xe9ngnisse|Gef\\\xe9ngnissen|Gef\\\xe9ngnisses|Gef\\\xe9ngniswagen|gef\\\ufb02gig|gegenfiber|gegeniiber|gegeniibertritt|gegeniiberzusfehen|gegenijber|gegenlliber|gegenlliberstehen|Gegenstrfimung|Gegenstr\\\xe9mung|Gegensttlck|Gegenst\\\xe9nde|gegenuber|Gegenverschwiirung|gegenw\\\xe9rtigen|gegriindet|gegrijfit|gegrilfit|GegrUl3t|gegrundet|geh6ren|geh6rt|gehdrt|GeheilS|geheilSen|gehejetzt|gehf|gehfiirt|gehfire|gehfiren|gehfirt|gehiipft|Gehiir|gehiire|gehiiren|gehiirst|gehiirt|Gehim|Gehirnsch\\\xe9den|gehlngt|gehore|gehoren|gehort|geht\\'sl|Gehtirt|gehtjetzt|geh\\\xe9irt|Geh\\\xe9iuteten|geh\\\xe9r|geh\\\xe9re|geh\\\xe9ren|geh\\\xe9rst|Geh\\\xe9rt|geh\\\xe9rten|geh\\\xe9rtf|geiiffnet|geilbt|geistesgestort|Gei\\\ufb02blatt|Gei\\\ufb02blattstaude|gekiisst|gekiisstl|gekijndigt|gekijsst|gekilsst|gekimpfl|gekimpft|geklautl|gekliirt|gekllrt|gekl\\\xe9rt|gekriint|gekrijmmt|GEKUHLTER|gekurzt|gek\\\xe9mpft|gelaufenl|gelegf|gelegtwurde|geliist|gelilftet|gelndert|Gelst|Geltungsbedurfnis|GELUBDE|Gel\\\xe9chter|gel\\\xe9hmt|gel\\\xe9ischt|Gel\\\xe9nde|gel\\\xe9nge|gel\\\xe9st|gem|gemafiregelt|Geme|gemfitliches|Gemiise|gemiitlich|Gemijlse|Gemilt|gemiltlicher|GemLise|Gemut|gem\\\xe9fi|Gem\\\xe9fk|gem\\\xe9ht|Gem\\\xe9ili|Gem\\\xe9lde|Gem\\\xe9lden|Genaul|genieBt|genief\\$en|Geniefien|geniefk|genielien|genielken|genie\\\ufb02en|genligen|genlligend|genlligt|genlllgend|genugt|genugte|georfef|gepfluckt|gepriifter|gepruft|Gep\\\xe9ck|gerfit|Geriichte|Geriite|Gerijcht|Gerllicht|gerllistet|gernhaben|gernntgt|ger\\\xe9it|Ger\\\xe9iusch|Ger\\\xe9t|Ger\\\xe9te|Ger\\\xe9tschaften|ger\\\xe9umt|Ger\\\xe9usch|Ger\\\xe9usche|ger\\\xe9uschvoll|geschafff|GESCHAFTSFUHRER|gescha\\\ufb02i|Geschfift|geschfimt|Geschift|Geschifte|Geschiftsleute|Geschiftswelt|geschiidigt|Geschiift|Geschiiftsleben|geschijtzten|Geschiltz|Geschiltze|Geschiltzrohre|Geschiltzturm|geschlijpftl|Geschllitzstellungen|geschnfiffelt|Geschtitz|Geschtltz|Geschutz|Geschutze|Geschwiir|Geschwllir|Geschwur|geschw\\\xe9cht|geschw\\\xe9ingert|Geschw\\\xe9tz|Gesch\\\xe9ft|Gesch\\\xe9fte|Gesch\\\xe9ftige|gesch\\\xe9ftlich|Gesch\\\xe9fts|Gesch\\\xe9ftsleben|Gesch\\\xe9ift|Gesch\\\xe9ifte|gesch\\\xe9iftsm\\\xe9ifiig|gesch\\\xe9itzt|gesch\\\xe9nolet|Gesch\\\ufb02tze|Gesetzeshiiter|Gesichtl|Gesichtsausdrijcke|Gesiiff|gesiindigt|gespiirt|Gesprach|GESPRACH|GESPRACHE|Gespr\\\xe9ch|Gespr\\\xe9che|Gespr\\\xe9iche|Gespr\\\xe9ichsthema|Gespur|gestiirt|gestijrzt|gestijtzte|gestof\\$en|gestolken|Gestriipp|Gestrijpp|GESTURZT|gest\\\xe9irt|Gest\\\xe9ndnis|gest\\\xe9rt|gest\\\ufb02rzt|Gesundheitsbehijrde|Gesundheitsftlrsorge|Ges\\\xe9fitaschel|Ges\\\xe9iffstaschenl|get6tet|Getiise|getiitet|getr\\'a\\'umt|getr\\\xe9umt|get\\\xe9tet|get\\\xe9tetf|get\\\xe9uscht|gev\\\xe9gelt|gew6hnt|GEWACHSHAUS|gewaltt\\\xe9tig|gewarnf|Gewerkschaftsfunktion\\\xe9ren|gewfinscht|Gewiasenskon\\\ufb02ikte|gewiihlt|gewiihnen|gewiihnlich|gewiihnlicher|gewiihnliches|gewiihnt|gewiinscht|gewijhnlichen|gewijnscht|gewissermafien|gewissermallsen|gewlllnscht|Gewohnheitstiter|gewtinscht|gewunscht|gewunschten|Gew\\\xe9chshaus|gew\\\xe9hlt|gew\\\xe9hnen|gew\\\xe9hnlicher|gew\\\xe9hnst|gew\\\xe9hnt|Gew\\\xe9hren|gew\\\xe9hrt|Gew\\\xe9isser|Gew\\\xe9ssern|gezfichtet|gezilndet|gez\\\xe9hlt|gez\\\xe9ihlt|gez\\\xe9ihmt|ge\\\xe9ndert|GF6l\\'1Z6fUf|Gfirtel|Gfirtner|Gfiste|Gfitter|Ghrchen|gibtjede|gibtk|gibts|gieBen|GieBkanne|gief\\$t|giefit|gielit|gignalton|giinstiger|Giire|Giite|giitiger|Giitter|Giittliche|giittlichen|Gijte|Gijtel|Gilrtel|Gilte|Giltiger|Gitarrenkl\\\xe9nge|Gite|GIUck|GIUCKliCl\\'1|GL\\'lte|Glaubwurdigkeit|Glaubwurdigkeitl|glaubw\\\ufb02rdig|glb|glbt|Gle\\/ch|gleichgiiltig|gleichm\\\xe9mig|Glfick|glficklich|Glfickspilz|Gliick|Gliickchen|gliicklich|gliicklicher|Gliicksbringer|Gliickssfr\\\xe9hne|Gliickwunsch|gliilcklich|Glijck|glijcklich|Glilck|glilcklich|Glilckwunsch|Glillck|gllinstig|gllinstigem|gllinstigen|glljcklich|glllicklich|glllickliche|Glllte|Glorifiziertl|glticklich|Gltickszahlen|gltlckliohes|Gluck|glucklich|gluckliche|GLUCKSELIGKEIT|Gluckwunsch|Gluok|gluoklich|Glupsch\\\xe9ugige|glutheilie|gl\\\xe9inzende|gl\\\xe9nzende|gl\\\xe9nzte|Gl\\\xe9ser|gl\\\xe9ubige|Gl\\\xe9ubigen|Gl\\\ufb02ck|Gl\\\ufb02cklich|Gl\\\ufb02ckstag|Gl\\\ufb02ckwilnsche|gnidig|Gnllnden|gn\\\xe9dig|gn\\\xe9dige|gn\\\xe9digen|Gn\\\xe9digste|gn\\\xe9idig|Goff|Golfballweili|gonnst|gottesfllirchtiger|Gottverdammt|Go\\\ufb02|Gr6Be|gr6Ber|gr6Bere|gr6Beren|Gr6Bte|Gr6Bten|gr6Bter|gr6Btes|gr6f\\$te|gr6f\\$ten|gr6f5ten|gr6I3ter|gr6ISten|Gr6l3e|gr6l3ter|Grabst\\\xe9tte|gratulierel|grClf\\$en|grfilieren|Grfiner|griil3e|griiliere|griiliten|griin|Griinde|Griinden|griindlich|Griine|griinen|Griiner|griin\\\xe9iugige|griin\\\xe9iugiges|grii\\\ufb02te|Grijbeln|griJBen|grijn|Grijnde|grijnden|grijndlich|grijnes|Grijnfutter|Grilbelt|grilfken|Grillh\\\xe9hnchen|Grilnde|Grilnden|grilndet|grilndlich|grilndlicherf|grilndlichl|grilne|Grilnschn\\\xe9bel|grim|Grime|grinco|Grllinde|grllinden|grllindlich|grlllnes|Gro\\/3artig|gro\\/3es|gro\\/3zUgig|Gro\\/Bstadt|gro\\/Ken|groB|groBartig|GroBe|GroBes|GroBmutter|GroBteil|groBziJgiger|grof\\$|grof\\$artig|grof\\$artigen|grof\\$e|grof\\$er|grof\\$es|grof3|grof3\\>artige|Grof3e|grof3en|grof3erAlien|grof5es|Grofbvaters|grofi|Grofiangriffs|Grofiartig|grofiartige|grofiartigen|grofiartiger|Grofiartiges|Grofibritannien|Grofidiebstahl|Grofie|grofier|grofies|grofiten|grofk|Grofkartig|grofke|Grofken|Grofker|Grofkvater|grofLe|grofler|groflsartig|groflsartige|Groflse|groflsen|Grofser|grol|grol\\'3\\>en|grol2\\>|grol2\\>en|grol3\\>es|grol3e|grol3er|Grol3raum|groli|Groliartig|groliartige|groliartigen|grolie|grolien|groliherzig|Grolimutter|Grolisegel|Grolkvater|groller|Grollser|grollzugig|grolS|grolSe|GrolSeltern|grolSer|GrolSvater|grolZ\\~|gror\\$er|grorker|grosses|GROSSTE|gro\\\ufb02|gro\\\ufb02e|Gro\\\ufb02stadtkind|Gro\\\ufb02vater|Grtin|Grtmde|GruB|Grubenausg\\\xe9nge|Gruf\\$|grUf\\$en|grufit|Gruli|Grulikarte|Grulikarten|Grun|grundlich|Grundstiick|grunds\\\xe9tzlich|grune|grunen|Gr\\\xe9ben|gr\\\xe9bst|gr\\\xe9fier|gr\\\xe9fkte|gr\\\xe9flserer|Gr\\\xe9ifite|gr\\\xe9illten|gr\\\xe9sslich|Gr\\\xe9uel|gr\\\ufb02ndlich|gr\\\ufb02ne|gull|Gummist\\\xe9psel|Gumml|GUNSTIGSTEN|Gurtell|gutaussehend|gutaussehender|GUte|gutgebaut|gutgehen|Gutmijtigkeit|g\\\xe9be|g\\\xe9ben|g\\\xe9ibe|G\\\xe9ittern|G\\\xe9lisch|G\\\xe9lische|g\\\xe9lisches|G\\\xe9nsehaut|G\\\xe9nsen|G\\\xe9nze|G\\\xe9rfen|G\\\xe9rtnern|G\\\xe9ste|G\\\xe9stezimmer|G\\\xe9tter|G\\\xe9tterspeise|G\\\xe9ttin|G\\\xe9ttliche|g\\\xe9ttlichen|G\\\xe9tze|G\\\u20acfUhl6|G\\\u20acStFUpp|h\\<\\'\\>\\'r\\'t|h\\<\\'5r|h\\'a\\'lt|H\\'a\\'nde|H\\'a\\'nden|H\\'a\\'ttest|H\\/|H\\/er|h\\/nfer|h5tte|H6fe|h6flich|H6fling|H6hen|h6her|h6here|H6HERER|H6hle|H6l1e|H6lle|H6llen|h6lte|H6r|h6re|h6ren|H6rer|H6rner|h6rst|h6rt|h6rte|Ha\\/s|Haarbijrstel|Haarhfirste|Haarl|Haarstr\\\xe9hne|hab\\'jemanden|Hah|halbstlllndiges|halbvervvandelt|halfef|Hallfjchen|hallol|Halsb\\\xe9nder|Halsl|haltenl|Haltjohnny|Hammersch\\\xe9del|Handfl\\\xe9che|Handlungsstr\\\xe9nge|harfe|hartn\\\xe9ickig|Hasenful|Hasenfull|hassq|Hastja|hatjetzt|hatta|Haupfbus|Hauptaktion\\\xe9ire|Hauptaktion\\\xe9irinnen|Hauptkabell|haupts\\\xe9chlich|haupts\\\xe9ichlich|Haupttrib\\\ufb02ne|Hauptverschwiirer|Hauptwasserrohrwar|Hausfirzte|Haush\\\xe9lterin|Hausschlilssel|Haustilr|Hausubervvachung|ha\\\xdft|Hbr|hc\\'5ren|hc\\'\\\xa7r|hdchsfens|Hdchstleistung|hdher|Hdlle|Hdllenfeuer|hdre|hdren|hdrsf|hdrten|He\\/nr\\/ch|hedeutest|hegrfille|heiB|heiBe|heiBen|HeiBer|heiBes|heiBt|heif\\$|heif\\$e|heif\\$es|Heif\\$t|heif3\\>en|heif3t|heif5en|heifie|heifiem|heifien|heifit|heifkt|heifLt|heifZ\\>e|heil\\'\\$|heil\\'\\$en|heil\\'\\$t|heil\\'Se|heil2\\>en|heil2\\>t|heil3en|heil3t|heil5e|heil5t|heili|heilies|heilit|heillst|heilZ\\~|heir\\$|heisst|Helllger|Helzlichen|Hen\\'je|herabstofien|heransttlrmtet|heraush\\\xe9ngendem|herhfiren|herh\\\xe9ren|heriiber|HerrSchmidt|herumf\\\xe9hrt|herumkehren|herumlluft|herumzuwijhlen|Herzrhythmusst\\\xe9rungen|Herzschlielierei|Herzstlllck|Heuta|Hexenhtltte|HeY\\\xb7|Hfibscheste|hfiherer|hfihsch|Hfilfte|Hfille|hfilt|hfiltst|Hfin|hfipft|Hfir|hfiren|hfirst|hfirt|hfitte|hfitten|hie\\/3|hieB|hiefL|hiel3|hiells|hierhergereist|hierherzuriick|hierijber|hierjede|hierjeder|hierl|hierL|hierwar|hierzum|hie\\\ufb02|Hiibsch|Hiibsche|Hiibscher|hiibschl|hiichst|hiichstens|hiichster|hiichstpersiinlich|Hiifen|hiifischen|Hiifling|Hiigel|Hiihe|Hiihepunkt|hiiher|hiihere|Hiihlen|Hiihnchen|Hiihner|Hiihnerkl\\\xe9fkchen|Hiilfte|Hiille|Hiillenstreitmacht|hiillischen|hiipfen|Hiir|hiire|Hiiren|Hiirer|Hiiret|Hiirjetzt|Hiirt|hiirte|hiirtest|Hiissliches|Hiite|Hiiten|hiitet|Hiitte|hiitten|Hiitten|hijbsch|hijbschen|hijbsches|Hijfte|Hijften|Hijgel|Hijgels|Hijpfburgl|hijpfe|hijpfen|hijre|Hijren|Hijrer|hilbsch|hilbsche|hilbschen|hilbscher|Hilfel|HILFSPERSONALI|Hilgel|hillig|Hilt|hil\\\ufb02|Him|Himmell|hineintr\\\xe9umen|hinfijhrt|hingefiihrt|hingehdren|hingehiiren|hinilber|hinreiliend|hinschmeifit|HintenN\\\xe4ldler|Hintergrundl\\\xe9rm|hinterhfiltig|hinterh\\\xe9iltiger|Hinterh\\\xe9iltigl|hinterh\\\xe9ltige|hinterh\\\xe9ltiger|Hinterk\\\xe9pfen|hinterlieBe|hinterl\\\xe9sst|Hintersttlbchen|Hintertur|hinwollen|hinzufuhren|hinzuf\\\ufb02gten|Hirnrnel|hirteste|hisslich|Hi\\\xe9tte|Hler|hler|hllf|hllibsch|Hllindinnen|Hlllpf|hln|Hlnbllck|hltte|Hltten|Hochfrequenzst\\\xe9rungenl|hochl|Hochsicherheitsgef\\\xe9ngnis|Hochstens|Hochzeitskostiime|Hohek|Hohepunkt|hohere|HoHo|Holle|Holzsttlck|hor|Horen|Hosenscheifker|Hosenscheiiker|Hosenschei\\\ufb02er|Hotelg\\\xe9ste|HQHE|htibscher|Htihnchen|Htipfen|Htipfenl|htiren|hubsch|hubsche|hubschen|Hubscher|hubscheres|Hubsches|Huhner|humon\\/oll|Hundchen|Hundebullel|Hunden\\\xe9pfe|Hundescheilie|Hundl|HUNG|hunte|Hurensiihne|Hurensohnl|Huterin|HUtte|Hypoglyk\\\xe9mie|h\\\xe9|H\\\xe9chste|h\\\xe9chsten|H\\\xe9chstens|H\\\xe9chstpers\\\xe9nlich|H\\\xe9fen|h\\\xe9flich|H\\\xe9ftling|H\\\xe9ftlinge|H\\\xe9ftlingsr\\\xe9te|H\\\xe9hef|H\\\xe9hepunkt|h\\\xe9her|h\\\xe9heren|H\\\xe9i|H\\\xe9ifen|H\\\xe9ilften|h\\\xe9iltst|H\\\xe9inde|h\\\xe9ing|h\\\xe9ingen|h\\\xe9ingt|h\\\xe9ir|h\\\xe9irter|h\\\xe9itt|H\\\xe9itte|h\\\xe9itten|h\\\xe9ittest|h\\\xe9iufig|H\\\xe9lfte|H\\\xe9lle|H\\\xe9llen|H\\\xe9llenloch|h\\\xe9llisch|h\\\xe9llische|h\\\xe9lt|H\\\xe9ltst|h\\\xe9lzernes|h\\\xe9misch|H\\\xe9mmer|h\\\xe9mmernde|H\\\xe9moglobin|H\\\xe9morrhoiden|H\\\xe9ndchen|H\\\xe9nde|H\\\xe9ndedruck|H\\\xe9nden|H\\\xe9ndlerin|h\\\xe9ng|h\\\xe9ngen|h\\\xe9ngend|h\\\xe9ngst|h\\\xe9ngt|H\\\xe9r|h\\\xe9re|h\\\xe9ren|H\\\xe9rgesch\\\xe9idigte|h\\\xe9rst|h\\\xe9rt|h\\\xe9rte|h\\\xe9rten|h\\\xe9rter|H\\\xe9rzu|H\\\xe9schen|h\\\xe9sslich|h\\\xe9sslicher|h\\\xe9sslichl|h\\\xe9sslichste|h\\\xe9tt|H\\\xe9tte|h\\\xe9tten|h\\\xe9tten\\'s|h\\\xe9ttest|H\\\xe9ttet|H\\\xe9ufi|h\\\xe9ufig|h\\\xe9ufiger|H\\\xe9ufigkeit|h\\\xe9ufigsten|H\\\xe9user|H\\\xe9usern|h\\\xe9ute|H\\\u20acY|H\\\ufb02geln|i\\'\\\xa7ffne|I\\/egen|I5sst|I5stern|I6sen|Ia\\\xdf|Ia\\\xdft|Icll|identifizieet|IDENTITAT|IE|Iebendigl|Iebenslinglich|Iebtjetzt|Ieck|Iehn|Ieid\\\u201a|Ieinenlose|Ienistische|Ietztendlich|Ifigt|Ihrdllirft|ihrja|ihrjemals|ihrjetzt|ihrjeweiliges|ihrVater|ihrvorstrafenregister|ihrwahres|Ihrwerdet|ihrzwei|iibel|iibemehmen|iiber|iiberall|iiberallhin|iiberdauern|iiberdauerte|iibereinstimmte|iiberfallen|iiberfiel|iibergeben|iiberhaupt|iiberhiirt|iiberholt|iiberholter|iiberkam|iiberlassen|iiberleben|iiberlebt|iiberlegen|iiberlegten|iibernahmen|iibernehme|iibernehmen|iibernimmt|iibernommen|iiberpriife|iiberpriifen|iiberpriift|iiberpriiften|iiberqueren|iiberragen|iiberrascht|iiberraschte|iiberreden|iiberschritten|iibersetzen|iibersetzt|iibersteigt|iibertragen|iibertreffen|iibertreib|iibertreiben|iibertrieben|iiberzeugen|iiberzeugt|iiblich|iibliche|iibrig|IieB|Iiebte|Iief\\'s|Iiehe|Iie\\\ufb02est|iiffentlichen|iiffentliches|iiffnest|iifter|iihnllchkelt|Iisst|ijbel|ijben|ijberall|ijberhaupt|ijberlegene|ijbernehme|ijbernimmst|ijberprijfen|ijberreden|ijbertrage|ijberwunden|ijberzeugen|ijberzogen|Il6her|IleiB|Ill|Illfie|Ilrger|Ilufierste|immerja|immerjung|immerweinen|immerw\\\xe4hrende|immerw\\\xe9hrende|Improvisiation|Impulswellengeschutz|INBRUNSTIGE|instfindig|intramuskul\\\xe9r|INVASIONSFLOTFE|Iosgeliist|Iosgel\\\xe9st|Ioszuliisen|ip|irn|irrefuhren|irrefuhrende|istja|istjedoch|istjemand|istjetzt|istJohnny|istjung|istweg|ITIUSSEFI|ITIUSSGI7|ITTITTRZ|Ivl\\\xe9gliche|I\\\xe9cheln|I\\\xe9cherlich|I\\\xe9cherlichen|I\\\xe9hmt|I\\\xe9iuft|I\\\xe9nger|I\\\xe9sst|I\\\xe9sste|I\\\xe9uft|J0Shua|Jackettkaufen|jahr|jahre|jahren|JAHRIGE|jal|jemandenl|jetztl|jiidisch|Jiingem|jiingerwar|Jiingste|jilnger|Jlllngling|job|Jogglng|john|johnny|journalisten|Jullo|JUNGFRAULICHE|jungfr\\\xe9uliche|jungfr\\\xe9ulichen|jungfr\\\xe9ulicher|Jungfr\\\xe9ulichkeit|Jungsl|Jungste|Jurlgs|Justitzministeriums|J\\\xe9ger|J\\\xe9hrige|j\\\xe9hrigen|j\\\xe9hriger|j\\\xe9hrlich|J\\\xe9iger|j\\\xe9ihrigen|j\\\xe9mmerlich|k\\'a\\'mpfen|K\\/no|K\\/Varte|K\\/Velle|K5NIGIN|K6der|K6ln|K6nig|K6nige|K6nigin|k6nnen|k6nnen\\'s|k6nnest|k6nnt|K6nnte|k6nnte\\'s|k6nnten|k6nntest|K6pfe|K6rper|K6rpers|K6stlich|Kabelm\\\xe9nner|kalf|kaltblijtig|kampfen|Kampfj\\\xe9ger|Kanarienviigeln|kann\\'sja|kannstja|Kan\\\xe9len|Kapitan|Kapitln|Kapitlnen|Kapitlns|Kapit\\\xe9in|Kapit\\\xe9inleutnant|Kapit\\\xe9ins|Kapit\\\xe9n|Kapit\\\xe9nleutnant|Kapit\\\xe9ns|Kapt\\'n|kaputthaust|Kartoffelsch\\\xe9len|Kassettenger\\\xe9it|kbnnen|kbnnten|kdnnen|kdnnfe|kdnnte|ke\\/ne|Kefn|Keh\\/1|Keithl|keln|kelne|Keri|kfime|Kfimmer|kfimmere|kfimmern|kfimmert|kfimpft|kfimpften|Kfinig|Kfinnen|kfinnte|Kfinnten|Kfinntest|Kfiss|Kfisschen|Kfissen|Kfjnnte|Khnlichkeit|KIar|Kifig|Kiiche|Kiichenhelfer|Kiichln|Kiihe|Kiihlbox|kiihler|Kiihlschrank|kiimmem|kiimmer|kiimmere|Kiimmern|kiindigen|Kiinig|Kiinige|Kiinigen|Kiinigin|Kiiniginnen|kiinigliche|kiiniglichen|kiiniglicher|Kiinigreichs|Kiinigs|Kiinigtum|kiinne|kiinnen|kiinnt|Kiinnte|kiinnten|kiinntest|kiinntet|Kiinstler|kiinstlerischen|kiipfen|Kiirper|Kiirperfunktionen|Kiirperhaltung|kiirperliche|Kiirperliches|Kiirpersprache|Kiirperverletzung|kiirzen|kiirzerzutreten|kiirzeste|Kiisschen|Kiissen|Kiisst|Kiiste|kiistlich|Kijche|Kijhlschrank|Kijmmere|kijmmern|kijmmernl|kijmmerst|kijmmerten|kijndigt|kijnnen|kijnnt|kijnnte|kijnnten|Kijnstler|Kijrbis|kijrzlich|kijrzliche|Kijrzungen|kijsst|Kijste|Kilche|Kilchlein|kilhlen|kilhler|Kilhlkreislauf|Kilhlschrank|Kilmmern|Kilmmert|kilndigen|kilnstliche|kilss|kilsse|kilssen|Kinderm\\\xe9dchen|Kinderspiell|Kindsk\\\xe9pfe|kiokflip|KIotz|KL\\'lr|KL\\'lste|Klapsmiihle|Klassem\\\xe9dchen|kle\\/ne|Kleidergr6Be|Kleidergrfilie|Kleinerl|kleinwiichsige|kleinwilchsiges|klijger|klijgsten|klilger|kLinft\\'gen|klirst|kljmmere|Kllirze|kllissen|Klliste|Klllche|klllhnsten|kllllger|Klobtlrsten|klop\\\ufb02l|Klpt\\'n|Klpt\\'nl|Klpt\\'ns|Klse|Klseschnuffelei|Kltigste|Klugschei\\\ufb02er|kl\\\xe9ffen|Kl\\\xe9iren|Kl\\\xe9ranlage|Kl\\\xe9re|kl\\\xe9ren|Kn6pf|Knallttite|Knastwill|Knderung|Knochengrfinde|Knofen|Knuller|Knupf|Knupfe|knupfen|knzjipfe|Kn\\\xe9dell|kn\\\xe9pf|Kn\\\xe9pfe|Kn\\\xe9sten|Kofferraumschliissel|Kohlens\\\xe9ure|Komaf\\\xe9lle|Komaf\\\xe9llen|Kombiise|Kombuse|Komiidie|kommerz\\/ellen|kommjetzt|Kompatibilitfits|Kompatibilit\\\xe9its|Kompatiblit5ts|Kom\\\xe9die|KONIGIN|konne|konnen|konnt|konsen\\/ativ|Kopfabreifimann|Kopfgeldj\\\xe9ger|Kopfgeldj\\\xe9gern|Kopfm\\\xe9fiig|Kopfnijsse|kostengtlnstige|Kostiim|Kostiimdesigner|Kostiimdesignerin|Kostiimdrama|Kostiime|Kostiims|Kostume|Kost\\\ufb02m|kr\\/egen|kr6ne|kr6nen|Kr6ten|Krafte|Kraftwfirfel|Kranf\\\ufb02hrer|Kreativit\\\xe9t|Kreuzverhor|krfiftiger|Krfiutertee|Kriegserkl\\\xe9rungen|Kriegsfuhrung|Kriegsschauplatze|Kriifte|Kriinung|Kriinungsfeier|Krijppel|Krijte|Kronjuwell|KROTE|Krsche|Kr\\\xe9fte|Kr\\\xe9ften|Kr\\\xe9ftigsten|Kr\\\xe9he|kr\\\xe9ht|kr\\\xe9ichzt|Kr\\\xe9ifte|Kr\\\xe9iutertee|Kr\\\xe9mpfe|kr\\\xe9nte|Kr\\\xe9te|Kr\\\xe9tes|Kr\\\xe9utern|Kr\\\xe9utersenf|Ktiche|Ktinige|ktinntest|Ktisschen|ktlmmere|ktznnen|Kuche|KUCHE|Kuckucksger\\\xe9usch|KUl\\'ZSCl\\'1lUSS9|kulz|kummer|Kummere|kummern|kummert|Kumpell|Kunststficke|Kunststticke|Kuriosit\\\xe9ten|kurzeste|kurzte|Kurzwellenfunkger\\\xe9te|Kurzzeitgediichtnis|Kurzzeitged\\\xe9chtnis|KUS1I\\\u20ac|Kuschelhengstl|KUSSE|KUSSGH|kusste|KUSTE|Kuste|K\\\xe9fer|K\\\xe9fig|k\\\xe9ime|k\\\xe9impfen|k\\\xe9impfend|k\\\xe9impft|k\\\xe9impfte|k\\\xe9impften|k\\\xe9impftest|k\\\xe9impfwie|K\\\xe9inguru|k\\\xe9innen|k\\\xe9innte|K\\\xe9irper|K\\\xe9ise|K\\\xe9isebrunnen|K\\\xe9lte|k\\\xe9lter|k\\\xe9lteste|k\\\xe9me|k\\\xe9men|k\\\xe9mpfe|K\\\xe9mpfen|K\\\xe9mpfer|k\\\xe9mpferische|k\\\xe9mpfst|k\\\xe9mpft|k\\\xe9mpfte|k\\\xe9mpften|k\\\xe9mt|K\\\xe9nig|K\\\xe9nige|K\\\xe9nigin|K\\\xe9niginl|K\\\xe9niginnen|k\\\xe9niglich|k\\\xe9nigliche|k\\\xe9niglichen|k\\\xe9nigliches|K\\\xe9nigreich|K\\\xe9nigreichs|K\\\xe9nigs|K\\\xe9nigsfamilie|k\\\xe9nne|k\\\xe9nnen|k\\\xe9nnt|k\\\xe9nnte|K\\\xe9nnten|K\\\xe9nntest|K\\\xe9nntet|K\\\xe9pfchen|K\\\xe9pfe|K\\\xe9pfen|k\\\xe9pft|K\\\xe9pt\\'n|K\\\xe9rbchen|K\\\xe9rbchengr\\\xe9fie|K\\\xe9rben|K\\\xe9rper|K\\\xe9rperfunktionen|k\\\xe9rperlich|k\\\xe9rperliche|K\\\xe9rperproportionen|K\\\xe9rpersprache|K\\\xe9rpertyp|K\\\xe9rperverletzung|K\\\xe9rper\\\xe9ffnungen|K\\\xe9se|K\\\xe9sebrett|K\\\xe9secracker|k\\\xe9stlich|K\\\xe9ter|K\\\xe9tern|K\\\ufb02mmere|k\\\ufb02mmern|L\\'a\\'cherlich|L\\'a\\'ndern|l\\'a\\'sst|l\\'a\\'uft|l\\/chtes|l\\/Vings|L5cheln|L6ffel|L6schen|L6se|l6sen|L6wen|L6win|LADIESMANZ17|Landh\\\xe9user|Landstra\\\ufb02e|Lands\\\xe9iugetier|langl|langweiligl|Lasergestutzte|Laserzielger\\\xe9t|Lattenzaunwei\\\ufb02|Laudal|laufl|Lau\\\ufb02|La\\\xdf|lch|ldee|ldeen|ldelia|ldentifikation|ldentifikationsnummer|ldentifikationssignal|ldentifizierung|ldentit\\'a\\'tsscheibe|ldioten|ldloten|Le\\/d|Lebenl|lebensf\\\xe9hig|lebensl\\\xe9nglich|lebensmijlde|Lebersch\\\xe9den|leergegessen|legend\\\xe9re|legend\\\xe9ren|Legion\\\xe9r|Legion\\\xe9re|Lehe|Leichensch\\\xe9ndung|leichtjemanden|leidl|Leistuljg|Lelbwfichter|Leld|lemen|Lenks\\\xe9ule|lfidt|lfigt|lfinger|lfiuft|Lfiuterung|lgitt|lgnorier|lhm|lhn|lhnen|lhnenl|lhr|lhre|lhrem|lhren|lhrer|lhrerverffigung|lhres|lhrfehlt|lhrjemalsjemanden|lhrVerteidiger|Libel|Libelwollen|Liben|Liber|Liberall|Liberdenken|Liberdrllissig|Liberfallen|Libergebrannt|Liberhaupt|Liberlasst|Liberleben|Liberlegen|Liberlegt|Libernimmt|Liberpriift|Liberreden|Libersteht|Liberstllirzen|Liberwachen|Liberwacht|Liberwinden|Liberw\\\xe9ltigen|Liberw\\\xe9ltigt|Liberzeugt|Lible|Liblich|Libliche|Librig|lie\\/3|lie\\/Se|lieB|lieBe|liebenswilrdig|liebenswurdiger|Liebesgestiindnis|Lieblingsbesch\\\xe9ftigung|Lieblingsrockerl|Lieblingss\\\xe9tze|lief2\\>en|Liefergebiihren|lieflsen|liegenlassen|Liehe|lieli|lielien|Liellen|liells|lien|Liicher|Liige|Liigner|liinger|liischen|liischt|Liisst|liist|Liisung|Liisungen|Liiwen|Lii\\\ufb02ung|lijgen|Lijgner|Lilgner|lilgst|lilgt|Lilterer|LIMOUSINENSERVICE10I06|linger|lke\\'s|lkone|lL\\'lgt|Llberstehen|Llebe|llebt|lllfie|lllfillensstark|lllfillie\\'s|lllfir|Lllignerl|llligtl|lllusionen|llngst|llztlicher|lm|lmbiss|lmmer|lmmigranten|lmpuls|lmpulsantrieb|lndianer|lndianerin|lndianerm\\\xe9dchen|lndianertanz|lndikation|lndividualit\\\xe9t|lndividuen|lndividuum|lnduktion|lneffizienz|lnformationen|lnfos|lngenieur|lngenieure|lnhalt|lnhalte|lnnenraum|lnnenr\\\xe9ume|lnsekt|lnsekten|lnsel|lnserat|lnspektion|lnstinkt|lnstinkte|lnstitut|lnstrumente|lnstrumentenwagen|lnsubordination|lntellektuellste|lntelligenz|lntensivstation|lnteraktion|lnteresse|lnteressen|lnternat|lntrigantin|lntrigantl|lntrigen|lnverness|lnvestition|lnvestoren|lnzucht|lo|Lordk\\\xe9mmerer|losf|losl|losw\\\ufb02rde|Lou\\/e|Loyalit\\\xe9t|lrak|lraner|lren|Lrgendetvvas|lrland|lronhide|lronie|lrre|lrren|lrrenanstalt|lrrenhaus|lrrer|lrrgarten|lrrlicht|lrrlichter|lrrsinn|lrrsinns|lrrtum|lscandar|lscandars|lsolierband|lss|lstja|ltaker|ltakerflossen|ltalo|Ltiffel|ltlgen|Lufijagen|Luftballonsl|Luftjagen|Luftunterst\\\ufb02tzung|LUgen|lvl\\\xe9idchen|lwan|l\\\xa7uft\\'s|L\\\xe9chelmfinderl|l\\\xe9cheln|l\\\xe9chelt|L\\\xe9cher|L\\\xe9cherlich|l\\\xe9cherliches|L\\\xe9chle|l\\\xe9dt|L\\\xe9ffel|l\\\xe9ge|L\\\xe9icheln|L\\\xe9icherlich|l\\\xe9ichle|L\\\xe9indchen|l\\\xe9ingst|l\\\xe9isen|l\\\xe9issig|l\\\xe9isst|L\\\xe9iuft|L\\\xe9jsung|L\\\xe9mmchen|L\\\xe9mmer|L\\\xe9nder|L\\\xe9ndern|L\\\xe9nge|L\\\xe9ngen|l\\\xe9nger|l\\\xe9ngst|l\\\xe9ngste|L\\\xe9rm|L\\\xe9rmbeschwerden|l\\\xe9schen|L\\\xe9se|L\\\xe9segeld|l\\\xe9sst|l\\\xe9st|l\\\xe9ste|l\\\xe9sten|l\\\xe9stig|L\\\xe9sung|l\\\xe9ufig|l\\\xe9ufst|L\\\xe9uft|l\\\xe9uten|l\\\xe9utet|L\\\xe9we|L\\\ufb02gner|M\\'a\\'dchen|m\\/ese|M\\/ffsommernachfsfraum|M\\/r|M0I8KUI|m6belt|m6chte|m6chtest|m6gen|m6glich|m6glichen|m6glicher|m6gt|M6rder|MaB|MaBgabe|mac\\/1e|mac\\/7|machs|Machtiibernahme|madenschw\\\xe9inziger|Mafinahme|Magengeschwiire|Magengeschwilr|Magengeschwtir|Magnolienbliiten|Majesfait|Majest\\\xe9it|Majest\\\xe9t|Majest\\\xe9ten|Mal2\\>en|Mal3en|malf|Malinahme|mall|Mallregelten|Mandverstation|Manfiver|Maniiver|Manikfire|Mannscha\\\ufb02|Mansclle\\\ufb02\\'enkm\\'5pfe|Man\\\xe9iver|Man\\\xe9ver|man\\\xe9vrieren|man\\\xe9vrierf\\\xe9hig|Man\\\xe9vriermodus|Margoliserklfirung|Margoliserkl\\\xe9rung|marsch\\\xe9hnliche|Massagestllihlen|Massenzerst\\\xe9rung|Massenzerst\\\xe9rungswaffen|Mater\\/al|Maxiriicke|Mayonaise|mbglichst|Mdge|mdglichen\\/veise|mdglicherweise|Mdglichkeit|me\\/n|mehrZeit|mein\\'ja|meinerjetzigen|Meinungs\\\xe9ufierung|Meisterbr\\\xe9u|Meisterstijck|meistgehasste|meln|melne|Mend|Menschenh\\\xe9indler|Menstruationsst\\\xe9rungen|Merkwiirdig|Merkwiirdige|merkwiirdiger|merkwilrdig|merkwlllrdige|merkwurdig|merkwurolig|merkw\\\ufb02rdig|Messger\\\xe9t|mfichte|Mfichten|Mfidchen|Mfidchenl|Mfidels|mfigen|Mfigliche|mfiglichen|mfiglicherweise|Mfill|Mfillhalde|Mfinchen|Mfinder|Mfinnern|Mfissen|mfisst|mfisste|Mfjrder|Midchen|Migrane|Migr\\\xe9ne|Migr\\\ufb02ne|miichte|Miichtegern|Miichten|miichtest|miide|Miidels|miides|miige|miigen|miiglich|miigliche|miiglichen|miigliches|Miiglichkeit|Miiglichkeiten|miigt|Miill|Miillhalde|Miilltonnen|miilssen|miirderisch|miisse|Miissen|miisst|miisste|Miiuse|mijchte|Mijcken|Mijhe|Mijnzen|mijssen|mijsst|mijsste|mijsstest|Milchstrafie|Milhe|Milhle|MILITAR|Militiirprogramme|Militir|militlrische|Milit\\\xe9irkodex|Milit\\\xe9r|Milit\\\xe9rakademie|Milit\\\xe9rdienst|milit\\\xe9rischen|Milit\\\xe9rkodex|Milit\\\xe9rluftraum|Milit\\\xe9rnetzwerk|Milit\\\xe9rs|Milit\\\xe9rsystem|Millbilligung|Millefs|Millgeburt|Milliard\\\xe9iren|Million\\\xe9rssohn|Milli\\\xe9quivalent|Millltonne|millverstanden|milssen|milsst|milsste|milssten|Miltter|Minenraumen|Miniriicke|mirglauben|mirja|mirje|mirjeglichen|mirjemals|mirjemand|mirjetzt|mirso|mirvon|mirzu|Miserabell|missf\\\xe9llt|Missverstfindnisl|Missverstiindnis|Missverst\\\xe9ndnis|Missverst\\\xe9ndnissen|Mistkerlel|Mistkiiter|Miststiick|Mistst\\\ufb02cke|Mitbijrger|Mitbilrger|mitfiihlend|mitfiihlender|mitfuhlend|Mitgefiihl|Mitgefuhl|mitgehiirt|mitgez\\\xe9hlt|mitjedem|mitjemandem|mittlen\\/veile|ML\\'1nze|mlch|Mldchen|mLissen|Mljnder|Mllillschlucker|Mllindel|Mllindung|mllissen|mllisst|Mlllhe|Mllllon|Mllllonen|mlllsst|Mllltterjedoch|Mlnnern|mlr|mlrl|mlt|moglich|Moglichkeit|Moglichkeiten|Molekijle|MolekL\\'lle|Mondeinhiirner|Mondeinhiirnerl|Mondeinh\\\xe9irner|Mondk\\\xe9ilber|Monl|MONTONEI|Mordsiiberraschung|Mordverd\\\xe9chtiger|Morsealphabetl|Motorger\\\xe9usch|Motorger\\\xe9usche|Mousset\\\ufb02e\\'s|Mowen|Mtihe|Mtillschlucker|mtissen|mtissenl|Mtitzel|mtlde|mtlsste|muBt|Mucken|mucksm\\\xe9uschenstill|mude|Muhe|MUII|mull|MULL|mullte|Mundl|Mundung|Munzfernsprecher|Muskatnijsse|Muskelkumpelsl|muskul\\\xe9ren|mussen|MUSSEN|mUssen\\'s|muss\\_\\'\\\xa7e|Musterschuler|Mutterja|mutterlich|Mutze|mu\\\xdf|mu\\\xdft|mu\\\xdfte|mx\\'t|Mzlinnern|M\\\xe9bel|m\\\xe9cht|M\\\xe9chte|m\\\xe9chte|M\\\xe9chtegern|m\\\xe9chten|m\\\xe9chtest|m\\\xe9chtet|m\\\xe9chtig|m\\\xe9chtige|m\\\xe9chtigen|m\\\xe9chtiger|m\\\xe9chtiges|m\\\xe9chtigste|m\\\xe9chtigsten|M\\\xe9dchen|M\\\xe9dchenh\\\xe9nden|M\\\xe9dchens|M\\\xe9del|M\\\xe9dels|M\\\xe9delsl|M\\\xe9fiigung|m\\\xe9ge|M\\\xe9gen|M\\\xe9glich|m\\\xe9gliche|M\\\xe9glichen|M\\\xe9gliches|M\\\xe9glichkeit|M\\\xe9glichkeiten|m\\\xe9glichst|m\\\xe9gt|m\\\xe9ichtig|m\\\xe9ichtige|m\\\xe9ichtigen|m\\\xe9ichtiger|M\\\xe9idchen|M\\\xe9idel|M\\\xe9inner|M\\\xe9innl|m\\\xe9innlicher|M\\\xe9irder|M\\\xe9irz|M\\\xe9nnchen|M\\\xe9nnchens|M\\\xe9nner|M\\\xe9nnerfreundschaft|M\\\xe9nnern|M\\\xe9nnersache|m\\\xe9nnlich|m\\\xe9nnliche|M\\\xe9ntel|M\\\xe9olel|M\\\xe9olels|M\\\xe9rchen|M\\\xe9rchenl|M\\\xe9rchenprinzen|M\\\xe9rder|M\\\xe9rtyrer|M\\\xe9rz|M\\\xe9tresse|M\\\xe9uschen|M\\\xe9use|M\\\xe9usehtipfer|M\\\xe9usen|M\\\xe9userennen|m\\\xfc\\\xdft|m\\\ufb02de|m\\\ufb02ssen|n\\'a\\'chste|n\\'a\\'hert|n\\/chfs|n\\/chi|N\\/ck|n\\/e|N6|n6tig|nac\\/1|Nachf|nachllssig|nachl\\\xe9ssig|nachl\\\xe9sst|nachprufen|Nachschlussel|Nachste|NAHERT|NAHERTE|Nat\\/on|natfirlich|Natiilrlich|Natiirlich|Natiirllch|natijrlich|natijrlichen|natilrlich|natilrliche|natL\\'lrlich|Natllirlich|Nattirlich|Nattlrlich|Nattlrliohl|Naturlich|naturlich|naturlichen|naturlichsten|Navajoweifi|ndtige|ne\\/n|Nebengeb\\\xe9ude|Nebengesch\\\xe9ift|neffes|Nehmf|neinl|Neln|nerv6s|Nervens\\\xe9ge|Nervens\\\xe9ige|nerviis|Nerv\\\xe9s|ner\\\\\\/t|Neuankiimmlinge|neuromuskul\\\xe9ren|Neuzug\\\xe9inge|Nfichster|NIANN|nichsten|nichtim|nichtjemand|Nichtjetzt|Nichtsl|nichtzurilckgelassen|nic\\_l\\_1t|niederk\\\xe9mpfen|niederliells|niedlichl|niher|niichsten|niichstes|niirgeln|niitig|niitige|Nijssen|Nijsternl|nijtzlich|nilchtern|niltzen|Nlagnaten|Nlannern|nlchste|nlchsthoheren|nlcht|nle|Nlemalsl|Nlhe|nlir|nllitzen|Nl\\\xe9inner|noc\\/1|Not\\/\\'all|Notfalll|notig|notigen|Notliige|Notziindung|NUFI|Nunja|Nurdich|nureins|nurflustern|Nurjetzt|nurl|nurwunscht|Nurzu|nus|NUSSS|nutzlich|Nx\\'emand|N\\\xe9chste|n\\\xe9chsten|N\\\xe9chster|n\\\xe9chstes|N\\\xe9chte|N\\\xe9chten|n\\\xe9chtlichen|N\\\xe9gel|N\\\xe9h|N\\\xe9he|n\\\xe9henf|n\\\xe9her|n\\\xe9here|N\\\xe9hern|n\\\xe9hernde|n\\\xe9hert|n\\\xe9herte|n\\\xe9hren|n\\\xe9ht|N\\\xe9hten|N\\\xe9ichste|n\\\xe9ichsten|N\\\xe9ichstes|N\\\xe9ihe|n\\\xe9iher|n\\\xe9ihern|n\\\xe9ihert|N\\\xe9ihten|n\\\xe9imlich|n\\\xe9mlich|N\\\xe9pfe|n\\\xe9rdlich|n\\\xe9rgelnde|N\\\xe9rrin|N\\\xe9schen|n\\\xe9tig|n\\\xe9tige|n\\\xe9tiges|O8|obdachlosl|Obefil\\\xe9iche|OBERFLACHENSCHWERKRAFT|Oberfl\\\xe9che|Oberfl\\\xe9chen|oberfl\\\xe9chlich|oberfl\\\xe9chliche|Oberm\\\xe9inner|Ober\\\ufb02fiche|of\\/\\'en|Offenslchtllch|Offentliches|Offentlichkeit|Offne|Offnen|Offnet|ofi|Ofiiziere|Ofiiziers|Oftweg|Of\\\ufb02cer|Ohnejede|ohnm\\\xe9chtig|ohnm\\\xe9ichtig|OI|olas|oles|Oltanks|OO|Orgelt\\\xe9ne|ORTI|Ortl|Ostfltlgel|Paliontologie|pallt|Pal\\\xe9sten|Panfike\\/chen|Papierbl\\\xe9tter|Papiertiite|Papiertilcher|Parfyknaller|Partyhiite|Partyhijte|Passendervveise|Paulgenauso|pa\\\xdf|pa\\\xdft|peinliohl|persdnlich|persfinlich|persiinlich|persiinliche|persiinlicher|Persiinllchkeltsspaltun|persijnliche|personlich|Personlichkeit|pers\\\xe9nlich|pers\\\xe9nliche|pers\\\xe9nlicher|Pers\\\xe9nliches|Pers\\\xe9nlichkeit|pe\\\ufb02g|Pfadfindervvappen|Pfad\\\ufb02ndeml|Pffitzen|Pfiitchen|Pfippchen|pflL\\'lgen|Pfllitze|pflugte|Pfundbijro|ph\\\xe9nomenal|PIatz|Piimpel|Piinlttchenltrawatte|Pijppchen|Pijppchenl|Planetenf|planm\\\xe9fiigen|Plastikfr\\\xe9iuleinl|plattmachen|Plfitzchen|plfitzlich|pliitzlich|pliitzllch|Pllllnderer|plotzlich|pl\\\xe9dieren|Pl\\\xe9ine|Pl\\\xe9inen|Pl\\\xe9itzchen|Pl\\\xe9itze|Pl\\\xe9ne|Pl\\\xe9tzchen|Pl\\\xe9tze|Pl\\\xe9tzel|pl\\\xe9tzlich|pl\\\xe9tzliche|Pofkawoche|Polizistl|pompiise|popul\\\xe9r|potth\\\xe9sslich|prasentleren|prfignant|Prfisentation|Prfisi|priide|Priife|priifen|prijfen|Priorit2a\\'t|PRIORITKT|PRIORITKTSZUGANG|Priorit\\\xe9itszugang|Priorit\\\xe9t|Prisident|Privatgem\\\xe9chern|Privatsph\\\xe9re|Probfeme|Profitinzerinnen|Protege|prude|Pruf|prufen|Prugelei|prugeln|pr\\\xe9chtig|Pr\\\xe9fekt|pr\\\xe9historischer|pr\\\xe9ichtiger|pr\\\xe9ichtiges|Pr\\\xe9imie|pr\\\xe9ipotente|pr\\\xe9isentiert|Pr\\\xe9isidenten|Pr\\\xe9itorianer|Pr\\\xe9mie|Pr\\\xe9operative|pr\\\xe9sentiere|pr\\\xe9sentieren|Pr\\\xe9sentiert|Pr\\\xe9senz|Pr\\\xe9sident|Pr\\\xe9sidenten|Pr\\\xe9sidentin|Pr\\\xe9sidentschaft|Pr\\\xe9torianer|pr\\\xe9zise|pr\\\xe9ziser|Pr\\\ufb02fungen|Pubert\\\xe9it|Publlkuml|PUPPCHEN|PUpst|Purzelb\\\xe9ume|P\\\xe9ckchen|p\\\xe9idagogisch|P\\\xe9irchen|P\\\xe9rchen|p\\\ufb02egen|P\\\ufb02icht|p\\\ufb02ichtbewullt|Qas|Qualit\\\xe9tskontrolle|Quten|qu\\\xe9ilen|qu\\\xe9ilt|Qu\\\xe9l|Qu\\\xe9lt|R\\'a\\'che|R\\/ck|R\\/nge|R6mer|rachsiichtiger|ranghfiheren|rangh\\\xe9heren|ranzukommen|Rasenm\\\xe9herunfall|Rasterllibertragung|Rasterubertragung|Ratschl\\\xe9ige|Rattenf\\\xe9nger|Rauc\\/7|Rauc\\/vender|rauhen|RAUMFAHRE|Raumf\\\xe9hre|Raumsschiff|rausf\\\xe9hrt|rausgeprtigeltl|rausliefien|rauszuschmeifien|rau\\\ufb02|Re\\/se|Realit\\\xe9it|Realit\\\xe9t|Rechtgl\\\xe9ubige|rechtm\\\xe9fkigen|RECHTSANWALTE|rechtsl|Reffer|regelm\\\xe9fiige|Regenh\\\xe9igen|Regenm\\\xe9ntel|Regierungsgehirnw\\\xe9ischesignal|regul\\\xe9re|reiB|reiBt|Reichtfimer|Reichtllimern|reif\\$|reif\\$en|Reifiverschluss|Reil3t|reil5|Reili|reilien|Reilin\\\xe9gel|Reillt|reilZ\\>|reingeh\\\xe9ngt|Reingelegtl|reinhupft|reinl|reinstilrmen|reiohen|REISSVERSCHLUSSGERAUSCH|rei\\\ufb02|rei\\\ufb02en|relch|religi6s|religiiiser|religi\\\xe9s|Rels|Rentenbezuge|Repr\\\xe9sentantin|Rettungsflofi|Rev\\/er|rfiber|rfiberwachsen|Rfickseite|rfihrselige|rfilpse|Rfissel|RGMISCHE|Richer|Riesenhfipfer|Riesenspafi|Riesentijr|riiber|Riicheln|riichelt|Riick|Riickblickend|Riicken|Riickenlage|Riickenwind|riicksichtslos|Riicksichtslosigkeit|Riicksitz|Riickw\\\xe9irts|Riickzug|Riick\\\ufb02ug|riihrt|Riilpsen|riilpst|Riimischen|Riistung|Riiumlichkeiten|Rijbe|rijber|rijckgfingig|rijckw\\\xe9irts|Rijsseltierl|Rilbe|rilber|rilberkommen|Rilckkehr|rilcksichtsloses|rilckw\\\xe9rts|Rillpsen|Riol|Rivalit\\\xe9t|rL\\'lber|RL\\'lhr|rllicken|rllickt|Rlllckgrat|Rlnge|Rlumgerate|ROMISCHE|ROMISCHEN|rosa\\\xe9ugiges|rotiugiger|Rotk\\\xe9ppchen|Rott\\\xe9nen|Routinetlberprijfung|Rticken|rticksichtslos|rtlber|Rtlckseite|ruber|Ruberrutschen|Ruckblende|Ruckblick|Rucken|Ruckenlage|Ruckenwind|Ruckfall|Ruckfrage|Ruckgriff|Ruckkehr|Rucksitz|Ruckzugl|ruhlg|ruhrenl|Ruhrt|Rul3|Rumgebrfillel|rumhingen|rumh\\\xe9ngen|rumh\\\xe9ngst|ruml\\\xe9uft|rumwuhlen|rumzuf\\\ufb02hren|rum\\\xe9rgern|runterffihrt|runtergespillt|runtergesp\\\ufb02lt|Runterl|runterspillen|runterspllllen|runtersp\\\xfclt|runtervverfen|Rupem|Rustung|r\\\xe9che|r\\\xe9chen|R\\\xe9cher|r\\\xe9cht|R\\\xe9der|R\\\xe9dern|R\\\xe9hre|R\\\xe9idern|R\\\xe9itsel|r\\\xe9itseln|r\\\xe9itst|R\\\xe9iume|R\\\xe9mern|r\\\xe9mische|r\\\xe9mischen|r\\\xe9mischer|R\\\xe9nder|R\\\xe9nke|R\\\xe9nken|R\\\xe9ntgenaufnahme|R\\\xe9ntgenbild|R\\\xe9son|r\\\xe9t|R\\\xe9tsel|r\\\xe9tselhaft|R\\\xe9tselhaftes|R\\\xe9ume|R\\\xe9umen|R\\\xe9umlichkeiten|R\\\xe9umt|r\\\xe9uspert|R\\\ufb02be|r\\\ufb02bergeguckt|R\\\ufb02ckkehr|S\\/e|s\\/nd|S5tze|S6hne|saB|Sachverstlndiger|sagf|sagfen|Sammlerstiicken|Sands\\\xe9cke|Sanftmiltigen|Sanierungsbeh\\\xe9rde|Sanit\\\xe9ter|Sargn\\\xe9gel|sari|Satellitenschijssel|Satellitenschusseln|Satellitenuberwachung|Saugf\\\ufb02flsen|sc\\/10\\/1|sc\\/16\\/1|sch\\/cken|Sch\\/ffe|sch6n|Schadeniiberpriifung|Schadenuberprtlfung|Scharfschijtze|schbn|schc\\'\\\xa7n|Schdn|schdnen|Schecksl|ScheiB|ScheiBe|scheiBegal|Scheif\\$e|scheiffsel|Scheifi|Scheifiding|scheifie|Scheifiel|Scheifier|Scheifihelm|Scheifiloch|Scheifipascha|Scheifisofa|Scheifiweiber|Scheifle|Scheiiislangweilig|Scheil\\'\\$e|Scheil3\\>er|Scheil3e|Scheili|Scheilie|scheilien|Scheille|Scheillel|ScheilSe|ScheilZ\\>|Scheir\\$oling|scheissegal|Scheisskarre|Schei\\\ufb02e|scheme|scheuf\\$lich|Scheulilich|schfichtern|schfimen|schfin|Schfine|schfinen|Schfines|schfirfer|Schfissel|Schfitzchen|schfjnes|Schideln|schief\\$en|Schief3\\>en|Schiefien|schiefit|schiefZ\\>t|schiel\\'5|Schiel3t|schiellen|Schielmbung|schie\\\ufb02en|schie\\\ufb02t|Schiffs\\\xe9rzte|Schiffzerstfiren|Schifies|Schiidel|schiilzen|schiin|schiine|Schiinen|Schiiner|schiines|Schiinheit|Schiipfer|Schiipfung|Schiisse|Schiitt|Schiittelfrost|schiitten|schiittet|schiitze|schiitzen|schiitzt|schijn|Schijnes|schijng|Schijssel|schijttelt|Schijtze|schijtzen|Schildkr\\\xe9te|Schilrze|Schilsse|schiltten|schiltzen|schimte|Schizophrenia|Schi\\\xe9tze|Schlachtgetllimmels|Schlachtschifl|schlafenl|Schlafk\\\xe9fern|Schlafmiitzenl|Schlafm\\\ufb02tzel|Schlangeng\\\xe9ttin|Schlappschw\\\xe9nze|Schlaumeierl|schlechf|Schlelistiinde|Schlellen|Schle\\\ufb02t|Schlfilsselparty|Schlfisse|SchlieBe|schlieBen|schlieBIich|schlieBlich|SchlieBt|schlief\\$en|Schlief\\$lich|schlief2\\>lich|schlief3t|Schliefie|schliefien|Schliefilich|schlieflslich|schliel3en|schliel3lich|Schliel5t|schlielie|schlielien|schlielilich|schliellsen|SchlielSt|Schliissel|Schliissell|Schliisselmoment|Schliisseln|Schlijsse|Schlijssel|Schlijsselloch|Schlilssel|Schlilssell|Schlilsselparty|schlimmsterAlbtraum|Schlle\\\ufb02en|Schllisse|schllitze|schllitzen|Schlllissell|Schlull|Schlupfern|Schlusselmoment|Schlusselszenen|Schlusselw\\\xe9rter|Schlussl|Schlu\\\xdf|Schl\\\xe9chter|schl\\\xe9fst|Schl\\\xe9ft|Schl\\\xe9ge|Schl\\\xe9ger|Schl\\\xe9gerei|schl\\\xe9gt|schl\\\xe9ift|schl\\\xe9igst|Schl\\\ufb02ssel|Schmatzger\\\xe9usche|SchmeiBt|Schmeif\\$|Schmeif\\$t|Schmeifien|schmeifit|Schmeilit|Schmei\\\ufb02|Schmier\\\xe9l|schmiicken|schmilztl|schmi\\\ufb02|Schmuckk\\\xe9stchen|Schmuckstiick|Schnappschijsse|Schnauzel|Schneegest\\\xe9ber|Schneidez\\\xe9hnen|Schneidez\\\xe9ihne|schnellf|Schnfiffeln|schnfiffelnl|schnfiffelst|Schnfirsenkel|schniiffele|schnijffelt|Schnilffeln|schnilrt|Schnitzereigesch\\\xe9ft|Schniuzer|Schnuoki|Schn\\\xe9ppchen|SchoB|Schofk|ScholShund|Schones|schonl|schopferische|scho\\\xdf|Schrankw\\\xe9nde|Schraubenschlijssel|schrecklichl|Schriftist|Schriftstijcks|schr\\\xe9ge|Schr\\\xe9ges|Schr\\\xe9nke|Schr\\\xe9nken|schtin|schtine|Schtisse|schuchtern|Schuchterne|Schuhl|Schuldgeftihlen|Schulterl|Schutzen|Schutzr\\\xe9ume|SCHUTZT|Schw6r\\'s|Schwachkop\\\ufb02|Schwanzlutscherl|Schwarzh\\\xe9ndler|Schwarzweills|schwei\\\ufb02durchnisst|schwerh\\\xe9rig|schwiicht|schwiire|schwiiren|Schwimmanziige|schwi\\\xe9rmten|schwnre|Schw\\\xe9che|Schw\\\xe9chen|schw\\\xe9cher|schw\\\xe9cheren|schw\\\xe9chsten|Schw\\\xe9icheanfall|Schw\\\xe9ichen|schw\\\xe9icher|Schw\\\xe9ichling|Schw\\\xe9irmerei|schw\\\xe9irzeste|Schw\\\xe9mme|schw\\\xe9re|schw\\\xe9ren|Schw\\\xe9rme|schw\\\xe9rmt|schw\\\xe9rmte|Schw\\\xe9tzer|sch\\\xe9biger|Sch\\\xe9del|Sch\\\xe9den|Sch\\\xe9inder|sch\\\xe9ine|sch\\\xe9inen|Sch\\\xe9iner|sch\\\xe9irfen|sch\\\xe9le|sch\\\xe9me|Sch\\\xe9n|sch\\\xe9ne|Sch\\\xe9nen|Sch\\\xe9ner|Sch\\\xe9nes|Sch\\\xe9nheit|sch\\\xe9nl|sch\\\xe9nste|sch\\\xe9nsten|sch\\\xe9nstes|Sch\\\xe9tzchen|Sch\\\xe9tze|sch\\\xe9tzen|sch\\\xe9tzt|Sch\\\xe9tzung|Sch\\\xe9umen|sch\\\ufb02chtern|SCl\\'1lUSS6l|Scllrift|scmoss|se\\/n|Se\\/wen|sehenl|Sehenswlllrdigkeiten|Sehnsilchte|sehrangespannt|sehrjung|Sehrwohl|sehrzufrieden|sehtjetzt|Seidenglattl|seidjetzt|Seitwann|SEKRETARIN|Sekretiir|Sekretir|Sekret\\\xe9irin|Sekret\\\xe9rin|sel\\/g|selbstl|selbststiindig|selbstsuchtige|selbstverstindlich|Selbstverstlndlich|Selbstverst\\\xe9indlich|Selbstverst\\\xe9ndlich|seld|selhst|SeligerVater|seln|Selt|sentimalen|seri\\\xe9ser|Sexualit\\\xe9t|Sfe|Sfidamerikas|Sfidwind|Sfifies|Sfihne|Sfildner|Sfilie|Sfilieste|Sfi\\\ufb02igkeiten|sfnd|SICHERHEITSBEHORDE|Sicherheitsgrijnden|Sichtubervvachung|Sichtunterstutzung|Sieja|Sifihnchen|Signalst\\\xe9rke|Siiden|Siidfrankreich|siidliche|siil\\$|siili|Siilie|siilier|SIim\\'s|Siinde|Siinden|Siinder|siindigen|sii\\\ufb02en|siJB|SiJBe|siJchtige|sijlien|sijliesten|Sijsser|Sildtunnel|Silfie|Silfier|Silfies|silfker|Silnden|Silndenbock|sindja|Sirl|Sj\\_r|Skilaufen|skrupelloserAnw\\\xe9lte|sL\\'lf\\$e|sL1B|slch|sle|slebe|sLif\\$|SLif\\$e|SLif\\$er|sLif\\$es|SLilSe|Slliden|Sllinde|sllindigen|Slnd|Slr|Slrs|SoBen|sofortl|soh\\\xe9nen|Solien|sollenl|SONDERMULL|sorgf\\\xe9iltig|sorgf\\\xe9ltig|souver\\\xe9ine|souver\\\xe9inen|souver\\\xe9ner|sp\\'a\\'ter|sp\\/elen|SpaB|Spaf\\$|Spaf2\\>|Spaffs|Spafi|Spafls|SpafS|Spal\\'5|Spal2\\>|Spal3|Spali|Spall|Spass|spat|spektakular|Spell|Spells|Spell\\\xbb|Spezialit\\\xe9t|spfit|SpieB|spief\\$ig|Spielzeuggeschfiftn|spiilte|spiiren|spiirt|spiit|spijre|spijren|spijrt|Spillmeier|spilre|spilren|spit|Spitzenfriihstiick|spLir\\'s|splliren|splter|Sportilbertragung|Sportsfraund|Sprachpijppchen|SPRACHPUPPCHEN|Spriichlein|Sprilht|spr\\\xe9che|spr\\\xe9chen|spr\\\xe9chet|Spr\\\ufb02che|spr\\\ufb02ht|spUl|spUr|spurbare|spUrt|sp\\\xa7ter|Sp\\\xe4\\\xdf|sp\\\xe9it|sp\\\xe9iter|sp\\\xe9t|Sp\\\xe9ter|Sp\\\xe9tzchen|Sp\\\xe9tzchenl|ssh|st6Bt|st6hnt|st6lSt|St6rt|ST\\@HNT|Staatsaff\\\xe9ren|staatsbllirgerliches|Staatsgesch\\\xe9fte|Standardan\\\xe9sthesie|standig|STARSCREAMI|station\\\xe9r|Statusmeldungl|stdrte|stecktjede|Stehenbleiben|Stehvermiigen|Steigbilgeldinger|Steinh\\\xe9user|Sternenkijsse|Steuererkl\\\xe9rung|Steuererkl\\\xe9rungen|Steuerprtifer|Steuerprtifung|Steuersiitzen|stfipseln|stfiren|stfirker|Stfirt|stfirzt|stieB|Stiefbriider|Stiicke|Stiihle|Stiihlen|stiihnt|Stiillen|Stiire|stiiren|Stiirme|stiirmischen|Stiirsignale|stiirt|Stiirung|stiirzen|Stiitzpunkt|Stijck|Stijckchen|Stijcke|stijhle|stijrme|stijrzen|Stilck|Stilcke|Stillckchen|Stillst\\\xe9nde|Stilvolll|stinden|Stldseite|stleg|Stllihle|Stllirmen|stllirzt|stlllrzen|Stl\\\ufb02|sto\\/3en|StoB|stoBe|stof\\$en|Stofi|STOHNT|Stol3zahn|Stol3zeit|stolie|Storung|Str6men|str6mt|StraBe|StraBen|StraBenk6tern|Straf\\$e|Strafiengang|Strafienratten|Strafienschlacht|Straflsenecke|Straflsenmaler|Straflsenschilder|Straft\\\xe9ter|Strahlenschutzger\\\xe9t|Strahlungsintensit\\\xe9t|Stral3en|Stral5e|Stralie|Straliengang|Stralienk\\\xe9ter|Straliensperre|Streitkr\\\xe9fte|Streitkr\\\xe9ften|Streit\\\xe9xte|strfimten|Striimen|Striimungen|Stromschliige|Stromschnellenl|Stromung|Strullerl|Str\\\xe9mung|Str\\\xe9mungen|sturzte|STUTZPUNKT|St\\\xe9be|st\\\xe9hnt|st\\\xe9hnte|St\\\xe9idtchen|St\\\xe9idte|st\\\xe9indig|St\\\xe9irke|st\\\xe9irker|St\\\xe9irkeres|st\\\xe9llst|St\\\xe9ndchen|St\\\xe9nder|St\\\xe9ndig|st\\\xe9pseln|st\\\xe9ren|St\\\xe9rke|St\\\xe9rken|st\\\xe9rker|St\\\xe9rkere|st\\\xe9rkeres|st\\\xe9rkste|st\\\xe9rst|st\\\xe9rt|St\\\xe9rung|St\\\xe9tten|St\\\ufb02ck|St\\\ufb02hlen|sUB|sUBe|Suchfeam|SUden|Sudseite|Sudwest|sUf\\$|SUf\\$e|suMM\\\u2020|Suohet|Superkr\\\xe9fte|superl\\\xe9cherlich|s\\\xa2\\'il3|S\\\xe9cke|S\\\xe9ge|s\\\xe9he|S\\\xe9hne|S\\\xe9hnen|S\\\xe9icke|S\\\xe9inger|S\\\xe9iulen|S\\\xe9ldner|s\\\xe9mfl\\/che|s\\\xe9mtliche|s\\\xe9mtlichen|S\\\xe9nger|S\\\xe9ngerin|s\\\xe9ubern|s\\\xe9uft|s\\\xe9ugen|S\\\xe9ulen|S\\\xe9urewannen|S\\\ufb02dh\\\xe9ingen|T6chter|T6pfchen|T6rn|T6rtchen|t6te|T6ten|t6tet|TANZERINNEN|Tater|tats\\\xe9chlich|tats\\\xe9chliche|tats\\\xe9ichlich|Tatverd\\\xe9ichtigen|Tauchg\\\xe9inge|Tauchg\\\xe9nge|Tauschgesch\\\xe9fte|Tauschgesch\\\xe9\\\ufb02e|Tbrn|tbten|tdten|tdtete|Telefongespr\\\xe9che|Tempelsch\\\xe9nderf|TemPO|TESTGELANDE|Testvorf\\\ufb02hrungen|tfidlich|tfiitet|Tfir|tfirkischen|Tfite|Theaterstfick|Therapiel|Thermalger\\\xe9t|Thronr\\\xe9uber|Thronr\\\xe9uberin|Tiefkilhlung|Tiefktih\\/system|Tiefktihleind\\\xe9mmung|TIEFKUHL|Tiefkuhlstasis|Tiefkuhlung|tiglich|tiichtige|tiint|Tiipfchen|Tiipfchennummer|Tiir|Tiiren|Tiirl|Tiirme|tiite|Tiite|tiiten|tiitet|tiitete|TiJr|Tijrme|Tilr|Tilrglocke|Tilrklingel|Tilr\\\xe9ffner|Tippger\\\xe9usch|Tischlenuerkstatt|TL\\'lr|tlglich|Tllir|Tllirkei|Tlllpfelchen|TOILETTENSPULUNG|Tonl|Toreroabs\\\xe9tze|Tortenb\\\xe9ickerin|Tragfidie|Tragiidie|Trag\\\xe9die|Trainingsijbung|TRAUMKCRPER|treffan|trfiumen|Tribiinen|trif\\'f\\'t|trigt|Triibsal|Triimmem|triistllch|Triistungen|Triiume|Trilmmer|triume|Trockenger\\\xe9ite|Trockenger\\\xe9te|Tropfsteinhiihle|Trottell|Trubsal|tr\\\xe9ge|Tr\\\xe9gerschiff|tr\\\xe9gt|Tr\\\xe9igerschiff|tr\\\xe9igt|tr\\\xe9ium|tr\\\xe9iume|tr\\\xe9iumen|tr\\\xe9iumt|tr\\\xe9llert|Tr\\\xe9ne|Tr\\\xe9nen|Tr\\\xe9um|tr\\\xe9ume|Tr\\\xe9umen|Tr\\\xe9umer|tr\\\xe9umst|Tr\\\xe9umt|Tschiiss|Tschiissl|tschijss|Tschtiss|tsch\\\xfc\\\xdf|Tsch\\\ufb02s|Ttir|ttlckisch|Ttlte|tubul\\\xe9re|Tupperschiissel|TUR|TUr|Turen|TURKEI|Turmwiichter|tutjetzt|typlschl|T\\\xe9chter|t\\\xe9d\\/ichen|t\\\xe9dlich|t\\\xe9dliche|t\\\xe9dlichen|t\\\xe9glich|t\\\xe9glichen|t\\\xe9iglich|t\\\xe9itowieren|t\\\xe9itowierte|T\\\xe9itowierung|t\\\xe9iuschen|T\\\xe9ler|T\\\xe9lpell|T\\\xe9nze|T\\\xe9nzerin|T\\\xe9pfchen|T\\\xe9pfchenquatsch|T\\\xe9pfchensache|t\\\xe9te|T\\\xe9ten|t\\\xe9test|t\\\xe9tet|t\\\xe9tete|t\\\xe9towieren|t\\\xe9towierte|T\\\xe9towierung|T\\\xe9towierungen|t\\\xe9uschen|t\\\xe9uscht|T\\\xe9uschung|T\\\xe9uschungsman\\\xe9ver|Ub6FpFUfl\\'T1al|Ub6l\\'pl\\'Uf\\\u20ac|Ube|Ubel|Ubelkeit|Ubelt\\\xe9ter|Uben|Uben\\/vachen|Uben\\/vacher|Uben\\/vacht|Uben\\/vachungen|Uben\\/vachungsgesetz|Uben\\/vinden|Uber|UBER|Uberall|Uberanstrenge|Uberanstrengung|Uberarbeiten|UberAuf\\$erirdische|Uberaus|Uberbleibsel|Uberblick|Uberbringe|Uberdauern|Uberdecken|Ubereinstimmung|Uberfahren|Uberfall|Uberflilssig|Ubergabe|Ubergaben|Ubergabepunkt|Ubergangen|Ubergangsweise|Ubergeben|Ubergehen|Uberhaupt|Uberholt|Uberholter|Uberh\\\xe9rt|Uberjemanden|Uberlagerungs|Uberlandleitungen|Uberlass|Uberlasse|Uberlassen|Uberlassenl|Uberlasteten|Uberleben|Uberlebende|Uberlebenden|Uberlebenschancen|Uberlebenswichtigen|Uberlebt|Uberleg|Uberlegen|Uberlegenheit|uberlegt|Uberlegten|Uberleiten|Uberleitung|Uberlieferungen|Uberl\\\xe9sst|Uberm|Ubermorgen|Ubernachtungsgast|Ubernahm|Ubernahme|Ubernahmen|Ubernehme|Ubernehmen|Ubernimmst|ubernimmt|Ubernommen|Uberpriifen|Uberprilfen|Uberprliifen|Uberprufe|Uberprufen|Uberpruft|Uberraschend|Uberrascht|Uberraschte|Uberraschter|Uberraschung|Uberraschungen|Uberraschungl|Uberreagiert|Uberreden|Uberredet|Uberreste|Uberrumpeln|Uberrumple|Ubers|Uberschl\\\xe9gt|Uberschreiten|Uberschritten|Uberschwemmung|Ubersehen|Ubersensibilit\\\xe9t|Ubersetzung|Uberspannte|Uberspielt|Uberstehen|Ubersteigerten|Ubersteigt|Uberstunden|Ubertraf|UBERTRAGEN|Ubertragen|UBERTRAGUNG|ubertreibe|Ubertreiben|Ubertrieben|Ubertriebene|ubertriebener|Ubertrifft|Ubervvachen|Ubervvacht|Ubervvachung|Ubervvachungs|Ubervvachungsstaat|Ubervvachungsstaats|Ubervvachungsvideos|Ubervv\\\xe9iltigend|Uberwachen|Uberwacher|Uberwachung|Uberzeuge|Uberzeugen|Uberzeugend|Uberzeugt|Uberzeugung|Uberzeugungen|Uberziehen|Uberzuleiten|ublem|Ubler|Ubles|Ublich|Ubliche|ublichen|Ubrig|Ubrige|Ubrigen|Ubrigens|Ubrlgens|Ubrllccol|Ubung|Ubungsbedingungen|Ubungsschiisse|Ubungsschusse|Ub\\\u20acf\\'pf\\'Uf\\\u20acl\\'1|Uher|ultrakiistlichl|umgeriistet|umg\\\xe9nglich|umhdren|umh\\\xe9ngt|Umschlfigen|umschlieBt|Umst\\\xe9inden|Umst\\\xe9nde|Umst\\\xe9nden|umst\\\xe9ndlich|umweltsch\\\xe9dlich|unabhiingiges|unabh\\\xe9ingig|unabh\\\xe9ngig|unabl\\\xe9ssig|Unauff\\\xe9lligeres|unaufhalfsam|unaufhiirlich|unaufh\\\xe9rlich|unaufi\\\xe9llig|unberijhrbar|unberllihrten|unbesch\\\xe9digt|Uncl|undja|undjeder|undjemand|undjetzt|undlassenihn|undlhnen|undurchfuhrbar|uneingeschr\\\xe9nkten|unergrilndliche|unerhort|unerhorte|unerkl\\\xe9rliche|unerkl\\\xe9rlichen|unertr\\\xe9glich|unf\\'a\\'hig|Unfahigkeit|unfersfellen|unfiirmigen|unf\\\xe9hig|unf\\\xe9higste|unf\\\xe9ihigste|Unf\\\xe9ille|Unf\\\xe9lle|ungef\\\xe9hr|ungef\\\xe9hre|Ungef\\\xe9ihr|ungef\\\xe9ihrlich|ungemutlich|ungenugend|ungestbrt|ungewfihnliche|Ungewfjhnliches|ungewiihnlich|Ungewijhnliches|ungew\\\xe9hnlich|ungew\\\xe9hnliche|ungew\\\xe9hnlichste|ungfinstigen|ungiiltig|ungilnstig|Unglaubliohl|unglaubwurdig|Unglfiubige|Ungliicklicherweise|Unglilck|Ungll\\'Jcklichervveise|Unglllick|unglllicklich|ungllllckliche|unglucklich|Ungl\\\xe9ubiger|ungultig|ungunstigen|unheimlichl|UNHORBARES|unh\\\xe9flich|Universitlt|Universit\\\xe9t|unlfisbare|unm6glich|unmfiglich|Unmiiglich|Unmiigliche|unmijglich|unmissverst\\\xe9ndlich|unmoglich|Unmtioglich|Unm\\\xe9glich|unm\\\xe9glioh|unnatiirliche|unnaturliche|unnfitigen|unniitig|unnllitz|unn\\\xe9tig|unn\\\xe9tigen|unol|unp\\\xe9sslich|UNREGELMASSIG|Unregelm\\\xe9fiigkeiten|unschliissig|unserejungen|unsererAnw\\\xe9lte|unsererjungfr\\\xe9ulichen|unsjede|uns\\\xe9glich|Untenuelt|unterdriickten|Unterdrilckung|unterdrtlckte|Unterdr\\\ufb02ckung|Unterhaltskostenl|Unterhaltungsm\\\xe9fiig|unterhfilt|unterh\\\xe9lt|unterschitzt|untersch\\\xe9tzte|unterstiitzt|Unterstiitzung|unterstijtzt|Unterstiltzung|Unterstllitzung|unterstutzen|unterstutzt|Unterstutzten|Unterstutzung|Untersuchungsausschijsse|Unterw\\\xe9sche|untr\\\xe9stlich|Unt\\\xe9tigkeit|unumg\\\xe9nglich|unverm\\\xe9hlt|Unverschfimtheitl|unversch\\\xe9mte|Unversch\\\xe9mtheitl|UNVERSTANDLICH|UNVERSTANDLICHE|UNVERSTANDLICHER|UNVERSTANDLICHES|Unverst\\\xe9ndliche|unverst\\\xe9ndlichen|unverst\\\xe9ndliches|unverzlliglich|unver\\\xe9ndert|Unzerbrechliohen|unzurechnungsfahig|unzuverlassiger|Unzuverl\\\xe9ssiger|unzuverl\\\xe9ssiges|unz\\\xe9hlige|unz\\\xe9hligen|unz\\\xe9ihlige|Urgrofivaters|Urlaubsuberschreitung|Ursprijnglich|ursprtmglich|Ursprunglich|Ururgrofivater|v\\/el|v\\/er|v\\/erfe|v\\/erfes|V6gel|v6IIig|V6lker|V6llig|v6lllg|vdllig|Ve\\/Teidigungskr\\\xe9fte|Velzeih|Velzeihung|velzichte|Ven\\/vandter|ven\\/v\\\xe9hntl|Ventilationsfiffnung|Ventilatorsch\\\xe9chte|VERACHTLICH|verandert|Verbiindeten|Verbilndeter|verbliidet|Verbliidung|verbllirgen|verbrachfe|Verbrec\\/ver|Verbtmdeter|Verbundeten|Verb\\\ufb02nolete|verdiichtigen|verdiinnt|verdllistern|verdr\\\ufb02ckt|verdunnt|verd\\\xe9chtig|Verd\\\xe9chtigen|verd\\\xe9chtiger|verffilgbares|Verfiigung|verfiihren|verfiihrt|verfiittem|Verfijgung|verfilgst|verfilgte|Verfilgung|Verfilhrungskilnste|verflligen|verfllihrt|Verflllgung|verfolgf|verfolgtl|VERFUGBAR|verfugt|vergafk|Vergniigen|Vergniigens|Vergniigungsausflug|Vergnijgen|Vergnilgen|Vergnlligen|Vergntigen|Vergnugen|vergnugt|vergnugte|Vergnugungsausflug|vergr6Bern|vergr\\\xe9fiern|Vergr\\\xe9fierung|verg\\\xe9nglich|verhiirt|Verhiitung|Verhor|verhort|verhorten|verh\\\xe9ilt|verh\\\xe9lt|Verh\\\xe9ltnis|Verh\\\xe9ltnisse|verh\\\xe9ltst|veriindert|Verinderungen|verkilnden|verkilndet|verkniipft|verknUpf\\'t|verkunde|verkunden|verkundet|VERKUNDIGUNG|Verk\\\xe9ufer|verletztl|verlieB|verlielien|verlorenl|verl\\\xe9ingert|Verl\\\xe9ingerungskabel|verl\\\xe9isst|verl\\\xe9sst|verl\\\xe9uft|verm\\'aihlen|verm\\/ssf|vermiibelt|Vermiigt|Verm\\\xe9gen|verm\\\xe9hle|verm\\\xe9hlen|verm\\\xe9hlt|Verm\\\xe9ihlung|vernachl\\\xe9ssigt|Vernachl\\\xe9ssigung|vernfinftig|vernfinftige|vernilnftig|vernllmftigsten|verntmftige|vernunftig|vernunftigsten|vern\\\ufb02nftig|verpa\\\xdft|verpesfefe|verprilgle|verprugeln|Verp\\\ufb02ichtungen|verrat|verrfickter|verriickt|Verriickte|Verriickten|Verriickter|verriicktes|verrijckt|verrijckte|verrilckt|Verrilckte|Verrilckter|Verrilcktes|verrL\\'lckt|verrljckt|verrllickt|Verrllickte|Verrllickter|verrlllckte|verrtickt|verrUckt|Verruckte|verruckten|Verruckter|Verr\\\xe9iter|verr\\\xe9itst|verr\\\xe9t|Verr\\\xe9ter|Verr\\\xe9terin|verr\\\xe9terisch|verr\\\xe9terischen|verr\\\ufb02ckt|versaumt|Verscheifier|verschiichtert|verschiitten|verschlucktl|VERSCHLUSSELN|VERSCHLUSSELT|Verschlusselung|Verschnauferst|Verschwdrung|verschweilit|Verschwiirer|verschwiirerisch|Verschwiirern|Verschwiirung|Verschwiirungen|Verschw\\\xe9rer|Verschw\\\xe9rung|Verschw\\\xe9rungstheoretiker|versch\\\xe9rft|versfanden|Versfehen|versiihnlich|Versiihnung|verslumte|Verspfitung|verspiire|verspilre|verspiten|versprijht|verst0I3en|verst6Bt|Verst6ISt|verst6l3t|verstehejetzt|Verstiindnis|verstiirkt|Verstiirkung|verstilmmelst|verstoBen|verstofken|verstolien|verstummelt|verstunde|verstundest|verst\\\xe9fkt|verst\\\xe9indlich|Verst\\\xe9irkung|Verst\\\xe9ndigen|Verst\\\xe9ndigt|verst\\\xe9ndlich|Verst\\\xe9ndnis|verst\\\xe9rken|verst\\\xe9rkt|verst\\\xe9rkte|verst\\\xe9rkter|Verst\\\xe9rkung|verst\\\xe9rt|vers\\\xe9hnen|vers\\\xe9hnt|vers\\\xe9umen|vers\\\xe9umt|VERTRAGSLANGE|vertrauenswiirdig|vertrauenswtlrdig|vertrauenswtlrdigen|vertr\\\xe9umte|vervvanzt|verwiistete|verwllisten|verwustet|verw\\\xe9hnten|verw\\\xe9ihnen|verw\\\xe9ssert|verz\\\xe9gere|Verz\\\xe9gerte|Verz\\\xe9gerung|ver\\\xe9ffentliche|ver\\\xe9ffentlichen|ver\\\xe9ffentlicht|ver\\\xe9indert|Ver\\\xe9inderung|ver\\\xe9ndern|ver\\\xe9ndert|ver\\\xe9nderte|ver\\\xe9nderten|Ver\\\xe9nderung|Ver\\\xe9nderungen|ver\\\xe9ngstigtes|ver\\\xe9ppelt|ver\\\xe9rgert|vewvendet|vfillig|VGFKUFZGH|VI\\/illkommen|VI\\/itwicky|vial|Videoiiben\\/vachung|Vie\\/e|Vielfrafi|vielf\\\xe9ltig|Vielleichtja|vielversprechend|Vieraugengespr\\\xe9ch|vieriunge|vierj\\\xe9hriges|vierk\\\xe9pfige|Viigel|viillig|viilliges|Viterchen|Vizepr\\\xe9isident|vlel|Vlellelcht|Vogelscheifke|Vogelscheilie|Volksm\\\xe9rchen|vollerjeder|vollmachen|vollst\\\xe9ndig|vollst\\\xe9ndige|Volltrefferl|vollz\\\xe9hlig|Volumenl|von\\/vagten|von\\/v\\\xe9irts|vonn6ten|Vonn\\\xe9irts|Vordertiir|Vorderturl|vordr\\\xe9ngelnl|vorfibergehend|Vorfuhrungen|vorgef\\\ufb02hrt|Vorgiinge|Vorg\\\xe9nger|Vorg\\\xe9ngern|Vorh\\\xe9nge|vorijbergehend|vorilber|vorilbergehende|vorkniipfen|Vorl\\\xe9ufer|Vorl\\\xe9ufig|Vorraus|Vorschl\\\xe9ge|vorschriftsm\\\xe9fiig|vorschriftsm\\\xe9iliig|Vorsichtsmaflnahme|Vorstellungsgespr\\\xe9ch|Vorstellungsgespr\\\xe9che|Vorstof\\$|Vortlbergehende|vort\\\xe9uschen|vorubergehend|vorvv\\\xe9rts|Vorwfirts|vorw\\\xe9rts|vorzfiglichl|vor\\\ufb02ber|Vor\\\ufb02bergehend|VVACHMANN|Vvaffen|Vvagen|VVarte|VVeif3\\>t|VVeil\\'2\\>t|VVir|VVM|v\\\\\\/as|V\\\\\\/e|V\\\xe9gel|v\\\xe9geln|v\\\xe9gelt|v\\\xe9llig|w\\/\\'r|W\\/e|w\\/eder|W\\/nkel|w\\/r|w\\/rd|w\\/rkl\\/ch|W0|w5r|w5r\\'s|W6lfe|W6lfen|W99|Waffenschr\\\xe9nke|wafs|wahrend|WAHRENDDESSEN|Wahrheitl|wail|Walbl|Walsinghaml|wankelmiltig|ware|WAREST|Warfe|warja|Waschbrettb\\\xe9uche|Waschb\\\xe9ir|Waschb\\\xe9iren|Wasseranschlljssen|Wattekn\\\xe9uel|Wattest\\\xe9bchen|we\\'re|We\\'ro|we\\/B|We\\/Bf|we\\/fere|Wechsell|weggebfirstet|weggespllllt|weggesplllltl|weggesp\\\ufb02lt|wegl|wegreiflsen|wegschieBen|Wegtratan|wegzuwefien|wei\\/3|WeiB|weiBe|weiBen|weiBer|weiBes|WeiBfresse|weiBt|Weif\\$|Weif\\$t|weif2\\>|weif3|weif3\\>|Weif3t|weif5|Weifbe|weifbt|Weifi|Weifie|weifies|Weifist|Weifit|weifk|weifken|Weifker|weifkes|weifkt|weifL|weifLt|weifl\\\xbb|weifS|WeifSt|weifZ\\>|WeifZ\\>t|weif\\\xe9t|Weihnachtseink\\\xe9ufe|Weihnachtsm\\\xe9nner|weil\\'5|weil\\'5t|weil3|Weil3t|weil5|Weil5t|weili|weilit|weilke|Weill|weills|weillst|weillt|weilS|weilSe|WeilSglut|weilZ\\>|weilZ\\~|weiss|weissen|weisst|weiterhiipfen|Weiterpessen|weitl\\\xe9ufige|weitweg|WelBt|well|Well|Wellit|welllt|welt|WELTBEVOLKERUNG|Wel\\\ufb02t|Werdja|Werkst\\\xe9tten|Werkzeugg\\\ufb02rtel|wertschfitzen|Westflilgel|Westkilste|Wettk\\\xe9mpfe|Wettk\\\xe9mpfen|Wettk\\\xe9mpfer|Wfinsche|wfinschen|Wfird|wfirde|Wfirden|wfirdest|wfire|Wfirme|Wfisste|wfitete|wfssen|Widen\\/v\\\xe9rtig|widerf\\'a\\'hrt|widerspriichliche|Widerw\\\xe9irtig|wiedergew\\\xe9ihltl|wiederhaben|Wiederh\\\xe9ren|Wieheifiternoch|Wieheiliternoch|wihlerisch|wihlerlsch|wiihlen|wiihlte|wiihrend|wiilrdest|Wiinde|wiinsch|Wiinsche|Wiinschen|wiinschst|wiinscht|wiinschte|wiirde|Wiirden|Wiirdest|wiirdet|wiirdigst|Wiire|wiiren|Wiirfel|wiirfeln|Wiirfels|wiirs|Wiirstchen|wiischt|Wiisste|wiissten|wiisstest|Wiiste|wiitenden|wijnsche|wijnschen|wijnschte|wijrd|wijrde|wijrden|wijrdest|wijrdiger|Wijrg|wijsste|wijtend|wildl|wilnsch|wilnsche|wilnschen|wilnscht|wilnschte|wilrd|Wilrde|Wilrden|Wilrdest|wilrdig|Wilrfel|Wilrfelenergie|wilsste|wilssten|Wilstling|wiltend|Windelhundl|Windhundk\\\xe9rper|winner|Wire|wires|Wirfangen|wirja|wirje|wirjede|wirjeden|wirjetzt|Wirnisse|Wirsind|wirtragen|Wirtschaftspriifer|Wirverfolgen|wirvom|Wirwaren|Wirwarten|Wirwerden|Wirwissen|Wirwollen|Wirwollten|Wirzeigten|wirzu|Witzl|WKHRENDDESSEN|wL\\'lrden|wle|Wleso|Wlhlen|wllinsch|wllinschst|wllinscht|wllirde|wllirden|wllirdest|wllirdet|Wllirgegriff|wllirgen|wllisste|wlr|wlrd|wlrkllch|Wlrkllchkelt|wlrst|Wlrwarten|wlrwollen|Wo\\/f|Wochenf\\\xe9hre|woffir|Wofiir|Wofijr|wofilr|Wofur|WoherweiB|WoherweiBt|Woherweif\\$t|wohlfilhlen|Wollkn\\\xe9uel|womiiglich|wom\\\xe9glich|wom\\\xe9iglich|Worfiber|woriiber|Worijber|Wortgepl\\\xe9nkel|Woruber|wt\\/\\'rden|wtinsche|wtinschst|wtirde|Wtirdest|Wtirfel|Wtmschen|WUl\\'d\\\u20ac|WUlfelbecher|wullte|Wundersch6n|wunderschfin|Wunderschiin|wunderschiinen|wundersch\\\xe9n|wundersch\\\xe9ne|Wundersch\\\xe9nel|wundersch\\\xe9nen|wundersch\\\xe9nes|wundersoh\\\xe9n|wunsche|Wunschen|wunscht|wunschte|WUNSCHTE|wurcle|wUrde|Wurdige|WURGT|Wurmer|Wursfsfulle|Wuste|WUSTEN|wutend|wu\\\xdfte|wu\\\xdftest|w\\\xa7r\\'s|w\\\xa7re|W\\\xa7ren\\'s|w\\\xe9\\'hrend|w\\\xe9chst|W\\\xe9chter|w\\\xe9fs|W\\\xe9g|w\\\xe9hle|w\\\xe9hlejetzt|w\\\xe9hlen|W\\\xe9hler|W\\\xe9hlern|w\\\xe9hlt|w\\\xe9hlte|w\\\xe9hrend|W\\\xe9hrung|W\\\xe9ichter|w\\\xe9ihlen|w\\\xe9ihrend|w\\\xe9ir|w\\\xe9ir\\'s|w\\\xe9irde|W\\\xe9ire|w\\\xe9iren|w\\\xe9irmen|w\\\xe9irst|W\\\xe9lder|W\\\xe9ldern|W\\\xe9lfen|W\\\xe9lkchen|W\\\xe9nde|W\\\xe9nden|w\\\xe9r|w\\\xe9r\\'s|W\\\xe9re|W\\\xe9ren|w\\\xe9ret|w\\\xe9rja|W\\\xe9rm|W\\\xe9rme|w\\\xe9rmt|W\\\xe9rst|w\\\xe9rt|W\\\xe9rter|W\\\xe9rterbuch|w\\\xe9rtliche|W\\\xe9sche|W\\\xe9scheklammer|W\\\xe9schst|w\\\xe9scht|w\\\ufb02rde|w\\\ufb02rden|W\\\ufb02rfel|z\\'a\\'h|Z\\/egf|Z\\/yarettenb\\\xe4ume|Z05|z6gel1e|z6gern|zahlenm\\\xe9\\\ufb02ig|zappelnl|Zauberspruchen|Zaubervoodookr\\\xe9fte|Zauherpfippchen|Zefietzende|zeitgem5B|Zeitgem\\\xe9\\\ufb02e|Zeitgeniissische|zeitgeniissischen|Zellenschliissel|zerbeif\\$en|zerbeif\\$t|zerf\\\xe9llt|Zermatschger\\\xe9usch|zerm\\\ufb02rben|zerreifien|zerreilit|zersfdren|zerst6rst|zerst6rt|zerstdren|Zerstfiren|Zerstfirer|Zerstfirungskraft|Zerstiickelung|zerstiire|zerstiiren|Zerstiirer|zerstiirt|zerstiirten|zerstiirtl|Zerstiirungl|zerstoren|zerst\\\xe9re|zerst\\\xe9ren|Zerst\\\xe9rer|zerst\\\xe9rt|Zerst\\\xe9rung|Zerst\\\xe9rungsfeldzug|zertrlllmmert|zfihlt|Ziel160m|Zihnelt|ziichtiger|Ziige|Ziindkapseln|Zilnd|Zilnden|Zilndungsenergie|Zilrich|Zindern|Zingstlich|Ziufierst|zleht|ZLIFUCK|Zooschlieliung|Zuckerschn\\\ufb02tchen|zuerstvor|zuffillig|zuflligen|ZUFUCK|Zuf\\\xe9illig|Zuf\\\xe9illigerweise|zuf\\\xe9llig|Zuf\\\xe9lligerweise|zug\\'a\\'nglichen|ZUGANGSPRIORITKT|zugehdrt|zugeh\\\xe9rt|zugestofien|Zugest\\\xe9ndnis|Zugest\\\xe9ndnisse|Zugiinge|zuh6ren|zuh6rt|zuhiiren|zuhiirt|Zuh\\\xe9lter|Zuh\\\xe9ren|Zuh\\\xe9rer|zukilnftiges|zul|zundete|Zundverteilerkappe|zunjick|zun\\\xe9chst|zun\\\xe9hen|zun\\\xe9ihen|Zuokerschntltchen|zurfick|zurfickblicken|zurfickgekommen|zurfickgezogen|zurfickkehren|zurfickzufuhren|zuriick|zuriickbleiben|zuriickgeben|zuriickgehen|zuriickgekommen|zuriickgezogen|zuriickhaben|zuriickkehre|zuriickkehren|zuriickkehrst|zuriickziehen|Zurijck|zurijckbringen|zurijckfordem|zurijckgeholt|zurijckgekehrt|zurijckgekommen|zurijckgelassen|zurijckgerufen|zurijckkehren|zurijcknehmen|zurijckstolpern|Zurilck|Zurilckf|zurilckgeblieben|zurilckgeholt|zurilckgekehrt|zurilckhalten|zurilckholen|zurilckkehre|zurilckkehren|zurilckkehrt|zurilckkommen|zurilckkommt|zurilcklassen|zurilckziehen|Zurilckziehenl|zurilckzugeben|zurl\\'Jck|zurL\\'lck|zurLick|zurljckgeben|zurllickfallen|zurllickgekehrt|zurllickkehrt|zurllickzukehren|zurlllckgehen|zurlllckkomme|zurtick|zurtickbringe|zurtickgezogen|zurtlckgekommen|zurtlckvervvandeln|Zuruck|ZURUCK|zuruckbleiben|zuruckblicken|zuruckdenke|zuruckfeuern|zuruckgehen|zuruckgelegt|zuruckgewiesen|zuruckgreifen|zuruckhaben|zuruckkehren|zuruckkehrten|zuruckkomme|zuruckkommen|zuruckk\\\xe9mst|zuruckl|zurucklassen|zurUcklieB|zuruckl\\\xe9cheln|zurucknehmen|zuruckverwandeln|zuruckverwandelt|zuruckziehen|zuruckzukommen|zurverfilgung|zur\\\xe9ickrufen|zur\\\ufb02ck|Zur\\\ufb02ckbleiben|zur\\\ufb02ckfliegen|zur\\\ufb02ckgeschickt|zur\\\ufb02ckgibst|zus\\'a\\'tzliche|zusammenbeilien|zusammenffigen|zusammenfugen|zusammenfuhren|zusammenf\\\xe9illt|zusammenh\\\xe9ilt|zusammenh\\\xe9lt|zusammenh\\\xe9ngen|zusammenreifien|zusammenzuschweifien|zuschl\\\xe9gst|zust6Bt|zustofken|zust\\\xe9indig|zust\\\xe9ncligen|zust\\\xe9ndig|zust\\\xe9ndigen|zus\\\xe9tzlich|zus\\\xe9tzliche|zuverlfissig|zuverllssig|zuverl\\\xe9ssig|zuverl\\\xe9ssiger|zuviel|zuviele|zuzuflligen|Zu\\\ufb02ucht|zvvei|Zw6If|zw6lfmal|Zwel|Zwickmfihle|Zwillingstiichter|Zwischenf\\\xe9lle|zwnlf|Zw\\\xe9ilften|zw\\\xe9lf|z\\\xe9gerlich|z\\\xe9gern|Z\\\xe9gerns|z\\\xe9h|z\\\xe9he|z\\\xe9her|z\\\xe9hl|z\\\xe9hle|z\\\xe9hlen|Z\\\xe9hlerei|z\\\xe9hlt|z\\\xe9hltl|Z\\\xe9hlung|Z\\\xe9hne|Z\\\xe9hnen|Z\\\xe9hneputzen|z\\\xe9ihle|z\\\xe9ihlen|z\\\xe9ihlt|Z\\\xe9ihlungen|Z\\\xe9ihne|Z\\\xe9libat|\\\\\\/GFQHUQGH|\\\\\\/OFVVUFf\\\u20ac|\\\\\\/Vahrheit|\\\\\\/Vir|\\\\\\/\\\\\\/i6fUl\\'1l\\\u20acfi|\\\\\\/\\\\\\/il\\'fUl\\'1I\\'\\\u20acl\\'1|\\\\Nynn|\\_|\\\xc4u|\\\xe9|\\\xe9chzt|\\\xe9ffentlich|\\\xe9ffne|\\\xe9ffnen|\\\xe9ffnet|\\\xe9fft|\\\xe9fter|\\\xe9fters|\\\xe9h|\\\xe9hnlich|\\\xe9hnliche|\\\xe9hnlicher|\\\xe9ih|\\\xe9ihnlich|\\\xe9indern|\\\xe9itzend|\\\xe9lter|\\\xe9lteste|\\\xe9ltesten|\\\xe9ndere|\\\xe9ndern|\\\xe9ndert|\\\xe9nderte|\\\xe9nderten|\\\xe9ngstlich|\\\xe9rgere|\\\xe9rgern|\\\xe9rztliche|\\\xe9rztlichen|\\\xe9rztlicher|\\\xe9sthetisch|\\\xe9tzend|\\\xe9ufierst|\\\xe9ufiersten|\\\xe9uflserst|\\\ufb02atterndem|\\\ufb02el|\\\ufb02iehen|\\\ufb02jr|\\\ufb02lhlen|\\\ufb02lllen|\\\ufb02lr|\\\ufb02lrchterlich|\\\ufb02ndet|AIle|AIter|GI\\\xfcck|PIaystation|AIIes|AIso|Ouatsch|AIles|BIeib|KIaut|AIlah|PIan|oderjemand|liestjetzt)(\\b|$)"}},
 'eng': {'BeginLines': {'data': OrderedDict([(u'lgot it', u'I got it'), (u'Don,t ', u"Don't "), (u'Can,t ', u"Can't "), (u'Let,s ', u"Let's "), (u'He,s ', u"He's "), (u'I,m ', u"I'm "), (u'I,ve ', u"I've "), (u'I,ll ', u"I'll "), (u'You,ll ', u"You'll "), (u'T hey ', u'They '), (u'T here ', u'There '), (u'W here ', u'Where '), (u'M aybe ', u'Maybe '), (u'S hould ', u'Should '), (u'|was', u'I was'), (u'|am ', u'I am'), (u'No w, ', u'Now, '), (u'l... I ', u'I... I '), (u'L... I ', u'I... I '), (u'lrn gonna', u"I'm gonna"), (u"-l don't", u"-I don't"), (u"l don't", u"I don't"), (u'L ', u'I '), (u'-L ', u'-I '), (u'- L ', u'- I '), (u'-l ', u'-I '), (u'- l ', u'- I '), (u'G0', u'Go'), (u'GO get', u'Go get'), (u'GO to', u'Go to'), (u'GO for', u'Go for'), (u'Ifl', u'If I'), (u"lt'll", u"It'll"), (u"Lt'll", u"It'll"), (u'IVIa', u'Ma'), (u'IVIu', u'Mu'), (u'0ne', u'One'), (u'0nly', u'Only'), (u'0n ', u'On '), (u'lt ', u'It '), (u'Lt ', u'It '), (u"lt's ", u"It's "), (u"Lt's ", u"It's "), (u'ln ', u'In '), (u'Ln ', u'In '), (u'l-in ', u'I-in '), (u'l-impossible', u'I-impossible'), (u'l- impossible', u'I-impossible'), (u'L- impossible', u'I-impossible'), (u"l-isn't ", u"I-isn't "), (u"L-isn't ", u"I-isn't "), (u"l- isn't ", u"I-isn't "), (u"L- isn't ", u"I-isn't "), (u'l- l ', u'I-I '), (u'L- l ', u'I-I '), (u'l- it ', u'I-it '), (u'L- it ', u'I-it '), (u'Ls it ', u'Is it '), (u'Ls there ', u'Is there '), (u'Ls he ', u'Is he '), (u'Ls she ', u'Is she '), (u'L can', u'I can'), (u'l can', u'I can'), (u"L'm ", u"I'm "), (u"L' m ", u"I'm "), (u"Lt' s ", u"It's "), (u"I']I ", u"I'll "), (u'...ls ', u'...Is '), (u'- ls ', u'- Is '), (u'...l ', u'...I '), (u'Ill ', u"I'll "), (u'L hope ', u'I hope '), (u"|\u2019E'$ ", u"It's "), (u"The y're ", u"They're "), (u'<i>/ ', u'<i>I '), (u'/ ', u'I '), (u'<i>/n ', u'<i>In '), (u'/n ', u'In '), (u'<i>Ana\u2019 ', u'<i>And '), (u"<i>Ana' ", u'<i>And '), (u'~ ', u'- '), (u"<i>A'|'|'EN BOROUGH:", u'<i>ATTENBOROUGH:'), (u"A'|'|'EN BOROUGH:", u'ATTENBOROUGH:'), (u"DAVID A'|'|'EN BOROUGH:", u'DAVID ATTENBOROUGH:'), (u"AT|'EN BOROUGH:", u'ATTENBOROUGH:'), (u"DAVID AT|'EN BOROUGH:", u'DAVID ATTENBOROUGH:'), (u"<i>AT|'EN BOROUGH:", u'<i>ATTENBOROUGH:'), (u'TH REE ', u'THREE '), (u'NARRA TOR', u'NARRATOR'), (u'<i>NARRA TOR', u'<i>NARRATOR'), (u"lt'syour", u"It's your"), (u"It'syour", u"It's your"), (u'Ls ', u'Is '), (u'I ve ', u"I've "), (u'I ii ', u"I'll "), (u'I m ', u"I'm "), (u'Why d ', u"Why'd "), (u'why d ', u"Why'd "), (u'Couldn t ', u"Couldn't "), (u'couldn t ', u"Couldn't "), (u'That s ', u"That's "), (u'that s ', u"That's "), (u'l ', u'I ')]),
                        'pattern': u"(?um)^(?:lgot\\ it|Don\\,t\\ |Can\\,t\\ |Let\\,s\\ |He\\,s\\ |I\\,m\\ |I\\,ve\\ |I\\,ll\\ |You\\,ll\\ |T\\ hey\\ |T\\ here\\ |W\\ here\\ |M\\ aybe\\ |S\\ hould\\ |\\|was|\\|am\\ |No\\ w\\,\\ |l\\.\\.\\.\\ I\\ |L\\.\\.\\.\\ I\\ |lrn\\ gonna|\\-l\\ don\\'t|l\\ don\\'t|L\\ |\\-L\\ |\\-\\ L\\ |\\-l\\ |\\-\\ l\\ |G0|GO\\ get|GO\\ to|GO\\ for|Ifl|lt\\'ll|Lt\\'ll|IVIa|IVIu|0ne|0nly|0n\\ |lt\\ |Lt\\ |lt\\'s\\ |Lt\\'s\\ |ln\\ |Ln\\ |l\\-in\\ |l\\-impossible|l\\-\\ impossible|L\\-\\ impossible|l\\-isn\\'t\\ |L\\-isn\\'t\\ |l\\-\\ isn\\'t\\ |L\\-\\ isn\\'t\\ |l\\-\\ l\\ |L\\-\\ l\\ |l\\-\\ it\\ |L\\-\\ it\\ |Ls\\ it\\ |Ls\\ there\\ |Ls\\ he\\ |Ls\\ she\\ |L\\ can|l\\ can|L\\'m\\ |L\\'\\ m\\ |Lt\\'\\ s\\ |I\\'\\]I\\ |\\.\\.\\.ls\\ |\\-\\ ls\\ |\\.\\.\\.l\\ |Ill\\ |L\\ hope\\ |\\|\\\u2019E\\'\\$\\ |The\\ y\\'re\\ |\\<i\\>\\/\\ |\\/\\ |\\<i\\>\\/n\\ |\\/n\\ |\\<i\\>Ana\\\u2019\\ |\\<i\\>Ana\\'\\ |\\~\\ |\\<i\\>A\\'\\|\\'\\|\\'EN\\ BOROUGH\\:|A\\'\\|\\'\\|\\'EN\\ BOROUGH\\:|DAVID\\ A\\'\\|\\'\\|\\'EN\\ BOROUGH\\:|AT\\|\\'EN\\ BOROUGH\\:|DAVID\\ AT\\|\\'EN\\ BOROUGH\\:|\\<i\\>AT\\|\\'EN\\ BOROUGH\\:|TH\\ REE\\ |NARRA\\ TOR|\\<i\\>NARRA\\ TOR|lt\\'syour|It\\'syour|Ls\\ |I\\ ve\\ |I\\ ii\\ |I\\ m\\ |Why\\ d\\ |why\\ d\\ |Couldn\\ t\\ |couldn\\ t\\ |That\\ s\\ |that\\ s\\ |l\\ )"},
         'EndLines': {'data': OrderedDict([(u', sin', u', sir.'), (u' mothen', u' mother.'), (u" can't_", u" can't."), (u' openiL', u' open it.'), (u' of\ufb02', u' off!'), (u'pshycol', u'psycho!'), (u' i...', u' I...'), (u' L.', u' I.')]),
                      'pattern': u"(?um)(?:\\,\\ sin|\\ mothen|\\ can\\'t\\_|\\ openiL|\\ of\\\ufb02|pshycol|\\ i\\.\\.\\.|\\ L\\.)$"},
         'PartialLines': {'data': OrderedDict([(u' /be ', u' I be '), (u" aren '1'", u" aren't"), (u" aren'tyou", u" aren't you"), (u" doesn '1'", u" doesn't"), (u" fr/eno'", u' friend'), (u" fr/eno'.", u' friend.'), (u" haven 'z' ", u" haven't "), (u" haven 'z'.", u" haven't."), (u' I ha ve ', u' I have '), (u" I']I ", u" I'll "), (u' L am', u' I am'), (u' L can', u' I can'), (u" L don't ", u" I don't "), (u' L hate ', u' I hate '), (u' L have ', u' I have '), (u' L like ', u' I like '), (u' L will', u' I will'), (u' L would', u' I would'), (u" L'll ", u" I'll "), (u" L've ", u" I've "), (u' m y family', u' my family'), (u" 's ", u"'s "), (u" shou/dn '1 ", u" shouldn't "), (u" won 'z' ", u" won't "), (u" won 'z'.", u" won't."), (u" wou/c/n 'z' ", u" wouldn't "), (u" wou/c/n 'z'.", u" wouldn't."), (u" wou/dn 'z' ", u" wouldn't "), (u" wou/dn 'z'.", u" wouldn't."), (u'/ did', u'I did'), (u'/ have ', u'I have '), (u'/ just ', u'I just '), (u'/ loved ', u'I loved '), (u'/ need', u'I need'), (u'|was11', u'I was 11'), (u'at Hrst', u'at first'), (u"B ullshiz'", u'Bullshit'), (u'big lunk', u'love you'), (u"can 't", u"can't"), (u"can' t ", u"can't "), (u"can 't ", u"can't "), (u'CHA TTERING', u'CHATTERING'), (u'come 0n', u'come on'), (u'Come 0n', u'Come on'), (u"couldn 't", u"couldn't"), (u"couldn' t ", u"couldn't "), (u"couldn 't ", u"couldn't "), (u"Destin y's", u"Destiny's"), (u"didn 't", u"didn't"), (u"didn' t ", u"didn't "), (u"didn 't ", u"didn't "), (u"Doesn '1'", u"Doesn't"), (u"doesn '1' ", u"doesn't "), (u"doesn '1\u2018 ", u"doesn't "), (u"doesn 't", u"doesn't"), (u"doesn'1' ", u"doesn't "), (u"doesn'1\u2018 ", u"doesn't "), (u"don '1' ", u"don't "), (u"don '1\u2018 ", u"don't "), (u"don '2' ", u"don't "), (u" aren '2'", u" aren't"), (u"aren '2' ", u"aren't "), (u"don '2\u2018 ", u"don't "), (u"don 't", u"don't"), (u"Don' t ", u"Don't "), (u"Don 't ", u"Don't "), (u"don'1' ", u"don't "), (u"don'1\u2018 ", u"don't "), (u"there '5 ", u"there's "), (u'E very', u'Every'), (u'get 0n', u'get on'), (u'go 0n', u'go on'), (u'Go 0n', u'Go on'), (u"H3993' birthday", u'Happy birthday'), (u"hadn 't", u"hadn't"), (u"he 's", u"he's"), (u"He 's", u"He's"), (u'He y', u'Hey'), (u'he)/', u'hey'), (u'He)/', u'Hey'), (u'HEA VY', u'HEAVY'), (u'Henry ll', u'Henry II'), (u'Henry lll', u'Henry III'), (u'Henry Vlll', u'Henry VIII'), (u'Henry Vll', u'Henry VII'), (u'Henry Vl', u'Henry VI'), (u'Hold 0n', u'Hold on'), (u'I am. ls', u'I am. Is'), (u'I d0', u'I do'), (u"I 'm", u"I'm"), (u"I 'rn ", u"I'm "), (u"I 've", u"I've"), (u'I0 ve her', u'love her'), (u'I0 ve you', u'love you'), (u"I02'", u'lot'), (u"I'm sony", u"I'm sorry"), (u"isn' t ", u"isn't "), (u"isn 't ", u"isn't "), (u'K)/le', u'Kyle'), (u'L ook', u'Look'), (u'let me 90', u'let me go'), (u'Let me 90', u'Let me go'), (u"let's 90", u"let's go"), (u"Let's 90", u"Let's go"), (u'lfl had', u'If I had'), (u'lova you', u'love you'), (u'Lova you', u'love you'), (u'lovo you', u'love you'), (u'Lovo you', u'love you'), (u'ls anyone', u'Is anyone'), (u'ls he', u'Is he'), (u'-ls he', u'- Is he'), (u'ls it', u'Is it'), (u'-ls it', u'- Is it'), (u'ls she', u'Is she'), (u'-ls she', u'- Is she'), (u'ls that', u'Is that'), (u'-ls that', u'- Is that'), (u'ls this', u'Is this'), (u'-ls this', u'- Is this'), (u'Maze] tov', u'Mazel tov'), (u"N02' ", u'Not '), (u' of 0ur ', u' of our '), (u' ot mine ', u' of mine '), (u'PLA YING', u'PLAYING'), (u'REPEA TING ', u'REPEATING '), (u'Sa y', u'Say'), (u"she 's", u"she's"), (u"She 's", u"She's"), (u"shouldn 't", u"shouldn't"), (u'sta y', u'stay'), (u'Sta y', u'Stay'), (u'SWO rd', u'Sword'), (u'taka care', u'take care'), (u'Taka care', u'Take care'), (u'the Hrst', u'the first'), (u'toc late', u'too late'), (u'uf me', u'of me'), (u'uf our', u'of our'), (u'wa y', u'way'), (u'Wal-I\\/Iart', u'Wal-Mart'), (u"wasn '1' ", u"wasn't "), (u"Wasn '1' ", u"Wasn't "), (u"wasn '1\u2018 ", u"wasn't "), (u"Wasn '1\u2018 ", u"Wasn't "), (u"wasn 't", u"wasn't"), (u"Wasn 't", u"Wasn't"), (u"we 've", u"we've"), (u"We 've", u"We've"), (u"wem' off", u'went off'), (u"weren 't", u"weren't"), (u"who 's", u"who's"), (u"won 't", u"won't"), (u'would ha ve', u'would have '), (u"wouldn 't", u"wouldn't"), (u"Wouldn 't", u"Wouldn't"), (u'y()u', u'you'), (u'you QUYS', u'you guys'), (u"you' re ", u"you're "), (u"you 're ", u"you're "), (u"you 've", u"you've"), (u"You 've", u"You've"), (u"you' ve ", u"you've "), (u"you 've ", u"you've "), (u'aftera while', u'after a while'), (u'Aftera while', u'After a while'), (u'THUN DERCLAPS', u'THUNDERCLAPS'), (u'(BUZZI N G)', u'(BUZZING)'), (u'[BUZZI N G]', u'[BUZZING]'), (u'(G RU NTING', u'(GRUNTING'), (u'[G RU NTING', u'[GRUNTING'), (u'(G ROWLING', u'(GROWLING'), (u'[G ROWLING', u'[GROWLING'), (u' WAI LS)', u'WAILS)'), (u' WAI LS]', u'WAILS]'), (u'(scu RRYING)', u'(SCURRYING)'), (u'[scu RRYING]', u'[SCURRYING]'), (u'(GRUNT5)', u'(GRUNTS)'), (u'[GRUNT5]', u'[GRUNTS]'), (u'NARRA TOR:', u'NARRATOR:'), (u'(GROAN ING', u'(GROANING'), (u'[GROAN ING', u'[GROANING'), (u'GROAN ING)', u'GROANING)'), (u'GROAN ING]', u'GROANING]'), (u'(LAUGH ING', u'(LAUGHING'), (u'[LAUGH ING', u'[LAUGHING'), (u'LAUGH ING)', u'LAUGHING)'), (u'LAUGH ING]', u'LAUGHING]'), (u'(BU BBLING', u'(BUBBLING'), (u'[BU BBLING', u'[BUBBLING'), (u'BU BBLING)', u'BUBBLING)'), (u'BU BBLING]', u'BUBBLING]'), (u'(SH USHING', u'(SHUSHING'), (u'[SH USHING', u'[SHUSHING'), (u'SH USHING)', u'SHUSHING)'), (u'SH USHING]', u'SHUSHING]'), (u'(CH ILDREN', u'(CHILDREN'), (u'[CH ILDREN', u'[CHILDREN'), (u'CH ILDREN)', u'CHILDREN)'), (u'CH ILDREN]', u'CHILDREN]'), (u'(MURMU RING', u'(MURMURING'), (u'[MURMU RING', u'[MURMURING'), (u'MURMU RING)', u'MURMURING)'), (u'MURMU RING]', u'MURMURING]'), (u'(GU N ', u'(GUN '), (u'[GU N ', u'[GUN '), (u'GU N)', u'GUN)'), (u'GU N]', u'GUN]'), (u'CH ILDREN:', u'CHILDREN:'), (u'STU DENTS:', u'STUDENTS:'), (u'(WH ISTLE', u'(WHISTLE'), (u'[WH ISTLE', u'[WHISTLE'), (u'WH ISTLE)', u'WHISTLE)'), (u'WH ISTLE]', u'WHISTLE]'), (u'U LU LATING', u'ULULATING'), (u'AU DIENCE:', u'AUDIENCE:'), (u'HA WAIIAN', u'HAWAIIAN'), (u'(ARTH UR', u'(ARTHUR'), (u'[ARTH UR', u'[ARTHUR'), (u'ARTH UR)', u'ARTHUR)'), (u'ARTH UR]', u'ARTHUR]'), (u'J EREMY:', u'JEREMY:'), (u'(ELEVA TOR', u'(ELEVATOR'), (u'[ELEVA TOR', u'[ELEVATOR'), (u'ELEVA TOR)', u'ELEVATOR)'), (u'ELEVA TOR]', u'ELEVATOR]'), (u'CONTIN U ES', u'CONTINUES'), (u'WIN D HOWLING', u'WIND HOWLING'), (u'telis me', u'tells me'), (u'Telis me', u'Tells me'), (u'. Ls ', u'. Is '), (u'! Ls ', u'! Is '), (u'? Ls ', u'? Is '), (u'. Lt ', u'. It '), (u'! Lt ', u'! It '), (u'? Lt ', u'? It '), (u'SQMEWH ERE ELSE', u'SOMEWHERE ELSE'), (u' I,m ', u" I'm "), (u' I,ve ', u" I've "), (u' you,re ', u" you're "), (u' you,ll ', u" you'll "), (u' doesn,t ', u" doesn't "), (u' let,s ', u" let's "), (u' he,s ', u" he's "), (u' it,s ', u" it's "), (u' can,t ', u" can't "), (u' Can,t ', u" Can't "), (u' don,t ', u" don't "), (u' Don,t ', u" Don't "), (u"wouldn 'tyou", u"wouldn't you"), (u' lgot it', u' I got it'), (u' you,ve ', u" you've "), (u' I ve ', u" I've "), (u' I ii ', u" I'll "), (u' I m ', u" I'm "), (u' why d ', u" why'd "), (u' couldn t ', u" couldn't "), (u' that s ', u" that's "), (u' i... ', u' I... '), (u"L don't", u"I don't"), (u"L won't", u"I won't"), (u'L should', u'I should'), (u'L had', u'I had'), (u'L happen', u'I happen'), (u"L wasn't", u"I wasnt't"), (u'H i', u'Hi'), (u"L didn't", u"I didn't"), (u'L do', u'I do'), (u'L could', u'I could'), (u'L will', u'I will'), (u'L suggest', u'I suggest'), (u'L reckon', u'I reckon'), (u'L am', u'I am'), (u"L couldn't", u"I couldn't"), (u'L might', u'I might'), (u'L would', u'I would'), (u'L was', u'I was'), (u'L know', u'I know'), (u'L think', u'I think'), (u"L haven't", u"I haven't"), (u'L have ', u'I have'), (u'L want', u'I want'), (u'L can', u'I can'), (u'L love', u'I love'), (u'L like', u'I like')]),
                          'pattern': u"(?um)(?:(?<=\\s)|(?<=^)|(?<=\\b))(?:\\ \\/be\\ |\\ aren\\ \\'1\\'|\\ aren\\'tyou|\\ doesn\\ \\'1\\'|\\ fr\\/eno\\'|\\ fr\\/eno\\'\\.|\\ haven\\ \\'z\\'\\ |\\ haven\\ \\'z\\'\\.|\\ I\\ ha\\ ve\\ |\\ I\\'\\]I\\ |\\ L\\ am|\\ L\\ can|\\ L\\ don\\'t\\ |\\ L\\ hate\\ |\\ L\\ have\\ |\\ L\\ like\\ |\\ L\\ will|\\ L\\ would|\\ L\\'ll\\ |\\ L\\'ve\\ |\\ m\\ y\\ family|\\ \\'s\\ |\\ shou\\/dn\\ \\'1\\ |\\ won\\ \\'z\\'\\ |\\ won\\ \\'z\\'\\.|\\ wou\\/c\\/n\\ \\'z\\'\\ |\\ wou\\/c\\/n\\ \\'z\\'\\.|\\ wou\\/dn\\ \\'z\\'\\ |\\ wou\\/dn\\ \\'z\\'\\.|\\/\\ did|\\/\\ have\\ |\\/\\ just\\ |\\/\\ loved\\ |\\/\\ need|\\|was11|at\\ Hrst|B\\ ullshiz\\'|big\\ lunk|can\\ \\'t|can\\'\\ t\\ |can\\ \\'t\\ |CHA\\ TTERING|come\\ 0n|Come\\ 0n|couldn\\ \\'t|couldn\\'\\ t\\ |couldn\\ \\'t\\ |Destin\\ y\\'s|didn\\ \\'t|didn\\'\\ t\\ |didn\\ \\'t\\ |Doesn\\ \\'1\\'|doesn\\ \\'1\\'\\ |doesn\\ \\'1\\\u2018\\ |doesn\\ \\'t|doesn\\'1\\'\\ |doesn\\'1\\\u2018\\ |don\\ \\'1\\'\\ |don\\ \\'1\\\u2018\\ |don\\ \\'2\\'\\ |\\ aren\\ \\'2\\'|aren\\ \\'2\\'\\ |don\\ \\'2\\\u2018\\ |don\\ \\'t|Don\\'\\ t\\ |Don\\ \\'t\\ |don\\'1\\'\\ |don\\'1\\\u2018\\ |there\\ \\'5\\ |E\\ very|get\\ 0n|go\\ 0n|Go\\ 0n|H3993\\'\\ birthday|hadn\\ \\'t|he\\ \\'s|He\\ \\'s|He\\ y|he\\)\\/|He\\)\\/|HEA\\ VY|Henry\\ ll|Henry\\ lll|Henry\\ Vlll|Henry\\ Vll|Henry\\ Vl|Hold\\ 0n|I\\ am\\.\\ ls|I\\ d0|I\\ \\'m|I\\ \\'rn\\ |I\\ \\'ve|I0\\ ve\\ her|I0\\ ve\\ you|I02\\'|I\\'m\\ sony|isn\\'\\ t\\ |isn\\ \\'t\\ |K\\)\\/le|L\\ ook|let\\ me\\ 90|Let\\ me\\ 90|let\\'s\\ 90|Let\\'s\\ 90|lfl\\ had|lova\\ you|Lova\\ you|lovo\\ you|Lovo\\ you|ls\\ anyone|ls\\ he|\\-ls\\ he|ls\\ it|\\-ls\\ it|ls\\ she|\\-ls\\ she|ls\\ that|\\-ls\\ that|ls\\ this|\\-ls\\ this|Maze\\]\\ tov|N02\\'\\ |\\ of\\ 0ur\\ |\\ ot\\ mine\\ |PLA\\ YING|REPEA\\ TING\\ |Sa\\ y|she\\ \\'s|She\\ \\'s|shouldn\\ \\'t|sta\\ y|Sta\\ y|SWO\\ rd|taka\\ care|Taka\\ care|the\\ Hrst|toc\\ late|uf\\ me|uf\\ our|wa\\ y|Wal\\-I\\\\\\/Iart|wasn\\ \\'1\\'\\ |Wasn\\ \\'1\\'\\ |wasn\\ \\'1\\\u2018\\ |Wasn\\ \\'1\\\u2018\\ |wasn\\ \\'t|Wasn\\ \\'t|we\\ \\'ve|We\\ \\'ve|wem\\'\\ off|weren\\ \\'t|who\\ \\'s|won\\ \\'t|would\\ ha\\ ve|wouldn\\ \\'t|Wouldn\\ \\'t|y\\(\\)u|you\\ QUYS|you\\'\\ re\\ |you\\ \\'re\\ |you\\ \\'ve|You\\ \\'ve|you\\'\\ ve\\ |you\\ \\'ve\\ |aftera\\ while|Aftera\\ while|THUN\\ DERCLAPS|\\(BUZZI\\ N\\ G\\)|\\[BUZZI\\ N\\ G\\]|\\(G\\ RU\\ NTING|\\[G\\ RU\\ NTING|\\(G\\ ROWLING|\\[G\\ ROWLING|\\ WAI\\ LS\\)|\\ WAI\\ LS\\]|\\(scu\\ RRYING\\)|\\[scu\\ RRYING\\]|\\(GRUNT5\\)|\\[GRUNT5\\]|NARRA\\ TOR\\:|\\(GROAN\\ ING|\\[GROAN\\ ING|GROAN\\ ING\\)|GROAN\\ ING\\]|\\(LAUGH\\ ING|\\[LAUGH\\ ING|LAUGH\\ ING\\)|LAUGH\\ ING\\]|\\(BU\\ BBLING|\\[BU\\ BBLING|BU\\ BBLING\\)|BU\\ BBLING\\]|\\(SH\\ USHING|\\[SH\\ USHING|SH\\ USHING\\)|SH\\ USHING\\]|\\(CH\\ ILDREN|\\[CH\\ ILDREN|CH\\ ILDREN\\)|CH\\ ILDREN\\]|\\(MURMU\\ RING|\\[MURMU\\ RING|MURMU\\ RING\\)|MURMU\\ RING\\]|\\(GU\\ N\\ |\\[GU\\ N\\ |GU\\ N\\)|GU\\ N\\]|CH\\ ILDREN\\:|STU\\ DENTS\\:|\\(WH\\ ISTLE|\\[WH\\ ISTLE|WH\\ ISTLE\\)|WH\\ ISTLE\\]|U\\ LU\\ LATING|AU\\ DIENCE\\:|HA\\ WAIIAN|\\(ARTH\\ UR|\\[ARTH\\ UR|ARTH\\ UR\\)|ARTH\\ UR\\]|J\\ EREMY\\:|\\(ELEVA\\ TOR|\\[ELEVA\\ TOR|ELEVA\\ TOR\\)|ELEVA\\ TOR\\]|CONTIN\\ U\\ ES|WIN\\ D\\ HOWLING|telis\\ me|Telis\\ me|\\.\\ Ls\\ |\\!\\ Ls\\ |\\?\\ Ls\\ |\\.\\ Lt\\ |\\!\\ Lt\\ |\\?\\ Lt\\ |SQMEWH\\ ERE\\ ELSE|\\ I\\,m\\ |\\ I\\,ve\\ |\\ you\\,re\\ |\\ you\\,ll\\ |\\ doesn\\,t\\ |\\ let\\,s\\ |\\ he\\,s\\ |\\ it\\,s\\ |\\ can\\,t\\ |\\ Can\\,t\\ |\\ don\\,t\\ |\\ Don\\,t\\ |wouldn\\ \\'tyou|\\ lgot\\ it|\\ you\\,ve\\ |\\ I\\ ve\\ |\\ I\\ ii\\ |\\ I\\ m\\ |\\ why\\ d\\ |\\ couldn\\ t\\ |\\ that\\ s\\ |\\ i\\.\\.\\.\\ |L\\ don\\'t|L\\ won\\'t|L\\ should|L\\ had|L\\ happen|L\\ wasn\\'t|H\\ i|L\\ didn\\'t|L\\ do|L\\ could|L\\ will|L\\ suggest|L\\ reckon|L\\ am|L\\ couldn\\'t|L\\ might|L\\ would|L\\ was|L\\ know|L\\ think|L\\ haven\\'t|L\\ have\\ |L\\ want|L\\ can|L\\ love|L\\ like)(?:(?=\\s)|(?=$)|(?=\\b))"},
         'PartialWordsAlways': {'data': OrderedDict([(u'\xa4', u'o'), (u'lVI', u'M'), (u'IVl', u'M'), (u'lVl', u'M'), (u'I\\/I', u'M'), (u'l\\/I', u'M'), (u'I\\/l', u'M'), (u'l\\/l', u'M'), (u'IVIa', u'Ma'), (u'IVIe', u'Me'), (u'IVIi', u'Mi'), (u'IVIo', u'Mo'), (u'IVIu', u'Mu'), (u'IVIy', u'My'), (u' l ', u' I '), (u'l/an', u'lian'), (u'\xb0x\xb0', u'%'), (u'\xc3\xc2s', u"'s"), (u'at/on', u'ation'), (u'lljust', u'll just'), (u"'sjust", u"'s just"), (u'";', u"'s"), (u'compiete', u'complete'), (u' L ', u' I '), (u'a/ion', u'ation'), (u'\xc2s', u"'s"), (u"'tjust", u"'t just")]),
                                'pattern': None},
         'WholeLines': {'data': OrderedDict([(u'H ey.', u'Hey.'), (u'He)\u2019-', u'Hey.'), (u'N0.', u'No.'), (u'-N0.', u'-No.'), (u'Noll', u'No!!'), (u'(G ROANS)', u'(GROANS)'), (u'[G ROANS]', u'[GROANS]'), (u'(M EOWS)', u'(MEOWS)'), (u'[M EOWS]', u'[MEOWS]'), (u'Uaughs]', u'[laughs]'), (u'[chitte rs]', u'[chitters]'), (u'Hil\u2018 it!', u'Hit it!'), (u'<i>Hil\u2018 it!</i>', u'<i>Hit it!</i>'), (u'ISIGHS]', u'[SIGHS]')]),
                        'pattern': None},
         'WholeWords': {'data': OrderedDict([(u'$COff$', u'scoffs'), (u'$ergei', u'Sergei'), (u"$'llOp", u'Stop'), (u"/'//", u"I'll"), (u"/'/I", u"I'll"), (u'/ennifer', u'Jennifer'), (u'/got', u'I got'), (u'/have', u'I have'), (u'/hope', u'I hope'), (u'/just', u'I just'), (u'/love', u'I love'), (u"/'m", u"I'm"), (u'/mmerse', u'immerse'), (u'/nsu/ts', u'Insults'), (u'/ong', u'long'), (u'/ook', u'look'), (u"/t's", u"It's"), (u"/'ve", u"I've"), (u"\\/\\/e'd", u"We'd"), (u"\\/\\/e're", u"We're"), (u"\\/\\/e've", u"We've"), (u'\\/\\/hat', u'What'), (u"\\/\\/here'd", u"Where'd"), (u'\\/\\/hoo', u'Whoo'), (u'\\/\\/hy', u'Why'), (u"\\/\\/hy'd", u"Why'd"), (u"\\/\\le're", u"We're"), (u'\\/Ve', u'We'), (u"\\Ne're", u"We're"), (u"\\Nhat's", u"What's"), (u"\\Nhere's", u"Where's"), (u"|'mjust", u"I'm just"), (u'\xa4ff', u'off'), (u'\xa4Id', u'old'), (u'\xa4Ids', u'olds'), (u'\xa4n', u'on'), (u'\xa4ne', u'one'), (u'\xa4nly', u'only'), (u'\xa4pen', u'open'), (u'\xa4r', u'or'), (u'\xa4rder', u'order'), (u'\xa4ther', u'other'), (u'\xa4ur', u'our'), (u'\xa4ut', u'out'), (u'\xa4ver', u'over'), (u'\xa4wn', u'own'), (u"\u20acV\u20acI'y", u'every'), (u"0'clock", u"o'clock"), (u'0f', u'of'), (u'0fEngland', u'of England'), (u'0fft0', u'off to'), (u'0l/er', u'over'), (u'0n', u'on'), (u'0ne', u'one'), (u"0ne's", u"one's"), (u'0r', u'or'), (u'0rders', u'orders'), (u"0thers'", u"others'"), (u'0ut', u'out'), (u"0utlaw's", u"outlaw's"), (u"0utlaws'", u"outlaws'"), (u'0ver', u'over'), (u'13oos', u'1300s'), (u'18oos', u'1800s'), (u'195os', u'1950s'), (u"1et's", u"let's"), (u'1o', u'10'), (u'1oo', u'100'), (u'1ooth', u'100th'), (u'1oth', u'10th'), (u'2E_', u'2E.'), (u"2'IST", u'21ST'), (u"2'Ist_", u"2'1st."), (u'2o', u'20'), (u'2oth', u'20th'), (u'3o', u'30'), (u'3oth', u'30th'), (u'4o', u'40'), (u'4os', u'40s'), (u'4oth', u'40th'), (u'50rry', u'sorry'), (u'5o', u'50'), (u'5oth', u'50th'), (u'6o', u'60'), (u'6os', u'60s'), (u"'6os", u"'60s"), (u'6oth', u'60th'), (u'7o', u'70'), (u"'7os", u"'70s"), (u'7oth', u'70th'), (u'8o', u'80'), (u"'8os", u"'80s"), (u'8oth', u'80th'), (u'9/aim', u'alarm'), (u'9o', u'90'), (u'9oth', u'90th'), (u'9UnShQt', u'gunshot'), (u'a//', u'all'), (u'a/bum', u'album'), (u'a/so', u'also'), (u'A/ways', u'Always'), (u'abcut', u'about'), (u'aboutjoining', u'about joining'), (u'aboutposh', u'about posh'), (u'aboutus', u'about us'), (u'aboutyou', u'about you'), (u'accldent', u'accident'), (u'Acool', u'A cool'), (u'afier', u'after'), (u'affraid', u'afraid'), (u'Afriend', u'A friend'), (u'afterall', u'after all'), (u'afterthe', u'after the'), (u'afulcrum', u'a fulcrum'), (u'Afunny', u'A funny'), (u'aga/nst', u'against'), (u'ahsolutes', u'absolutes'), (u'AI_I_', u'ALL'), (u'AIien', u'Alien'), (u'AIex', u'Alex'), (u'AII', u'All'), (u'AIIan', u'Allan'), (u'AIIow', u'Allow'), (u'AIive', u'Alive'), (u"ain'tgotno", u"ain't got no"), (u"Ain'tgotno", u"Ain't got no"), (u'airstrike', u'air strike'), (u'AIVIBULANCE', u'AMBULANCE'), (u'ajob', u'a job'), (u'ajockey_', u'a jockey.'), (u'ajoke', u'a joke'), (u'Ajoke', u'A joke'), (u'ajoking', u'a joking'), (u'al/', u'all'), (u'al/en', u'alien'), (u'alittle', u'a little'), (u'allgasp', u'all gasp'), (u'alljustforshow', u'all just for show'), (u"aln't", u"ain't"), (u'alot', u'a lot'), (u'Alot', u'A lot'), (u'An5wer', u'Answer'), (u'Andit', u'And it'), (u"Andit's", u"And it's"), (u'andl', u'and I'), (u'andlaughs', u'and laughs'), (u'andleave', u'and leave'), (u'andthe', u'and the'), (u'andyou', u'and you'), (u'Andyou', u'And you'), (u'ANNOUNC/NG', u'ANNOUNCING'), (u'anotherstep', u'another step'), (u'ANSWER/NG', u'ANSWERING'), (u'answerwhat', u'answer what'), (u'antiquejoke', u'antique joke'), (u"anyhcdy's", u"anybody's"), (u'Anyidea', u'Any idea'), (u"anyone's_", u"anyone's."), (u'apejust', u'ape just'), (u'ARABlc', u'ARABIC'), (u"aren't_", u"aren't."), (u"arerl't", u"aren't"), (u"Arnsteln's", u"Arnstein's"), (u'atleast', u'at least'), (u'Atough', u'A tough'), (u'Awhole', u'A whole'), (u'awoman', u'a woman'), (u'Awoman', u'A woman'), (u'barelytalked', u'barely talked'), (u'bcat', u'boat'), (u'Bcllvla', u'Bolivia'), (u'bcmb', u'bomb'), (u'bcmbs', u'bombs'), (u'be//y', u'belly'), (u'becuase', u'because'), (u"Beep/'ng", u'Beeping'), (u'bejumpy', u'be jumpy'), (u'besldes', u'besides'), (u'bestfriend', u'best friend'), (u'bestguy', u'best guy'), (u'bestjob', u'best job'), (u'BIack', u'Black'), (u'BIess', u'Bless'), (u'bigos___', u'bigos...'), (u'BIame', u'Blame'), (u'BIind', u'Blind'), (u'BIood', u'Blood'), (u'BIue', u'Blue'), (u'BLOVVS', u'BLOWS'), (u'blowholel', u'blowhole!'), (u'blt', u'bit'), (u'Bo99', u'Bogg'), (u'bodiedyoung', u'bodied young'), (u'breakf\xe9wtl', u'breakfast!'), (u'bulldozlng', u'bulldozing'), (u'butjust', u'but just'), (u'butl', u'but I'), (u'Butl', u'But I'), (u'butljust', u'but I just'), (u"Butljustcan'tgetenough", u"But I just can't get enough"), (u"Butyou're", u"But you're"), (u'buythem', u'buy them'), (u'buyyou', u'buy you'), (u'byjust', u'by just'), (u'bythe', u'by the'), (u"C/latter/'/7g", u'Chattering'), (u'ca///ng', u'calling'), (u'ca/I', u'call'), (u'call/ng', u'calling'), (u'callyou', u'call you'), (u'can*t', u"can't"), (u"can'i", u"can't"), (u"can'I", u"can't"), (u'canlgetyou', u'canI get you'), (u'cannotchange', u'cannot change'), (u'cannut', u'cannot'), (u"can'T", u"can't"), (u"can't_", u'Crucially'), (u"can'tjust", u"can't just"), (u"can'tletgo", u"can't let go"), (u'Car0l', u'Carol'), (u'Carhorn', u'Car horn'), (u'carrled', u'carried'), (u'Ccug', u'Coug'), (u'Ccugs', u'Cougs'), (u'Ccver', u'Cover'), (u'cellularchange', u'cellular change'), (u'cff', u'off'), (u'cfycu', u'of you'), (u'cfycur', u'of your'), (u'Ch/rping', u'Chirping'), (u'chaletgirl', u'chalet girl'), (u'changejobs', u'change jobs'), (u'Charliejust', u'Charlie just'), (u"Chatter/'rtg", u'Chattering'), (u'CHATTERWG', u'CHATTERING'), (u'Chequeredlove', u'Chequered love'), (u'cHIRPINcs', u'CHIRPING'), (u'chjldishness', u'childishness'), (u'chlldrcn', u'children'), (u'chlldren', u'children'), (u'chocolatte', u'chocolate'), (u'Cho/r', u'Choir'), (u'cHucKl_Es', u'CHUCKLES'), (u'CIark', u'Clark'), (u'CIear', u'Clear'), (u'circumcised_', u'circumcised.'), (u'ckay', u'okay'), (u'cl_osEs', u'CLOSES'), (u'CLATTERWG', u'CLATTERING'), (u'cn', u'on'), (u'cne', u'one'), (u'cnes', u'ones'), (u'Coincidenta//y', u'Coincidentally'), (u'COm\u20ac', u'Come'), (u'comp/etey', u'completely'), (u'complainingabout', u'complaining about'), (u'coms', u'come'), (u'cond/lion', u'condition'), (u'confdence', u'confidence'), (u'conhrmed', u'confirmed'), (u'connrm', u'confirm'), (u'Consecutivelyl', u'Consecutively!'), (u'COUGH5', u'COUGHS'), (u'CouGHING', u'COUGHING'), (u"couIdn't", u"couldn't"), (u'couldjust', u'could just'), (u"couldn'T", u"couldn't"), (u"couldn'tjust", u"couldn't just"), (u'Couldyou', u'Could you'), (u'crappyjob', u'crappy job'), (u'CRAsHING', u'CRASHING'), (u'crder', u'order'), (u'Crowdcheers', u'Crowd cheers'), (u'Cruoially', u'Crucially'), (u'cther', u'other'), (u'cuuld', u'could'), (u'cver', u'over'), (u"d/'dn't", u"didn't"), (u'd/squietude', u'disquietude'), (u"D\xa4esn't", u"Doesn't"), (u"d\xa4n'i", u"don't"), (u"d\xa4n't", u"don't"), (u'd\xb09', u'dog'), (u'd0', u'do'), (u'D0', u'Do'), (u"D0asn't", u"Doesn't"), (u"Dad'//", u"Dad'll"), (u'dairyjust', u'dairy just'), (u'Dar//ng', u'Darling'), (u'dc', u'do'), (u'Dcbby', u'Dobby'), (u"dccsn't", u"doesn't"), (u'dcctcr', u'doctor'), (u'Dces', u'Does'), (u'dcgs', u'dogs'), (u'dcing', u'doing'), (u"dcn'I", u"don't"), (u"dcn't", u"don't"), (u"Dcn't", u"Don't"), (u'dcughnut', u'doughnut'), (u'declslons', u'decisions'), (u'deedhas', u'deed has'), (u'Dehnitely', u'Definitely'), (u'desewes', u'deserves'), (u'desperate/\xbby', u'desperately'), (u'D\ufb02nk', u'Drink'), (u'DIAl_lNcs', u'DIALING'), (u"didn'!", u"didn't"), (u'didnt', u"didn't"), (u"didn'T", u"didn't"), (u"dIdn't", u"didn't"), (u"didn't_", u"didn't."), (u'didrft', u"didn't"), (u"didrl't", u"didn't"), (u'didyou', u'did you'), (u'divorcing_', u'divorcing.'), (u'dld', u'did'), (u"dldn't", u"didn't"), (u'dlfflcull', u'difficult'), (u'dlg', u'dig'), (u'dlsobeyed', u'disobeyed'), (u"doasn't", u"doesn't"), (u"Doasn't", u"Doesn't"), (u'doctoh', u'doctor'), (u'Doctor___tell', u'Doctor... tell'), (u'doesnt', u"doesn't"), (u"doesn'T", u"doesn't"), (u"doesri't", u"doesnt't"), (u'doesrt', u"doesn't"), (u'Doesrt', u"Doesn't"), (u'doit', u'do it'), (u'dojust', u'do just'), (u'don*t', u"don't"), (u'donejobs', u'done jobs'), (u"don'i", u"don't"), (u"don'l", u"don't"), (u"Don'l", u"Don't"), (u'Donllook', u"Don't look"), (u'dont', u"don't"), (u"don'T", u"don't"), (u"don'tcare", u"don't care"), (u"don'tjoke", u"don't joke"), (u"Don'tjudge", u"Don't judge"), (u"don'tjust", u"don't just"), (u"Don'tjust", u"Don't just"), (u"Don'tlet", u"Don't let"), (u"don'tlhink", u"don't think"), (u"don'tpush", u"don't push"), (u"Don'tyou", u"Don't you"), (u'DonWlook', u"Don't look"), (u'Dooropens', u'Door opens'), (u'doorshuts', u'door shuts'), (u'dothat', u'do that'), (u'dothis', u'do this'), (u'Drinkthis', u'Drink this'), (u'dumbass', u'dumb-ass'), (u'dumbto', u'dumb to'), (u"dun't", u"don't"), (u'E//e', u'Elle'), (u'E9YPt', u'Egypt'), (u"ea/'t/7", u'earth'), (u'eart/7', u'earth'), (u"efi'/'c/'ent", u'efficient'), (u'EN<3LlsH', u'ENGLISH'), (u'Enjoythe', u'Enjoy the'), (u'Erv\\/an', u'Erwan'), (u"Erv\\/an's", u"Erwan's"), (u'etemity', u'eternity'), (u'ev/I', u'evil'), (u'eve/yone', u'everyone'), (u"even/body's", u"everybody's"), (u'eversay', u'ever say'), (u'Everymonth', u'Every month'), (u'everythings', u"everything's"), (u"Everythirlg's", u'Everything\u2019s'), (u"Everythlng's", u"Everything's"), (u'Everytime', u'Every time'), (u'Exac\ufb02y', u'Exactly'), (u'ExacUy_', u'Exactly.'), (u'excitedshrieking', u'excited shrieking'), (u'ExcLAllvls', u'EXCLAIMS'), (u'exploatation', u'exploitation'), (u'expreusion', u'expression'), (u'fairthat', u'fair that'), (u'Fathef', u'Father'), (u'fatherfigure', u'father figure'), (u'FBl', u'FBI'), (u'fcrebcdlng', u'foreboding'), (u'fcreverjudges', u'forever judges'), (u'fcund', u'found'), (u'feeleverything', u'feel everything'), (u'feelsweet', u'feel sweet'), (u"fiam/'/y", u'family'), (u'\ufb01ngernail', u'fingernail'), (u'finishedjunior', u'finished junior'), (u'FIynn', u'Flynn'), (u'flll', u'fill'), (u'flra', u'fira'), (u'Flylng', u'Flying'), (u'Fnends', u'Fiends'), (u'fo/low', u'follow'), (u'fonzvard', u'forward'), (u'fora', u'for a'), (u'Fora', u'For a'), (u'forajob', u'for a job'), (u'forAmerica', u'for America'), (u'forNew', u'for New'), (u'forone', u'for one'), (u'forso', u'for so'), (u'Forsuch', u'For such'), (u'forsunburns', u'for sunburns'), (u'forthe', u'for the'), (u'Foryears', u'For years'), (u'foryou', u'for you'), (u'Foudeen', u'Fouteen'), (u'Fou\ufb02een', u'Fourteen'), (u'FourSeasons', u'Four Seasons'), (u'fr/ends', u'friends'), (u'freezerfood', u'freezer food'), (u'F\xfchrerfeels', u'F\xfchrer feels'), (u'furthernotice', u'further notice'), (u'furyou', u'for you'), (u'G0', u'Go'), (u'g0in9', u'going'), (u'gamlenias', u'gardenias'), (u'GAsPING', u'GASPING'), (u'gc', u'go'), (u'gcing', u'going'), (u'gcnna', u'gonna'), (u'Gcnna', u'Gonna'), (u'gct', u'get'), (u'Gct', u'Got'), (u'genercsity', u'generosity'), (u'generosityn', u'generosity"'), (u'getjust', u'get just'), (u'g\ufb02ing', u'going'), (u'gi\ufb02friend', u'girlfriend'), (u'gir/', u'girl'), (u"gir/s'boarding", u"girls' boarding"), (u'giris', u'girls'), (u'gLlyS', u'guys'), (u'glum_', u'glum.'), (u'gnyone', u'anyone'), (u'golng', u'going'), (u'goodboyand', u'good boy and'), (u'goodjob', u'good job'), (u'gOt', u'got'), (u'gotjumped', u'got jumped'), (u'gotmyfirstinterview', u'got my first interview'), (u'grandjury', u'grand jury'), (u'greatjob', u'great job'), (u'Greatjobl', u'Great job!'), (u'grinco', u'gringo'), (u'GRoANING', u'GROANING'), (u'GRUNUNG', u'GRUNTING'), (u'gu', u'go'), (u'gunna', u'gonna'), (u'guyjumped', u'guy jumped'), (u'guyjust', u'guy just'), (u'gUyS', u'guys'), (u'_H6Y-', u'- Hey!'), (u'H\u20acY', u'Hey'), (u'H0we\xb7ver', u'However'), (u'halftheir', u'half their'), (u'hapPY', u'happy'), (u'hasrt', u"hasn't"), (u'Hasrt', u"Hasn't"), (u"haven'tspokerl", u"haven't spoken"), (u'hcle', u'hole'), (u'hcme', u'home'), (u'hcmes', u'homes'), (u'hcpe', u'hope'), (u'hctel', u'hotel'), (u'hcurs', u'hours'), (u'Hcw', u'How'), (u'he/ps', u'helps'), (u'hearjokestonight', u'hear jokes tonight'), (u'hearme', u'hear me'), (u'Hefell', u'He fell'), (u"he'II", u"he'll"), (u"He'II", u"He'll"), (u'HeII0', u'Hello'), (u"He'Il", u"He'll"), (u'Hejust', u'He just'), (u"He'lI", u"He'll"), (u'HelIo', u'Hello'), (u'hellc', u'hello'), (u'HellO', u'Hello'), (u'herboyfr/end', u'her boyfriend'), (u'herflesh', u'her flesh'), (u'herfollov\\/ed', u'her followed'), (u'herjob_', u'her job.'), (u'HerrSchmidt', u'Herr Schmidt'), (u'herwith', u'her with'), (u'HeY\xb7', u'Hey.'), (u'HeyJennifer', u'Hey Jennifer'), (u'hiddsn', u'hidden'), (u'hisjunk', u'his junk'), (u'Hitlershare', u'Hitler share'), (u'Hlneed', u"I'll need"), (u'Hnally', u'finally'), (u'Hnishing', u'finishing'), (u'HOId', u'Hold'), (u'hOIes', u'holes'), (u'HONMNG', u'HONKING'), (u'honorthe', u'honor the'), (u'honoryou', u'honor you'), (u'honoryour', u'honor your'), (u"Hov\\/'s", u"How's"), (u"Hov\\/'S", u"How's"), (u'HovvLING', u'HOWLING'), (u'howit', u'how it'), (u"HoW's", u"How's"), (u'howto', u'how to'), (u"Hs's", u"He's"), (u'hurtyou', u'hurt you'), (u'I/erilj/', u'verify'), (u'I/fe', u'life'), (u'I\\/I', u'M'), (u'I\\/Ian', u'Man'), (u'I\\/Iathies', u'Mathies'), (u'I\\/Ie', u'Me'), (u'I\\/Iommy', u'Mommy'), (u'I\\/Ir', u'Mr'), (u'I\\/Ir.', u'Mr.'), (u'I\\/ly', u'My'), (u'I3EEPING', u'BEEPING'), (u'I3LARING', u'BLARING'), (u'Iacings', u'lacings'), (u'Iaid', u'laid'), (u'Iam', u'I am'), (u'Iand', u'land'), (u'Ianding', u'landing'), (u'Iast', u'last'), (u'Iate', u'late'), (u'Icad', u'load'), (u'Icading', u'loading'), (u'Ican', u'I can'), (u'Iccked', u'locked'), (u'Icng', u'long'), (u'Icsing', u'losing'), (u'Icslng', u'losing'), (u'Idid', u'I did'), (u"Ididn't", u"I didn't"), (u'Ido', u'I do'), (u"Idon'i", u"I don't"), (u"Idon't", u"I don't"), (u"Idon'tthink", u"I don't think"), (u"I'E'$", u"It's"), (u'Ieamed', u'learned'), (u'Ieapt', u'leapt'), (u'Iearned', u'learned'), (u'Ieast', u'least'), (u'Ieave', u'leave'), (u'Ied', u'led'), (u'Ieft', u'left'), (u"Ieg's", u"leg's"), (u'Iess', u'less'), (u'Iet', u'let'), (u"Iet's", u"let's"), (u"Iet'sjust", u"let's just"), (u'if/just', u'if I just'), (u'Ifear', u'I fear'), (u'Ifeared', u'I feared'), (u'Ifeel', u'I feel'), (u"ifI'||", u"if I'll"), (u"ifI'd", u"if I'd"), (u"ifI'II", u"if I'll"), (u"ifI'll", u"if I'll"), (u"ifI'm", u"if I'm"), (u'Ifinally', u'I finally'), (u"ifI've", u"if I've"), (u'ifl', u'if I'), (u'Iforgot', u'I forgot'), (u'Ifound', u'I found'), (u'ifshe', u'if she'), (u"ifthat's", u"if that's"), (u'ifthe', u'if the'), (u'Ifthe', u'If the'), (u"ifthere's", u"if there's"), (u'Ifthey', u'If they'), (u'ifwe', u'if we'), (u'Ifwe', u'If we'), (u'Ifycu', u'If you'), (u'ifyou', u'if you'), (u'Ifyou', u'If you'), (u'ifyuu', u'if you'), (u'Iget', u'I get'), (u'Igot', u'I got'), (u'Igotta', u'I gotta'), (u'Igotyou', u'I got you'), (u'Iguess', u'I guess'), (u'Iguessljust', u'I guess I just'), (u'Ihad', u'I had'), (u"Ihat's", u"that's"), (u'Ihave', u'I have'), (u'Iheard', u'I heard'), (u"ihere's", u"there's"), (u"ihey've", u"they've"), (u'Ihope', u'I hope'), (u'ii/Iary', u'Mary'), (u'ii/Ir', u'Mr'), (u'ii/Ir.', u'Mr.'), (u'ii/love', u'Move'), (u'Iife', u'life'), (u"I'II", u"I'll"), (u'Iike', u'like'), (u"I'Il", u"I'll"), (u'Iine', u'line'), (u'iirst', u'first'), (u"ii's", u"it's"), (u"Ii's", u"It's"), (u'Iiterallyjumped', u'literally jumped'), (u'Ijoined', u'I joined'), (u'Ijust', u'I just'), (u'Iknew', u'I knew'), (u'Iknow', u'I know'), (u'Ile', u'lie'), (u'Ileft', u'I left'), (u"I'lldo", u"I'll do"), (u"I'llmake", u"I'll make"), (u'Ilons', u'lions'), (u'Ilove', u'I love'), (u"I'mjust", u"I'm just"), (u'Inconceivablel', u'Inconceivable!'), (u'infact', u'in fact'), (u'Infact', u'In fact'), (u'in\ufb02uence', u'influence'), (u'infront', u'in front'), (u'injust', u'in just'), (u'insc\ufb01p\ufb01ons', u'inscriptions'), (u'insolencel', u'insolence!'), (u'intc', u'into'), (u'internationaljudges', u'international judges'), (u'inthe', u'in the'), (u'Iockdown', u'lockdown'), (u'Iong', u'long'), (u'Iongships', u'longships'), (u'Iook', u'look'), (u'Iookjust', u'look just'), (u'Iooklng', u'looking'), (u'Iooks', u'looks'), (u'Ioose', u'loose'), (u"Iord's", u"lord's"), (u'Iose', u'lose'), (u'Ioser', u'loser'), (u'Ioss', u'loss'), (u'Iost', u'lost'), (u'Iot', u'lot'), (u"Iot's", u"lot's"), (u'Iousyjob', u'lousy job'), (u'Iove', u'love'), (u'Ioves', u'loves'), (u'Iowlife', u'lowlife'), (u'Ipaid', u'I paid'), (u'Iquit', u'I quit'), (u'Ireallythinkthis', u'I really think this'), (u"I'rn", u"I'm"), (u'Isaw', u'I saw'), (u'Isayt/1e', u'I say the'), (u'isjust', u'is just'), (u"isn'i", u"isn't"), (u"isn't_", u"isn't."), (u'Isthis', u'Is this'), (u'Istill', u'I still'), (u'Istumblod', u'I stumbled'), (u'Itake', u'I take'), (u'itdown', u'it down'), (u'Iteach', u'I teach'), (u'Itfeels', u'It feels'), (u'ithave', u'it have'), (u'Ithink', u'I think'), (u'Ithinkthat', u'I think that'), (u'Ithinkthis', u'I think this'), (u"Ithinkyou're", u"I think you're"), (u'Ithlnk', u'I think'), (u'Ithoguht', u'I thought'), (u'Ithought', u'I thought'), (u'Ithoughtl', u'I thought I'), (u"it'II", u"it'll"), (u"It'II", u"It'll"), (u"it'Il", u"it'll"), (u"It'Il", u"It'll"), (u'itin', u'it in'), (u'itjust', u'it just'), (u'Itjust', u'It just'), (u"it'lI", u"it'll"), (u"It'lI", u"It'll"), (u"It'llhappen", u"It'll happen"), (u"it'lljust", u"it'll just"), (u'Itold', u'I told'), (u'Itook', u'I took'), (u'itout', u'it out'), (u"it'S", u"it's"), (u"it'sjinxed", u"it's jinxed"), (u"it'sjust", u"it's just"), (u"It'sjust", u"It's just"), (u'itso', u'it so'), (u'Ittends', u'It tends'), (u"Itwasn't", u"It wasn't"), (u'Iuckier', u'luckier'), (u'IV|oney', u'Money'), (u"IV|oney's", u"Money's"), (u"I'va", u"I've"), (u"I'Ve", u"I've"), (u'IVIan', u'Man'), (u'IVIAN', u'MAN'), (u'IVIarch', u'March'), (u"IVIarci's", u"Marci's"), (u'IVIarko', u'Marko'), (u'IVIe', u'Me'), (u"IVIine's", u"Mine's"), (u'IVImm', u'Mmm'), (u'IVIoney', u'Money'), (u'IVIr.', u'Mr.'), (u'IVIrs', u'Mrs'), (u'IVIuch', u'Much'), (u'IVIust', u'Must'), (u'IVIy', u'My'), (u'IVlacArthur', u'MacArthur'), (u"IVlacArthur's", u"MacArthur's"), (u'IVlcBride', u'McBride'), (u'IVlore', u'More'), (u'IVlotherfucker_', u'Motherfucker.'), (u'IVlr', u'Mr'), (u'IVlr.', u'Mr.'), (u'IVlr_', u'Mr.'), (u'IVlust', u'Must'), (u'IVly', u'My'), (u'Iwake', u'I wake'), (u'Iwant', u'I want'), (u'Iwanted', u'I wanted'), (u'Iwas', u'I was'), (u'Iwasjust', u'I was just'), (u'Iwasjustu', u'I was just...'), (u'Iwill', u'I will'), (u'Iwish', u'I wish'), (u"Iwon't", u"I won't"), (u'Iworked', u'I worked'), (u'Iwould', u'I would'), (u'jalapeno', u'jalape\xf1o'), (u'Jaokson', u'Jackson'), (u'Jascn', u'Jason'), (u'jcke', u'joke'), (u'jennifer', u'Jennifer'), (u'joseph', u'Joseph'), (u'jsut', u'just'), (u'Jumpthem', u'Jump them'), (u'jusi', u'just'), (u'jusl', u'just'), (u'justjudge', u'just judge'), (u'justleave', u'just leave'), (u'Justletgo', u'Just let go'), (u'kidsjumped', u'kids jumped'), (u'kiokflip', u'kickflip'), (u'knowjust', u'know just'), (u'knowthat', u'know that'), (u'knowthis', u'know this'), (u'knowwhat', u'know what'), (u'knowyet', u'know yet'), (u'knowyourlove', u'know your love'), (u'korean', u'Korean'), (u'L/ght', u'Light'), (u'L/kes', u'Likes'), (u'L\\/Ianuela', u'Manuela'), (u'L\\/Ianuelal', u'Manuela!'), (u'l\\/Iauzard', u'Mauzard'), (u'l\\/I\xe9lanie', u'M\xe9lanie'), (u'L\\/I\xe9lanie', u'M\xe9lanie'), (u'l\\/Iom', u'Mom'), (u'l\\/Iommy', u'Mommy'), (u'l\\/Ir', u'Mr'), (u'l\\/Ir.', u'Mr.'), (u'l\\/Is', u'Ms'), (u'l\\/ly', u'My'), (u'l_AuGHING', u'LAUGHING'), (u'l\u2018m', u"I'm"), (u'Laml6', u'I am l6'), (u'Lcad', u'Load'), (u'lcan', u'I can'), (u"lcan't", u"I can't"), (u"lcarl't_", u"I can't."), (u'Lcve', u'Love'), (u"l'd", u"I'd"), (u"L'd", u"I'd"), (u'ldid', u'I did'), (u'Ldid', u'I did'), (u'ldiot', u'Idiot'), (u"L'djump", u"I'd jump"), (u"ldon't", u"I don't"), (u"Ldon't", u"I don't"), (u'Lefs', u"Let's"), (u"Let'sjust", u"Let's just"), (u'lf', u'if'), (u'Lf', u'If'), (u'lfeelonelung', u'I feel one lung'), (u'lfthey', u'if they'), (u'lfyou', u'If you'), (u'Lfyou', u'If you'), (u"lfyou're", u"If you're"), (u'lget', u'I get'), (u'lgive', u'I give'), (u'Li/0/Academy', u'Lilly Academy'), (u'li/lr.', u'Mr.'), (u'ligature___', u'ligature...'), (u"l'II", u"I'll"), (u"l'Il", u"I'll"), (u'ljust', u'I just'), (u'Ljust', u'I just'), (u"ll/Iommy's", u"Mommy's"), (u'll/lajor', u'Major'), (u'Ll/lajor', u'Major'), (u'll/layans', u'Mayans'), (u"l'lI", u"I'll"), (u"l'll", u"I'll"), (u"L'll", u"I'll"), (u"l'lljust", u"I'll just"), (u"L'lltake", u"I'll take"), (u'llte', u'lite'), (u"l'm", u"I'm"), (u"L'm", u"I'm"), (u'Lmean', u'I mean'), (u"l'mjust", u"I'm just"), (u'ln', u'In'), (u'lN', u'IN'), (u'lNAuDll3LE', u'INAUDIBLE'), (u'LNAuDll3LE', u'INAUDIBLE'), (u'LNDlsTINcT', u'INDISTINCT'), (u'lneed', u'I need'), (u'lostyou', u'lost you'), (u'Loudmusic', u'Loud music'), (u'lraq', u'Iraq'), (u"lRA's", u"IRA's"), (u'Lrenka', u'Irenka'), (u'Lrn', u"I'm"), (u'lRS', u'IRS'), (u'lsabella', u'Isabella'), (u"lsn't", u"isn't"), (u"Lsn't", u"Isn't"), (u"Lst's", u"Let's"), (u'lsuppose', u'I suppose'), (u'lt', u'It'), (u'ltake', u'I take'), (u'ltell', u'I tell'), (u'lthink', u'I think'), (u'Lthink', u'I think'), (u'lthink___', u'I think...'), (u"lt'II", u"It'll"), (u"lt'Il", u"It'll"), (u'ltjammed_', u'It jammed.'), (u"lt'll", u"It'll"), (u'ltold', u'I told'), (u"lt's", u"It's"), (u"lT'S", u"IT'S"), (u"Lt'S", u"It's"), (u"Lt'sjust", u"It's just"), (u"lv\\/asn't", u"I wasn't"), (u"l've", u"I've"), (u"L've", u"I've"), (u'lVIan', u'Man'), (u'lVIcHenry', u'McHenry'), (u'lVIr.', u'Mr.'), (u'lVlacArthur', u'MacArthur'), (u'LVlore', u'More'), (u'lVlr', u'Mr'), (u'lVlr.', u'Mr.'), (u'lvluslc', u'MUSIC'), (u'lVlust', u'Must'), (u'LVly', u'Lily'), (u'lwaited', u'I waited'), (u'lwamoto', u'Iwamoto'), (u'lwant', u'I want'), (u'lwanted', u'I wanted'), (u'lwas', u'I was'), (u'lwill', u'I will'), (u"lwon't", u"I won't"), (u'lworked', u'I worked'), (u'lwould', u'I would'), (u"lwould've", u"I would've"), (u'lx/Iorning', u'Morning'), (u'M/dd/e', u'Middle'), (u'm/g/7ty', u'mighty'), (u'MACH/NE', u'MACHINE'), (u'MacKenz/e', u'MacKenzie'), (u'majorjackpot', u'major jackpot'), (u'majormuscle', u'major muscle'), (u'Manuela_', u'Manuela.'), (u'maste/y', u'mastery'), (u'Masturhate', u'Masturbate'), (u'Mattei_', u'Mattei.'), (u'mayjust', u'may just'), (u'mbecause', u'"because'), (u'McCa/Iister', u'McCallister'), (u'McCallisler', u'McCallister'), (u'Mccallister', u'McCallister'), (u'Mccallisters', u'McCallisters'), (u"mcm's", u"mom's"), (u'mcney', u'money'), (u'mcral', u'moral'), (u'mcre', u'more'), (u'mcve', u'move'), (u'mejust', u'me just'), (u'Mexioo', u'Mexico'), (u'mi//<', u'milk'), (u'misfartune', u'misfortune'), (u'Ml6', u'MI6'), (u'Mlnd', u'Mind'), (u"Mock/'ngbl'rd", u'Mockingbird'), (u"mOI'\u20ac", u'more'), (u'Mom_', u'Mom.'), (u'monkeyback', u'monkey back'), (u'move___l', u'move... I'), (u'moveto', u'move to'), (u'mustknock', u'must knock'), (u'Myheart', u'My heart'), (u'myjch', u'my job'), (u'myjet', u'my jet'), (u'myjob', u'my job'), (u'Myjob', u'My job'), (u"myjob's", u"my job's"), (u'mylife', u'my life'), (u'Mynew', u'My new'), (u'myown', u'my own'), (u'mypants', u'my pants'), (u'myselli', u'myself'), (u'Myshoes', u'My shoes'), (u'mysong', u'my song'), (u'mytemper', u'my temper'), (u'mythumb', u'my thumb'), (u'Myworld', u'My world'), (u'N0', u'No'), (u'narne', u'name'), (u'Natians', u'Nations'), (u'naTve', u'naive'), (u'nc', u'no'), (u'Nc', u'No'), (u'ncne', u'none'), (u'Ncrth', u'North'), (u'ncw', u'new'), (u'Ncw', u'Now'), (u'needyou', u'need you'), (u'neighboun', u'neighbour'), (u'neverfound', u'never found'), (u'neverthere', u'never there'), (u'neverv\\/ill_', u'never will.'), (u'NewJersey', u'New Jersey'), (u'newjob', u'new job'), (u'newjobs', u'new jobs'), (u'nextdoor', u'next door'), (u'Nighw', u'Nighty'), (u'nilios', u'ni\xf1os'), (u'Nlagnificence', u'Magnificence'), (u'Nlakes', u'Makes'), (u'Nlalina', u'Malina'), (u'Nlan', u'Man'), (u'Nlarch', u'March'), (u'Nlarine', u'Marine'), (u'Nlarion', u'Marion'), (u'Nlarry', u'Marry'), (u'Nlars', u'Mars'), (u'Nlarty', u'Marty'), (u'Nle', u'Me'), (u'Nleet', u'Meet'), (u'Nlen', u'Men'), (u'Nlom', u'Mom'), (u'Nlore', u'More'), (u'Nlornin', u'Mornin'), (u'Nlother', u'Mother'), (u'Nlr', u'Mr'), (u'Nlr.', u'Mr.'), (u'Nlrs', u'Mrs'), (u'Nluch', u'Much'), (u'nojurisdiction', u'no jurisdiction'), (u'noone', u'no one'), (u'Noone', u'No one'), (u'not judging', u'not judging'), (u'notgoing', u'not going'), (u'notjunk', u'not junk'), (u'Notjunk', u'Not junk'), (u'notjust', u'not just'), (u'notsure', u'not sure'), (u'novv', u'now'), (u'Nowjust', u'Now just'), (u"Nowthat's", u"Now that's"), (u'Numbertwo', u'Number two'), (u"oan't", u"can't"), (u"oan'tjust", u"can't just"), (u'objecl', u'object'), (u'occultpowerand', u'occult power and'), (u'Ocps', u'Oops'), (u'ofa', u'of a'), (u'ofajudge', u'of a judge'), (u'ofall', u'of all'), (u'Ofall', u'Of all'), (u'ofBedford', u'of Bedford'), (u'ofcourse', u'of course'), (u'Ofcourse', u'Of course'), (u'ofeach', u'of each'), (u'ofeither', u'of either'), (u"Offioer's", u"Officer's"), (u'ofFrance', u'of France'), (u'offreedom', u'of freedom'), (u'offthe', u'off the'), (u'offthis', u'off this'), (u'offto', u'off to'), (u'offun', u'of fun'), (u'ofguy', u'of guy'), (u'Ofhce', u'Office'), (u'ofhis', u'of his'), (u'ofHis', u'of His'), (u'ofhoneybees', u'of honeybees'), (u'ofit', u'of it'), (u'ofjam', u'of jam'), (u'OFJOAN', u'OF JOAN'), (u'ofjoy', u'of joy'), (u'ofjunior', u'of junior'), (u'ofme', u'of me'), (u'ofmead', u'of mead'), (u'ofmicroinjections', u'of microinjections'), (u'ofmy', u'of my'), (u'ofNew', u'of New'), (u"ofNorris'", u"of Norris'"), (u'ofopinions', u'of opinions'), (u'ofour', u'of our'), (u'ofpeopla', u'of people'), (u'ofthat', u'of that'), (u'ofthe', u'of the'), (u'Ofthe', u'Of the'), (u'oftheir', u'of their'), (u'ofthem', u'of them'), (u"ofthem's", u"of them's"), (u'ofthemselves', u'of themselves'), (u'ofthere', u'of there'), (u'ofthese', u'of these'), (u'ofthings', u'of things'), (u'ofthis', u'of this'), (u'ofthlngs', u'of things'), (u'ofthose', u'of those'), (u'ofuse', u'of use'), (u'ofwashington', u'of Washington'), (u'ofyou', u'of you'), (u'ofyour', u'of your'), (u'OId', u'Old'), (u'OIsson', u'Olsson'), (u'Ok3Y', u'Okay'), (u'okaY', u'okay'), (u'OkaY', u'Okay'), (u'OKaY', u'Okay'), (u'OKGY', u'Okay'), (u'Ol<', u'Ole'), (u'oldAdolfon', u'old Adolf on'), (u'onboard', u'on board'), (u'onIy', u'only'), (u'onIything', u'only thing'), (u'onJanuaw', u'on January'), (u'onlyjust', u'only just'), (u'Onyinal', u'Original'), (u'oomprise', u'comprise'), (u'oonstitution', u'constitution'), (u"oouldn't", u"couldn't"), (u"oould've", u"could've"), (u"oousin's", u"cousin's"), (u'opiimistically', u'optimistically'), (u'ora', u'or a'), (u'orfall', u'or fall'), (u'orglory', u'or glory'), (u'orjust', u'or just'), (u'Orjust', u'Or just'), (u'Orthat', u'Or that'), (u'orwould', u'or would'), (u'Orwould', u'Or would'), (u'Othenzvise', u'Otherwise'), (u'our joumey', u'our journey'), (u'ourbrave', u'our brave'), (u'ourfathers', u'our fathers'), (u'ourgirlon', u'our girl on'), (u'Ourgoal', u'Our goal'), (u'Ourguy', u'Our guy'), (u"ourj0b's", u"our job's"), (u"Ourj0b's", u"Our job's"), (u'ourjobs', u'our jobs'), (u"ourjob's", u"our job's"), (u"Ourjob's", u"Our job's"), (u'ourjoumey', u'our journey'), (u'ourphotos', u'our photos'), (u'ourv\\/ay', u'our way'), (u"outlool<'s", u"outlook's"), (u'overme', u'over me'), (u'overthe', u'over the'), (u'overthere', u'over there'), (u'p/ace', u'place'), (u'P/ease', u'Please'), (u'p_m_', u'p.m.'), (u'P\xb0P$', u'Pops'), (u'PANUNG', u'PANTING'), (u'pclnt', u'point'), (u'pclnts', u'points'), (u'pe0pIe', u'people'), (u'Perrut_', u'Perrut.'), (u'Persona/4/', u'Personally'), (u'Persona/y', u'Personally'), (u'persors', u"person's"), (u'PIain', u'Plain'), (u'PIease', u'Please'), (u'PIeasure', u'Pleasure'), (u'PIus', u'Plus'), (u'pleasurlng', u'pleasuring'), (u'POIe', u'Pole'), (u'Polynes/ans', u'Polynesians'), (u'poorshowing', u'poor showing'), (u'popsicle', u'Popsicle'), (u'Presidenfs', u"President's"), (u'probablyjust', u'probably just'), (u'puIIing', u'pulling'), (u'Putyourhand', u'Put your hand'), (u'Qh', u'Oh'), (u'QkaY', u'Okay'), (u'Qpen', u'Open'), (u'QUYS', u'GUYS'), (u'_QW', u'Aw'), (u'r/ght', u'right'), (u'ralnbow', u'rainbow'), (u'ratherjump', u'rather jump'), (u'ratherjust', u'rather just'), (u'Rcque', u'Roque'), (u'rcscucd', u'rescued'), (u'rea/', u'real'), (u'readytolaunchu', u'ready to launch...'), (u'reaHy', u'really'), (u'ReaHy', u'Really'), (u'reallyjust', u'really just'), (u'reallymiss', u'really miss'), (u'reallytalked', u'really talked'), (u'reallythink', u'really think'), (u'reallythinkthis', u'really think this'), (u'rememberthem', u'remember them'), (u'reoalibrated', u'recalibrated'), (u'retum', u'return'), (u'rhfluence', u'influence'), (u'rightdown', u'right down'), (u'roadyou', u'road you'), (u'RUMBUNG', u'RUMBLING'), (u's/uggikh', u'sluggish'), (u'S0', u'So'), (u'S1oW1y', u'Slowly'), (u'saidyou', u'said you'), (u"sayeverything's", u"say everything's"), (u'saynothing', u'say nothing'), (u'saythat', u'say that'), (u'sc', u'so'), (u'scientihc', u'scientific'), (u'SCREAIVHNG', u'SCREAMING'), (u'sCREAlvllNG', u'SCREAMING'), (u'SCREAlvllNG', u'SCREAMING'), (u'scund', u'sound'), (u"S'EOp", u'Stop'), (u'severa/parents', u'several parents'), (u'sfill', u'still'), (u'S\ufb02ence', u'Silence'), (u'shallrise', u'shall rise'), (u'sHATTERING', u'SHATTERING'), (u'shcws', u'shows'), (u'Shdsjust', u"She's just"), (u'She`s', u"She's"), (u'She\u2018II', u"She'll"), (u"she'II", u"she'll"), (u"She'II", u"She'll"), (u"she'Il", u"she'll"), (u'Shejust', u'She just'), (u"she'lI", u"she'll"), (u'Shoofing', u'Shooting'), (u'ShOp', u'shop'), (u'shortyears', u'short years'), (u'shou/dn', u'shouldn\u2019t'), (u'shou\ufb01ng', u'shouting'), (u'Shou\ufb02ng', u'Shouting'), (u'shouldnt', u"shouldn't"), (u'Shouldrt', u"Shouldn't"), (u'shouldrt', u"shouldn't"), (u"Shs's", u"She's"), (u'SHUDDERWG', u'SHUDDERING'), (u'Shutup', u'Shut up'), (u'SIGH$', u'SIGHS'), (u'signifcance', u'significance'), (u'Sincc', u'Since'), (u'sistervvill', u'sister will'), (u'Skarsg\xe9rd', u'Skarsg\xe5rd'), (u'slcsHs', u'SIGHS'), (u'slGHINcs', u'SIGHING'), (u'slGHING', u'SIGHING'), (u'slNGING', u'SINGING'), (u'slzzLING', u'SIZZLING'), (u'smarfest', u'smartest'), (u'Smiih', u'Smith'), (u'so/id', u'solid'), (u'SoBl3lNG', u'SOBBING'), (u'soemtimes', u'sometimes'), (u'Sojust', u'So just'), (u'soldierl', u'soldier!'), (u'somethlng', u'something'), (u"somethlng's", u"something's"), (u"somez'/7/ng", u'something'), (u'somthing', u'something'), (u'sumthing', u'something'), (u'sou/', u'soul'), (u'SoundofMusic', u'Sound of Music'), (u'SP/ash', u'Splash'), (u'SPEAK/NG', u'SPEAKING'), (u'speII', u'spell'), (u"speII's", u"spell's"), (u'Spendourtime', u'Spend our time'), (u'sQUA\\/\\/KING', u'SQUAWKING'), (u'StAnton', u'St Anton'), (u'stealsjeans', u'steals jeans'), (u'StilI', u'Still'), (u'Stilldesperatelyseeking', u'Still desperately seeking'), (u'stlll', u'still'), (u'sToPs', u'STOPS'), (u'storyl', u'story!'), (u'Stubbom', u'Stubborn'), (u'su/faces', u'surfaces'), (u'suffocaiing', u'suffocating'), (u'summerjob', u'summer job'), (u'Summerjust', u'Summer just'), (u'sun/ive', u'survive'), (u'superiorman', u'superior man'), (u'sur\ufb02aces', u'surfaces'), (u't/ying', u'trying'), (u'T0', u'To'), (u'T00', u'Too'), (u'ta/ks', u'talks'), (u'taiked', u'talked'), (u'talkto', u'talk to'), (u'Talkto', u'Talk to'), (u'talktonight', u'talk tonight'), (u'tampax', u'Tampax'), (u'tc', u'to'), (u'tcday', u'today'), (u'tcrturing', u'torturing'), (u'tcuch', u'touch'), (u'te//', u'tell'), (u'tearjust', u'tear just'), (u'tellsjokes', u'tells jokes'), (u'tellyou', u'tell you'), (u'terriers_', u'terriers.'), (u'th/nk', u'think'), (u'THEPASSION', u'THE PASSION'), (u'thafs', u"that's"), (u'Thafs', u"That's"), (u"Thai's", u"That's"), (u"Thal's", u"That's"), (u'thankyou', u'thank you'), (u'Thankyou', u'Thank you'), (u'thatconverts', u'that converts'), (u'thatgoes', u'that goes'), (u"that'II", u"that'll"), (u"That'II", u"That'll"), (u'thatjob', u'that job'), (u'thatjunk', u'that junk'), (u'thatjust', u'that just'), (u'thatleads', u'that leads'), (u"Thatl'm", u"That I'm"), (u"that's just", u"that's just"), (u'Thatsand', u'That sand'), (u"that'sjust", u"that's just"), (u"That'sjust", u"That's just"), (u'Thc', u'The'), (u'theirface', u'their face'), (u'theirfeet', u'their feet'), (u'theirfury', u'their fury'), (u'thejaw', u'the jaw'), (u'thejoint', u'the joint'), (u'thejudge', u'the judge'), (u'thejudges', u'the judges'), (u'Thejudges', u'The judges'), (u'thejury', u'the jury'), (u'Thelook', u'The look'), (u'Therds', u"There's"), (u"There'II", u"There'll"), (u"There'Il", u"There'll"), (u"There'lI", u"There'll"), (u"They'/'e", u"They're"), (u"they/'II", u"they'll"), (u'They/re', u"They're"), (u"They/'re", u"They're"), (u"they'II", u"they'll"), (u"they'Il", u"they'll"), (u'theyjust', u'they just'), (u'Theyjust', u'They just'), (u"they'lI", u"they'll"), (u"They'lI", u"They'll"), (u'theyre', u"they're"), (u'theysay', u'they say'), (u'thinkthat', u'think that'), (u"this'II", u"this'll"), (u'thlngs', u'things'), (u'Thlnkthls', u'Think this'), (u'thls', u'this'), (u"thore's", u"there's"), (u"Thore's", u"There's"), (u'Thorjust', u'Thor just'), (u"thoughtl'dletyou", u"thought I'd let you"), (u'tnatjust', u'that just'), (u"tnat's", u"that's"), (u"Tnat's", u"That's"), (u"Tnere'll", u"There'll"), (u'to//et', u'toilet'), (u'To//S', u'Tolls'), (u"todayl'd", u"today I'd"), (u'togelher', u'together'), (u'togethen', u'together'), (u'tojoin', u'to join'), (u'tojudge', u'to judge'), (u'toldyou', u'told you'), (u'tomorrovv', u'tomorrow'), (u'Tonighfsjust', u"Tonight's just"), (u'totake', u'to take'), (u'totalk', u'to talk'), (u'tothat', u'to that'), (u'tothe', u'to the'), (u'Towef', u'Tower'), (u'Tr/ck/ing', u'Trickling'), (u'Traitur', u'Traitor'), (u'tv\\/o', u'two'), (u'tvvelve', u'twelve'), (u'Tvvelve', u'Twelve'), (u'tvventy', u'tvventy'), (u'Tvventy', u'Tvventy'), (u'tvvo', u'two'), (u'Tvvo', u'Two'), (u'twc', u'two'), (u'unconhrmed', u'unconfirmed'), (u'underthat', u'under that'), (u'underthe', u'under the'), (u'underthese', u'under these'), (u'underyour', u'under your'), (u'unfilyou', u'until you'), (u"Unfon'unate/y", u'Unfortunately'), (u'Uninnabited', u'Uninhabited'), (u'untilApril', u'until April'), (u'untilyou', u'until you'), (u'upthinking', u'up thinking'), (u'upto', u'up to'), (u'V\\/ait___', u'Wait...'), (u'v\\/as', u'was'), (u'V\\/as', u'Was'), (u'V\\/e', u'We'), (u"v\\/eek's", u"week's"), (u'V\\/eird_', u'Weird.'), (u'V\\/ell', u'Well'), (u'V\\/hat', u'what'), (u"V\\/hen'll", u"When'll"), (u'V\\/ho', u'Who'), (u"v\\/ho'll", u"who'll"), (u'v\\/Hoops', u'Whoops'), (u"v\\/ho's", u"who's"), (u"V\\/ho's", u"Who's"), (u'V\\/hy', u'Why'), (u'v\\/ith', u'with'), (u"v\\/on't", u"won't"), (u'V\\fith', u'With'), (u'V\\fithin', u'Within'), (u'valedictolian', u'valedictorian'), (u'vcice', u'voice'), (u've/y', u'very'), (u'veiy', u'very'), (u'V\xe9ry', u'Very'), (u'versioin', u'version'), (u'vi/ay', u'way'), (u'visitjails', u'visit jails'), (u"Viva/di's", u"Vivaldi's"), (u'vlll', u'vill'), (u'Voil\xe1', u'Voil\xe0'), (u'Voil\xe9', u'Voil\xe0'), (u'vvasjust', u'was just'), (u"VVasn't", u"Wasn't"), (u'vvay', u'way'), (u'VVe', u'We'), (u"VVe'II", u"We'll"), (u"VVe'll", u"We'll"), (u'Vvelooked', u'We looked'), (u"VVe're", u"We're"), (u"VVe've", u"We've"), (u'VVhat', u'What'), (u"VVhat's", u"What's"), (u"VVhat'S", u"What's"), (u'VVhen', u'When'), (u"'v'Vhere's", u"Where's"), (u'VVhip', u'Whip'), (u'vvHooPING', u'WHOOPING'), (u'VvHooPING', u'WHOOPING'), (u'VVhy', u'Why'), (u'VVill', u'Will'), (u'VVinters', u'Winters'), (u'vvlND', u'WIND'), (u"w\xa4n't", u"won't"), (u'W9', u'We'), (u'waht', u'want'), (u'waierfall', u'waterfall'), (u'walkjust', u'walk just'), (u'wallplant', u'wall plant'), (u'wannajump', u'wanna jump'), (u'wantyou', u'want you'), (u'Warcontinues', u'War continues'), (u'wasjennifer', u'was Jennifer'), (u'wasjust', u'was just'), (u'wasrt', u"wasn't"), (u'Wasrt', u"Wasn't"), (u'wayl', u'way I'), (u'wayround', u'way round'), (u'wclf', u'wolf'), (u'wcman', u'woman'), (u'wcmen', u'women'), (u"wcn't", u"won't"), (u'wcrse', u'worse'), (u'wculd', u'would'), (u'We//', u'Well'), (u'We/came', u'Welcome'), (u'we/come', u'welcome'), (u'We/come', u'Welcome'), (u'We/I', u'Well'), (u'weekendjust', u'weekend just'), (u'werert', u"weren't"), (u'Werert', u"Weren't"), (u"we'II", u"we'll"), (u"We'II", u"We'll"), (u"we'Il", u"we'll"), (u"We'Il", u"We'll"), (u'wejust', u'we just'), (u"we'lI", u"we'll"), (u"We'rejust", u"We're just"), (u"We'ro", u"We're"), (u"We'Ve", u"We've"), (u'wh/p', u'whip'), (u'Wh\xb0ops', u'Whoops'), (u'Whafs', u"What's"), (u'Whatam', u'What am'), (u'Whatare', u'What are'), (u'Whateverwe', u'Whatever we'), (u"What'II", u"What'll"), (u'Whatis', u'What is'), (u'whatjust', u'what just'), (u'Whatl', u'What I'), (u'whatshe', u'what she'), (u'whatwe', u'what we'), (u"Whc's", u"Who's"), (u'Whcse', u'Whose'), (u'wHlsPERs', u'WHISPERS'), (u'wi//', u'will'), (u'wil/', u'will'), (u'Wil/', u'Will'), (u'wilI', u'will'), (u'willbe', u'will be'), (u'willhire', u'will hire'), (u'willneverknow', u'will never know'), (u'willyou', u'will you'), (u'wlfe', u'wife'), (u"wlfe's", u"wife's"), (u'wlth', u'with'), (u"wnat's", u"what's"), (u'Wno', u'Who'), (u'Wo/f', u'Wolf'), (u'wo\ufb02d', u'world'), (u"WOI'1't", u"won't"), (u'wondernobody', u'wonder nobody'), (u"won'T", u"won't"), (u"won'tanswerme", u"won't answer me"), (u"won'tforget", u"won't forget"), (u"won'tletitbring", u"won't let it bring"), (u"Wo're", u"We're"), (u'worfd', u'world'), (u"won'th", u'worth'), (u"won'thwhile", u'worthwhile'), (u'workyou', u'work you'), (u"wouIdn't", u"wouldn't"), (u"wouldn'!", u"wouldn't"), (u'Wouldrt', u"Wouldn't"), (u"wr/'2'/ng", u'writing'), (u'writign', u'writing'), (u'wrcng', u'wrong'), (u'wuuld', u'would'), (u'_Yay', u'Yay'), (u"Y\xa4u'II", u"You'll"), (u"Y\xa4u'll", u"You'll"), (u"y\xa4u're", u"you're"), (u"Y\xa4u're", u"You're"), (u"y\xa4u've", u"you've"), (u'Y0', u'Yo'), (u'y0LI', u'you'), (u"y0u'II", u"you'll"), (u"Y0u'rc", u"You're"), (u"Y0u're", u"You're"), (u"Y0u've", u"You've"), (u'yaming', u'yarning'), (u'yaurparents', u'your parents'), (u'ycu', u'you'), (u"ycu'd", u"you'd"), (u'ycur', u'your'), (u"Ycu're", u"You're"), (u'Ycursins', u'Your sins'), (u'YEI_I_', u'YELL'), (u'YELL$', u'YELLS'), (u'yigg/mg', u'giggling'), (u'Yigg/mg', u'giggling'), (u'yoLI', u'you'), (u'yOu', u'you'), (u'yOU', u'you'), (u'you`re', u"you're"), (u"you'II", u"you'll"), (u"You'II", u"You'll"), (u"You'Il", u"You'll"), (u'youjack', u'you jack'), (u'youjoin', u'you join'), (u'Youjoin', u'You join'), (u'youjust', u'you just'), (u"You'lI", u"You'll"), (u'youngsterlike', u'youngster like'), (u'youpick', u'you pick'), (u"you'ra", u"you're"), (u'Yourattention', u'Your attention'), (u'yourautomobile', u'your automobile'), (u"You'rejustjealous", u"You're just jealous"), (u'yourextra', u'your extra'), (u'yourfather', u'your father'), (u'yourhand', u'your hand'), (u'yourhusband', u'your husband'), (u'yourjewelry', u'your jewelry'), (u'yourjob', u'your job'), (u'Yourjob', u'Your job'), (u'yourjob_', u'your job.'), (u'yourjockey', u'your jockey'), (u'yourjury', u'your jury'), (u'yourname', u'your name'), (u'Yourpackage', u'Your package'), (u'yourpackage', u'your package'), (u"you'ro", u"you're"), (u'yourpoorleg', u'your poor leg'), (u'yourvveak', u'your weak'), (u"you'va", u"you've"), (u"You'va", u"You've"), (u'youWlneversee', u"you'll never see"), (u'yQu', u'you'), (u'YQu', u'You'), (u"yQu'_7", u'you?'), (u'yummY', u'yummy'), (u'yuu', u'you'), (u'Yuu', u'You'), (u"Yuu've", u"You've"), (u"z'housand", u'thousand'), (u'zlPPING', u'ZIPPING'), (u'Ifslocked', u"It's locked"), (u'nightjust', u'night just'), (u'dayjourney', u'day journey'), (u'Ourjob', u'Our job'), (u'IunCh', u'lunch'), (u'nieCe', u'niece'), (u'giVes', u'gives'), (u'wantto', u'want to'), (u'besttoday', u'best today'), (u'NiCe', u'Nice'), (u'oftravelling', u'of travelling'), (u'oftwo', u'of two'), (u'ALl', u'ALI'), (u'afterparty', u'after-party'), (u'welL', u'well.'), (u'theirjob', u'their job'), (u"lfhe's", u"If he's"), (u'babyjesus', u'baby Jesus'), (u'shithousejohn', u'shithouse John'), (u'jesus', u'Jesus'), (u'withjesus', u'with Jesus'), (u'Gojoin', u'Go join'), (u'Adaughter', u'A daughter'), (u'talkwith', u'talk with'), (u'anyjournals', u'any journals'), (u"L'mjewish", u"I'm Jewish"), (u'arejust', u'are just'), (u'soundjust', u'sound just'), (u"ifl'm", u"if I'm"), (u'askyou', u'ask you'), (u'ordinarywoman', u'ordinary woman'), (u'andjunkies', u'and junkies'), (u'isjack', u'is Jack'), (u'helpyou', u'help you'), (u'thinkyou', u'think you'), (u'Lordjesus', u'Lord Jesus'), (u'injuvy', u'in juvy'), (u'thejets', u'the jets'), (u'ifGod', u'if God'), (u'againstjewish', u'against Jewish'), (u'ajunkie', u'a junkie'), (u'dearjesus', u'dear Jesus'), (u'hearyour', u'hear your'), (u'takeyears', u'take years'), (u'friendjean', u'friend Jean'), (u'Fatherjohn', u'Father John'), (u'youjean', u'you Jean'), (u'hearyou', u'hear you'), (u'Ifshe', u'If she'), (u"didn'tjust", u"didn't just"), (u'IfGod', u'If God'), (u'notjudge', u'not judge'), (u'andjudge', u'and judge'), (u'OKBY', u'Okay'), (u'myjourney', u'my journey'), (u'yourpremium', u'your premium'), (u"we'rejust", u"we're just"), (u'Iittlejokes', u'little jokes'), (u'Iifejust', u'life just'), (u'Andjust', u'And just'), (u'ofThe', u'of The'), (u'lifejust', u'life just'), (u'AIice', u'Alice'), (u'lnternationalAirport', u'International Airport'), (u'yourbody', u'your body'), (u'DollarBaby', u'Dollar Baby'), (u'ofjonesing', u'of jonesing'), (u'yourpanties', u'your panties'), (u'offforme', u'off for me'), (u'pantyparty', u'panty party'), (u'everhit', u'ever hit'), (u'theirhomes', u'their homes'), (u'AirForce', u'Air Force'), (u'yourhead', u'your head'), (u'betterbe', u'better be'), (u'myparty', u'my party'), (u'disasterlockdown', u'disaster lockdown'), (u"Ifpot's", u"If pot's"), (u'ifmy', u'if my'), (u'yourmoney', u'your money'), (u'Potterfan', u'Potter fan'), (u'Hermionejust', u'Hermione just'), (u'ofourshit', u'of our shit'), (u'showyou', u'show you'), (u'answernow', u'answer now'), (u'theirsjust', u'theirs just'), (u'BIackie', u'Blackie'), (u'SIeep', u'Sleep'), (u'foryour', u'for your'), (u'oryour', u'or your'), (u'forArthur', u'for Arthur'), (u'CIamp', u'Clamp'), (u'CIass', u'Class'), (u'CIose', u'Close'), (u'GIove', u'Glove'), (u'EIIen', u'Ellen'), (u'PIay', u'Play'), (u'PIace', u'Place'), (u'EIgyn', u'Elgyn'), (u'AIert', u'Alert'), (u'CIaus', u'Claus'), (u'CIimb', u'Climb'), (u"military'II", u"military'll"), (u'anylonget', u'any longer'), (u'yourlife', u'your life'), (u"Yourbitch'IIgetyou", u"Your bitch'll get you"), (u'yourdick', u'your dick'), (u'Tellyourbitch', u'Tell your bitch'), (u'rememberyou', u'remember you'), (u'newface', u'new face'), (u'Butyou', u'But you'), (u"don'tyou", u"don't you"), (u'yourlives', u'your lives'), (u'Iovedher', u'loved her'), (u'reallydid', u'really did'), (u'firstperson', u'first person'), (u'mybest', u'my best'), (u'Justgive', u'Just give'), (u'AIong', u'Along'), (u'atyourbody', u'at your body'), (u'myhands', u'my hands'), (u'sayhe', u'say he'), (u'mybooty', u'my booty'), (u'yourbooty', u'your booty'), (u'yourgirl', u'your girl'), (u'yourlegs', u'your legs'), (u'betterifthey', u'better if they'), (u'manybeautiful', u'many beautiful'), (u'contactpolice', u'contact police'), (u'numberbelow', u'number below'), (u'biggestproblem', u'biggest problem'), (u'Itgave', u'It gave'), (u'everybodykind', u'everybody kind'), (u'theyhad', u'they had'), (u'knowherlast', u'know her last'), (u'herhearing', u'her hearing'), (u'othermembers', u'other members'), (u'BIing', u'Bling'), (u'CIyde', u'Clyde'), (u'foundguilty', u'found guilty'), (u'fouryears', u'four years'), (u'countyjail', u'county jail'), (u'yearin', u'year in'), (u'theirrole', u'their role'), (u'manybottles', u'many bottles'), (u"can'tpronounce", u"can't pronounce"), (u'manybowls', u'many bowls'), (u'ofthatgreen', u'of that green'), (u'manyjoyrides', u'many joyrides'), (u'Superrich', u'Super rich'), (u'Iprefer', u'I prefer'), (u'Theymust', u'They must'), (u'whatyou', u'what you'), (u"I'IIjump", u"I'll jump"), (u'nobodyknow', u'nobody know'), (u'neverknew', u'never knew'), (u'EIectronica', u'Electronica'), (u'AIarm', u'Alarm'), (u'getyourman', u'get your man'), (u'sayyou', u'say you'), (u'getyour', u'get your'), (u'Fuckyou', u'Fuck you'), (u'Whyyou', u'Why you'), (u'butyoujust', u'but you just'), (u'forgetyourname', u'forget your name'), (u'Whatyou', u'What you'), (u"Co/'ncidenta//y", u'Coincidentally'), (u'GIad', u'Glad'), (u'RachelMarron', u'Rachel Marron'), (u"She'llgive", u"She'll give"), (u'presidentialsuite', u'presidential suite'), (u'andgentlemen', u'and gentlemen'), (u'willnot', u'will not'), (u'ourproducers', u'our producers'), (u"Ifshe's", u"If she's"), (u'CIock', u'Clock'), (u'Ishould', u'I should'), (u"I'llgo", u"I'll go"), (u'maypass', u'may pass'), (u'andprotecting', u'and protecting'), (u'BIessed', u'Blessed'), (u'CIean', u'Clean'), (u'SIave', u'Slave'), (u'AIi', u'Ali'), (u'AIIah', u'Allah'), (u'AIIahu', u'Allahu'), (u'CIick', u'Click'), (u'BIast', u'Blast'), (u'AIlah', u'Allah'), (u'SIow', u'Slow'), (u'theirpolicies', u'their policies'), (u'Orperhaps', u'Or perhaps'), (u'ofsex', u'of sex'), (u'forpleasure', u'for pleasure'), (u'ourpower', u'our power'), (u'Yourpiece', u'Your piece'), (u'Offioers', u'Officers'), (u'oondesoended', u'condescended'), (u'myseif', u'myself'), (u"let'sjust", u'let\u2019s just'), (u'yourway', u'your way'), (u'An9TY', u'Angry'), (u'ourjourney', u'our journey'), (u'LuCY', u'Lucy'), (u"\\'m", u'I\u2019m'), (u'CEDR/C', u'CEDRIC'), (u'lsaac', u'Isaac'), (u'FIy', u'Fly'), (u'Ionger', u'longer'), (u'Iousy', u'lousy'), (u'Iosing', u'losing'), (u"They'II", u"They'll"), (u'yourpaws', u'your paws'), (u'littie', u'little'), (u"It'lljust", u"It'll just"), (u'AIso', u'Also'), (u'Iisten', u'listen'), (u'suPPosed', u'supposed'), (u'somePIace', u'someplace'), (u'exPIain', u'explain'), (u'Iittle', u'little'), (u'StoP', u'Stop'), (u'AIways', u'Always'), (u'Iectures', u'lectures'), (u'Iow', u'low'), (u'Ieaving', u'leaving'), (u'Ietting', u'letting'), (u'Iistening', u'listening'), (u'Iecture', u'lecture'), (u'Iicking', u'licking'), (u'Iosses', u'losses'), (u'PIeased', u'Pleased'), (u'ofburglaries', u'of burglaries'), (u"He'sjust", u"He's just"), (u'mytrucktoo', u'my truck too'), (u'nowwhat', u'now what'), (u'yourfire', u'your fire'), (u"herwhat's", u"her what's"), (u'hearthat', u'hear that'), (u'oryou', u'or you'), (u'preferjournalist', u'prefer journalist'), (u'CIaw', u'Claw'), (u'Ifour', u'If our'), (u'lron', u'Iron'), (u"It'syour", u"It's your"), (u'lfstill', u'If still'), (u'forjoining', u'for joining'), (u'foryears', u'for years'), (u'Ifit', u'If it'), (u'notjump', u'not jump'), (u'ourproblem', u'our problem'), (u'yourprofile', u'your profile'), (u'ifJanine', u'if Janine'), (u'forpreventative', u'for preventative'), (u'whetherprotest', u'whether protest'), (u'Ifnot', u'If not'), (u'ourpeople', u'our people'), (u'offmy', u'off my'), (u'forproviding', u'for providing'), (u'hadjust', u'had just'), (u'nearyou', u'near you'), (u'whateveryou', u'whatever you'), (u'hourputs', u'hour puts'), (u'timejob', u'time job'), (u'overyour', u'over your'), (u'orpermanent', u'or permanent'), (u'createjobs', u'create jobs'), (u"I'vejust", u"I've just"), (u'peoplejobs', u'people jobs'), (u'dinnerpail', u'dinner pail'), (u'hasjumped', u'has jumped'), (u'theirprivacy', u'their privacy'), (u'AIl', u'All'), (u'ofserious', u'of serious'), (u'yourprofessional', u'your professional'), (u'poiitical', u'political'), (u'tojump', u'to jump'), (u'iives', u'lives'), (u'eiections', u'elections'), (u'militaryjuntas', u'military juntas'), (u'nojoke', u'no joke'), (u'yourpresidency', u'your presidency'), (u'ofmilitaryjuntas', u'of military juntas'), (u'Ourproposal', u'Our proposal'), (u'LeBIanc', u'LeBlanc'), (u'KIaus', u'Klaus'), (u'yourpussy', u'your pussy'), (u'lNTERVIEWER', u'INTERVIEWER'), (u'lNAUDIBLE', u'INAUDIBLE'), (u'SImpsons', u'Simpsons'), (u'anotherjob', u'another job'), (u'lfthere', u'If there'), (u'descentinto', u'descent into'), (u'ofthathere', u'of that here'), (u'ofway', u'of way'), (u'yourseat', u'your seat'), (u'allyou', u'all you'), (u'Allyou', u'All you'), (u'yourass', u'your ass'), (u'Yourbutt', u'Your butt'), (u'iustiiggle', u'just jiggle'), (u'iust', u'just'), (u'CSi', u'CSI'), (u'affernoon', u'afternoon'), (u'orpersecution', u'or persecution'), (u'theirpetty', u'their petty'), (u'Fourpercent', u'Four percent'), (u'fourpercent', u'four percent'), (u'willjust', u'will just'), (u"Ifyou're", u"If you're"), (u'ourplanet', u'our planet'), (u'lsolation', u'Isolation'), (u'yourprimitive', u'your primitive'), (u'yourplanet', u'your planet'), (u'matteryour', u'matter your'), (u'Yourplace', u'Your place'), (u'andjustice', u'and justice'), (u'anotherpart', u'another part'), (u'confiict', u'conflict'), (u'growingjeopardy', u'growing jeopardy'), (u'hasjust', u'has just'), (u'havejust', u'have just'), (u'herselfinto', u'herself into'), (u'ifnecessary', u'if necessary'), (u"we'vejust", u"we've just"), (u'tojust', u'to just'), (u'yourjudgment', u'your judgment'), (u'yourjeans', u'your jeans'), (u'Youjust', u'You just'), (u'ajanitor', u'a janitor'), (u'FIattery', u'Flattery'), (u'myjournal', u'my journal'), (u'myjudgment', u'my judgment'), (u'offofmy', u'off of my'), (u'offyour', u'off your'), (u'ofgood', u'of good'), (u'ofguilty', u'of guilty'), (u'ofhaving', u'of having'), (u'ofheart', u'of heart'), (u'ofhonor', u'of honor'), (u'oflove', u'of love'), (u'ofmankind', u'of mankind'), (u'ofmany', u'of many'), (u'ofnormal', u'of normal'), (u'ofpeople', u'of people'), (u'ofpower', u'of power'), (u'ofsuch', u'of such'), (u'peoplejust', u'people just'), (u"They'rejust", u"They're just"), (u'tojeopardize', u'to jeopardize'), (u'Yourplaces', u'Your places'), (u'yourposition', u'your position'), (u'yourselfa', u'yourself a'), (u'yourselfright', u'yourself right'), (u'thejob', u'the job'), (u'thejanitors', u'the janitors'), (u'alljust', u'all just'), (u"forAmerica's", u"for America's"), (u'Forpencils', u'For pencils'), (u'forpondering', u'for pondering'), (u'handwrittenjournals', u'handwritten journals'), (u'herpursuit', u'her pursuit'), (u'ofjust', u'of just'), (u'oflanding', u'of landing'), (u'oflife', u'of life'), (u'outjust', u'out just'), (u'Thejoke', u'The joke'), (u'ourpatient', u'our patient'), (u"oryou're", u"or you're"), (u'ofyourself', u'of yourself'), (u'poweryour', u'power your'), (u'Ofmy', u'Of my'), (u'EIlen', u'Ellen'), (u"Don'tget", u"Don't get"), (u'tellme', u'tell me'), (u'ofdecision', u'of decision'), (u'itgoing', u'it going'), (u'artificialgravity', u'artificial gravity'), (u'shouldknow', u'should know'), (u"Hasn'tgot", u"Hasn't got"), (u'thirdjunction', u'third junction'), (u'somebodypicks', u'somebody picks'), (u'Willyou', u'Will you'), (u"can'tget", u"can't get"), (u'BuZZes', u'Buzzes'), (u"wouldn'tyou", u"wouldn't you"), (u'Wellbelow', u'Well below'), (u"What'dyou", u"What'd you"), (u'decipheredpart', u'deciphered part'), (u"they'llknow", u"they'll know"), (u"ifit's", u"if it's"), (u'ornot', u'or not'), (u'myposition', u'my position'), (u'lndistinct', u'Indistinct'), (u'anybiscuits', u'any biscuits'), (u'Andifyou', u'And if you'), (u'lfwe', u'If we'), (u'yourarm', u'your arm'), (u'lnteresting', u'Interesting'), (u'findit', u'find it'), (u"it'llstart", u"it'll start"), (u'holdit', u'hold it'), (u'ofkilling', u'of killing'), (u'Howyou', u'How you'), (u'lnhales', u'Inhales'), (u'lgot', u'I got'), (u'CIip', u'Clip'), (u"what'II", u"what'll"), (u"road'II", u"road'll"), (u'girI', u'girl'), (u'LIoyd', u'Lloyd'), (u'BIake', u'Blake'), (u'reaI', u'real'), (u'Foryour', u'For your'), (u'yourpublic', u'your public'), (u'LAst', u'Last'), (u'h is', u'his'), (u'He)\u2019', u'Hey'), (u'Ls', u'Is'), (u"al'", u'at'), (u"wail'", u'wait'), (u"III'll", u"I'll"), (u'forthis', u'for this'), (u'Yea h', u'Yeah'), (u'a re', u'are'), (u'He)"', u'Hey'), (u"pan'", u'part'), (u'yea h', u'yeah'), (u'Tun', u'Run'), (u"He)'", u'Hey'), (u"he)'", u'hey'), (u"I'11", u"I'll"), (u'he)"', u'hey'), (u" 're ", u"'re ")]),
                        'pattern': u'(?um)(\\b|^)(?:\\$COff\\$|\\$ergei|\\$\\\'llOp|\\/\\\'\\/\\/|\\/\\\'\\/I|\\/ennifer|\\/got|\\/have|\\/hope|\\/just|\\/love|\\/\\\'m|\\/mmerse|\\/nsu\\/ts|\\/ong|\\/ook|\\/t\\\'s|\\/\\\'ve|\\\\\\/\\\\\\/e\\\'d|\\\\\\/\\\\\\/e\\\'re|\\\\\\/\\\\\\/e\\\'ve|\\\\\\/\\\\\\/hat|\\\\\\/\\\\\\/here\\\'d|\\\\\\/\\\\\\/hoo|\\\\\\/\\\\\\/hy|\\\\\\/\\\\\\/hy\\\'d|\\\\\\/\\\\le\\\'re|\\\\\\/Ve|\\\\Ne\\\'re|\\\\Nhat\\\'s|\\\\Nhere\\\'s|\\|\\\'mjust|\\\xa4ff|\\\xa4Id|\\\xa4Ids|\\\xa4n|\\\xa4ne|\\\xa4nly|\\\xa4pen|\\\xa4r|\\\xa4rder|\\\xa4ther|\\\xa4ur|\\\xa4ut|\\\xa4ver|\\\xa4wn|\\\u20acV\\\u20acI\\\'y|0\\\'clock|0f|0fEngland|0fft0|0l\\/er|0n|0ne|0ne\\\'s|0r|0rders|0thers\\\'|0ut|0utlaw\\\'s|0utlaws\\\'|0ver|13oos|18oos|195os|1et\\\'s|1o|1oo|1ooth|1oth|2E\\_|2\\\'IST|2\\\'Ist\\_|2o|2oth|3o|3oth|4o|4os|4oth|50rry|5o|5oth|6o|6os|\\\'6os|6oth|7o|\\\'7os|7oth|8o|\\\'8os|8oth|9\\/aim|9o|9oth|9UnShQt|a\\/\\/|a\\/bum|a\\/so|A\\/ways|abcut|aboutjoining|aboutposh|aboutus|aboutyou|accldent|Acool|afier|affraid|Afriend|afterall|afterthe|afulcrum|Afunny|aga\\/nst|ahsolutes|AI\\_I\\_|AIien|AIex|AII|AIIan|AIIow|AIive|ain\\\'tgotno|Ain\\\'tgotno|airstrike|AIVIBULANCE|ajob|ajockey\\_|ajoke|Ajoke|ajoking|al\\/|al\\/en|alittle|allgasp|alljustforshow|aln\\\'t|alot|Alot|An5wer|Andit|Andit\\\'s|andl|andlaughs|andleave|andthe|andyou|Andyou|ANNOUNC\\/NG|anotherstep|ANSWER\\/NG|answerwhat|antiquejoke|anyhcdy\\\'s|Anyidea|anyone\\\'s\\_|apejust|ARABlc|aren\\\'t\\_|arerl\\\'t|Arnsteln\\\'s|atleast|Atough|Awhole|awoman|Awoman|barelytalked|bcat|Bcllvla|bcmb|bcmbs|be\\/\\/y|becuase|Beep\\/\\\'ng|bejumpy|besldes|bestfriend|bestguy|bestjob|BIack|BIess|bigos\\_\\_\\_|BIame|BIind|BIood|BIue|BLOVVS|blowholel|blt|Bo99|bodiedyoung|breakf\\\xe9wtl|bulldozlng|butjust|butl|Butl|butljust|Butljustcan\\\'tgetenough|Butyou\\\'re|buythem|buyyou|byjust|bythe|C\\/latter\\/\\\'\\/7g|ca\\/\\/\\/ng|ca\\/I|call\\/ng|callyou|can\\*t|can\\\'i|can\\\'I|canlgetyou|cannotchange|cannut|can\\\'T|can\\\'t\\_|can\\\'tjust|can\\\'tletgo|Car0l|Carhorn|carrled|Ccug|Ccugs|Ccver|cellularchange|cff|cfycu|cfycur|Ch\\/rping|chaletgirl|changejobs|Charliejust|Chatter\\/\\\'rtg|CHATTERWG|Chequeredlove|cHIRPINcs|chjldishness|chlldrcn|chlldren|chocolatte|Cho\\/r|cHucKl\\_Es|CIark|CIear|circumcised\\_|ckay|cl\\_osEs|CLATTERWG|cn|cne|cnes|Coincidenta\\/\\/y|COm\\\u20ac|comp\\/etey|complainingabout|coms|cond\\/lion|confdence|conhrmed|connrm|Consecutivelyl|COUGH5|CouGHING|couIdn\\\'t|couldjust|couldn\\\'T|couldn\\\'tjust|Couldyou|crappyjob|CRAsHING|crder|Crowdcheers|Cruoially|cther|cuuld|cver|d\\/\\\'dn\\\'t|d\\/squietude|D\\\xa4esn\\\'t|d\\\xa4n\\\'i|d\\\xa4n\\\'t|d\\\xb09|d0|D0|D0asn\\\'t|Dad\\\'\\/\\/|dairyjust|Dar\\/\\/ng|dc|Dcbby|dccsn\\\'t|dcctcr|Dces|dcgs|dcing|dcn\\\'I|dcn\\\'t|Dcn\\\'t|dcughnut|declslons|deedhas|Dehnitely|desewes|desperate\\/\\\xbby|D\\\ufb02nk|DIAl\\_lNcs|didn\\\'\\!|didnt|didn\\\'T|dIdn\\\'t|didn\\\'t\\_|didrft|didrl\\\'t|didyou|divorcing\\_|dld|dldn\\\'t|dlfflcull|dlg|dlsobeyed|doasn\\\'t|Doasn\\\'t|doctoh|Doctor\\_\\_\\_tell|doesnt|doesn\\\'T|doesri\\\'t|doesrt|Doesrt|doit|dojust|don\\*t|donejobs|don\\\'i|don\\\'l|Don\\\'l|Donllook|dont|don\\\'T|don\\\'tcare|don\\\'tjoke|Don\\\'tjudge|don\\\'tjust|Don\\\'tjust|Don\\\'tlet|don\\\'tlhink|don\\\'tpush|Don\\\'tyou|DonWlook|Dooropens|doorshuts|dothat|dothis|Drinkthis|dumbass|dumbto|dun\\\'t|E\\/\\/e|E9YPt|ea\\/\\\'t\\/7|eart\\/7|efi\\\'\\/\\\'c\\/\\\'ent|EN\\<3LlsH|Enjoythe|Erv\\\\\\/an|Erv\\\\\\/an\\\'s|etemity|ev\\/I|eve\\/yone|even\\/body\\\'s|eversay|Everymonth|everythings|Everythirlg\\\'s|Everythlng\\\'s|Everytime|Exac\\\ufb02y|ExacUy\\_|excitedshrieking|ExcLAllvls|exploatation|expreusion|fairthat|Fathef|fatherfigure|FBl|fcrebcdlng|fcreverjudges|fcund|feeleverything|feelsweet|fiam\\/\\\'\\/y|\\\ufb01ngernail|finishedjunior|FIynn|flll|flra|Flylng|Fnends|fo\\/low|fonzvard|fora|Fora|forajob|forAmerica|forNew|forone|forso|Forsuch|forsunburns|forthe|Foryears|foryou|Foudeen|Fou\\\ufb02een|FourSeasons|fr\\/ends|freezerfood|F\\\xfchrerfeels|furthernotice|furyou|G0|g0in9|gamlenias|GAsPING|gc|gcing|gcnna|Gcnna|gct|Gct|genercsity|generosityn|getjust|g\\\ufb02ing|gi\\\ufb02friend|gir\\/|gir\\/s\\\'boarding|giris|gLlyS|glum\\_|gnyone|golng|goodboyand|goodjob|gOt|gotjumped|gotmyfirstinterview|grandjury|greatjob|Greatjobl|grinco|GRoANING|GRUNUNG|gu|gunna|guyjumped|guyjust|gUyS|\\_H6Y\\-|H\\\u20acY|H0we\\\xb7ver|halftheir|hapPY|hasrt|Hasrt|haven\\\'tspokerl|hcle|hcme|hcmes|hcpe|hctel|hcurs|Hcw|he\\/ps|hearjokestonight|hearme|Hefell|he\\\'II|He\\\'II|HeII0|He\\\'Il|Hejust|He\\\'lI|HelIo|hellc|HellO|herboyfr\\/end|herflesh|herfollov\\\\\\/ed|herjob\\_|HerrSchmidt|herwith|HeY\\\xb7|HeyJennifer|hiddsn|hisjunk|Hitlershare|Hlneed|Hnally|Hnishing|HOId|hOIes|HONMNG|honorthe|honoryou|honoryour|Hov\\\\\\/\\\'s|Hov\\\\\\/\\\'S|HovvLING|howit|HoW\\\'s|howto|Hs\\\'s|hurtyou|I\\/erilj\\/|I\\/fe|I\\\\\\/I|I\\\\\\/Ian|I\\\\\\/Iathies|I\\\\\\/Ie|I\\\\\\/Iommy|I\\\\\\/Ir|I\\\\\\/Ir\\.|I\\\\\\/ly|I3EEPING|I3LARING|Iacings|Iaid|Iam|Iand|Ianding|Iast|Iate|Icad|Icading|Ican|Iccked|Icng|Icsing|Icslng|Idid|Ididn\\\'t|Ido|Idon\\\'i|Idon\\\'t|Idon\\\'tthink|I\\\'E\\\'\\$|Ieamed|Ieapt|Iearned|Ieast|Ieave|Ied|Ieft|Ieg\\\'s|Iess|Iet|Iet\\\'s|Iet\\\'sjust|if\\/just|Ifear|Ifeared|Ifeel|ifI\\\'\\|\\||ifI\\\'d|ifI\\\'II|ifI\\\'ll|ifI\\\'m|Ifinally|ifI\\\'ve|ifl|Iforgot|Ifound|ifshe|ifthat\\\'s|ifthe|Ifthe|ifthere\\\'s|Ifthey|ifwe|Ifwe|Ifycu|ifyou|Ifyou|ifyuu|Iget|Igot|Igotta|Igotyou|Iguess|Iguessljust|Ihad|Ihat\\\'s|Ihave|Iheard|ihere\\\'s|ihey\\\'ve|Ihope|ii\\/Iary|ii\\/Ir|ii\\/Ir\\.|ii\\/love|Iife|I\\\'II|Iike|I\\\'Il|Iine|iirst|ii\\\'s|Ii\\\'s|Iiterallyjumped|Ijoined|Ijust|Iknew|Iknow|Ile|Ileft|I\\\'lldo|I\\\'llmake|Ilons|Ilove|I\\\'mjust|Inconceivablel|infact|Infact|in\\\ufb02uence|infront|injust|insc\\\ufb01p\\\ufb01ons|insolencel|intc|internationaljudges|inthe|Iockdown|Iong|Iongships|Iook|Iookjust|Iooklng|Iooks|Ioose|Iord\\\'s|Iose|Ioser|Ioss|Iost|Iot|Iot\\\'s|Iousyjob|Iove|Ioves|Iowlife|Ipaid|Iquit|Ireallythinkthis|I\\\'rn|Isaw|Isayt\\/1e|isjust|isn\\\'i|isn\\\'t\\_|Isthis|Istill|Istumblod|Itake|itdown|Iteach|Itfeels|ithave|Ithink|Ithinkthat|Ithinkthis|Ithinkyou\\\'re|Ithlnk|Ithoguht|Ithought|Ithoughtl|it\\\'II|It\\\'II|it\\\'Il|It\\\'Il|itin|itjust|Itjust|it\\\'lI|It\\\'lI|It\\\'llhappen|it\\\'lljust|Itold|Itook|itout|it\\\'S|it\\\'sjinxed|it\\\'sjust|It\\\'sjust|itso|Ittends|Itwasn\\\'t|Iuckier|IV\\|oney|IV\\|oney\\\'s|I\\\'va|I\\\'Ve|IVIan|IVIAN|IVIarch|IVIarci\\\'s|IVIarko|IVIe|IVIine\\\'s|IVImm|IVIoney|IVIr\\.|IVIrs|IVIuch|IVIust|IVIy|IVlacArthur|IVlacArthur\\\'s|IVlcBride|IVlore|IVlotherfucker\\_|IVlr|IVlr\\.|IVlr\\_|IVlust|IVly|Iwake|Iwant|Iwanted|Iwas|Iwasjust|Iwasjustu|Iwill|Iwish|Iwon\\\'t|Iworked|Iwould|jalapeno|Jaokson|Jascn|jcke|jennifer|joseph|jsut|Jumpthem|jusi|jusl|justjudge|justleave|Justletgo|kidsjumped|kiokflip|knowjust|knowthat|knowthis|knowwhat|knowyet|knowyourlove|korean|L\\/ght|L\\/kes|L\\\\\\/Ianuela|L\\\\\\/Ianuelal|l\\\\\\/Iauzard|l\\\\\\/I\\\xe9lanie|L\\\\\\/I\\\xe9lanie|l\\\\\\/Iom|l\\\\\\/Iommy|l\\\\\\/Ir|l\\\\\\/Ir\\.|l\\\\\\/Is|l\\\\\\/ly|l\\_AuGHING|l\\\u2018m|Laml6|Lcad|lcan|lcan\\\'t|lcarl\\\'t\\_|Lcve|l\\\'d|L\\\'d|ldid|Ldid|ldiot|L\\\'djump|ldon\\\'t|Ldon\\\'t|Lefs|Let\\\'sjust|lf|Lf|lfeelonelung|lfthey|lfyou|Lfyou|lfyou\\\'re|lget|lgive|Li\\/0\\/Academy|li\\/lr\\.|ligature\\_\\_\\_|l\\\'II|l\\\'Il|ljust|Ljust|ll\\/Iommy\\\'s|ll\\/lajor|Ll\\/lajor|ll\\/layans|l\\\'lI|l\\\'ll|L\\\'ll|l\\\'lljust|L\\\'lltake|llte|l\\\'m|L\\\'m|Lmean|l\\\'mjust|ln|lN|lNAuDll3LE|LNAuDll3LE|LNDlsTINcT|lneed|lostyou|Loudmusic|lraq|lRA\\\'s|Lrenka|Lrn|lRS|lsabella|lsn\\\'t|Lsn\\\'t|Lst\\\'s|lsuppose|lt|ltake|ltell|lthink|Lthink|lthink\\_\\_\\_|lt\\\'II|lt\\\'Il|ltjammed\\_|lt\\\'ll|ltold|lt\\\'s|lT\\\'S|Lt\\\'S|Lt\\\'sjust|lv\\\\\\/asn\\\'t|l\\\'ve|L\\\'ve|lVIan|lVIcHenry|lVIr\\.|lVlacArthur|LVlore|lVlr|lVlr\\.|lvluslc|lVlust|LVly|lwaited|lwamoto|lwant|lwanted|lwas|lwill|lwon\\\'t|lworked|lwould|lwould\\\'ve|lx\\/Iorning|M\\/dd\\/e|m\\/g\\/7ty|MACH\\/NE|MacKenz\\/e|majorjackpot|majormuscle|Manuela\\_|maste\\/y|Masturhate|Mattei\\_|mayjust|mbecause|McCa\\/Iister|McCallisler|Mccallister|Mccallisters|mcm\\\'s|mcney|mcral|mcre|mcve|mejust|Mexioo|mi\\/\\/\\<|misfartune|Ml6|Mlnd|Mock\\/\\\'ngbl\\\'rd|mOI\\\'\\\u20ac|Mom\\_|monkeyback|move\\_\\_\\_l|moveto|mustknock|Myheart|myjch|myjet|myjob|Myjob|myjob\\\'s|mylife|Mynew|myown|mypants|myselli|Myshoes|mysong|mytemper|mythumb|Myworld|N0|narne|Natians|naTve|nc|Nc|ncne|Ncrth|ncw|Ncw|needyou|neighboun|neverfound|neverthere|neverv\\\\\\/ill\\_|NewJersey|newjob|newjobs|nextdoor|Nighw|nilios|Nlagnificence|Nlakes|Nlalina|Nlan|Nlarch|Nlarine|Nlarion|Nlarry|Nlars|Nlarty|Nle|Nleet|Nlen|Nlom|Nlore|Nlornin|Nlother|Nlr|Nlr\\.|Nlrs|Nluch|nojurisdiction|noone|Noone|not\\ judging|notgoing|notjunk|Notjunk|notjust|notsure|novv|Nowjust|Nowthat\\\'s|Numbertwo|oan\\\'t|oan\\\'tjust|objecl|occultpowerand|Ocps|ofa|ofajudge|ofall|Ofall|ofBedford|ofcourse|Ofcourse|ofeach|ofeither|Offioer\\\'s|ofFrance|offreedom|offthe|offthis|offto|offun|ofguy|Ofhce|ofhis|ofHis|ofhoneybees|ofit|ofjam|OFJOAN|ofjoy|ofjunior|ofme|ofmead|ofmicroinjections|ofmy|ofNew|ofNorris\\\'|ofopinions|ofour|ofpeopla|ofthat|ofthe|Ofthe|oftheir|ofthem|ofthem\\\'s|ofthemselves|ofthere|ofthese|ofthings|ofthis|ofthlngs|ofthose|ofuse|ofwashington|ofyou|ofyour|OId|OIsson|Ok3Y|okaY|OkaY|OKaY|OKGY|Ol\\<|oldAdolfon|onboard|onIy|onIything|onJanuaw|onlyjust|Onyinal|oomprise|oonstitution|oouldn\\\'t|oould\\\'ve|oousin\\\'s|opiimistically|ora|orfall|orglory|orjust|Orjust|Orthat|orwould|Orwould|Othenzvise|our\\ joumey|ourbrave|ourfathers|ourgirlon|Ourgoal|Ourguy|ourj0b\\\'s|Ourj0b\\\'s|ourjobs|ourjob\\\'s|Ourjob\\\'s|ourjoumey|ourphotos|ourv\\\\\\/ay|outlool\\<\\\'s|overme|overthe|overthere|p\\/ace|P\\/ease|p\\_m\\_|P\\\xb0P\\$|PANUNG|pclnt|pclnts|pe0pIe|Perrut\\_|Persona\\/4\\/|Persona\\/y|persors|PIain|PIease|PIeasure|PIus|pleasurlng|POIe|Polynes\\/ans|poorshowing|popsicle|Presidenfs|probablyjust|puIIing|Putyourhand|Qh|QkaY|Qpen|QUYS|\\_QW|r\\/ght|ralnbow|ratherjump|ratherjust|Rcque|rcscucd|rea\\/|readytolaunchu|reaHy|ReaHy|reallyjust|reallymiss|reallytalked|reallythink|reallythinkthis|rememberthem|reoalibrated|retum|rhfluence|rightdown|roadyou|RUMBUNG|s\\/uggikh|S0|S1oW1y|saidyou|sayeverything\\\'s|saynothing|saythat|sc|scientihc|SCREAIVHNG|sCREAlvllNG|SCREAlvllNG|scund|S\\\'EOp|severa\\/parents|sfill|S\\\ufb02ence|shallrise|sHATTERING|shcws|Shdsjust|She\\`s|She\\\u2018II|she\\\'II|She\\\'II|she\\\'Il|Shejust|she\\\'lI|Shoofing|ShOp|shortyears|shou\\/dn|shou\\\ufb01ng|Shou\\\ufb02ng|shouldnt|Shouldrt|shouldrt|Shs\\\'s|SHUDDERWG|Shutup|SIGH\\$|signifcance|Sincc|sistervvill|Skarsg\\\xe9rd|slcsHs|slGHINcs|slGHING|slNGING|slzzLING|smarfest|Smiih|so\\/id|SoBl3lNG|soemtimes|Sojust|soldierl|somethlng|somethlng\\\'s|somez\\\'\\/7\\/ng|somthing|sumthing|sou\\/|SoundofMusic|SP\\/ash|SPEAK\\/NG|speII|speII\\\'s|Spendourtime|sQUA\\\\\\/\\\\\\/KING|StAnton|stealsjeans|StilI|Stilldesperatelyseeking|stlll|sToPs|storyl|Stubbom|su\\/faces|suffocaiing|summerjob|Summerjust|sun\\/ive|superiorman|sur\\\ufb02aces|t\\/ying|T0|T00|ta\\/ks|taiked|talkto|Talkto|talktonight|tampax|tc|tcday|tcrturing|tcuch|te\\/\\/|tearjust|tellsjokes|tellyou|terriers\\_|th\\/nk|THEPASSION|thafs|Thafs|Thai\\\'s|Thal\\\'s|thankyou|Thankyou|thatconverts|thatgoes|that\\\'II|That\\\'II|thatjob|thatjunk|thatjust|thatleads|Thatl\\\'m|that\\\'s\\ just|Thatsand|that\\\'sjust|That\\\'sjust|Thc|theirface|theirfeet|theirfury|thejaw|thejoint|thejudge|thejudges|Thejudges|thejury|Thelook|Therds|There\\\'II|There\\\'Il|There\\\'lI|They\\\'\\/\\\'e|they\\/\\\'II|They\\/re|They\\/\\\'re|they\\\'II|they\\\'Il|theyjust|Theyjust|they\\\'lI|They\\\'lI|theyre|theysay|thinkthat|this\\\'II|thlngs|Thlnkthls|thls|thore\\\'s|Thore\\\'s|Thorjust|thoughtl\\\'dletyou|tnatjust|tnat\\\'s|Tnat\\\'s|Tnere\\\'ll|to\\/\\/et|To\\/\\/S|todayl\\\'d|togelher|togethen|tojoin|tojudge|toldyou|tomorrovv|Tonighfsjust|totake|totalk|tothat|tothe|Towef|Tr\\/ck\\/ing|Traitur|tv\\\\\\/o|tvvelve|Tvvelve|tvventy|Tvventy|tvvo|Tvvo|twc|unconhrmed|underthat|underthe|underthese|underyour|unfilyou|Unfon\\\'unate\\/y|Uninnabited|untilApril|untilyou|upthinking|upto|V\\\\\\/ait\\_\\_\\_|v\\\\\\/as|V\\\\\\/as|V\\\\\\/e|v\\\\\\/eek\\\'s|V\\\\\\/eird\\_|V\\\\\\/ell|V\\\\\\/hat|V\\\\\\/hen\\\'ll|V\\\\\\/ho|v\\\\\\/ho\\\'ll|v\\\\\\/Hoops|v\\\\\\/ho\\\'s|V\\\\\\/ho\\\'s|V\\\\\\/hy|v\\\\\\/ith|v\\\\\\/on\\\'t|V\\\\fith|V\\\\fithin|valedictolian|vcice|ve\\/y|veiy|V\\\xe9ry|versioin|vi\\/ay|visitjails|Viva\\/di\\\'s|vlll|Voil\\\xe1|Voil\\\xe9|vvasjust|VVasn\\\'t|vvay|VVe|VVe\\\'II|VVe\\\'ll|Vvelooked|VVe\\\'re|VVe\\\'ve|VVhat|VVhat\\\'s|VVhat\\\'S|VVhen|\\\'v\\\'Vhere\\\'s|VVhip|vvHooPING|VvHooPING|VVhy|VVill|VVinters|vvlND|w\\\xa4n\\\'t|W9|waht|waierfall|walkjust|wallplant|wannajump|wantyou|Warcontinues|wasjennifer|wasjust|wasrt|Wasrt|wayl|wayround|wclf|wcman|wcmen|wcn\\\'t|wcrse|wculd|We\\/\\/|We\\/came|we\\/come|We\\/come|We\\/I|weekendjust|werert|Werert|we\\\'II|We\\\'II|we\\\'Il|We\\\'Il|wejust|we\\\'lI|We\\\'rejust|We\\\'ro|We\\\'Ve|wh\\/p|Wh\\\xb0ops|Whafs|Whatam|Whatare|Whateverwe|What\\\'II|Whatis|whatjust|Whatl|whatshe|whatwe|Whc\\\'s|Whcse|wHlsPERs|wi\\/\\/|wil\\/|Wil\\/|wilI|willbe|willhire|willneverknow|willyou|wlfe|wlfe\\\'s|wlth|wnat\\\'s|Wno|Wo\\/f|wo\\\ufb02d|WOI\\\'1\\\'t|wondernobody|won\\\'T|won\\\'tanswerme|won\\\'tforget|won\\\'tletitbring|Wo\\\'re|worfd|won\\\'th|won\\\'thwhile|workyou|wouIdn\\\'t|wouldn\\\'\\!|Wouldrt|wr\\/\\\'2\\\'\\/ng|writign|wrcng|wuuld|\\_Yay|Y\\\xa4u\\\'II|Y\\\xa4u\\\'ll|y\\\xa4u\\\'re|Y\\\xa4u\\\'re|y\\\xa4u\\\'ve|Y0|y0LI|y0u\\\'II|Y0u\\\'rc|Y0u\\\'re|Y0u\\\'ve|yaming|yaurparents|ycu|ycu\\\'d|ycur|Ycu\\\'re|Ycursins|YEI\\_I\\_|YELL\\$|yigg\\/mg|Yigg\\/mg|yoLI|yOu|yOU|you\\`re|you\\\'II|You\\\'II|You\\\'Il|youjack|youjoin|Youjoin|youjust|You\\\'lI|youngsterlike|youpick|you\\\'ra|Yourattention|yourautomobile|You\\\'rejustjealous|yourextra|yourfather|yourhand|yourhusband|yourjewelry|yourjob|Yourjob|yourjob\\_|yourjockey|yourjury|yourname|Yourpackage|yourpackage|you\\\'ro|yourpoorleg|yourvveak|you\\\'va|You\\\'va|youWlneversee|yQu|YQu|yQu\\\'\\_7|yummY|yuu|Yuu|Yuu\\\'ve|z\\\'housand|zlPPING|Ifslocked|nightjust|dayjourney|Ourjob|IunCh|nieCe|giVes|wantto|besttoday|NiCe|oftravelling|oftwo|ALl|afterparty|welL|theirjob|lfhe\\\'s|babyjesus|shithousejohn|jesus|withjesus|Gojoin|Adaughter|talkwith|anyjournals|L\\\'mjewish|arejust|soundjust|ifl\\\'m|askyou|ordinarywoman|andjunkies|isjack|helpyou|thinkyou|Lordjesus|injuvy|thejets|ifGod|againstjewish|ajunkie|dearjesus|hearyour|takeyears|friendjean|Fatherjohn|youjean|hearyou|Ifshe|didn\\\'tjust|IfGod|notjudge|andjudge|OKBY|myjourney|yourpremium|we\\\'rejust|Iittlejokes|Iifejust|Andjust|ofThe|lifejust|AIice|lnternationalAirport|yourbody|DollarBaby|ofjonesing|yourpanties|offforme|pantyparty|everhit|theirhomes|AirForce|yourhead|betterbe|myparty|disasterlockdown|Ifpot\\\'s|ifmy|yourmoney|Potterfan|Hermionejust|ofourshit|showyou|answernow|theirsjust|BIackie|SIeep|foryour|oryour|forArthur|CIamp|CIass|CIose|GIove|EIIen|PIay|PIace|EIgyn|AIert|CIaus|CIimb|military\\\'II|anylonget|yourlife|Yourbitch\\\'IIgetyou|yourdick|Tellyourbitch|rememberyou|newface|Butyou|don\\\'tyou|yourlives|Iovedher|reallydid|firstperson|mybest|Justgive|AIong|atyourbody|myhands|sayhe|mybooty|yourbooty|yourgirl|yourlegs|betterifthey|manybeautiful|contactpolice|numberbelow|biggestproblem|Itgave|everybodykind|theyhad|knowherlast|herhearing|othermembers|BIing|CIyde|foundguilty|fouryears|countyjail|yearin|theirrole|manybottles|can\\\'tpronounce|manybowls|ofthatgreen|manyjoyrides|Superrich|Iprefer|Theymust|whatyou|I\\\'IIjump|nobodyknow|neverknew|EIectronica|AIarm|getyourman|sayyou|getyour|Fuckyou|Whyyou|butyoujust|forgetyourname|Whatyou|Co\\/\\\'ncidenta\\/\\/y|GIad|RachelMarron|She\\\'llgive|presidentialsuite|andgentlemen|willnot|ourproducers|Ifshe\\\'s|CIock|Ishould|I\\\'llgo|maypass|andprotecting|BIessed|CIean|SIave|AIi|AIIah|AIIahu|CIick|BIast|AIlah|SIow|theirpolicies|Orperhaps|ofsex|forpleasure|ourpower|Yourpiece|Offioers|oondesoended|myseif|let\\\'sjust|yourway|An9TY|ourjourney|LuCY|\\\\\\\'m|CEDR\\/C|lsaac|FIy|Ionger|Iousy|Iosing|They\\\'II|yourpaws|littie|It\\\'lljust|AIso|Iisten|suPPosed|somePIace|exPIain|Iittle|StoP|AIways|Iectures|Iow|Ieaving|Ietting|Iistening|Iecture|Iicking|Iosses|PIeased|ofburglaries|He\\\'sjust|mytrucktoo|nowwhat|yourfire|herwhat\\\'s|hearthat|oryou|preferjournalist|CIaw|Ifour|lron|It\\\'syour|lfstill|forjoining|foryears|Ifit|notjump|ourproblem|yourprofile|ifJanine|forpreventative|whetherprotest|Ifnot|ourpeople|offmy|forproviding|hadjust|nearyou|whateveryou|hourputs|timejob|overyour|orpermanent|createjobs|I\\\'vejust|peoplejobs|dinnerpail|hasjumped|theirprivacy|AIl|ofserious|yourprofessional|poiitical|tojump|iives|eiections|militaryjuntas|nojoke|yourpresidency|ofmilitaryjuntas|Ourproposal|LeBIanc|KIaus|yourpussy|lNTERVIEWER|lNAUDIBLE|SImpsons|anotherjob|lfthere|descentinto|ofthathere|ofway|yourseat|allyou|Allyou|yourass|Yourbutt|iustiiggle|iust|CSi|affernoon|orpersecution|theirpetty|Fourpercent|fourpercent|willjust|Ifyou\\\'re|ourplanet|lsolation|yourprimitive|yourplanet|matteryour|Yourplace|andjustice|anotherpart|confiict|growingjeopardy|hasjust|havejust|herselfinto|ifnecessary|we\\\'vejust|tojust|yourjudgment|yourjeans|Youjust|ajanitor|FIattery|myjournal|myjudgment|offofmy|offyour|ofgood|ofguilty|ofhaving|ofheart|ofhonor|oflove|ofmankind|ofmany|ofnormal|ofpeople|ofpower|ofsuch|peoplejust|They\\\'rejust|tojeopardize|Yourplaces|yourposition|yourselfa|yourselfright|thejob|thejanitors|alljust|forAmerica\\\'s|Forpencils|forpondering|handwrittenjournals|herpursuit|ofjust|oflanding|oflife|outjust|Thejoke|ourpatient|oryou\\\'re|ofyourself|poweryour|Ofmy|EIlen|Don\\\'tget|tellme|ofdecision|itgoing|artificialgravity|shouldknow|Hasn\\\'tgot|thirdjunction|somebodypicks|Willyou|can\\\'tget|BuZZes|wouldn\\\'tyou|Wellbelow|What\\\'dyou|decipheredpart|they\\\'llknow|ifit\\\'s|ornot|myposition|lndistinct|anybiscuits|Andifyou|lfwe|yourarm|lnteresting|findit|it\\\'llstart|holdit|ofkilling|Howyou|lnhales|lgot|CIip|what\\\'II|road\\\'II|girI|LIoyd|BIake|reaI|Foryour|yourpublic|LAst|h\\ is|He\\)\\\u2019|Ls|al\\\'|wail\\\'|III\\\'ll|forthis|Yea\\ h|a\\ re|He\\)\\"|pan\\\'|yea\\ h|Tun|He\\)\\\'|he\\)\\\'|I\\\'11|he\\)\\"|\\ \\\'re\\ )(\\b|$)'}},
 'fin': {'BeginLines': {'data': OrderedDict(),
                        'pattern': None},
         'EndLines': {'data': OrderedDict(),
                      'pattern': None},
         'PartialLines': {'data': OrderedDict(),
                          'pattern': None},
         'PartialWordsAlways': {'data': OrderedDict(),
                                'pattern': None},
         'WholeLines': {'data': OrderedDict([(u'Katsokaa pa.', u'Katsokaapa.'), (u'Mik!\r\n""e\u201c9ir\xe4\u0131', u'Mik!\r\n-Hengit\xe4!'), (u'Tu lta!', u'Tulta!'), (u'...0I1...', u'...on...'), (u'Ken g\xe4n nauh oja?', u'Keng\xe4nnauhoja?'), (u'k\xe3mmott\xe3V\xe3ll\xe3 mUiStoll\xe3.', u'kammottavana muistona.'), (u'H\xe4n n\xe4ki naisen menev\xe4n\r\nkellarikerroksen ksen asun to o ns\xe4.', u'H\xe4n n\xe4ki naisen menev\xe4n\r\nkellarikerroksen asuntoonsa.'), (u'Min\xe4 etsin k\xe4siini miehen, joka\r\non aurtanutiestradea ja minua:', u'Min\xe4 etsin k\xe4siini miehen, joka\r\non auttanut Lestradea ja minua:'), (u'Huomaa erityisesti\r\npunaisella merkitty "kitoris.', u'Huomaa erityisesti\r\npunaisella merkitty "klitoris".'), (u'Tulkaa, meill\xe4 on\r\nHa va\u0131ji-bileet suihkussa', u'Tulkaa, meill\xe4 on\r\nHavaiji-bileet suihkussa'), (u'Ta rkoitatko ett\xe4\r\nh\xe4net myrkytettiin?', u'Tarkoitatko ett\xe4\r\nh\xe4net myrkytettiin?'), (u'Odotta kaa soittoani\r\nIev\xe4hdyspaikalla.', u'Odottakaa soittoani\r\nlev\xe4hdyspaikalla.'), (u'Nyt kuuntelet, perska rva.', u'Nyt kuuntelet, perskarva.'), (u'Ta patko h\xe4net sitten?', u'Tapatko h\xe4net sitten?'), (u'Seuraa vissa va/oissa.', u'Seuraavissa valoissa.'), (u'A\u0131o\u0131t rapattaa minut.\r\n- En.', u'Aioit tapattaa minut.\r\n- En.'), (u'Todella vaku uttavaa.', u'Todella vakuuttavaa.'), (u'I-le ovat tuolla alhaalla', u'He ovat tuolla alhaalla'), (u'Nainen kuuluu minulle.\r\n- I-I\xe0ivy siit\xe4, ylikasvuinen hyttynen!', u'Nainen kuuluu minulle.\r\n- H\xe4ivy siit\xe4, ylikasvuinen hyttynen!'), (u'I-Ialuatte k\xe4ytt\xe4\xe4 pyh\xe0\xe0 kive\xe4\r\ndynastian aarteen l\xf6yt\xe4miseksi.', u'Haluatte k\xe4ytt\xe4\xe4 pyh\xe0\xe0 kive\xe4\r\ndynastian aarteen l\xf6yt\xe4miseksi.'), (u'Mit\xe4f?', u'Mit\xe4.. ?'), (u'Kuuluuko Hiru ko-klaanista mit\xe4\xe4n?\r\n- Ninjasoturit ovat edell\xe4mme.', u'Kuuluuko Hiruko-klaanista mit\xe4\xe4n?\r\n- Ninjasoturit ovat edell\xe4mme.'), (u'Anteeks\u0131} painoin kai... -', u'Anteeksi, painoin kai... -'), (u'ja Rea! Ho usew\xedves.', u'ja Real Housewives.'), (u'Et halu n n ut Julkkistansseihinkaan.', u'Et halunnut Julkkistansseihinkaan.'), (u'Laard i k\xe4si?', u'Laardik\xe4si?'), (u'Varo kaa!', u'Varokaa!'), (u'N\xe4ytt\xe4v\xe4t k\xf6 tyt\xf6t v\xe4h \xe4n\r\nh uorahtavi m m i lta?', u'N\xe4ytt\xe4v\xe4tk\xf6 tyt\xf6t v\xe4h\xe4n\r\nhuorahtavimmilta?'), (u'Stif... Ier.', u'Stif... ler.'), (u'J u mantsu kka! M it\xe4?', u'Jumantsukka! Mit\xe4?'), (u'Varasin Ch u m bawam ban,', u'Varasin Chumbawamban,'), (u'J u malavita!', u'Jumalavita!'), (u'S', u'Isi...'), (u'Haluan kertoa jotai n', u'Haluan kertoa jotain'), (u'I-Ialuatte', u'Haluatte')]),
                        'pattern': None},
         'WholeWords': {'data': OrderedDict([(u'kellojo', u'kello jo'), (u'onjo', u'on jo'), (u'senj\xe4lkeen', u'sen j\xe4lkeen'), (u'Ts\xe4u', u'Tsau'), (u'hydraulinenjousitus', u'hydraulinen jousitus'), (u'Kevyetja', u'Kevyet ja'), (u'Oleijo', u'Olet jo'), (u'viimeinenjuna', u'viimeinen juna'), (u'n\xe4ytt\xe4\xe4jotenkin', u'n\xe4ytt\xe4\xe4 jotenkin'), (u'onjoku', u'on joku'), (u'Iapsuuteen', u'Lapsuuteen'), (u'Ieikitjunill\xe4', u'leikit junilla'), (u'Sfiy', u'Stig'), (u'Iukulasejani', u'Lukulasejani'), (u'Ieikkiminen', u'Leikkiminen'), (u'K\xe4\xe4lik\xe4\xe4rylepizz\xe4', u'Kaalik\xe4\xe4rylepizza'), (u'sukl\xe4\xe4k\xe4stikkeen', u'suklaakastikkeen'), (u'p\xe4istetun', u'paistetun'), (u'b\xe4n\xe4\xe4nin', u'banaanin'), (u'pifi', u'piti'), (u'a\u0131keasfaan', u'oikeastaan'), (u'Stg', u'Stig'), (u'sikain\ufb02uenssatja', u'sikainfluenssat ja'), (u'Hienojuna', u'Hieno juna'), (u'kiinnostuajunista', u'kiinnostua junista'), (u'h\xe4y\u0131yvetu\u0131\xedn', u'h\xf6yryveturin'), (u'pienaismalli', u'pienoismalli'), (u'ena', u'eno'), (u'racfios\xe3hk\xe4ff\xe1j\xe3n\xe3', u'radios\xe4hk\xf6tt\xe4j\xe4n\xe4'), (u'Amenkan', u'Amerikan'), (u'laiva/la', u'laivalla'), (u'0/in', u'Olin'), (u'Junaha\u0131rasfus', u'Junaharrastus'), (u'enasfa', u'enosta'), (u'/V\u0131\xedn', u'Niin'), (u'Oliivarmasii', u'Olit varmasti'), (u'Internetist\xe4juuri', u'Internetist\xe4 juuri'), (u'hu\u0131janj\xe3nniff\xe5v\xe3\xe0l', u'hurjan j\xe4nnitt\xe4v\xe4\xe4.'), (u'Vaikkajunat', u'Vaikka junat'), (u'k\xe4\xe4ntyija', u'k\xe4\xe4ntyi ja'), (u'osaajotain', u'osaa jotain'), (u'Ieikill\xe4mme', u'leikill\xe4mme'), (u'Bellinjuna', u'Beltin juna'), (u't\xe4st\xe4johtolangasta', u't\xe4st\xe4 johtolangasta'), (u'tuntisijonkun', u'tuntisi jonkun'), (u'Olgajotain', u'Olga jotain'), (u'tulokseivuodesia', u'tulokset vuodesta'), (u'tuloksetvuodesta', u'tulokset vuodesta'), (u'Vainjalkapallo', u'Vain jalkapallo'), (u'lloveyou', u'I love you'), (u'po\ufb02\u2039aisi', u'potkaisi'), (u'minufulos', u'minut ulos'), (u'Ieiv\xe4npaahdinl', u'leiv\xe4npaahdin!'), (u'Ieiv\xe4npaahdinta', u'leiv\xe4npaahdinta'), (u'asuajossain', u'asua jossain'), (u'Koiratjuoksentelivat', u'Koirat juoksentelivat'), (u'tiet\xe4\xe4jotain', u'tiet\xe4\xe4 jotain'), (u'osaatjuna', u'osaat juna'), (u'va/as', u'valas'), (u'va/asperhe', u'valasperhe'), (u'koskeejotain', u'koskee jotain'), (u'I\xe4\xe4kkeens\xe4', u'l\xe4\xe4kkeens\xe4'), (u'Iaulavan', u'laulavan'), (u'Kuulitj\xe4\xe4n', u'Kuulit j\xe4\xe4n'), (u'Ievolle', u'levolle'), (u'Va/aa//e', u'Valaalle'), (u'va/aa//a', u'valaalla'), (u'I\xe4hdenkin', u'l\xe4hdenkin'), (u'Iakkiin', u'lakkiin'), (u'Iohik\xe4\xe4rmeell\xe4', u'lohik\xe4\xe4rmeell\xe4'), (u'Mik\u0131', u'Mik!'), (u'Iukossa', u'lukossa'), (u'Va/aan', u'Valaan'), (u's\xe4ve/m\xe4', u's\xe4velm\xe4'), (u'j\xe4//een', u'j\xe4lleen'), (u'P\xf6\xf6\u0131', u'P\xf6\xf6!'), (u'Hnjaa', u'Hiljaa'), (u'Iiftasin', u'liftasin'), (u'Jute//aan', u'Jutellaan'), (u'Iohduttamaan', u'lohduttamaan'), (u"L'lYP\xe4f\xe4\xe4n", u'Hyp\xe4t\xe4\xe4n'), (u'\xc4\u0131r\u0131\u0131', u'\xc4iti!'), (u'F\u0131\u0131\u0131p\u0131', u'Filip!'), (u'Yr\u203ar\u203a\xe4\xe4\u0131', u'Hypp\xe4\xe4!'), (u'Miki', u'Mik!'), (u'Heng\u0131r\xe4\u0131', u'Hengit\xe4!'), (u'Va/as', u'Valas'), (u'Ko///is', u'Koillis'), (u'Audieja', u'Audie ja'), (u'I/man', u'Ilman'), (u'/entotukia/ukse/ta', u'lentotukialukselta'), (u'/aivastosta', u'laivastosta'), (u'/entotukikohtaan', u'lentotukikohtaan'), (u'tu/ee', u'tulee'), (u'akse/iva//at', u'akselivallat'), (u'a\u0131\u0131ek\u0131rjo\u0131rerr\u0131\u0131n', u'allekirjoitettiin'), (u'Iitkua', u'litkua'), (u'0li', u'Oli'), (u'Iaskuvarjojoukkoihin', u'laskuvarjojoukkoihin'), (u'Iaskuvarjojoukoissa', u'laskuvarjojoukoissa'), (u'Tarvitsetjotain', u'Tarvitset jotain'), (u'Ieukaremmi', u'leukaremmi'), (u'Iainaatko', u'lainaatko'), (u'p\xe4\xe4llik\xf6lleja', u'p\xe4\xe4llik\xf6lle ja'), (u'I\xe4hell\xe4ni', u'l\xe4hell\xe4ni'), (u'Soti/aan', u'Sotilaan'), (u'va//attava', u'vallattava'), (u'viho//ise/ta', u'viholliselta'), (u'/iittoutuneet', u'liittoutuneet'), (u'voitjohtaa', u'voit johtaa'), (u'pohditkojotain', u'pohditko jotain'), (u'viho//ista', u'vihollista'), (u'sej\xe4isi', u'se j\xe4isi'), (u'Ient\xe4jill\xe4', u'lent\xe4jill\xe4'), (u'Soltutl', u'Soltut!'), (u'Iaulustamme', u'laulustamme'), (u'Iakkiani', u'lakkiani'), (u'Iiemeen', u'liemeen'), (u'kanadala\u0131\u0161ia', u'kanadalaisia'), (u'si//anp\xe4\xe4asema', u'sillanp\xe4\xe4asema'), (u'vahv\u0131\u0161tettiin', u'vahv\u0131stettiin'), (u'tu/ituki', u'tulituki'), (u'eliitt\u0131joukkoa', u'eliittijoukkoa'), (u'pa\u0131ka\u0131\u0131as\u0131\u0131', u'paikallasi!'), (u'Ieikkinyt', u'leikkinyt'), (u'Iujitettu', u'lujitettu'), (u'Ete/\xe4', u'Etel\xe4'), (u'viho//isranna//e', u'vihollisrannalle'), (u'sivusta/ta', u'sivustalta'), (u'/oppuisi', u'loppuisi'), (u'Iaskuvarjojoukkojen', u'laskuvarjojoukkojen'), (u'p\xe4\xe4tt\xe4nytj\xe4\xe4d\xe4', u'p\xe4\xe4tt\xe4nyt j\xe4\xe4d\xe4'), (u'Iuutnanteille', u'luutnanteille'), (u'I\xe4ht\xf6valmiiksi', u'l\xe4ht\xf6valmiiksi'), (u'Iokoisat', u'lokoisat'), (u'Korjaus/ukemat', u'Korjauslukemat'), (u'tanke///e', u'tankeille'), (u'ky\u0131\u0131\xe4\u0131', u'kyll\xe4!'), (u'Iisti\xe4', u'listi\xe4'), (u'Kunniamita/in', u'Kunniamitalin'), (u'Vemon', u'Vernon'), (u'fied\xe3n', u'Tied\xe4n'), (u'Ei\u0131is', u'Elvis'), (u'Inlem\xe4tion\xe4', u'International'), (u'holelfss\xe4', u'hotellissa'), (u'Han\u0131ey', u'Harvey'), (u'peikk\xe4', u'pelkk\xe4'), (u'Ehisl\xe3', u'Elvist\xe4'), (u'Y\ufb02\xe3ll\xe3v\xe3', u'Yll\xe4tt\xe4v\xe4'), (u'mahdolisuus', u'mahdollisuus'), (u'loisteiaan', u'loisteliaan'), (u'aku', u'alku'), (u'Garonilie', u'Garonille'), (u'Iikainen', u'likainen'), (u'vaiehtelijoita', u'valehtelijoita'), (u'puutari\u0131aasi', u'puutarhaasi'), (u'Garunin', u'Garonin'), (u'oravaietti\xe4', u'oravaletti\xe4'), (u'paijon', u'paljon'), (u'sutja', u'sut ja'), (u'gospeikvartetissa', u'gospelkvartetissa'), (u'Iauiajaksi', u'laulajaksi'), (u'viihdylt\xe4j\xe4', u'viihdytt\xe4j\xe4'), (u'hannaala', u'harmaata'), (u'Iaulajalta', u'laulajalta'), (u'saatjotain', u'saat jotain'), (u'L\xf6yd\xe4njonkun', u'L\xf6yd\xe4n jonkun'), (u'py\xfcr\xedyi', u'py\xf6rtyi'), (u'Cn\u0131dupia', u'Crudupia'), (u'Iiikaa', u'liikaa'), (u'ke\u0131taa', u'kertaa'), (u'Thafs', u"That's"), (u'Kappaietta', u'Kappaletta'), (u'soijoka', u'soi joka'), (u'Levytl\xe4', u'Levyll\xe4'), (u'paiaamista', u'palaamista'), (u'kuonnunn', u'kuormurin'), (u'Tytt\xfcyst\xe4v\xe4t', u'Tytt\xf6yst\xe4v\xe4t'), (u'k\xe3p\xe3l\xf6ifiin', u'k\xe4p\xe4l\xf6itiin'), (u'Oiko', u'Oliko'), (u'tuipalo', u'tulipalo'), (u'hebofiavaa', u'helpottavaa'), (u'ongeina', u'ongelma'), (u'ongeimia', u'ongelmia'), (u'Ajateikaa', u'Ajatelkaa'), (u'ku\u0131ki', u'kurki'), (u'lhailen', u'Ihailen'), (u'L\xe4ht\xfcsi', u'L\xe4ht\xf6si'), (u'yhti\xf6ile', u'yhti\xf6lle'), (u'eitoimi', u'ei toimi'), (u'voij\xe4\xe4d\xe4', u'voi j\xe4\xe4d\xe4'), (u'Pomkat', u'Porukat'), (u'kon\u0131ata', u'korvata'), (u'konsentien', u'konserttien'), (u'Sep\xe3', u'Sep\xe4'), (u'hebolus', u'helpotus'), (u'k\xfcyryss\xe4', u'k\xf6yryss\xe4'), (u'repiat', u'replat'), (u'kuikee', u'kulkee'), (u'pon\u0131koita', u'porukoita'), (u'naisetja', u'naiset ja'), (u'ten\u0131etuileeksi', u'tervetulleeksi'), (u'yl\xe4puolelia', u'yl\xe4puolella'), (u'kuullut180', u'kuullut 180'), (u'Iapsellista', u'lapsellista'), (u'esiinnytja', u'esiinnyt ja'), (u'Iaulat', u'laulat'), (u'Henanjestas', u'Herranjestas'), (u'teilie', u'teille'), (u'IIe', u'lle'), (u't\xe4ilaisia', u't\xe4llaisia'), (u'Varu', u'Varo'), (u'nimeli\xe4\xe4n', u'nimell\xe4\xe4n'), (u'anneijaan', u'armeijaan'), (u'pen\u0131staa', u'perustaa'), (u'minkkitu\u0131kkia', u'minkkiturkkia'), (u'minkkituiiiilla', u'minkkiturkilla'), (u'Ten\u0131etuioa', u'Tervetuloa'), (u'kuitalevy\xe4', u'kultalevy\xe4'), (u'ei\xe4m\xe4ss\xe4', u'el\xe4m\xe4ss\xe4'), (u'jutkaisua', u'julkaisua'), (u'Fo\u0131t', u'Fort'), (u'oien', u'olen'), (u'asioilie', u'asioille'), (u'Eitarvitsekaan', u'Ei tarvitsekaan'), (u'p\xf6kenyin', u'p\xf6kerryin'), (u'yll\xe4iiyy', u'yll\xe4ttyy'), (u'komeaita', u'komealta'), (u'Chadie', u'Charlie'), (u'laulaisilteko', u'laulaisitteko'), (u'Iaittaa', u'laittaa'), (u'iytt\xe4renne', u'tytt\xe4renne'), (u'pikkutytt\xfcn\xe4', u'pikkutytt\xf6n\xe4'), (u'tytt\xfckulta', u'tytt\xf6kulta'), (u'vimuilua', u'virnuilua'), (u'reporitereita', u'reporttereita'), (u'vime', u'virne'), (u'eijohdu', u'ei johdu'), (u'eriiainen', u'erilainen'), (u'Iasketa', u'lasketa'), (u'kem\u0131ttu', u'kerrottu'), (u'Manyja', u'Marty ja'), (u'etteijutusta', u'ettei jutusta'), (u'Katifomiassa', u'Kaliforniassa'), (u'sun\xb0filaudan', u'surffilaudan'), (u'bn\u0131netti', u'brunetti'), (u'vaimiina', u'valmiina'), (u'yiim\xe4\xe4r\xe4iset', u'ylim\xe4\xe4r\xe4iset'), (u'leffatj\xe4\xe4', u'leffat j\xe4\xe4'), (u"koin'lle", u'koirille'), (u'T\xe4ilaisen', u'T\xe4llaisen'), (u'antanutjo', u'antanut jo'), (u'Cha\u0131lien', u'Charlien'), (u'ymp\xe4riliesi', u'ymp\xe4rillesi'), (u'Iy\xfc', u'ly\xf6'), (u"lopan't", u'loparit'), (u'h\u0131isi', u'tulisi'), (u'kuuiuvanijonnekin', u'kuuluvani jonnekin'), (u'juh\u0131n', u'jutun'), (u'miefkseni', u'mielikseni'), (u'Tuisitko', u'Tulisitko'), (u'I\u0131on\xe4ni', u'luonani'), (u'\xe4k\xe4\xe4', u'alkaa'), (u'yi', u'yli'), (u'rupallelemaan', u'rupattelemaan'), (u'Priscilialla', u'Priscillalla'), (u'Hemmoltelet', u'Hemmotelet'), (u'Hearlbreak', u'Heartbreak'), (u'Holelia', u'Hotelia'), (u'Nyton', u'Nyt on'), (u'kiertueeile', u'kiertueelle'), (u'Elvist\xe3', u'Elvist\xe4'), (u'puoleila', u'puolella'), (u'\xc4\u0131\xe4', u'\xc4l\xe4'), (u'lnlemalional', u'International'), (u'Iuottamustanne', u'luottamustanne'), (u'Mycroft\xedsta', u'Mycroftista'), (u'Iopettako', u'lopettako'), (u'Ielukauppa', u'lelukauppa'), (u'Iomamatkalle', u'lomamatkalle'), (u'Iyhyelle', u'lyhyelle'), (u'Alk\xe4\xe4', u'\xc4lk\xe4\xe4'), (u'K_uka', u'Kuka'), (u'IIa', u'lla'), (u'Aitinne', u'\xc4itinne'), (u'V\xe4/ikohtaus', u'V\xe4likohtaus'), (u'kuo//aan', u'kuollaan'), (u'n\xe4/k\xe4\xe4n', u'n\xe4lk\xe4\xe4n'), (u'Su/je', u'Sulje'), (u'I\xe4im\xe4ytit', u'l\xe4im\xe4ytit'), (u'I\xe4hetyst\xf6ss\xe4', u'l\xe4hetyst\xf6ss\xe4'), (u'I\xe4hetyst\xf6\xf6n', u'l\xe4hetyst\xf6\xf6n'), (u'Iaosilainen', u'laosilainen'), (u'Iiiketarjous', u'liiketarjous'), (u'kaappavat', u'kaappaavat'), (u'Ieiviss\xe4\xe4n', u'leiviss\xe4\xe4n'), (u'EriC', u'Eric'), (u'Voi/\xe0', u'Voil\xe0'), (u'Crawley\u0131', u'Crawley!'), (u'Iihaksiaan', u'lihaksiaan'), (u'Iuenkaan', u'luenkaan'), (u'Olemma', u'Olemme'), (u'I\xe4htisitte', u'l\xe4htisitte'), (u'jot\xe2in', u'jotain'), (u'Eversi', u'Eversti'), (u'Ieiriyty\xe4', u'leiriyty\xe4'), (u'Iiikutte', u'liikutte'), (u'I\xe4\xe4ketiedett\xe4', u'l\xe4\xe4ketiedett\xe4'), (u'Iivet\xe4', u'livet\xe4'), (u'Iapsetkin', u'lapsetkin'), (u'I\xe4\xe4keluettelo', u'l\xe4\xe4keluettelo'), (u'Iaatiko', u'laatikko'), (u'hyvih', u'hyvin'), (u'Ieukakuoppa', u'leukakuoppa'), (u'Ient\xe4j\xe4ni', u'lent\xe4j\xe4ni'), (u'Ieikkisi', u'leikkisi'), (u'Iupaamastaan', u'lupaamastaan'), (u'ku/taseni', u'kultaseni'), (u'tu/en', u'tulen'), (u'Iautalle', u'lautalle'), (u'100_vuotiaaksi', u'100 vuotiaaksi'), (u'_', u''), (u'Viilt\xe4j\xe3_Jackin', u'Viilt\xe4j\xe4 Jackin'), (u'keff\xe4rfkerro', u'kellarikerroksen'), (u'tan/itsi', u'tarvitsi'), (u'_Aivan', u'Aivan'), (u'_Valosta', u'Valosta'), (u'_Teemmek\xf6', u'Teemmek\xf6'), (u'Viilt\xe4j\xe4_Jack', u'Viilt\xe4j\xe4 Jack'), (u'_Voi', u'Voi'), (u'_Tied\xe4tte', u'Tied\xe4tte'), (u'kulunutjo', u'kulunut jo'), (u'Vuokra_auto', u'Vuokra-auto'), (u'_Tuokaa', u'Tuokaa'), (u'_Tunnetteko', u'Tunnetteko'), (u'_Tied\xe4mme', u'Tied\xe4mme'), (u'toissay\xf6n', u'toissa y\xf6n'), (u'_Toki', u'Toki'), (u'_Ammuttu', u'Ammuttu'), (u'_Jahtasit', u'Jahtasit'), (u'_Tunnenko', u'Tunnenko'), (u'_Joku', u'Joku'), (u'_Taivahan', u'Taivahan'), (u'Kuorma_auto', u'Kuorma-auto'), (u'_Vain', u'Vain'), (u'Mesmer_klubille', u'Mesmer klubille'), (u"0nslow'IIe", u"Onslow'lle"), (u'Mesmer_klubi', u'Mesmer klubi'), (u'_Anteeksi', u'Anteeksi'), (u'Schrenk_Notzing', u'Schrenk Notzing'), (u'_Tapoin', u'Tapoin'), (u'_AIk\xe4\xe4', u'\xc4lk\xe4\xe4'), (u'0dotan', u'Odotan'), (u'Iuonteenlu', u'luonteenlu'), (u'Iempikaupunkini', u'lempikaupunkini'), (u'Iavasta', u'lavasta'), (u'I\xe4mmittelij\xe4t', u'l\xe4mmittelij\xe4t'), (u'Iaastaria', u'laastaria'), (u'Riiu\xe4\xe4', u'Riitt\xe4\xe4'), (u'K\xe4yu\xe4v\xe4tk\xf6', u'K\xe4ytt\xe4v\xe4tk\xf6'), (u'I\xe4hestyk\xf6', u'l\xe4hestyk\xf6'), (u'Ieikekirja', u'leikekirja'), (u'Ievyj\xe4\xe4n', u'levyj\xe4\xe4n'), (u'Iahjoitamme', u'lahjoitamme'), (u'L\xe4pp\xe4\xe4tuohon', u'L\xe4pp\xe4\xe4 tuohon'), (u'CIawdy', u'Clawdy'), (u'mita', u'mit\xe4'), (u'jalkeen', u'j\xe4lkeen'), (u'Cannabisjaponica', u'Cannabis japonica'), (u'Ieningin', u'leningin'), (u'ki\u0131joitatte', u'kirjoitatte'), (u'ki\u0131joitetuksi', u'kirjoitetuksi'), (u'kuluttuu', u'kuluttaa'), (u'Iuvulta', u'luvulta'), (u'Ieipomiskilpailuun', u'leipomiskilpailuun'), (u'Maclntire', u'MacIntire'), (u'Iehteemme', u'lehteemme'), (u'Al\xe4', u'\xc4l\xe4'), (u'kysesss\xe4', u'kyseess\xe4'), (u'Itsepuolustustal', u'Itsepuolustusta!'), (u'Iiipasimesta', u'liipasimesta'), (u'Iuutani', u'luutani'), (u'Iahjansa', u'lahjansa'), (u'I\xe4himm\xe4isemme', u'l\xe4himm\xe4isemme'), (u'Iuhistuu', u'luhistuu'), (u'\u0131\xf6yhk\xe4', u'l\xf6yhk\xe4'), (u'Iehtileikkeleit\xe4', u'lehtileikkeleit\xe4'), (u'vefieni', u'veljeni'), (u'Iapselleni', u'lapselleni'), (u'ep\xe4normaalinal', u'ep\xe4normaalina!'), (u'Iuurankoja', u'luurankoja'), (u'Iuurangoista', u'luurangoista'), (u'p\xe4\xe4tiellel', u'p\xe4\xe4tielle!'), (u'Valonneitsytta', u'Valonneitsytt\xe4'), (u'Iohik\xe1\xe1rmekuula', u'lohik\xe4\xe4rmekuula'), (u'yhdella', u'yhdell\xe4'), (u'Tasta', u'T\xe4st\xe4'), (u'__', u''), (u'Alk\xe1\xe4', u'\xc4lk\xe4\xe4'), (u'etta', u'ett\xe4'), (u'pitaa', u'pit\xe4\xe4'), (u'n\xe4lk\xe1isi\xe4', u'n\xe4lk\xe4isi\xe4'), (u'Hyva', u'Hyv\xe4'), (u'hyvasta', u'hyv\xe4st\xe4'), (u'ruoastaja', u'ruoasta ja'), (u'K\xe1sivarteni', u'K\xe4sivarteni'), (u'k\xe4ikki', u'kaikki'), (u'Mozukust\xe4', u'Mozukusta'), (u'Etsiv\xe1tk\xf6', u'Etsiv\xe4tk\xf6'), (u'Iohik\xe1\xe1rmekuulaa', u'lohik\xe4\xe4rmekuulaa'), (u'Valonneitsytt\xe1', u'Valonneitsytt\xe4'), (u'taalla', u't\xe4\xe4ll\xe4'), (u'siemeni\xe1\xe1n', u'siemeni\xe4\xe4n'), (u'kunh\xe4n', u'kunhan'), (u'\xe4j\xe4ttelen', u'ajattelen'), (u'pelkuril', u'pelkuri!'), (u'kyla', u'kyl\xe4'), (u'hy\xf6kk\xe1ykselt\xe4', u'hy\xf6kk\xe4ykselt\xe4'), (u'hy\xf6kk\xe1isi', u'hy\xf6kk\xe4isi'), (u'hy\xf6kataan', u'hy\xf6k\xe4t\xe4\xe4n'), (u'Voitjuoda', u'Voit juoda'), (u'Iittaamisesta', u'littaamisesta'), (u'Iahtenyt', u'l\xe4htenyt'), (u'kylasta', u'kyl\xe4st\xe4'), (u'Etjuurik\xe4\xe4n', u'Et juurikaan'), (u's\xe4m\xe4lt\xe4', u'samalta'), (u'k\xe4ikki\xe4ll\xe4', u'kaikkialla'), (u'ehka', u'ehk\xe4'), (u'tiennytkaan', u'tiennytk\xe4\xe4n'), (u'taistelenl', u'taistelen!'), (u'Iiikkeita', u'liikkeit\xe4'), (u'Taistellaanl', u'Taistellaan!'), (u'Odott\xe4m\xe4ttom\xe4t', u'Odottamattomat'), (u'n\xe4utinnot', u'nautinnot'), (u'rikk\xe4\xe4n', u'rikkaan'), (u'Iuotettavalta', u'luotettavalta'), (u'elaa', u'el\xe4\xe4'), (u'pekki\xe3', u'pelkki\xe4'), (u'j\xe3keen', u'j\xe4lkeen'), (u'n\xf6rttej\xe3', u'n\xf6rttej\xe4'), (u'pen\u0131skursseja', u'peruskursseja'), (u'Suorititjo', u'Suoritit jo'), (u'sein\xe4il\xe4', u'sein\xe4ll\xe4'), (u'Iaiteta', u'laiteta'), (u'hennostu', u'hermostu'), (u'Coiumbiassa', u'Columbiassa'), (u'Pen\u0131erssi\xe4', u'Perverssej\xe4'), (u'sukupuoieimisl\xe3', u'sukupuolielimist\xe4'), (u'ep\xe3iooginen', u'ep\xe4looginen'), (u'oisin', u'olisin'), (u'iittoni', u'liittoni'), (u'oisi', u'olisi'), (u'asuntoia', u'asuntola'), (u'p\xe4\xe4sittejatkoseminaariini', u'p\xe4\xe4sitte jatkoseminaariini'), (u'An\u0131atkaapa', u'Arvatkaapa'), (u'Iopussa', u'lopussa'), (u'Oletjo', u'Olet jo'), (u'Haiuan', u'Haluan'), (u'luennoilie', u'luennoille'), (u'Iintsata', u'lintsata'), (u'oletjuuri', u'olet juuri'), (u'Iuuietko', u'luuletko'), (u'kylvyss\xe3', u'kylvyss\xe4'), (u'v\xe3l\xe3hti', u'v\xe4l\xe4hti'), (u'Miettik\xe3\xe3', u'Miettik\xe4\xe4'), (u'insin\xf6\xfcn', u'insin\xf6\xf6ri'), (u'Menithalpaan', u'Menit halpaan'), (u'Tukaa', u'Tulkaa'), (u'Aarun', u'Aaron'), (u'Kieleil\xe4si', u'Kielell\xe4si'), (u'pystytjohonkin', u'pystyt johonkin'), (u'K\xe4mppikseniWilliam', u'K\xe4mppikseni William'), (u'Iuolamies', u'luolamies'), (u'keskian\u0131on', u'keskiarvon'), (u'kananosta', u'kartanosta'), (u'p\xe4iv\xe4lliselie', u'p\xe4iv\xe4lliselle'), (u'Iasagnea', u'lasagnea'), (u'voitehota', u'voi tehota'), (u'0lisit', u'Olisit'), (u'menijuuri', u'meni juuri'), (u'tapasivatjo', u'tapasivat jo'), (u'kn\u0131unukoriiiliiset', u'kruunukorkilliset'), (u'eijuo', u'ei juo'), (u'N\xe4yt\xe4tuupuneeita', u'N\xe4yt\xe4t uupuneelta'), (u'Etan\u0131aakaan', u'Et arvaakaan'), (u'lhanko', u'Ihanko'), (u'y\ufb02t\xe4k\xe4\xe4n', u'yrit\xe4k\xe4\xe4n'), (u'serkkuniWinn', u'serkkuni Winn'), (u'voijatkua', u'voi jatkua'), (u'miehetja', u'miehet ja'), (u'v\xedesfin\xed', u'viestini'), (u'kuull\u0131lsinusla', u'kuullut sinusta'), (u'T\xe3m\xe3', u'T\xe4m\xe4'), (u'kel\xe3\xe3n', u'ket\xe4\xe4n'), (u'vedess\xe3k\xe3veij\xe3', u'vedess\xe4k\xe4velij\xe4'), (u'/abrassa', u'labrassa'), (u'akaa', u'alkaa'), (u'Iiinaa', u'liinaa'), (u'kan\u0131ainen', u'karvainen'), (u'oten', u'olen'), (u'kallaisesi', u'kaltaisesi'), (u'pmffa', u'proffa'), (u'tulitt\xe4nne', u'tulit t\xe4nne'), (u'Alalteko', u'Alatteko'), (u'luuiisit', u'luulisit'), (u'Pys\xe3hdy', u'Pys\xe4hdy'), (u'Paskath\xe4nest\xe4', u'Paskat h\xe4nest\xe4'), (u'Pys\xe3hdyheti', u'Pys\xe4hdy heti'), (u'Heivetti', u'Helvetti'), (u'Pid\xe3l\xe3n', u'Pid\xe4t\xe4n'), (u'V\ufb02ru', u'Varo'), (u'huolissasijostain', u'huolissasi jostain'), (u'hurmaavatpuhelusi', u'hurmaavat puhelusi'), (u'yst\xe4vysiyin', u'yst\xe4vystyin'), (u'Cunya', u'Currya'), (u'cunya', u'currya'), (u'kohdaliani', u'kohdallani'), (u'an\u0131oista', u'arvoista'), (u'Loputn\xe4kev\xe4tn\xe4lk\xe4\xe4', u'Loput n\xe4kev\xe4t n\xe4lk\xe4\xe4'), (u'oletollut', u'olet ollut'), (u'j\xe4ikin\u0131oan', u'j\xe4lkiruoan'), (u'Saath\xe4net', u'Saat h\xe4net'), (u'Kem\u0131n', u'Kerron'), (u'kappaieiksi', u'kappaleiksi'), (u'vuok\u0131anja', u'vuokran ja'), (u'iyperys', u'typerys'), (u'mmanltisella', u'romanttisella'), (u'\u0131akastellut', u'rakastellut'), (u'jutteiimme', u'juttelimme'), (u'vesimittann', u'vesimittarin'), (u'kuikevat', u'kulkevat'), (u'tavaratja', u'tavarat ja'), (u'piiltaal', u'piittaat'), (u'etehk\xe4', u'et ehk\xe4'), (u'Lapsenvahtisituli', u'Lapsenvahtisi tuli'), (u'Ymm\xe4n\xe4lk\xf6', u'Ymm\xe4rr\xe4tk\xf6'), (u'iyii\xe3resi', u'tytt\xe4resi'), (u'my\xf6h\xe3', u'my\xf6h\xe4'), (u'n\xe4hnytAaron', u'n\xe4hnyt Aaron'), (u'haiunnut', u'halunnut'), (u'Olitoikeassa', u'Olit oikeassa'), (u'itseenijuuri', u'itseeni juuri'), (u'lempin\u0131okaani', u'lempiruokaani'), (u'Iupaamaan', u'lupaamaan'), (u'Teetsoimun', u'Teet solmun'), (u'Sen\u0131ice', u'Service'), (u'Iasini', u'lasini'), (u'Ieuassa', u'leuassa'), (u'Iiikekumppaninsa', u'liikekumppaninsa'), (u'Iiikekumppani', u'liikekumppani'), (u'Iausuttiinkaan', u'lausuttiinkaan'), (u'Iastauslaiturille', u'lastauslaiturille'), (u'Oleko', u'Oletko'), (u'tie/t\xe4', u'tielt\xe4'), (u"Mayhew'IIe", u"Mayhew'lle"), (u'Iakiasiaintoimisto', u'lakiasiaintoimisto'), (u'Iakimiest\xe4', u'lakimiest\xe4'), (u'ne//eens\xe4', u'nelleens\xe4'), (u'ha//ituksiin', u'hallituksiin'), (u'soti/aa//isiin', u'sotilaallisiin'), (u'Iahtasit', u'lahtasit'), (u'Tiestik\xf6', u'Tiesitk\xf6'), (u'Iakimiehi\xe4', u'lakimiehi\xe4'), (u'\xc4l\xe4k\xe4\xe4', u'\xc4lk\xe4\xe4'), (u'O/en', u'Olen'), (u'minsta', u'minusta'), (u'Iuennosta', u'luennosta'), (u'Iakimiehest\xe4', u'lakimiehest\xe4'), (u'Iopetatte', u'lopetatte'), (u'0/it', u'0lit'), (u'tu/it', u'tulit'), (u"Mayhew'Ita", u"Mayhew'lta"), (u'I\xe4hiet\xe4isyydell\xe4', u'l\xe4hiet\xe4isyydell\xe4'), (u'ennenkuin', u'ennen kuin'), (u'nukku\xe4', u'nukkua'), (u'ihmisia', u'ihmisi\xe4'), (u'eloss\xe4', u'elossa'), (u'tiedett\xe4v\xe1', u'tiedett\xe4v\xe4'), (u'Etsik\xe1\xe1', u'Etsik\xe4\xe4'), (u'A\u0131ja\u0131', u'Aijai'), (u'V\xe4lonneitsyen', u'Valonneitsyen'), (u'Iup\xe4ust\xe4si', u'lupaustasi'), (u'Y\xe4mikugyo', u'Yamikugyo'), (u'ep\xe4onnistumisi\xe4', u'ep\xe4onnistumisia'), (u'Ymm\xe1rr\xe4tk\xf6', u'Ymm\xe4rr\xe4tk\xf6'), (u'Iohik\xe4\xe4rmekuula', u'lohik\xe4\xe4rmekuula'), (u'tasta', u't\xe4st\xe4'), (u'taynna', u't\xe4ynn\xe4'), (u'mina', u'min\xe4'), (u'tata', u't\xe4t\xe4'), (u'tyhmaa', u'tyhm\xe4\xe4'), (u'enemman', u'enemm\xe4n'), (u'p\xe1tev\xf6ity', u'p\xe4tev\xf6ity'), (u'kylla', u'kyll\xe4'), (u'\xe4rvok\xe4st\xe4', u'arvokasta'), (u'selviytyj\xe1ksi', u'selviytyj\xe4ksi'), (u'myyda', u'myyd\xe4'), (u'hanet', u'h\xe4net'), (u'\xe4pu\xe4si', u'apuasi'), (u'Kuk\xe4', u'Kuka'), (u's\xe4noi', u'sanoi'), (u'\xe4ut\xe4n', u'autan'), (u'\xc4la', u'\xc4l\xe4'), (u'Han', u'H\xe4n'), (u'Mita', u'Mit\xe4'), (u'tama', u't\xe4m\xe4'), (u'Olettiellamme', u'Olet tiell\xe4mme'), (u'Kylani', u'Kyl\xe4ni'), (u'Iahdemme', u'l\xe4hdemme'), (u'viela', u'viel\xe4'), (u'yhdeksan', u'yhdeks\xe4n'), (u'Nasaviisaudet', u'N\xe4s\xe4viisaudet'), (u'L\xe1hemp\xe4n\xe4', u'L\xe4hemp\xe4n\xe4'), (u'tietaa', u'tiet\xe4\xe4'), (u'mentava', u'ment\xe4v\xe4'), (u'onk\xe4\xe4n', u'onkaan'), (u'tekemista', u'tekemist\xe4'), (u'Sina', u'Sin\xe4'), (u'sina', u'sin\xe4'), (u'kiitett\xe4v\xe1', u'kiitett\xe4v\xe4'), (u'edell\xe1mme', u'edell\xe4mme'), (u'eika', u'eik\xe4'), (u'Takanas\ufb02', u'Takanasi!'), (u'Iankaan', u'lankaan'), (u'v\xe4lloillens\xe4', u'valloillensa'), (u'siita', u'siit\xe4'), (u'Iohikaarmekuulan', u'lohik\xe4\xe4rmekuulan'), (u'Keta', u'Ket\xe4'), (u'nama', u'n\xe4m\xe4'), (u'ajateltavaal', u'ajateltavaa!'), (u'oll\xe4kseni', u'ollakseni'), (u'v\xe4rm\xe4', u'varma'), (u'hanta', u'h\xe4nt\xe4'), (u'hanelle', u'h\xe4nelle'), (u'Os\xe4\xe4tko', u'Osaatko'), (u'rajahteita', u'r\xe4j\xe4hteit\xe4'), (u'Jyashil', u'Jyashi!'), (u'Nama', u'N\xe4m\xe4'), (u'sita', u'sit\xe4'), (u'kosk\xe4\xe4n', u'koskaan'), (u'Viek\xe1\xe1', u'Viek\xe4\xe4'), (u'Pid\xe1tt\xe4k\xe4\xe4', u'Pid\xe4tt\xe4k\xe4\xe4'), (u'Oclottakaal', u'Odottakaa!'), (u'pelk\xe1\xe4m\xe1', u'pelk\xe4\xe4m\xe4'), (u'ost\xe4v\xe4nne', u'ostavanne'), (u'rovoill\xe4nne', u'rovoillanne'), (u'Jon\xe4in', u'Jonain'), (u"piit'taa", u'piittaa'), (u'>', u''), (u't\xe1ysikuu', u't\xe4ysikuu'), (u'sinutt\xe4nne', u'sinut t\xe4nne'), (u'Iahtea', u'l\xe4hte\xe4'), (u'Paastaksemme', u'P\xe4\xe4st\xe4ksemme'), (u'P\xe1rj\xe1\xe4mme', u'P\xe4rj\xe4\xe4mme'), (u'h\xe4nsk\xe4ss\xe4', u'hanskassa'), (u'Tama', u'T\xe4m\xe4'), (u'Menkaa', u'Menk\xe4\xe4'), (u'H\xe4ipyk\xe1\xe1', u'H\xe4ipyk\xe4\xe4'), (u'kasin', u'k\xe4sin'), (u'Tata', u'T\xe4t\xe4'), (u'Hylkaatk\xf6', u'Hylk\xe4\xe4tk\xf6'), (u'Paasta', u'P\xe4\xe4st\xe4'), (u'ry\xf6st\xe4\xe1', u'ry\xf6st\xe4\xe4'), (u'Iivist\xe4', u'livist\xe4'), (u'viivyt\xe1t', u'viivyt\xe4t'), (u'Pys\xe4htyk\xe1\xe4', u'Pys\xe4htyk\xe4\xe4'), (u'k\xe4nnoilt\xe4', u'kannoilta'), (u'k\xe1sken', u'k\xe4sken'), (u'Pys\xe4htyk\xe1\xe1', u'Pys\xe4htyk\xe4\xe4'), (u'huonoj\xe1tk\xe4', u'huono j\xe4tk\xe4'), (u'k\xe1tyrini', u'k\xe4tyrini'), (u'mitaan', u'mit\xe4\xe4n'), (u'Missa', u'Miss\xe4'), (u'kynt\xe4v\xe1n', u'kynt\xe4v\xe4n'), (u'p\xe4rj\xe1nneet', u'p\xe4rj\xe4nneet'), (u'ruok\xe4\xe4', u'ruokaa'), (u'm\xe4rjoj\xe4', u'marjoja'), (u'kuink\xe4', u'kuinka'), (u'oll\xe4', u'olla'), (u'missa', u'miss\xe4'), (u'Per\xe1\xe4nny', u'Per\xe4\xe4nny'), (u'Pysyk\xe1\xe4', u'Pysyk\xe4\xe4'), (u'Vetel\xe0t', u'Vetel\xe4t'), (u't\xe4pp\xe4\xe4', u'tappaa'), (u'ketaan', u'ket\xe4\xe4n'), (u'pelkaamaan', u'pelk\xe4\xe4m\xe4\xe4n'), (u'ovatja', u'ovat ja'), (u'ymmarra', u'ymm\xe4rr\xe4'), (u'ystv\xe4ni', u'yst\xe4v\xe4ni'), (u'K\xe4rp\xe1si\xe4k\xf6', u'K\xe4rp\xe4si\xe4k\xf6'), (u'mets\xe1st\xe4t', u'mets\xe4st\xe4t'), (u'Iiittya', u'liitty\xe4'), (u'Al\xe1', u'\xc4l\xe4'), (u'py\xf6rty\xe1', u'py\xf6rty\xe4'), (u'n\xe4l\xe4st\xe1', u'n\xe4l\xe4st\xe4'), (u'hyva', u'hyv\xe4'), (u'sy\xf6maan', u'sy\xf6m\xe4\xe4n'), (u'katyreita', u'k\xe4tyreit\xe4'), (u'Ep\xe1reilua', u'Ep\xe4reilua'), (u'L\xe4utt\xe4', u'Lautta'), (u'ilt\xe4n\xe4', u'iltana'), (u'T\xe4isimme', u'Taisimme'), (u'Voih\xe4n', u'Voihan'), (u'hittol\xe4inen', u'hittolainen'), (u'J\xe4', u'Ja'), (u'Iohik\xe1\xe1rmekivi', u'lohik\xe4\xe4rmekivi'), (u'siina', u'siin\xe4'), (u'Iaake', u'l\xe4\xe4ke'), (u'purrutjokin', u'purrut jokin'), (u'tahan', u't\xe4h\xe4n'), (u'paasseet', u'p\xe4\xe4sseet'), (u'Iaakkeen', u'l\xe4\xe4kkeen'), (u'Ieposija', u'leposija'), (u'Kylla', u'Kyll\xe4'), (u'pitkalta', u'pitk\xe4lt\xe4'), (u'eivat', u'eiv\xe4t'), (u'tanne', u't\xe4nne'), (u'taman', u't\xe4m\xe4n'), (u'Ehka', u'Ehk\xe4'), (u'han', u'h\xe4n'), (u'mista', u'mist\xe4'), (u'pidat', u'pid\xe4t'), (u'Joutuk\xe4\xe4', u'Joutukaa'), (u'Hanen', u'H\xe4nen'), (u'sisallaan', u'sis\xe4ll\xe4\xe4n'), (u'Pysyk\xe1\xe1', u'Pysyk\xe4\xe4'), (u'L\xe4htek\xe4\xe1', u'L\xe4htek\xe4\xe4'), (u'til\xe4\xe4n', u'tilaan'), (u'paatella', u'p\xe4\xe4tell\xe4'), (u'isani', u'is\xe4ni'), (u'paasemme', u'p\xe4\xe4semme'), (u'haipyivat', u'h\xe4ipyiv\xe4t'), (u'Teh\xe1n', u'Teh\xe4n'), (u'Hy\xf6kk\xe1\xe4tte', u'Hy\xf6kk\xe4\xe4tte'), (u'Iiikahdattekaan', u'liikahdattekaan'), (u'j\xe4', u'ja'), (u'v\xe4lmist\xe4uduin', u'valmistauduin'), (u'Hikavvassa', u'Hikawassa'), (u'Kuolel', u'Kuole!'), (u'hanen', u'h\xe4nen'), (u'yhta', u'yht\xe4'), (u'Sisalla', u'Sis\xe4ll\xe4'), (u'ruumiiss\xe4', u'ruumiissa'), (u'minka', u'mink\xe4'), (u'Iih\xe4\xe4', u'lihaa'), (u'Iuut\xe4', u'luuta'), (u'Sis\xe0ll\xe0mme', u'Sis\xe4ll\xe4mme'), (u'Tottelel', u'Tottele!'), (u'\xc4l\xe4j\xe4t\xe4', u'\xc4l\xe4 j\xe4t\xe4'), (u'aitisi', u'\xe4itisi'), (u'Mina', u'Min\xe4'), (u'ymmartamaan', u'ymm\xe4rt\xe4m\xe4\xe4n'), (u'sy\xf6daan', u'sy\xf6d\xe4\xe4n'), (u'p\xe4h\xe4lt\xe4', u'pahalta'), (u'D\xe4ku\xe4n', u'Dakuan'), (u'sirkutahti', u'sirkust\xe4hti'), (u'Iapiota', u'lapiota'), (u'mieltasi', u'mielt\xe4si'), (u'pitaisi', u'pit\xe4isi'), (u'vieda', u'vied\xe4'), (u't\xe1\xe1ll\xe4k\xe4\xe1n', u't\xe4\xe4ll\xe4k\xe4\xe4n'), (u'taytyy', u't\xe4ytyy'), (u'kivesta', u'kivest\xe4'), (u'etsia', u'etsi\xe4'), (u'Poikatyt\xf6st\xe0', u'Poikatyt\xf6st\xe4'), (u'hy\xf6kkasi', u'hy\xf6kk\xe4si'), (u'takaapain', u'takaap\xe4in'), (u'I\xe4skee', u'laskee'), (u'haipya', u'h\xe4ipy\xe4'), (u'tehcl\xe1kseni', u'tehd\xe4kseni'), (u'pi\xe4n', u'pian'), (u'tyrkytt\xe4\xe1', u'tyrkytt\xe4\xe4'), (u'minu\xe4', u'minua'), (u'n\xe1lk\xe1inen', u'n\xe4lk\xe4inen'), (u'Sydamet\xf6n', u'Syd\xe4met\xf6n'), (u'hylata', u'hyl\xe4t\xe4'), (u'yha', u'yh\xe4'), (u'k\xe4uniisti', u'kauniisti'), (u'ihmisverest\xe1', u'ihmisverest\xe4'), (u'Siii\xe4', u'Sin\xe4'), (u'h\xe4lu\xe4t', u'haluat'), (u'Iahemmin', u'l\xe4hemmin'), (u'kayttaa', u'k\xe4ytt\xe4\xe4'), (u'hyvaksi', u'hyv\xe4ksi'), (u'paase', u'p\xe4\xe4se'), (u'siivilla', u'siivill\xe4'), (u'j\xe4lkel\xe4is\xe1', u'j\xe4lkel\xe4isi\xe4'), (u'syista', u'syist\xe4'), (u'pyh\xe1\xe4', u'pyh\xe4\xe4'), (u'Tyhmat', u'Tyhm\xe4t'), (u'pyytavat', u'pyyt\xe4v\xe4t'), (u'H\xf6lynp\xf6ly\xe4l', u'H\xf6lynp\xf6ly\xe4!'), (u'Nakivat', u'N\xe4kiv\xe4t'), (u'kannissa', u'k\xe4nniss\xe4'), (u'kasivarren', u'k\xe4sivarren'), (u'h\xe1nenlaisensa', u'h\xe4nenlaisensa'), (u'sol\xe4\xe4', u'solaa'), (u'Iiioitella', u'liioitella'), (u'Iiioittele', u'liioittele'), (u'Tiedathan', u'Tied\xe4th\xe4n'), (u'pyh\xe1st\xe4', u'pyh\xe4st\xe4'), (u'Iohik\xe1\xe1rmekivest\xe4', u'lohik\xe4\xe4rmekivest\xe4'), (u'Ymm\xe1rr\xe1t', u'Ymm\xe4rr\xe4t'), (u'\xe4rmonne', u'armonne'), (u'n\xe4isten', u'naisten'), (u'Iup\xe4ukseni', u'lupaukseni'), (u'kekseli\xe1isyytesi', u'kekseli\xe4isyytesi'), (u'Iaudalta', u'laudalta'), (u'kest\xe1vyytesi', u'kest\xe4vyytesi'), (u'taiclakaan', u'taidakaan'), (u'tytt\xf6ystava', u'tytt\xf6yst\xe4v\xe4'), (u'sormiss\xe4ni', u'sormissani'), (u'r\xe4ivois\xe4n', u'raivoisan'), (u'k\xe4rhun', u'karhun'), (u'helvetista', u'helvetist\xe4'), (u'v\xe4i', u'vai'), (u'poiss\xe4', u'poissa'), (u'elamani', u'el\xe4m\xe4ni'), (u'pitk\xe1tjalkasi', u'pitk\xe4t jalkasi'), (u'Kadet', u'K\xe4det'), (u'niita', u'niit\xe4'), (u'Kaske', u'K\xe4ske'), (u'paastaa', u'p\xe4\xe4st\xe4\xe4'), (u'Pida', u'Pid\xe4'), (u'Iohikaarmekivi', u'lohik\xe4\xe4rmekivi'), (u'sinust\xe4', u'sinusta'), (u'sy\xf6ksyyjo', u'sy\xf6ksyy jo'), (u'veljeasi', u'velje\xe4si'), (u'Odot\xe4', u'Odota'), (u'Pys\xe1hdy', u'Pys\xe4hdy'), (u'kivea', u'kive\xe4'), (u'Missaan', u'Miss\xe4\xe4n'), (u'tihe\xe1mpi', u'tihe\xe4mpi'), (u'Iuulitkaan', u'luulitkaan'), (u'kaarmekuula', u'k\xe4\xe4rmekuula'), (u'muttaj\xe4t\xe4n', u'mutta j\xe4t\xe4n'), (u'kuoletl', u'kuolet!'), (u'Iohikaarmekuula', u'lohik\xe4\xe4rmekuula'), (u'kieltava', u'kielt\xe4v\xe4'), (u'L\xe1htek\xe1\xe1', u'L\xe4htek\xe4\xe4'), (u'Iohik\xe1\xe4rmekuulaa', u'lohik\xe4\xe4rmekuulaa'), (u'hereilla', u'hereill\xe4'), (u'kaljupaa', u'kaljup\xe4\xe4'), (u'\xe4nt\xe4m\xe4ll\xe4', u'antamalla'), (u'kuul\xe4n', u'kuulan'), (u't\xe4k\xe4isin', u'takaisin'), (u'puolikk\xe4\xe4n', u'puolikkaan'), (u'pohjoisessaja', u'pohjoisessa ja'), (u'metsasta', u'mets\xe4st\xe4'), (u'Iohik\xe4\xe4rmekuul\xe4lle', u'lohik\xe4\xe4rmekuulalle'), (u'teita', u'teit\xe4'), (u'Linnutk\xe4\xe4n', u'Linnutkaan'), (u'Puolikk\xe4\xe4n', u'Puolikkaan'), (u'\xe4nt\xe4nut', u'antanut'), (u'tiedan', u'tied\xe4n'), (u'her\xe1tt\xe1m\xe1ss\xe1', u'her\xe4tt\xe4m\xe4ss\xe4'), (u'I\xe4sin', u'lasin'), (u'h\xe4t\xe1n\xe4', u'h\xe4t\xe4n\xe4'), (u'I\xf6ysitte', u'l\xf6ysitte'), (u"a//\u0131'gaal'tor\u0131h", u'alligaattorin'), (u'Tyttbparka', u'tytt\xf6parka'), (u'b\xe4n\xe3\xe4', u'b\xe4n\xe4\xe4'), (u'Co/en', u'Colen'), (u'Iapsiko\u0131fin', u'lapsikortin'), (u'rauhallisemminl', u'rauhallisemmin!'), (u'Iahjasi', u'lahjasi'), (u'Ruokih\xe4net', u'Ruoki h\xe4net'), (u'I\xf6ystymist\xe4', u'l\xf6ystymist\xe4'), (u'Iapsestaan', u'lapsestaan'), (u'Iaatuaikaa', u'laatuaikaa'), (u'Ioukkaannuit', u'loukkaannuit'), (u'Ioistojuttu', u'loistojuttu'), (u'Ioukkaavaa', u'loukkaavaa'), (u'Ioukkaan', u'loukkaan'), (u"l'\u0131ed\xe4n", u'Tied\xe4n'), (u'Iy\xf6m\xe4st\xe4', u'ly\xf6m\xe4st\xe4'), (u'C/\u0131\xe2teauneuf', u'Ch\xe2teauneuf'), (u'Iikaisten', u'likaisten'), (u'Iapsenlapseton', u'lapsenlapseton'), (u'Ieukani', u'leukani'), (u'Ientokonetta', u'lentokonetta'), (u'Iorrainea', u'lorrainea'), (u'Iastentarhaan', u'lastentarhaan'), (u'Iupaavin', u'lupaavin'), (u'Iastenhoitaja', u'lastenhoitaja'), (u'Kegeleit\xe3', u'Kegeleit\xe4'), (u'helkkaril', u'helkkari!'), (u'Ieukaani', u'leukaani'), (u'Iaihtuneen', u'laihtuneen'), (u'Iahjoittamaan', u'lahjoittamaan'), (u'tref\ufb02t', u'treffit'), (u'I\xf6ysyys', u'l\xf6ysyys'), (u'Diggleri\xe3', u'Diggleri\xe4'), (u'Ku\u0131fi//a', u'Kurtilla'), (u'pys\xe3hdell\xe4', u'pys\xe4hdell\xe4'), (u'Iomaasi', u'lomaasi'), (u'Iastattu', u'lastattu'), (u'Iasinne', u'lasinne'), (u'Iuihin', u'luihin'), (u'Iastensuojelujuttuun', u'lastensuojelujuttuun'), (u'Ieffaan', u'leffaan'), (u'mulkkul', u'mulkku!'), (u'Iapsenvahtia', u'lapsenvahtia'), (u'I\xe4hell\xe4si', u'l\xe4hell\xe4si'), (u'st\xe3', u'st\xe4'), (u'TOSi', u'Tosi'), (u'Ioistoidea', u'loistoidea'), (u'Ty\u0131si\xe4', u'Tylsi\xe4'), (u'lsi', u'Isi'), (u'Iaastarin', u'laastarin'), (u'Viewjatkuu', u'View jatkuu'), (u'lnStylen', u'InStylen'), (u'k\xf6ril\xe4sl', u'k\xf6ril\xe4s!'), (u'Ieffoissa', u'leffoissa'), (u'Ieffaseuraksi', u'leffaseuraksi'), (u'Iueskelemaan', u'lueskelemaan'), (u'Mit\xe4j\xe4tk\xe4', u'Mit\xe4 j\xe4tk\xe4'), (u'Iaukesitkaan', u'laukesitkaan'), (u'Kiit\xe3', u'Kiit\xe4'), (u'\xc4\xe3Ii\xf6', u'\xc4\xe4li\xf6'), (u'Iyhytp\xf6ksy', u'lyhytp\xf6ksy'), (u'Iacrosse', u'lacrosse'), (u'I\xf6yt\xe3m\xe3tt\xe3', u'l\xf6yt\xe4m\xe4tt\xe4'), (u'samojajuttuja', u'samoja juttuja'), (u'J\xe4rvellel', u'J\xe4rvelle!'), (u'Talouspaperitl', u'Talouspaperit!'), (u'\xc4lk\xe4\xe3s', u'\xc4lk\xe4\xe4s'), (u'pillunaamal', u'pillunaama!'), (u'poikayst\xe4v\xe4ns\xe3', u'poikayst\xe4v\xe4ns\xe4'), (u'Iapsenvahti', u'lapsenvahti'), (u'Nykist\xe3', u'Nykist\xe4'), (u'Iaatuaikamme', u'laatuaikamme'), (u'K\xe4\xe3nsin', u'K\xe4\xe4nsin'), (u'Iatinaksi', u'latinaksi'), (u'yleens\xe4juo', u'yleens\xe4 juo'), (u'kreisej\xe3juttuja', u'kreisej\xe4 juttuja'), (u'Iiitostasi', u'liitostasi'), (u'Mit\xe4jos', u'Mit\xe4 jos'), (u'Sinullaja', u'Sinulla ja'), (u'Iempparini', u'lempparini'), (u'Iienetkin', u'lienetkin'), (u'Iuokkajuhla', u'luokkajuhla'), (u'Iuokkakokouksesta', u'luokkakokouksesta'), (u'Iukuteeman', u'lukuteeman'), (u'Menejo', u'Mene jo'), (u'Sin\xe3j\xe4tit', u'Sin\xe4 j\xe4tit'), (u'I\xe4ht\xf6\xe3si', u'l\xe4ht\xf6\xe4si'), (u'I\xe3\xe4kikseen', u'l\xe4\xe4kikseen'), (u'puhuajostain', u'puhua jostain'), (u'tavatajoku', u'tavata joku'), (u'Iookia', u'lookia'), (u'Iapsiyst\xe4v\xe4llisemp\xe3n\xe3', u'lapsiyst\xe4v\xe4llisemp\xe4n\xe4'), (u'is\xe3nn\xe4lle', u'is\xe4nn\xe4lle'), (u't\xe3', u't\xe4'), (u'Ieidi', u'leidi'), (u'K\xe3visik\xf6', u'K\xe4visik\xf6'), (u'maris\xe3tk\xe4', u'maris\xe4tk\xe4'), (u'k\xe4nniss\xe4j\xe4rveen', u'k\xe4nniss\xe4 j\xe4rveen'), (u'sinullajotain', u'sinulla jotain'), (u'Iuntun', u'luntun'), (u'Iunttu', u'lunttu'), (u'Iukitsin', u'lukitsin'), (u'jyyst\xe3\xe4', u'jyyst\xe4\xe4'), (u'Iuokkajuhlaan', u'luokkajuhlaan'), (u'Michellest\xe3', u'Michellest\xe4'), (u'Iuokkakokous', u'luokkakokous'), (u'sin\xe4ja', u'sin\xe4 ja'), (u'Sin\xe3ja', u'Sin\xe4 ja'), (u'Sill\xe3joskus', u'Sill\xe4 joskus'), (u'Iopetimme', u'lopetimme'), (u'Ymm\xe3rr\xe3tk\xf6', u'Ymm\xe4rr\xe4tk\xf6'), (u'kanssajoka', u'kanssa joka'), (u'Iiioitellusti', u'liioitellusti'), (u'Iaihalta', u'laihalta'), (u'Miaja', u'Mia ja'), (u'Mietit\xe3\xe4np\xe3', u'Mietit\xe4\xe4np\xe4'), (u'Ky\u0131\u0131\xe4', u'Kyll\xe4'), (u'Pid\xe3ttelel', u'Pid\xe4ttele!'), (u'ymm\xe4rt\xe3misest\xe4', u'ymm\xe4rt\xe4misest\xe4'), (u'jaj\xe4\xe4n', u'ja j\xe4\xe4n'), (u'Selenaja', u'Selena ja'), (u'Iuokkakokousta', u'luokkakokousta'), (u'\xe1k\xe1pussi', u'\xe4k\xe4pussi'), (u'karkoituksen', u'karkotuksen')]),
                        'pattern': u"(?um)(\\b|^)(?:kellojo|onjo|senj\\\xe4lkeen|Ts\\\xe4u|hydraulinenjousitus|Kevyetja|Oleijo|viimeinenjuna|n\\\xe4ytt\\\xe4\\\xe4jotenkin|onjoku|Iapsuuteen|Ieikitjunill\\\xe4|Sfiy|Iukulasejani|Ieikkiminen|K\\\xe4\\\xe4lik\\\xe4\\\xe4rylepizz\\\xe4|sukl\\\xe4\\\xe4k\\\xe4stikkeen|p\\\xe4istetun|b\\\xe4n\\\xe4\\\xe4nin|pifi|a\\\u0131keasfaan|Stg|sikain\\\ufb02uenssatja|Hienojuna|kiinnostuajunista|h\\\xe4y\\\u0131yvetu\\\u0131\\\xedn|pienaismalli|ena|racfios\\\xe3hk\\\xe4ff\\\xe1j\\\xe3n\\\xe3|Amenkan|laiva\\/la|0\\/in|Junaha\\\u0131rasfus|enasfa|\\/V\\\u0131\\\xedn|Oliivarmasii|Internetist\\\xe4juuri|hu\\\u0131janj\\\xe3nniff\\\xe5v\\\xe3\\\xe0l|Vaikkajunat|k\\\xe4\\\xe4ntyija|osaajotain|Ieikill\\\xe4mme|Bellinjuna|t\\\xe4st\\\xe4johtolangasta|tuntisijonkun|Olgajotain|tulokseivuodesia|tuloksetvuodesta|Vainjalkapallo|lloveyou|po\\\ufb02\\\u2039aisi|minufulos|Ieiv\\\xe4npaahdinl|Ieiv\\\xe4npaahdinta|asuajossain|Koiratjuoksentelivat|tiet\\\xe4\\\xe4jotain|osaatjuna|va\\/as|va\\/asperhe|koskeejotain|I\\\xe4\\\xe4kkeens\\\xe4|Iaulavan|Kuulitj\\\xe4\\\xe4n|Ievolle|Va\\/aa\\/\\/e|va\\/aa\\/\\/a|I\\\xe4hdenkin|Iakkiin|Iohik\\\xe4\\\xe4rmeell\\\xe4|Mik\\\u0131|Iukossa|Va\\/aan|s\\\xe4ve\\/m\\\xe4|j\\\xe4\\/\\/een|P\\\xf6\\\xf6\\\u0131|Hnjaa|Iiftasin|Jute\\/\\/aan|Iohduttamaan|L\\'lYP\\\xe4f\\\xe4\\\xe4n|\\\xc4\\\u0131r\\\u0131\\\u0131|F\\\u0131\\\u0131\\\u0131p\\\u0131|Yr\\\u203ar\\\u203a\\\xe4\\\xe4\\\u0131|Miki|Heng\\\u0131r\\\xe4\\\u0131|Va\\/as|Ko\\/\\/\\/is|Audieja|I\\/man|\\/entotukia\\/ukse\\/ta|\\/aivastosta|\\/entotukikohtaan|tu\\/ee|akse\\/iva\\/\\/at|a\\\u0131\\\u0131ek\\\u0131rjo\\\u0131rerr\\\u0131\\\u0131n|Iitkua|0li|Iaskuvarjojoukkoihin|Iaskuvarjojoukoissa|Tarvitsetjotain|Ieukaremmi|Iainaatko|p\\\xe4\\\xe4llik\\\xf6lleja|I\\\xe4hell\\\xe4ni|Soti\\/aan|va\\/\\/attava|viho\\/\\/ise\\/ta|\\/iittoutuneet|voitjohtaa|pohditkojotain|viho\\/\\/ista|sej\\\xe4isi|Ient\\\xe4jill\\\xe4|Soltutl|Iaulustamme|Iakkiani|Iiemeen|kanadala\\\u0131\\\u0161ia|si\\/\\/anp\\\xe4\\\xe4asema|vahv\\\u0131\\\u0161tettiin|tu\\/ituki|eliitt\\\u0131joukkoa|pa\\\u0131ka\\\u0131\\\u0131as\\\u0131\\\u0131|Ieikkinyt|Iujitettu|Ete\\/\\\xe4|viho\\/\\/isranna\\/\\/e|sivusta\\/ta|\\/oppuisi|Iaskuvarjojoukkojen|p\\\xe4\\\xe4tt\\\xe4nytj\\\xe4\\\xe4d\\\xe4|Iuutnanteille|I\\\xe4ht\\\xf6valmiiksi|Iokoisat|Korjaus\\/ukemat|tanke\\/\\/\\/e|ky\\\u0131\\\u0131\\\xe4\\\u0131|Iisti\\\xe4|Kunniamita\\/in|Vemon|fied\\\xe3n|Ei\\\u0131is|Inlem\\\xe4tion\\\xe4|holelfss\\\xe4|Han\\\u0131ey|peikk\\\xe4|Ehisl\\\xe3|Y\\\ufb02\\\xe3ll\\\xe3v\\\xe3|mahdolisuus|loisteiaan|aku|Garonilie|Iikainen|vaiehtelijoita|puutari\\\u0131aasi|Garunin|oravaietti\\\xe4|paijon|sutja|gospeikvartetissa|Iauiajaksi|viihdylt\\\xe4j\\\xe4|hannaala|Iaulajalta|saatjotain|L\\\xf6yd\\\xe4njonkun|py\\\xfcr\\\xedyi|Cn\\\u0131dupia|Iiikaa|ke\\\u0131taa|Thafs|Kappaietta|soijoka|Levytl\\\xe4|paiaamista|kuonnunn|Tytt\\\xfcyst\\\xe4v\\\xe4t|k\\\xe3p\\\xe3l\\\xf6ifiin|Oiko|tuipalo|hebofiavaa|ongeina|ongeimia|Ajateikaa|ku\\\u0131ki|lhailen|L\\\xe4ht\\\xfcsi|yhti\\\xf6ile|eitoimi|voij\\\xe4\\\xe4d\\\xe4|Pomkat|kon\\\u0131ata|konsentien|Sep\\\xe3|hebolus|k\\\xfcyryss\\\xe4|repiat|kuikee|pon\\\u0131koita|naisetja|ten\\\u0131etuileeksi|yl\\\xe4puolelia|kuullut180|Iapsellista|esiinnytja|Iaulat|Henanjestas|teilie|IIe|t\\\xe4ilaisia|Varu|nimeli\\\xe4\\\xe4n|anneijaan|pen\\\u0131staa|minkkitu\\\u0131kkia|minkkituiiiilla|Ten\\\u0131etuioa|kuitalevy\\\xe4|ei\\\xe4m\\\xe4ss\\\xe4|jutkaisua|Fo\\\u0131t|oien|asioilie|Eitarvitsekaan|p\\\xf6kenyin|yll\\\xe4iiyy|komeaita|Chadie|laulaisilteko|Iaittaa|iytt\\\xe4renne|pikkutytt\\\xfcn\\\xe4|tytt\\\xfckulta|vimuilua|reporitereita|vime|eijohdu|eriiainen|Iasketa|kem\\\u0131ttu|Manyja|etteijutusta|Katifomiassa|sun\\\xb0filaudan|bn\\\u0131netti|vaimiina|yiim\\\xe4\\\xe4r\\\xe4iset|leffatj\\\xe4\\\xe4|koin\\'lle|T\\\xe4ilaisen|antanutjo|Cha\\\u0131lien|ymp\\\xe4riliesi|Iy\\\xfc|lopan\\'t|h\\\u0131isi|kuuiuvanijonnekin|juh\\\u0131n|miefkseni|Tuisitko|I\\\u0131on\\\xe4ni|\\\xe4k\\\xe4\\\xe4|yi|rupallelemaan|Priscilialla|Hemmoltelet|Hearlbreak|Holelia|Nyton|kiertueeile|Elvist\\\xe3|puoleila|\\\xc4\\\u0131\\\xe4|lnlemalional|Iuottamustanne|Mycroft\\\xedsta|Iopettako|Ielukauppa|Iomamatkalle|Iyhyelle|Alk\\\xe4\\\xe4|K\\_uka|IIa|Aitinne|V\\\xe4\\/ikohtaus|kuo\\/\\/aan|n\\\xe4\\/k\\\xe4\\\xe4n|Su\\/je|I\\\xe4im\\\xe4ytit|I\\\xe4hetyst\\\xf6ss\\\xe4|I\\\xe4hetyst\\\xf6\\\xf6n|Iaosilainen|Iiiketarjous|kaappavat|Ieiviss\\\xe4\\\xe4n|EriC|Voi\\/\\\xe0|Crawley\\\u0131|Iihaksiaan|Iuenkaan|Olemma|I\\\xe4htisitte|jot\\\xe2in|Eversi|Ieiriyty\\\xe4|Iiikutte|I\\\xe4\\\xe4ketiedett\\\xe4|Iivet\\\xe4|Iapsetkin|I\\\xe4\\\xe4keluettelo|Iaatiko|hyvih|Ieukakuoppa|Ient\\\xe4j\\\xe4ni|Ieikkisi|Iupaamastaan|ku\\/taseni|tu\\/en|Iautalle|100\\_vuotiaaksi|\\_|Viilt\\\xe4j\\\xe3\\_Jackin|keff\\\xe4rfkerro|tan\\/itsi|\\_Aivan|\\_Valosta|\\_Teemmek\\\xf6|Viilt\\\xe4j\\\xe4\\_Jack|\\_Voi|\\_Tied\\\xe4tte|kulunutjo|Vuokra\\_auto|\\_Tuokaa|\\_Tunnetteko|\\_Tied\\\xe4mme|toissay\\\xf6n|\\_Toki|\\_Ammuttu|\\_Jahtasit|\\_Tunnenko|\\_Joku|\\_Taivahan|Kuorma\\_auto|\\_Vain|Mesmer\\_klubille|0nslow\\'IIe|Mesmer\\_klubi|\\_Anteeksi|Schrenk\\_Notzing|\\_Tapoin|\\_AIk\\\xe4\\\xe4|0dotan|Iuonteenlu|Iempikaupunkini|Iavasta|I\\\xe4mmittelij\\\xe4t|Iaastaria|Riiu\\\xe4\\\xe4|K\\\xe4yu\\\xe4v\\\xe4tk\\\xf6|I\\\xe4hestyk\\\xf6|Ieikekirja|Ievyj\\\xe4\\\xe4n|Iahjoitamme|L\\\xe4pp\\\xe4\\\xe4tuohon|CIawdy|mita|jalkeen|Cannabisjaponica|Ieningin|ki\\\u0131joitatte|ki\\\u0131joitetuksi|kuluttuu|Iuvulta|Ieipomiskilpailuun|Maclntire|Iehteemme|Al\\\xe4|kysesss\\\xe4|Itsepuolustustal|Iiipasimesta|Iuutani|Iahjansa|I\\\xe4himm\\\xe4isemme|Iuhistuu|\\\u0131\\\xf6yhk\\\xe4|Iehtileikkeleit\\\xe4|vefieni|Iapselleni|ep\\\xe4normaalinal|Iuurankoja|Iuurangoista|p\\\xe4\\\xe4tiellel|Valonneitsytta|Iohik\\\xe1\\\xe1rmekuula|yhdella|Tasta|\\_\\_|Alk\\\xe1\\\xe4|etta|pitaa|n\\\xe4lk\\\xe1isi\\\xe4|Hyva|hyvasta|ruoastaja|K\\\xe1sivarteni|k\\\xe4ikki|Mozukust\\\xe4|Etsiv\\\xe1tk\\\xf6|Iohik\\\xe1\\\xe1rmekuulaa|Valonneitsytt\\\xe1|taalla|siemeni\\\xe1\\\xe1n|kunh\\\xe4n|\\\xe4j\\\xe4ttelen|pelkuril|kyla|hy\\\xf6kk\\\xe1ykselt\\\xe4|hy\\\xf6kk\\\xe1isi|hy\\\xf6kataan|Voitjuoda|Iittaamisesta|Iahtenyt|kylasta|Etjuurik\\\xe4\\\xe4n|s\\\xe4m\\\xe4lt\\\xe4|k\\\xe4ikki\\\xe4ll\\\xe4|ehka|tiennytkaan|taistelenl|Iiikkeita|Taistellaanl|Odott\\\xe4m\\\xe4ttom\\\xe4t|n\\\xe4utinnot|rikk\\\xe4\\\xe4n|Iuotettavalta|elaa|pekki\\\xe3|j\\\xe3keen|n\\\xf6rttej\\\xe3|pen\\\u0131skursseja|Suorititjo|sein\\\xe4il\\\xe4|Iaiteta|hennostu|Coiumbiassa|Pen\\\u0131erssi\\\xe4|sukupuoieimisl\\\xe3|ep\\\xe3iooginen|oisin|iittoni|oisi|asuntoia|p\\\xe4\\\xe4sittejatkoseminaariini|An\\\u0131atkaapa|Iopussa|Oletjo|Haiuan|luennoilie|Iintsata|oletjuuri|Iuuietko|kylvyss\\\xe3|v\\\xe3l\\\xe3hti|Miettik\\\xe3\\\xe3|insin\\\xf6\\\xfcn|Menithalpaan|Tukaa|Aarun|Kieleil\\\xe4si|pystytjohonkin|K\\\xe4mppikseniWilliam|Iuolamies|keskian\\\u0131on|kananosta|p\\\xe4iv\\\xe4lliselie|Iasagnea|voitehota|0lisit|menijuuri|tapasivatjo|kn\\\u0131unukoriiiliiset|eijuo|N\\\xe4yt\\\xe4tuupuneeita|Etan\\\u0131aakaan|lhanko|y\\\ufb02t\\\xe4k\\\xe4\\\xe4n|serkkuniWinn|voijatkua|miehetja|v\\\xedesfin\\\xed|kuull\\\u0131lsinusla|T\\\xe3m\\\xe3|kel\\\xe3\\\xe3n|vedess\\\xe3k\\\xe3veij\\\xe3|\\/abrassa|akaa|Iiinaa|kan\\\u0131ainen|oten|kallaisesi|pmffa|tulitt\\\xe4nne|Alalteko|luuiisit|Pys\\\xe3hdy|Paskath\\\xe4nest\\\xe4|Pys\\\xe3hdyheti|Heivetti|Pid\\\xe3l\\\xe3n|V\\\ufb02ru|huolissasijostain|hurmaavatpuhelusi|yst\\\xe4vysiyin|Cunya|cunya|kohdaliani|an\\\u0131oista|Loputn\\\xe4kev\\\xe4tn\\\xe4lk\\\xe4\\\xe4|oletollut|j\\\xe4ikin\\\u0131oan|Saath\\\xe4net|Kem\\\u0131n|kappaieiksi|vuok\\\u0131anja|iyperys|mmanltisella|\\\u0131akastellut|jutteiimme|vesimittann|kuikevat|tavaratja|piiltaal|etehk\\\xe4|Lapsenvahtisituli|Ymm\\\xe4n\\\xe4lk\\\xf6|iyii\\\xe3resi|my\\\xf6h\\\xe3|n\\\xe4hnytAaron|haiunnut|Olitoikeassa|itseenijuuri|lempin\\\u0131okaani|Iupaamaan|Teetsoimun|Sen\\\u0131ice|Iasini|Ieuassa|Iiikekumppaninsa|Iiikekumppani|Iausuttiinkaan|Iastauslaiturille|Oleko|tie\\/t\\\xe4|Mayhew\\'IIe|Iakiasiaintoimisto|Iakimiest\\\xe4|ne\\/\\/eens\\\xe4|ha\\/\\/ituksiin|soti\\/aa\\/\\/isiin|Iahtasit|Tiestik\\\xf6|Iakimiehi\\\xe4|\\\xc4l\\\xe4k\\\xe4\\\xe4|O\\/en|minsta|Iuennosta|Iakimiehest\\\xe4|Iopetatte|0\\/it|tu\\/it|Mayhew\\'Ita|I\\\xe4hiet\\\xe4isyydell\\\xe4|ennenkuin|nukku\\\xe4|ihmisia|eloss\\\xe4|tiedett\\\xe4v\\\xe1|Etsik\\\xe1\\\xe1|A\\\u0131ja\\\u0131|V\\\xe4lonneitsyen|Iup\\\xe4ust\\\xe4si|Y\\\xe4mikugyo|ep\\\xe4onnistumisi\\\xe4|Ymm\\\xe1rr\\\xe4tk\\\xf6|Iohik\\\xe4\\\xe4rmekuula|tasta|taynna|mina|tata|tyhmaa|enemman|p\\\xe1tev\\\xf6ity|kylla|\\\xe4rvok\\\xe4st\\\xe4|selviytyj\\\xe1ksi|myyda|hanet|\\\xe4pu\\\xe4si|Kuk\\\xe4|s\\\xe4noi|\\\xe4ut\\\xe4n|\\\xc4la|Han|Mita|tama|Olettiellamme|Kylani|Iahdemme|viela|yhdeksan|Nasaviisaudet|L\\\xe1hemp\\\xe4n\\\xe4|tietaa|mentava|onk\\\xe4\\\xe4n|tekemista|Sina|sina|kiitett\\\xe4v\\\xe1|edell\\\xe1mme|eika|Takanas\\\ufb02|Iankaan|v\\\xe4lloillens\\\xe4|siita|Iohikaarmekuulan|Keta|nama|ajateltavaal|oll\\\xe4kseni|v\\\xe4rm\\\xe4|hanta|hanelle|Os\\\xe4\\\xe4tko|rajahteita|Jyashil|Nama|sita|kosk\\\xe4\\\xe4n|Viek\\\xe1\\\xe1|Pid\\\xe1tt\\\xe4k\\\xe4\\\xe4|Oclottakaal|pelk\\\xe1\\\xe4m\\\xe1|ost\\\xe4v\\\xe4nne|rovoill\\\xe4nne|Jon\\\xe4in|piit\\'taa|\\>|t\\\xe1ysikuu|sinutt\\\xe4nne|Iahtea|Paastaksemme|P\\\xe1rj\\\xe1\\\xe4mme|h\\\xe4nsk\\\xe4ss\\\xe4|Tama|Menkaa|H\\\xe4ipyk\\\xe1\\\xe1|kasin|Tata|Hylkaatk\\\xf6|Paasta|ry\\\xf6st\\\xe4\\\xe1|Iivist\\\xe4|viivyt\\\xe1t|Pys\\\xe4htyk\\\xe1\\\xe4|k\\\xe4nnoilt\\\xe4|k\\\xe1sken|Pys\\\xe4htyk\\\xe1\\\xe1|huonoj\\\xe1tk\\\xe4|k\\\xe1tyrini|mitaan|Missa|kynt\\\xe4v\\\xe1n|p\\\xe4rj\\\xe1nneet|ruok\\\xe4\\\xe4|m\\\xe4rjoj\\\xe4|kuink\\\xe4|oll\\\xe4|missa|Per\\\xe1\\\xe4nny|Pysyk\\\xe1\\\xe4|Vetel\\\xe0t|t\\\xe4pp\\\xe4\\\xe4|ketaan|pelkaamaan|ovatja|ymmarra|ystv\\\xe4ni|K\\\xe4rp\\\xe1si\\\xe4k\\\xf6|mets\\\xe1st\\\xe4t|Iiittya|Al\\\xe1|py\\\xf6rty\\\xe1|n\\\xe4l\\\xe4st\\\xe1|hyva|sy\\\xf6maan|katyreita|Ep\\\xe1reilua|L\\\xe4utt\\\xe4|ilt\\\xe4n\\\xe4|T\\\xe4isimme|Voih\\\xe4n|hittol\\\xe4inen|J\\\xe4|Iohik\\\xe1\\\xe1rmekivi|siina|Iaake|purrutjokin|tahan|paasseet|Iaakkeen|Ieposija|Kylla|pitkalta|eivat|tanne|taman|Ehka|han|mista|pidat|Joutuk\\\xe4\\\xe4|Hanen|sisallaan|Pysyk\\\xe1\\\xe1|L\\\xe4htek\\\xe4\\\xe1|til\\\xe4\\\xe4n|paatella|isani|paasemme|haipyivat|Teh\\\xe1n|Hy\\\xf6kk\\\xe1\\\xe4tte|Iiikahdattekaan|j\\\xe4|v\\\xe4lmist\\\xe4uduin|Hikavvassa|Kuolel|hanen|yhta|Sisalla|ruumiiss\\\xe4|minka|Iih\\\xe4\\\xe4|Iuut\\\xe4|Sis\\\xe0ll\\\xe0mme|Tottelel|\\\xc4l\\\xe4j\\\xe4t\\\xe4|aitisi|Mina|ymmartamaan|sy\\\xf6daan|p\\\xe4h\\\xe4lt\\\xe4|D\\\xe4ku\\\xe4n|sirkutahti|Iapiota|mieltasi|pitaisi|vieda|t\\\xe1\\\xe1ll\\\xe4k\\\xe4\\\xe1n|taytyy|kivesta|etsia|Poikatyt\\\xf6st\\\xe0|hy\\\xf6kkasi|takaapain|I\\\xe4skee|haipya|tehcl\\\xe1kseni|pi\\\xe4n|tyrkytt\\\xe4\\\xe1|minu\\\xe4|n\\\xe1lk\\\xe1inen|Sydamet\\\xf6n|hylata|yha|k\\\xe4uniisti|ihmisverest\\\xe1|Siii\\\xe4|h\\\xe4lu\\\xe4t|Iahemmin|kayttaa|hyvaksi|paase|siivilla|j\\\xe4lkel\\\xe4is\\\xe1|syista|pyh\\\xe1\\\xe4|Tyhmat|pyytavat|H\\\xf6lynp\\\xf6ly\\\xe4l|Nakivat|kannissa|kasivarren|h\\\xe1nenlaisensa|sol\\\xe4\\\xe4|Iiioitella|Iiioittele|Tiedathan|pyh\\\xe1st\\\xe4|Iohik\\\xe1\\\xe1rmekivest\\\xe4|Ymm\\\xe1rr\\\xe1t|\\\xe4rmonne|n\\\xe4isten|Iup\\\xe4ukseni|kekseli\\\xe1isyytesi|Iaudalta|kest\\\xe1vyytesi|taiclakaan|tytt\\\xf6ystava|sormiss\\\xe4ni|r\\\xe4ivois\\\xe4n|k\\\xe4rhun|helvetista|v\\\xe4i|poiss\\\xe4|elamani|pitk\\\xe1tjalkasi|Kadet|niita|Kaske|paastaa|Pida|Iohikaarmekivi|sinust\\\xe4|sy\\\xf6ksyyjo|veljeasi|Odot\\\xe4|Pys\\\xe1hdy|kivea|Missaan|tihe\\\xe1mpi|Iuulitkaan|kaarmekuula|muttaj\\\xe4t\\\xe4n|kuoletl|Iohikaarmekuula|kieltava|L\\\xe1htek\\\xe1\\\xe1|Iohik\\\xe1\\\xe4rmekuulaa|hereilla|kaljupaa|\\\xe4nt\\\xe4m\\\xe4ll\\\xe4|kuul\\\xe4n|t\\\xe4k\\\xe4isin|puolikk\\\xe4\\\xe4n|pohjoisessaja|metsasta|Iohik\\\xe4\\\xe4rmekuul\\\xe4lle|teita|Linnutk\\\xe4\\\xe4n|Puolikk\\\xe4\\\xe4n|\\\xe4nt\\\xe4nut|tiedan|her\\\xe1tt\\\xe1m\\\xe1ss\\\xe1|I\\\xe4sin|h\\\xe4t\\\xe1n\\\xe4|I\\\xf6ysitte|a\\/\\/\\\u0131\\'gaal\\'tor\\\u0131h|Tyttbparka|b\\\xe4n\\\xe3\\\xe4|Co\\/en|Iapsiko\\\u0131fin|rauhallisemminl|Iahjasi|Ruokih\\\xe4net|I\\\xf6ystymist\\\xe4|Iapsestaan|Iaatuaikaa|Ioukkaannuit|Ioistojuttu|Ioukkaavaa|Ioukkaan|l\\'\\\u0131ed\\\xe4n|Iy\\\xf6m\\\xe4st\\\xe4|C\\/\\\u0131\\\xe2teauneuf|Iikaisten|Iapsenlapseton|Ieukani|Ientokonetta|Iorrainea|Iastentarhaan|Iupaavin|Iastenhoitaja|Kegeleit\\\xe3|helkkaril|Ieukaani|Iaihtuneen|Iahjoittamaan|tref\\\ufb02t|I\\\xf6ysyys|Diggleri\\\xe3|Ku\\\u0131fi\\/\\/a|pys\\\xe3hdell\\\xe4|Iomaasi|Iastattu|Iasinne|Iuihin|Iastensuojelujuttuun|Ieffaan|mulkkul|Iapsenvahtia|I\\\xe4hell\\\xe4si|st\\\xe3|TOSi|Ioistoidea|Ty\\\u0131si\\\xe4|lsi|Iaastarin|Viewjatkuu|lnStylen|k\\\xf6ril\\\xe4sl|Ieffoissa|Ieffaseuraksi|Iueskelemaan|Mit\\\xe4j\\\xe4tk\\\xe4|Iaukesitkaan|Kiit\\\xe3|\\\xc4\\\xe3Ii\\\xf6|Iyhytp\\\xf6ksy|Iacrosse|I\\\xf6yt\\\xe3m\\\xe3tt\\\xe3|samojajuttuja|J\\\xe4rvellel|Talouspaperitl|\\\xc4lk\\\xe4\\\xe3s|pillunaamal|poikayst\\\xe4v\\\xe4ns\\\xe3|Iapsenvahti|Nykist\\\xe3|Iaatuaikamme|K\\\xe4\\\xe3nsin|Iatinaksi|yleens\\\xe4juo|kreisej\\\xe3juttuja|Iiitostasi|Mit\\\xe4jos|Sinullaja|Iempparini|Iienetkin|Iuokkajuhla|Iuokkakokouksesta|Iukuteeman|Menejo|Sin\\\xe3j\\\xe4tit|I\\\xe4ht\\\xf6\\\xe3si|I\\\xe3\\\xe4kikseen|puhuajostain|tavatajoku|Iookia|Iapsiyst\\\xe4v\\\xe4llisemp\\\xe3n\\\xe3|is\\\xe3nn\\\xe4lle|t\\\xe3|Ieidi|K\\\xe3visik\\\xf6|maris\\\xe3tk\\\xe4|k\\\xe4nniss\\\xe4j\\\xe4rveen|sinullajotain|Iuntun|Iunttu|Iukitsin|jyyst\\\xe3\\\xe4|Iuokkajuhlaan|Michellest\\\xe3|Iuokkakokous|sin\\\xe4ja|Sin\\\xe3ja|Sill\\\xe3joskus|Iopetimme|Ymm\\\xe3rr\\\xe3tk\\\xf6|kanssajoka|Iiioitellusti|Iaihalta|Miaja|Mietit\\\xe3\\\xe4np\\\xe3|Ky\\\u0131\\\u0131\\\xe4|Pid\\\xe3ttelel|ymm\\\xe4rt\\\xe3misest\\\xe4|jaj\\\xe4\\\xe4n|Selenaja|Iuokkakokousta|\\\xe1k\\\xe1pussi|karkoituksen)(\\b|$)"}},
 'fra': {'BeginLines': {'data': OrderedDict(),
                        'pattern': None},
         'EndLines': {'data': OrderedDict(),
                      'pattern': None},
         'PartialLines': {'data': OrderedDict([(u" I'", u" l'"), (u" |'", u" l'")]),
                          'pattern': u"(?um)(?:(?<=\\s)|(?<=^)|(?<=\\b))(?:\\ I\\'|\\ \\|\\')(?:(?=\\s)|(?=$)|(?=\\b))"},
         'PartialWordsAlways': {'data': OrderedDict(),
                                'pattern': None},
         'WholeLines': {'data': OrderedDict([(u'"D\'ac:c:ord."', u'"D\'accord."'), (u'\u201ci QU\xce gagne, qui perd,', u'ni qui gagne, qui perd,'), (u"L'ac:c:ent est mis \r\n \r\n sur son trajet jusqu'en Suisse.", u"L'accent est mis \r\n \r\n sur son trajet jusqu'en Suisse."), (u"C'est la plus gentille chose \r\n \r\n qu'Hitchc:oc:k m'ait jamais dite.", u"C'est la plus gentille chose \r\n \r\n qu'Hitchcock m'ait jamais dite."), (u"Tout le monde, en revanche, qualifie \r\n \r\n Goldfinger d'aventu re structur\xe9e,", u"Tout le monde, en revanche, qualifie \r\n \r\n Goldfinger d'aventure structur\xe9e,"), (u'et le film Shadow of a man \r\n \r\n a lanc\xe9 sa carri\xe8re au cin\xe9ma.', u'et le film <i>Shadow of a man</i> \r\n \r\n a lanc\xe9 sa carri\xe8re au cin\xe9ma.'), (u'En 1948, Young est pass\xe9 \xe0 la r\xe9alisation \r\n \r\n avec One night with you.', u'En 1948, Young est pass\xe9 \xe0 la r\xe9alisation \r\n \r\n avec <i>One night with you</i>.'), (u'Il a construit tous ces v\xe9hicules \r\n \r\n \xe0 C)c:ala, en Floride.', u'Il a construit tous ces v\xe9hicules \r\n \r\n \xe0 Ocala, en Floride.'), (u'Tokyo Pop et A Taxing Woman? Return.', u"Tokyo Pop et A Taxing Woman's Return."), (u'Peter H u nt.', u'Peter Hunt.'), (u'"C\'est bien mieux dans Peau. \r\n \r\n On peut s\ufb02\xe9clabousser, faire du bruit."', u'"C\'est bien mieux dans l\'eau. \r\n \r\n On peut s\'\xe9clabousser, faire du bruit."')]),
                        'pattern': None},
         'WholeWords': {'data': OrderedDict([(u'@immatriculation', u"d'immatriculation"), (u'acquer', u'acqu\xe9r'), (u'acteurjoue', u'acteur joue'), (u'aerien', u'a\xe9rien'), (u'agreable', u'agr\xe9able'), (u'aientjamais', u'aient jamais'), (u'AII', u'All'), (u'aitjamais', u'ait jamais'), (u'aitjus', u'ait jus'), (u'alle', u'all\xe9'), (u'alles', u'all\xe9s'), (u'appele', u'appel\xe9'), (u'apres', u'apr\xe8s'), (u'aujourdhui', u"aujourd'hui"), (u'aupres', u'aupr\xe8s'), (u'beaute', u'beaut\xe9'), (u'cabossee', u'caboss\xe9e'), (u"carj'", u"car j'"), (u"Carj'", u"Car j'"), (u'carla', u'car la'), (u'CEdipe', u'\u0152dipe'), (u'Cest', u"C'est"), (u"c'etaient", u"c'\xe9taient"), (u'C\xe9taient', u"C'\xe9taient"), (u"c'etait", u"c'\xe9tait"), (u"C'etait", u"C'\xe9tait"), (u'C\xe9tait', u"C'\xe9tait"), (u'choregraphiee', u'chor\xe9graphi\xe9e'), (u'cinema', u'cin\xe9ma'), (u"cl'AIcatraz", u"d'Alcatraz"), (u'cles', u'cl\xe9s'), (u'c\u0153urjoie', u'c\u0153ur-joie'), (u'completer', u'compl\xe9ter'), (u'costumiere', u'costumi\xe8re'), (u'cree', u'cr\xe9\xe9'), (u'daccord', u"d'accord"), (u"d'AIbert", u"d'Albert"), (u"d'AIdous", u"d'Aldous"), (u"d'AIec", u"d'Alec"), (u'danniversaire', u"d'anniversaire"), (u"d'Arra'bida", u"d'Arrabida"), (u"d'autod\xe9rision", u"d'auto-d\xe9rision"), (u'dautres', u"d'autres"), (u'debattait', u'd\xe9battait'), (u'decor', u'd\xe9cor'), (u'decorateurs', u'd\xe9corateurs'), (u'decors', u'd\xe9cors'), (u'defi', u'd\xe9fi'), (u'dej\xe0', u'd\xe9j\xe0'), (u'd\xe9j\xe0m', u'd\xe9j\xe0...'), (u'dejeunait', u'd\xe9jeunait'), (u'dengager', u"d'engager"), (u'd\xe9quipement', u"d'\xe9quipement"), (u'd\xe9rni\xe8r\xe9', u'derni\xe8re'), (u'Desole', u'D\xe9sol\xe9'), (u'dessayage', u"d'essayage"), (u'dessence', u"d'essence"), (u'd\xe9taient', u"c'\xe9taient"), (u'detail', u'd\xe9tail'), (u'dexcellents', u"d'excellents"), (u'dexp\xe9rience', u"d'exp\xe9rience"), (u'dexp\xe9riences', u"d'exp\xe9riences"), (u"d'h\xe9ro'l'ne", u"d'h\xe9ro\xefne"), (u"d'idees", u"d'id\xe9es"), (u"d'intensite", u"d'intensit\xe9"), (u'dontj', u'dont j'), (u'doublaitAlfo', u'doublait Alfo'), (u'DrNo', u'Dr No'), (u"e'", u'\xe9'), (u'ecrit', u'\xe9crit'), (u'elegant', u'\xe9l\xe9gant'), (u'Ell\xe9', u'Elle'), (u'\xe9n', u'en'), (u'equipe', u'\xe9quipe'), (u'erjus', u'er jus'), (u'estjamais', u'est jamais'), (u'\xe9t', u'et'), (u'etaient', u'\xe9taient'), (u'etait', u'\xe9tait'), (u'ete', u'\xe9t\xe9'), (u'etiez', u'\xe9tiez'), (u"etj'", u"et j'"), (u"Etj'", u"Et j'"), (u'etje', u'et je'), (u'Etje', u'Et je'), (u'EtsouvenL', u'Et souvent'), (u'eviter', u'\xe9viter'), (u'Fabsence', u"l'absence"), (u'fadapter', u"t'adapter"), (u'fadore', u"j'adore"), (u'F\xe2ge', u"l'\xe2ge"), (u'Fagent', u"l'agent"), (u'faiessay\xe9', u"j'ai essay\xe9"), (u'Failure', u"l'alllure"), (u'Fambiance', u"l'ambiance"), (u'Famener', u"l'amener"), (u'Fanniversaire', u"l'anniversaire"), (u'Fapparence', u"l'apparence"), (u'Fapres', u"l'apres"), (u'Fapr\xe8s', u"l'apr\xe8s"), (u'Farm\xe9e', u"l'arm\xe9e"), (u'Farri\xe8re', u"l'arri\xe8re"), (u'Farriv\xe9e', u"l'arriv\xe9e"), (u'Fascenseur', u"l'ascenseur"), (u'Fascension', u"l'ascension"), (u'Fassaut', u"l'assaut"), (u'Fassomme', u"l'assomme"), (u'Fatmosph\xe8re', u"l'atmosph\xe8re"), (u'Fattention', u"l'attention"), (u'Favalanche', u"l'avalanche"), (u'F\xe9clairage', u"l'\xe9clairage"), (u'F\xe9cran', u"l'\xe9cran"), (u'F\xe9motion', u"l'\xe9motion"), (u'Femplacement', u"l'emplacement"), (u'Fendroit', u"l'endroit"), (u'Fenseigne', u"l'enseigne"), (u'Fensemble', u"l'ensemble"), (u'Fentouraient', u"l'entouraient"), (u'Fentr\xe9e', u"l'entr\xe9e"), (u'F\xe9paisseur', u"l'\xe9paisseur"), (u'F\xe9poque', u"l'\xe9poque"), (u'F\xe9quipe', u'\xc9quipe'), (u'Fespace', u"l'espace"), (u'fesp\xe9rais', u"j'esp\xe9rais"), (u'Fesp\xe8re', u"l'esp\xe8re"), (u'Festh\xe9tique', u"l'esth\xe9tique"), (u'Fetranger', u"l'etranger"), (u'F\xe9vasion', u"l'\xe9vasion"), (u'F\xe9voque', u"l'\xe9voque"), (u'Fexp\xe9rience', u"l'exp\xe9rience"), (u'Fexplique', u"l'explique"), (u'Fexplosion', u"l'explosion"), (u'Fext\xe9rieur', u"l'ext\xe9rieur"), (u'Fhabituelle', u"l'habituelle"), (u'Fh\xe9licopt\xe8re', u"l'h\xe9licopt\xe8re"), (u'Fh\xe9liport', u"l'h\xe9liport"), (u'Fh\xe9listation', u"l'h\xe9listation"), (u'Fhonneur', u"l'honneur"), (u'Fhorloge', u"l'horloge"), (u'Fid\xe9e', u"l'id\xe9e"), (u'Fimage', u"l'image"), (u'Fimportance', u"l'importance"), (u'Fimpression', u"l'impression"), (u'Finfluence', u"l'influence"), (u'Finscription', u"l'inscription"), (u'Fint\xe9rieur', u"l'int\xe9rieur"), (u'Fintrigue', u"l'intrigue"), (u'Fobjectif', u"l'objectif"), (u'Foccasion', u"l'occasion"), (u'Fordre', u"l'ordre"), (u'Forigine', u"l'origine"), (u'fr\xeare', u'fr\xe8re'), (u'gaylns', u'gaijins'), (u'general', u'g\xe9n\xe9ral'), (u'hawa\xefennel', u'hawa\xefenne'), (u"hawa'l'en", u'hawa\xefen'), (u'Ia', u'la'), (u'I\xe0', u'l\xe0'), (u'Iaryngotomie', u'laryngotomie'), (u'idee', u'id\xe9e'), (u'idees', u'id\xe9es'), (u'Ie', u'le'), (u'Ies', u'les'), (u'Iester', u'Lester'), (u'II', u'Il'), (u'Iimit', u'limit'), (u'IIs', u'Ils'), (u'immediatement', u'imm\xe9diatement'), (u'insufflee', u'insuffl\xe9e'), (u'integrer', u'int\xe9grer'), (u'interessante', u'int\xe9ressante'), (u'Iogions', u'logions'), (u'Iorsqu', u'lorsqu'), (u'isee', u'is\xe9e'), (u'Iumiere', u'lumiere'), (u'Iynchage', u'lynchage'), (u"J'espere", u"J'esp\xe8re"), (u'Jessaie', u"J'essaie"), (u"j'etais", u"j'\xe9tais"), (u"J'etais", u"J'\xe9tais"), (u'lat\xe9ral\xe9m\xe9nt', u'lat\xe9ralement'), (u'lci', u'Ici'), (u'Lci', u'Ici'), (u'l\xe9-', u'l\xe0-'), (u'lepidopteres', u'l\xe9pidopt\xe8res'), (u'litteraire', u'litt\xe9raire'), (u'll', u'il'), (u'Ll', u'Il'), (u'lls', u'ils'), (u'Lls', u'Ils'), (u'maintenanu', u'maintenant'), (u'maniere', u'mani\xe8re'), (u'mariee', u'mari\xe9e'), (u'Mayer/ing', u'Mayerling'), (u'meilleurjour', u'meilleur jour'), (u'melange', u'm\xe9lange'), (u"n'avai\xe9nt", u"n'avaient"), (u"n'etait", u"n'\xe9tait"), (u'oitjamais', u'oit jamais'), (u'oitjus', u'oit jus'), (u'ontete', u'ont \xe9t\xe9'), (u'operateur', u'op\xe9rateur'), (u'ouv\xe9rt\xe9', u'ouverte'), (u'P\xe9preuve', u"l'\xe9preuve"), (u'pere', u'p\xe8re'), (u'plateforme', u'plate-forme'), (u'pourjouer', u'pour jouer'), (u'precipice', u'pr\xe9cipice'), (u'preferes', u'pr\xe9f\xe9r\xe9s'), (u'premierjour', u'premier jour'), (u'presenter', u'pr\xe9senter'), (u'prevu', u'pr\xe9vu'), (u'prevue', u'pr\xe9vue'), (u'propriete', u'propri\xe9t\xe9'), (u'prot\xe8geraient', u'prot\xe9geraient'), (u'qu\xe9', u'que'), (u'qwangoiss\xe9', u"qu'angoiss\xe9"), (u'realisateur', u'r\xe9alisateur'), (u'reception', u'r\xe9ception'), (u're\xe9valu', u'r\xe9\xe9valu'), (u'repute', u'r\xe9put\xe9'), (u'reussi', u'r\xe9ussi'), (u"s'arr\xe9tait", u"s'arr\xeatait"), (u"s'ave'rer", u"s'av\xe9rer"), (u'scenario', u'sc\xe9nario'), (u'scene', u'sc\xe8ne'), (u'scenes', u'sc\xe8nes'), (u'seances', u's\xe9ances'), (u'sequence', u's\xe9quence'), (u's\ufb02\xe9crasa', u"s'\xe9crasa"), (u'speciale', u'sp\xe9ciale'), (u'Supen', u'Super'), (u'torturee', u'tortur\xe9e'), (u'Uadmirable', u"L'admirable"), (u'Uensemblier', u"L'ensemblier"), (u'Uexplosion', u"L'explosion"), (u'Uouvre', u"L'ouvre"), (u'Vaise', u"l'aise"), (u'vecu', u'v\xe9cu'), (u'vehicules', u'v\xe9hicules'), (u'\u0178appr\xe9ciais', u"J'appr\xe9ciais"), (u'\u0178esp\xe8re', u"J'esp\xe8re"), (u'\xff\xe9trangle', u"s'\xe9trangle")]),
                        'pattern': u"(?um)(\\b|^)(?:\\@immatriculation|acquer|acteurjoue|aerien|agreable|aientjamais|AII|aitjamais|aitjus|alle|alles|appele|apres|aujourdhui|aupres|beaute|cabossee|carj\\'|Carj\\'|carla|CEdipe|Cest|c\\'etaient|C\\\xe9taient|c\\'etait|C\\'etait|C\\\xe9tait|choregraphiee|cinema|cl\\'AIcatraz|cles|c\\\u0153urjoie|completer|costumiere|cree|daccord|d\\'AIbert|d\\'AIdous|d\\'AIec|danniversaire|d\\'Arra\\'bida|d\\'autod\\\xe9rision|dautres|debattait|decor|decorateurs|decors|defi|dej\\\xe0|d\\\xe9j\\\xe0m|dejeunait|dengager|d\\\xe9quipement|d\\\xe9rni\\\xe8r\\\xe9|Desole|dessayage|dessence|d\\\xe9taient|detail|dexcellents|dexp\\\xe9rience|dexp\\\xe9riences|d\\'h\\\xe9ro\\'l\\'ne|d\\'idees|d\\'intensite|dontj|doublaitAlfo|DrNo|e\\'|ecrit|elegant|Ell\\\xe9|\\\xe9n|equipe|erjus|estjamais|\\\xe9t|etaient|etait|ete|etiez|etj\\'|Etj\\'|etje|Etje|EtsouvenL|eviter|Fabsence|fadapter|fadore|F\\\xe2ge|Fagent|faiessay\\\xe9|Failure|Fambiance|Famener|Fanniversaire|Fapparence|Fapres|Fapr\\\xe8s|Farm\\\xe9e|Farri\\\xe8re|Farriv\\\xe9e|Fascenseur|Fascension|Fassaut|Fassomme|Fatmosph\\\xe8re|Fattention|Favalanche|F\\\xe9clairage|F\\\xe9cran|F\\\xe9motion|Femplacement|Fendroit|Fenseigne|Fensemble|Fentouraient|Fentr\\\xe9e|F\\\xe9paisseur|F\\\xe9poque|F\\\xe9quipe|Fespace|fesp\\\xe9rais|Fesp\\\xe8re|Festh\\\xe9tique|Fetranger|F\\\xe9vasion|F\\\xe9voque|Fexp\\\xe9rience|Fexplique|Fexplosion|Fext\\\xe9rieur|Fhabituelle|Fh\\\xe9licopt\\\xe8re|Fh\\\xe9liport|Fh\\\xe9listation|Fhonneur|Fhorloge|Fid\\\xe9e|Fimage|Fimportance|Fimpression|Finfluence|Finscription|Fint\\\xe9rieur|Fintrigue|Fobjectif|Foccasion|Fordre|Forigine|fr\\\xeare|gaylns|general|hawa\\\xefennel|hawa\\'l\\'en|Ia|I\\\xe0|Iaryngotomie|idee|idees|Ie|Ies|Iester|II|Iimit|IIs|immediatement|insufflee|integrer|interessante|Iogions|Iorsqu|isee|Iumiere|Iynchage|J\\'espere|Jessaie|j\\'etais|J\\'etais|lat\\\xe9ral\\\xe9m\\\xe9nt|lci|Lci|l\\\xe9\\-|lepidopteres|litteraire|ll|Ll|lls|Lls|maintenanu|maniere|mariee|Mayer\\/ing|meilleurjour|melange|n\\'avai\\\xe9nt|n\\'etait|oitjamais|oitjus|ontete|operateur|ouv\\\xe9rt\\\xe9|P\\\xe9preuve|pere|plateforme|pourjouer|precipice|preferes|premierjour|presenter|prevu|prevue|propriete|prot\\\xe8geraient|qu\\\xe9|qwangoiss\\\xe9|realisateur|reception|re\\\xe9valu|repute|reussi|s\\'arr\\\xe9tait|s\\'ave\\'rer|scenario|scene|scenes|seances|sequence|s\\\ufb02\\\xe9crasa|speciale|Supen|torturee|Uadmirable|Uensemblier|Uexplosion|Uouvre|Vaise|vecu|vehicules|\\\u0178appr\\\xe9ciais|\\\u0178esp\\\xe8re|\\\xff\\\xe9trangle)(\\b|$)"}},
 'hrv': {'BeginLines': {'data': OrderedDict(),
                        'pattern': None},
         'EndLines': {'data': OrderedDict(),
                      'pattern': None},
         'PartialLines': {'data': OrderedDict([(u'Ako ej', u'Ako je'), (u'ako ej', u'ako je'), (u'bez svesti', u'bez svijesti'), (u'Bi\u0107u uz', u'Bit \u0107u uz'), (u'bi ja', u'bih ja'), (u'bi la', u'bila'), (u'biti uredu', u'biti u redu'), (u'bi da bude', u'bi biti'), (u'Bi ste', u'Biste'), (u'Bilo ko', u'Bilo tko'), (u'bilo ko', u'bilo tko'), (u'\u0107e da do\u0111e', u'\u0107e do\u0107i'), (u'Da li \u0107e', u'Ho\u0107e li'), (u'Da li \u0107emo', u'Ho\u0107emo li'), (u'Da li \u0107u', u'Ho\u0107u li'), (u'da li \u0107u', u'ho\u0107u li'), (u'dali \u0107u', u'ho\u0107u li'), (u'Da li je', u'Je li'), (u'da li je', u'je li'), (u'dali je', u'je li'), (u'Da li ste', u'Jeste li'), (u'Da li si', u'Jesi li'), (u'dali si', u'jesi li'), (u'da li \u0107e', u'ho\u0107e li'), (u'dali \u0107e', u'ho\u0107e li'), (u'do srede', u'do srijede'), (u'Dobro ve\u010de', u'Dobra ve\u010der'), (u'Dobro ve\u010der', u'Dobra ve\u010der'), (u'Dobar ve\u010der', u'Dobra ve\u010der'), (u'gdje ide\u0161', u'kamo ide\u0161'), (u'Gdje ide\u0161', u'Kamo ide\u0161'), (u'Gdje sada', u'Kamo sada'), (u'gle ko', u'gle tko'), (u'ho\u0107u da budem', u'\u017eelim biti'), (u'Ho\u0107u da budem', u'\u017delim biti'), (u'ho\u0107u da ka\u017eem', u'\u017eelim re\u0107i'), (u'ho\u0107e\u0161 da ka\u017ee\u0161', u'\u017eeli\u0161 re\u0107i'), (u'ho\u0107e da ka\u017ee', u'\u017eeli re\u0107i'), (u'ho\u0107u da \u017eivim', u'\u017eelim \u017eivjeti'), (u'Izvini se', u'Ispri\u010daj se'), (u'izvini se', u'ispri\u010daj se'), (u'Izvinite me', u'Ispri\u010dajte me'), (u'Izvinite nas', u'Ispri\u010dajte nas'), (u'izvinite nas', u'ispri\u010dajte nas'), (u'Izvinjavamo se', u'Ispri\u010davamo se'), (u'ja bi', u'ja bih'), (u'Ja bi', u'Ja bih'), (u'Jel sam ti', u'Jesam li ti'), (u'Jeli se', u'Je li se'), (u'Jeli sve', u'Je li sve'), (u'Jeli ti', u'Je li ti'), (u'ko je', u'tko je'), (u'ko si', u'tko si'), (u'ko ti je', u'tko ti je'), (u'ko te je', u'tko te je'), (u'ko zna', u'tko zna'), (u'mo\u0107i da idemo', u'mo\u0107i i\u0107i'), (u'moglo da bude', u'moglo biti'), (u'moje sau\u010de\u0161\u0107e', u'moja su\u0107ut'), (u'mora da bude', u'mora biti'), (u'moram da budem', u'moram biti'), (u'Moram da idem', u'Moram i\u0107i'), (u'moram da idem', u'moram i\u0107i'), (u'Mora\u0161 da ide\u0161', u'Mora\u0161 i\u0107i'), (u'Moramo da idemo', u'Moramo i\u0107i'), (u'moram da vidim', u'moram vidjeti'), (u'moram da zaboravim', u'moram zaboraviti'), (u'mora\u0161 da zaboravi\u0161', u'mora\u0161 zaboraviti'), (u'mora da zna', u'mora znati'), (u'moram da znam', u'moram znati'), (u'Moram da znam', u'Moram znati'), (u'mora\u0161 da zna\u0161', u'mora\u0161 znati'), (u'mora\u0161 da ide\u0161', u'mora\u0161 i\u0107i'), (u'mo\u017ee da bude', u'mo\u017ee biti'), (u'mo\u017ee\u0161 da bude\u0161', u'mo\u017ee\u0161 biti'), (u'mo\u017ee da di\u0161e', u'mo\u017ee disati'), (u'mo\u017ee\u0161 da dobije\u0161', u'mo\u017ee\u0161 dobiti'), (u'mo\u017eemo da imamo', u'mo\u017eemo imati'), (u'na ve\u010der', u'nave\u010der'), (u'Na ve\u010der', u'Nave\u010der'), (u'ne\u0107e da bude', u'ne\u0107e biti'), (u'ne\u0107e\u0161 da bude\u0161', u'ne\u0107e\u0161 biti'), (u'ne\u0107e\u0161 da po\u017eali\u0161', u'ne\u0107e\u0161 po\u017ealiti'), (u'Neko ko', u'Netko tko'), (u'neko ko', u'netko tko'), (u'neko ne\u0161to', u'netko ne\u0161to'), (u'nedjelju dana', u'tjedan dana'), (u'Ne mogu da verujem', u'Ne mogu vjerovati'), (u'new yor\u0161ki', u'njujor\u0161ki'), (u'nju jor\u0161ki', u'njujor\u0161ki'), (u'od kako', u'otkako'), (u'Pla\u0161im se', u'Bojim se'), (u'pla\u0161im se', u'bojim se'), (u'pravo u o\u010di', u'ravno u o\u010di'), (u'sa njim', u's njim'), (u'sa njima', u's njima'), (u'sa njom', u's njom'), (u'sa tim', u's tim'), (u'sa tom', u's tom'), (u'sa tobom', u's tobom'), (u'sa vama', u's vama'), (u'sam da budem', u'sam biti'), (u'si\u0107i dolje', u'si\u0107i'), (u'Si dobro', u'Jesi li dobro'), (u'Svako ko', u'Svatko tko'), (u'Svo vreme', u'Sve vrijeme'), (u'Svo vrijeme', u'Sve vrijeme'), (u'smeo da', u'smio'), (u'smeli da', u'smjeli'), (u'\u0160to ej', u'\u0160to je'), (u'\u0161to ej', u'\u0161to je'), (u'to j', u'to je'), (u'to ej', u'to je'), (u'To ej', u'To je'), (u'tamo natrag', u'tamo iza'), (u'tamo je natrag', u'tamo je iza'), (u'Tamo je natrag', u'Tamo je iza'), (u'treba da bude', u'treba biti'), (u'u jutro', u'ujutro'), (u'u\u0107i unutra', u'u\u0107i'), (u'vas je lagao', u'vam je lagao'), (u'za uvijek', u'zauvijek'), (u'zato sto', u'zato \u0161to'), (u'zna da bude', u'zna biti'), (u'zna ko', u'zna tko'), (u'znati ko', u'znati tko'), (u'\u017eele da budu', u'\u017eele biti'), (u'\u017eeli da bude', u'\u017eeli biti'), (u'\u017eelio da budem', u'\u017eelio biti'), (u'\u017eelim da budem', u'\u017eelim biti'), (u'\u017delim da budem', u'\u017delim biti'), (u'\u017eeli\u0161 da bude\u0161', u'\u017eeli\u0161 biti'), (u'\u017eelim da idem', u'\u017eelim i\u0107i'), (u'\u017eelim da odem', u'\u017eelim oti\u0107i'), (u'\u017eeli\u0161 da ode\u0161', u'\u017eeli\u0161 oti\u0107i'), (u'\u017eeli\u0161 da u\u0111e\u0161', u'\u017eeli\u0161 u\u0107i'), (u'\u017eelim da umrem', u'\u017eelim umrijeti'), (u'\u017delim da znam', u'\u017delim znati'), (u'\u017eelim da znam', u'\u017eelim znati'), (u'\u017eeli\u0161 da zna\u0161', u'\u017eeli\u0161 znati')]),
                          'pattern': u'(?um)(?:(?<=\\s)|(?<=^)|(?<=\\b))(?:Ako\\ ej|ako\\ ej|bez\\ svesti|Bi\\\u0107u\\ uz|bi\\ ja|bi\\ la|biti\\ uredu|bi\\ da\\ bude|Bi\\ ste|Bilo\\ ko|bilo\\ ko|\\\u0107e\\ da\\ do\\\u0111e|Da\\ li\\ \\\u0107e|Da\\ li\\ \\\u0107emo|Da\\ li\\ \\\u0107u|da\\ li\\ \\\u0107u|dali\\ \\\u0107u|Da\\ li\\ je|da\\ li\\ je|dali\\ je|Da\\ li\\ ste|Da\\ li\\ si|dali\\ si|da\\ li\\ \\\u0107e|dali\\ \\\u0107e|do\\ srede|Dobro\\ ve\\\u010de|Dobro\\ ve\\\u010der|Dobar\\ ve\\\u010der|gdje\\ ide\\\u0161|Gdje\\ ide\\\u0161|Gdje\\ sada|gle\\ ko|ho\\\u0107u\\ da\\ budem|Ho\\\u0107u\\ da\\ budem|ho\\\u0107u\\ da\\ ka\\\u017eem|ho\\\u0107e\\\u0161\\ da\\ ka\\\u017ee\\\u0161|ho\\\u0107e\\ da\\ ka\\\u017ee|ho\\\u0107u\\ da\\ \\\u017eivim|Izvini\\ se|izvini\\ se|Izvinite\\ me|Izvinite\\ nas|izvinite\\ nas|Izvinjavamo\\ se|ja\\ bi|Ja\\ bi|Jel\\ sam\\ ti|Jeli\\ se|Jeli\\ sve|Jeli\\ ti|ko\\ je|ko\\ si|ko\\ ti\\ je|ko\\ te\\ je|ko\\ zna|mo\\\u0107i\\ da\\ idemo|moglo\\ da\\ bude|moje\\ sau\\\u010de\\\u0161\\\u0107e|mora\\ da\\ bude|moram\\ da\\ budem|Moram\\ da\\ idem|moram\\ da\\ idem|Mora\\\u0161\\ da\\ ide\\\u0161|Moramo\\ da\\ idemo|moram\\ da\\ vidim|moram\\ da\\ zaboravim|mora\\\u0161\\ da\\ zaboravi\\\u0161|mora\\ da\\ zna|moram\\ da\\ znam|Moram\\ da\\ znam|mora\\\u0161\\ da\\ zna\\\u0161|mora\\\u0161\\ da\\ ide\\\u0161|mo\\\u017ee\\ da\\ bude|mo\\\u017ee\\\u0161\\ da\\ bude\\\u0161|mo\\\u017ee\\ da\\ di\\\u0161e|mo\\\u017ee\\\u0161\\ da\\ dobije\\\u0161|mo\\\u017eemo\\ da\\ imamo|na\\ ve\\\u010der|Na\\ ve\\\u010der|ne\\\u0107e\\ da\\ bude|ne\\\u0107e\\\u0161\\ da\\ bude\\\u0161|ne\\\u0107e\\\u0161\\ da\\ po\\\u017eali\\\u0161|Neko\\ ko|neko\\ ko|neko\\ ne\\\u0161to|nedjelju\\ dana|Ne\\ mogu\\ da\\ verujem|new\\ yor\\\u0161ki|nju\\ jor\\\u0161ki|od\\ kako|Pla\\\u0161im\\ se|pla\\\u0161im\\ se|pravo\\ u\\ o\\\u010di|sa\\ njim|sa\\ njima|sa\\ njom|sa\\ tim|sa\\ tom|sa\\ tobom|sa\\ vama|sam\\ da\\ budem|si\\\u0107i\\ dolje|Si\\ dobro|Svako\\ ko|Svo\\ vreme|Svo\\ vrijeme|smeo\\ da|smeli\\ da|\\\u0160to\\ ej|\\\u0161to\\ ej|to\\ j|to\\ ej|To\\ ej|tamo\\ natrag|tamo\\ je\\ natrag|Tamo\\ je\\ natrag|treba\\ da\\ bude|u\\ jutro|u\\\u0107i\\ unutra|vas\\ je\\ lagao|za\\ uvijek|zato\\ sto|zna\\ da\\ bude|zna\\ ko|znati\\ ko|\\\u017eele\\ da\\ budu|\\\u017eeli\\ da\\ bude|\\\u017eelio\\ da\\ budem|\\\u017eelim\\ da\\ budem|\\\u017delim\\ da\\ budem|\\\u017eeli\\\u0161\\ da\\ bude\\\u0161|\\\u017eelim\\ da\\ idem|\\\u017eelim\\ da\\ odem|\\\u017eeli\\\u0161\\ da\\ ode\\\u0161|\\\u017eeli\\\u0161\\ da\\ u\\\u0111e\\\u0161|\\\u017eelim\\ da\\ umrem|\\\u017delim\\ da\\ znam|\\\u017eelim\\ da\\ znam|\\\u017eeli\\\u0161\\ da\\ zna\\\u0161)(?:(?=\\s)|(?=$)|(?=\\b))'},
         'PartialWordsAlways': {'data': OrderedDict(),
                                'pattern': None},
         'WholeLines': {'data': OrderedDict(),
                        'pattern': None},
         'WholeWords': {'data': OrderedDict([(u'advokati', u'odvjetnici'), (u'Advokati', u'Odvjetnici'), (u'advokatima', u'odvjetnicima'), (u'Advokatima', u'Odvjetnicima'), (u'afirmi\u0161e', u'afirmira'), (u'akcenat', u'naglasak'), (u'akcionara', u'dioni\u010dara'), (u'akvarijum', u'akvarij'), (u'akvarijumu', u'akvariju'), (u'amin', u'amen'), (u'Amin', u'Amen'), (u'ans', u'nas'), (u'apsorbovanje', u'apsorbiranje'), (u'apsorbuje', u'apsorbira'), (u'azot', u'du\u0161ik'), (u'ba\u0161ta', u'vrt'), (u'Ba\u0161ta', u'Vrt'), (u'ba\u0161te', u'vrtovi'), (u'Ba\u0161te', u'Vrtovi'), (u'ba\u0161ti', u'vrtu'), (u'ba\u0161tu', u'vrt'), (u'Ba\u0161tu', u'Vrt'), (u'ba\u0161tom', u'vrtom'), (u'bedan', u'bijedan'), (u'bede', u'bijede'), (u'bedi', u'bijedi'), (u'bejah', u'bijah'), (u'bejahu', u'bijahu'), (u'bele\u0161ci', u'bilje\u0161ci'), (u'be\u0161ike', u'mjehure'), (u'bebisiterka', u'dadilja'), (u'beg', u'bijeg'), (u'begu', u'bijegu'), (u'begstva', u'bijega'), (u'beja\u0161e', u'bija\u0161e'), (u'bekstvo', u'bijeg'), (u'bekstvu', u'bijegu'), (u'begstvu', u'bijegu'), (u'bes', u'bijes'), (u'besa', u'bijesa'), (u'besan', u'bijesan'), (u'besom', u'bijesom'), (u'besu', u'bijesu'), (u'be\u0161e', u'bje\u0161e'), (u'bimso', u'bismo'), (u'blije\u0111i', u'blje\u0111i'), (u'bioje', u'bio je'), (u'bi smo', u'bismo'), (u'bi ste', u'biste'), (u'bioskop', u'kino'), (u'bioskopi', u'kina'), (u'bitci', u'bitki'), (u'bled', u'blijed'), (u'blede', u'blijede'), (u'boksuje\u0161', u'boksa\u0161'), (u'bolesan', u'bolestan'), (u'bolila', u'boljela'), (u'bori\u0107e\u0161', u'borit \u0107e\u0161'), (u'Bori\u0107e\u0161', u'Borit \u0107e\u0161'), (u'braon', u'sme\u0111a'), (u'bregu', u'brijegu'), (u'bti', u'biti'), (u'cedilu', u'cjedilu'), (u'ceo', u'cijeli'), (u'Ceo', u'Cijeli'), (u'cepa', u'cijepa'), (u'cev', u'cijev'), (u'cevi', u'cijevi'), (u'cjevi', u'cijevi'), (u'cevima', u'cijevima'), (u'Cevi', u'Cijevi'), (u'Cjevi', u'Cijevi'), (u'Cevima', u'Cijevima'), (u'Cjevima', u'Cijevima'), (u'cev\u010dica', u'cjev\u010dica'), (u'cev\u010dicu', u'cjev\u010dicu'), (u'cutanje', u'\u0161utnja'), (u'\u010dutanje', u'\u0161utnja'), (u'\u0107utanje', u'\u0161utnja'), (u'Cutanje', u'\u0160utnja'), (u'\u010cutanje', u'\u0160utnja'), (u'\u0106utanje', u'\u0160utnja'), (u'cutanjem', u'\u0161utnjom'), (u'\u010dutanjem', u'\u0161utnjom'), (u'\u0107utanjem', u'\u0161utnjom'), (u'Cutanjem', u'\u0160utnjom'), (u'\u010cutanjem', u'\u0160utnjom'), (u'\u0106utanjem', u'\u0160utnjom'), (u'cvetaju', u'cvjetaju'), (u'cvetove', u'cvjetove'), (u'cvetu', u'cvijetu'), (u'cvjetu', u'cvijetu'), (u'cvetalo', u'cvjetalo'), (u'cvjetom', u'cvijetom'), (u'\u010cakom', u'Chuckom'), (u'\u010dar\u0161av', u'plahta'), (u'\u010dar\u0161ave', u'plahte'), (u'\u010dar\u0161avi', u'plahte'), (u'\u010dar\u0161avima', u'plahtama'), (u'\u010das', u'sat'), (u'\u010detvoro', u'\u010detvero'), (u'\u010cita\u0107u', u'\u010citat \u0107u'), (u'\u010derku', u'k\u0107er'), (u'\u010cerku', u'K\u0107er'), (u'\u0107erku', u'k\u0107er'), (u'\u0106erku', u'K\u0107er'), (u'\u0107erkama', u'k\u0107erima'), (u'\u010derkama', u'k\u0107erima'), (u'\u0107erkom', u'k\u0107eri'), (u'\u010derkom', u'k\u0107eri'), (u'k\u0107erkom', u'k\u0107eri'), (u'k\u010derkom', u'k\u0107eri'), (u'\u010cu', u'\u0106u'), (u'\u010ce\u0161', u'\u0106e\u0161'), (u'\u010ce', u'\u0106e'), (u'\u010cemo', u'\u0106emo'), (u'\u010cete', u'\u0106ete'), (u'\u010du', u'\u0107u'), (u'\u010de\u0161', u'\u0107e\u0161'), (u'\u010de', u'\u0107e'), (u'\u010demo', u'\u0107emo'), (u'\u010dete', u'\u0107ete'), (u'\u0107ebe', u'deku'), (u'\u0107ebetu', u'deki'), (u'\u010dk', u'\u010dak'), (u'\u0107\u0161', u'\u0107e\u0161'), (u'\u0107ale', u'tata'), (u'\u0107aletom', u'ocem'), (u'\u0107aleta', u'oca'), (u'\u0107aletu', u'ocu'), (u'\u0107orsokak', u'slijepa ulica'), (u'\u0107orsokaku', u'slijepoj ulici'), (u'\u0107o\u0161ak', u'ugao'), (u'\u0107o\u0161ku', u'uglu'), (u'\u0107erka', u'k\u0107i'), (u'\u0106erka', u'K\u0107i'), (u'\u0107mo', u'\u0107emo'), (u'\u0107te', u'\u0107ete'), (u'\u010du\u0107e', u'\u010dut \u0107e'), (u'\u010du\u0107emo', u'\u010dut \u0107emo'), (u'\u010cu\u0107emo', u'\u010cut \u0107emo'), (u'\u010cu\u0107ete', u'\u010cut \u0107ete'), (u'\u010cu\u0107e', u'\u010cut \u0107e'), (u'\u0107uo', u'\u010duo'), (u'\u0107utao', u'\u0161utio'), (u'\u0106utao', u'\u0160utio'), (u'\u0107ute', u'\u0161ute'), (u'\u0106ute', u'\u0160ute'), (u'cvetova', u'cvjetova'), (u'daga', u'da ga'), (u'damas', u'danas'), (u'date', u'dane'), (u'deda', u'djed'), (u'Deda', u'Djed'), (u'dede', u'djeda'), (u'dedi', u'djedu'), (u'dedom', u'djedom'), (u'defini\u0161e', u'definira'), (u'dejstvo', u'djelovanje'), (u'Dejstvo', u'Djelovanje'), (u'dejstvom', u'djelovanjem'), (u'Dejstvom', u'Djelovanjem'), (u'dele\u0107i', u'dijele\u0107i'), (u'deo', u'dio'), (u'Deo', u'Dio'), (u'de\u0161ava', u'doga\u0111a'), (u'dete', u'dijete'), (u'Dete', u'Dijete'), (u'diluje', u'dila'), (u'diluju', u'dilaju'), (u'diskutuje', u'raspravlja'), (u'Diskutuje', u'Raspravlja'), (u'diskutujemo', u'raspravljamo'), (u'Diskutujemo', u'Raspravljamo'), (u'djete', u'dijete'), (u'Djete', u'Dijete'), (u'detektuje', u'detektira'), (u'dodju', u'do\u0111u'), (u'dole', u'dolje'), (u'Dole', u'Dolje'), (u'donijeo', u'donio'), (u'Donijeo', u'Donio'), (u'Donije\u0107u', u'Donijet \u0107u'), (u'dosledan', u'dosljedan'), (u'dospeo', u'dospio'), (u'dospeju', u'dospiju'), (u'do\u0111avola', u'dovraga'), (u'Do\u0111avola', u'Dovraga'), (u'drug', u'prijatelj'), (u'drugari', u'prijatelji'), (u'drugare', u'prijatelje'), (u'drug\u010diji', u'druga\u010diji'), (u'drugde', u'drugdje'), (u'duuga', u'd\xfaga'), (u'duvana', u'duhana'), (u'dve', u'dvije'), (u'Dve', u'Dvije'), (u'dvema', u'dvjema'), (u'\u0111avo', u'vrag'), (u'\u0111avola', u'vraga'), (u'\u0111emper', u'd\u017eemper'), (u'd\u017eanki', u'ovisnik'), (u'd\u017eelat', u'krvnik'), (u'\u0111ubre', u'sme\u0107e'), (u'efekat', u'efekt'), (u'eksperata', u'stru\u010dnjaka'), (u'eksperti', u'stru\u010dnjaci'), (u'Eksperti', u'Stru\u010dnjaci'), (u'ekspertima', u'stru\u010dnjacima'), (u'en', u'ne'), (u'emitovao', u'emitirao'), (u'emitovati', u'emitirati'), (u'emituje', u'emitira'), (u'emitujem', u'emitiram'), (u'Emitujem', u'Emitiram'), (u'emituju', u'emitiraju'), (u'evra', u'eura'), (u'familija', u'obitelj'), (u'Familija', u'Obitelj'), (u'familiju', u'obitelj'), (u'Familiju', u'Obitelj'), (u'familijama', u'obiteljima'), (u'familiji', u'obitelji'), (u'flertuje', u'o\u010dijuka'), (u'foka', u'tuljan'), (u'foku', u'tuljana'), (u'foke', u'tuljani'), (u'fokama', u'tuljanima'), (u'fotografi\u0161u', u'fotografiraju'), (u'gasova', u'plinova'), (u'gde', u'gdje'), (u'Gde', u'Gdje'), (u'gluhonem', u'gluhonijem'), (u'gre\u0161e', u'grije\u0161e'), (u'grje\u0161e', u'grije\u0161e'), (u'gre\u0161i', u'grije\u0161i'), (u'grje\u0161i', u'grije\u0161i'), (u'gre\u0161ki', u'gre\u0161ci'), (u'grijehova', u'grijeha'), (u'grijehove', u'grijehe'), (u'hipnotisao', u'hipnotizirao'), (u'hipnotisana', u'hipnotizirana'), (u'hipnoti\u0161e', u'hipnotizira'), (u'Historija', u'Povijest'), (u'Historiju', u'Povijest'), (u'Historije', u'Povijesti'), (u'Historiji', u'Povijesti'), (u'Istorija', u'Povijest'), (u'Istoriju', u'Povijest'), (u'Istorije', u'Povijesti'), (u'Istoriji', u'Povijesti'), (u'historije', u'povijesti'), (u'historiji', u'povijesti'), (u'istorije', u'povijesti'), (u'istoriji', u'povijesti'), (u'istorijom', u'povije\u0161\u0107u'), (u'hakuje', u'hakira'), (u'Hakuje', u'Hakira'), (u'hakujemo', u'hakiramo'), (u'Hakujemo', u'Hakiramo'), (u'Hakuju', u'Hakiraju'), (u'hakuju', u'hakiraju'), (u'ho\u010du', u'ho\u0107u'), (u'Ho\u010du', u'Ho\u0107u'), (u'hte\u0107e', u'htjet \u0107e'), (u'htedoh', u'htjedoh'), (u'Htjeo', u'Htio'), (u'Hteo', u'Htio'), (u'htjeo', u'htio'), (u'hteo', u'htio'), (u'i\u010di', u'i\u0107i'), (u'I\u010di', u'I\u0107i'), (u'iko', u'itko'), (u'ignori\u0161i', u'ignoriraj'), (u'Ignori\u0161i', u'Ignoriraj'), (u'ignori\u0161ite', u'ignorirajte'), (u'Ignori\u0161ite', u'Ignorirajte'), (u'ignori\u0161u', u'ignoriraju'), (u'ilustruju', u'ilustriraju'), (u'inspirisao', u'inspirirao'), (u'interesantan', u'zanimljiv'), (u'Interesantan', u'Zanimljiv'), (u'interesuje', u'zanima'), (u'Interesuje', u'Zanima'), (u'interesujemo', u'zanimamo'), (u'Interesujemo', u'Zanimamo'), (u'interesujete', u'zanimate'), (u'Interesujete', u'Zanimate'), (u'Interesuju', u'Zanimaju'), (u'interesuju', u'zanimaju'), (u'isekao', u'izrezao'), (u'isterao', u'istjerao'), (u'istera\u0161', u'istjera\u0161'), (u'Istera\u0161', u'Istjera\u0161'), (u'istrebi', u'istrijebi'), (u'istrebiti', u'istrijebiti'), (u'isuvi\u0161e', u'previ\u0161e'), (u'ivica', u'rub'), (u'ivice', u'ruba'), (u'ivici', u'rubu'), (u'ivicu', u'rub'), (u'izduvaj', u'ispu\u0161i'), (u'izduvamo', u'ispu\u0161emo'), (u'izoluje', u'izolira'), (u'izolujemo', u'izoliramo'), (u'izoluje\u0161', u'izolira\u0161'), (u'Izolujete', u'Izolirate'), (u'Izolujte', u'Izolirajte'), (u'izolujte', u'izolirajte'), (u'izgladneo', u'izgladnio'), (u'izmeriti', u'izmjeriti'), (u'izmerio', u'izmjerio'), (u'izme\u0161ane', u'izmije\u0161ane'), (u'izneo', u'iznio'), (u'izneti', u'iznijeti'), (u'izvestan', u'izvjestan'), (u'izvinem', u'ispri\u010dam'), (u'izvine\u0161', u'ispri\u010da\u0161'), (u'Izvinem', u'Ispri\u010dam'), (u'Izvine\u0161', u'Ispri\u010da\u0161'), (u'izvinim', u'ispri\u010dam'), (u'izvini\u0161', u'ispri\u010da\u0161'), (u'izviniti', u'ispri\u010dati'), (u'izvinjenje', u'isprika'), (u'izvinjenja', u'isprike'), (u'izvinjenju', u'isprici'), (u'jedamput', u'jedanput'), (u'jelda', u"jel' da"), (u'Je\u0161\u0107emo', u'Jest \u0107emo'), (u'Je\u0161\u0107e\u0161', u'Jest \u0107e\u0161'), (u'je\u0161\u0107e', u'jest \u0107e'), (u'je\u0161\u0107u', u'jest \u0107u'), (u'Je\u0161\u0107u', u'Jest \u0107u'), (u'je\u0161\u0107e\u0161', u'jest \u0107e\u0161'), (u'je\u0161\u0107emo', u'jest \u0107emo'), (u'ju\u010de', u'ju\u010der'), (u'Ju\u010de', u'Ju\u010der'), (u'kakava', u'kakva'), (u'kampovao', u'kampirao'), (u'kampuje', u'kampira'), (u'kampujemo', u'kampiramo'), (u'kampuju', u'kampiraju'), (u'kancelarija', u'ured'), (u'kancelarijama', u'uredima'), (u'kancelariju', u'ured'), (u'Kancelarija', u'Ured'), (u'Kancelariju', u'Ured'), (u'kancelariji', u'uredu'), (u'kancelarije', u'ureda'), (u'kancelarijom', u'uredom'), (u'kancera', u'raka'), (u'kandidovati', u'kandidirati'), (u'kandidujem', u'kandidiram'), (u'kapar', u'kopar'), (u'kapra', u'kopra'), (u'karmin', u'ru\u017e'), (u'karminom', u'ru\u017eem'), (u'k\u0107erci', u'k\u0107eri'), (u'k\u0107erka', u'k\u0107i'), (u'k\u010derka', u'k\u0107i'), (u'K\u0107erka', u'K\u0107i'), (u'K\u010derka', u'K\u0107i'), (u'k\u0107erkama', u'k\u0107erima'), (u'ker', u'pas'), (u'Ker', u'Pas'), (u'kerova', u'pasa'), (u'kidnapovan', u'otet'), (u'Kidnapovan', u'Otet'), (u'kiji', u'koji'), (u'kijim', u'kojim'), (u'klasifikuju', u'klasificiraju'), (u'kle\u0161ta', u'klije\u0161ta'), (u'klje\u0161ta', u'klije\u0161ta'), (u'Ko', u'Tko'), (u'koa', u'kao'), (u'koaj', u'koja'), (u'kola', u'auto'), (u'kolima', u'autu'), (u'komandni', u'zapovjedni'), (u'kombinuju', u'kombiniraju'), (u'kompanija', u'tvrtka'), (u'komponovao', u'skladao'), (u'kom\u0161ija', u'susjed'), (u'kom\u0161iji', u'susjedu'), (u'kom\u0161iju', u'susjeda'), (u'kom\u0161iluk', u'susjedstvo'), (u'kom\u0161iluka', u'susjedstva'), (u'kom\u0161iluku', u'susjedstvu'), (u'kom\u0161ije', u'susjedi'), (u'kom\u0161ijama', u'susjedima'), (u'kom\u0161inica', u'susjeda'), (u'kom\u0161inicu', u'susjedu'), (u'konektovan', u'spojen'), (u'konektovati', u'spojiti'), (u'kontroli\u0161u', u'kontroliraju'), (u'Kontroli\u0161u', u'Kontroliraju'), (u'Kontroli\u0161i', u'Kontroliraj'), (u'kontroli\u0161i', u'kontroliraj'), (u'Kontroli\u0161ite', u'Kontrolirajte'), (u'kontroli\u0161ite', u'kontrolirajte'), (u'korpu', u'ko\u0161aru'), (u'kritikuju', u'kritiziraju'), (u'krsta', u'kri\u017ea'), (u'krsta\u0161i', u'kri\u017eari'), (u'krstu', u'kri\u017eu'), (u'krsti\u0107a', u'kri\u017ei\u0107a'), (u'krsti\u0107u', u'kri\u017ei\u0107u'), (u'Krsta', u'Kri\u017ea'), (u'Krstu', u'Kri\u017eu'), (u'Krsti\u0107a', u'Kri\u017ei\u0107a'), (u'Krsti\u0107u', u'Kri\u017ei\u0107u'), (u'krstom', u'kri\u017eem'), (u'krstove', u'kri\u017eeve'), (u'Krstove', u'Kri\u017eeve'), (u'krstovima', u'kri\u017eevima'), (u'Krstovima', u'Kri\u017eevima'), (u'kri\u017eom', u'kri\u017eem'), (u'kupatilo', u'kupaona'), (u'kupatilu', u'kupaoni'), (u'kvalifikuju', u'kvalificiraju'), (u'la\u017eeju', u'la\u017eu'), (u'La\u017eov', u'La\u017eljivac'), (u'la\u017eov', u'la\u017eljivac'), (u'la\u017eovi', u'la\u017eljivci'), (u'la\u017eovu', u'la\u017eljivcu'), (u'la\u017eovima', u'la\u017eljivcima'), (u'la\u017eovom', u'la\u017eljivcem'), (u'lebdeo', u'lebdio'), (u'le\u010di', u'lije\u010di'), (u'le\u010de', u'lije\u010de'), (u'lje\u010di', u'lije\u010di'), (u'Le\u010di', u'Lije\u010di'), (u'Lje\u010di', u'Lije\u010di'), (u'Lejn', u'Lane'), (u'Lenja', u'Lijena'), (u'lenji', u'lijeni'), (u'lenja', u'lijena'), (u'le\u0161nik', u'lje\u0161njak'), (u'Leta', u'Ljeta'), (u'leto', u'ljeto'), (u'Leto', u'Ljeto'), (u'letos', u'ljetos'), (u'letiti', u'letjeti'), (u'leve', u'lijeve'), (u'lo\u017ei', u'pali'), (u'lza', u'Iza'), (u'ljepiti', u'lijepiti'), (u'ljepili', u'lijepili'), (u'magnezijuma', u'magnezija'), (u'magnezijumu', u'magneziju'), (u'maja', u'svibnja'), (u'maju', u'svibnju'), (u'majem', u'svibnjem'), (u'majca', u'majica'), (u'majce', u'majice'), (u'majcu', u'majicu'), (u'majcom', u'majicom'), (u'Malopre', u'Malo prije'), (u'malopre', u'malo prije'), (u'maloprije', u'malo prije'), (u'manifestuje', u'manifestira'), (u'manifestuju', u'manifestiraju'), (u'marta', u'o\u017eujka'), (u'martu', u'o\u017eujku'), (u'martom', u'o\u017eujkom'), (u'mehur', u'mjehur'), (u'menom', u'mnom'), (u'mera\u010d', u'mjera\u010d'), (u'meri', u'mjeri'), (u'mere', u'mjere'), (u'merdevine', u'ljestve'), (u'merdevinama', u'ljestvama'), (u'merljivo', u'mjerljivo'), (u'me\u0161ane', u'mije\u0161ane'), (u'me\u0161avina', u'mje\u0161avina'), (u'me\u0161avine', u'mje\u0161avine'), (u'me\u0161avinu', u'mje\u0161avinu'), (u'minut', u'minutu'), (u'mleo', u'mljeo'), (u'mo\u010d', u'mo\u0107'), (u'mofu', u'mogu'), (u'momenat', u'trenutak'), (u'momenta', u'trena'), (u'muzejem', u'muzejom'), (u'muzici', u'glazbi'), (u'muzika', u'glazba'), (u'muzike', u'glazbe'), (u'muzikom', u'glazbom'), (u'Muzika', u'Glazba'), (u'Muzike', u'Glazbe'), (u'Muzikom', u'Glazbom'), (u'na\u010di', u'na\u0107i'), (u'nadevati', u'nadijevati'), (u'naduvan', u'napu\u0161en'), (u'najpre', u'najprije'), (u'Najpre', u'Najprije'), (u'najzad', u'napokon'), (u'nanev\u0161i', u'nanjev\u0161i'), (u'nanjeli', u'nanijeli'), (u'napastvuje', u'napastuje'), (u'Napolje', u'Van'), (u'napolje', u'van'), (u'Napolju', u'Vani'), (u'napolju', u'vani'), (u'nauka', u'znanost'), (u'Nauka', u'Znanost'), (u'nauci', u'znanosti'), (u'nazad', u'natrag'), (u'Nazad', u'Natrag'), (u'napred', u'naprijed'), (u'Napred', u'Naprijed'), (u'naprimjer', u'na primjer'), (u'naseo', u'nasjeo'), (u'nasesti', u'nasjesti'), (u'nasre\u0107u', u'na sre\u0107u'), (u'nebi', u'ne bi'), (u'nebih', u'ne bih'), (u'Nebi', u'Ne bi'), (u'Nebih', u'Ne bih'), (u'nebismo', u'ne bismo'), (u'Nebismo', u'Ne bismo'), (u'nebiste', u'ne biste'), (u'Nebiste', u'Ne biste'), (u'nedaj', u'ne daj'), (u'negde', u'negdje'), (u'Negde', u'Negdje'), (u'neguje', u'njeguje'), (u'neguju', u'njeguju'), (u'nekto', u'netko'), (u'nemi', u'nijemi'), (u'nemrem', u'ne mogu'), (u'nemogu', u'ne mogu'), (u'Nemogu', u'Ne mogu'), (u'nemora', u'ne mora'), (u'Nemora', u'Ne mora'), (u'nene', u'njene'), (u'ne\u0161o', u'ne\u0161to'), (u'nevesta', u'nevjesta'), (u'nevreme', u'nevrijeme'), (u'nezi', u'njezi'), (u'niasm', u'nisam'), (u'nigde', u'nigdje'), (u'Nigde', u'Nigdje'), (u'nikakave', u'nikakve'), (u'niko', u'nitko'), (u'Niko', u'Nitko'), (u'nisma', u'nisam'), (u'Nisma', u'Nisam'), (u'ne\u0107\u0161', u'ne\u0107e\u0161'), (u'nejde', u'ne ide'), (u'Nejde', u'Ne ide'), (u'neda', u'ne da'), (u'nedam', u'ne dam'), (u'negujem', u'njegujem'), (u'njegi', u'njezi'), (u'ne\u017eeli', u'ne \u017eeli'), (u'niej', u'nije'), (u'nili', u'niti'), (u'njie', u'nije'), (u'njem', u'nijem'), (u'njeme', u'njene'), (u'nominovan', u'nominiran'), (u'nsiam', u'nisam'), (u'nteko', u'netko'), (u'obe', u'obje'), (u'Obe', u'Obje'), (u'obema', u'objema'), (u'Obezbe\u0111uju', u'Osiguravaju'), (u'obezbe\u0111uju', u'osiguravaju'), (u'objekat', u'objekt'), (u'oblast', u'podru\u010dje'), (u'oblastima', u'podru\u010djima'), (u'oblasti', u'podru\u010dj*'), (u'obolelu', u'oboljelu'), (u'obo\u017eavalac', u'obo\u017eavatelj'), (u'obu\u010di', u'obu\u0107i'), (u'obuhvata', u'obuhva\u0107a'), (u'odandje', u'odande'), (u'odavdje', u'odavde'), (u'Odavdje', u'Odavde'), (u'odbi\u0107e\u0161', u'odbit \u0107e\u0161'), (u'odbi\u0107emo', u'odbit \u0107emo'), (u'odela', u'odjela'), (u'odelu', u'odjelu'), (u'odelenja', u'odjela'), (u'odelenje', u'odjel'), (u'odelenju', u'odjelu'), (u'odeljak', u'odjeljak'), (u'odeljenje', u'odjel'), (u'Odeljenje', u'Odjel'), (u'odjeljenje', u'odjel'), (u'Odjeljenje', u'Odjel'), (u'odeljenjem', u'odjelom'), (u'odma', u'odmah'), (u'Odne\u0107u', u'Odnijet \u0107u'), (u'odne\u0107u', u'odnijet \u0107u'), (u'odne\u0107e', u'odnijet \u0107e'), (u'odoliti', u'odoljeti'), (u'odneti', u'odnijeti'), (u'odseo', u'odsjeo'), (u'odsela', u'odsjela'), (u'odsesti', u'odsjesti'), (u'odupreti', u'oduprijeti'), (u'oduvek', u'oduvijek'), (u'Oduvek', u'Oduvijek'), (u'oduvjek', u'oduvijek'), (u'Oduvjek', u'Oduvijek'), (u'ogladneo', u'ogladnio'), (u'okoreli', u'okorjeli'), (u'organizuju', u'organiziraju'), (u'Organizuju', u'Organiziraju'), (u'osje\u0107anja', u'osje\u0107aje'), (u'osmehe', u'osmijehe'), (u'osmehne', u'osmjehne'), (u'osmehnu', u'osmjehnu'), (u'osobenosti', u'osobnosti'), (u'ostareli', u'ostarjeli'), (u'ostrva', u'otoka'), (u'ostrvu', u'otoku'), (u'ostrvom', u'otokom'), (u'Ostrva', u'Otoka'), (u'Ostrvu', u'Otoku'), (u'Ostrvom', u'Otokom'), (u'ostrvima', u'otocima'), (u'osete', u'osjete'), (u'ostrvo', u'otok'), (u'Ostrvo', u'Otok'), (u'osvjetljen', u'osvijetljen'), (u'ovde', u'ovdje'), (u'Ovde', u'Ovdje'), (u'ovdej', u'ovdje'), (u'ovdije', u'ovdje'), (u'Ovdije', u'Ovdje'), (u'ovjde', u'ovdje'), (u'Ovjde', u'Ovdje'), (u'pakuje', u'pakira'), (u'Pakuje', u'Pakira'), (u'Pakuju', u'Pakiraju'), (u'pakuju', u'pakiraju'), (u'palatama', u'pala\u010dama'), (u'palate', u'pala\u010de'), (u'palatu', u'pala\u010du'), (u'palati', u'pala\u010di'), (u'pantalone', u'hla\u010de'), (u'Pantalone', u'Hla\u010de'), (u'pantalona', u'hla\u010da'), (u'pantalonama', u'hla\u010dama'), (u'par\u010de', u'komadi\u0107'), (u'par\u010deta', u'komadi\u0107a'), (u'par\u010detu', u'komadi\u0107u'), (u'par\u010detom', u'komadi\u0107em'), (u'parampar\u010dad', u'komadi\u0107i'), (u'pastuv', u'pastuh'), (u'pastuva', u'pastuha'), (u'pastuvu', u'pastuhu'), (u'pd', u'od'), (u'pemzija', u'penzija'), (u'pemziju', u'penziju'), (u'penzionerski', u'umirovljeni\u010dki'), (u'Penzionerski', u'Umirovljeni\u010dki'), (u'pertle', u'\u017enirance'), (u'pesama', u'pjesama'), (u'pesnicima', u'pjesnicima'), (u'pe\u0161ice', u'pje\u0161ice'), (u'Pe\u0161ice', u'Pje\u0161ice'), (u'pe\u0161ke', u'pje\u0161ke'), (u'plata', u'pla\u0107a'), (u'pla\u010da', u'pla\u0107a'), (u'platom', u'pla\u0107om'), (u'platu', u'pla\u0107u'), (u'pla\u010danje', u'pla\u0107anje'), (u'pla\u010danjem', u'pla\u0107anjem'), (u'pla\u0107e\u0161', u'pla\u010de\u0161'), (u'plen', u'plijen'), (u'Plen', u'Plijen'), (u'pljen', u'plijen'), (u'Pljen', u'Plijen'), (u'po\u010de\u0107u', u'po\u010det \u0107u'), (u'podjelimo', u'podijelimo'), (u'podnesti', u'podnijeti'), (u'podstreka\u010d', u'poticatelj'), (u'podsete', u'podsjete'), (u'poen', u'bod'), (u'poena', u'boda'), (u'poene', u'bodove'), (u'poeni', u'bodovi'), (u'Poeni', u'Bodovi'), (u'poenima', u'bodovima'), (u'poludili', u'poludjeli'), (u'poma\u0107i', u'pomaknuti'), (u'pomaknim', u'pomaknem'), (u'pomaknio', u'pomaknuo'), (u'pomakni\u0161', u'pomakne\u0161'), (u'pomakniti', u'pomaknuti'), (u'pomenu', u'spomenu'), (u'Pomera', u'Mi\u010de'), (u'pomera', u'mi\u010de'), (u'pomjera', u'pomi\u010de'), (u'pomerajte', u'mi\u010dite'), (u'pomjeri', u'pomakni'), (u'pomeraj', u'mi\u010di'), (u'pomjeraj', u'mi\u010di'), (u'pomeraju', u'mi\u010du'), (u'pomerala', u'micala'), (u'pomjerala', u'pomicala'), (u'pomjeraju', u'pomi\u010du'), (u'pomeranja', u'pomicanja'), (u'pomerati', u'micati'), (u'pomjerati', u'pomicati'), (u'pomeri\u0161', u'pomakne\u0161'), (u'ponaosob', u'osobno'), (u'ponesla', u'ponijela'), (u'Ponesla', u'Ponijela'), (u'pore\u0111enje', u'usporedba'), (u'pore\u0111enju', u'usporedbi'), (u'porekla', u'podrijetla'), (u'poreklo', u'podrijetlo'), (u'poreklu', u'podrijetlu'), (u'Porodica', u'Obitelj'), (u'Porodice', u'Obitelji'), (u'porodica', u'obitelj'), (u'porodice', u'obitelji'), (u'porodici', u'obitelji'), (u'porodicama', u'obiteljima'), (u'porodicom', u'obitelji'), (u'porodicu', u'obitelj'), (u'poslata', u'poslana'), (u'posle', u'poslije'), (u'Posle', u'Poslije'), (u'poslje', u'poslije'), (u'posredi', u'posrijedi'), (u'postara', u'pobrine'), (u'Postara\u0107u', u'Pobrinut \u0107u'), (u'postara\u0107u', u'pobrinut \u0107u'), (u'postaraj', u'pobrini'), (u'Postaraj', u'Pobrini'), (u'Postaraju', u'Pobrinu'), (u'postaraju', u'pobrinu'), (u'postarajmo', u'pobrinimo'), (u'postaramo', u'pobrinemo'), (u'postara\u0161', u'pobrine\u0161'), (u'povesne', u'povijesne'), (u'Povinuju', u'Pokoravaju'), (u'povinuju', u'pokoravaju'), (u'pozadi', u'iza'), (u'po\u017eeleo', u'po\u017eelio'), (u'Po\u017eeleo', u'Po\u017eelio'), (u'Po\u017eeljeo', u'Po\u017eelio'), (u'po\u017eeljeo', u'po\u017eelio'), (u'praktikuj', u'prakticiraj'), (u'praktikuju', u'prakticiraju'), (u'praktikovala', u'prakticirala'), (u'praktikovati', u'prakticirati'), (u'pre', u'prije'), (u'Pre', u'Prije'), (u'predela', u'predjela'), (u'predelu', u'predjelu'), (u'Pre\u0107i', u'Prije\u0107i'), (u'pre\u0107i', u'prije\u0107i'), (u'pre\u0107utkuje', u'pre\u0161u\u0107uje'), (u'predame', u'preda me'), (u'predamnom', u'preda mnom'), (u'Predamnom', u'Preda mnom'), (u'preformuli\u0161i', u'preformuliraj'), (u'preklo', u'porijeklo'), (u'preloma', u'prijeloma'), (u'Prene\u0107u', u'Prenijet \u0107u'), (u'prene\u0107u', u'prenijet \u0107u'), (u'prenos', u'prijenos'), (u'prenosa', u'prijenosa'), (u'prenosom', u'prijenosom'), (u'prenosu', u'prijenosu'), (u'preneo', u'prenio'), (u'Preneo', u'Prenio'), (u'prenela', u'prenijela'), (u'prenjela', u'prenijela'), (u'preneli', u'prenijeli'), (u'prenjeli', u'prenijeli'), (u'preneti', u'prenijeti'), (u'preporu\u010da', u'preporu\u010duje'), (u'prese\u0107i', u'presje\u0107i'), (u'preti', u'prijeti'), (u'prete', u'prijete'), (u'Prete', u'Prijete'), (u'prjeti', u'prijeti'), (u'prjete', u'prijete'), (u'prete\u0107im', u'prijete\u0107im'), (u'prete\u0107ih', u'prijete\u0107ih'), (u'pretrpeo', u'pretrpio'), (u'prevod', u'prijevod'), (u'Prevod', u'Prijevod'), (u'prezentovati', u'prezentirati'), (u'prezentovane', u'prezentirane'), (u'prezentovan', u'prezentiran'), (u'prezentovani', u'prezentirani'), (u'prezentovano', u'prezentirano'), (u'pridonjeti', u'pridonijeti'), (u'prijatan', u'ugodan'), (u'prime\u0107ivao', u'primje\u0107ivao'), (u'primedbi', u'primjedbi'), (u'primjete', u'primijete'), (u'prisetim', u'prisjetim'), (u'prisetio', u'prisjetio'), (u'prisetite', u'prisjetite'), (u'pritiskam', u'priti\u0161\u0107em'), (u'prmda', u'iako'), (u'procenat', u'postotak'), (u'procent', u'postotak'), (u'procenta', u'postotka'), (u'procenata', u'postotaka'), (u'procenti', u'postoci'), (u'Procenti', u'Postoci'), (u'procente', u'postotke'), (u'Procente', u'Postotke'), (u'procentu', u'postotku'), (u'Procentu', u'Postotku'), (u'procentima', u'postocima'), (u'prodato', u'prodano'), (u'prohte', u'prohtije'), (u'projekat', u'projekt'), (u'Projekat', u'Projekt'), (u'promijena', u'promjena'), (u'prosledili', u'proslijedili'), (u'protestvovat', u'protestirat'), (u'Protestvovat', u'Protestirat'), (u'Protestvujem', u'Protestiram'), (u'protestvujem', u'protestiram'), (u'protestvuju', u'protestiraju'), (u'protestuju\u0107i', u'protestiraju\u0107i'), (u'psihi\u0107ki', u'psihi\u010dki'), (u'pto', u'\u0161to'), (u'ptom', u'potom'), (u'punoletan', u'punoljetan'), (u'Punoletan', u'Punoljetan'), (u'ra\u010dunari', u'ra\u010dunala'), (u'ra\u010dunare', u'ra\u010dunala'), (u'radijo', u'radio'), (u'ra\u0111e', u'radije'), (u'ranac', u'ruksak'), (u'rancu', u'ruksaku'), (u'rascep', u'rascjep'), (u'rasejan', u'rastresen'), (u'rasejana', u'rastresena'), (u'raspust', u'odmor'), (u'razbi\u0107u', u'razbit \u0107u'), (u'razbijesneo', u'razbjesnio'), (u'ra\u0161\u0107e', u'rast \u0107e'), (u'Razbi\u0107u', u'Razbit \u0107u'), (u'razdevi\u010de', u'razdjevi\u010de'), (u'razgovrati', u'razgovarati'), (u'razre\u0161i', u'razrije\u0161i'), (u'razume', u'razumije'), (u'razumeju', u'razumiju'), (u're\u010dju', u'rije\u010dju'), (u'Re\u010dju', u'Rije\u010dju'), (u'rje\u010dju', u'rije\u010dju'), (u'Rje\u010dju', u'Rije\u010dju'), (u'reagujte', u'reagirajte'), (u'redov', u'vojnik'), (u'redovu', u'vojniku'), (u're\u0111e', u'rje\u0111e'), (u're\u0111i', u'rje\u0111i'), (u'rejv', u'rave'), (u'rejvu', u'raveu'), (u'reko', u'rekao'), (u'rengen', u'rendgen'), (u'repuje\u0161', u'repa\u0161'), (u'resetuje', u'resetira'), (u'resetujte', u'resetirajte'), (u'Resetujte', u'Resetirajte'), (u'rije\u0111i', u'rje\u0111i'), (u'Rizikuj', u'Riskiraj'), (u'rizikuju', u'riskiraju'), (u'rizikuje', u'riskira'), (u'rizikujte', u'riskirajte'), (u'rje\u0161io', u'rije\u0161io'), (u'rokenrol', u"rock'n'roll"), (u'ronioc', u'ronilac'), (u'savije\u0161\u0107u', u'savje\u0161\u0107u'), (u'save\u0161\u0107u', u'savje\u0161\u0107u'), (u'secka', u'sjecka'), (u'seckam', u'sjeckam'), (u'sede\u0107e\u0161', u'sjedit \u0107e\u0161'), (u'sedeli', u'sjedili'), (u'sedi\u0161ta', u'sjedala'), (u'sedi\u0161te', u'sjedalo'), (u'sedi\u0161tu', u'sjedalu'), (u'sedni', u'sjedni'), (u'Sedni', u'Sjedni'), (u'sedi', u'sjedi'), (u'Sedi', u'Sjedi'), (u'sedite', u'sjedite'), (u'sesti', u'sjesti'), (u'sekire', u'sjekire'), (u'sekiraj', u'brini'), (u'sekiram', u'brinem'), (u'sekiramo', u'brinemo'), (u'sekira\u0161', u'brine\u0161'), (u'sekirate', u'brinete'), (u'sekirajte', u'brinite'), (u'seme', u'sjeme'), (u'sertan', u'sretan'), (u'Se\u0161\u0107u', u'Sjest \u0107u'), (u'se\u0161\u0107u', u'sjest \u0107u'), (u'sje\u0161\u0107emo', u'sjest \u0107emo'), (u'seta', u'sjeta'), (u'sigruno', u'sigurno'), (u'siguan', u'siguran'), (u'sija', u'sja'), (u'sijaju', u'sjaju'), (u'sir\u0107e', u'ocat'), (u'sir\u0107eta', u'octa'), (u'sir\u0107etu', u'octu'), (u'sje\u0161\u0107u', u'sjest \u0107u'), (u'sje\u0161\u0107e', u'sjest \u0107e'), (u'sle\u0107e', u'slije\u0107e'), (u'sle\u0107u', u'slije\u0107u'), (u'sle\u0107emo', u'slije\u0107emo'), (u'sleva', u'slijeva'), (u'se\u0107anjima', u'sje\u0107anjima'), (u'seo', u'sjeo'), (u'Seo', u'Sjeo'), (u'sem', u'osim'), (u'sma', u'sam'), (u'smao', u'samo'), (u'Smao', u'Samo'), (u'sme', u'smije'), (u'Sme', u'Smije'), (u'sme\u0107pm', u'sme\u0107em'), (u'smej', u'smij'), (u'Smejte', u'Smijte'), (u'smejte', u'smijte'), (u'smesta', u'smjesta'), (u'Smesta', u'Smjesta'), (u'smeste', u'smjeste'), (u'sme\u0161ak', u'smje\u0161ak'), (u'sme\u0161i', u'smije\u0161i'), (u'Sme\u0161i', u'Smije\u0161i'), (u'sme\u0161io', u'smije\u0161io'), (u'sme\u0161i\u0161', u'smije\u0161i\u0161'), (u'sme\u0161kom', u'smje\u0161kom'), (u'smjeo', u'smio'), (u'smrdeo', u'smrdio'), (u'sintersajzer', u'synthesizer'), (u'sitnisajzer', u'synthesizer'), (u'skelet', u'kostur'), (u'so\u010diva', u'le\u0107e'), (u'so\u010divima', u'le\u0107ama'), (u'so\u010divo', u'le\u0107a'), (u'so\u010divom', u'le\u0107om'), (u'so\u010divu', u'le\u0107i'), (u'Spakuj', u'Spakiraj'), (u'Spakujte', u'Spakirajte'), (u'spakujte', u'spakirajte'), (u'spasao', u'spasio'), (u'Spasao', u'Spasio'), (u'spasen', u'spa\u0161en'), (u'spasla', u'spasila'), (u'spasli', u'spasili'), (u'speluje', u'sri\u010de'), (u'speluju', u'sri\u010du'), (u'spoji\u0107e', u'spojit \u0107e'), (u'spolja', u'izvana'), (u'Sredi\u0107e', u'Sredit \u0107e'), (u'Sredi\u0107u', u'Sredit \u0107u'), (u'stabilizuju', u'stabiliziraju'), (u'starao', u'brinuo'), (u'starati', u'brinuti'), (u'Starati', u'Brinuti'), (u'steni', u'stijeni'), (u'stepen', u'stupanj'), (u'stepena', u'stupnjeva'), (u'stepeni', u'stupnjeva'), (u'stepenu', u'stupnju'), (u'sticati', u'stjecati'), (u'stiditi', u'stidjeti'), (u'streljamo', u'strijeljamo'), (u'streljati', u'strijeljati'), (u'stole\u0107a', u'stolje\u0107a'), (u'stobom', u's tobom'), (u'stvrano', u'stvarno'), (u'Stupi\u0107u', u'Stupit \u0107u'), (u'stupi\u0107u', u'stupit \u0107u'), (u'subjekat', u'subjekt'), (u'sudija', u'sudac'), (u'Sudija', u'Sudac'), (u'sudije', u'suca'), (u'sudiji', u'sucu'), (u'sudijo', u'su\u010de'), (u'sudiju', u'suca'), (u'sudijom', u'sucem'), (u'sudijskog', u'sudskog'), (u'sugeri\u0161u', u'predla\u017eu'), (u'sugeri\u0161e', u'predla\u017ee'), (u'supa', u'juha'), (u'supe', u'juhe'), (u'supi', u'juhi'), (u'supu', u'juhu'), (u'supom', u'juhom'), (u'supama', u'juhama'), (u'Supa', u'Juha'), (u'Supe', u'Juhe'), (u'Supi', u'Juhi'), (u'Supu', u'Juhu'), (u'Supom', u'Juhom'), (u'Supama', u'Juhama'), (u'surfuje', u'surfa'), (u'surfuje\u0161', u'surfa\u0161'), (u'surfuju', u'surfaju'), (u'su\u0161tina', u'bit'), (u'su\u0161tinski', u'bitni'), (u'suvom', u'suhom'), (u'suvog', u'suhog'), (u'suvoj', u'suhoj'), (u'Suvom', u'Suhom'), (u'Suvog', u'Suhog'), (u'Suvoj', u'Suhoj'), (u'suvim', u'suhim'), (u'Suvim', u'Suhim'), (u'svestan', u'svjestan'), (u'svjest', u'svijest'), (u'Svjest', u'Svijest'), (u'svjesti', u'svijesti'), (u'Svjesti', u'Svijesti'), (u'svetova', u'svjetova'), (u'svetove', u'svjetove'), (u'svugde', u'svugdje'), (u'\u0161olja', u'\u0161alica'), (u'\u0161olju', u'\u0161alicu'), (u'\u0160ta', u'\u0160to'), (u'\u0161tagod', u'\u0161to god'), (u'\u0161ta', u'\u0161to'), (u'\u0161tp', u'\u0161to'), (u'\u0161tampa', u'tisak'), (u'\u0161tampu', u'tisak'), (u'\u0161tampom', u'tiskom'), (u'\u0161tampi', u'tisku'), (u'\u0161tampati', u'tiskati'), (u'\u0160utje\u0107e', u'\u0160utjet \u0107e'), (u'tablu', u'plo\u010du'), (u'taguje', u'tagira'), (u'tako\u0111e', u'tako\u0111er'), (u'Tako\u0111e', u'Tako\u0111er'), (u'talas', u'val'), (u'Talas', u'Val'), (u'talasa', u'valova'), (u'talase', u'valove'), (u'talasi', u'valovi'), (u'Talasi', u'Valovi'), (u'talasima', u'valovima'), (u'Talasima', u'Valovima'), (u'te\u010dnost', u'teku\u0107ina'), (u'te\u010dnosti', u'teku\u0107ine'), (u'te\u010dno\u0161\u0107u', u'teku\u0107inom'), (u'tek\u0161o', u'te\u0161ko'), (u'Tek\u0161o', u'Te\u0161ko'), (u'terajte', u'tjerajte'), (u'te\u0161io', u'tje\u0161io'), (u'te\u0161i\u0161', u'tje\u0161i\u0161'), (u'tki', u'tko'), (u'to\u010dak', u'kota\u010d'), (u'To\u010dak', u'Kota\u010d'), (u'toha', u'toga'), (u'tovj', u'tvoj'), (u'trabam', u'trebam'), (u'trkanje', u'utrkivanje'), (u'trkanja', u'utrkivanja'), (u'trkao', u'utrkivao'), (u'trougao', u'trokut'), (u'trougla', u'trokuta'), (u'trouglu', u'trokutu'), (u'trouglove', u'trokute'), (u'trpeo', u'trpio'), (u'Trpeo', u'Trpio'), (u'tugi', u'tuzi'), (u'tvrtci', u'tvrtki'), (u'ubede', u'uvjere'), (u'Ube\u0111ivao', u'Uvjeravao'), (u'ube\u0111ivati', u'uvjeravati'), (u'ubje\u0111ivati', u'uvjeravati'), (u'ube\u0111uje', u'uvjerava'), (u'ube\u0111uje\u0161', u'uvjerava\u0161'), (u'ube\u0111uju', u'uvjeravaju'), (u'ubjediti', u'uvjeriti'), (u'u\u010dtivo', u'uljudno'), (u'u\u010dtivost', u'uljudnost'), (u'u\u010dtivo\u0161\u0107u', u'uljudno\u0161\u0107u'), (u'udata', u'udana'), (u'Udata', u'Udana'), (u'udatoj', u'udanoj'), (u'udeo', u'udio'), (u'ugljenik', u'ugljik'), (u'uliva', u'ulijeva'), (u'ulivali', u'ulijevali'), (u'ulivate', u'ulijevate'), (u'uljeva', u'ulijeva'), (u'ujutru', u'ujutro'), (u'Ukoliko', u'Ako'), (u'ukoliko', u'ako'), (u'ume', u'zna'), (u'umem', u'umijem'), (u'ume\u0161', u'umije\u0161'), (u'umesto', u'umjesto'), (u'Umesto', u'umjesto'), (u'umete', u'znate'), (u'umijesto', u'umjesto'), (u'Umijesto', u'Umjesto'), (u'umetninama', u'umjetninama'), (u'umreti', u'umrijeti'), (u'Umret', u'Umrijet'), (u'umrije\u0107e\u0161', u'umrijet \u0107e\u0161'), (u'umrije\u0107ete', u'umrijet \u0107ete'), (u'Une\u0107u', u'Unijet \u0107u'), (u'univerzitet', u'sveu\u010dili\u0161te'), (u'univerzitetu', u'sveu\u010dili\u0161tu'), (u'Uop\u0161te', u'Uop\u0107e'), (u'uop\u0161te', u'uop\u0107e'), (u'uop\u010de', u'uop\u0107e'), (u'upustva', u'uputstva'), (u'uprkos', u'usprkos'), (u'Uprkos', u'Usprkos'), (u'uradio', u'u\u010dinio'), (u'Uredu', u'U redu'), (u'uspe', u'uspije'), (u'Uspe', u'Uspije'), (u'uspeo', u'uspio'), (u'Uspeo', u'Uspio'), (u'uspe\u0107e\u0161', u'uspjet \u0107e\u0161'), (u'uspje\u0107e\u0161', u'uspjet \u0107e\u0161'), (u'uspe\u0107emo', u'uspjet \u0107emo'), (u'uspe\u0161', u'uspije\u0161'), (u'uspeju', u'uspiju'), (u'uspjevala', u'uspijevala'), (u'uspijo', u'uspio'), (u'u sred', u'usred'), (u'usled', u'uslijed'), (u'Usled', u'Uslijed'), (u'usledila', u'uslijedila'), (u'usljed', u'uslijed'), (u'Usljed', u'Uslijed'), (u'u\u0161unjate', u'u\u0161uljate'), (u'utehe', u'utjehe'), (u'uve\u010de', u'nave\u010der'), (u'uvek', u'uvijek'), (u'Uvek', u'Uvijek'), (u'uvjek', u'uvijek'), (u'Uvjek', u'Uvijek'), (u'uvijet', u'uvjet'), (u'uvijeti', u'uvjeti'), (u'uvijetima', u'uvjetima'), (u'uva', u'uha'), (u'Uva', u'Uha'), (u'uvo', u'uho'), (u'Uvo', u'Uho'), (u'uvom', u'uhom'), (u'Uvom', u'Uhom'), (u'uvu', u'uhu'), (u'Uvu', u'Uhu'), (u'vaistinu', u'uistinu'), (u'Vaistinu', u'Uistinu'), (u'vajar', u'kipar'), (u'vakcini\u0161e', u'cijepi'), (u'varnica', u'iskra'), (u'varnicu', u'iskru'), (u'vaspitala', u'odgojila'), (u'vaspitavan', u'odgajan'), (u'vaspitavanju', u'odgoju'), (u'va\u0161ljivi', u'u\u0161ljivi'), (u'va\u017ei', u'vrijedi'), (u've\u010dan', u'vje\u010dan'), (u've\u0107ati', u'vije\u0107ati'), (u'vek', u'stolje\u0107e'), (u'veka', u'stolje\u0107a'), (u'veke', u'vijeke'), (u'vekova', u'stolje\u0107a'), (u'venca', u'vijenca'), (u've\u010dnost', u'vje\u010dnost'), (u'veoma', u'vrlo'), (u'Veoma', u'Vrlo'), (u'vera', u'vjera'), (u'vere', u'vjere'), (u'veri', u'vjeri'), (u'verom', u'vjerom'), (u'veru', u'vjeru'), (u'veran', u'vjeran'), (u'verama', u'vjerama'), (u'Vera', u'Vjera'), (u'Vere', u'Vjere'), (u'Veri', u'Vjeri'), (u'Verom', u'Vjerom'), (u'Veru', u'Vjeru'), (u'Veran', u'Vjeran'), (u'Verama', u'Vjerama'), (u'veren', u'zaru\u010den'), (u'Veren', u'Zaru\u010den'), (u'verena', u'zaru\u010dena'), (u'vereni', u'zaru\u010deni'), (u'verimo', u'zaru\u010dimo'), (u'vest', u'vijest'), (u'Vest', u'Vijest'), (u'vesti', u'vijesti'), (u'Vesti', u'Vijesti'), (u'Vjesti', u'Vijesti'), (u'vjesti', u'vijesti'), (u'vestima', u'vijestima'), (u'Vestima', u'Vijestima'), (u'vjestima', u'vijestima'), (u'Vjestima', u'Vijestima'), (u've\u0161ala', u'vje\u0161ala'), (u've\u0161\u0107u', u'vije\u0161\u0107u'), (u've\u0161u', u'rublju'), (u'vide\u0161e', u'vidje\u0161e'), (u'vidjeo', u'vidio'), (u'Vidjeo', u'Vidio'), (u'vjerojatno\u0107a', u'vjerojatnost'), (u'vje\u0161\u0107u', u'vije\u0161\u0107u'), (u'vlo', u'vrlo'), (u'Vodi\u0107e', u'Vodit \u0107e'), (u'Vodi\u0107u', u'Vodit \u0107u'), (u'voliti', u'voljeti'), (u'vredelo', u'vrijedilo'), (u'vrednom', u'vrijednom'), (u'vrednog', u'vrijednog'), (u'vreme', u'vrijeme'), (u'Vreme', u'Vrijeme'), (u'vrjeme', u'vrijeme'), (u'Vrjeme', u'Vrijeme'), (u'vrteo', u'vrtio'), (u'vrvela', u'vrvjela'), (u'whiskey', u'viski'), (u'zaceljivanje', u'zacjeljivanje'), (u'zagreva', u'zagrijava'), (u'Zagreva', u'Zagrijava'), (u'Zagrevate', u'Zagrijavate'), (u'zagrevanje', u'zagrijavanje'), (u'zakunio', u'zakleo'), (u'zalepili', u'zalijepili'), (u'zalepiti', u'zalijepiti'), (u'zaliv', u'zaljev'), (u'zalivu', u'zaljevu'), (u'zanm', u'znam'), (u'zanma', u'zanima'), (u'zaplena', u'zapljena'), (u'zapleni', u'zaplijeni'), (u'zaplenu', u'zapljenu'), (u'zaspem', u'zaspim'), (u'zastareo', u'zastario'), (u'zauvek', u'zauvijek'), (u'Zauvek', u'Zauvijek'), (u'zauvjek', u'zauvijek'), (u'Zauvjek', u'Zauvijek'), (u'zavera', u'zavjera'), (u'zahtev', u'zahtjev'), (u'Zahtev', u'Zahtjev'), (u'zasede', u'zasjede'), (u'zasedi', u'zasjedi'), (u'zasedu', u'zasjedu'), (u'zatp', u'zato'), (u'Zatp', u'Zato'), (u'za\u017eeleo', u'za\u017eelio'), (u'Za\u017eeleo', u'Za\u017eelio'), (u'Za\u017eeljeo', u'Za\u017eelio'), (u'za\u017eeljeo', u'za\u017eelio'), (u'zbg', u'zbog'), (u'zdrvo', u'zdravo'), (u'Zdrvo', u'Zdravo'), (u'zlodela', u'zlodjela'), (u'zna\u0107i', u'zna\u010di'), (u'zvani\u010dan', u'slu\u017eben'), (u'zvezdom', u'zvijezdom'), (u'\u017eemo', u'\u0107emo'), (u'\u017eeleo', u'\u017eelio'), (u'\u017deleo', u'\u017delio'), (u'\u017deljeo', u'\u017delio'), (u'\u017eeljeo', u'\u017eelio'), (u'\u017diveo', u'\u017divio'), (u'\u017eiveo', u'\u017eivio'), (u'\u017emureo', u'\u017emirio'), (u'Abi', u'Abby'), (u'Alis', u'Alice'), (u'Ajk', u'Ike'), (u'Ajku', u'Ikeu'), (u'Ajrin', u'Irene'), (u'Ajris', u'Iris'), (u'Ajron', u'Iron'), (u'Ajvi', u'Ivy'), (u'An\u0111eles', u'Angeles'), (u'An\u0111elesa', u'Angelesa'), (u'An\u0111elesu', u'Angelesu'), (u'An\u0111elesom', u'Angelesom'), (u'Antoni', u'Anthony'), (u'Antoniju', u'Anthonyju'), (u'Ar\u010di', u'Archie'), (u'Beverli', u'Beverly'), (u'Bejker', u'Baker'), (u'Bitls', u'Beatles'), (u'Bitlsi', u'Beatlesi'), (u'Brid\u017eit', u'Bridget'), (u'Bri\u017eit', u'Brigitte'), (u'Bruks', u'Brooks'), (u'Dablin', u'Dublin'), (u'Dablina', u'Dublina'), (u'Dablinu', u'Dublinu'), (u'Dag', u'Doug'), (u'Darvin', u'Darwin'), (u'Darvina', u'Darwina'), (u'Darvinu', u'Darwinu'), (u'Darvinom', u'Darwinom'), (u'Dejv', u'Dave'), (u'Dejvi', u'Davie'), (u'Dejva', u'Davea'), (u'Dejvu', u'Daveu'), (u'Dejvom', u'Daveom'), (u'Den', u'Dan'), (u'Deril', u'Daryl'), (u'Dijaz', u'Diaz'), (u'Dru', u'Drew'), (u'\u0110eni', u'Jenny'), (u'\u0110o\u0161ua', u'Joshua'), (u'D\u017eejmi', u'Jamie'), (u'D\u017ead', u'Jude'), (u'D\u017eeri', u'Jerry'), (u'D\u017eerija', u'Jerryja'), (u'D\u017eo', u'Joe'), (u'D\u017eoel', u'Joel'), (u'D\u017eoelu', u'Joelu'), (u'D\u017eo\u0161', u'Josh'), (u'D\u017eo\u0161u', u'Joshu'), (u'D\u017eosi', u'Josie'), (u'D\u017eozi', u'Josie'), (u'D\u017ees', u'Jess'), (u'D\u017een', u'Jen'), (u'D\u017eej', u'Jay'), (u'D\u017eejn', u'Jane'), (u'D\u017eil', u'Jill'), (u'D\u017eodi', u'Jody'), (u'D\u017eud', u'Jude'), (u'D\u017euli', u'Julie'), (u'Ebi', u'Abby'), (u'Ejb', u'Abe'), (u'Ejba', u'Abea'), (u'Ejmi', u'Amy'), (u'Ejpril', u'April'), (u'Empajer', u'Empire'), (u'En\u0111el', u'Angel'), (u'End\u017ei', u'Angie'), (u'Entoni', u'Anthony'), (u'E\u0161ford', u'Ashford'), (u'E\u0161forda', u'Ashforda'), (u'E\u0161li', u'Ashley'), (u'Fibi', u'Phoebe'), (u'Filovo', u'Philovo'), (u'Flober', u'Flaubert'), (u'Fokner', u'Faulkner'), (u'Fren', u'Fran'), (u'Gre\u010den', u'Gretchen'), (u'Grejs', u'Grace'), (u'Hadson', u'Hudson'), (u'Hadsonu', u'Hudsonu'), (u'Hant', u'Hunt'), (u'Hemingvej', u'Hemingway'), (u'Henk', u'Hank'), (u'Hejstings', u'Hastings'), (u'Hju', u'Hugh'), (u'Hjua', u'Hugha'), (u'Hjuz', u'Hughes'), (u'Hjuza', u'Hughesa'), (u'Hjuston', u'Houston'), (u'Hjustonu', u'Houstonu'), (u'Igo', u'Hugo'), (u'Ilejn', u'Elaine'), (u'\u017didovin', u'\u017didov'), (u'Johni', u'Johnny'), (u'Jud\u017ein', u'Eugene'), (u'Kasl', u'Castle'), (u'Kejd\u017e', u'Cage'), (u'Kejn', u'Kane'), (u'Kejsi', u'Casey'), (u'Kejti', u'Katie'), (u'Keren', u'Karen'), (u'Kerol', u'Carol'), (u'Kerolajn', u'Caroline'), (u'Klajv', u'Clive'), (u'Klajva', u'Clivea'), (u'Klajve', u'Clive'), (u'Klajvu', u'Cliveu'), (u'Klarens', u'Clarence'), (u'Kler', u'Claire'), (u'Kloi', u'Chloe'), (u'Klod', u'Claude'), (u'Klode', u'Claude'), (u'Kol', u'Cole'), (u'Kolins', u'Collins'), (u'Kortni', u'Courtney'), (u'Krej?g', u'Craig'), (u'Kristi', u'Christie'), (u'Lajf', u'Life'), (u'Lajl', u'Lile'), (u'Lejk', u'Lake'), (u'Lorejn', u'Loraine'), (u'Lorens', u'Lawrence'), (u'Lusi', u'Lucy'), (u'Majk', u'Mike'), (u'Majkeve', u'Mikeove'), (u'Majlo', u'Milo'), (u'Maslou', u'Maslow'), (u'Medlin', u'Madelaine'), (u'Medelin', u'Madeline'), (u'Mejbel', u'Mabel'), (u'Mejn', u'Maine'), (u'Mejna', u'Mainea'), (u'Mejnu', u'Maineu'), (u'Mejnom', u'Maineom'), (u'Mejpls', u'Maples'), (u'Mejsi', u'Maisy'), (u'Mek', u'Mac'), (u'Merilend', u'Maryland'), (u'Mi\u010del', u'Mitchell'), (u'Nensi', u'Nancy'), (u'Ni\u010de', u'Nietzsche'), (u'Ni\u010dea', u'Nietzschea'), (u'Ni\u010deu', u'Nietzscheu'), (u'Ni\u010deom', u'Nietzscheom'), (u'Odri', u'Audrey'), (u'Ohajo', u'Ohio'), (u'Ohaja', u'Ohia'), (u'Ohaju', u'Ohiu'), (u'Olbrajt', u'Albright'), (u"O'Nil", u"O'Neal"), (u'Orlins', u'Orleans'), (u'Orlinsa', u'Orleansa'), (u'Orlinsu', u'Orleansu'), (u'Pem', u'Pam'), (u'Pejd\u017e', u'Paige'), (u'Red\u017ei', u'Reggie'), (u'Red\u017einald', u'Reginald'), (u'Rej', u'Ray'), (u'Rej\u010del', u'Rachel'), (u'Ri\u010d', u'Rich'), (u'Rouz', u'Rose'), (u'Sendi', u'Sandy'), (u'Sidnej', u'Sidney'), (u'Sindi', u'Cindy'), (u'Sojer', u'Sawyer'), (u'Sojeru', u'Sawyeru'), (u'Sole', u'Saule'), (u'Stejsi', u'Stacy'), (u'Stoun', u'Stone'), (u'\u0160eron', u'Sharon'), (u'\u0160eril', u'Cheryl'), (u'\u0160irli', u'Shirley'), (u'\u0160paniji', u'\u0160panjolskoj'), (u'Tajms', u'Times'), (u'Tejlor', u'Taylor'), (u'Vajlder', u'Wilder'), (u'Val\u0161', u'Walsh'), (u'Vins', u'Vince'), (u'Voren', u'Warren'), (u'Vud', u'Wood'), (u'\u017dak', u'Jacques'), (u'\u017dil', u'Jules'), (u'januar', u'sije\u010danj'), (u'Januar', u'Sije\u010danj'), (u'februar', u'velja\u010da'), (u'februara', u'velja\u010de'), (u'februaru', u'velja\u010di'), (u'Februar', u'Velja\u010da'), (u'Februara', u'Velja\u010de'), (u'Februaru', u'Velja\u010di'), (u'mart', u'o\u017eujak'), (u'Mart', u'O\u017eujak'), (u'april', u'travanj'), (u'April', u'Travanj'), (u'maj', u'svibanj'), (u'Maj', u'Svibanj'), (u'svibnjom', u'svibnjem'), (u'jun', u'lipanj'), (u'juna', u'lipnja'), (u'junu', u'lipnju'), (u'Jun', u'Lipanj'), (u'Juni', u'Lipanj'), (u'juli', u'srpanj'), (u'jula', u'srpnja'), (u'julu', u'srpnju'), (u'Juli', u'Srpanj'), (u'septembar', u'rujan'), (u'Septembar', u'Rujan'), (u'oktobar', u'listopad'), (u'Oktobar', u'Listopad'), (u'oktobra', u'listopada'), (u'oktobru', u'listopadu'), (u'novembar', u'studeni'), (u'november', u'studeni'), (u'novembra', u'studenog'), (u'novembru', u'studenom'), (u'Novembar', u'Studeni'), (u'November', u'Studeni'), (u'Novembra', u'Studenog'), (u'Novembru', u'Studenom'), (u'decembar', u'prosinac'), (u'Decembar', u'Prosinac')]),
                        'pattern': u"(?um)(\\b|^)(?:advokati|Advokati|advokatima|Advokatima|afirmi\\\u0161e|akcenat|akcionara|akvarijum|akvarijumu|amin|Amin|ans|apsorbovanje|apsorbuje|azot|ba\\\u0161ta|Ba\\\u0161ta|ba\\\u0161te|Ba\\\u0161te|ba\\\u0161ti|ba\\\u0161tu|Ba\\\u0161tu|ba\\\u0161tom|bedan|bede|bedi|bejah|bejahu|bele\\\u0161ci|be\\\u0161ike|bebisiterka|beg|begu|begstva|beja\\\u0161e|bekstvo|bekstvu|begstvu|bes|besa|besan|besom|besu|be\\\u0161e|bimso|blije\\\u0111i|bioje|bi\\ smo|bi\\ ste|bioskop|bioskopi|bitci|bled|blede|boksuje\\\u0161|bolesan|bolila|bori\\\u0107e\\\u0161|Bori\\\u0107e\\\u0161|braon|bregu|bti|cedilu|ceo|Ceo|cepa|cev|cevi|cjevi|cevima|Cevi|Cjevi|Cevima|Cjevima|cev\\\u010dica|cev\\\u010dicu|cutanje|\\\u010dutanje|\\\u0107utanje|Cutanje|\\\u010cutanje|\\\u0106utanje|cutanjem|\\\u010dutanjem|\\\u0107utanjem|Cutanjem|\\\u010cutanjem|\\\u0106utanjem|cvetaju|cvetove|cvetu|cvjetu|cvetalo|cvjetom|\\\u010cakom|\\\u010dar\\\u0161av|\\\u010dar\\\u0161ave|\\\u010dar\\\u0161avi|\\\u010dar\\\u0161avima|\\\u010das|\\\u010detvoro|\\\u010cita\\\u0107u|\\\u010derku|\\\u010cerku|\\\u0107erku|\\\u0106erku|\\\u0107erkama|\\\u010derkama|\\\u0107erkom|\\\u010derkom|k\\\u0107erkom|k\\\u010derkom|\\\u010cu|\\\u010ce\\\u0161|\\\u010ce|\\\u010cemo|\\\u010cete|\\\u010du|\\\u010de\\\u0161|\\\u010de|\\\u010demo|\\\u010dete|\\\u0107ebe|\\\u0107ebetu|\\\u010dk|\\\u0107\\\u0161|\\\u0107ale|\\\u0107aletom|\\\u0107aleta|\\\u0107aletu|\\\u0107orsokak|\\\u0107orsokaku|\\\u0107o\\\u0161ak|\\\u0107o\\\u0161ku|\\\u0107erka|\\\u0106erka|\\\u0107mo|\\\u0107te|\\\u010du\\\u0107e|\\\u010du\\\u0107emo|\\\u010cu\\\u0107emo|\\\u010cu\\\u0107ete|\\\u010cu\\\u0107e|\\\u0107uo|\\\u0107utao|\\\u0106utao|\\\u0107ute|\\\u0106ute|cvetova|daga|damas|date|deda|Deda|dede|dedi|dedom|defini\\\u0161e|dejstvo|Dejstvo|dejstvom|Dejstvom|dele\\\u0107i|deo|Deo|de\\\u0161ava|dete|Dete|diluje|diluju|diskutuje|Diskutuje|diskutujemo|Diskutujemo|djete|Djete|detektuje|dodju|dole|Dole|donijeo|Donijeo|Donije\\\u0107u|dosledan|dospeo|dospeju|do\\\u0111avola|Do\\\u0111avola|drug|drugari|drugare|drug\\\u010diji|drugde|duuga|duvana|dve|Dve|dvema|\\\u0111avo|\\\u0111avola|\\\u0111emper|d\\\u017eanki|d\\\u017eelat|\\\u0111ubre|efekat|eksperata|eksperti|Eksperti|ekspertima|en|emitovao|emitovati|emituje|emitujem|Emitujem|emituju|evra|familija|Familija|familiju|Familiju|familijama|familiji|flertuje|foka|foku|foke|fokama|fotografi\\\u0161u|gasova|gde|Gde|gluhonem|gre\\\u0161e|grje\\\u0161e|gre\\\u0161i|grje\\\u0161i|gre\\\u0161ki|grijehova|grijehove|hipnotisao|hipnotisana|hipnoti\\\u0161e|Historija|Historiju|Historije|Historiji|Istorija|Istoriju|Istorije|Istoriji|historije|historiji|istorije|istoriji|istorijom|hakuje|Hakuje|hakujemo|Hakujemo|Hakuju|hakuju|ho\\\u010du|Ho\\\u010du|hte\\\u0107e|htedoh|Htjeo|Hteo|htjeo|hteo|i\\\u010di|I\\\u010di|iko|ignori\\\u0161i|Ignori\\\u0161i|ignori\\\u0161ite|Ignori\\\u0161ite|ignori\\\u0161u|ilustruju|inspirisao|interesantan|Interesantan|interesuje|Interesuje|interesujemo|Interesujemo|interesujete|Interesujete|Interesuju|interesuju|isekao|isterao|istera\\\u0161|Istera\\\u0161|istrebi|istrebiti|isuvi\\\u0161e|ivica|ivice|ivici|ivicu|izduvaj|izduvamo|izoluje|izolujemo|izoluje\\\u0161|Izolujete|Izolujte|izolujte|izgladneo|izmeriti|izmerio|izme\\\u0161ane|izneo|izneti|izvestan|izvinem|izvine\\\u0161|Izvinem|Izvine\\\u0161|izvinim|izvini\\\u0161|izviniti|izvinjenje|izvinjenja|izvinjenju|jedamput|jelda|Je\\\u0161\\\u0107emo|Je\\\u0161\\\u0107e\\\u0161|je\\\u0161\\\u0107e|je\\\u0161\\\u0107u|Je\\\u0161\\\u0107u|je\\\u0161\\\u0107e\\\u0161|je\\\u0161\\\u0107emo|ju\\\u010de|Ju\\\u010de|kakava|kampovao|kampuje|kampujemo|kampuju|kancelarija|kancelarijama|kancelariju|Kancelarija|Kancelariju|kancelariji|kancelarije|kancelarijom|kancera|kandidovati|kandidujem|kapar|kapra|karmin|karminom|k\\\u0107erci|k\\\u0107erka|k\\\u010derka|K\\\u0107erka|K\\\u010derka|k\\\u0107erkama|ker|Ker|kerova|kidnapovan|Kidnapovan|kiji|kijim|klasifikuju|kle\\\u0161ta|klje\\\u0161ta|Ko|koa|koaj|kola|kolima|komandni|kombinuju|kompanija|komponovao|kom\\\u0161ija|kom\\\u0161iji|kom\\\u0161iju|kom\\\u0161iluk|kom\\\u0161iluka|kom\\\u0161iluku|kom\\\u0161ije|kom\\\u0161ijama|kom\\\u0161inica|kom\\\u0161inicu|konektovan|konektovati|kontroli\\\u0161u|Kontroli\\\u0161u|Kontroli\\\u0161i|kontroli\\\u0161i|Kontroli\\\u0161ite|kontroli\\\u0161ite|korpu|kritikuju|krsta|krsta\\\u0161i|krstu|krsti\\\u0107a|krsti\\\u0107u|Krsta|Krstu|Krsti\\\u0107a|Krsti\\\u0107u|krstom|krstove|Krstove|krstovima|Krstovima|kri\\\u017eom|kupatilo|kupatilu|kvalifikuju|la\\\u017eeju|La\\\u017eov|la\\\u017eov|la\\\u017eovi|la\\\u017eovu|la\\\u017eovima|la\\\u017eovom|lebdeo|le\\\u010di|le\\\u010de|lje\\\u010di|Le\\\u010di|Lje\\\u010di|Lejn|Lenja|lenji|lenja|le\\\u0161nik|Leta|leto|Leto|letos|letiti|leve|lo\\\u017ei|lza|ljepiti|ljepili|magnezijuma|magnezijumu|maja|maju|majem|majca|majce|majcu|majcom|Malopre|malopre|maloprije|manifestuje|manifestuju|marta|martu|martom|mehur|menom|mera\\\u010d|meri|mere|merdevine|merdevinama|merljivo|me\\\u0161ane|me\\\u0161avina|me\\\u0161avine|me\\\u0161avinu|minut|mleo|mo\\\u010d|mofu|momenat|momenta|muzejem|muzici|muzika|muzike|muzikom|Muzika|Muzike|Muzikom|na\\\u010di|nadevati|naduvan|najpre|Najpre|najzad|nanev\\\u0161i|nanjeli|napastvuje|Napolje|napolje|Napolju|napolju|nauka|Nauka|nauci|nazad|Nazad|napred|Napred|naprimjer|naseo|nasesti|nasre\\\u0107u|nebi|nebih|Nebi|Nebih|nebismo|Nebismo|nebiste|Nebiste|nedaj|negde|Negde|neguje|neguju|nekto|nemi|nemrem|nemogu|Nemogu|nemora|Nemora|nene|ne\\\u0161o|nevesta|nevreme|nezi|niasm|nigde|Nigde|nikakave|niko|Niko|nisma|Nisma|ne\\\u0107\\\u0161|nejde|Nejde|neda|nedam|negujem|njegi|ne\\\u017eeli|niej|nili|njie|njem|njeme|nominovan|nsiam|nteko|obe|Obe|obema|Obezbe\\\u0111uju|obezbe\\\u0111uju|objekat|oblast|oblastima|oblasti|obolelu|obo\\\u017eavalac|obu\\\u010di|obuhvata|odandje|odavdje|Odavdje|odbi\\\u0107e\\\u0161|odbi\\\u0107emo|odela|odelu|odelenja|odelenje|odelenju|odeljak|odeljenje|Odeljenje|odjeljenje|Odjeljenje|odeljenjem|odma|Odne\\\u0107u|odne\\\u0107u|odne\\\u0107e|odoliti|odneti|odseo|odsela|odsesti|odupreti|oduvek|Oduvek|oduvjek|Oduvjek|ogladneo|okoreli|organizuju|Organizuju|osje\\\u0107anja|osmehe|osmehne|osmehnu|osobenosti|ostareli|ostrva|ostrvu|ostrvom|Ostrva|Ostrvu|Ostrvom|ostrvima|osete|ostrvo|Ostrvo|osvjetljen|ovde|Ovde|ovdej|ovdije|Ovdije|ovjde|Ovjde|pakuje|Pakuje|Pakuju|pakuju|palatama|palate|palatu|palati|pantalone|Pantalone|pantalona|pantalonama|par\\\u010de|par\\\u010deta|par\\\u010detu|par\\\u010detom|parampar\\\u010dad|pastuv|pastuva|pastuvu|pd|pemzija|pemziju|penzionerski|Penzionerski|pertle|pesama|pesnicima|pe\\\u0161ice|Pe\\\u0161ice|pe\\\u0161ke|plata|pla\\\u010da|platom|platu|pla\\\u010danje|pla\\\u010danjem|pla\\\u0107e\\\u0161|plen|Plen|pljen|Pljen|po\\\u010de\\\u0107u|podjelimo|podnesti|podstreka\\\u010d|podsete|poen|poena|poene|poeni|Poeni|poenima|poludili|poma\\\u0107i|pomaknim|pomaknio|pomakni\\\u0161|pomakniti|pomenu|Pomera|pomera|pomjera|pomerajte|pomjeri|pomeraj|pomjeraj|pomeraju|pomerala|pomjerala|pomjeraju|pomeranja|pomerati|pomjerati|pomeri\\\u0161|ponaosob|ponesla|Ponesla|pore\\\u0111enje|pore\\\u0111enju|porekla|poreklo|poreklu|Porodica|Porodice|porodica|porodice|porodici|porodicama|porodicom|porodicu|poslata|posle|Posle|poslje|posredi|postara|Postara\\\u0107u|postara\\\u0107u|postaraj|Postaraj|Postaraju|postaraju|postarajmo|postaramo|postara\\\u0161|povesne|Povinuju|povinuju|pozadi|po\\\u017eeleo|Po\\\u017eeleo|Po\\\u017eeljeo|po\\\u017eeljeo|praktikuj|praktikuju|praktikovala|praktikovati|pre|Pre|predela|predelu|Pre\\\u0107i|pre\\\u0107i|pre\\\u0107utkuje|predame|predamnom|Predamnom|preformuli\\\u0161i|preklo|preloma|Prene\\\u0107u|prene\\\u0107u|prenos|prenosa|prenosom|prenosu|preneo|Preneo|prenela|prenjela|preneli|prenjeli|preneti|preporu\\\u010da|prese\\\u0107i|preti|prete|Prete|prjeti|prjete|prete\\\u0107im|prete\\\u0107ih|pretrpeo|prevod|Prevod|prezentovati|prezentovane|prezentovan|prezentovani|prezentovano|pridonjeti|prijatan|prime\\\u0107ivao|primedbi|primjete|prisetim|prisetio|prisetite|pritiskam|prmda|procenat|procent|procenta|procenata|procenti|Procenti|procente|Procente|procentu|Procentu|procentima|prodato|prohte|projekat|Projekat|promijena|prosledili|protestvovat|Protestvovat|Protestvujem|protestvujem|protestvuju|protestuju\\\u0107i|psihi\\\u0107ki|pto|ptom|punoletan|Punoletan|ra\\\u010dunari|ra\\\u010dunare|radijo|ra\\\u0111e|ranac|rancu|rascep|rasejan|rasejana|raspust|razbi\\\u0107u|razbijesneo|ra\\\u0161\\\u0107e|Razbi\\\u0107u|razdevi\\\u010de|razgovrati|razre\\\u0161i|razume|razumeju|re\\\u010dju|Re\\\u010dju|rje\\\u010dju|Rje\\\u010dju|reagujte|redov|redovu|re\\\u0111e|re\\\u0111i|rejv|rejvu|reko|rengen|repuje\\\u0161|resetuje|resetujte|Resetujte|rije\\\u0111i|Rizikuj|rizikuju|rizikuje|rizikujte|rje\\\u0161io|rokenrol|ronioc|savije\\\u0161\\\u0107u|save\\\u0161\\\u0107u|secka|seckam|sede\\\u0107e\\\u0161|sedeli|sedi\\\u0161ta|sedi\\\u0161te|sedi\\\u0161tu|sedni|Sedni|sedi|Sedi|sedite|sesti|sekire|sekiraj|sekiram|sekiramo|sekira\\\u0161|sekirate|sekirajte|seme|sertan|Se\\\u0161\\\u0107u|se\\\u0161\\\u0107u|sje\\\u0161\\\u0107emo|seta|sigruno|siguan|sija|sijaju|sir\\\u0107e|sir\\\u0107eta|sir\\\u0107etu|sje\\\u0161\\\u0107u|sje\\\u0161\\\u0107e|sle\\\u0107e|sle\\\u0107u|sle\\\u0107emo|sleva|se\\\u0107anjima|seo|Seo|sem|sma|smao|Smao|sme|Sme|sme\\\u0107pm|smej|Smejte|smejte|smesta|Smesta|smeste|sme\\\u0161ak|sme\\\u0161i|Sme\\\u0161i|sme\\\u0161io|sme\\\u0161i\\\u0161|sme\\\u0161kom|smjeo|smrdeo|sintersajzer|sitnisajzer|skelet|so\\\u010diva|so\\\u010divima|so\\\u010divo|so\\\u010divom|so\\\u010divu|Spakuj|Spakujte|spakujte|spasao|Spasao|spasen|spasla|spasli|speluje|speluju|spoji\\\u0107e|spolja|Sredi\\\u0107e|Sredi\\\u0107u|stabilizuju|starao|starati|Starati|steni|stepen|stepena|stepeni|stepenu|sticati|stiditi|streljamo|streljati|stole\\\u0107a|stobom|stvrano|Stupi\\\u0107u|stupi\\\u0107u|subjekat|sudija|Sudija|sudije|sudiji|sudijo|sudiju|sudijom|sudijskog|sugeri\\\u0161u|sugeri\\\u0161e|supa|supe|supi|supu|supom|supama|Supa|Supe|Supi|Supu|Supom|Supama|surfuje|surfuje\\\u0161|surfuju|su\\\u0161tina|su\\\u0161tinski|suvom|suvog|suvoj|Suvom|Suvog|Suvoj|suvim|Suvim|svestan|svjest|Svjest|svjesti|Svjesti|svetova|svetove|svugde|\\\u0161olja|\\\u0161olju|\\\u0160ta|\\\u0161tagod|\\\u0161ta|\\\u0161tp|\\\u0161tampa|\\\u0161tampu|\\\u0161tampom|\\\u0161tampi|\\\u0161tampati|\\\u0160utje\\\u0107e|tablu|taguje|tako\\\u0111e|Tako\\\u0111e|talas|Talas|talasa|talase|talasi|Talasi|talasima|Talasima|te\\\u010dnost|te\\\u010dnosti|te\\\u010dno\\\u0161\\\u0107u|tek\\\u0161o|Tek\\\u0161o|terajte|te\\\u0161io|te\\\u0161i\\\u0161|tki|to\\\u010dak|To\\\u010dak|toha|tovj|trabam|trkanje|trkanja|trkao|trougao|trougla|trouglu|trouglove|trpeo|Trpeo|tugi|tvrtci|ubede|Ube\\\u0111ivao|ube\\\u0111ivati|ubje\\\u0111ivati|ube\\\u0111uje|ube\\\u0111uje\\\u0161|ube\\\u0111uju|ubjediti|u\\\u010dtivo|u\\\u010dtivost|u\\\u010dtivo\\\u0161\\\u0107u|udata|Udata|udatoj|udeo|ugljenik|uliva|ulivali|ulivate|uljeva|ujutru|Ukoliko|ukoliko|ume|umem|ume\\\u0161|umesto|Umesto|umete|umijesto|Umijesto|umetninama|umreti|Umret|umrije\\\u0107e\\\u0161|umrije\\\u0107ete|Une\\\u0107u|univerzitet|univerzitetu|Uop\\\u0161te|uop\\\u0161te|uop\\\u010de|upustva|uprkos|Uprkos|uradio|Uredu|uspe|Uspe|uspeo|Uspeo|uspe\\\u0107e\\\u0161|uspje\\\u0107e\\\u0161|uspe\\\u0107emo|uspe\\\u0161|uspeju|uspjevala|uspijo|u\\ sred|usled|Usled|usledila|usljed|Usljed|u\\\u0161unjate|utehe|uve\\\u010de|uvek|Uvek|uvjek|Uvjek|uvijet|uvijeti|uvijetima|uva|Uva|uvo|Uvo|uvom|Uvom|uvu|Uvu|vaistinu|Vaistinu|vajar|vakcini\\\u0161e|varnica|varnicu|vaspitala|vaspitavan|vaspitavanju|va\\\u0161ljivi|va\\\u017ei|ve\\\u010dan|ve\\\u0107ati|vek|veka|veke|vekova|venca|ve\\\u010dnost|veoma|Veoma|vera|vere|veri|verom|veru|veran|verama|Vera|Vere|Veri|Verom|Veru|Veran|Verama|veren|Veren|verena|vereni|verimo|vest|Vest|vesti|Vesti|Vjesti|vjesti|vestima|Vestima|vjestima|Vjestima|ve\\\u0161ala|ve\\\u0161\\\u0107u|ve\\\u0161u|vide\\\u0161e|vidjeo|Vidjeo|vjerojatno\\\u0107a|vje\\\u0161\\\u0107u|vlo|Vodi\\\u0107e|Vodi\\\u0107u|voliti|vredelo|vrednom|vrednog|vreme|Vreme|vrjeme|Vrjeme|vrteo|vrvela|whiskey|zaceljivanje|zagreva|Zagreva|Zagrevate|zagrevanje|zakunio|zalepili|zalepiti|zaliv|zalivu|zanm|zanma|zaplena|zapleni|zaplenu|zaspem|zastareo|zauvek|Zauvek|zauvjek|Zauvjek|zavera|zahtev|Zahtev|zasede|zasedi|zasedu|zatp|Zatp|za\\\u017eeleo|Za\\\u017eeleo|Za\\\u017eeljeo|za\\\u017eeljeo|zbg|zdrvo|Zdrvo|zlodela|zna\\\u0107i|zvani\\\u010dan|zvezdom|\\\u017eemo|\\\u017eeleo|\\\u017deleo|\\\u017deljeo|\\\u017eeljeo|\\\u017diveo|\\\u017eiveo|\\\u017emureo|Abi|Alis|Ajk|Ajku|Ajrin|Ajris|Ajron|Ajvi|An\\\u0111eles|An\\\u0111elesa|An\\\u0111elesu|An\\\u0111elesom|Antoni|Antoniju|Ar\\\u010di|Beverli|Bejker|Bitls|Bitlsi|Brid\\\u017eit|Bri\\\u017eit|Bruks|Dablin|Dablina|Dablinu|Dag|Darvin|Darvina|Darvinu|Darvinom|Dejv|Dejvi|Dejva|Dejvu|Dejvom|Den|Deril|Dijaz|Dru|\\\u0110eni|\\\u0110o\\\u0161ua|D\\\u017eejmi|D\\\u017ead|D\\\u017eeri|D\\\u017eerija|D\\\u017eo|D\\\u017eoel|D\\\u017eoelu|D\\\u017eo\\\u0161|D\\\u017eo\\\u0161u|D\\\u017eosi|D\\\u017eozi|D\\\u017ees|D\\\u017een|D\\\u017eej|D\\\u017eejn|D\\\u017eil|D\\\u017eodi|D\\\u017eud|D\\\u017euli|Ebi|Ejb|Ejba|Ejmi|Ejpril|Empajer|En\\\u0111el|End\\\u017ei|Entoni|E\\\u0161ford|E\\\u0161forda|E\\\u0161li|Fibi|Filovo|Flober|Fokner|Fren|Gre\\\u010den|Grejs|Hadson|Hadsonu|Hant|Hemingvej|Henk|Hejstings|Hju|Hjua|Hjuz|Hjuza|Hjuston|Hjustonu|Igo|Ilejn|\\\u017didovin|Johni|Jud\\\u017ein|Kasl|Kejd\\\u017e|Kejn|Kejsi|Kejti|Keren|Kerol|Kerolajn|Klajv|Klajva|Klajve|Klajvu|Klarens|Kler|Kloi|Klod|Klode|Kol|Kolins|Kortni|Krej\\?g|Kristi|Lajf|Lajl|Lejk|Lorejn|Lorens|Lusi|Majk|Majkeve|Majlo|Maslou|Medlin|Medelin|Mejbel|Mejn|Mejna|Mejnu|Mejnom|Mejpls|Mejsi|Mek|Merilend|Mi\\\u010del|Nensi|Ni\\\u010de|Ni\\\u010dea|Ni\\\u010deu|Ni\\\u010deom|Odri|Ohajo|Ohaja|Ohaju|Olbrajt|O\\'Nil|Orlins|Orlinsa|Orlinsu|Pem|Pejd\\\u017e|Red\\\u017ei|Red\\\u017einald|Rej|Rej\\\u010del|Ri\\\u010d|Rouz|Sendi|Sidnej|Sindi|Sojer|Sojeru|Sole|Stejsi|Stoun|\\\u0160eron|\\\u0160eril|\\\u0160irli|\\\u0160paniji|Tajms|Tejlor|Vajlder|Val\\\u0161|Vins|Voren|Vud|\\\u017dak|\\\u017dil|januar|Januar|februar|februara|februaru|Februar|Februara|Februaru|mart|Mart|april|April|maj|Maj|svibnjom|jun|juna|junu|Jun|Juni|juli|jula|julu|Juli|septembar|Septembar|oktobar|Oktobar|oktobra|oktobru|novembar|november|novembra|novembru|Novembar|November|Novembra|Novembru|decembar|Decembar)(\\b|$)"}},
 'hun': {'BeginLines': {'data': OrderedDict(),
                        'pattern': None},
         'EndLines': {'data': OrderedDict(),
                      'pattern': None},
         'PartialLines': {'data': OrderedDict(),
                          'pattern': None},
         'PartialWordsAlways': {'data': OrderedDict(),
                                'pattern': None},
         'WholeLines': {'data': OrderedDict(),
                        'pattern': None},
         'WholeWords': {'data': OrderedDict(),
                        'pattern': None}},
 'nld': {'BeginLines': {'data': OrderedDict(),
                        'pattern': None},
         'EndLines': {'data': OrderedDict(),
                      'pattern': None},
         'PartialLines': {'data': OrderedDict(),
                          'pattern': None},
         'PartialWordsAlways': {'data': OrderedDict([(u'\u010d', u'\xe8'), (u'I\u05bb', u'I'), (u'\u05d0', u'\xe0'), (u'\u05d9', u'\xe9'), (u'\u05d8', u'\xe8'), (u'\u05db', u'\xeb'), (u'\u05dd', u'i'), (u'\u05df', u'\xef'), (u'\u05e3', u'\xf3'), (u'\u05e4', u'o'), (u'\u05e6', u'\xeb')]),
                                'pattern': None},
         'WholeLines': {'data': OrderedDict(),
                        'pattern': None},
         'WholeWords': {'data': OrderedDict([(u'ls', u'Is'), (u'ln', u'In'), (u'lk', u'Ik'), (u'ledereen', u'Iedereen'), (u'ledere', u'Iedere'), (u'lemand', u'Iemand')]),
                        'pattern': u'(?um)(\\b|^)(?:ls|ln|lk|ledereen|ledere|lemand)(\\b|$)'}},
 'nob': {'BeginLines': {'data': OrderedDict(),
                        'pattern': None},
         'EndLines': {'data': OrderedDict(),
                      'pattern': None},
         'PartialLines': {'data': OrderedDict(),
                          'pattern': None},
         'PartialWordsAlways': {'data': OrderedDict(),
                                'pattern': None},
         'WholeLines': {'data': OrderedDict(),
                        'pattern': None},
         'WholeWords': {'data': OrderedDict([(u'varjeg', u'var jeg'), (u'omjeg', u'om jeg'), (u'menjeg', u'men jeg'), (u'noejeg', u'noe jeg'), (u'f\xf8rjeg', u'f\xf8r jeg'), (u'harjobbet', u'har jobbet'), (u'Kunnejeg', u'Kunne jeg'), (u'haddejeg', u'hadde jeg'), (u'p\xe5jorden', u'p\xe5 jorden'), (u'n\xe5rjeg', u'n\xe5r jeg'), (u'tenkerjeg', u'tenker jeg'), (u'helejorden', u'hele jorden'), (u'menjorden', u'men jorden'), (u'rundtjorden', u'rundt jorden'), (u'forjorden', u'for jorden'), (u'avjordens', u'av jordens')]),
                        'pattern': u'(?um)(\\b|^)(?:varjeg|omjeg|menjeg|noejeg|f\\\xf8rjeg|harjobbet|Kunnejeg|haddejeg|p\\\xe5jorden|n\\\xe5rjeg|tenkerjeg|helejorden|menjorden|rundtjorden|forjorden|avjordens)(\\b|$)'}},
 'nor': {'BeginLines': {'data': OrderedDict(),
                        'pattern': None},
         'EndLines': {'data': OrderedDict(),
                      'pattern': None},
         'PartialLines': {'data': OrderedDict(),
                          'pattern': None},
         'PartialWordsAlways': {'data': OrderedDict(),
                                'pattern': None},
         'WholeLines': {'data': OrderedDict(),
                        'pattern': None},
         'WholeWords': {'data': OrderedDict(),
                        'pattern': None}},
 'por': {'BeginLines': {'data': OrderedDict(),
                        'pattern': None},
         'EndLines': {'data': OrderedDict(),
                      'pattern': None},
         'PartialLines': {'data': OrderedDict([(u'IN 6-E', u'N 6 E'), (u'in tegrar-se', u'integrar-se'), (u'in teresse', u'interesse'), (u'in testinos', u'intestinos'), (u'indica \xe7\xe3o', u'indica\xe7\xe3o'), (u'inte tino', u'intestino'), (u'intes tinos', u'intestinos'), (u'L da', u'Lda'), (u'mal estar', u'mal-estar'), (u'mastiga \xe7\xe1o', u'mastiga\xe7\xe3o'), (u'm\xe9di cas', u'm\xe9dicas'), (u'mineo rais', u'minerais'), (u'mola res', u'molares'), (u'movi mentos', u'movimentos'), (u'movimen to', u'movimento'), (u'N 5-Estendido', u'N\xba 5 Estendido'), (u'oxig\xe9 nio', u'oxig\xe9nio'), (u'pod mos', u'podemos'), (u'poder-se ia', u'poder-se-ia'), (u'pos sibilidade', u'possibilidade'), (u'possibi lidades', u'possibilidades'), (u'pro duto', u'produto'), (u'procu rar', u'procurar'), (u'Q u e', u'Que'), (u'qualifi cam', u'qualificam'), (u'R egi\xe3o', u'Regi\xe3o'), (u'unsuficien temente', u'insuficientemente')]),
                          'pattern': u'(?um)(?:(?<=\\s)|(?<=^)|(?<=\\b))(?:IN\\ 6\\-E|in\\ tegrar\\-se|in\\ teresse|in\\ testinos|indica\\ \\\xe7\\\xe3o|inte\\ tino|intes\\ tinos|L\\ da|mal\\ estar|mastiga\\ \\\xe7\\\xe1o|m\\\xe9di\\ cas|mineo\\ rais|mola\\ res|movi\\ mentos|movimen\\ to|N\\ 5\\-Estendido|oxig\\\xe9\\ nio|pod\\ mos|poder\\-se\\ ia|pos\\ sibilidade|possibi\\ lidades|pro\\ duto|procu\\ rar|Q\\ u\\ e|qualifi\\ cam|R\\ egi\\\xe3o|unsuficien\\ temente)(?:(?=\\s)|(?=$)|(?=\\b))'},
         'PartialWordsAlways': {'data': OrderedDict(),
                                'pattern': None},
         'WholeLines': {'data': OrderedDict(),
                        'pattern': None},
         'WholeWords': {'data': OrderedDict([(u'abitual', u'habitual'), (u'\xe0cerca', u'acerca'), (u'acessor', u'assessor'), (u'ac\xf3lico', u'ac\xf3lito'), (u'a\xe7oreano', u'a\xe7oriano'), (u'actuacao', u'actua\xe7\xe3o'), (u'acucar', u'a\xe7\xfacar'), (u'a\xe7ucar', u'a\xe7\xfacar'), (u'advinhar', u'adivinhar'), (u'africa', u'\xc1frica'), (u'ajuisar', u'ajuizar'), (u'album', u'\xe1lbum'), (u'alcool\xe9mia', u'alcoolemia'), (u'aldi\xe3o', u'alde\xe3o'), (u'algerino', u'argelino'), (u'ameixeal', u'ameixial'), (u'amia\xe7a', u'amea\xe7a'), (u'analizar', u'analisar'), (u'and\xe1ste', u'andaste'), (u'anemona', u'an\xe9mona'), (u'antartico', u'ant\xe1rctico'), (u'ant\xe1rtico', u'ant\xe1rctico'), (u'antep\xf4r', u'antepor'), (u'ap\xe1rte', u'aparte'), (u'apiadeiro', u'apeadeiro'), (u'apiar', u'apear'), (u'apreciacao', u'aprecia\xe7\xe3o'), (u'arctico', u'\xe1rctico'), (u'arrazar', u'arrasar'), (u'\xe1rtico', u'\xe1rctico'), (u'artifice', u'art\xedfice'), (u'artif\xedcial', u'artificial'), (u'ascen\xe7\xe3o', u'ascens\xe3o'), (u'ass\xfacar', u'a\xe7\xfacar'), (u'aste', u'haste'), (u'aster\xedstico', u'asterisco'), (u'aver\xe7\xe3o', u'avers\xe3o'), (u'avizar', u'avisar'), (u'avulsso', u'avulso'), (u'ba\xednha', u'bainha'), (u'banca-rota', u'bancarrota'), (u'bandeija', u'bandeja'), (u'b\xe9b\xe9', u'beb\xe9'), (u'beige', u'bege'), (u'ben\xe7\xe3o', u'b\xean\xe7\xe3o'), (u'benefici\xeancia', u'benefic\xeancia'), (u'beneficiente', u'beneficente'), (u'benvinda', u'bem-vinda'), (u'benvindo', u'bem-vindo'), (u'boasvindas', u'boas-vindas'), (u'borborinho', u'burburinho'), (u'Brazil', u'Brasil'), (u'bussula', u'b\xfassola'), (u'cabo-verdeano', u'cabo-verdiano'), (u'caimbras', u'c\xe3ibras'), (u'calc\xe1reo', u'calc\xe1rio'), (u'calsado', u'cal\xe7ado'), (u'calv\xedce', u'calv\xedcie'), (u'camoneano', u'camoniano'), (u'campi\xe3o', u'campe\xe3o'), (u'can\xe7acos', u'cansa\xe7os'), (u'caracter', u'car\xe1cter'), (u'caract\xe9res', u'caracteres'), (u'catequeze', u'catequese'), (u'catequisador', u'catequizador'), (u'catequisar', u'catequizar'), (u'ch\xedcara', u'x\xedcara'), (u'ciclano', u'sicrano'), (u'cicrano', u'sicrano'), (u'cidad\xe3es', u'cidad\xe3os'), (u'cidad\xf5es', u'cidad\xe3os'), (u'cincoenta', u'cinquenta'), (u'cinseiro', u'cinzeiro'), (u'cinsero', u'sincero'), (u'citacoes', u'cita\xe7\xf5es'), (u'coaliz\xe3o', u'colis\xe3o'), (u'c\xf4dia', u'c\xf4dea'), (u'comb\xf3io', u'comboio'), (u'comp\xf4r', u'compor'), (u'concerteza', u'com certeza'), (u'constituia', u'constitu\xeda'), (u'constitu\xedu', u'constituiu'), (u'contato', u'contacto'), (u'contens\xe3o', u'conten\xe7\xe3o'), (u'contribuicoes', u'contribui\xe7\xf5es'), (u'c\xf4r', u'cor'), (u'corass\xe3o', u'cora\xe7\xe3o'), (u'cor\xe7ario', u'cors\xe1rio'), (u'cor\xe7\xe1rio', u'cors\xe1rio'), (u'cornprimidosinbo', u'comprimidozinho'), (u'cr\xe2neo', u'cr\xe2nio'), (u'dE', u'de'), (u'defeni\xe7\xe3o', u'defini\xe7\xe3o'), (u'defenido', u'definido'), (u'defenir', u'definir'), (u'deficite', u'd\xe9fice'), (u'degladiar', u'digladiar'), (u'deiche', u'deixe'), (u'desinteria', u'disenteria'), (u'despendio', u'disp\xeandio'), (u'desp\xeandio', u'disp\xeandio'), (u'desplic\xeancia', u'displic\xeancia'), (u'dificulidade', u'dificuldade'), (u'dispender', u'despender'), (u'dispendio', u'disp\xeandio'), (u'distribuido', u'distribu\xeddo'), (u'dru\xedda', u'druida'), (u'\xe9cr\xe3', u'ecr\xe3'), (u'ecran', u'ecr\xe3'), (u'\xe9cran', u'ecr\xe3'), (u'\xeale', u'ele'), (u'elice', u'h\xe9lice'), (u'\xe9lice', u'h\xe9lice'), (u'emiratos', u'emirados'), (u'engolis-te', u'engoliste'), (u'engulir', u'engolir'), (u'enguliste', u'engoliste'), (u'entertido', u'entretido'), (u'entitular', u'intitular'), (u'entreterimento', u'entretenimento'), (u'entreti-me', u'entretive-me'), (u'env\xf3lucro', u'inv\xf3lucro'), (u'er\xf3i', u'her\xf3i'), (u'escluir', u'excluir'), (u'esclus\xe3o', u'exclus\xe3o'), (u'escriv\xf5es', u'escriv\xe3es'), (u'esqueiro', u'isqueiro'), (u'esquesito', u'esquisito'), (u'estacoes', u'esta\xe7\xf5es'), (u'esteje', u'esteja'), (u'excava\xe7\xe3o', u'escava\xe7\xe3o'), (u'excavar', u'escavar'), (u'exdr\xfaxula', u'esdr\xfaxula'), (u'exdr\xfaxulas', u'esdr\xfaxulas'), (u'exitar', u'hesitar'), (u'explicacoes', u'explica\xe7\xf5es'), (u'exquisito', u'esquisito'), (u'extende', u'estende'), (u'extender', u'estender'), (u'f\xe0cilmenfe', u'facilmente'), (u'f\xe0cilmente', u'facilmente'), (u'fariam-lhe', u'far-lhe-iam'), (u'FARM\xc1ClAS', u'FARM\xc1CIAS'), (u'farmec\xeautico', u'farmac\xeautico'), (u'fassa', u'fa\xe7a'), (u'f\xe9bre', u'febre'), (u'fecula', u'f\xe9cula'), (u'f\xe9mea', u'f\xeamea'), (u'femenino', u'feminino'), (u'femininismo', u'feminismo'), (u'f\xedsiologista', u'fisiologista'), (u'fiz\xe9mos', u'fizemos'), (u'fizes-te', u'fizeste'), (u'fl\xf4r', u'flor'), (u'for\xe3o', u'foram'), (u'formalisar', u'formalizar'), (u'f\xf4ro', u'foro'), (u'fos-te', u'foste'), (u'frag\xe2ncia', u'fragr\xe2ncia'), (u'fran\xe7\xeas', u'franc\xeas'), (u'frasqutnho', u'frasquinho'), (u'frustado', u'frustrado'), (u'fur\xe1', u'furar'), (u'gaz', u'g\xe1s'), (u'g\xe1z', u'g\xe1s'), (u'geito', u'jeito'), (u'geneceu', u'gineceu'), (u'geropiga', u'jeropiga'), (u'glic\xe9mia', u'glicemia'), (u'gorgeta', u'gorjeta'), (u'grangear', u'granjear'), (u'guizar', u'guisar'), (u'hectar', u'hectare'), (u'herm\xe9ticamente', u'hermeticamente'), (u'hernia', u'h\xe9rnia'), (u'higi\xe9ne', u'higiene'), (u'hilariedade', u'hilaridade'), (u'hiperac\xeddez', u'hiperacidez'), (u'hontem', u'ontem'), (u'igiene', u'higiene'), (u'igienico', u'higi\xe9nico'), (u'igi\xe9nico', u'higi\xe9nico'), (u'igreija', u'igreja'), (u'iguasu', u'igua\xe7u'), (u'ilac\xe7\xe3o', u'ila\xe7\xe3o'), (u'imbigo', u'umbigo'), (u'impecilho', u'empecilho'), (u'\xedncas', u'incas'), (u'inc\xeasto', u'incesto'), (u'inclusiv\xe9', u'inclusive'), (u'inc\xf4modos', u'inc\xf3modos'), (u'incontest\xe1velmente', u'incontestavelmente'), (u'incontest\xe0velmente', u'incontestavelmente'), (u'indespens\xe1veis', u'indispens\xe1veis'), (u'indespens\xe1vel', u'indispens\xe1vel'), (u'India', u'\xcdndia'), (u'indiguina\xe7\xe3o', u'indigna\xe7\xe3o'), (u'indiguinado', u'indignado'), (u'indiguinar', u'indignar'), (u'inflac\xe7\xe3o', u'infla\xe7\xe3o'), (u'ingreja', u'igreja'), (u'INSCRICOES', u'INSCRI\xc7\xd5ES'), (u'intens\xe3o', u'inten\xe7\xe3o'), (u'intertido', u'entretido'), (u'intoxica', u'Intoxica'), (u'intrega', u'entrega'), (u'inveros\xedmel', u'inveros\xedmil'), (u'iorgute', u'iogurte'), (u'ipop\xf3tamo', u'hipop\xf3tamo'), (u'ipsilon', u'\xedpsilon'), (u'ipslon', u'\xedpsilon'), (u'isquesito', u'esquisito'), (u'ju\xedz', u'juiz'), (u'juiza', u'ju\xedza'), (u'j\xfaniores', u'juniores'), (u'justanzente', u'justamente'), (u'juz', u'jus'), (u'kilo', u'quilo'), (u'laborat\xf3rio-porque', u'laborat\xf3rio porque'), (u'ladravaz', u'ladrava'), (u'lament\xe0velmente', u'lamentavelmente'), (u'lampe\xe3o', u'lampi\xe3o'), (u'largartixa', u'lagartixa'), (u'largarto', u'lagarto'), (u'l\xeam', u'l\xeaem'), (u'leuc\xe9mia', u'leucemia'), (u'licensa', u'licen\xe7a'), (u'lingu\xedsta', u'linguista'), (u'lisongear', u'lisonjear'), (u'logista', u'lojista'), (u'ma\xe7ajar', u'massajar'), (u'Macfadden-o', u'Macfadden o'), (u'mae', u'm\xe3e'), (u'magestade', u'majestade'), (u'm\xe3gua', u'm\xe1goa'), (u'mangerico', u'manjerico'), (u'mangerona', u'manjerona'), (u'manteem-se', u'mant\xeam-se'), (u'mantega', u'manteiga'), (u'mantem-se', u'mant\xe9m-se'), (u'massi\xe7o', u'maci\xe7o'), (u'massisso', u'maci\xe7o'), (u'm\xe9dica-Rio', u'm\xe9dica Rio'), (u'menistro', u'ministro'), (u'merciaria', u'mercearia'), (u'metrelhadora', u'metralhadora'), (u'miscegena\xe7\xe3o', u'miscigena\xe7\xe3o'), (u'misogenia', u'misoginia'), (u'misogeno', u'mis\xf3gino'), (u'mis\xf3geno', u'mis\xf3gino'), (u'm\xba', u'\xba'), (u'm\xf4lho', u'molho'), (u'monument\xe2nea', u'moment\xe2nea'), (u'mortandela', u'mortadela'), (u'morteIa', u'mortela'), (u'muinto', u'muito'), (u'nasaias', u'nasais'), (u'n\xeale', u'nele'), (u'nest', u'neste'), (u'Nivea', u'N\xedvea'), (u'nonagessimo', u'nonag\xe9simo'), (u'nonag\xe9ssimo', u'nonag\xe9simo'), (u'nornal', u'normal'), (u'not\xe0velmente', u'notavelmente'), (u'obcess\xe3o', u'obsess\xe3o'), (u'obesidae', u'obesidade'), (u'\xf3bviamente', u'obviamente'), (u'\xf2bviamente', u'obviamente'), (u'ofecina', u'oficina'), (u'oje', u'hoje'), (u'omem', u'homem'), (u'opcoes', u'op\xe7\xf5es'), (u'op\xf3brio', u'opr\xf3brio'), (u'opr\xf3bio', u'opr\xf3brio'), (u'orf\xe3o', u'\xf3rf\xe3o'), (u'organigrama', u'organograma'), (u'organisar', u'organizar'), (u'org\xe3o', u'\xf3rg\xe3o'), (u'orta', u'horta'), (u'\xf3tima', u'\xf3ptima'), (u'\xf3timos', u'\xf3ptimos'), (u'paraliza\xe7\xe3o', u'paralisa\xe7\xe3o'), (u'paralizado', u'paralisado'), (u'paralizar', u'paralisar'), (u'par\xe1ste', u'paraste'), (u'P\xe1tria', u'p\xe1tria'), (u'pa\xfal', u'Paul'), (u'pecal\xe7o', u'percal\xe7o'), (u'p\xeaga', u'pega'), (u'periodo', u'per\xedodo'), (u'pertubar', u'perturbar'), (u'per\xfa', u'peru'), (u'piqueno', u'pequeno'), (u'pirin\xe9us', u'Piren\xe9us'), (u'poblema', u'problema'), (u'pobrema', u'problema'), (u'poden', u'podem'), (u'poder-mos', u'pudermos'), (u'ponteagudo', u'pontiagudo'), (u'pontuacoes', u'pontua\xe7\xf5es'), (u'prazeiroso', u'prazeroso'), (u'precaridade', u'precariedade'), (u'precizar', u'precisar'), (u'preserveran\xe7a', u'perseveran\xe7a'), (u'previl\xe9gio', u'privil\xe9gio'), (u'prim\xe1ria-que', u'prim\xe1ria que'), (u'pri\xfado', u'per\xedodo'), (u'probalidade', u'probabilidade'), (u'progreso', u'progresso'), (u'proib\xeddo', u'proibido'), (u'pro\xedbido', u'proibido'), (u'pr\xf3pia', u'pr\xf3pria'), (u'propiedade', u'propriedade'), (u'propio', u'pr\xf3prio'), (u'pr\xf3pio', u'pr\xf3prio'), (u'provocacoes', u'provoca\xe7\xf5es'), (u'prsen\xe7a', u'presen\xe7a'), (u'prustituta', u'prostituta'), (u'pud\xe9rmos', u'pudermos'), (u'p\xfalico', u'p\xfablico'), (u'p\xfas', u'pus'), (u'pus\xe9mos', u'pusemos'), (u'quadricomia', u'quadricromia'), (u'quadriplicado', u'quadruplicado'), (u'quaisqueres', u'quaisquer'), (u'quer-a', u'quere-a'), (u'quere-se', u'quer-se'), (u'quer-o', u'quere-o'), (u'qu\xedmco', u'qu\xedmico'), (u'quises-te', u'quiseste'), (u'quizer', u'quiser'), (u'quizeram', u'quiseram'), (u'quizesse', u'quisesse'), (u'quizessem', u'quisessem'), (u'ra\xednha', u'rainha'), (u'ra\xedz', u'raiz'), (u'raizes', u'ra\xedzes'), (u'ratato', u'retrato'), (u'ra\xfal', u'raul'), (u'razar', u'rasar'), (u'rectaguarda', u'retaguarda'), (u'r\xe9dia', u'r\xe9dea'), (u'reestabelecer', u'restabelecer'), (u'refeicoes', u'refei\xe7\xf5es'), (u'ref\xearencia', u'refer\xeancia'), (u'regeitar', u'rejeitar'), (u'regurjitar', u'regurgitar'), (u'reinvidica\xe7\xe3o', u'reivindica\xe7\xe3o'), (u'reinvidicar', u'reivindicar'), (u'requer-a', u'requere-a'), (u'requere-se', u'requer-se'), (u'requer-o', u'requere-o'), (u'requesito', u'requisito'), (u'requisicoes', u'requisi\xe7\xf5es'), (u'RESIDENCIA', u'RESID\xcaNCIA'), (u'respira\xe7\xe1o', u'respira\xe7\xe3o'), (u'restablecer', u'restabelecer'), (u'r\xe9stea', u'r\xe9stia'), (u'ruborisar', u'ruborizar'), (u'r\xfabrica', u'rubrica'), (u's\xe0dia', u'sadia'), (u'saiem', u'saem'), (u'salchicha', u'salsicha'), (u'salchichas', u'salsichas'), (u'saloice', u'saloiice'), (u'salv\xe9', u'salve'), (u'salve-ra\xednha', u'salve-rainha'), (u'salv\xe9-rainha', u'salve-rainha'), (u'salv\xe9-ra\xednha', u'salve-rainha'), (u'sao', u's\xe3o'), (u'sargeta', u'sarjeta'), (u'se\xe7\xf5es', u'sec\xe7\xf5es'), (u'seija', u'seja'), (u'seissentos', u'seiscentos'), (u'seje', u'seja'), (u'semiar', u'semear'), (u's\xe9niores', u'seniores'), (u'sensibilidadc', u'sensibilidade'), (u'sens\xedvelmente', u'sensivelmente'), (u'setessentos', u'setecentos'), (u'siclano', u'sicrano'), (u'Sifilis', u'S\xedfilis'), (u'sif\xedlis', u's\xedfilis'), (u'sin\xe3o', u'sen\xe3o'), (u'sinmtoma', u'sintoma'), (u'sint\xe9ticamente', u'sinteticamente'), (u'sintetisa', u'sintetiza'), (u'S\xd3', u's\xf3'), (u's\xf4fra', u'sofra'), (u's\xf4fregamente', u'sofregamente'), (u'som\xe1ste', u'somaste'), (u'sombracelha', u'sobrancelha'), (u'sombrancelha', u'sobrancelha'), (u'sombrancelhas', u'sobrancelhas'), (u'suavisar', u'suavizar'), (u'substituido', u'substitu\xeddo'), (u'suburbio', u'sub\xfarbio'), (u'suI', u'sul'), (u'Sui\xe7a', u'Su\xed\xe7a'), (u'sui\xe7as', u'su\xed\xe7as'), (u'sui\xe7o', u'su\xed\xe7o'), (u'sui\xe7os', u'su\xed\xe7os'), (u'sup\xf4r', u'supor'), (u'tabeli\xf5es', u'tabeli\xe3es'), (u'ta\xednha', u'tainha'), (u'tava', u'estava'), (u't\xeaem', u't\xeam'), (u'telemovel', u'telem\xf3vel'), (u'tel\xe9movel', u'telem\xf3vel'), (u'terminacoes', u'termina\xe7\xf5es'), (u'tor\xe1xico', u'tor\xe1cico'), (u'tou', u'estou'), (u'transp\xf4r', u'transpor'), (u'trasnporte', u'transporte'), (u'tumors', u'tumores'), (u'\xfamida', u'h\xfamida'), (u'umidade', u'unidade'), (u'vai-vem', u'vaiv\xe9m'), (u'vegil\xe2ncia', u'vigil\xe2ncia'), (u'vegilante', u'vigilante'), (u'vento\xednha', u'ventoinha'), (u'veros\xedmel', u'veros\xedmil'), (u'video', u'v\xeddeo'), (u'virus', u'v\xedrus'), (u'visiense', u'viseense'), (u'vo\xe7e', u'voc\xea'), (u'vo\xe7\xea', u'voc\xea'), (u'v\xf4o', u'voo'), (u'xadr\xeas', u'xadrez'), (u'xafariz', u'chafariz'), (u'x\xe9x\xe9', u'xex\xe9'), (u'xilindr\xf3', u'chilindr\xf3'), (u'za\xedre', u'Zaire'), (u'zepelin', u'zepelim'), (u'zig-zag', u'ziguezague'), (u'zo\xf4', u'zoo'), (u'z\xf4o', u'zoo'), (u'zuar', u'zoar'), (u'zum-zum', u'zunzum')]),
                        'pattern': u'(?um)(\\b|^)(?:abitual|\\\xe0cerca|acessor|ac\\\xf3lico|a\\\xe7oreano|actuacao|acucar|a\\\xe7ucar|advinhar|africa|ajuisar|album|alcool\\\xe9mia|aldi\\\xe3o|algerino|ameixeal|amia\\\xe7a|analizar|and\\\xe1ste|anemona|antartico|ant\\\xe1rtico|antep\\\xf4r|ap\\\xe1rte|apiadeiro|apiar|apreciacao|arctico|arrazar|\\\xe1rtico|artifice|artif\\\xedcial|ascen\\\xe7\\\xe3o|ass\\\xfacar|aste|aster\\\xedstico|aver\\\xe7\\\xe3o|avizar|avulsso|ba\\\xednha|banca\\-rota|bandeija|b\\\xe9b\\\xe9|beige|ben\\\xe7\\\xe3o|benefici\\\xeancia|beneficiente|benvinda|benvindo|boasvindas|borborinho|Brazil|bussula|cabo\\-verdeano|caimbras|calc\\\xe1reo|calsado|calv\\\xedce|camoneano|campi\\\xe3o|can\\\xe7acos|caracter|caract\\\xe9res|catequeze|catequisador|catequisar|ch\\\xedcara|ciclano|cicrano|cidad\\\xe3es|cidad\\\xf5es|cincoenta|cinseiro|cinsero|citacoes|coaliz\\\xe3o|c\\\xf4dia|comb\\\xf3io|comp\\\xf4r|concerteza|constituia|constitu\\\xedu|contato|contens\\\xe3o|contribuicoes|c\\\xf4r|corass\\\xe3o|cor\\\xe7ario|cor\\\xe7\\\xe1rio|cornprimidosinbo|cr\\\xe2neo|dE|defeni\\\xe7\\\xe3o|defenido|defenir|deficite|degladiar|deiche|desinteria|despendio|desp\\\xeandio|desplic\\\xeancia|dificulidade|dispender|dispendio|distribuido|dru\\\xedda|\\\xe9cr\\\xe3|ecran|\\\xe9cran|\\\xeale|elice|\\\xe9lice|emiratos|engolis\\-te|engulir|enguliste|entertido|entitular|entreterimento|entreti\\-me|env\\\xf3lucro|er\\\xf3i|escluir|esclus\\\xe3o|escriv\\\xf5es|esqueiro|esquesito|estacoes|esteje|excava\\\xe7\\\xe3o|excavar|exdr\\\xfaxula|exdr\\\xfaxulas|exitar|explicacoes|exquisito|extende|extender|f\\\xe0cilmenfe|f\\\xe0cilmente|fariam\\-lhe|FARM\\\xc1ClAS|farmec\\\xeautico|fassa|f\\\xe9bre|fecula|f\\\xe9mea|femenino|femininismo|f\\\xedsiologista|fiz\\\xe9mos|fizes\\-te|fl\\\xf4r|for\\\xe3o|formalisar|f\\\xf4ro|fos\\-te|frag\\\xe2ncia|fran\\\xe7\\\xeas|frasqutnho|frustado|fur\\\xe1|gaz|g\\\xe1z|geito|geneceu|geropiga|glic\\\xe9mia|gorgeta|grangear|guizar|hectar|herm\\\xe9ticamente|hernia|higi\\\xe9ne|hilariedade|hiperac\\\xeddez|hontem|igiene|igienico|igi\\\xe9nico|igreija|iguasu|ilac\\\xe7\\\xe3o|imbigo|impecilho|\\\xedncas|inc\\\xeasto|inclusiv\\\xe9|inc\\\xf4modos|incontest\\\xe1velmente|incontest\\\xe0velmente|indespens\\\xe1veis|indespens\\\xe1vel|India|indiguina\\\xe7\\\xe3o|indiguinado|indiguinar|inflac\\\xe7\\\xe3o|ingreja|INSCRICOES|intens\\\xe3o|intertido|intoxica|intrega|inveros\\\xedmel|iorgute|ipop\\\xf3tamo|ipsilon|ipslon|isquesito|ju\\\xedz|juiza|j\\\xfaniores|justanzente|juz|kilo|laborat\\\xf3rio\\-porque|ladravaz|lament\\\xe0velmente|lampe\\\xe3o|largartixa|largarto|l\\\xeam|leuc\\\xe9mia|licensa|lingu\\\xedsta|lisongear|logista|ma\\\xe7ajar|Macfadden\\-o|mae|magestade|m\\\xe3gua|mangerico|mangerona|manteem\\-se|mantega|mantem\\-se|massi\\\xe7o|massisso|m\\\xe9dica\\-Rio|menistro|merciaria|metrelhadora|miscegena\\\xe7\\\xe3o|misogenia|misogeno|mis\\\xf3geno|m\\\xba|m\\\xf4lho|monument\\\xe2nea|mortandela|morteIa|muinto|nasaias|n\\\xeale|nest|Nivea|nonagessimo|nonag\\\xe9ssimo|nornal|not\\\xe0velmente|obcess\\\xe3o|obesidae|\\\xf3bviamente|\\\xf2bviamente|ofecina|oje|omem|opcoes|op\\\xf3brio|opr\\\xf3bio|orf\\\xe3o|organigrama|organisar|org\\\xe3o|orta|\\\xf3tima|\\\xf3timos|paraliza\\\xe7\\\xe3o|paralizado|paralizar|par\\\xe1ste|P\\\xe1tria|pa\\\xfal|pecal\\\xe7o|p\\\xeaga|periodo|pertubar|per\\\xfa|piqueno|pirin\\\xe9us|poblema|pobrema|poden|poder\\-mos|ponteagudo|pontuacoes|prazeiroso|precaridade|precizar|preserveran\\\xe7a|previl\\\xe9gio|prim\\\xe1ria\\-que|pri\\\xfado|probalidade|progreso|proib\\\xeddo|pro\\\xedbido|pr\\\xf3pia|propiedade|propio|pr\\\xf3pio|provocacoes|prsen\\\xe7a|prustituta|pud\\\xe9rmos|p\\\xfalico|p\\\xfas|pus\\\xe9mos|quadricomia|quadriplicado|quaisqueres|quer\\-a|quere\\-se|quer\\-o|qu\\\xedmco|quises\\-te|quizer|quizeram|quizesse|quizessem|ra\\\xednha|ra\\\xedz|raizes|ratato|ra\\\xfal|razar|rectaguarda|r\\\xe9dia|reestabelecer|refeicoes|ref\\\xearencia|regeitar|regurjitar|reinvidica\\\xe7\\\xe3o|reinvidicar|requer\\-a|requere\\-se|requer\\-o|requesito|requisicoes|RESIDENCIA|respira\\\xe7\\\xe1o|restablecer|r\\\xe9stea|ruborisar|r\\\xfabrica|s\\\xe0dia|saiem|salchicha|salchichas|saloice|salv\\\xe9|salve\\-ra\\\xednha|salv\\\xe9\\-rainha|salv\\\xe9\\-ra\\\xednha|sao|sargeta|se\\\xe7\\\xf5es|seija|seissentos|seje|semiar|s\\\xe9niores|sensibilidadc|sens\\\xedvelmente|setessentos|siclano|Sifilis|sif\\\xedlis|sin\\\xe3o|sinmtoma|sint\\\xe9ticamente|sintetisa|S\\\xd3|s\\\xf4fra|s\\\xf4fregamente|som\\\xe1ste|sombracelha|sombrancelha|sombrancelhas|suavisar|substituido|suburbio|suI|Sui\\\xe7a|sui\\\xe7as|sui\\\xe7o|sui\\\xe7os|sup\\\xf4r|tabeli\\\xf5es|ta\\\xednha|tava|t\\\xeaem|telemovel|tel\\\xe9movel|terminacoes|tor\\\xe1xico|tou|transp\\\xf4r|trasnporte|tumors|\\\xfamida|umidade|vai\\-vem|vegil\\\xe2ncia|vegilante|vento\\\xednha|veros\\\xedmel|video|virus|visiense|vo\\\xe7e|vo\\\xe7\\\xea|v\\\xf4o|xadr\\\xeas|xafariz|x\\\xe9x\\\xe9|xilindr\\\xf3|za\\\xedre|zepelin|zig\\-zag|zo\\\xf4|z\\\xf4o|zuar|zum\\-zum)(\\b|$)'}},
 'rus': {'BeginLines': {'data': OrderedDict(),
                        'pattern': None},
         'EndLines': {'data': OrderedDict(),
                      'pattern': None},
         'PartialLines': {'data': OrderedDict(),
                          'pattern': None},
         'PartialWordsAlways': {'data': OrderedDict(),
                                'pattern': None},
         'WholeLines': {'data': OrderedDict(),
                        'pattern': None},
         'WholeWords': {'data': OrderedDict([(u'\u041d\u0404\u0419', u'\u041d\u0415\u0419'), (u'\u041e\u0420\u0413\u0417\u041d\u0418\u0417\u041c\u041e\u0411', u'\u041e\u0420\u0413\u0410\u041d\u0418\u0417\u041c\u0410'), (u'\u0427\u04570', u'\u0427\u0422\u041e'), (u'\u041d\u042d', u'\u041d\u0410'), (u'\u0421\u041e\u0421\u0404\u0414\u041d\u042e\u042e', u'\u0421\u041e\u0421\u0415\u0414\u041d\u042e\u042e'), (u'\u041f\u041b\u0417\u041d\u0404\u0422\u0423', u'\u041f\u041b\u0410\u041d\u0415\u0422\u0423'), (u'\u0417\u0417\u0413\u042d\u0414\u041e\u041a', u'\u0417\u0410\u0413\u0410\u0414\u041e\u041a'), (u'\u0421\u041e\u0422\u0412\u041e\u0420\u0404\u041d\u0418\u042f', u'\u0421\u041e\u0422\u0412\u041e\u0420\u0415\u041d\u0418\u042f'), (u'\u041c\u0418\u0420\u042d', u'\u041c\u0418\u0420\u0410'), (u'\u041f\u041e\u042f\u0411\u041b\u0404\u041d\u0418\u042f', u'\u041f\u041e\u042f\u0412\u041b\u0415\u041d\u0418\u042f'), (u'\u0417\u0404\u041c\u041b\u0404', u'\u0417\u0415\u041c\u041b\u0415'), (u'\u0404\u0429\u0404', u'\u0415\u0429\u0401'), (u'\u0422\u0404\u041c\u041d\u042c\u0406\u0425', u'\u0422\u0415\u041c\u041d\u042b\u0425'), (u'\u0421\u0404\u0420\u042c\u0404\u0417\u041d\u042c\u0406\u041c', u'\u0421\u0415\u0420\u042c\u0415\u0417\u041d\u042b\u041c'), (u'\u041f\u041e\u0428\u0406\u04060', u'\u041f\u041e\u0428\u041b\u041e'), (u'\u041f\u04400\u0418\u04170\u0428\u0404\u041b', u'\u041f\u0420\u041e\u0418\u0417\u041e\u0428\u0415\u041b'), (u'\u0421\u0404\u041a\u0420\u0404\u0422\u042d\u041c\u0418', u'\u0421\u0415\u041a\u0420\u0415\u0422\u0410\u041c\u0418'), (u'\u041c\u042d\u0422\u0404\u0420\u0418\u0417\u041b\u042c\u0406', u'\u041c\u0410\u0422\u0415\u0420\u0418\u0410\u041b\u042b'), (u'\u041f\u042f\u0422\u0404\u041d', u'\u041f\u042f\u0422\u0415\u041d'), (u'\u041f\u041b\u0430\u041d\u0404\u0457\u0404', u'\u041f\u041b\u0410\u041d\u0415\u0422\u0415'), (u'\u041a\u0417\u0422\u042d\u041a\u041b\u0418\u0417\u041c', u'\u041a\u0410\u0422\u0410\u041a\u041b\u0418\u0417\u041c'), (u'\u041e\u041a\u0417\u0417\u0417\u041b\u0421\u042f', u'\u041e\u041a\u0410\u0417\u0410\u041b\u0421\u042f'), (u'\u0414\u042d\u041b\u042c\u0428\u0415', u'\u0414\u0410\u041b\u042c\u0428\u0415'), (u'\u0422\u0412\u041a', u'\u0422\u0410\u041a'), (u'\u041f\u041b\u0417\u041d\u0404\u0422\u0417', u'\u041f\u041b\u0410\u041d\u0415\u0422\u0410'), (u'\u0427\u0404\u0413\u041e', u'\u0427\u0415\u0413\u041e'), (u'\u0423\u0417\u041d\u042d\u0422\u042c', u'\u0423\u0417\u041d\u0410\u0422\u042c'), (u'\u041f\u041b\u042d\u041d\u0404\u0422\u0404', u'\u041f\u041b\u0410\u041d\u0415\u0422\u0415'), (u'\u041d\u0404\u041c', u'\u041d\u0415\u041c'), (u'\u0411\u041e\u0417\u041c\u041e\u0416\u041d\u0417', u'\u0412\u041e\u0417\u041c\u041e\u0416\u041d\u0410'), (u'\u0421\u041e\u0411\u0404\u0420\u0428\u0404\u041d\u041d\u041e', u'\u0421\u041e\u0412\u0415\u0420\u0428\u0415\u041d\u041d\u041e'), (u'\u0418\u041d\u042d\u0427\u0404', u'\u0418\u041d\u0410\u0427\u0415'), (u'\u0411\u0421\u0404', u'\u0412\u0421\u0415'), (u'\u041d\u0415\u0414\u041e\u0421\u0422\u0417\u0422\u041a\u0418', u'\u041d\u0415\u0414\u041e\u0421\u0422\u0410\u0422\u041a\u0418'), (u'\u041d\u041e\u0412\u042c\u0406\u0404', u'\u041d\u041e\u0412\u042b\u0415'), (u'\u0412\u0404\u041b\u0418\u041a\u041e\u041b\u0404\u041f\u041d\u042d\u042f', u'\u0412\u0415\u041b\u0418\u041a\u041e\u041b\u0415\u041f\u041d\u0410\u042f'), (u'\u041e\u0421\u0422\u042d\u0406\u0406\u041e\u0421\u042c', u'\u041e\u0421\u0422\u0410\u041b\u041e\u0421\u042c'), (u'\u041d\u0417\u041b\u0418\u0427\u0418\u0404', u'\u041d\u0410\u041b\u0418\u0427\u0418\u0415'), (u'\u0431\u042b', u'\u0431\u044b'), (u'\u041f\u0420\u041e\u0426\u0412\u0415\u0422\u0412\u0422\u042c', u'\u041f\u0420\u041e\u0426\u0412\u0415\u0422\u0410\u0422\u042c'), (u'\u041a\u0417\u041a', u'\u041a\u0410\u041a'), (u'\u0412\u041e\u0414\u0417', u'\u0412\u041e\u0414\u0410'), (u'\u041d\u0417\u0428\u0415\u041b', u'\u041d\u0410\u0428\u0415\u041b'), (u'\u041d\u0404', u'\u041d\u0415'), (u'\u0422\u041e\u0416\u0404', u'\u0422\u041e\u0416\u0415'), (u'\u0412\u0423\u041b\u041a\u042d\u041d\u0418\u0427\u0404\u0421\u041a\u041e\u0419', u'\u0412\u0423\u041b\u041a\u0410\u041d\u0418\u0427\u0415\u0421\u041a\u041e\u0419'), (u'\u042d\u041a\u0422\u0418\u0411\u041d\u041e\u0421\u0422\u0418', u'\u0410\u041a\u0422\u0418\u0412\u041d\u041e\u0421\u0422\u0418'), (u'\u041f\u041e\u042f\u0412\u0418\u041b\u0417\u0421\u042c', u'\u041f\u041e\u042f\u0412\u0418\u041b\u0410\u0421\u042c'), (u'\u041d\u041e\u0412\u0417\u042f', u'\u041d\u041e\u0412\u0410\u042f'), (u'\u0421\u0422\u0420\u042d\u0422\u0404\u0413\u0418\u042f', u'\u0421\u0422\u0420\u0410\u0422\u0415\u0413\u0418\u042f'), (u'\u0423\u0421\u041f\u0404\u0428\u041d0', u'\u0423\u0421\u041f\u0415\u0428\u041d\u041e'), (u'\u041f\u041e\u0421\u0417\u0414\u041a\u0423', u'\u041f\u041e\u0421\u0410\u0414\u041a\u0423'), (u'\u0413\u041e\u0422\u041e\u0411\u042b', u'\u0413\u041e\u0422\u041e\u0412\u042b'), (u'\u041d\u0417\u0427\u0417\u0422\u042c', u'\u041d\u0410\u0427\u0410\u0422\u042c'), (u'\u041e\u0425\u041e\u0422\u042d', u'\u041e\u0425\u041e\u0422\u0410'), (u'\u041f\u0420\u0418\u0417\u041d\u0417\u041a\u0417\u041c\u0418', u'\u041f\u0420\u0418\u0417\u041d\u0410\u041a\u0410\u041c\u0418'), (u'\u041f\u04400\u0428\u041b\u041e\u041c', u'\u041f\u0420\u041e\u0428\u041b\u041e\u041c'), (u'\u041d\u042d\u0421\u0422\u041e\u042f\u0429\u0404\u041c', u'\u041d\u0410\u0421\u0422\u041e\u042f\u0429\u0415\u041c'), (u'\u041f\u0423\u0421\u0422\u041e\u0422\u0417\u0425', u'\u041f\u0423\u0421\u0422\u041e\u0422\u0410\u0425'), (u'\u0411\u041b\u0417\u0416\u041d\u041e\u0419', u'\u0412\u041b\u0410\u0416\u041d\u041e\u0419'), (u'\u041f\u041e\u0427\u0411\u0404', u'\u041f\u041e\u0427\u0412\u0415'), (u'\u041c\u042c\u0406', u'\u041c\u042b'), (u'\u0421\u0404\u0419\u0427\u0417\u0421', u'\u0421\u0415\u0419\u0427\u0410\u0421'), (u'\u0404\u0421\u041b\u0418', u'\u0415\u0421\u041b\u0418'), (u'\u0417\u0417\u0422\u0420\u041e\u041d\u0415\u041c', u'\u0417\u0410\u0422\u0420\u041e\u041d\u0415\u041c'), (u'\u041e\u041f\u0417\u0421\u0417\u0404\u041c\u0421\u042f', u'\u041e\u041f\u0410\u0421\u0410\u0415\u041c\u0421\u042f'), (u'\u0421\u0418\u041b\u042c\u041d0', u'\u0421\u0418\u041b\u042c\u041d\u041e'), (u'\u041e\u0422\u041b\u0418\u0427\u0417\u0404\u0422\u0421\u042f', u'\u041e\u0422\u041b\u0418\u0427\u0410\u0415\u0422\u0421\u042f'), (u'\u0420\u042d\u041d\u042c\u0428\u0404', u'\u0420\u0410\u041d\u042c\u0428\u0415'), (u'\u041d\u0417\u0417\u042c\u0406\u0412\u0417\u042e\u0422', u'\u041d\u0410\u0417\u042b\u0412\u0410\u042e\u0422'), (u'\u0422\u0404\u041a\u041b3', u'\u0422\u0415\u041a\u041b\u0410'), (u'\u041e\u0421\u0417\u0414\u041e\u0427\u041d\u042b\u041c\u0418', u'\u041e\u0421\u0410\u0414\u041e\u0427\u041d\u042b\u041c\u0418'), (u'\u041f\u041e\u0421\u0422\u0404\u041f\u0404\u041d\u041d0', u'\u041f\u041e\u0421\u0422\u0415\u041f\u0415\u041d\u041d\u041e'), (u'\u0418\u0421\u041f\u042d\u0420\u042f\u041b\u0417\u0421\u042c', u'\u0418\u0421\u041f\u0410\u0420\u042f\u041b\u0410\u0421\u042c'), (u'\u0404\u041e\u041b\u042c\u0428\u041e\u0404', u'\u0411\u041e\u041b\u042c\u0428\u041e\u0415'), (u'\u041a\u041e\u041b\u0418\u0427\u0404\u0421\u0422\u0411\u041e', u'\u041a\u041e\u041b\u0418\u0427\u0415\u0421\u0422\u0412\u041e'), (u'\u0413\u0404\u041c\u0417\u0422\u0418\u0422\u0415', u'\u0413\u0415\u041c\u0410\u0422\u0418\u0422\u0410'), (u'\u041f\u041e\u041b\u0423\u0427\u042d\u0404\u0422', u'\u041f\u041e\u041b\u0423\u0427\u0410\u0415\u0422'), (u'\u041d\u0404\u0414\u041e\u0421\u0422\u0417\u0427\u041d0', u'\u041d\u0415\u0414\u041e\u0421\u0422\u0410\u0422\u041e\u0427\u041d\u041e'), (u'\u041f\u0418\u0422\u042d\u041d\u0418\u042f', u'\u041f\u0418\u0422\u0410\u041d\u0418\u042f'), (u'\u041f\u041e\u041a\u0417', u'\u041f\u041e\u041a\u0410'), (u'\u0411\u042c\u0406\u0425\u041e\u0414\u0418\u041b\u0418', u'\u0412\u042b\u0425\u041e\u0414\u0418\u041b\u0418'), (u'\u0417\u0404\u041c\u0406\u0406\u0404', u'\u0417\u0415\u041c\u041b\u0415'), (u'\u0412\u0404\u0421\u042c\u0406\u0418\u0417', u'\u0412\u0415\u0421\u042c\u041c\u0410'), (u'\u0417\u0404\u041c\u041b\u0418', u'\u0417\u0415\u041c\u041b\u0418'), (u'\u0431\u042c\u0406\u041b\u041e', u'\u0411\u042b\u041b\u041e'), (u'\u041a\u0418\u0417\u041d\u0418', u'\u0416\u0418\u0417\u041d\u0418'), (u'\u0421\u0422\u0417\u041d\u041e\u0412\u0418\u041b\u0417\u0421\u042c', u'\u0421\u0422\u0410\u041d\u041e\u0412\u0418\u041b\u0410\u0421\u042c'), (u'\u0421\u041e\u041b\u0404\u041d\u0404\u0404', u'\u0421\u041e\u041b\u0401\u041d\u0415\u0415'), (u'\u041c\u042d\u0413\u041d\u0418\u0422\u041d\u042b\u041c', u'\u041c\u0410\u0413\u041d\u0418\u0422\u041d\u042b\u041c'), (u'\u0427\u0422\u041e\u0431\u042c\u0406', u'\u0427\u0422\u041e\u0411\u042b'), (u'\u0421\u041e\u0417\u0414\u0415\u0422\u042c', u'\u0421\u041e\u0417\u0414\u0410\u0422\u042c'), (u'\u041c\u0417\u0413\u041d\u0418\u0422\u041d\u041e\u0404', u'\u041c\u0410\u0413\u041d\u0418\u0422\u041d\u041e\u0415'), (u'\u041a\u042d\u0416\u0423\u0422\u0421\u042f', u'\u041a\u0410\u0416\u0423\u0422\u0421\u042f'), (u'\u041e\u0417\u041d\u0417\u0427\u0417\u0404\u0422', u'\u041e\u0417\u041d\u0410\u0427\u0410\u0415\u0422'), (u'\u041c\u041e\u0413\u041b\u0417', u'\u041c\u041e\u0413\u041b\u0410'), (u'\u0418\u041c\u0404\u0422\u042c', u'\u0418\u041c\u0415\u0422\u042c'), (u'\u041a\u041e\u0421\u041c\u041e\u0421\u042d', u'\u041a\u041e\u0421\u041c\u041e\u0421\u0410'), (u'\u0421\u041e\u041b\u041d\u0404\u0427\u041d\u0417\u042f', u'\u0421\u041e\u041b\u041d\u0415\u0427\u041d\u0410\u042f'), (u'\u0421\u0418\u0421\u0422\u0404\u041c\u0417', u'\u0421\u0418\u0421\u0422\u0415\u041c\u0410'), (u'\u041f\u041e\u0421\u0406\u0406\u0423\u0416\u0418\u041b\u041e', u'\u041f\u041e\u0421\u041b\u0423\u0416\u0418\u041b\u041e'), (u'\u041c\u0417\u0413\u041d\u0418\u0422\u041d\u041e\u0413\u041e', u'\u041c\u0410\u0413\u041d\u0418\u0422\u041d\u041e\u0413\u041e'), (u'\u041f\u041b\u0412\u041d\u0404\u0422\u042b', u'\u041f\u041b\u0410\u041d\u0415\u0422\u042b'), (u'\u041b\u041e\u041a\u0417\u041b\u042c\u041d\u042c\u0406\u0425', u'\u041b\u041e\u041a\u0410\u041b\u042c\u041d\u042b\u0425'), (u'\u041f\u041e\u041b\u0404\u0419', u'\u041f\u041e\u041b\u0415\u0419'), (u'\u041a\u0417\u0416\u0423\u0422\u0421\u042f', u'\u041a\u0410\u0416\u0423\u0422\u0421\u042f'), (u'\u041a\u0417\u041a\u041e\u0413\u041e', u'\u041a\u0410\u041a\u041e\u0413\u041e'), (u'\u0421\u0422\u0420\u0417\u0428\u041d\u041e\u0413\u041e', u'\u0421\u0422\u0420\u0410\u0428\u041d\u041e\u0413\u041e'), (u'\u0421\u0422\u041e\u041b\u041a\u041d\u041e\u0415\u0404\u041d\u0418\u042f', u'\u0421\u0422\u041e\u041b\u041a\u041d\u041e\u0412\u0415\u041d\u0418\u042f'), (u'\u041c\u0415\u0421\u0422\u0417\u041c\u0418', u'\u041c\u0415\u0421\u0422\u0410\u041c\u0418'), (u'\u0421\u0414\u0404\u041b\u0417\u0422\u042c', u'\u0421\u0414\u0415\u041b\u0410\u0422\u042c'), (u'\u0421\u0422\u0417\u041b\u041e', u'\u0421\u0422\u0410\u041b\u041e'), (u'\u041c\u042d\u0413\u041d\u0418\u0422\u041d\u041e\u0413\u041e', u'\u041c\u0410\u0413\u041d\u0418\u0422\u041d\u041e\u0413\u041e'), (u'\u0417\u0417\u041a\u041b\u042e\u0427\u0417\u0412\u0428\u0404\u0419\u0421\u042f', u'\u0417\u0410\u041a\u041b\u042e\u0427\u0410\u0412\u0428\u0415\u0419\u0421\u042f'), (u'\u0404\u0413\u041e', u'\u0415\u0413\u041e'), (u'\u042f\u0414\u0420\u0404', u'\u042f\u0414\u0420\u0415'), (u'\u041d\u0417', u'\u041d\u0410'), (u'\u0418\u0421\u0427\u0404\u0417\u041b3', u'\u0418\u0421\u0427\u0415\u0417\u041b\u0410'), (u'\u0421\u0427\u0418\u0422\u0417\u042e', u'\u0421\u0427\u0418\u0422\u0410\u042e'), (u'\u0428\u042d\u041d\u0421\u042b', u'\u0428\u0410\u041d\u0421\u042b'), (u'\u0418\u041d\u0417\u0427\u0404', u'\u0418\u041d\u0410\u0427\u0415'), (u'\u0421\u0422\u0417\u041b', u'\u0421\u0422\u0410\u041b'), (u'\u0422\u0420\u0417\u0422\u0418\u0422\u042c', u'\u0422\u0420\u0410\u0422\u0418\u0422\u042c'), (u'\u041d\u0417\u041f\u0420\u0417\u0412\u041b\u042f\u0404\u0422\u0421\u042f', u'\u041d\u0410\u041f\u0420\u0410\u0412\u041b\u042f\u0415\u0422\u0421\u042f'), (u'\u041e\u0411\u041b\u042d\u0421\u0422\u0418', u'\u041e\u0411\u041b\u0410\u0421\u0422\u0418'), (u'\u042f\u0412\u041b\u042f\u0406\u041e\u0422\u0421\u042f', u'\u042f\u0412\u041b\u042f\u042e\u0422\u0421\u042f'), (u'\u0413\u041b\u042d\u0412\u041d\u041e\u0419', u'\u0413\u041b\u0410\u0412\u041d\u041e\u0419'), (u'\u0414\u041e\u041a\u0417\u0417\u0417\u0422\u0404\u041b\u042c\u0421\u0422\u0412', u'\u0414\u041e\u041a\u0410\u0417\u0410\u0422\u0415\u041b\u042c\u0421\u0422\u0412'), (u'\u041a\u0418\u0421\u041b\u041e\u0422\u042d\u041c\u0418', u'\u041a\u0418\u0421\u041b\u041e\u0422\u0410\u041c\u0418'), (u'\u041e\u041d\u042d', u'\u041e\u041d\u0410'), (u'\u041f\u0420\u0417\u041a\u0422\u0418\u0427\u0404\u0421\u041a\u0418', u'\u041f\u0420\u0410\u041a\u0422\u0418\u0427\u0415\u0421\u041a\u0418'), (u'\u041b\u0404\u0421\u0423', u'\u041b\u0415\u0421\u0423'), (u'\u0423\u0421\u041b\u041e\u0411\u0418\u042f\u041c', u'\u0423\u0421\u041b\u041e\u0412\u0418\u042f\u041c'), (u'\u0421\u041f\u0417\u0421\u0422\u0418\u0421\u042c', u'\u0421\u041f\u0410\u0421\u0422\u0418\u0421\u042c'), (u'\u0420\u0417\u0417\u0412\u0418\u0412\u0417\u042e\u0429\u0418\u0404\u0421\u042f', u'\u0420\u0410\u0417\u0412\u0418\u0412\u0410\u042e\u0429\u0418\u0415\u0421\u042f'), (u'\u0428\u042d\u041f\u041a\u0418', u'\u0428\u0410\u041f\u041a\u0418'), (u'\u0417\u041d\u0417\u0404\u041c', u'\u0417\u041d\u0410\u0415\u041c'), (u'\u0421\u041e\u041e\u0418\u0420\u042d\u0404\u041c\u0421\u042f', u'\u0421\u041e\u0411\u0418\u0420\u0410\u0415\u041c\u0421\u042f'), (u'\u0411\u042b\u042f\u0421\u041d\u0418\u0422\u042c', u'\u0412\u042b\u042f\u0421\u041d\u0418\u0422\u042c'), (u'\u0421\u0417\u041c', u'\u0421\u0410\u041c'), (u'\u0420\u0417\u0421\u041f\u041e\u0417\u041d\u0417\u0422\u042c', u'\u0420\u0410\u0421\u041f\u041e\u0417\u041d\u0410\u0422\u042c'), (u'\u0423\u0417\u041d\u0417\u0422\u042c', u'\u0423\u0417\u041d\u0410\u0422\u042c'), (u'\u041a\u042d\u0416\u0404\u0422\u0421\u042f', u'\u041a\u0410\u0416\u0415\u0422\u0421\u042f'), (u'\u041e\u0420\u0404\u0418\u0422\u0417\u041b\u042c\u041d\u042c\u0406\u0404', u'\u041e\u0420\u0411\u0418\u0422\u0410\u041b\u042c\u041d\u042b\u0415'), (u'\u041b\u0404\u0422\u042d\u0422\u0404\u041b\u042c\u041d\u042c\u0406\u0404', u'\u041b\u0415\u0422\u0410\u0422\u0415\u041b\u042c\u041d\u042b\u0415'), (u'\u0417\u041f\u041f\u0417\u0420\u0415\u0422\u042c\u0406', u'\u0410\u041f\u041f\u0410\u0420\u0410\u0422\u042b'), (u'\u0416\u0404', u'\u0416\u0415'), (u'\u0422\u0417\u041a\u0417\u042f', u'\u0422\u0410\u041a\u0410\u042f'), (u'\u041c\u0417\u041b\u0404\u041d\u042c\u041a\u0417\u042f', u'\u041c\u0410\u041b\u0415\u041d\u042c\u041a\u0410\u042f'), (u'\u041f\u041b\u042d\u041d\u0404\u0422\u0417', u'\u041f\u041b\u0410\u041d\u0415\u0422\u0410'), (u'\u0421\u041f\u0417\u0406\u0406\u042c\u041a\u041e', u'\u0421\u0422\u041e\u041b\u042c\u041a\u041e'), (u'\u0431\u042c\u0406\u041b3', u'\u0411\u042b\u041b\u0410'), (u'\u0401\u0415\u0421\u0427\u0418\u0421\u041b\u0404\u041d\u041d\u041e\u0404', u'\u0411\u0415\u0421\u0427\u0418\u0421\u041b\u0415\u041d\u041d\u041e\u0415'), (u'\u041c\u0417\u0413\u041d\u0418\u0457\u041d\u042c\u0406\u0425', u'\u041c\u0410\u0413\u041d\u0418\u0422\u041d\u042b\u0425'), (u'\u041f\u041e\u0421\u0422\u0440\u0430\u04143\u041b', u'\u041f\u041e\u0421\u0422\u0420\u0410\u0414\u0410\u041b'), (u'\u0414\u0417\u0416\u0404', u'\u0414\u0410\u0416\u0415'), (u'\u0420\u0417\u0417\u041d\u042c\u0406\u041c\u0418', u'\u0420\u0410\u0417\u041d\u042b\u041c\u0418'), (u'\u0421\u0423\u0429\u0404\u0421\u0422\u0411\u041e\u0412\u042d\u041d\u0418\u0404', u'\u0421\u0423\u0429\u0415\u0421\u0422\u0412\u041e\u0412\u0410\u041d\u0418\u0415'), (u'\u041f\u041b\u0430\u041d\u0404\u0457\u042c\u0406', u'\u041f\u041b\u0410\u041d\u0415\u0422\u042b'), (u'\u041f\u041e\u0414\u0412\u0404\u0420\u0413\u041b\u0417\u0421\u042c', u'\u041f\u041e\u0414\u0412\u0415\u0420\u0413\u041b\u0410\u0421\u042c'), (u'\u041e\u041f\u0417\u0421\u0406-\u0406\u041e\u0421\u0422\u0418', u'\u041e\u041f\u0410\u0421\u041d\u041e\u0421\u0422\u0418'), (u'\u041f\u041b\u0417\u041d\u0404\u0422\u0404', u'\u041f\u041b\u0410\u041d\u0415\u0422\u0415'), (u'\u041d0', u'\u041d\u041e'), (u'\u0431\u042c\u0406', u'\u0411\u042b'), (u'\u041e\u0422\u0414\u0417\u041b\u0404\u041d\u041d\u042b\u0404', u'\u041e\u0422\u0414\u0410\u041b\u0401\u041d\u041d\u042b\u0415'), (u'\u041f\u041e\u041b\u042f\u0420\u041d\u042c\u0406\u0404', u'\u041f\u041e\u041b\u042f\u0420\u041d\u042b\u0415'), (u'\u0426\u0404\u041b\u042c\u0406-\u041e', u'\u0426\u0415\u041b\u042c\u042e'), (u'\u041f\u0404\u0429\u0404\u0420\u0417\u0425', u'\u041f\u0415\u0429\u0415\u0420\u0410\u0425'), (u'\u041d\u0417\u041f\u041e\u041b\u041d\u0404\u041d\u041d\u042c\u0406\u0425', u'\u041d\u0410\u041f\u041e\u041b\u041d\u0415\u041d\u041d\u042b\u0425'), (u'\u0418\u0421\u041f\u0417\u0420\u0404\u041d\u0418\u042f\u041c\u0418', u'\u0418\u0421\u041f\u0410\u0420\u0415\u041d\u0418\u042f\u041c\u0418'), (u'\u041c\u0418\u041d\u0418\u0417\u0422\u042e\u0420\u041d\u042c\u0406\u0404', u'\u041c\u0418\u041d\u0418\u0410\u0422\u042e\u0420\u041d\u042b\u0415'), (u'\u0422\u042d\u041a\u0417\u042f', u'\u0422\u0410\u041a\u0410\u042f'), (u'\u041f\u0440\u0418\u0421\u041f0\u0421\u041e\u0431\u0418\u0422\u042c\u0421\u042f', u'\u041f\u0420\u0418\u0421\u041f\u041e\u0421\u041e\u0411\u0418\u0422\u042c\u0421\u042f'), (u'\u041d\u0404\u041e\u0404\u0425\u041e\u0414\u0418\u041c\u042c\u0406\u0404', u'\u041d\u0415\u041e\u0411\u0425\u041e\u0414\u0418\u041c\u042b\u0415'), (u'\u041e\u0420\u0413\u0412\u041d\u0418\u0427\u0404\u0421\u041a\u0418\u0404', u'\u041e\u0420\u0413\u0410\u041d\u0418\u0427\u0415\u0421\u041a\u0418\u0415'), (u'\u041c\u0417\u0420\u0421\u0418\u0417\u041d\u0421\u041a\u0418\u0404', u'\u041c\u0410\u0420\u0421\u0418\u0410\u041d\u0421\u041a\u0418\u0415'), (u'\u041c\u0404\u0421\u0422\u0404', u'\u041c\u0415\u0421\u0422\u0415'), (u'\u0406\\/\u0406\u0410\u041a\u041a\u0415\u0419\u0428', u'\u041c\u0410\u041a\u041a\u0415\u0419\u041d'), (u'\u041d\u0417\u0425\u041e\u0414\u042f\u0429\u0418\u0404\u0421\u042f', u'\u041d\u0410\u0425\u041e\u0414\u042f\u0429\u0418\u0415\u0421\u042f'), (u'\u041d\u0404\u0417\u041a\u0422\u0418\u0412\u041d\u041e\u041c', u'\u041d\u0415\u0410\u041a\u0422\u0418\u0412\u041d\u041e\u041c'), (u'\u0417\u042d\u0421\u041d\u042f\u0422\u042c', u'\u0417\u0410\u0421\u041d\u042f\u0422\u042c'), (u'\u041e\u0420\u0413\u0417\u041d\u0418\u0417\u041c\u042c\u0406', u'\u041e\u0420\u0413\u0410\u041d\u0418\u0417\u041c\u042b'), (u'\u0412\u0417\u0415\u0418\u041c\u041e\u0414\u0404\u0419\u0421\u0422\u0412\u041e\u0412\u0415\u0422\u042c', u'\u0412\u0417\u0410\u0418\u041c\u041e\u0414\u0415\u0419\u0421\u0422\u0412\u041e\u0412\u0410\u0422\u042c'), (u'\u041f\u0423\u0422\u0404\u0428\u0404\u0421\u0422\u0411\u0418\u0404', u'\u041f\u0423\u0422\u0415\u0428\u0415\u0421\u0422\u0412\u0418\u0415'), (u'\u041f\u0443\u0421\u0457\u042c\u0406\u041d\u041d\u042b\u0425', u'\u041f\u0423\u0421\u0422\u042b\u041d\u041d\u042b\u0425'), (u'\u0422\u0417\u041a\u0418\u0425', u'\u0422\u0410\u041a\u0418\u0425'), (u'\u041f\u0404\u0420\u0404\u0422\u0417\u0421\u041a\u0418\u0412\u0417\u0404\u041c', u'\u041f\u0415\u0420\u0415\u0422\u0410\u0421\u041a\u0418\u0412\u0410\u0415\u041c'), (u'\u0427\u04220', u'\u0427\u0422\u041e'), (u'\u0412\u0404\u0421\u042c\u041c\u0417', u'\u0412\u0415\u0421\u042c\u041c\u0410'), (u'\u041f\u041e\u041b\u041e\u0421\u0417\u041c\u0418', u'\u041f\u041e\u041b\u041e\u0421\u0410\u041c\u0418'), (u'\u041e\u0440\u0457\u042d\u041d\u0418\u0417\u041c\u042c\u0406', u'\u041e\u0420\u0413\u0410\u041d\u0418\u0417\u041c\u042b'), (u'\u041e\u0401\u041b\u0417\u0421\u0422\u0418', u'\u041e\u0411\u041b\u0410\u0421\u0422\u0418'), (u'\u042f\u0411\u041b\u042f\u042e\u0422\u0421\u042f', u'\u042f\u0412\u041b\u042f\u042e\u0422\u0421\u042f'), (u'\u0426\u0404\u041b\u042c\u042e', u'\u0426\u0415\u041b\u042c\u042e'), (u'\u041f\u041e\u0418\u0421\u041a\u041e\u0411', u'\u041f\u041e\u0418\u0421\u041a\u041e\u0412'), (u'\u0414\u041e\u041a\u0417\u0417\u0417\u0422\u0404\u0406\u0406\u042c\u0421\u0422\u0412', u'\u0414\u041e\u041a\u0410\u0417\u0410\u0422\u0415\u041b\u042c\u0421\u0422\u0412'), (u'\u041c\u041e\u0416\u0404\u0422', u'\u041c\u041e\u0416\u0415\u0422'), (u'\u041d\u042d\u0425\u041e\u0414\u0418\u0422\u042c\u0421\u042f', u'\u041d\u0410\u0425\u041e\u0414\u0418\u0422\u042c\u0421\u042f'), (u'\u041e\u0427\u0404\u041d\u042c', u'\u041e\u0427\u0415\u041d\u042c'), (u'\u0421\u0420\u0417\u0412\u041d\u0418\u0422\u042c', u'\u0421\u0420\u0410\u0412\u041d\u0418\u0422\u042c'), (u'\u041e\u0404\u041d\u0417\u0420\u0423\u0416\u0418\u041b', u'\u041e\u0411\u041d\u0410\u0420\u0423\u0416\u0418\u041b'), (u'\u041b\u042c\u0414\u0417', u'\u041b\u042c\u0414\u0410'), (u'\u041f\u041e\u0422\u0404\u041f\u041b\u0404\u041d\u0418\u0404\u0406\u0418', u'\u041f\u041e\u0422\u0415\u041f\u041b\u0415\u041d\u0418\u0415\u041c'), (u'\u041f\u041e\u0425\u041e\u041b\u041e\u0414\u0417\u041d\u0418\u0404\u0411\u0414', u'\u041f\u041e\u0425\u041e\u041b\u041e\u0414\u0410\u041d\u0418\u0415\u041c'), (u'\u041a\u042d\u041a', u'\u041a\u0410\u041a'), (u'\u0422\u0404\u041b\u041e', u'\u0422\u0415\u041b\u041e'), (u'\u0431\u041e\u041b\u042c\u0428\u0404', u'\u0411\u041e\u041b\u042c\u0428\u0415'), (u'\u041d\u042d\u041a\u041b\u041e\u041d\u042f\u0404\u0422\u0421\u042f', u'\u041d\u0410\u041a\u041b\u041e\u041d\u042f\u0415\u0422\u0421\u042f'), (u'\u0421\u041e\u0406\u0406\u041d\u0426\u0423', u'\u0421\u041e\u041b\u041d\u0426\u0423'), (u'\u0421\u04223\u0431\u0418\u041b\u0418\u0417\u0418\u0440\u041e\u0411\u0417\u0422\u042c', u'\u0421\u0422\u0410\u0411\u0418\u041b\u0418\u0417\u0418\u0420\u041e\u0412\u0410\u0422\u042c'), (u'\u0421\u0422\u042d\u0411\u0418\u041b\u042c\u041d\u042d', u'\u0421\u0422\u0410\u0411\u0418\u041b\u042c\u041d\u0410'), (u'\u041c\u0418\u041b\u0406\u0406\u0418\u041e\u041d\u041e\u0412', u'\u041c\u0418\u041b\u041b\u0418\u041e\u041d\u041e\u0412'), (u'\u041d\u0417\u0417\u042d\u0414', u'\u041d\u0410\u0417\u0410\u0414'), (u'\u0422\u0404\u041f\u041b0', u'\u0422\u0415\u041f\u041b\u041e'), (u'\u041f\u041e\u0406\u0406\u042f\u0420\u041d\u042b\u0425', u'\u041f\u041e\u041b\u042f\u0420\u041d\u042b\u0425'), (u'\u0421\u041e\u0406\u0406\u0415\u041d\u042b\u041c\u0418', u'\u0421\u041e\u041b\u0415\u041d\u042b\u041c\u0418'), (u'\u041a\u0415\u041a\u0418\u041c\u0418', u'\u041a\u0410\u041a\u0418\u041c\u0418'), (u'\u043a\u0438\u0441\u043b\u044e\u0442\u043d\u044e\u0441\u0433\u0433\u044c', u'\u043a\u0438\u0441\u043b\u043e\u0442\u043d\u043e\u0441\u0442\u044c'), (u'\u0422\u0417\u041c', u'\u0422\u0410\u041c'), (u'\u041e\u0420\u0413\u0417\u041d\u0418\u0417\u041c\u042b', u'\u041e\u0420\u0413\u0410\u041d\u0418\u0417\u041c\u042b'), (u'\u0421\u0423\u0429\u0404\u0421\u0422\u0412\u041e\u0412\u0404\u0422\u042c', u'\u0421\u0423\u0429\u0415\u0421\u0422\u0412\u041e\u0412\u0410\u0422\u042c'), (u'\u0412\u041d\u0418\u041c\u0417\u041d\u0418\u0404', u'\u0412\u041d\u0418\u041c\u0410\u041d\u0418\u0415'), (u'\u0421\u0414\u0404\u041b\u0417\u0404\u0422', u'\u0421\u0414\u0415\u041b\u0410\u0415\u0422'), (u'\u041f\u041e\u0417\u041d\u042d\u041a\u041e\u041c\u0418\u0422\u042c\u0421\u042f', u'\u041f\u041e\u0417\u041d\u0410\u041a\u041e\u041c\u0418\u0422\u042c\u0421\u042f'), (u'\u041d\u042d\u0428\u0418\u041c', u'\u041d\u0410\u0428\u0418\u041c'), (u'\u0414\u041e\u041a\u0417\u0417\u042d\u0422\u0404\u041b\u042c\u0421\u0422\u0411\u041e', u'\u0414\u041e\u041a\u0410\u0417\u0410\u0422\u0415\u041b\u042c\u0421\u0422\u0412\u041e'), (u'\u0429\u0417\u0417\u0429\u0404\u041d\u0418\u042f', u'\u0412\u0420\u0410\u0429\u0415\u041d\u0418\u042f'), (u'\u0431\u042c\u0406\u041b0', u'\u0411\u042b\u041b\u041e'), (u'\u041e\u0404\u041b\u0415\u0421\u0422\u042f\u0425', u'\u041e\u0411\u041b\u0410\u0421\u0422\u042f\u0425'), (u'\u0431\u042c\u0406\u041b\u0418', u'\u0411\u042b\u041b\u0418'), (u'\u0420\u042d\u0417\u041c\u042c\u0406\u0428\u041b\u042f\u0406\u0406\u0418', u'\u0420\u0410\u0417\u041c\u042b\u0428\u041b\u042f\u041b\u0418'), (u'\u041a\u041e\u041b\u0418\u0427\u0404\u0421\u0422\u0411\u0404', u'\u041a\u041e\u041b\u0418\u0427\u0415\u0421\u0422\u0412\u0415'), (u'\u0429\u0404\u0406\u0406\u041e\u0427\u041d\u042b\u0404', u'\u0429\u0415\u041b\u041e\u0427\u041d\u042b\u0415'), (u'\u041d\u0404\u041a\u041e\u0422\u0429\u0417\u042c\u0406\u0404', u'\u041d\u0415\u041a\u041e\u0422\u041e\u0420\u042b\u0415'), (u'\u041f\u0440\u0418\u0411\u04061\u0415\u041a\u0443\u0457', u'\u041f\u0420\u0418\u0412\u041b\u0415\u041a\u0423\u0422'), (u'\u041d\u0417\u0417\u042c\u0406\u0412\u042d\u0404\u041c\u042b\u0404', u'\u041d\u0410\u0417\u042b\u0412\u0410\u0415\u041c\u042b\u0415'), (u'\u0427\u045706\u042b', u'\u0427\u0422\u041e\u0411\u042b')]),
                        'pattern': u'(?um)(\\b|^)(?:\\\u041d\\\u0404\\\u0419|\\\u041e\\\u0420\\\u0413\\\u0417\\\u041d\\\u0418\\\u0417\\\u041c\\\u041e\\\u0411|\\\u0427\\\u04570|\\\u041d\\\u042d|\\\u0421\\\u041e\\\u0421\\\u0404\\\u0414\\\u041d\\\u042e\\\u042e|\\\u041f\\\u041b\\\u0417\\\u041d\\\u0404\\\u0422\\\u0423|\\\u0417\\\u0417\\\u0413\\\u042d\\\u0414\\\u041e\\\u041a|\\\u0421\\\u041e\\\u0422\\\u0412\\\u041e\\\u0420\\\u0404\\\u041d\\\u0418\\\u042f|\\\u041c\\\u0418\\\u0420\\\u042d|\\\u041f\\\u041e\\\u042f\\\u0411\\\u041b\\\u0404\\\u041d\\\u0418\\\u042f|\\\u0417\\\u0404\\\u041c\\\u041b\\\u0404|\\\u0404\\\u0429\\\u0404|\\\u0422\\\u0404\\\u041c\\\u041d\\\u042c\\\u0406\\\u0425|\\\u0421\\\u0404\\\u0420\\\u042c\\\u0404\\\u0417\\\u041d\\\u042c\\\u0406\\\u041c|\\\u041f\\\u041e\\\u0428\\\u0406\\\u04060|\\\u041f\\\u04400\\\u0418\\\u04170\\\u0428\\\u0404\\\u041b|\\\u0421\\\u0404\\\u041a\\\u0420\\\u0404\\\u0422\\\u042d\\\u041c\\\u0418|\\\u041c\\\u042d\\\u0422\\\u0404\\\u0420\\\u0418\\\u0417\\\u041b\\\u042c\\\u0406|\\\u041f\\\u042f\\\u0422\\\u0404\\\u041d|\\\u041f\\\u041b\\\u0430\\\u041d\\\u0404\\\u0457\\\u0404|\\\u041a\\\u0417\\\u0422\\\u042d\\\u041a\\\u041b\\\u0418\\\u0417\\\u041c|\\\u041e\\\u041a\\\u0417\\\u0417\\\u0417\\\u041b\\\u0421\\\u042f|\\\u0414\\\u042d\\\u041b\\\u042c\\\u0428\\\u0415|\\\u0422\\\u0412\\\u041a|\\\u041f\\\u041b\\\u0417\\\u041d\\\u0404\\\u0422\\\u0417|\\\u0427\\\u0404\\\u0413\\\u041e|\\\u0423\\\u0417\\\u041d\\\u042d\\\u0422\\\u042c|\\\u041f\\\u041b\\\u042d\\\u041d\\\u0404\\\u0422\\\u0404|\\\u041d\\\u0404\\\u041c|\\\u0411\\\u041e\\\u0417\\\u041c\\\u041e\\\u0416\\\u041d\\\u0417|\\\u0421\\\u041e\\\u0411\\\u0404\\\u0420\\\u0428\\\u0404\\\u041d\\\u041d\\\u041e|\\\u0418\\\u041d\\\u042d\\\u0427\\\u0404|\\\u0411\\\u0421\\\u0404|\\\u041d\\\u0415\\\u0414\\\u041e\\\u0421\\\u0422\\\u0417\\\u0422\\\u041a\\\u0418|\\\u041d\\\u041e\\\u0412\\\u042c\\\u0406\\\u0404|\\\u0412\\\u0404\\\u041b\\\u0418\\\u041a\\\u041e\\\u041b\\\u0404\\\u041f\\\u041d\\\u042d\\\u042f|\\\u041e\\\u0421\\\u0422\\\u042d\\\u0406\\\u0406\\\u041e\\\u0421\\\u042c|\\\u041d\\\u0417\\\u041b\\\u0418\\\u0427\\\u0418\\\u0404|\\\u0431\\\u042b|\\\u041f\\\u0420\\\u041e\\\u0426\\\u0412\\\u0415\\\u0422\\\u0412\\\u0422\\\u042c|\\\u041a\\\u0417\\\u041a|\\\u0412\\\u041e\\\u0414\\\u0417|\\\u041d\\\u0417\\\u0428\\\u0415\\\u041b|\\\u041d\\\u0404|\\\u0422\\\u041e\\\u0416\\\u0404|\\\u0412\\\u0423\\\u041b\\\u041a\\\u042d\\\u041d\\\u0418\\\u0427\\\u0404\\\u0421\\\u041a\\\u041e\\\u0419|\\\u042d\\\u041a\\\u0422\\\u0418\\\u0411\\\u041d\\\u041e\\\u0421\\\u0422\\\u0418|\\\u041f\\\u041e\\\u042f\\\u0412\\\u0418\\\u041b\\\u0417\\\u0421\\\u042c|\\\u041d\\\u041e\\\u0412\\\u0417\\\u042f|\\\u0421\\\u0422\\\u0420\\\u042d\\\u0422\\\u0404\\\u0413\\\u0418\\\u042f|\\\u0423\\\u0421\\\u041f\\\u0404\\\u0428\\\u041d0|\\\u041f\\\u041e\\\u0421\\\u0417\\\u0414\\\u041a\\\u0423|\\\u0413\\\u041e\\\u0422\\\u041e\\\u0411\\\u042b|\\\u041d\\\u0417\\\u0427\\\u0417\\\u0422\\\u042c|\\\u041e\\\u0425\\\u041e\\\u0422\\\u042d|\\\u041f\\\u0420\\\u0418\\\u0417\\\u041d\\\u0417\\\u041a\\\u0417\\\u041c\\\u0418|\\\u041f\\\u04400\\\u0428\\\u041b\\\u041e\\\u041c|\\\u041d\\\u042d\\\u0421\\\u0422\\\u041e\\\u042f\\\u0429\\\u0404\\\u041c|\\\u041f\\\u0423\\\u0421\\\u0422\\\u041e\\\u0422\\\u0417\\\u0425|\\\u0411\\\u041b\\\u0417\\\u0416\\\u041d\\\u041e\\\u0419|\\\u041f\\\u041e\\\u0427\\\u0411\\\u0404|\\\u041c\\\u042c\\\u0406|\\\u0421\\\u0404\\\u0419\\\u0427\\\u0417\\\u0421|\\\u0404\\\u0421\\\u041b\\\u0418|\\\u0417\\\u0417\\\u0422\\\u0420\\\u041e\\\u041d\\\u0415\\\u041c|\\\u041e\\\u041f\\\u0417\\\u0421\\\u0417\\\u0404\\\u041c\\\u0421\\\u042f|\\\u0421\\\u0418\\\u041b\\\u042c\\\u041d0|\\\u041e\\\u0422\\\u041b\\\u0418\\\u0427\\\u0417\\\u0404\\\u0422\\\u0421\\\u042f|\\\u0420\\\u042d\\\u041d\\\u042c\\\u0428\\\u0404|\\\u041d\\\u0417\\\u0417\\\u042c\\\u0406\\\u0412\\\u0417\\\u042e\\\u0422|\\\u0422\\\u0404\\\u041a\\\u041b3|\\\u041e\\\u0421\\\u0417\\\u0414\\\u041e\\\u0427\\\u041d\\\u042b\\\u041c\\\u0418|\\\u041f\\\u041e\\\u0421\\\u0422\\\u0404\\\u041f\\\u0404\\\u041d\\\u041d0|\\\u0418\\\u0421\\\u041f\\\u042d\\\u0420\\\u042f\\\u041b\\\u0417\\\u0421\\\u042c|\\\u0404\\\u041e\\\u041b\\\u042c\\\u0428\\\u041e\\\u0404|\\\u041a\\\u041e\\\u041b\\\u0418\\\u0427\\\u0404\\\u0421\\\u0422\\\u0411\\\u041e|\\\u0413\\\u0404\\\u041c\\\u0417\\\u0422\\\u0418\\\u0422\\\u0415|\\\u041f\\\u041e\\\u041b\\\u0423\\\u0427\\\u042d\\\u0404\\\u0422|\\\u041d\\\u0404\\\u0414\\\u041e\\\u0421\\\u0422\\\u0417\\\u0427\\\u041d0|\\\u041f\\\u0418\\\u0422\\\u042d\\\u041d\\\u0418\\\u042f|\\\u041f\\\u041e\\\u041a\\\u0417|\\\u0411\\\u042c\\\u0406\\\u0425\\\u041e\\\u0414\\\u0418\\\u041b\\\u0418|\\\u0417\\\u0404\\\u041c\\\u0406\\\u0406\\\u0404|\\\u0412\\\u0404\\\u0421\\\u042c\\\u0406\\\u0418\\\u0417|\\\u0417\\\u0404\\\u041c\\\u041b\\\u0418|\\\u0431\\\u042c\\\u0406\\\u041b\\\u041e|\\\u041a\\\u0418\\\u0417\\\u041d\\\u0418|\\\u0421\\\u0422\\\u0417\\\u041d\\\u041e\\\u0412\\\u0418\\\u041b\\\u0417\\\u0421\\\u042c|\\\u0421\\\u041e\\\u041b\\\u0404\\\u041d\\\u0404\\\u0404|\\\u041c\\\u042d\\\u0413\\\u041d\\\u0418\\\u0422\\\u041d\\\u042b\\\u041c|\\\u0427\\\u0422\\\u041e\\\u0431\\\u042c\\\u0406|\\\u0421\\\u041e\\\u0417\\\u0414\\\u0415\\\u0422\\\u042c|\\\u041c\\\u0417\\\u0413\\\u041d\\\u0418\\\u0422\\\u041d\\\u041e\\\u0404|\\\u041a\\\u042d\\\u0416\\\u0423\\\u0422\\\u0421\\\u042f|\\\u041e\\\u0417\\\u041d\\\u0417\\\u0427\\\u0417\\\u0404\\\u0422|\\\u041c\\\u041e\\\u0413\\\u041b\\\u0417|\\\u0418\\\u041c\\\u0404\\\u0422\\\u042c|\\\u041a\\\u041e\\\u0421\\\u041c\\\u041e\\\u0421\\\u042d|\\\u0421\\\u041e\\\u041b\\\u041d\\\u0404\\\u0427\\\u041d\\\u0417\\\u042f|\\\u0421\\\u0418\\\u0421\\\u0422\\\u0404\\\u041c\\\u0417|\\\u041f\\\u041e\\\u0421\\\u0406\\\u0406\\\u0423\\\u0416\\\u0418\\\u041b\\\u041e|\\\u041c\\\u0417\\\u0413\\\u041d\\\u0418\\\u0422\\\u041d\\\u041e\\\u0413\\\u041e|\\\u041f\\\u041b\\\u0412\\\u041d\\\u0404\\\u0422\\\u042b|\\\u041b\\\u041e\\\u041a\\\u0417\\\u041b\\\u042c\\\u041d\\\u042c\\\u0406\\\u0425|\\\u041f\\\u041e\\\u041b\\\u0404\\\u0419|\\\u041a\\\u0417\\\u0416\\\u0423\\\u0422\\\u0421\\\u042f|\\\u041a\\\u0417\\\u041a\\\u041e\\\u0413\\\u041e|\\\u0421\\\u0422\\\u0420\\\u0417\\\u0428\\\u041d\\\u041e\\\u0413\\\u041e|\\\u0421\\\u0422\\\u041e\\\u041b\\\u041a\\\u041d\\\u041e\\\u0415\\\u0404\\\u041d\\\u0418\\\u042f|\\\u041c\\\u0415\\\u0421\\\u0422\\\u0417\\\u041c\\\u0418|\\\u0421\\\u0414\\\u0404\\\u041b\\\u0417\\\u0422\\\u042c|\\\u0421\\\u0422\\\u0417\\\u041b\\\u041e|\\\u041c\\\u042d\\\u0413\\\u041d\\\u0418\\\u0422\\\u041d\\\u041e\\\u0413\\\u041e|\\\u0417\\\u0417\\\u041a\\\u041b\\\u042e\\\u0427\\\u0417\\\u0412\\\u0428\\\u0404\\\u0419\\\u0421\\\u042f|\\\u0404\\\u0413\\\u041e|\\\u042f\\\u0414\\\u0420\\\u0404|\\\u041d\\\u0417|\\\u0418\\\u0421\\\u0427\\\u0404\\\u0417\\\u041b3|\\\u0421\\\u0427\\\u0418\\\u0422\\\u0417\\\u042e|\\\u0428\\\u042d\\\u041d\\\u0421\\\u042b|\\\u0418\\\u041d\\\u0417\\\u0427\\\u0404|\\\u0421\\\u0422\\\u0417\\\u041b|\\\u0422\\\u0420\\\u0417\\\u0422\\\u0418\\\u0422\\\u042c|\\\u041d\\\u0417\\\u041f\\\u0420\\\u0417\\\u0412\\\u041b\\\u042f\\\u0404\\\u0422\\\u0421\\\u042f|\\\u041e\\\u0411\\\u041b\\\u042d\\\u0421\\\u0422\\\u0418|\\\u042f\\\u0412\\\u041b\\\u042f\\\u0406\\\u041e\\\u0422\\\u0421\\\u042f|\\\u0413\\\u041b\\\u042d\\\u0412\\\u041d\\\u041e\\\u0419|\\\u0414\\\u041e\\\u041a\\\u0417\\\u0417\\\u0417\\\u0422\\\u0404\\\u041b\\\u042c\\\u0421\\\u0422\\\u0412|\\\u041a\\\u0418\\\u0421\\\u041b\\\u041e\\\u0422\\\u042d\\\u041c\\\u0418|\\\u041e\\\u041d\\\u042d|\\\u041f\\\u0420\\\u0417\\\u041a\\\u0422\\\u0418\\\u0427\\\u0404\\\u0421\\\u041a\\\u0418|\\\u041b\\\u0404\\\u0421\\\u0423|\\\u0423\\\u0421\\\u041b\\\u041e\\\u0411\\\u0418\\\u042f\\\u041c|\\\u0421\\\u041f\\\u0417\\\u0421\\\u0422\\\u0418\\\u0421\\\u042c|\\\u0420\\\u0417\\\u0417\\\u0412\\\u0418\\\u0412\\\u0417\\\u042e\\\u0429\\\u0418\\\u0404\\\u0421\\\u042f|\\\u0428\\\u042d\\\u041f\\\u041a\\\u0418|\\\u0417\\\u041d\\\u0417\\\u0404\\\u041c|\\\u0421\\\u041e\\\u041e\\\u0418\\\u0420\\\u042d\\\u0404\\\u041c\\\u0421\\\u042f|\\\u0411\\\u042b\\\u042f\\\u0421\\\u041d\\\u0418\\\u0422\\\u042c|\\\u0421\\\u0417\\\u041c|\\\u0420\\\u0417\\\u0421\\\u041f\\\u041e\\\u0417\\\u041d\\\u0417\\\u0422\\\u042c|\\\u0423\\\u0417\\\u041d\\\u0417\\\u0422\\\u042c|\\\u041a\\\u042d\\\u0416\\\u0404\\\u0422\\\u0421\\\u042f|\\\u041e\\\u0420\\\u0404\\\u0418\\\u0422\\\u0417\\\u041b\\\u042c\\\u041d\\\u042c\\\u0406\\\u0404|\\\u041b\\\u0404\\\u0422\\\u042d\\\u0422\\\u0404\\\u041b\\\u042c\\\u041d\\\u042c\\\u0406\\\u0404|\\\u0417\\\u041f\\\u041f\\\u0417\\\u0420\\\u0415\\\u0422\\\u042c\\\u0406|\\\u0416\\\u0404|\\\u0422\\\u0417\\\u041a\\\u0417\\\u042f|\\\u041c\\\u0417\\\u041b\\\u0404\\\u041d\\\u042c\\\u041a\\\u0417\\\u042f|\\\u041f\\\u041b\\\u042d\\\u041d\\\u0404\\\u0422\\\u0417|\\\u0421\\\u041f\\\u0417\\\u0406\\\u0406\\\u042c\\\u041a\\\u041e|\\\u0431\\\u042c\\\u0406\\\u041b3|\\\u0401\\\u0415\\\u0421\\\u0427\\\u0418\\\u0421\\\u041b\\\u0404\\\u041d\\\u041d\\\u041e\\\u0404|\\\u041c\\\u0417\\\u0413\\\u041d\\\u0418\\\u0457\\\u041d\\\u042c\\\u0406\\\u0425|\\\u041f\\\u041e\\\u0421\\\u0422\\\u0440\\\u0430\\\u04143\\\u041b|\\\u0414\\\u0417\\\u0416\\\u0404|\\\u0420\\\u0417\\\u0417\\\u041d\\\u042c\\\u0406\\\u041c\\\u0418|\\\u0421\\\u0423\\\u0429\\\u0404\\\u0421\\\u0422\\\u0411\\\u041e\\\u0412\\\u042d\\\u041d\\\u0418\\\u0404|\\\u041f\\\u041b\\\u0430\\\u041d\\\u0404\\\u0457\\\u042c\\\u0406|\\\u041f\\\u041e\\\u0414\\\u0412\\\u0404\\\u0420\\\u0413\\\u041b\\\u0417\\\u0421\\\u042c|\\\u041e\\\u041f\\\u0417\\\u0421\\\u0406\\-\\\u0406\\\u041e\\\u0421\\\u0422\\\u0418|\\\u041f\\\u041b\\\u0417\\\u041d\\\u0404\\\u0422\\\u0404|\\\u041d0|\\\u0431\\\u042c\\\u0406|\\\u041e\\\u0422\\\u0414\\\u0417\\\u041b\\\u0404\\\u041d\\\u041d\\\u042b\\\u0404|\\\u041f\\\u041e\\\u041b\\\u042f\\\u0420\\\u041d\\\u042c\\\u0406\\\u0404|\\\u0426\\\u0404\\\u041b\\\u042c\\\u0406\\-\\\u041e|\\\u041f\\\u0404\\\u0429\\\u0404\\\u0420\\\u0417\\\u0425|\\\u041d\\\u0417\\\u041f\\\u041e\\\u041b\\\u041d\\\u0404\\\u041d\\\u041d\\\u042c\\\u0406\\\u0425|\\\u0418\\\u0421\\\u041f\\\u0417\\\u0420\\\u0404\\\u041d\\\u0418\\\u042f\\\u041c\\\u0418|\\\u041c\\\u0418\\\u041d\\\u0418\\\u0417\\\u0422\\\u042e\\\u0420\\\u041d\\\u042c\\\u0406\\\u0404|\\\u0422\\\u042d\\\u041a\\\u0417\\\u042f|\\\u041f\\\u0440\\\u0418\\\u0421\\\u041f0\\\u0421\\\u041e\\\u0431\\\u0418\\\u0422\\\u042c\\\u0421\\\u042f|\\\u041d\\\u0404\\\u041e\\\u0404\\\u0425\\\u041e\\\u0414\\\u0418\\\u041c\\\u042c\\\u0406\\\u0404|\\\u041e\\\u0420\\\u0413\\\u0412\\\u041d\\\u0418\\\u0427\\\u0404\\\u0421\\\u041a\\\u0418\\\u0404|\\\u041c\\\u0417\\\u0420\\\u0421\\\u0418\\\u0417\\\u041d\\\u0421\\\u041a\\\u0418\\\u0404|\\\u041c\\\u0404\\\u0421\\\u0422\\\u0404|\\\u0406\\\\\\/\\\u0406\\\u0410\\\u041a\\\u041a\\\u0415\\\u0419\\\u0428|\\\u041d\\\u0417\\\u0425\\\u041e\\\u0414\\\u042f\\\u0429\\\u0418\\\u0404\\\u0421\\\u042f|\\\u041d\\\u0404\\\u0417\\\u041a\\\u0422\\\u0418\\\u0412\\\u041d\\\u041e\\\u041c|\\\u0417\\\u042d\\\u0421\\\u041d\\\u042f\\\u0422\\\u042c|\\\u041e\\\u0420\\\u0413\\\u0417\\\u041d\\\u0418\\\u0417\\\u041c\\\u042c\\\u0406|\\\u0412\\\u0417\\\u0415\\\u0418\\\u041c\\\u041e\\\u0414\\\u0404\\\u0419\\\u0421\\\u0422\\\u0412\\\u041e\\\u0412\\\u0415\\\u0422\\\u042c|\\\u041f\\\u0423\\\u0422\\\u0404\\\u0428\\\u0404\\\u0421\\\u0422\\\u0411\\\u0418\\\u0404|\\\u041f\\\u0443\\\u0421\\\u0457\\\u042c\\\u0406\\\u041d\\\u041d\\\u042b\\\u0425|\\\u0422\\\u0417\\\u041a\\\u0418\\\u0425|\\\u041f\\\u0404\\\u0420\\\u0404\\\u0422\\\u0417\\\u0421\\\u041a\\\u0418\\\u0412\\\u0417\\\u0404\\\u041c|\\\u0427\\\u04220|\\\u0412\\\u0404\\\u0421\\\u042c\\\u041c\\\u0417|\\\u041f\\\u041e\\\u041b\\\u041e\\\u0421\\\u0417\\\u041c\\\u0418|\\\u041e\\\u0440\\\u0457\\\u042d\\\u041d\\\u0418\\\u0417\\\u041c\\\u042c\\\u0406|\\\u041e\\\u0401\\\u041b\\\u0417\\\u0421\\\u0422\\\u0418|\\\u042f\\\u0411\\\u041b\\\u042f\\\u042e\\\u0422\\\u0421\\\u042f|\\\u0426\\\u0404\\\u041b\\\u042c\\\u042e|\\\u041f\\\u041e\\\u0418\\\u0421\\\u041a\\\u041e\\\u0411|\\\u0414\\\u041e\\\u041a\\\u0417\\\u0417\\\u0417\\\u0422\\\u0404\\\u0406\\\u0406\\\u042c\\\u0421\\\u0422\\\u0412|\\\u041c\\\u041e\\\u0416\\\u0404\\\u0422|\\\u041d\\\u042d\\\u0425\\\u041e\\\u0414\\\u0418\\\u0422\\\u042c\\\u0421\\\u042f|\\\u041e\\\u0427\\\u0404\\\u041d\\\u042c|\\\u0421\\\u0420\\\u0417\\\u0412\\\u041d\\\u0418\\\u0422\\\u042c|\\\u041e\\\u0404\\\u041d\\\u0417\\\u0420\\\u0423\\\u0416\\\u0418\\\u041b|\\\u041b\\\u042c\\\u0414\\\u0417|\\\u041f\\\u041e\\\u0422\\\u0404\\\u041f\\\u041b\\\u0404\\\u041d\\\u0418\\\u0404\\\u0406\\\u0418|\\\u041f\\\u041e\\\u0425\\\u041e\\\u041b\\\u041e\\\u0414\\\u0417\\\u041d\\\u0418\\\u0404\\\u0411\\\u0414|\\\u041a\\\u042d\\\u041a|\\\u0422\\\u0404\\\u041b\\\u041e|\\\u0431\\\u041e\\\u041b\\\u042c\\\u0428\\\u0404|\\\u041d\\\u042d\\\u041a\\\u041b\\\u041e\\\u041d\\\u042f\\\u0404\\\u0422\\\u0421\\\u042f|\\\u0421\\\u041e\\\u0406\\\u0406\\\u041d\\\u0426\\\u0423|\\\u0421\\\u04223\\\u0431\\\u0418\\\u041b\\\u0418\\\u0417\\\u0418\\\u0440\\\u041e\\\u0411\\\u0417\\\u0422\\\u042c|\\\u0421\\\u0422\\\u042d\\\u0411\\\u0418\\\u041b\\\u042c\\\u041d\\\u042d|\\\u041c\\\u0418\\\u041b\\\u0406\\\u0406\\\u0418\\\u041e\\\u041d\\\u041e\\\u0412|\\\u041d\\\u0417\\\u0417\\\u042d\\\u0414|\\\u0422\\\u0404\\\u041f\\\u041b0|\\\u041f\\\u041e\\\u0406\\\u0406\\\u042f\\\u0420\\\u041d\\\u042b\\\u0425|\\\u0421\\\u041e\\\u0406\\\u0406\\\u0415\\\u041d\\\u042b\\\u041c\\\u0418|\\\u041a\\\u0415\\\u041a\\\u0418\\\u041c\\\u0418|\\\u043a\\\u0438\\\u0441\\\u043b\\\u044e\\\u0442\\\u043d\\\u044e\\\u0441\\\u0433\\\u0433\\\u044c|\\\u0422\\\u0417\\\u041c|\\\u041e\\\u0420\\\u0413\\\u0417\\\u041d\\\u0418\\\u0417\\\u041c\\\u042b|\\\u0421\\\u0423\\\u0429\\\u0404\\\u0421\\\u0422\\\u0412\\\u041e\\\u0412\\\u0404\\\u0422\\\u042c|\\\u0412\\\u041d\\\u0418\\\u041c\\\u0417\\\u041d\\\u0418\\\u0404|\\\u0421\\\u0414\\\u0404\\\u041b\\\u0417\\\u0404\\\u0422|\\\u041f\\\u041e\\\u0417\\\u041d\\\u042d\\\u041a\\\u041e\\\u041c\\\u0418\\\u0422\\\u042c\\\u0421\\\u042f|\\\u041d\\\u042d\\\u0428\\\u0418\\\u041c|\\\u0414\\\u041e\\\u041a\\\u0417\\\u0417\\\u042d\\\u0422\\\u0404\\\u041b\\\u042c\\\u0421\\\u0422\\\u0411\\\u041e|\\\u0429\\\u0417\\\u0417\\\u0429\\\u0404\\\u041d\\\u0418\\\u042f|\\\u0431\\\u042c\\\u0406\\\u041b0|\\\u041e\\\u0404\\\u041b\\\u0415\\\u0421\\\u0422\\\u042f\\\u0425|\\\u0431\\\u042c\\\u0406\\\u041b\\\u0418|\\\u0420\\\u042d\\\u0417\\\u041c\\\u042c\\\u0406\\\u0428\\\u041b\\\u042f\\\u0406\\\u0406\\\u0418|\\\u041a\\\u041e\\\u041b\\\u0418\\\u0427\\\u0404\\\u0421\\\u0422\\\u0411\\\u0404|\\\u0429\\\u0404\\\u0406\\\u0406\\\u041e\\\u0427\\\u041d\\\u042b\\\u0404|\\\u041d\\\u0404\\\u041a\\\u041e\\\u0422\\\u0429\\\u0417\\\u042c\\\u0406\\\u0404|\\\u041f\\\u0440\\\u0418\\\u0411\\\u04061\\\u0415\\\u041a\\\u0443\\\u0457|\\\u041d\\\u0417\\\u0417\\\u042c\\\u0406\\\u0412\\\u042d\\\u0404\\\u041c\\\u042b\\\u0404|\\\u0427\\\u045706\\\u042b)(\\b|$)'}},
 'spa': {'BeginLines': {'data': OrderedDict(),
                        'pattern': None},
         'EndLines': {'data': OrderedDict([(u'.\xbb.', u'\xbb.')]),
                      'pattern': u'(?um)(?:\\.\\\xbb\\.)$'},
         'PartialLines': {'data': OrderedDict([(u'de gratis', u'gratis'), (u'si quiera', u'siquiera'), (u'Cada una de los', u'Cada uno de los'), (u'Cada uno de las', u'Cada una de las'), (u'haber que', u'a ver qu\xe9'), (u'haber qu\xe9', u'a ver qu\xe9'), (u'Haber si', u'A ver si'), (u' que hora', u' qu\xe9 hora'), (u'yo que se', u'yo qu\xe9 s\xe9'), (u'Yo que se', u'Yo qu\xe9 s\xe9'), (u' tu!', u' t\xfa!'), (u' si!', u' s\xed!'), (u' mi!', u' m\xed!'), (u' el!', u' \xe9l!'), (u' tu?', u' t\xfa?'), (u' si?', u' s\xed?'), (u' mi?', u' m\xed?'), (u' el?', u' \xe9l?'), (u' aun?', u' a\xfan?'), (u' mas?', u' m\xe1s?'), (u' que?', u' qu\xe9?'), (u' paso?', u' pas\xf3?'), (u' cuando?', u' cu\xe1ndo?'), (u' cuanto?', u' cu\xe1nto?'), (u' cuanta?', u' cu\xe1nta?'), (u' cuantas?', u' cu\xe1ntas?'), (u' cuantos?', u' cu\xe1ntos?'), (u' donde?', u' d\xf3nde?'), (u' quien?', u' qui\xe9n?'), (u' como?', u' c\xf3mo?'), (u' adonde?', u' ad\xf3nde?'), (u' cual?', u' cu\xe1l?'), (u'\xbfSi?', u'\xbfS\xed?'), (u'\xbfesta bien?', u'\xbfest\xe1 bien?'), (u'\xbfPero qu\xe9 haces?', u'\xa1\xbfPero qu\xe9 haces?!'), (u'\xbfpero qu\xe9 haces?', u'\xa1\xbfpero qu\xe9 haces?!'), (u'\xbfEs que no me has escuchado?', u'\xa1\xbfEs que no me has escuchado?!'), (u'\xa1\xbfes que no me has escuchado?!', u'\xa1\xbfes que no me has escuchado?!'), (u'\xbfaun', u'\xbfa\xfan'), (u'\xbftu ', u'\xbft\xfa '), (u'\xbfque ', u'\xbfqu\xe9 '), (u'\xbfsabes que', u'\xbfsabes qu\xe9'), (u'\xbfsabes adonde', u'\xbfsabes ad\xf3nde'), (u'\xbfsabes cual', u'\xbfsabes cu\xe1l'), (u'\xbfsabes quien', u'\xbfsabes qui\xe9n'), (u'\xbfsabes como', u'\xbfsabes c\xf3mo'), (u'\xbfsabes cuan', u'\xbfsabes cu\xe1n'), (u'\xbfsabes cuanto', u'\xbfsabes cu\xe1nto'), (u'\xbfsabes cuanta', u'\xbfsabes cu\xe1nta'), (u'\xbfsabes cuantos', u'\xbfsabes cu\xe1ntos'), (u'\xbfsabes cuantas', u'\xbfsabes cu\xe1ntas'), (u'\xbfsabes cuando', u'\xbfsabes cu\xe1ndo'), (u'\xbfsabes donde', u'\xbfsabes d\xf3nde'), (u'\xbfsabe que', u'\xbfsabe qu\xe9'), (u'\xbfsabe adonde', u'\xbfsabe ad\xf3nde'), (u'\xbfsabe cual', u'\xbfsabe cu\xe1l'), (u'\xbfsabe quien', u'\xbfsabe qui\xe9n'), (u'\xbfsabe como', u'\xbfsabe c\xf3mo'), (u'\xbfsabe cuan', u'\xbfsabe cu\xe1n'), (u'\xbfsabe cuanto', u'\xbfsabe cu\xe1nto'), (u'\xbfsabe cuanta', u'\xbfsabe cu\xe1nta'), (u'\xbfsabe cuantos', u'\xbfsabe cu\xe1ntos'), (u'\xbfsabe cuantas', u'\xbfsabe cu\xe1ntas'), (u'\xbfsabe cuando', u'\xbfsabe cu\xe1ndo'), (u'\xbfsabe donde', u'\xbfsabe d\xf3nde'), (u'\xbfsaben que', u'\xbfsaben qu\xe9'), (u'\xbfsaben adonde', u'\xbfsaben ad\xf3nde'), (u'\xbfsaben cual', u'\xbfsaben cu\xe1l'), (u'\xbfsaben quien', u'\xbfsaben qui\xe9n'), (u'\xbfsaben como', u'\xbfsaben c\xf3mo'), (u'\xbfsaben cuan', u'\xbfsaben cu\xe1n'), (u'\xbfsaben cuanto', u'\xbfsaben cu\xe1nto'), (u'\xbfsaben cuanta', u'\xbfsaben cu\xe1nta'), (u'\xbfsaben cuantos', u'\xbfsaben cu\xe1ntos'), (u'\xbfsaben cuantas', u'\xbfsaben cu\xe1ntas'), (u'\xbfsaben cuando', u'\xbfsaben cu\xe1ndo'), (u'\xbfsaben donde', u'\xbfsaben d\xf3nde'), (u'\xbfde que', u'\xbfde qu\xe9'), (u'\xbfde donde', u'\xbfde d\xf3nde'), (u'\xbfde cual', u'\xbfde cu\xe1l'), (u'\xbfde quien', u'\xbfde qui\xe9n'), (u'\xbfde cuanto', u'\xbfde cu\xe1nto'), (u'\xbfde cuanta', u'\xbfde cu\xe1nta'), (u'\xbfde cuantos', u'\xbfde cu\xe1ntos'), (u'\xbfde cuantas', u'\xbfde cu\xe1ntas'), (u'\xbfde cuando', u'\xbfde cu\xe1ndo'), (u'\xbfsobre que', u'\xbfsobre qu\xe9'), (u'\xbfcomo ', u'\xbfc\xf3mo '), (u'\xbfcual ', u'\xbfcu\xe1l '), (u'\xbfen cual', u'\xbfen cu\xe1l'), (u'\xbfcuando', u'\xbfcu\xe1ndo'), (u'\xbfhasta cual', u'\xbfhasta cu\xe1l'), (u'\xbfhasta quien', u'\xbfhasta qui\xe9n'), (u'\xbfhasta cuanto', u'\xbfhasta cu\xe1nto'), (u'\xbfhasta cuantas', u'\xbfhasta cu\xe1ntas'), (u'\xbfhasta cuantos', u'\xbfhasta cu\xe1ntos'), (u'\xbfhasta cuando', u'\xbfhasta cu\xe1ndo'), (u'\xbfhasta donde', u'\xbfhasta d\xf3nde'), (u'\xbfhasta que', u'\xbfhasta qu\xe9'), (u'\xbfhasta adonde', u'\xbfhasta ad\xf3nde'), (u'\xbfdesde que', u'\xbfdesde qu\xe9'), (u'\xbfdesde cuando', u'\xbfdesde cu\xe1ndo'), (u'\xbfdesde quien', u'\xbfdesde qui\xe9n'), (u'\xbfdesde donde', u'\xbfdesde d\xf3nde'), (u'\xbfcuanto', u'\xbfcu\xe1nto'), (u'\xbfcuantos', u'\xbfcu\xe1ntos'), (u'\xbfdonde', u'\xbfd\xf3nde'), (u'\xbfadonde', u'\xbfad\xf3nde'), (u'\xbfcon que', u'\xbfcon qu\xe9'), (u'\xbfcon cual', u'\xbfcon cu\xe1l'), (u'\xbfcon quien', u'\xbfcon qui\xe9n'), (u'\xbfcon cuantos', u'\xbfcon cu\xe1ntos'), (u'\xbfcon cuantas', u'\xbfcon cu\xe1ntas'), (u'\xbfcon cuanta', u'\xbfcon cu\xe1nta'), (u'\xbfcon cuanto', u'\xbfcon cu\xe1nto'), (u'\xbfpara donde', u'\xbfpara d\xf3nde'), (u'\xbfpara adonde', u'\xbfpara ad\xf3nde'), (u'\xbfpara cuando', u'\xbfpara cu\xe1ndo'), (u'\xbfpara que', u'\xbfpara qu\xe9'), (u'\xbfpara quien', u'\xbfpara qui\xe9n'), (u'\xbfpara cuanto', u'\xbfpara cu\xe1nto'), (u'\xbfpara cuanta', u'\xbfpara cu\xe1nta'), (u'\xbfpara cuantos', u'\xbfpara cu\xe1ntos'), (u'\xbfpara cuantas', u'\xbfpara cu\xe1ntas'), (u'\xbfa donde', u'\xbfa d\xf3nde'), (u'\xbfa que', u'\xbfa qu\xe9'), (u'\xbfa cual', u'\xbfa cu\xe1l'), (u'\xbfa quien', u'\xbfa quien'), (u'\xbfa como', u'\xbfa c\xf3mo'), (u'\xbfa cuanto', u'\xbfa cu\xe1nto'), (u'\xbfa cuanta', u'\xbfa cu\xe1nta'), (u'\xbfa cuantos', u'\xbfa cu\xe1ntos'), (u'\xbfa cuantas', u'\xbfa cu\xe1ntas'), (u'\xbfpor que', u'\xbfpor qu\xe9'), (u'\xbfpor cual', u'\xbfpor cu\xe1l'), (u'\xbfpor quien', u'\xbfpor qui\xe9n'), (u'\xbfpor cuanto', u'\xbfpor cu\xe1nto'), (u'\xbfpor cuanta', u'\xbfpor cu\xe1nta'), (u'\xbfpor cuantos', u'\xbfpor cu\xe1ntos'), (u'\xbfpor cuantas', u'\xbfpor cu\xe1ntas'), (u'\xbfpor donde', u'\xbfpor d\xf3nde'), (u'\xbfporque', u'\xbfpor qu\xe9'), (u'\xbfporqu\xe9', u'\xbfpor qu\xe9'), (u'\xbfy que', u'\xbfy qu\xe9'), (u'\xbfy como', u'\xbfy c\xf3mo'), (u'\xbfy cuando', u'\xbfy cu\xe1ndo'), (u'\xbfy cual', u'\xbfy cu\xe1l'), (u'\xbfy quien', u'\xbfy qui\xe9n'), (u'\xbfy cuanto', u'\xbfy cu\xe1nto'), (u'\xbfy cuanta', u'\xbfy cu\xe1nta'), (u'\xbfy cuantos', u'\xbfy cu\xe1ntos'), (u'\xbfy cuantas', u'\xbfy cu\xe1ntas'), (u'\xbfy donde', u'\xbfy d\xf3nde'), (u'\xbfy adonde', u'\xbfy ad\xf3nde'), (u'\xbfquien ', u'\xbfqui\xe9n '), (u'\xbfesta ', u'\xbfest\xe1 '), (u'\xbfestas ', u'\xbfest\xe1s '), (u'\xbfAun', u'\xbfA\xfan'), (u'\xbfQue ', u'\xbfQu\xe9 '), (u'\xbfSabes que', u'\xbfSabes qu\xe9'), (u'\xbfSabes adonde', u'\xbfSabes ad\xf3nde'), (u'\xbfSabes cual', u'\xbfSabes cu\xe1l'), (u'\xbfSabes quien', u'\xbfSabes qui\xe9n'), (u'\xbfSabes como', u'\xbfSabes c\xf3mo'), (u'\xbfSabes cuan', u'\xbfSabes cu\xe1n'), (u'\xbfSabes cuanto', u'\xbfSabes cu\xe1nto'), (u'\xbfSabes cuanta', u'\xbfSabes cu\xe1nta'), (u'\xbfSabes cuantos', u'\xbfSabes cu\xe1ntos'), (u'\xbfSabes cuantas', u'\xbfSabes cu\xe1ntas'), (u'\xbfSabes cuando', u'\xbfSabes cu\xe1ndo'), (u'\xbfSabes donde', u'\xbfSabes d\xf3nde'), (u'\xbfSabe que', u'\xbfSabe qu\xe9'), (u'\xbfSabe adonde', u'\xbfSabe ad\xf3nde'), (u'\xbfSabe cual', u'\xbfSabe cu\xe1l'), (u'\xbfSabe quien', u'\xbfSabe qui\xe9n'), (u'\xbfSabe como', u'\xbfSabe c\xf3mo'), (u'\xbfSabe cuan', u'\xbfSabe cu\xe1n'), (u'\xbfSabe cuanto', u'\xbfSabe cu\xe1nto'), (u'\xbfSabe cuanta', u'\xbfSabe cu\xe1nta'), (u'\xbfSabe cuantos', u'\xbfSabe cu\xe1ntos'), (u'\xbfSabe cuantas', u'\xbfSabe cu\xe1ntas'), (u'\xbfSabe cuando', u'\xbfSabe cu\xe1ndo'), (u'\xbfSabe donde', u'\xbfSabe d\xf3nde'), (u'\xbfSaben que', u'\xbfSaben qu\xe9'), (u'\xbfSaben adonde', u'\xbfSaben ad\xf3nde'), (u'\xbfSaben cual', u'\xbfSaben cu\xe1l'), (u'\xbfSaben quien', u'\xbfSaben qui\xe9n'), (u'\xbfSaben como', u'\xbfSaben c\xf3mo'), (u'\xbfSaben cuan', u'\xbfSaben cu\xe1n'), (u'\xbfSaben cuanto', u'\xbfSaben cu\xe1nto'), (u'\xbfSaben cuanta', u'\xbfSaben cu\xe1nta'), (u'\xbfSaben cuantos', u'\xbfSaben cu\xe1ntos'), (u'\xbfSaben cuantas', u'\xbfSaben cu\xe1ntas'), (u'\xbfSaben cuando', u'\xbfSaben cu\xe1ndo'), (u'\xbfSaben donde', u'\xbfSaben d\xf3nde'), (u'\xbfDe que', u'\xbfDe qu\xe9'), (u'\xbfDe donde', u'\xbfDe d\xf3nde'), (u'\xbfDe cual', u'\xbfDe cu\xe1l'), (u'\xbfDe quien', u'\xbfDe qui\xe9n'), (u'\xbfDe cuanto', u'\xbfDe cu\xe1nto'), (u'\xbfDe cuanta', u'\xbfDe cu\xe1nta'), (u'\xbfDe cuantos', u'\xbfDe cu\xe1ntos'), (u'\xbfDe cuantas', u'\xbfDe cu\xe1ntas'), (u'\xbfDe cuando', u'\xbfDe cu\xe1ndo'), (u'\xbfDesde que', u'\xbfDesde qu\xe9'), (u'\xbfDesde cuando', u'\xbfDesde cu\xe1ndo'), (u'\xbfDesde quien', u'\xbfDesde qui\xe9n'), (u'\xbfDesde donde', u'\xbfDesde d\xf3nde'), (u'\xbfSobre que', u'\xbfSobre qu\xe9'), (u'\xbfComo ', u'\xbfC\xf3mo '), (u'\xbfCual ', u'\xbfCu\xe1l '), (u'\xbfEn cual', u'\xbfEn cu\xe1l'), (u'\xbfCuando', u'\xbfCu\xe1ndo'), (u'\xbfHasta cual', u'\xbfHasta cu\xe1l'), (u'\xbfHasta quien', u'\xbfHasta qui\xe9n'), (u'\xbfHasta cuanto', u'\xbfHasta cu\xe1nto'), (u'\xbfHasta cuantas', u'\xbfHasta cu\xe1ntas'), (u'\xbfHasta cuantos', u'\xbfHasta cu\xe1ntos'), (u'\xbfHasta cuando', u'\xbfHasta cu\xe1ndo'), (u'\xbfHasta donde', u'\xbfHasta d\xf3nde'), (u'\xbfHasta que', u'\xbfHasta qu\xe9'), (u'\xbfHasta adonde', u'\xbfHasta ad\xf3nde'), (u'\xbfCuanto', u'\xbfCu\xe1nto'), (u'\xbfCuantos', u'\xbfCu\xe1ntos'), (u'\xbfDonde', u'\xbfD\xf3nde'), (u'\xbfAdonde', u'\xbfAd\xf3nde'), (u'\xbfCon que', u'\xbfCon qu\xe9'), (u'\xbfCon cual', u'\xbfCon cu\xe1l'), (u'\xbfCon quien', u'\xbfCon qui\xe9n'), (u'\xbfCon cuantos', u'\xbfCon cu\xe1ntos'), (u'\xbfCon cuanta', u'\xbfCon cu\xe1nta'), (u'\xbfCon cuanto', u'\xbfCon cu\xe1nto'), (u'\xbfPara donde', u'\xbfPara d\xf3nde'), (u'\xbfPara adonde', u'\xbfPara ad\xf3nde'), (u'\xbfPara cuando', u'\xbfPara cu\xe1ndo'), (u'\xbfPara que', u'\xbfPara qu\xe9'), (u'\xbfPara quien', u'\xbfPara qui\xe9n'), (u'\xbfPara cuanto', u'\xbfPara cu\xe1nto'), (u'\xbfPara cuanta', u'\xbfPara cu\xe1nta'), (u'\xbfPara cuantos', u'\xbfPara cu\xe1ntos'), (u'\xbfPara cuantas', u'\xbfPara cu\xe1ntas'), (u'\xbfA donde', u'\xbfA d\xf3nde'), (u'\xbfA que', u'\xbfA qu\xe9'), (u'\xbfA cual', u'\xbfA cu\xe1l'), (u'\xbfA quien', u'\xbfA quien'), (u'\xbfA como', u'\xbfA c\xf3mo'), (u'\xbfA cuanto', u'\xbfA cu\xe1nto'), (u'\xbfA cuanta', u'\xbfA cu\xe1nta'), (u'\xbfA cuantos', u'\xbfA cu\xe1ntos'), (u'\xbfA cuantas', u'\xbfA cu\xe1ntas'), (u'\xbfPor que', u'\xbfPor qu\xe9'), (u'\xbfPor cual', u'\xbfPor cu\xe1l'), (u'\xbfPor quien', u'\xbfPor qui\xe9n'), (u'\xbfPor cuanto', u'\xbfPor cu\xe1nto'), (u'\xbfPor cuanta', u'\xbfPor cu\xe1nta'), (u'\xbfPor cuantos', u'\xbfPor cu\xe1ntos'), (u'\xbfPor cuantas', u'\xbfPor cu\xe1ntas'), (u'\xbfPor donde', u'\xbfPor d\xf3nde'), (u'\xbfPorque', u'\xbfPor qu\xe9'), (u'\xbfPorqu\xe9', u'\xbfPor qu\xe9'), (u'\xbfY que', u'\xbfY qu\xe9'), (u'\xbfY como', u'\xbfY c\xf3mo'), (u'\xbfY cuando', u'\xbfY cu\xe1ndo'), (u'\xbfY cual', u'\xbfY cu\xe1l'), (u'\xbfY quien', u'\xbfY qui\xe9n'), (u'\xbfY cuanto', u'\xbfY cu\xe1nto'), (u'\xbfY cuanta', u'\xbfY cu\xe1nta'), (u'\xbfY cuantos', u'\xbfY cu\xe1ntos'), (u'\xbfY cuantas', u'\xbfY cu\xe1ntas'), (u'\xbfY donde', u'\xbfY d\xf3nde'), (u'\xbfY adonde', u'\xbfY ad\xf3nde'), (u'\xbfQuien ', u'\xbfQui\xe9n '), (u'\xbfEsta ', u'\xbfEst\xe1 '), (u'el porque', u'el porqu\xe9'), (u'su porque', u'su porqu\xe9'), (u'los porqu\xe9s', u'los porqu\xe9s'), (u'aun,', u'a\xfan,'), (u'aun no', u'a\xfan no'), (u' de y ', u' d\xe9 y '), (u' nos de ', u' nos d\xe9 '), (u' tu ya ', u' t\xfa ya '), (u'Tu ya ', u'T\xfa ya '), (u' de, ', u' d\xe9,'), (u' mi, ', u' m\xed,'), (u' tu, ', u' t\xfa,'), (u' el, ', u' \xe9l,'), (u' te, ', u' t\xe9,'), (u' mas, ', u' m\xe1s,'), (u' quien, ', u' qui\xe9n,'), (u' cual,', u' cu\xe1l,'), (u'porque, ', u'porqu\xe9,'), (u'cuanto, ', u'cu\xe1nto,'), (u'cuando, ', u'cu\xe1ndo,'), (u' se,', u' s\xe9,'), (u'se donde', u's\xe9 d\xf3nde'), (u'se cuando', u's\xe9 cu\xe1ndo'), (u'se adonde', u's\xe9 ad\xf3nde'), (u'se como', u's\xe9 c\xf3mo'), (u'se cual', u's\xe9 cu\xe1l'), (u'se quien', u's\xe9 qui\xe9n'), (u'se cuanto', u's\xe9 cu\xe1nto'), (u'se cuanta', u's\xe9 cu\xe1nta'), (u'se cuantos', u's\xe9 cu\xe1ntos'), (u'se cuantas', u's\xe9 cu\xe1ntas'), (u'se cuan', u's\xe9 cu\xe1n'), (u' el si ', u' el s\xed '), (u'si mismo', u's\xed mismo'), (u'si misma', u's\xed misma'), (u' llegal', u' ilegal'), (u' lluminar', u' iluminar'), (u'sllbato', u'silbato'), (u'sllenclo', u'silencio'), (u'clemencla', u'clemencia'), (u'socledad', u'sociedad'), (u'tlene', u'tiene'), (u'tlempo', u'tiempo'), (u'equlvocaba', u'equivocaba'), (u'qulnce', u'quince'), (u'comlen', u'comien'), (u'historl', u'histori'), (u'misterl', u'misteri'), (u'vivencl', u'vivenci')]),
                          'pattern': u'(?um)(?:(?<=\\s)|(?<=^)|(?<=\\b))(?:de\\ gratis|si\\ quiera|Cada\\ una\\ de\\ los|Cada\\ uno\\ de\\ las|haber\\ que|haber\\ qu\\\xe9|Haber\\ si|\\ que\\ hora|yo\\ que\\ se|Yo\\ que\\ se|\\ tu\\!|\\ si\\!|\\ mi\\!|\\ el\\!|\\ tu\\?|\\ si\\?|\\ mi\\?|\\ el\\?|\\ aun\\?|\\ mas\\?|\\ que\\?|\\ paso\\?|\\ cuando\\?|\\ cuanto\\?|\\ cuanta\\?|\\ cuantas\\?|\\ cuantos\\?|\\ donde\\?|\\ quien\\?|\\ como\\?|\\ adonde\\?|\\ cual\\?|\\\xbfSi\\?|\\\xbfesta\\ bien\\?|\\\xbfPero\\ qu\\\xe9\\ haces\\?|\\\xbfpero\\ qu\\\xe9\\ haces\\?|\\\xbfEs\\ que\\ no\\ me\\ has\\ escuchado\\?|\\\xa1\\\xbfes\\ que\\ no\\ me\\ has\\ escuchado\\?\\!|\\\xbfaun|\\\xbftu\\ |\\\xbfque\\ |\\\xbfsabes\\ que|\\\xbfsabes\\ adonde|\\\xbfsabes\\ cual|\\\xbfsabes\\ quien|\\\xbfsabes\\ como|\\\xbfsabes\\ cuan|\\\xbfsabes\\ cuanto|\\\xbfsabes\\ cuanta|\\\xbfsabes\\ cuantos|\\\xbfsabes\\ cuantas|\\\xbfsabes\\ cuando|\\\xbfsabes\\ donde|\\\xbfsabe\\ que|\\\xbfsabe\\ adonde|\\\xbfsabe\\ cual|\\\xbfsabe\\ quien|\\\xbfsabe\\ como|\\\xbfsabe\\ cuan|\\\xbfsabe\\ cuanto|\\\xbfsabe\\ cuanta|\\\xbfsabe\\ cuantos|\\\xbfsabe\\ cuantas|\\\xbfsabe\\ cuando|\\\xbfsabe\\ donde|\\\xbfsaben\\ que|\\\xbfsaben\\ adonde|\\\xbfsaben\\ cual|\\\xbfsaben\\ quien|\\\xbfsaben\\ como|\\\xbfsaben\\ cuan|\\\xbfsaben\\ cuanto|\\\xbfsaben\\ cuanta|\\\xbfsaben\\ cuantos|\\\xbfsaben\\ cuantas|\\\xbfsaben\\ cuando|\\\xbfsaben\\ donde|\\\xbfde\\ que|\\\xbfde\\ donde|\\\xbfde\\ cual|\\\xbfde\\ quien|\\\xbfde\\ cuanto|\\\xbfde\\ cuanta|\\\xbfde\\ cuantos|\\\xbfde\\ cuantas|\\\xbfde\\ cuando|\\\xbfsobre\\ que|\\\xbfcomo\\ |\\\xbfcual\\ |\\\xbfen\\ cual|\\\xbfcuando|\\\xbfhasta\\ cual|\\\xbfhasta\\ quien|\\\xbfhasta\\ cuanto|\\\xbfhasta\\ cuantas|\\\xbfhasta\\ cuantos|\\\xbfhasta\\ cuando|\\\xbfhasta\\ donde|\\\xbfhasta\\ que|\\\xbfhasta\\ adonde|\\\xbfdesde\\ que|\\\xbfdesde\\ cuando|\\\xbfdesde\\ quien|\\\xbfdesde\\ donde|\\\xbfcuanto|\\\xbfcuantos|\\\xbfdonde|\\\xbfadonde|\\\xbfcon\\ que|\\\xbfcon\\ cual|\\\xbfcon\\ quien|\\\xbfcon\\ cuantos|\\\xbfcon\\ cuantas|\\\xbfcon\\ cuanta|\\\xbfcon\\ cuanto|\\\xbfpara\\ donde|\\\xbfpara\\ adonde|\\\xbfpara\\ cuando|\\\xbfpara\\ que|\\\xbfpara\\ quien|\\\xbfpara\\ cuanto|\\\xbfpara\\ cuanta|\\\xbfpara\\ cuantos|\\\xbfpara\\ cuantas|\\\xbfa\\ donde|\\\xbfa\\ que|\\\xbfa\\ cual|\\\xbfa\\ quien|\\\xbfa\\ como|\\\xbfa\\ cuanto|\\\xbfa\\ cuanta|\\\xbfa\\ cuantos|\\\xbfa\\ cuantas|\\\xbfpor\\ que|\\\xbfpor\\ cual|\\\xbfpor\\ quien|\\\xbfpor\\ cuanto|\\\xbfpor\\ cuanta|\\\xbfpor\\ cuantos|\\\xbfpor\\ cuantas|\\\xbfpor\\ donde|\\\xbfporque|\\\xbfporqu\\\xe9|\\\xbfy\\ que|\\\xbfy\\ como|\\\xbfy\\ cuando|\\\xbfy\\ cual|\\\xbfy\\ quien|\\\xbfy\\ cuanto|\\\xbfy\\ cuanta|\\\xbfy\\ cuantos|\\\xbfy\\ cuantas|\\\xbfy\\ donde|\\\xbfy\\ adonde|\\\xbfquien\\ |\\\xbfesta\\ |\\\xbfestas\\ |\\\xbfAun|\\\xbfQue\\ |\\\xbfSabes\\ que|\\\xbfSabes\\ adonde|\\\xbfSabes\\ cual|\\\xbfSabes\\ quien|\\\xbfSabes\\ como|\\\xbfSabes\\ cuan|\\\xbfSabes\\ cuanto|\\\xbfSabes\\ cuanta|\\\xbfSabes\\ cuantos|\\\xbfSabes\\ cuantas|\\\xbfSabes\\ cuando|\\\xbfSabes\\ donde|\\\xbfSabe\\ que|\\\xbfSabe\\ adonde|\\\xbfSabe\\ cual|\\\xbfSabe\\ quien|\\\xbfSabe\\ como|\\\xbfSabe\\ cuan|\\\xbfSabe\\ cuanto|\\\xbfSabe\\ cuanta|\\\xbfSabe\\ cuantos|\\\xbfSabe\\ cuantas|\\\xbfSabe\\ cuando|\\\xbfSabe\\ donde|\\\xbfSaben\\ que|\\\xbfSaben\\ adonde|\\\xbfSaben\\ cual|\\\xbfSaben\\ quien|\\\xbfSaben\\ como|\\\xbfSaben\\ cuan|\\\xbfSaben\\ cuanto|\\\xbfSaben\\ cuanta|\\\xbfSaben\\ cuantos|\\\xbfSaben\\ cuantas|\\\xbfSaben\\ cuando|\\\xbfSaben\\ donde|\\\xbfDe\\ que|\\\xbfDe\\ donde|\\\xbfDe\\ cual|\\\xbfDe\\ quien|\\\xbfDe\\ cuanto|\\\xbfDe\\ cuanta|\\\xbfDe\\ cuantos|\\\xbfDe\\ cuantas|\\\xbfDe\\ cuando|\\\xbfDesde\\ que|\\\xbfDesde\\ cuando|\\\xbfDesde\\ quien|\\\xbfDesde\\ donde|\\\xbfSobre\\ que|\\\xbfComo\\ |\\\xbfCual\\ |\\\xbfEn\\ cual|\\\xbfCuando|\\\xbfHasta\\ cual|\\\xbfHasta\\ quien|\\\xbfHasta\\ cuanto|\\\xbfHasta\\ cuantas|\\\xbfHasta\\ cuantos|\\\xbfHasta\\ cuando|\\\xbfHasta\\ donde|\\\xbfHasta\\ que|\\\xbfHasta\\ adonde|\\\xbfCuanto|\\\xbfCuantos|\\\xbfDonde|\\\xbfAdonde|\\\xbfCon\\ que|\\\xbfCon\\ cual|\\\xbfCon\\ quien|\\\xbfCon\\ cuantos|\\\xbfCon\\ cuanta|\\\xbfCon\\ cuanto|\\\xbfPara\\ donde|\\\xbfPara\\ adonde|\\\xbfPara\\ cuando|\\\xbfPara\\ que|\\\xbfPara\\ quien|\\\xbfPara\\ cuanto|\\\xbfPara\\ cuanta|\\\xbfPara\\ cuantos|\\\xbfPara\\ cuantas|\\\xbfA\\ donde|\\\xbfA\\ que|\\\xbfA\\ cual|\\\xbfA\\ quien|\\\xbfA\\ como|\\\xbfA\\ cuanto|\\\xbfA\\ cuanta|\\\xbfA\\ cuantos|\\\xbfA\\ cuantas|\\\xbfPor\\ que|\\\xbfPor\\ cual|\\\xbfPor\\ quien|\\\xbfPor\\ cuanto|\\\xbfPor\\ cuanta|\\\xbfPor\\ cuantos|\\\xbfPor\\ cuantas|\\\xbfPor\\ donde|\\\xbfPorque|\\\xbfPorqu\\\xe9|\\\xbfY\\ que|\\\xbfY\\ como|\\\xbfY\\ cuando|\\\xbfY\\ cual|\\\xbfY\\ quien|\\\xbfY\\ cuanto|\\\xbfY\\ cuanta|\\\xbfY\\ cuantos|\\\xbfY\\ cuantas|\\\xbfY\\ donde|\\\xbfY\\ adonde|\\\xbfQuien\\ |\\\xbfEsta\\ |el\\ porque|su\\ porque|los\\ porqu\\\xe9s|aun\\,|aun\\ no|\\ de\\ y\\ |\\ nos\\ de\\ |\\ tu\\ ya\\ |Tu\\ ya\\ |\\ de\\,\\ |\\ mi\\,\\ |\\ tu\\,\\ |\\ el\\,\\ |\\ te\\,\\ |\\ mas\\,\\ |\\ quien\\,\\ |\\ cual\\,|porque\\,\\ |cuanto\\,\\ |cuando\\,\\ |\\ se\\,|se\\ donde|se\\ cuando|se\\ adonde|se\\ como|se\\ cual|se\\ quien|se\\ cuanto|se\\ cuanta|se\\ cuantos|se\\ cuantas|se\\ cuan|\\ el\\ si\\ |si\\ mismo|si\\ misma|\\ llegal|\\ lluminar|sllbato|sllenclo|clemencla|socledad|tlene|tlempo|equlvocaba|qulnce|comlen|historl|misterl|vivencl)(?:(?=\\s)|(?=$)|(?=\\b))'},
         'PartialWordsAlways': {'data': OrderedDict(),
                                'pattern': None},
         'WholeLines': {'data': OrderedDict([(u'No', u'No.')]),
                        'pattern': None},
         'WholeWords': {'data': OrderedDict([(u'KBs', u'kB'), (u'Vd', u'Ud'), (u'N\xb0', u'N.\xb0'), (u'n\xb0', u'n.\xb0'), (u'nro.', u'n.\xb0'), (u'Nro.', u'N.\xb0'), (u'aca', u'ac\xe1'), (u'actuas', u'act\xfaas'), (u'actues', u'act\xfaes'), (u'adios', u'adi\xf3s'), (u'agarrenla', u'ag\xe1rrenla'), (u'agarrenlo', u'ag\xe1rrenlo'), (u'agarrandose', u'agarr\xe1ndose'), (u'algun', u'alg\xfan'), (u'alli', u'all\xed'), (u'alla', u'all\xe1'), (u'alejate', u'al\xe9jate'), (u'ahi', u'ah\xed'), (u'angel', u'\xe1ngel'), (u'angeles', u'\xe1ngeles'), (u'ansian', u'ans\xedan'), (u'apagala', u'ap\xe1gala'), (u'aqui', u'aqu\xed'), (u'asi', u'as\xed'), (u'bahia', u'bah\xeda'), (u'busqueda', u'b\xfasqueda'), (u'busquedas', u'b\xfasquedas'), (u'callate', u'c\xe1llate'), (u'carcel', u'c\xe1rcel'), (u'camara', u'c\xe1mara'), (u'caido', u'ca\xeddo'), (u'cabron', u'cabr\xf3n'), (u'camion', u'cami\xf3n'), (u'codigo', u'c\xf3digo'), (u'codigos', u'c\xf3digos'), (u'comence', u'comenc\xe9'), (u'comprate', u'c\xf3mprate'), (u'consegui', u'consegu\xed'), (u'confias', u'conf\xedas'), (u'convertira', u'convertir\xe1'), (u'corazon', u'coraz\xf3n'), (u'crei', u'cre\xed'), (u'creia', u'cre\xeda'), (u'creido', u'cre\xeddo'), (u'creiste', u'cre\xedste'), (u'cubrenos', u'c\xfabrenos'), (u'comio', u'comi\xf3'), (u'dara', u'dar\xe1'), (u'dia', u'd\xeda'), (u'dias', u'd\xedas'), (u'debio', u'debi\xf3'), (u'demelo', u'd\xe9melo'), (u'dimelo', u'd\xedmelo'), (u'denoslo', u'd\xe9noslo'), (u'deselo', u'd\xe9selo'), (u'decia', u'dec\xeda'), (u'decian', u'dec\xedan'), (u'detras', u'detr\xe1s'), (u'deberia', u'deber\xeda'), (u'deberas', u'deber\xe1s'), (u'deberias', u'deber\xedas'), (u'deberian', u'deber\xedan'), (u'deberiamos', u'deber\xedamos'), (u'dejame', u'd\xe9jame'), (u'dejate', u'd\xe9jate'), (u'dejalo', u'd\xe9jalo'), (u'dejarian', u'dejar\xedan'), (u'damela', u'd\xe1mela'), (u'despues', u'despu\xe9s'), (u'diciendome', u'dici\xe9ndome'), (u'dificil', u'dif\xedcil'), (u'dificiles', u'dif\xedciles'), (u'disculpate', u'disc\xfalpate'), (u'dolares', u'd\xf3lares'), (u'hechar', u'echar'), (u'examenes', u'ex\xe1menes'), (u'empezo', u'empez\xf3'), (u'empujon', u'empuj\xf3n'), (u'empujalo', u'emp\xfajalo'), (u'energia', u'energ\xeda'), (u'enfrian', u'enfr\xedan'), (u'escondanme', u'esc\xf3ndanme'), (u'esperame', u'esp\xe9rame'), (u'estara', u'estar\xe1'), (u'estare', u'estar\xe9'), (u'estaria', u'estar\xeda'), (u'estan', u'est\xe1n'), (u'estaran', u'estar\xe1n'), (u'estabamos', u'est\xe1bamos'), (u'estuvieramos', u'estuvi\xe9ramos'), (u'exito', u'\xe9xito'), (u'facil', u'f\xe1cil'), (u'fiscalia', u'fiscal\xeda'), (u'fragil', u'fr\xe1gil'), (u'fragiles', u'fr\xe1giles'), (u'frances', u'franc\xe9s'), (u'gustaria', u'gustar\xeda'), (u'habia', u'hab\xeda'), (u'habias', u'hab\xedas'), (u'habian', u'hab\xedan'), (u'habrian', u'habr\xedan'), (u'habrias', u'habr\xedas'), (u'hagalo', u'h\xe1galo'), (u'haria', u'har\xeda'), (u'increible', u'incre\xedble'), (u'incredulo', u'incr\xe9dulo'), (u'intentalo', u'int\xe9ntalo'), (u'ire', u'ir\xe9'), (u'jovenes', u'j\xf3venes'), (u'ladron', u'ladr\xf3n'), (u'linea', u'l\xednea'), (u'llamame', u'll\xe1mame'), (u'llevalo', u'll\xe9valo'), (u'mama', u'mam\xe1'), (u'maricon', u'maric\xf3n'), (u'mayoria', u'mayor\xeda'), (u'metodo', u'm\xe9todo'), (u'metodos', u'm\xe9todos'), (u'mio', u'm\xedo'), (u'mostro', u'mostr\xf3'), (u'morira', u'morir\xe1'), (u'muevete', u'mu\xe9vete'), (u'murio', u'muri\xf3'), (u'numero', u'n\xfamero'), (u'numeros', u'n\xfameros'), (u'ningun', u'ning\xfan'), (u'oido', u'o\xeddo'), (u'oidos', u'o\xeddos'), (u'oimos', u'o\xedmos'), (u'oiste', u'o\xedste'), (u'pasale', u'p\xe1sale'), (u'pasame', u'p\xe1same'), (u'paraiso', u'para\xedso'), (u'parate', u'p\xe1rate'), (u'pense', u'pens\xe9'), (u'peluqueria', u'peluquer\xeda'), (u'platano', u'pl\xe1tano'), (u'plastico', u'pl\xe1stico'), (u'plasticos', u'pl\xe1sticos'), (u'policia', u'polic\xeda'), (u'policias', u'polic\xedas'), (u'poster', u'p\xf3ster'), (u'podia', u'pod\xeda'), (u'podias', u'pod\xedas'), (u'podria', u'podr\xeda'), (u'podrian', u'podr\xedan'), (u'podrias', u'podr\xedas'), (u'podriamos', u'podr\xedamos'), (u'prometio', u'prometi\xf3'), (u'proposito', u'prop\xf3sito'), (u'pideselo', u'p\xeddeselo'), (u'ponganse', u'p\xf3nganse'), (u'prometeme', u'prom\xe9teme'), (u'publico', u'p\xfablico'), (u'publicos', u'p\xfablicos'), (u'publicamente', u'p\xfablicamente'), (u'quedate', u'qu\xe9date'), (u'queria', u'quer\xeda'), (u'querrias', u'querr\xedas'), (u'querian', u'quer\xedan'), (u'rapido', u'r\xe1pido'), (u'rapidamente', u'r\xe1pidamente'), (u'razon', u'raz\xf3n'), (u'rehusen', u'reh\xfasen'), (u'rie', u'r\xede'), (u'rias', u'r\xedas'), (u'rindete', u'r\xedndete'), (u'sacame', u's\xe1came'), (u'sentian', u'sent\xedan'), (u'sientate', u'si\xe9ntate'), (u'sera', u'ser\xe1'), (u'soplon', u'sopl\xf3n'), (u'sueltalo', u'su\xe9ltalo'), (u'tambien', u'tambi\xe9n'), (u'teoria', u'teor\xeda'), (u'tendra', u'tendr\xe1'), (u'telefono', u'tel\xe9fono'), (u'tipica', u't\xedpica'), (u'todavia', u'todav\xeda'), (u'tomalo', u't\xf3malo'), (u'tonterias', u'tonter\xedas'), (u'torci', u'torc\xed'), (u'traelos', u'tr\xe1elos'), (u'traiganlo', u'tr\xe1iganlo'), (u'traiganlos', u'tr\xe1iganlos'), (u'trio', u'tr\xedo'), (u'tuvieramos', u'tuvi\xe9ramos'), (u'union', u'uni\xf3n'), (u'ultimo', u'\xfaltimo'), (u'ultima', u'\xfaltima'), (u'ultimos', u'\xfaltimos'), (u'ultimas', u'\xfaltimas'), (u'unica', u'\xfanica'), (u'unico', u'\xfanico'), (u'vamonos', u'v\xe1monos'), (u'vayanse', u'v\xe1yanse'), (u'victima', u'v\xedctima'), (u'vivira', u'vivir\xe1'), (u'volvio', u'volvi\xf3'), (u'volvia', u'volv\xeda'), (u'volvian', u'volv\xedan'), (u'reir', u're\xedr'), (u'freir', u'fre\xedr'), (u'sonreir', u'sonre\xedr'), (u'hazmerreir', u'hazmerre\xedr'), (u'oir', u'o\xedr'), (u'oirlo', u'o\xedrlo'), (u'oirte', u'o\xedrte'), (u'oirse', u'o\xedrse'), (u'oirme', u'o\xedrme'), (u'oirle', u'o\xedrle'), (u'oirla', u'o\xedrla'), (u'oirles', u'o\xedrles'), (u'oirnos', u'o\xedrnos'), (u'oirlas', u'o\xedrlas'), (u'bi\xe9n', u'bien'), (u'cr\xedmen', u'crimen'), (u'fu\xe9', u'fue'), (u'fu\xed', u'fui'), (u'qui\xe9res', u'quieres'), (u't\xed', u'ti'), (u'd\xed', u'di'), (u'v\xe1', u'va'), (u'v\xe9', u've'), (u'v\xed', u'vi'), (u'vi\xf3', u'vio'), (u'\xf3', u'o'), (u'cl\xf3n', u'clon'), (u'di\xf3', u'dio'), (u'gui\xf3n', u'guion'), (u'd\xf3n', u'don'), (u'f\xe9', u'fe'), (u'\xe1quel', u'aquel'), (u'\xe9ste', u'este'), (u'\xe9sta', u'esta'), (u'\xe9stos', u'estos'), (u'\xe9stas', u'estas'), (u'\xe9se', u'ese'), (u'\xe9sa', u'esa'), (u'\xe9sos', u'esos'), (u'\xe9sas', u'esas'), (u's\xf3lo', u'solo'), (u'coktel', u'c\xf3ctel'), (u'cocktel', u'c\xf3ctel'), (u'conciente', u'consciente'), (u'comenz\xe9', u'comenc\xe9'), (u'desilucionarte', u'desilusionarte'), (u'dijieron', u'dijeron'), (u'empez\xe9', u'empec\xe9'), (u'hize', u'hice'), (u'ilucionarte', u'ilusionarte'), (u'inconciente', u'inconsciente'), (u'quize', u'quise'), (u'quizo', u'quiso'), (u'verguenza', u'verg\xfcenza'), (u'Nu\xf1ez', u'N\xfa\xf1ez'), (u'Ivan', u'Iv\xe1n'), (u'Japon', u'Jap\xf3n'), (u'Monica', u'M\xf3nica'), (u'Maria', u'Mar\xeda'), (u'Jose', u'Jos\xe9'), (u'Ramon', u'Ram\xf3n'), (u'Garcia', u'Garc\xeda'), (u'Gonzalez', u'Gonz\xe1lez'), (u'Jesus', u'Jes\xfas'), (u'Alvarez', u'\xc1lvarez'), (u'Damian', u'Dami\xe1n'), (u'Rene', u'Ren\xe9'), (u'Nicolas', u'Nicol\xe1s'), (u'Jonas', u'Jon\xe1s'), (u'Lopez', u'L\xf3pez'), (u'Hernandez', u'Hern\xe1ndez'), (u'Bermudez', u'Berm\xfadez'), (u'Fernandez', u'Fern\xe1ndez'), (u'Suarez', u'Su\xe1rez'), (u'Sofia', u'Sof\xeda'), (u'Seneca', u'S\xe9neca'), (u'Tokyo', u'Tokio'), (u'Canada', u'Canad\xe1'), (u'Paris', u'Par\xeds'), (u'Turquia', u'Turqu\xeda'), (u'Mexico', u'M\xe9xico'), (u'Mejico', u'M\xe9xico'), (u'Matias', u'Mat\xedas'), (u'Valentin', u'Valent\xedn'), (u'mejicano', u'mexicano'), (u'mejicanos', u'mexicanos'), (u'mejicana', u'mexicana'), (u'mejicanas', u'mexicanas'), (u'io', u'lo'), (u'ia', u'la'), (u'ie', u'le'), (u'Io', u'lo'), (u'Ia', u'la'), (u'AI', u'Al'), (u'Ie', u'le'), (u'EI', u'El'), (u'suba\ufb02uente', u'subafluente'), (u'a\ufb02\xf3jalo', u'afl\xf3jalo'), (u'A\ufb02\xf3jalo', u'Afl\xf3jalo'), (u'perdi', u'perd\xed'), (u'Podria', u'Podr\xeda'), (u'confia', u'conf\xeda'), (u'pasaria', u'pasar\xeda'), (u'Podias', u'Pod\xedas'), (u'responsabke', u'responsable'), (u'Todavia', u'Todav\xeda'), (u'envien', u'env\xeden'), (u'Queria', u'Quer\xeda'), (u'tio', u't\xedo'), (u'traido', u'tra\xeddo'), (u'Asi', u'As\xed'), (u'elegi', u'eleg\xed'), (u'habria', u'habr\xeda'), (u'encantaria', u'encantar\xeda'), (u'leido', u'le\xeddo'), (u'conocias', u'conoc\xedas'), (u'harias', u'har\xedas'), (u'Aqui', u'Aqu\xed'), (u'decidi', u'decid\xed'), (u'mia', u'm\xeda'), (u'Crei', u'Cre\xed'), (u'podiamos', u'pod\xedamos'), (u'avisame', u'av\xedsame'), (u'debia', u'deb\xeda'), (u'pensarias', u'pensar\xedas'), (u'reuniamos', u'reun\xedamos'), (u'PO\xcf', u'por'), (u'vendria', u'vendr\xeda'), (u'caida', u'ca\xedda'), (u'venian', u'ven\xedan'), (u'compa\xf1ias', u'compa\xf1\xedas'), (u'leiste', u'le\xedste'), (u'Leiste', u'Le\xedste'), (u'fiaria', u'fiar\xeda'), (u'Hungria', u'Hungr\xeda'), (u'fotografia', u'fotograf\xeda'), (u'cafeteria', u'cafeter\xeda'), (u'Digame', u'D\xedgame'), (u'debias', u'deb\xedas'), (u'tendria', u'tendr\xeda'), (u'C\xcfGO', u'creo'), (u'anteg', u'antes'), (u'S\xf3Io', u'Solo'), (u'Ilam\xe1ndola', u'llam\xe1ndola'), (u'C\xe1\ufb02at\xe9', u'C\xe1llate'), (u'Ilamaste', u'llamaste'), (u'daria', u'dar\xeda'), (u'Iargaba', u'largaba'), (u'Yati', u'Y a ti'), (u'querias', u'quer\xedas'), (u'Iimpiarlo', u'limpiarlo'), (u'Iargado', u'largado'), (u'galeria', u'galer\xeda'), (u'Bartomeu', u'Bertomeu'), (u'Iocalizarlo', u'localizarlo'), (u'Il\xe1mame', u'll\xe1mame')]),
                        'pattern': u'(?um)(\\b|^)(?:KBs|Vd|N\\\xb0|n\\\xb0|nro\\.|Nro\\.|aca|actuas|actues|adios|agarrenla|agarrenlo|agarrandose|algun|alli|alla|alejate|ahi|angel|angeles|ansian|apagala|aqui|asi|bahia|busqueda|busquedas|callate|carcel|camara|caido|cabron|camion|codigo|codigos|comence|comprate|consegui|confias|convertira|corazon|crei|creia|creido|creiste|cubrenos|comio|dara|dia|dias|debio|demelo|dimelo|denoslo|deselo|decia|decian|detras|deberia|deberas|deberias|deberian|deberiamos|dejame|dejate|dejalo|dejarian|damela|despues|diciendome|dificil|dificiles|disculpate|dolares|hechar|examenes|empezo|empujon|empujalo|energia|enfrian|escondanme|esperame|estara|estare|estaria|estan|estaran|estabamos|estuvieramos|exito|facil|fiscalia|fragil|fragiles|frances|gustaria|habia|habias|habian|habrian|habrias|hagalo|haria|increible|incredulo|intentalo|ire|jovenes|ladron|linea|llamame|llevalo|mama|maricon|mayoria|metodo|metodos|mio|mostro|morira|muevete|murio|numero|numeros|ningun|oido|oidos|oimos|oiste|pasale|pasame|paraiso|parate|pense|peluqueria|platano|plastico|plasticos|policia|policias|poster|podia|podias|podria|podrian|podrias|podriamos|prometio|proposito|pideselo|ponganse|prometeme|publico|publicos|publicamente|quedate|queria|querrias|querian|rapido|rapidamente|razon|rehusen|rie|rias|rindete|sacame|sentian|sientate|sera|soplon|sueltalo|tambien|teoria|tendra|telefono|tipica|todavia|tomalo|tonterias|torci|traelos|traiganlo|traiganlos|trio|tuvieramos|union|ultimo|ultima|ultimos|ultimas|unica|unico|vamonos|vayanse|victima|vivira|volvio|volvia|volvian|reir|freir|sonreir|hazmerreir|oir|oirlo|oirte|oirse|oirme|oirle|oirla|oirles|oirnos|oirlas|bi\\\xe9n|cr\\\xedmen|fu\\\xe9|fu\\\xed|qui\\\xe9res|t\\\xed|d\\\xed|v\\\xe1|v\\\xe9|v\\\xed|vi\\\xf3|\\\xf3|cl\\\xf3n|di\\\xf3|gui\\\xf3n|d\\\xf3n|f\\\xe9|\\\xe1quel|\\\xe9ste|\\\xe9sta|\\\xe9stos|\\\xe9stas|\\\xe9se|\\\xe9sa|\\\xe9sos|\\\xe9sas|s\\\xf3lo|coktel|cocktel|conciente|comenz\\\xe9|desilucionarte|dijieron|empez\\\xe9|hize|ilucionarte|inconciente|quize|quizo|verguenza|Nu\\\xf1ez|Ivan|Japon|Monica|Maria|Jose|Ramon|Garcia|Gonzalez|Jesus|Alvarez|Damian|Rene|Nicolas|Jonas|Lopez|Hernandez|Bermudez|Fernandez|Suarez|Sofia|Seneca|Tokyo|Canada|Paris|Turquia|Mexico|Mejico|Matias|Valentin|mejicano|mejicanos|mejicana|mejicanas|io|ia|ie|Io|Ia|AI|Ie|EI|suba\\\ufb02uente|a\\\ufb02\\\xf3jalo|A\\\ufb02\\\xf3jalo|perdi|Podria|confia|pasaria|Podias|responsabke|Todavia|envien|Queria|tio|traido|Asi|elegi|habria|encantaria|leido|conocias|harias|Aqui|decidi|mia|Crei|podiamos|avisame|debia|pensarias|reuniamos|PO\\\xcf|vendria|caida|venian|compa\\\xf1ias|leiste|Leiste|fiaria|Hungria|fotografia|cafeteria|Digame|debias|tendria|C\\\xcfGO|anteg|S\\\xf3Io|Ilam\\\xe1ndola|C\\\xe1\\\ufb02at\\\xe9|Ilamaste|daria|Iargaba|Yati|querias|Iimpiarlo|Iargado|galeria|Bartomeu|Iocalizarlo|Il\\\xe1mame)(\\b|$)'}},
 'srp': {'BeginLines': {'data': OrderedDict(),
                        'pattern': None},
         'EndLines': {'data': OrderedDict(),
                      'pattern': None},
         'PartialLines': {'data': OrderedDict([(u'bi smo', u'bismo'), (u'dali je', u'da li je'), (u'dali si', u'da li si'), (u'Dali si', u'Da li si'), (u'Jel sam ti', u'Jesam li ti'), (u'Jel si', u'Jesi li'), (u"Jel' si", u'Jesi li'), (u"Je I'", u'Jesi li'), (u'Jel si to', u'Jesi li to'), (u"Jel' si to", u'Da li si to'), (u'jel si to', u'da li si to'), (u"jel' si to", u'jesi li to'), (u'Jel si ti', u'Da li si ti'), (u"Jel' si ti", u'Da li si ti'), (u'jel si ti', u'da li si ti'), (u"jel' si ti", u'da li si ti'), (u'jel ste ', u'jeste li '), (u'Jel ste', u'Jeste li'), (u"jel' ste ", u'jeste li '), (u"Jel' ste ", u'Jeste li '), (u'Jel su ', u'Jesu li '), (u'Jel da ', u'Zar ne'), (u'jel da ', u'zar ne'), (u"jel'da ", u'zar ne'), (u'Jeli sve ', u'Je li sve'), (u'Jeli on ', u'Je li on'), (u'Jeli ti ', u'Je li ti'), (u'jeli ti ', u'je li ti'), (u'Jeli to ', u'Je li to'), (u'Nebrini', u'Ne brini'), (u'ne \u0107u', u'ne\u0107u'), (u'od kako', u'otkako'), (u'Si dobro', u'Jesi li dobro'), (u'Svo vreme', u'Sve vrijeme'), (u'Svo vrijeme', u'Sve vrijeme'), (u'Cijelo vrijeme', u'Sve vrijeme')]),
                          'pattern': u"(?um)(?:(?<=\\s)|(?<=^)|(?<=\\b))(?:bi\\ smo|dali\\ je|dali\\ si|Dali\\ si|Jel\\ sam\\ ti|Jel\\ si|Jel\\'\\ si|Je\\ I\\'|Jel\\ si\\ to|Jel\\'\\ si\\ to|jel\\ si\\ to|jel\\'\\ si\\ to|Jel\\ si\\ ti|Jel\\'\\ si\\ ti|jel\\ si\\ ti|jel\\'\\ si\\ ti|jel\\ ste\\ |Jel\\ ste|jel\\'\\ ste\\ |Jel\\'\\ ste\\ |Jel\\ su\\ |Jel\\ da\\ |jel\\ da\\ |jel\\'da\\ |Jeli\\ sve\\ |Jeli\\ on\\ |Jeli\\ ti\\ |jeli\\ ti\\ |Jeli\\ to\\ |Nebrini|ne\\ \\\u0107u|od\\ kako|Si\\ dobro|Svo\\ vreme|Svo\\ vrijeme|Cijelo\\ vrijeme)(?:(?=\\s)|(?=$)|(?=\\b))"},
         'PartialWordsAlways': {'data': OrderedDict(),
                                'pattern': None},
         'WholeLines': {'data': OrderedDict(),
                        'pattern': None},
         'WholeWords': {'data': OrderedDict([(u'\u010du', u'\u0107u'), (u'\u010de\u0161', u'\u0107e\u0161'), (u'\u010de', u'\u0107e'), (u'\u0107\u0161', u'\u0107e\u0161'), (u'\u0107mo', u'\u0107emo'), (u'\u0107te', u'\u0107ete'), (u'\u010demo', u'\u0107emo'), (u'\u010dete', u'\u0107ete'), (u'djete', u'dijete'), (u'Hey', u'Hej'), (u'hey', u'hej'), (u'htjeo', u'htio'), (u'i\u010di', u'i\u0107i'), (u'jel', u"je l'"), (u'Jel', u"Je l'"), (u'Nebi', u'Ne bi'), (u'Nebih', u'Ne bih'), (u'nebi', u'ne bi'), (u'nebih', u'ne bih'), (u'nedaj', u'ne daj'), (u'Nedaj', u'Ne daj'), (u'nedam', u'ne dam'), (u'Nedam', u'Ne dam'), (u'neda\u0161', u'ne da\u0161'), (u'Neda\u0161', u'Ne da\u0161'), (u'nemogu', u'ne mogu'), (u'Nemogu', u'Ne mogu'), (u'nemora', u'ne mora'), (u'Nemora', u'Ne mora'), (u'nemora\u0161', u'ne mora\u0161'), (u'Nemora\u0161', u'Ne mora\u0161'), (u'predamnom', u'preda mnom'), (u'Predamnom', u'Preda mnom'), (u'Rje\u0161it', u'Rije\u0161it'), (u'samnom', u'sa mnom'), (u'Samnom', u'Sa mnom'), (u'smjeo', u'smio'), (u'uop\u010de', u'uop\u0107e'), (u'Uop\u010de', u'Uop\u0107e'), (u'umijesto', u'umjesto'), (u'Umijesto', u'Umjesto'), (u'uspije\u0161an', u'uspje\u0161an'), (u'uvjek', u'uvijek'), (u'Uvjek', u'Uvijek'), (u'valda', u'valjda'), (u'zamnom', u'za mnom'), (u'Zamnom', u'Za mnom'), (u'\u017eelila', u'\u017eeljela')]),
                        'pattern': u'(?um)(\\b|^)(?:\\\u010du|\\\u010de\\\u0161|\\\u010de|\\\u0107\\\u0161|\\\u0107mo|\\\u0107te|\\\u010demo|\\\u010dete|djete|Hey|hey|htjeo|i\\\u010di|jel|Jel|Nebi|Nebih|nebi|nebih|nedaj|Nedaj|nedam|Nedam|neda\\\u0161|Neda\\\u0161|nemogu|Nemogu|nemora|Nemora|nemora\\\u0161|Nemora\\\u0161|predamnom|Predamnom|Rje\\\u0161it|samnom|Samnom|smjeo|uop\\\u010de|Uop\\\u010de|umijesto|Umijesto|uspije\\\u0161an|uvjek|Uvjek|valda|zamnom|Zamnom|\\\u017eelila)(\\b|$)'}},
 'swe': {'BeginLines': {'data': OrderedDict([(u'Ln ', u'In '), (u'U ppfattat', u'Uppfattat')]),
                        'pattern': u'(?um)^(?:Ln\\ |U\\ ppfattat)'},
         'EndLines': {'data': OrderedDict(),
                      'pattern': None},
         'PartialLines': {'data': OrderedDict(),
                          'pattern': None},
         'PartialWordsAlways': {'data': OrderedDict([(u'\u0139', u'\xc5'), (u'\u013a', u'\xe5')]),
                                'pattern': None},
         'WholeLines': {'data': OrderedDict(),
                        'pattern': None},
         'WholeWords': {'data': OrderedDict([(u'l\xe2rt', u'l\xe4rt'), (u'hederv\xe5rda', u'hederv\xe4rda'), (u'storm\xe2stare', u'storm\xe4stare'), (u'Avf\xe2rd', u'Avf\xe4rd'), (u't\xe2lten', u't\xe4lten'), (u'\xe2rjag', u'\xe4r jag'), (u'\xe4rjag', u'\xe4r jag'), (u'j\xe2mlikar', u'j\xe4mlikar'), (u'Riskako\ufb02', u'Riskakor'), (u'Karamellen/', u'Karamellen'), (u'Lngen\xfcng', u'Ingenting'), (u'\xe4rju', u'\xe4r ju'), (u'S\xe1', u'S\xe5'), (u'n\xe4rjag', u'n\xe4r jag'), (u'alltjag', u'allt jag'), (u'g\xf6rjag', u'g\xf6r jag'), (u'trorjag', u'tror jag'), (u'varju', u'var ju'), (u'g\xf6rju', u'g\xf6r ju'), (u'kanju', u'kan ju'), (u'blirjag', u'blir jag'), (u's\xe4gerjag', u's\xe4ger jag'), (u'beh\xe5llerjag', u'beh\xe5ller jag'), (u'pr\xf8blem', u'problem'), (u'r\xe4ddadeju', u'r\xe4ddade ju'), (u'hon\xf8m', u'honom'), (u'Ln', u'In'), (u'sv\xe5r\ufb02\xf6rtad', u'sv\xe5rfl\xf6rtad'), (u'\xf8ch', u'och'), (u'\ufb02\xf6rtar', u'fl\xf6rtar'), (u'k\xe4nnerjag', u'k\xe4nner jag'), (u'\ufb02ickan', u'flickan'), (u'sn\xf8', u'sn\xf6'), (u'gerju', u'ger ju'), (u'k\xf8ntakter', u'kontakter'), (u'\xf8lycka', u'olycka'), (u'n\xf8lla', u'nolla'), (u'sinnenajublar', u'sinnena jublar'), (u'ijobbet', u'i jobbet'), (u'F\xe5rjag', u'F\xe5r jag'), (u'Ar', u'\xc4r'), (u'liggerju', u'ligger ju'), (u'um', u'om'), (u'lbland', u'Ibland'), (u'skjuterjag', u'skjuter jag'), (u'Vadd\xe5', u'Vad d\xe5'), (u'pratarj\xe4mt', u'pratar j\xe4mt'), (u'harju', u'har ju'), (u'sitterjag', u'sitter jag'), (u'h\xe4\ufb02a', u'h\xe4rja'), (u's\ufb01\xe4l', u'stj\xe4l'), (u'F\xd6U', u'F\xf6lj'), (u'varf\xf6rjag', u'varf\xf6r jag'), (u's\ufb01\xe4rna', u'stj\xe4rna'), (u'b\xf6\ufb02ar', u'b\xf6rjar'), (u'b\xf6\ufb02an', u'b\xf6rjan'), (u'st\xe4ri', u'st\xe5r'), (u'p\xe4', u'p\xe5'), (u'harjag', u'har jag'), (u'attjag', u'att jag'), (u'Verkarjag', u'Verkar jag'), (u'K\xe4nnerjag', u'K\xe4nner jag'), (u'd\xe4rjag', u'd\xe4r jag'), (u'tu\ufb01', u'tuff'), (u'lurarjag', u'lurar jag'), (u'varj\xe4ttebra', u'var j\xe4ttebra'), (u'allvan', u'allvar'), (u'deth\xe4r', u'det h\xe4r'), (u'va\ufb02e', u'varje'), (u'F\xf6Uer', u'F\xf6ljer'), (u'personalm\xf6tetl', u'personalm\xf6tet!'), (u'harjust', u'har just'), (u'\xe4rj\xe4tteduktig', u'\xe4r j\xe4tteduktig'), (u'd\xe4rja', u'd\xe4r ja'), (u'lngen\xfcng', u'lngenting'), (u'iluften', u'i luften'), (u'\xf6sen', u'\xf6ser'), (u'tv\xe2', u'tv\xe5'), (u'Uejerna', u'Tjejerna'), (u'h\xe5n*', u'h\xe5rt'), (u'\xc4rjag', u'\xc4r jag'), (u'keL', u'Okej'), (u'F\xf6rjag', u'F\xf6r jag'), (u'varj\xe4ttekul', u'var j\xe4ttekul'), (u'k\xe4mpan', u'k\xe4mpar'), (u'mycketjobb', u'mycket jobb'), (u'Uus', u'ljus'), (u'serjag', u'ser jag'), (u'vetjag', u'vet jag'), (u'f\xe5rjag', u'f\xe5r jag'), (u'hurjag', u'hur jag'), (u'f\xf6rs\xf6kerjag', u'f\xf6rs\xf6ker jag'), (u't\xe1nagel', u't\xe5nagel'), (u'va\xfce', u'varje'), (u'Uudet', u'ljudet'), (u'amhopa', u'allihopa'), (u'V\xe4\xfc', u'V\xe4lj'), (u'g\xe4ri', u'g\xe5r'), (u'r\xf6d\xfcus', u'r\xf6dljus'), (u'Uuset', u'ljuset'), (u'Rid\xe0n', u'Rid\xe5n'), (u'vi\xfca', u'vilja'), (u'g\xe5ri', u'g\xe5r i'), (u'Hurd\xe5', u'Hur d\xe5'), (u'inter\\/juar', u'intervjuar'), (u'menarjag', u'menar jag'), (u'spyrjag', u'spyr jag'), (u'bri\xfcera', u'briljera'), (u'N\xe4rjag', u'N\xe4r jag'), (u'ner\\/\xf6s', u'nerv\xf6s'), (u'ilivets', u'i livets'), (u'n\xe4got', u'n\xe5got'), (u'p\xe0', u'p\xe5'), (u'Lnnan', u'Innan'), (u'Uf', u'Ut'), (u'lnnan', u'Innan'), (u'D\xe0ren', u'D\xe5ren'), (u'F\xe0rjag', u'F\xe5r jag'), (u'Vad\xe4rdetd\xe4L', u'Vad \xe4r det d\xe4r'), (u'sm\xe0tjuv', u'sm\xe5tjuv'), (u't\xe0gr\xe5nare', u't\xe5gr\xe5nare'), (u'dit\xe0t', u'dit\xe5t'), (u's\xe4', u's\xe5'), (u'v\xe0rdsl\xf6sa', u'v\xe5rdsl\xf6sa'), (u'n\xe0n', u'n\xe5n'), (u'kommerjag', u'kommer jag'), (u'\xe4rj\xe4ttebra', u'\xe4r j\xe4ttebra'), (u'\xe4rj\xe4vligt', u'\xe4r j\xe4vligt'), (u'\xe0kerjag', u'\xe5ker jag'), (u'ellerjapaner', u'eller japaner'), (u'attjaga', u'att jaga'), (u'eften', u'efter'), (u'h\xe4stan', u'h\xe4star'), (u'Lntensivare', u'Intensivare'), (u'fr\xe0garjag', u'fr\xe5gar jag'), (u'pen/ers', u'pervers'), (u'r\xe0barkade', u'r\xe5barkade'), (u'styrkon', u'styrkor'), (u'Dif\xe5f', u'Dit\xe5t'), (u'h\xe4nden', u'h\xe4nder'), (u'f\xf6\ufb01a', u'f\xf6lja'), (u'Idioten/', u'Idioter!'), (u'Varf\xf6rjagade', u'Varf\xf6r jagade'), (u'd\xe4rf\xf6rjag', u'd\xe4rf\xf6r jag'), (u'forjag', u'for jag'), (u'Iivsgladje', u'livsgl\xe4dje'), (u'narjag', u'n\xe4r jag'), (u'sajag', u'sa jag'), (u'genastja', u'genast ja'), (u'rockument\xe0ren', u'rockument\xe4ren'), (u'turne', u'turn\xe9'), (u'fickjag', u'fick jag'), (u'sager', u's\xe4ger'), (u'Ijush\xe5rig', u'ljush\xe5rig'), (u'tradg\xe5rdsolycka', u'tr\xe4dg\xe5rdsolycka'), (u'kvavdes', u'kv\xe4vdes'), (u'd\xe0rja', u'd\xe4r ja'), (u'hedersgaster', u'hedersg\xe4ster'), (u'Nar', u'N\xe4r'), (u'smaki\xf6sa', u'smakl\xf6sa'), (u'lan', u'Ian'), (u'Lan', u'Ian'), (u'eri', u'er i'), (u'universitetsamne', u'universitets\xe4mne'), (u'garna', u'g\xe4rna'), (u'ar', u'\xe4r'), (u'baltdjur', u'b\xe4ltdjur'), (u'varjag', u'var jag'), (u'\xe0r', u'\xe4r'), (u'f\xf6rf\xf6rst\xe0rkare', u'f\xf6rf\xf6rst\xe4rkare'), (u'arjattespeciell', u'\xe4r j\xe4ttespeciell'), (u'h\xe0rg\xe5r', u'h\xe4r g\xe5r'), (u'Ia', u'la'), (u'Iimousinen', u'limousinen'), (u'krickettra', u'krickettr\xe4'), (u'h\xe5rdrockv\xe0rlden', u'h\xe5rdrockv\xe4rlden'), (u'tr\xe0bit', u'tr\xe4bit'), (u'Mellanvastern', u'Mellanv\xe4stern'), (u'arju', u'\xe4r ju'), (u'turnen', u'turn\xe9n'), (u'kanns', u'k\xe4nns'), (u'battre', u'b\xe4ttre'), (u'v\xe0rldsturne', u'v\xe4rldsturne'), (u'dar', u'd\xe4r'), (u'sj\xe0lvant\xe0nder', u'sj\xe4lvant\xe4nder'), (u'jattelange', u'j\xe4ttel\xe4nge'), (u'berattade', u'ber\xe4ttade'), (u'S\xe4', u'S\xe5'), (u'vandpunkten', u'v\xe4ndpunkten'), (u'N\xe0rjag', u'N\xe4r jag'), (u'lasa', u'l\xe4sa'), (u'skitl\xe0skigt', u'skitl\xe4skigt'), (u'sambandsv\xe0g', u'sambandsv\xe4g'), (u'valdigt', u'v\xe4ldigt'), (u'Stamga\ufb01el', u'St\xe4mgaffel'), (u'\xe0rjag', u'\xe4r jag'), (u'tajming', u'tajmning'), (u'utg\xe4ng', u'utg\xe5ng'), (u'H\xe0r\xe5t', u'H\xe4r\xe5t'), (u'h\xe0r\xe5t', u'h\xe4r\xe5t'), (u'anvander', u'anv\xe4nder'), (u'harjobbat', u'har jobbat'), (u'imageide', u'imageid\xe9'), (u'kla\ufb01en', u'klaffen'), (u'sjalv', u'sj\xe4lv'), (u'dvarg', u'dv\xe4rg'), (u'detjag', u'det jag'), (u'dvargarna', u'dv\xe4rgarna'), (u'fantasiv\xe0rld', u'fantasiv\xe4rld'), (u'\ufb01olliga', u'Fjolliga'), (u'mandoiinstr\xe0ngar', u'mandollnstr\xe4ngar'), (u'mittjobb', u'mitt jobb'), (u'Skajag', u'Ska jag'), (u'landari', u'landar i'), (u'gang', u'g\xe4ng'), (u'Detjag', u'Det jag'), (u'Narmre', u'N\xe4rmre'), (u'I\xe5tjavelni', u'l\xe5tj\xe4veln'), (u'H\xe5llerjag', u'H\xe5ller jag'), (u'visionarer', u'vision\xe4rer'), (u'T\xfclvad', u'Till vad'), (u'milit\xe0rbas', u'milit\xe4rbas'), (u'jattegiada', u'j\xe4tteglada'), (u'Fastjag', u'Fast jag'), (u's\xe5jag', u's\xe5 jag'), (u'rockvarlden', u'rockv\xe4rlden'), (u'saknarjag', u'saknar jag'), (u'allafall', u'alla fall'), (u'\ufb01anta', u'fjanta'), (u'Kr\xe0ma', u'Kr\xe4ma'), (u'stammer', u'st\xe4mmer'), (u'budb\xe0rare', u'budb\xe4rare'), (u'Iivsfiiosofi', u'livsfiiosofi'), (u'f\xf6rj\xe4mnan', u'f\xf6r j\xe4mnan'), (u'gillarjag', u'gillar jag'), (u'Iarvat', u'larvat'), (u'klararjag', u'klarar jag'), (u"hatta\ufb01'\xe0r", u'hattaff\xe4r'), (u'D\xe0', u'D\xe5'), (u'upp\ufb01nna', u'uppfinna'), (u'R\xe0ttf\xe5glar', u'R\xe5ttf\xe5glar'), (u'Sv\xe4\xfcboda', u'Sv\xe4ljboda'), (u'P\xe5b\xf6\ufb02ar', u'P\xe5b\xf6rjar'), (u'slutarju', u'slutar ju'), (u'ni\ufb01skebu\xfcken', u'i fiskebutiken'), (u'h\xe4rj\xe4keln', u'h\xe4r j\xe4keln'), (u'H\xdfppa', u'Hoppa'), (u'f\xf6rst\xf6rds', u'f\xf6rst\xf6rdes'), (u'varj\xe4ttegoda', u'var j\xe4ttegoda'), (u'Kor\\/', u'Korv'), (u'br\xfcl\xe9el', u'br\xfcl\xe9e!'), (u'Hei', u'Hej'), (u'\xe4lskarjordgubbsglass', u'\xe4lskar jordgubbsglass'), (u'Sn\xf6bom', u'Sn\xf6boll'), (u'Sn\xf6boH', u'Sn\xf6boll'), (u'Sn\xf6bol', u'Sn\xf6boll'), (u'sn\xf6boH', u'sn\xf6boll'), (u'L\xe4ggerp\xe5', u'L\xe4gger p\xe5'), (u'lnge\ufb02', u'lnget!'), (u'S\xe4gerj\xe4ttesmarta', u'S\xe4ger j\xe4ttesmarta'), (u'dopplen/\xe4derradar', u'dopplerv\xe4derradar'), (u's\xe4kertj\xe4ttefin', u's\xe4kert j\xe4ttefin'), (u'\xe4rj\xe4ttefin', u'\xe4r j\xe4ttefin'), (u'verkarju', u'verkar ju'), (u'blirju', u'blir ju'), (u'kor\\/', u'korv'), (u'naturkatastro\ufb01', u'naturkatastrof!'), (u'stickerjag', u'stickerj ag'), (u'j\xe4ttebu\ufb01\xe9', u'j\xe4ttebuff\xe9'), (u'be\ufb01nner', u'befinner'), (u'Sp\ufb02ng', u'Spring'), (u'trec\ufb01e', u'tredje'), (u'ryckerjag', u'rycker jag'), (u'skullejag', u'skulle jag'), (u'vetju', u'vet ju'), (u'a\ufb02jag', u'att jag'), (u'\ufb02nns', u'finns'), (u'\xe4rl\xe5ng', u'\xe4r l\xe5ng'), (u'k\xe5ra', u'k\xe4ra'), (u'\xe4r\ufb01na', u'\xe4r \ufb01na'), (u'\xe4ri', u'\xe4r i'), (u'h\xf6rden', u'h\xf6r den'), (u'\xe4ttj\xe4g', u'att j\xe4g'), (u'g\xe4r', u'g\xe5r'), (u'f\xf6ri', u'f\xf6r i'), (u'Hurvisste', u'Hur visste'), (u'\ufb01ck', u'fick'), (u'\ufb01nns', u'finns'), (u'\ufb01n', u'fin'), (u'Fa', u'Bra.'), (u'bori', u'bor i'), (u'fiendeplanl', u'fiendeplan!'), (u'if\xf6rnamn', u'i f\xf6rnamn'), (u'detju', u'det ju'), (u'N\xfcd', u'Niki'), (u'hatarjag', u'hatar jag'), (u'Klararjag', u'Klarar jag'), (u'deta\ufb01er', u'detaljer'), (u'v\xe4/', u'v\xe4l'), (u'smakarju', u'smakar ju'), (u'Teache\ufb02', u'Teacher!'), (u'imorse', u'i morse'), (u'drickerjag', u'dricker jag'), (u'st\xe5ri', u'st\xe5r i'), (u'Harjag', u'Har jag'), (u'Talarjag', u'Talar jag'), (u'undrarjag', u'undrar jag'), (u'\xe5lderjag', u'\xe5lder jag'), (u'va\ufb01e', u'varje'), (u'f\xf6rfalskningl', u'f\xf6rfalskning!'), (u'Vi\ufb01iiiam', u'William'), (u'V\\\ufb01lliams', u'Williams'), (u'attjobba', u'att jobba'), (u'intei', u'inte i'), (u'n\xe4rV\\\ufb01lliam', u'n\xe4r William'), (u'V\\\ufb01lliam', u'William'), (u'E\ufb01ersom', u'Eftersom'), (u'Vl\ufb01lliam', u'William'), (u'I\xe4ngejag', u'l\xe4nge jag'), (u"'\ufb01digare", u'Tidigare'), (u'b\xf6rjadei', u'b\xf6rjade i'), (u'merjust', u'mer just'), (u'e\ufb01er\xe5t', u'efter\xe5t'), (u'gjordejag', u'gjorde jag'), (u'hadeju', u'hade ju'), (u'g\xe5rvi', u'g\xe5r vi'), (u'k\xf6perjag', u'k\xf6per jag'), (u'M\xe5stejag', u'M\xe5ste jag'), (u'k\xe4nnerju', u'k\xe4nner ju'), (u'\ufb02n', u'fin'), (u'treviig', u'trevlig'), (u'Grattisl', u'Grattis!'), (u'kande', u'k\xe4nde'), (u"'llden", u'Tiden'), (u'sakjag', u'sak jag'), (u'klartjag', u'klart jag'), (u'h\xe4\ufb01igt', u'h\xe4ftigt'), (u'I\xe4mnarjag', u'l\xe4mnar jag'), (u'gickju', u'gick ju'), (u'skajag', u'ska jag'), (u'G\xf6rjag', u'G\xf6r jag'), (u'm\xe5stejag', u'm\xe5ste jag'), (u'gra\\/iditet', u'graviditet'), (u'hittadqdin', u'hittade din'), (u'\xe4rjobbigt', u'\xe4r jobbigt'), (u'Overdrivet', u'\xd6verdrivet'), (u'hOgtidlig', u'h\xf6gtidlig'), (u'Overtyga', u'\xd6vertyga'), (u'SKILSMASSA', u'SKILSM\xc4SSA'), (u'brukarju', u'brukar ju'), (u'lsabel', u'Isabel'), (u'kundejag', u'kunde jag'), (u'\xe4rl\xe4get', u'\xe4r l\xe4get'), (u'blirinte', u'blir inte'), (u'ijakt', u'i jakt'), (u'avjordens', u'av jordens'), (u'90000O', u'900000'), (u'9O0', u'900'), (u'\xe4rp\xe5', u'\xe4r p\xe5'), (u'\xe4rproteserna', u'\xe4r proteserna'), (u'\xe4rytterst', u'\xe4r ytterst'), (u'beborjorden', u'bebor jorden'), (u'filmjag', u'film jag'), (u'fokuserarp\xe5', u'fokuserar p\xe5'), (u'folkjag', u'folk jag'), (u'f\xf6rest\xe4lldejag', u'f\xf6rest\xe4llde jag'), (u'f\xf6rpubliken', u'f\xf6r publiken'), (u'gilladejag', u'gillade jag'), (u'h\xe5llerp\xe5', u'h\xe5ller p\xe5'), (u'harp\xe5', u'har p\xe5'), (u'harplaner', u'har planer'), (u'harprylar', u'har prylar'), (u'kommerpubliken', u'kommer publiken'), (u'kostymerp\xe5', u'kostymer p\xe5'), (u'litarp\xe5', u'litar p\xe5'), (u'lngen', u'Ingen'), (u'lnom', u'Inom'), (u'lnte', u'Inte'), (u'ochjag', u'och jag'), (u'Ochjag', u'Och jag'), (u'ochjorden', u'och jorden'), (u'omjag', u'om jag'), (u'Omjag', u'Om jag'), (u'passarperfekt', u'passar perfekt'), (u's\xe4ttetjag', u's\xe4ttet jag'), (u'silverp\xe5', u'silver p\xe5'), (u'skruvarjag', u'skruvar jag'), (u'somjag', u'som jag'), (u'Somjag', u'Som jag'), (u'talarp\xe5', u'talar p\xe5'), (u't\xe4nktejag', u't\xe4nkte jag'), (u'tapparjag', u'tappar jag'), (u'tittarp\xe5', u'tittar p\xe5'), (u'visstejag', u'visste jag'), (u'medjetpacks', u'med jetpacks'), (u's\xe4tterp\xe5', u's\xe4tter p\xe5'), (u'st\xe5rp\xe5', u'st\xe5r p\xe5'), (u'tillh\xf6rp\xe5', u'tillh\xf6r p\xe5')]),
                        'pattern': u"(?um)(\\b|^)(?:l\\\xe2rt|hederv\\\xe5rda|storm\\\xe2stare|Avf\\\xe2rd|t\\\xe2lten|\\\xe2rjag|\\\xe4rjag|j\\\xe2mlikar|Riskako\\\ufb02|Karamellen\\/|Lngen\\\xfcng|\\\xe4rju|S\\\xe1|n\\\xe4rjag|alltjag|g\\\xf6rjag|trorjag|varju|g\\\xf6rju|kanju|blirjag|s\\\xe4gerjag|beh\\\xe5llerjag|pr\\\xf8blem|r\\\xe4ddadeju|hon\\\xf8m|Ln|sv\\\xe5r\\\ufb02\\\xf6rtad|\\\xf8ch|\\\ufb02\\\xf6rtar|k\\\xe4nnerjag|\\\ufb02ickan|sn\\\xf8|gerju|k\\\xf8ntakter|\\\xf8lycka|n\\\xf8lla|sinnenajublar|ijobbet|F\\\xe5rjag|Ar|liggerju|um|lbland|skjuterjag|Vadd\\\xe5|pratarj\\\xe4mt|harju|sitterjag|h\\\xe4\\\ufb02a|s\\\ufb01\\\xe4l|F\\\xd6U|varf\\\xf6rjag|s\\\ufb01\\\xe4rna|b\\\xf6\\\ufb02ar|b\\\xf6\\\ufb02an|st\\\xe4ri|p\\\xe4|harjag|attjag|Verkarjag|K\\\xe4nnerjag|d\\\xe4rjag|tu\\\ufb01|lurarjag|varj\\\xe4ttebra|allvan|deth\\\xe4r|va\\\ufb02e|F\\\xf6Uer|personalm\\\xf6tetl|harjust|\\\xe4rj\\\xe4tteduktig|d\\\xe4rja|lngen\\\xfcng|iluften|\\\xf6sen|tv\\\xe2|Uejerna|h\\\xe5n\\*|\\\xc4rjag|keL|F\\\xf6rjag|varj\\\xe4ttekul|k\\\xe4mpan|mycketjobb|Uus|serjag|vetjag|f\\\xe5rjag|hurjag|f\\\xf6rs\\\xf6kerjag|t\\\xe1nagel|va\\\xfce|Uudet|amhopa|V\\\xe4\\\xfc|g\\\xe4ri|r\\\xf6d\\\xfcus|Uuset|Rid\\\xe0n|vi\\\xfca|g\\\xe5ri|Hurd\\\xe5|inter\\\\\\/juar|menarjag|spyrjag|bri\\\xfcera|N\\\xe4rjag|ner\\\\\\/\\\xf6s|ilivets|n\\\xe4got|p\\\xe0|Lnnan|Uf|lnnan|D\\\xe0ren|F\\\xe0rjag|Vad\\\xe4rdetd\\\xe4L|sm\\\xe0tjuv|t\\\xe0gr\\\xe5nare|dit\\\xe0t|s\\\xe4|v\\\xe0rdsl\\\xf6sa|n\\\xe0n|kommerjag|\\\xe4rj\\\xe4ttebra|\\\xe4rj\\\xe4vligt|\\\xe0kerjag|ellerjapaner|attjaga|eften|h\\\xe4stan|Lntensivare|fr\\\xe0garjag|pen\\/ers|r\\\xe0barkade|styrkon|Dif\\\xe5f|h\\\xe4nden|f\\\xf6\\\ufb01a|Idioten\\/|Varf\\\xf6rjagade|d\\\xe4rf\\\xf6rjag|forjag|Iivsgladje|narjag|sajag|genastja|rockument\\\xe0ren|turne|fickjag|sager|Ijush\\\xe5rig|tradg\\\xe5rdsolycka|kvavdes|d\\\xe0rja|hedersgaster|Nar|smaki\\\xf6sa|lan|Lan|eri|universitetsamne|garna|ar|baltdjur|varjag|\\\xe0r|f\\\xf6rf\\\xf6rst\\\xe0rkare|arjattespeciell|h\\\xe0rg\\\xe5r|Ia|Iimousinen|krickettra|h\\\xe5rdrockv\\\xe0rlden|tr\\\xe0bit|Mellanvastern|arju|turnen|kanns|battre|v\\\xe0rldsturne|dar|sj\\\xe0lvant\\\xe0nder|jattelange|berattade|S\\\xe4|vandpunkten|N\\\xe0rjag|lasa|skitl\\\xe0skigt|sambandsv\\\xe0g|valdigt|Stamga\\\ufb01el|\\\xe0rjag|tajming|utg\\\xe4ng|H\\\xe0r\\\xe5t|h\\\xe0r\\\xe5t|anvander|harjobbat|imageide|kla\\\ufb01en|sjalv|dvarg|detjag|dvargarna|fantasiv\\\xe0rld|\\\ufb01olliga|mandoiinstr\\\xe0ngar|mittjobb|Skajag|landari|gang|Detjag|Narmre|I\\\xe5tjavelni|H\\\xe5llerjag|visionarer|T\\\xfclvad|milit\\\xe0rbas|jattegiada|Fastjag|s\\\xe5jag|rockvarlden|saknarjag|allafall|\\\ufb01anta|Kr\\\xe0ma|stammer|budb\\\xe0rare|Iivsfiiosofi|f\\\xf6rj\\\xe4mnan|gillarjag|Iarvat|klararjag|hatta\\\ufb01\\'\\\xe0r|D\\\xe0|upp\\\ufb01nna|R\\\xe0ttf\\\xe5glar|Sv\\\xe4\\\xfcboda|P\\\xe5b\\\xf6\\\ufb02ar|slutarju|ni\\\ufb01skebu\\\xfcken|h\\\xe4rj\\\xe4keln|H\\\xdfppa|f\\\xf6rst\\\xf6rds|varj\\\xe4ttegoda|Kor\\\\\\/|br\\\xfcl\\\xe9el|Hei|\\\xe4lskarjordgubbsglass|Sn\\\xf6bom|Sn\\\xf6boH|Sn\\\xf6bol|sn\\\xf6boH|L\\\xe4ggerp\\\xe5|lnge\\\ufb02|S\\\xe4gerj\\\xe4ttesmarta|dopplen\\/\\\xe4derradar|s\\\xe4kertj\\\xe4ttefin|\\\xe4rj\\\xe4ttefin|verkarju|blirju|kor\\\\\\/|naturkatastro\\\ufb01|stickerjag|j\\\xe4ttebu\\\ufb01\\\xe9|be\\\ufb01nner|Sp\\\ufb02ng|trec\\\ufb01e|ryckerjag|skullejag|vetju|a\\\ufb02jag|\\\ufb02nns|\\\xe4rl\\\xe5ng|k\\\xe5ra|\\\xe4r\\\ufb01na|\\\xe4ri|h\\\xf6rden|\\\xe4ttj\\\xe4g|g\\\xe4r|f\\\xf6ri|Hurvisste|\\\ufb01ck|\\\ufb01nns|\\\ufb01n|Fa|bori|fiendeplanl|if\\\xf6rnamn|detju|N\\\xfcd|hatarjag|Klararjag|deta\\\ufb01er|v\\\xe4\\/|smakarju|Teache\\\ufb02|imorse|drickerjag|st\\\xe5ri|Harjag|Talarjag|undrarjag|\\\xe5lderjag|va\\\ufb01e|f\\\xf6rfalskningl|Vi\\\ufb01iiiam|V\\\\\\\ufb01lliams|attjobba|intei|n\\\xe4rV\\\\\\\ufb01lliam|V\\\\\\\ufb01lliam|E\\\ufb01ersom|Vl\\\ufb01lliam|I\\\xe4ngejag|\\'\\\ufb01digare|b\\\xf6rjadei|merjust|e\\\ufb01er\\\xe5t|gjordejag|hadeju|g\\\xe5rvi|k\\\xf6perjag|M\\\xe5stejag|k\\\xe4nnerju|\\\ufb02n|treviig|Grattisl|kande|\\'llden|sakjag|klartjag|h\\\xe4\\\ufb01igt|I\\\xe4mnarjag|gickju|skajag|G\\\xf6rjag|m\\\xe5stejag|gra\\\\\\/iditet|hittadqdin|\\\xe4rjobbigt|Overdrivet|hOgtidlig|Overtyga|SKILSMASSA|brukarju|lsabel|kundejag|\\\xe4rl\\\xe4get|blirinte|ijakt|avjordens|90000O|9O0|\\\xe4rp\\\xe5|\\\xe4rproteserna|\\\xe4rytterst|beborjorden|filmjag|fokuserarp\\\xe5|folkjag|f\\\xf6rest\\\xe4lldejag|f\\\xf6rpubliken|gilladejag|h\\\xe5llerp\\\xe5|harp\\\xe5|harplaner|harprylar|kommerpubliken|kostymerp\\\xe5|litarp\\\xe5|lngen|lnom|lnte|ochjag|Ochjag|ochjorden|omjag|Omjag|passarperfekt|s\\\xe4ttetjag|silverp\\\xe5|skruvarjag|somjag|Somjag|talarp\\\xe5|t\\\xe4nktejag|tapparjag|tittarp\\\xe5|visstejag|medjetpacks|s\\\xe4tterp\\\xe5|st\\\xe5rp\\\xe5|tillh\\\xf6rp\\\xe5)(\\b|$)"}}}
for lang, grps in six.iteritems(data):
    for grp in six.iterkeys(grps):
        if data[lang][grp]["pattern"]:
            data[lang][grp]["pattern"] = re.compile(data[lang][grp]["pattern"])
